#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 4485
#define LARGE_STATE_COUNT 999
#define SYMBOL_COUNT 373
#define ALIAS_COUNT 6
#define TOKEN_COUNT 162
#define EXTERNAL_TOKEN_COUNT 5
#define FIELD_COUNT 44
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 275

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_type = 6,
  anon_sym_EQ = 7,
  anon_sym_as = 8,
  anon_sym_namespace = 9,
  anon_sym_LBRACE = 10,
  anon_sym_COMMA = 11,
  anon_sym_RBRACE = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_BANG = 19,
  anon_sym_else = 20,
  anon_sym_if = 21,
  anon_sym_switch = 22,
  anon_sym_for = 23,
  anon_sym_LPAREN = 24,
  anon_sym_RPAREN = 25,
  anon_sym_await = 26,
  anon_sym_in = 27,
  anon_sym_of = 28,
  anon_sym_while = 29,
  anon_sym_do = 30,
  anon_sym_try = 31,
  anon_sym_with = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  sym__glimmer_template_content = 46,
  anon_sym_LTtemplate_GT = 47,
  anon_sym_LT_SLASHtemplate_GT = 48,
  anon_sym_LT = 49,
  anon_sym_GT = 50,
  anon_sym_SLASH = 51,
  sym_jsx_text = 52,
  sym_jsx_identifier = 53,
  anon_sym_DOT = 54,
  anon_sym_class = 55,
  anon_sym_async = 56,
  anon_sym_function = 57,
  anon_sym_EQ_GT = 58,
  anon_sym_QMARK_DOT = 59,
  anon_sym_new = 60,
  anon_sym_PLUS_EQ = 61,
  anon_sym_DASH_EQ = 62,
  anon_sym_STAR_EQ = 63,
  anon_sym_SLASH_EQ = 64,
  anon_sym_PERCENT_EQ = 65,
  anon_sym_CARET_EQ = 66,
  anon_sym_AMP_EQ = 67,
  anon_sym_PIPE_EQ = 68,
  anon_sym_GT_GT_EQ = 69,
  anon_sym_GT_GT_GT_EQ = 70,
  anon_sym_LT_LT_EQ = 71,
  anon_sym_STAR_STAR_EQ = 72,
  anon_sym_AMP_AMP_EQ = 73,
  anon_sym_PIPE_PIPE_EQ = 74,
  anon_sym_QMARK_QMARK_EQ = 75,
  anon_sym_DOT_DOT_DOT = 76,
  anon_sym_AMP_AMP = 77,
  anon_sym_PIPE_PIPE = 78,
  anon_sym_GT_GT = 79,
  anon_sym_GT_GT_GT = 80,
  anon_sym_LT_LT = 81,
  anon_sym_AMP = 82,
  anon_sym_CARET = 83,
  anon_sym_PIPE = 84,
  anon_sym_PLUS = 85,
  anon_sym_DASH = 86,
  anon_sym_PERCENT = 87,
  anon_sym_STAR_STAR = 88,
  anon_sym_LT_EQ = 89,
  anon_sym_EQ_EQ = 90,
  anon_sym_EQ_EQ_EQ = 91,
  anon_sym_BANG_EQ = 92,
  anon_sym_BANG_EQ_EQ = 93,
  anon_sym_GT_EQ = 94,
  anon_sym_QMARK_QMARK = 95,
  anon_sym_instanceof = 96,
  anon_sym_TILDE = 97,
  anon_sym_void = 98,
  anon_sym_delete = 99,
  anon_sym_PLUS_PLUS = 100,
  anon_sym_DASH_DASH = 101,
  anon_sym_DQUOTE = 102,
  anon_sym_SQUOTE = 103,
  sym_unescaped_double_string_fragment = 104,
  sym_unescaped_single_string_fragment = 105,
  sym_escape_sequence = 106,
  sym_comment = 107,
  anon_sym_BQUOTE = 108,
  anon_sym_DOLLAR_LBRACE = 109,
  anon_sym_SLASH2 = 110,
  sym_regex_pattern = 111,
  sym_regex_flags = 112,
  sym_number = 113,
  sym_private_property_identifier = 114,
  anon_sym_target = 115,
  sym_this = 116,
  sym_super = 117,
  sym_true = 118,
  sym_false = 119,
  sym_null = 120,
  sym_undefined = 121,
  anon_sym_AT = 122,
  anon_sym_static = 123,
  anon_sym_readonly = 124,
  anon_sym_get = 125,
  anon_sym_set = 126,
  anon_sym_QMARK = 127,
  anon_sym_declare = 128,
  anon_sym_public = 129,
  anon_sym_private = 130,
  anon_sym_protected = 131,
  anon_sym_override = 132,
  anon_sym_module = 133,
  anon_sym_any = 134,
  anon_sym_number = 135,
  anon_sym_boolean = 136,
  anon_sym_string = 137,
  anon_sym_symbol = 138,
  anon_sym_abstract = 139,
  anon_sym_satisfies = 140,
  anon_sym_require = 141,
  anon_sym_extends = 142,
  anon_sym_implements = 143,
  anon_sym_global = 144,
  anon_sym_interface = 145,
  anon_sym_enum = 146,
  anon_sym_DASH_QMARK_COLON = 147,
  anon_sym_QMARK_COLON = 148,
  anon_sym_asserts = 149,
  anon_sym_infer = 150,
  anon_sym_is = 151,
  anon_sym_keyof = 152,
  anon_sym_unknown = 153,
  anon_sym_never = 154,
  anon_sym_object = 155,
  anon_sym_LBRACE_PIPE = 156,
  anon_sym_PIPE_RBRACE = 157,
  sym__automatic_semicolon = 158,
  sym__template_chars = 159,
  sym__ternary_qmark = 160,
  sym__function_signature_automatic_semicolon = 161,
  sym_program = 162,
  sym_export_statement = 163,
  sym_namespace_export = 164,
  sym_export_clause = 165,
  sym_export_specifier = 166,
  sym__module_export_name = 167,
  sym_declaration = 168,
  sym_import = 169,
  sym_import_statement = 170,
  sym_import_clause = 171,
  sym__from_clause = 172,
  sym_namespace_import = 173,
  sym_named_imports = 174,
  sym_import_specifier = 175,
  sym_expression_statement = 176,
  sym_variable_declaration = 177,
  sym_lexical_declaration = 178,
  sym_variable_declarator = 179,
  sym_statement_block = 180,
  sym_else_clause = 181,
  sym_if_statement = 182,
  sym_switch_statement = 183,
  sym_for_statement = 184,
  sym_for_in_statement = 185,
  sym__for_header = 186,
  sym_while_statement = 187,
  sym_do_statement = 188,
  sym_try_statement = 189,
  sym_with_statement = 190,
  sym_break_statement = 191,
  sym_continue_statement = 192,
  sym_debugger_statement = 193,
  sym_return_statement = 194,
  sym_throw_statement = 195,
  sym_empty_statement = 196,
  sym_labeled_statement = 197,
  sym_switch_body = 198,
  sym_switch_case = 199,
  sym_switch_default = 200,
  sym_catch_clause = 201,
  sym_finally_clause = 202,
  sym_parenthesized_expression = 203,
  sym_expression = 204,
  sym_primary_expression = 205,
  sym_yield_expression = 206,
  sym_object = 207,
  sym_object_pattern = 208,
  sym_assignment_pattern = 209,
  sym_object_assignment_pattern = 210,
  sym_array = 211,
  sym_array_pattern = 212,
  sym_glimmer_template = 213,
  sym_glimmer_opening_tag = 214,
  sym_glimmer_closing_tag = 215,
  sym_jsx_element = 216,
  sym_jsx_fragment = 217,
  sym_jsx_expression = 218,
  sym_jsx_opening_element = 219,
  sym_nested_identifier = 220,
  sym_jsx_namespace_name = 221,
  sym_jsx_closing_element = 222,
  sym_jsx_self_closing_element = 223,
  sym_jsx_attribute = 224,
  sym_class = 225,
  sym_class_declaration = 226,
  sym_class_heritage = 227,
  sym_function = 228,
  sym_function_declaration = 229,
  sym_generator_function = 230,
  sym_generator_function_declaration = 231,
  sym_arrow_function = 232,
  sym__call_signature = 233,
  sym__formal_parameter = 234,
  sym_optional_chain = 235,
  sym_call_expression = 236,
  sym_new_expression = 237,
  sym_await_expression = 238,
  sym_member_expression = 239,
  sym_subscript_expression = 240,
  sym_assignment_expression = 241,
  sym__augmented_assignment_lhs = 242,
  sym_augmented_assignment_expression = 243,
  sym__initializer = 244,
  sym__destructuring_pattern = 245,
  sym_spread_element = 246,
  sym_ternary_expression = 247,
  sym_binary_expression = 248,
  sym_unary_expression = 249,
  sym_update_expression = 250,
  sym_sequence_expression = 251,
  sym_string = 252,
  sym_template_string = 253,
  sym_template_substitution = 254,
  sym_regex = 255,
  sym_meta_property = 256,
  sym_arguments = 257,
  sym_decorator = 258,
  sym_decorator_member_expression = 259,
  sym_decorator_call_expression = 260,
  sym_class_body = 261,
  sym_formal_parameters = 262,
  sym_class_static_block = 263,
  sym_pattern = 264,
  sym_rest_pattern = 265,
  sym_method_definition = 266,
  sym_pair = 267,
  sym_pair_pattern = 268,
  sym__property_name = 269,
  sym_computed_property_name = 270,
  sym_public_field_definition = 271,
  sym_non_null_expression = 272,
  sym_method_signature = 273,
  sym_abstract_method_signature = 274,
  sym_function_signature = 275,
  sym_as_expression = 276,
  sym_satisfies_expression = 277,
  sym_import_require_clause = 278,
  sym_extends_clause = 279,
  sym_implements_clause = 280,
  sym_ambient_declaration = 281,
  sym_abstract_class_declaration = 282,
  sym_module = 283,
  sym_internal_module = 284,
  sym__module = 285,
  sym_import_alias = 286,
  sym_nested_type_identifier = 287,
  sym_interface_declaration = 288,
  sym_extends_type_clause = 289,
  sym_enum_declaration = 290,
  sym_enum_body = 291,
  sym_enum_assignment = 292,
  sym_type_alias_declaration = 293,
  sym_accessibility_modifier = 294,
  sym_override_modifier = 295,
  sym_required_parameter = 296,
  sym_optional_parameter = 297,
  sym__parameter_name = 298,
  sym_omitting_type_annotation = 299,
  sym_opting_type_annotation = 300,
  sym_type_annotation = 301,
  sym_asserts = 302,
  sym__type = 303,
  sym_tuple_parameter = 304,
  sym_optional_tuple_parameter = 305,
  sym_optional_type = 306,
  sym_rest_type = 307,
  sym__tuple_type_member = 308,
  sym_constructor_type = 309,
  sym__primary_type = 310,
  sym_template_type = 311,
  sym_template_literal_type = 312,
  sym_infer_type = 313,
  sym_conditional_type = 314,
  sym_generic_type = 315,
  sym_type_predicate = 316,
  sym_type_predicate_annotation = 317,
  sym__type_query_member_expression = 318,
  sym__type_query_subscript_expression = 319,
  sym__type_query_call_expression = 320,
  sym_type_query = 321,
  sym_index_type_query = 322,
  sym_lookup_type = 323,
  sym_mapped_type_clause = 324,
  sym_literal_type = 325,
  sym__number = 326,
  sym_existential_type = 327,
  sym_flow_maybe_type = 328,
  sym_parenthesized_type = 329,
  sym_predefined_type = 330,
  sym_type_arguments = 331,
  sym_object_type = 332,
  sym_call_signature = 333,
  sym_property_signature = 334,
  sym_type_parameters = 335,
  sym_type_parameter = 336,
  sym_default_type = 337,
  sym_constraint = 338,
  sym_construct_signature = 339,
  sym_index_signature = 340,
  sym_array_type = 341,
  sym_tuple_type = 342,
  sym_readonly_type = 343,
  sym_union_type = 344,
  sym_intersection_type = 345,
  sym_function_type = 346,
  aux_sym_program_repeat1 = 347,
  aux_sym_export_statement_repeat1 = 348,
  aux_sym_export_clause_repeat1 = 349,
  aux_sym_named_imports_repeat1 = 350,
  aux_sym_variable_declaration_repeat1 = 351,
  aux_sym_switch_body_repeat1 = 352,
  aux_sym_object_repeat1 = 353,
  aux_sym_object_pattern_repeat1 = 354,
  aux_sym_array_repeat1 = 355,
  aux_sym_array_pattern_repeat1 = 356,
  aux_sym_glimmer_template_repeat1 = 357,
  aux_sym_jsx_element_repeat1 = 358,
  aux_sym_string_repeat1 = 359,
  aux_sym_string_repeat2 = 360,
  aux_sym_template_string_repeat1 = 361,
  aux_sym_class_body_repeat1 = 362,
  aux_sym_formal_parameters_repeat1 = 363,
  aux_sym__jsx_start_opening_element_repeat1 = 364,
  aux_sym_extends_clause_repeat1 = 365,
  aux_sym_implements_clause_repeat1 = 366,
  aux_sym_extends_type_clause_repeat1 = 367,
  aux_sym_enum_body_repeat1 = 368,
  aux_sym_template_literal_type_repeat1 = 369,
  aux_sym_object_type_repeat1 = 370,
  aux_sym_type_parameters_repeat1 = 371,
  aux_sym_tuple_type_repeat1 = 372,
  alias_sym_property_identifier = 373,
  alias_sym_shorthand_property_identifier = 374,
  alias_sym_shorthand_property_identifier_pattern = 375,
  alias_sym_statement_identifier = 376,
  alias_sym_this_type = 377,
  alias_sym_type_identifier = 378,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym__glimmer_template_content] = "_glimmer_template_content",
  [anon_sym_LTtemplate_GT] = "<template>",
  [anon_sym_LT_SLASHtemplate_GT] = "</template>",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_abstract] = "abstract",
  [anon_sym_satisfies] = "satisfies",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_object] = "object",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__ternary_qmark] = "\?",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_namespace_export] = "namespace_export",
  [sym_export_clause] = "export_clause",
  [sym_export_specifier] = "export_specifier",
  [sym__module_export_name] = "_module_export_name",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_import_specifier] = "import_specifier",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_glimmer_template] = "glimmer_template",
  [sym_glimmer_opening_tag] = "glimmer_opening_tag",
  [sym_glimmer_closing_tag] = "glimmer_closing_tag",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_optional_chain] = "optional_chain",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_class_static_block] = "class_static_block",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_as_expression] = "as_expression",
  [sym_satisfies_expression] = "satisfies_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_extends_clause] = "extends_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_glimmer_template_repeat1] = "glimmer_template_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym__jsx_start_opening_element_repeat1] = "_jsx_start_opening_element_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym__glimmer_template_content] = sym__glimmer_template_content,
  [anon_sym_LTtemplate_GT] = anon_sym_LTtemplate_GT,
  [anon_sym_LT_SLASHtemplate_GT] = anon_sym_LT_SLASHtemplate_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [sym_jsx_text] = sym_jsx_text,
  [sym_jsx_identifier] = sym_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_unescaped_double_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_unescaped_single_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_satisfies] = anon_sym_satisfies,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_namespace_export] = sym_namespace_export,
  [sym_export_clause] = sym_export_clause,
  [sym_export_specifier] = sym_export_specifier,
  [sym__module_export_name] = sym__module_export_name,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_import_specifier] = sym_import_specifier,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_glimmer_template] = sym_glimmer_template,
  [sym_glimmer_opening_tag] = sym_glimmer_opening_tag,
  [sym_glimmer_closing_tag] = sym_glimmer_closing_tag,
  [sym_jsx_element] = sym_jsx_element,
  [sym_jsx_fragment] = sym_jsx_fragment,
  [sym_jsx_expression] = sym_jsx_expression,
  [sym_jsx_opening_element] = sym_jsx_opening_element,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_jsx_namespace_name] = sym_jsx_namespace_name,
  [sym_jsx_closing_element] = sym_jsx_closing_element,
  [sym_jsx_self_closing_element] = sym_jsx_self_closing_element,
  [sym_jsx_attribute] = sym_jsx_attribute,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_optional_chain] = sym_optional_chain,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_class_static_block] = sym_class_static_block,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_as_expression] = sym_as_expression,
  [sym_satisfies_expression] = sym_satisfies_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_glimmer_template_repeat1] = aux_sym_glimmer_template_repeat1,
  [aux_sym_jsx_element_repeat1] = aux_sym_jsx_element_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym__jsx_start_opening_element_repeat1] = aux_sym__jsx_start_opening_element_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym__glimmer_template_content] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LTtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASHtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_satisfies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_export] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__module_export_name] = {
    .visible = false,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_template] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_opening_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_chain] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_class_static_block] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_satisfies_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_glimmer_template_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__jsx_start_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constraint = 10,
  field_constructor = 11,
  field_content = 12,
  field_declaration = 13,
  field_decorator = 14,
  field_finalizer = 15,
  field_flags = 16,
  field_function = 17,
  field_handler = 18,
  field_increment = 19,
  field_index = 20,
  field_index_type = 21,
  field_initializer = 22,
  field_key = 23,
  field_kind = 24,
  field_label = 25,
  field_left = 26,
  field_module = 27,
  field_name = 28,
  field_object = 29,
  field_open_tag = 30,
  field_operator = 31,
  field_optional_chain = 32,
  field_parameter = 33,
  field_parameters = 34,
  field_pattern = 35,
  field_property = 36,
  field_return_type = 37,
  field_right = 38,
  field_sign = 39,
  field_source = 40,
  field_type = 41,
  field_type_arguments = 42,
  field_type_parameters = 43,
  field_value = 44,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_content] = "content",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_optional_chain] = "optional_chain",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 1},
  [12] = {.index = 3, .length = 1},
  [13] = {.index = 12, .length = 1},
  [14] = {.index = 13, .length = 2},
  [15] = {.index = 15, .length = 2},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 21, .length = 2},
  [19] = {.index = 23, .length = 2},
  [20] = {.index = 25, .length = 1},
  [21] = {.index = 26, .length = 2},
  [22] = {.index = 28, .length = 2},
  [23] = {.index = 30, .length = 2},
  [24] = {.index = 32, .length = 2},
  [28] = {.index = 34, .length = 1},
  [29] = {.index = 35, .length = 2},
  [30] = {.index = 37, .length = 2},
  [31] = {.index = 39, .length = 1},
  [32] = {.index = 40, .length = 2},
  [33] = {.index = 42, .length = 2},
  [34] = {.index = 44, .length = 6},
  [35] = {.index = 50, .length = 1},
  [36] = {.index = 51, .length = 3},
  [37] = {.index = 54, .length = 3},
  [38] = {.index = 57, .length = 2},
  [39] = {.index = 59, .length = 2},
  [40] = {.index = 61, .length = 2},
  [41] = {.index = 63, .length = 2},
  [42] = {.index = 65, .length = 2},
  [43] = {.index = 67, .length = 1},
  [44] = {.index = 68, .length = 1},
  [45] = {.index = 69, .length = 1},
  [46] = {.index = 70, .length = 2},
  [47] = {.index = 72, .length = 2},
  [48] = {.index = 74, .length = 2},
  [49] = {.index = 76, .length = 1},
  [52] = {.index = 77, .length = 2},
  [53] = {.index = 79, .length = 1},
  [54] = {.index = 80, .length = 2},
  [55] = {.index = 82, .length = 4},
  [56] = {.index = 86, .length = 2},
  [57] = {.index = 88, .length = 2},
  [58] = {.index = 26, .length = 2},
  [59] = {.index = 30, .length = 2},
  [60] = {.index = 74, .length = 2},
  [61] = {.index = 90, .length = 3},
  [62] = {.index = 93, .length = 2},
  [63] = {.index = 93, .length = 2},
  [64] = {.index = 95, .length = 3},
  [65] = {.index = 95, .length = 3},
  [66] = {.index = 98, .length = 3},
  [67] = {.index = 101, .length = 2},
  [68] = {.index = 103, .length = 3},
  [69] = {.index = 106, .length = 2},
  [70] = {.index = 108, .length = 4},
  [71] = {.index = 112, .length = 3},
  [72] = {.index = 115, .length = 2},
  [73] = {.index = 117, .length = 2},
  [74] = {.index = 119, .length = 1},
  [75] = {.index = 120, .length = 1},
  [76] = {.index = 26, .length = 2},
  [77] = {.index = 121, .length = 2},
  [78] = {.index = 123, .length = 5},
  [79] = {.index = 128, .length = 1},
  [80] = {.index = 129, .length = 2},
  [81] = {.index = 131, .length = 3},
  [82] = {.index = 134, .length = 2},
  [83] = {.index = 136, .length = 3},
  [84] = {.index = 139, .length = 6},
  [85] = {.index = 145, .length = 1},
  [86] = {.index = 146, .length = 1},
  [87] = {.index = 147, .length = 3},
  [88] = {.index = 150, .length = 3},
  [89] = {.index = 153, .length = 4},
  [90] = {.index = 157, .length = 2},
  [91] = {.index = 159, .length = 3},
  [92] = {.index = 162, .length = 2},
  [93] = {.index = 164, .length = 2},
  [94] = {.index = 166, .length = 2},
  [95] = {.index = 168, .length = 3},
  [96] = {.index = 171, .length = 2},
  [97] = {.index = 173, .length = 4},
  [98] = {.index = 177, .length = 2},
  [99] = {.index = 179, .length = 3},
  [100] = {.index = 182, .length = 2},
  [101] = {.index = 184, .length = 3},
  [102] = {.index = 187, .length = 3},
  [103] = {.index = 190, .length = 2},
  [104] = {.index = 192, .length = 2},
  [105] = {.index = 194, .length = 2},
  [106] = {.index = 196, .length = 2},
  [108] = {.index = 196, .length = 2},
  [109] = {.index = 198, .length = 2},
  [110] = {.index = 200, .length = 2},
  [111] = {.index = 202, .length = 4},
  [112] = {.index = 200, .length = 2},
  [113] = {.index = 206, .length = 4},
  [114] = {.index = 210, .length = 4},
  [115] = {.index = 214, .length = 5},
  [116] = {.index = 219, .length = 3},
  [117] = {.index = 134, .length = 2},
  [118] = {.index = 222, .length = 1},
  [119] = {.index = 222, .length = 1},
  [120] = {.index = 223, .length = 2},
  [121] = {.index = 225, .length = 3},
  [122] = {.index = 228, .length = 2},
  [123] = {.index = 230, .length = 3},
  [124] = {.index = 233, .length = 2},
  [125] = {.index = 235, .length = 3},
  [126] = {.index = 238, .length = 1},
  [127] = {.index = 239, .length = 2},
  [128] = {.index = 241, .length = 2},
  [129] = {.index = 243, .length = 5},
  [130] = {.index = 248, .length = 1},
  [131] = {.index = 249, .length = 4},
  [132] = {.index = 253, .length = 2},
  [133] = {.index = 255, .length = 2},
  [134] = {.index = 257, .length = 3},
  [135] = {.index = 260, .length = 1},
  [136] = {.index = 261, .length = 2},
  [137] = {.index = 263, .length = 2},
  [138] = {.index = 265, .length = 2},
  [139] = {.index = 267, .length = 4},
  [140] = {.index = 271, .length = 3},
  [141] = {.index = 274, .length = 4},
  [142] = {.index = 278, .length = 4},
  [143] = {.index = 282, .length = 1},
  [144] = {.index = 283, .length = 4},
  [145] = {.index = 287, .length = 4},
  [146] = {.index = 291, .length = 2},
  [147] = {.index = 293, .length = 2},
  [148] = {.index = 295, .length = 4},
  [149] = {.index = 299, .length = 4},
  [150] = {.index = 303, .length = 5},
  [151] = {.index = 308, .length = 2},
  [152] = {.index = 310, .length = 3},
  [153] = {.index = 313, .length = 2},
  [154] = {.index = 313, .length = 2},
  [155] = {.index = 315, .length = 3},
  [156] = {.index = 318, .length = 3},
  [157] = {.index = 129, .length = 2},
  [158] = {.index = 321, .length = 2},
  [159] = {.index = 323, .length = 3},
  [160] = {.index = 326, .length = 4},
  [161] = {.index = 330, .length = 3},
  [162] = {.index = 333, .length = 3},
  [163] = {.index = 336, .length = 2},
  [164] = {.index = 338, .length = 3},
  [165] = {.index = 341, .length = 5},
  [166] = {.index = 346, .length = 3},
  [167] = {.index = 346, .length = 3},
  [168] = {.index = 349, .length = 3},
  [169] = {.index = 352, .length = 2},
  [170] = {.index = 354, .length = 4},
  [171] = {.index = 129, .length = 2},
  [172] = {.index = 358, .length = 1},
  [173] = {.index = 359, .length = 2},
  [174] = {.index = 361, .length = 2},
  [175] = {.index = 363, .length = 2},
  [176] = {.index = 365, .length = 2},
  [177] = {.index = 367, .length = 3},
  [178] = {.index = 370, .length = 1},
  [179] = {.index = 371, .length = 3},
  [180] = {.index = 374, .length = 2},
  [181] = {.index = 376, .length = 2},
  [182] = {.index = 378, .length = 1},
  [183] = {.index = 379, .length = 4},
  [184] = {.index = 379, .length = 4},
  [185] = {.index = 383, .length = 4},
  [186] = {.index = 383, .length = 4},
  [187] = {.index = 387, .length = 4},
  [188] = {.index = 387, .length = 4},
  [189] = {.index = 391, .length = 2},
  [190] = {.index = 393, .length = 3},
  [191] = {.index = 396, .length = 5},
  [192] = {.index = 401, .length = 3},
  [193] = {.index = 404, .length = 2},
  [194] = {.index = 406, .length = 2},
  [195] = {.index = 408, .length = 2},
  [196] = {.index = 410, .length = 1},
  [197] = {.index = 411, .length = 4},
  [198] = {.index = 415, .length = 3},
  [199] = {.index = 418, .length = 4},
  [200] = {.index = 422, .length = 5},
  [201] = {.index = 427, .length = 1},
  [202] = {.index = 428, .length = 2},
  [203] = {.index = 430, .length = 4},
  [204] = {.index = 434, .length = 4},
  [205] = {.index = 438, .length = 2},
  [206] = {.index = 440, .length = 4},
  [207] = {.index = 444, .length = 4},
  [208] = {.index = 448, .length = 2},
  [209] = {.index = 450, .length = 2},
  [210] = {.index = 452, .length = 3},
  [211] = {.index = 455, .length = 3},
  [212] = {.index = 458, .length = 2},
  [213] = {.index = 460, .length = 2},
  [214] = {.index = 462, .length = 1},
  [215] = {.index = 463, .length = 1},
  [216] = {.index = 464, .length = 3},
  [217] = {.index = 467, .length = 2},
  [218] = {.index = 469, .length = 2},
  [219] = {.index = 471, .length = 4},
  [220] = {.index = 475, .length = 4},
  [221] = {.index = 479, .length = 4},
  [222] = {.index = 483, .length = 3},
  [223] = {.index = 486, .length = 2},
  [225] = {.index = 488, .length = 4},
  [226] = {.index = 492, .length = 5},
  [227] = {.index = 497, .length = 5},
  [228] = {.index = 502, .length = 5},
  [229] = {.index = 507, .length = 3},
  [230] = {.index = 510, .length = 3},
  [231] = {.index = 513, .length = 3},
  [232] = {.index = 510, .length = 3},
  [233] = {.index = 516, .length = 2},
  [234] = {.index = 518, .length = 4},
  [235] = {.index = 522, .length = 4},
  [236] = {.index = 526, .length = 3},
  [237] = {.index = 529, .length = 2},
  [238] = {.index = 531, .length = 2},
  [239] = {.index = 533, .length = 3},
  [240] = {.index = 536, .length = 2},
  [241] = {.index = 538, .length = 2},
  [242] = {.index = 540, .length = 1},
  [243] = {.index = 541, .length = 3},
  [244] = {.index = 544, .length = 2},
  [245] = {.index = 546, .length = 4},
  [246] = {.index = 550, .length = 4},
  [247] = {.index = 554, .length = 4},
  [248] = {.index = 558, .length = 3},
  [249] = {.index = 561, .length = 5},
  [250] = {.index = 566, .length = 5},
  [251] = {.index = 571, .length = 4},
  [252] = {.index = 575, .length = 4},
  [253] = {.index = 579, .length = 3},
  [254] = {.index = 582, .length = 3},
  [255] = {.index = 582, .length = 3},
  [256] = {.index = 585, .length = 2},
  [257] = {.index = 587, .length = 2},
  [258] = {.index = 589, .length = 3},
  [259] = {.index = 592, .length = 2},
  [260] = {.index = 594, .length = 2},
  [261] = {.index = 596, .length = 4},
  [262] = {.index = 600, .length = 5},
  [263] = {.index = 605, .length = 5},
  [264] = {.index = 610, .length = 4},
  [265] = {.index = 610, .length = 4},
  [266] = {.index = 614, .length = 4},
  [267] = {.index = 618, .length = 3},
  [268] = {.index = 621, .length = 2},
  [269] = {.index = 623, .length = 2},
  [270] = {.index = 625, .length = 3},
  [271] = {.index = 628, .length = 4},
  [272] = {.index = 632, .length = 5},
  [273] = {.index = 637, .length = 3},
  [274] = {.index = 640, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_pattern, 0},
  [9] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [11] =
    {field_body, 1},
  [12] =
    {field_constructor, 1},
  [13] =
    {field_argument, 0},
    {field_operator, 1},
  [15] =
    {field_arguments, 1},
    {field_function, 0},
  [17] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [19] =
    {field_parameters, 0},
    {field_return_type, 1},
  [21] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [23] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [25] =
    {field_declaration, 2},
  [26] =
    {field_left, 0},
    {field_right, 2},
  [28] =
    {field_body, 2},
    {field_label, 0},
  [30] =
    {field_body, 2},
    {field_parameter, 0},
  [32] =
    {field_body, 1},
    {field_name, 0},
  [34] =
    {field_source, 1},
  [35] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [37] =
    {field_name, 0},
    {field_type, 1},
  [39] =
    {field_kind, 0},
  [40] =
    {field_condition, 1},
    {field_consequence, 2},
  [42] =
    {field_body, 2},
    {field_value, 1},
  [44] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [50] =
    {field_pattern, 1},
  [51] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [54] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [57] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [59] =
    {field_body, 2},
    {field_condition, 1},
  [61] =
    {field_body, 1},
    {field_handler, 2},
  [63] =
    {field_body, 1},
    {field_finalizer, 2},
  [65] =
    {field_body, 2},
    {field_object, 1},
  [67] =
    {field_label, 1},
  [68] =
    {field_name, 1},
  [69] =
    {field_attribute, 0},
  [70] =
    {field_name, 0},
    {field_value, 1},
  [72] =
    {field_constraint, 1},
    {field_name, 0},
  [74] =
    {field_body, 2},
    {field_name, 1},
  [76] =
    {field_value, 1},
  [77] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [79] =
    {field_body, 2},
  [80] =
    {field_body, 2},
    {field_type_parameters, 1},
  [82] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [86] =
    {field_arguments, 2},
    {field_constructor, 1},
  [88] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [90] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [93] =
    {field_object, 0},
    {field_property, 2},
  [95] =
    {field_object, 0},
    {field_optional_chain, 1},
    {field_property, 2},
  [98] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [101] =
    {field_arguments, 2},
    {field_function, 0},
  [103] =
    {field_close_tag, 2},
    {field_content, 1},
    {field_open_tag, 0},
  [106] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [108] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [112] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [115] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [117] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [119] =
    {field_source, 2, .inherited = true},
  [120] =
    {field_value, 2},
  [121] =
    {field_key, 0},
    {field_value, 2},
  [123] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [128] =
    {field_source, 2},
  [129] =
    {field_name, 0},
    {field_type, 2},
  [131] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [134] =
    {field_body, 3},
    {field_name, 2},
  [136] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [139] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [145] =
    {field_type, 2},
  [146] =
    {field_pattern, 2},
  [147] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [150] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [153] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [157] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [159] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [162] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [164] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [166] =
    {field_name, 1},
    {field_type_arguments, 2},
  [168] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [171] =
    {field_flags, 3},
    {field_pattern, 1},
  [173] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [177] =
    {field_body, 3},
    {field_name, 1},
  [179] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [182] =
    {field_type_arguments, 2},
    {field_value, 1},
  [184] =
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1},
    {field_value, 2, .inherited = true},
  [187] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [190] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [192] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [194] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [196] =
    {field_name, 0},
    {field_type_arguments, 1},
  [198] =
    {field_body, 3},
    {field_type_parameters, 1},
  [200] =
    {field_body, 3},
    {field_parameter, 1},
  [202] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [206] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [210] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [214] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [219] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [222] =
    {field_type, 1},
  [223] =
    {field_index, 2},
    {field_object, 0},
  [225] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [228] =
    {field_declaration, 3},
    {field_decorator, 0, .inherited = true},
  [230] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [233] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [235] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [238] =
    {field_source, 3, .inherited = true},
  [239] =
    {field_alias, 2},
    {field_name, 0},
  [241] =
    {field_name, 1},
    {field_value, 3},
  [243] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [248] =
    {field_pattern, 3},
  [249] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [253] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [255] =
    {field_body, 1},
    {field_condition, 3},
  [257] =
    {field_attribute, 3, .inherited = true},
    {field_name, 1},
    {field_type_arguments, 2},
  [260] =
    {field_name, 2},
  [261] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [263] =
    {field_name, 1},
    {field_type, 2},
  [265] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [267] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [271] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [274] =
    {field_type_arguments, 2},
    {field_type_arguments, 3, .inherited = true},
    {field_value, 1},
    {field_value, 3, .inherited = true},
  [278] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [282] =
    {field_parameters, 1},
  [283] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [287] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [291] =
    {field_module, 0},
    {field_name, 2},
  [293] =
    {field_parameters, 0},
    {field_return_type, 2},
  [295] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [299] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [303] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [308] =
    {field_body, 4},
    {field_name, 2},
  [310] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [313] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [315] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [318] =
    {field_index, 3},
    {field_object, 0},
    {field_optional_chain, 1},
  [321] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [323] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [326] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [330] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [333] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [336] =
    {field_alias, 3},
    {field_name, 1},
  [338] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [341] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [346] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [349] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [352] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [354] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [358] =
    {field_type, 3},
  [359] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [361] =
    {field_name, 2},
    {field_type, 3},
  [363] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [365] =
    {field_name, 1},
    {field_type, 3},
  [367] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [370] =
    {field_name, 3},
  [371] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [374] =
    {field_parameters, 1},
    {field_type, 2},
  [376] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [378] =
    {field_parameters, 2},
  [379] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [383] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [387] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [391] =
    {field_parameters, 1},
    {field_type, 3},
  [393] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [396] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [401] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [404] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [406] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [408] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [410] =
    {field_name, 2, .inherited = true},
  [411] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [415] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [418] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [422] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [427] =
    {field_source, 4},
  [428] =
    {field_body, 3},
    {field_value, 1},
  [430] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [434] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [438] =
    {field_body, 4},
    {field_parameter, 2},
  [440] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [444] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [448] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [450] =
    {field_name, 2},
    {field_type, 4},
  [452] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [455] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [458] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [460] =
    {field_name, 3},
    {field_type, 4},
  [462] =
    {field_type, 4},
  [463] =
    {field_name, 4},
  [464] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [467] =
    {field_parameters, 2},
    {field_type, 3},
  [469] =
    {field_parameters, 3},
    {field_type_parameters, 2},
  [471] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [475] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [479] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [483] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [486] =
    {field_parameters, 2},
    {field_type, 4},
  [488] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [492] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [497] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [502] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [507] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [510] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [513] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [516] =
    {field_sign, 0},
    {field_type, 5},
  [518] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [522] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [526] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [529] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [531] =
    {field_name, 3},
    {field_type, 5},
  [533] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [536] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [538] =
    {field_name, 4},
    {field_type, 5},
  [540] =
    {field_name, 5},
  [541] =
    {field_parameters, 3},
    {field_type, 4},
    {field_type_parameters, 2},
  [544] =
    {field_index, 3},
    {field_object, 0},
  [546] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [550] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [554] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [558] =
    {field_parameters, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [561] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [566] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [571] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [575] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [579] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [582] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [585] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [587] =
    {field_name, 4},
    {field_type, 6},
  [589] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [592] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [594] =
    {field_name, 5},
    {field_type, 6},
  [596] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [600] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [605] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [610] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [614] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [618] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [621] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [623] =
    {field_name, 5},
    {field_type, 7},
  [625] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [628] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [632] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [637] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [640] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [12] = {
    [0] = alias_sym_type_identifier,
  },
  [21] = {
    [0] = sym_identifier,
  },
  [22] = {
    [0] = alias_sym_statement_identifier,
  },
  [23] = {
    [0] = sym_identifier,
  },
  [25] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [26] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [27] = {
    [1] = sym_identifier,
  },
  [43] = {
    [1] = alias_sym_statement_identifier,
  },
  [46] = {
    [0] = alias_sym_type_identifier,
  },
  [47] = {
    [0] = alias_sym_type_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [50] = {
    [0] = alias_sym_type_identifier,
  },
  [51] = {
    [0] = alias_sym_this_type,
  },
  [62] = {
    [2] = alias_sym_property_identifier,
  },
  [64] = {
    [2] = alias_sym_property_identifier,
  },
  [76] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [95] = {
    [0] = alias_sym_type_identifier,
  },
  [98] = {
    [1] = alias_sym_type_identifier,
  },
  [99] = {
    [1] = alias_sym_type_identifier,
  },
  [106] = {
    [0] = alias_sym_type_identifier,
  },
  [107] = {
    [1] = alias_sym_type_identifier,
  },
  [110] = {
    [1] = sym_identifier,
  },
  [117] = {
    [2] = alias_sym_type_identifier,
  },
  [118] = {
    [1] = alias_sym_type_identifier,
  },
  [123] = {
    [2] = alias_sym_type_identifier,
  },
  [128] = {
    [1] = alias_sym_type_identifier,
  },
  [140] = {
    [1] = alias_sym_type_identifier,
  },
  [146] = {
    [2] = alias_sym_type_identifier,
  },
  [151] = {
    [2] = alias_sym_type_identifier,
  },
  [152] = {
    [2] = alias_sym_type_identifier,
  },
  [153] = {
    [1] = alias_sym_type_identifier,
  },
  [157] = {
    [0] = sym_identifier,
  },
  [159] = {
    [2] = alias_sym_type_identifier,
  },
  [160] = {
    [2] = alias_sym_type_identifier,
  },
  [162] = {
    [3] = alias_sym_type_identifier,
  },
  [164] = {
    [1] = alias_sym_type_identifier,
  },
  [166] = {
    [1] = sym_identifier,
  },
  [171] = {
    [0] = alias_sym_type_identifier,
  },
  [183] = {
    [2] = alias_sym_property_identifier,
  },
  [185] = {
    [2] = alias_sym_property_identifier,
  },
  [187] = {
    [2] = alias_sym_property_identifier,
  },
  [192] = {
    [2] = alias_sym_type_identifier,
  },
  [197] = {
    [2] = alias_sym_type_identifier,
  },
  [198] = {
    [3] = alias_sym_type_identifier,
  },
  [199] = {
    [3] = alias_sym_type_identifier,
  },
  [224] = {
    [3] = alias_sym_property_identifier,
  },
  [225] = {
    [3] = alias_sym_type_identifier,
  },
  [230] = {
    [1] = sym_identifier,
  },
  [231] = {
    [0] = alias_sym_type_identifier,
  },
  [254] = {
    [2] = sym_identifier,
  },
  [264] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_predefined_type, 2,
    sym_predefined_type,
    sym_identifier,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 4,
  [8] = 4,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 14,
  [18] = 18,
  [19] = 14,
  [20] = 20,
  [21] = 20,
  [22] = 14,
  [23] = 20,
  [24] = 20,
  [25] = 20,
  [26] = 20,
  [27] = 20,
  [28] = 14,
  [29] = 14,
  [30] = 14,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 31,
  [38] = 31,
  [39] = 39,
  [40] = 35,
  [41] = 34,
  [42] = 42,
  [43] = 36,
  [44] = 33,
  [45] = 32,
  [46] = 36,
  [47] = 47,
  [48] = 42,
  [49] = 34,
  [50] = 39,
  [51] = 47,
  [52] = 42,
  [53] = 53,
  [54] = 35,
  [55] = 47,
  [56] = 33,
  [57] = 39,
  [58] = 32,
  [59] = 59,
  [60] = 60,
  [61] = 59,
  [62] = 59,
  [63] = 63,
  [64] = 59,
  [65] = 63,
  [66] = 59,
  [67] = 59,
  [68] = 68,
  [69] = 59,
  [70] = 70,
  [71] = 59,
  [72] = 72,
  [73] = 59,
  [74] = 74,
  [75] = 75,
  [76] = 59,
  [77] = 77,
  [78] = 77,
  [79] = 77,
  [80] = 80,
  [81] = 80,
  [82] = 80,
  [83] = 80,
  [84] = 80,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 88,
  [90] = 88,
  [91] = 88,
  [92] = 92,
  [93] = 88,
  [94] = 88,
  [95] = 88,
  [96] = 88,
  [97] = 88,
  [98] = 98,
  [99] = 98,
  [100] = 98,
  [101] = 98,
  [102] = 98,
  [103] = 98,
  [104] = 98,
  [105] = 98,
  [106] = 106,
  [107] = 106,
  [108] = 106,
  [109] = 106,
  [110] = 110,
  [111] = 110,
  [112] = 110,
  [113] = 110,
  [114] = 114,
  [115] = 114,
  [116] = 114,
  [117] = 117,
  [118] = 114,
  [119] = 119,
  [120] = 114,
  [121] = 114,
  [122] = 117,
  [123] = 117,
  [124] = 119,
  [125] = 114,
  [126] = 114,
  [127] = 127,
  [128] = 127,
  [129] = 129,
  [130] = 129,
  [131] = 131,
  [132] = 132,
  [133] = 131,
  [134] = 132,
  [135] = 132,
  [136] = 129,
  [137] = 131,
  [138] = 138,
  [139] = 139,
  [140] = 139,
  [141] = 141,
  [142] = 138,
  [143] = 138,
  [144] = 144,
  [145] = 138,
  [146] = 138,
  [147] = 147,
  [148] = 139,
  [149] = 138,
  [150] = 138,
  [151] = 144,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 144,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 159,
  [173] = 170,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 144,
  [189] = 189,
  [190] = 189,
  [191] = 144,
  [192] = 144,
  [193] = 144,
  [194] = 194,
  [195] = 189,
  [196] = 144,
  [197] = 189,
  [198] = 189,
  [199] = 144,
  [200] = 200,
  [201] = 189,
  [202] = 189,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 203,
  [207] = 207,
  [208] = 205,
  [209] = 209,
  [210] = 210,
  [211] = 205,
  [212] = 212,
  [213] = 212,
  [214] = 214,
  [215] = 212,
  [216] = 212,
  [217] = 212,
  [218] = 218,
  [219] = 212,
  [220] = 220,
  [221] = 212,
  [222] = 212,
  [223] = 212,
  [224] = 212,
  [225] = 225,
  [226] = 212,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 212,
  [231] = 218,
  [232] = 229,
  [233] = 233,
  [234] = 212,
  [235] = 235,
  [236] = 235,
  [237] = 235,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 240,
  [243] = 238,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 240,
  [248] = 248,
  [249] = 249,
  [250] = 248,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 249,
  [256] = 253,
  [257] = 257,
  [258] = 251,
  [259] = 238,
  [260] = 260,
  [261] = 238,
  [262] = 246,
  [263] = 254,
  [264] = 248,
  [265] = 249,
  [266] = 251,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 260,
  [271] = 271,
  [272] = 246,
  [273] = 238,
  [274] = 240,
  [275] = 238,
  [276] = 248,
  [277] = 249,
  [278] = 251,
  [279] = 260,
  [280] = 240,
  [281] = 246,
  [282] = 282,
  [283] = 260,
  [284] = 254,
  [285] = 254,
  [286] = 238,
  [287] = 252,
  [288] = 240,
  [289] = 246,
  [290] = 238,
  [291] = 246,
  [292] = 254,
  [293] = 248,
  [294] = 249,
  [295] = 251,
  [296] = 260,
  [297] = 246,
  [298] = 260,
  [299] = 254,
  [300] = 254,
  [301] = 260,
  [302] = 251,
  [303] = 249,
  [304] = 248,
  [305] = 305,
  [306] = 240,
  [307] = 240,
  [308] = 248,
  [309] = 249,
  [310] = 251,
  [311] = 249,
  [312] = 248,
  [313] = 251,
  [314] = 260,
  [315] = 244,
  [316] = 240,
  [317] = 246,
  [318] = 238,
  [319] = 254,
  [320] = 320,
  [321] = 321,
  [322] = 241,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 324,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 329,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 330,
  [340] = 340,
  [341] = 324,
  [342] = 342,
  [343] = 324,
  [344] = 340,
  [345] = 345,
  [346] = 329,
  [347] = 328,
  [348] = 340,
  [349] = 330,
  [350] = 328,
  [351] = 329,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 328,
  [356] = 324,
  [357] = 324,
  [358] = 327,
  [359] = 345,
  [360] = 325,
  [361] = 325,
  [362] = 362,
  [363] = 363,
  [364] = 328,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 365,
  [376] = 376,
  [377] = 325,
  [378] = 378,
  [379] = 363,
  [380] = 330,
  [381] = 340,
  [382] = 337,
  [383] = 324,
  [384] = 363,
  [385] = 330,
  [386] = 353,
  [387] = 324,
  [388] = 345,
  [389] = 378,
  [390] = 329,
  [391] = 365,
  [392] = 366,
  [393] = 376,
  [394] = 352,
  [395] = 324,
  [396] = 340,
  [397] = 374,
  [398] = 330,
  [399] = 340,
  [400] = 352,
  [401] = 373,
  [402] = 372,
  [403] = 336,
  [404] = 327,
  [405] = 378,
  [406] = 406,
  [407] = 370,
  [408] = 378,
  [409] = 376,
  [410] = 353,
  [411] = 367,
  [412] = 369,
  [413] = 376,
  [414] = 368,
  [415] = 415,
  [416] = 334,
  [417] = 374,
  [418] = 327,
  [419] = 373,
  [420] = 372,
  [421] = 345,
  [422] = 422,
  [423] = 370,
  [424] = 369,
  [425] = 328,
  [426] = 368,
  [427] = 367,
  [428] = 325,
  [429] = 366,
  [430] = 363,
  [431] = 365,
  [432] = 366,
  [433] = 367,
  [434] = 367,
  [435] = 366,
  [436] = 368,
  [437] = 369,
  [438] = 365,
  [439] = 370,
  [440] = 365,
  [441] = 363,
  [442] = 353,
  [443] = 325,
  [444] = 444,
  [445] = 368,
  [446] = 345,
  [447] = 372,
  [448] = 329,
  [449] = 373,
  [450] = 374,
  [451] = 376,
  [452] = 374,
  [453] = 378,
  [454] = 331,
  [455] = 352,
  [456] = 373,
  [457] = 327,
  [458] = 324,
  [459] = 331,
  [460] = 324,
  [461] = 353,
  [462] = 327,
  [463] = 329,
  [464] = 352,
  [465] = 345,
  [466] = 363,
  [467] = 353,
  [468] = 369,
  [469] = 372,
  [470] = 370,
  [471] = 330,
  [472] = 345,
  [473] = 327,
  [474] = 325,
  [475] = 372,
  [476] = 373,
  [477] = 363,
  [478] = 353,
  [479] = 479,
  [480] = 340,
  [481] = 352,
  [482] = 328,
  [483] = 324,
  [484] = 374,
  [485] = 376,
  [486] = 486,
  [487] = 365,
  [488] = 334,
  [489] = 353,
  [490] = 366,
  [491] = 340,
  [492] = 378,
  [493] = 330,
  [494] = 327,
  [495] = 345,
  [496] = 352,
  [497] = 367,
  [498] = 498,
  [499] = 368,
  [500] = 325,
  [501] = 369,
  [502] = 363,
  [503] = 370,
  [504] = 504,
  [505] = 365,
  [506] = 366,
  [507] = 370,
  [508] = 367,
  [509] = 368,
  [510] = 369,
  [511] = 328,
  [512] = 370,
  [513] = 372,
  [514] = 373,
  [515] = 374,
  [516] = 376,
  [517] = 369,
  [518] = 378,
  [519] = 329,
  [520] = 378,
  [521] = 368,
  [522] = 366,
  [523] = 334,
  [524] = 372,
  [525] = 373,
  [526] = 367,
  [527] = 352,
  [528] = 374,
  [529] = 376,
  [530] = 324,
  [531] = 531,
  [532] = 531,
  [533] = 531,
  [534] = 534,
  [535] = 534,
  [536] = 534,
  [537] = 537,
  [538] = 537,
  [539] = 537,
  [540] = 540,
  [541] = 540,
  [542] = 540,
  [543] = 543,
  [544] = 543,
  [545] = 543,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 185,
  [550] = 548,
  [551] = 546,
  [552] = 175,
  [553] = 548,
  [554] = 546,
  [555] = 547,
  [556] = 547,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 563,
  [565] = 563,
  [566] = 562,
  [567] = 562,
  [568] = 568,
  [569] = 569,
  [570] = 568,
  [571] = 571,
  [572] = 571,
  [573] = 573,
  [574] = 571,
  [575] = 573,
  [576] = 576,
  [577] = 571,
  [578] = 571,
  [579] = 573,
  [580] = 571,
  [581] = 569,
  [582] = 158,
  [583] = 571,
  [584] = 584,
  [585] = 571,
  [586] = 183,
  [587] = 587,
  [588] = 571,
  [589] = 571,
  [590] = 590,
  [591] = 181,
  [592] = 164,
  [593] = 568,
  [594] = 571,
  [595] = 590,
  [596] = 571,
  [597] = 160,
  [598] = 160,
  [599] = 167,
  [600] = 158,
  [601] = 601,
  [602] = 167,
  [603] = 590,
  [604] = 604,
  [605] = 183,
  [606] = 571,
  [607] = 571,
  [608] = 608,
  [609] = 152,
  [610] = 569,
  [611] = 576,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 157,
  [616] = 616,
  [617] = 571,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 153,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 162,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 164,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 181,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 184,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 778,
  [779] = 779,
  [780] = 779,
  [781] = 779,
  [782] = 779,
  [783] = 779,
  [784] = 784,
  [785] = 785,
  [786] = 785,
  [787] = 784,
  [788] = 785,
  [789] = 785,
  [790] = 784,
  [791] = 784,
  [792] = 784,
  [793] = 785,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 811,
  [813] = 813,
  [814] = 811,
  [815] = 813,
  [816] = 813,
  [817] = 817,
  [818] = 817,
  [819] = 817,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 822,
  [824] = 822,
  [825] = 821,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 822,
  [830] = 830,
  [831] = 827,
  [832] = 830,
  [833] = 820,
  [834] = 822,
  [835] = 822,
  [836] = 822,
  [837] = 822,
  [838] = 827,
  [839] = 830,
  [840] = 822,
  [841] = 830,
  [842] = 827,
  [843] = 830,
  [844] = 828,
  [845] = 830,
  [846] = 821,
  [847] = 826,
  [848] = 821,
  [849] = 826,
  [850] = 822,
  [851] = 827,
  [852] = 826,
  [853] = 821,
  [854] = 827,
  [855] = 822,
  [856] = 826,
  [857] = 820,
  [858] = 822,
  [859] = 820,
  [860] = 830,
  [861] = 821,
  [862] = 826,
  [863] = 863,
  [864] = 820,
  [865] = 865,
  [866] = 827,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 868,
  [871] = 871,
  [872] = 869,
  [873] = 873,
  [874] = 869,
  [875] = 875,
  [876] = 876,
  [877] = 873,
  [878] = 876,
  [879] = 869,
  [880] = 880,
  [881] = 875,
  [882] = 882,
  [883] = 875,
  [884] = 868,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 882,
  [889] = 882,
  [890] = 876,
  [891] = 891,
  [892] = 892,
  [893] = 880,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 876,
  [903] = 875,
  [904] = 896,
  [905] = 868,
  [906] = 894,
  [907] = 896,
  [908] = 882,
  [909] = 876,
  [910] = 882,
  [911] = 868,
  [912] = 898,
  [913] = 896,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 886,
  [919] = 873,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 894,
  [924] = 898,
  [925] = 882,
  [926] = 887,
  [927] = 927,
  [928] = 887,
  [929] = 929,
  [930] = 891,
  [931] = 931,
  [932] = 876,
  [933] = 886,
  [934] = 892,
  [935] = 899,
  [936] = 936,
  [937] = 899,
  [938] = 875,
  [939] = 915,
  [940] = 873,
  [941] = 915,
  [942] = 891,
  [943] = 887,
  [944] = 894,
  [945] = 899,
  [946] = 915,
  [947] = 900,
  [948] = 897,
  [949] = 898,
  [950] = 896,
  [951] = 899,
  [952] = 886,
  [953] = 901,
  [954] = 892,
  [955] = 891,
  [956] = 894,
  [957] = 892,
  [958] = 900,
  [959] = 891,
  [960] = 892,
  [961] = 897,
  [962] = 898,
  [963] = 963,
  [964] = 892,
  [965] = 897,
  [966] = 886,
  [967] = 900,
  [968] = 968,
  [969] = 886,
  [970] = 891,
  [971] = 894,
  [972] = 897,
  [973] = 916,
  [974] = 871,
  [975] = 898,
  [976] = 887,
  [977] = 900,
  [978] = 920,
  [979] = 915,
  [980] = 980,
  [981] = 896,
  [982] = 868,
  [983] = 899,
  [984] = 869,
  [985] = 963,
  [986] = 869,
  [987] = 873,
  [988] = 895,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 873,
  [993] = 875,
  [994] = 887,
  [995] = 897,
  [996] = 869,
  [997] = 900,
  [998] = 915,
  [999] = 963,
  [1000] = 863,
  [1001] = 963,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1002,
  [1005] = 1002,
  [1006] = 1006,
  [1007] = 963,
  [1008] = 1003,
  [1009] = 963,
  [1010] = 1003,
  [1011] = 1011,
  [1012] = 963,
  [1013] = 1011,
  [1014] = 963,
  [1015] = 963,
  [1016] = 1011,
  [1017] = 1017,
  [1018] = 963,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 963,
  [1022] = 963,
  [1023] = 1020,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1025,
  [1028] = 1028,
  [1029] = 963,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1026,
  [1034] = 1034,
  [1035] = 1020,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1026,
  [1039] = 1039,
  [1040] = 1024,
  [1041] = 1024,
  [1042] = 828,
  [1043] = 794,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1006,
  [1047] = 1047,
  [1048] = 963,
  [1049] = 863,
  [1050] = 963,
  [1051] = 1051,
  [1052] = 1047,
  [1053] = 807,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1054,
  [1058] = 1045,
  [1059] = 1047,
  [1060] = 963,
  [1061] = 1047,
  [1062] = 1062,
  [1063] = 1045,
  [1064] = 1064,
  [1065] = 1047,
  [1066] = 1055,
  [1067] = 1045,
  [1068] = 1068,
  [1069] = 1068,
  [1070] = 1054,
  [1071] = 1047,
  [1072] = 1072,
  [1073] = 1064,
  [1074] = 1074,
  [1075] = 1074,
  [1076] = 1076,
  [1077] = 1045,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1072,
  [1081] = 1047,
  [1082] = 1047,
  [1083] = 1083,
  [1084] = 1078,
  [1085] = 1047,
  [1086] = 1072,
  [1087] = 1064,
  [1088] = 1088,
  [1089] = 1079,
  [1090] = 1088,
  [1091] = 1076,
  [1092] = 1045,
  [1093] = 1076,
  [1094] = 1064,
  [1095] = 794,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1074,
  [1099] = 1099,
  [1100] = 1088,
  [1101] = 1044,
  [1102] = 1044,
  [1103] = 1045,
  [1104] = 1045,
  [1105] = 1064,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1072,
  [1109] = 1074,
  [1110] = 1028,
  [1111] = 1099,
  [1112] = 1107,
  [1113] = 1019,
  [1114] = 1039,
  [1115] = 1064,
  [1116] = 1088,
  [1117] = 1036,
  [1118] = 1037,
  [1119] = 1088,
  [1120] = 1099,
  [1121] = 807,
  [1122] = 1088,
  [1123] = 1096,
  [1124] = 1030,
  [1125] = 1074,
  [1126] = 1031,
  [1127] = 1056,
  [1128] = 1096,
  [1129] = 1047,
  [1130] = 1047,
  [1131] = 1074,
  [1132] = 1088,
  [1133] = 1088,
  [1134] = 1134,
  [1135] = 1064,
  [1136] = 1074,
  [1137] = 1047,
  [1138] = 1138,
  [1139] = 1044,
  [1140] = 1088,
  [1141] = 1045,
  [1142] = 1074,
  [1143] = 1143,
  [1144] = 1074,
  [1145] = 1062,
  [1146] = 1074,
  [1147] = 1088,
  [1148] = 1064,
  [1149] = 1149,
  [1150] = 1083,
  [1151] = 1151,
  [1152] = 1044,
  [1153] = 1047,
  [1154] = 1154,
  [1155] = 1149,
  [1156] = 1156,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 1074,
  [1160] = 1055,
  [1161] = 1068,
  [1162] = 1088,
  [1163] = 1163,
  [1164] = 1088,
  [1165] = 1044,
  [1166] = 1064,
  [1167] = 1044,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1074,
  [1171] = 1171,
  [1172] = 1097,
  [1173] = 1056,
  [1174] = 1074,
  [1175] = 1106,
  [1176] = 1044,
  [1177] = 1088,
  [1178] = 1074,
  [1179] = 1179,
  [1180] = 1078,
  [1181] = 1088,
  [1182] = 1182,
  [1183] = 1154,
  [1184] = 1083,
  [1185] = 1044,
  [1186] = 1088,
  [1187] = 1074,
  [1188] = 1188,
  [1189] = 1188,
  [1190] = 1188,
  [1191] = 1188,
  [1192] = 1188,
  [1193] = 1188,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1195,
  [1198] = 1196,
  [1199] = 1194,
  [1200] = 1200,
  [1201] = 1196,
  [1202] = 1202,
  [1203] = 1202,
  [1204] = 1202,
  [1205] = 1202,
  [1206] = 1195,
  [1207] = 1202,
  [1208] = 1195,
  [1209] = 1194,
  [1210] = 1194,
  [1211] = 1196,
  [1212] = 1195,
  [1213] = 1194,
  [1214] = 1196,
  [1215] = 1194,
  [1216] = 1196,
  [1217] = 1202,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1218,
  [1221] = 1218,
  [1222] = 1218,
  [1223] = 185,
  [1224] = 1218,
  [1225] = 1218,
  [1226] = 175,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1231,
  [1234] = 152,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1231,
  [1238] = 175,
  [1239] = 1239,
  [1240] = 1231,
  [1241] = 155,
  [1242] = 1231,
  [1243] = 185,
  [1244] = 153,
  [1245] = 1231,
  [1246] = 1231,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 158,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 808,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 183,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 557,
  [1286] = 1286,
  [1287] = 558,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1296,
  [1297] = 1297,
  [1298] = 1298,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1302,
  [1303] = 1303,
  [1304] = 1304,
  [1305] = 559,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 157,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 153,
  [1332] = 1332,
  [1333] = 152,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 561,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1364,
  [1365] = 560,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 809,
  [1373] = 1373,
  [1374] = 810,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1371,
  [1383] = 184,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1322,
  [1387] = 1373,
  [1388] = 1388,
  [1389] = 1268,
  [1390] = 1390,
  [1391] = 1368,
  [1392] = 1371,
  [1393] = 1370,
  [1394] = 1368,
  [1395] = 1321,
  [1396] = 1396,
  [1397] = 1366,
  [1398] = 1398,
  [1399] = 1363,
  [1400] = 1366,
  [1401] = 1262,
  [1402] = 1402,
  [1403] = 1377,
  [1404] = 1404,
  [1405] = 1360,
  [1406] = 1406,
  [1407] = 1373,
  [1408] = 1358,
  [1409] = 1322,
  [1410] = 1410,
  [1411] = 1357,
  [1412] = 1378,
  [1413] = 1306,
  [1414] = 1414,
  [1415] = 1353,
  [1416] = 1306,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1363,
  [1420] = 1377,
  [1421] = 1360,
  [1422] = 1358,
  [1423] = 1357,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1353,
  [1427] = 1286,
  [1428] = 1428,
  [1429] = 1296,
  [1430] = 1288,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1252,
  [1435] = 1315,
  [1436] = 1436,
  [1437] = 157,
  [1438] = 1289,
  [1439] = 1439,
  [1440] = 1252,
  [1441] = 1315,
  [1442] = 1442,
  [1443] = 1268,
  [1444] = 1262,
  [1445] = 1370,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1402,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 162,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 167,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 184,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 164,
  [1475] = 1475,
  [1476] = 1314,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1378,
  [1482] = 1482,
  [1483] = 1402,
  [1484] = 1484,
  [1485] = 1402,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1321,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1284,
  [1492] = 1492,
  [1493] = 1284,
  [1494] = 1494,
  [1495] = 183,
  [1496] = 162,
  [1497] = 1497,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 167,
  [1501] = 1314,
  [1502] = 1502,
  [1503] = 1281,
  [1504] = 181,
  [1505] = 160,
  [1506] = 1229,
  [1507] = 1230,
  [1508] = 1269,
  [1509] = 1296,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1486,
  [1513] = 1513,
  [1514] = 1286,
  [1515] = 1515,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 164,
  [1520] = 1520,
  [1521] = 1521,
  [1522] = 1502,
  [1523] = 158,
  [1524] = 181,
  [1525] = 1269,
  [1526] = 1281,
  [1527] = 1527,
  [1528] = 160,
  [1529] = 1529,
  [1530] = 1521,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1289,
  [1535] = 1288,
  [1536] = 1536,
  [1537] = 1363,
  [1538] = 1249,
  [1539] = 1250,
  [1540] = 1247,
  [1541] = 1541,
  [1542] = 1358,
  [1543] = 1281,
  [1544] = 1544,
  [1545] = 1357,
  [1546] = 1371,
  [1547] = 1370,
  [1548] = 1497,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1269,
  [1552] = 1289,
  [1553] = 1553,
  [1554] = 1284,
  [1555] = 1368,
  [1556] = 1556,
  [1557] = 1236,
  [1558] = 1558,
  [1559] = 1559,
  [1560] = 1235,
  [1561] = 1561,
  [1562] = 1497,
  [1563] = 1563,
  [1564] = 1360,
  [1565] = 1321,
  [1566] = 1248,
  [1567] = 1232,
  [1568] = 1550,
  [1569] = 1569,
  [1570] = 1377,
  [1571] = 1561,
  [1572] = 1257,
  [1573] = 1561,
  [1574] = 1563,
  [1575] = 1373,
  [1576] = 1239,
  [1577] = 1322,
  [1578] = 1363,
  [1579] = 1378,
  [1580] = 1306,
  [1581] = 1581,
  [1582] = 1550,
  [1583] = 1269,
  [1584] = 1556,
  [1585] = 1296,
  [1586] = 1586,
  [1587] = 1268,
  [1588] = 1262,
  [1589] = 1268,
  [1590] = 1296,
  [1591] = 1563,
  [1592] = 1592,
  [1593] = 1306,
  [1594] = 1378,
  [1595] = 1563,
  [1596] = 1521,
  [1597] = 1322,
  [1598] = 1373,
  [1599] = 1502,
  [1600] = 1371,
  [1601] = 1370,
  [1602] = 1368,
  [1603] = 1366,
  [1604] = 1262,
  [1605] = 1353,
  [1606] = 1377,
  [1607] = 1360,
  [1608] = 1550,
  [1609] = 1609,
  [1610] = 1252,
  [1611] = 1358,
  [1612] = 1357,
  [1613] = 1563,
  [1614] = 1315,
  [1615] = 1255,
  [1616] = 1486,
  [1617] = 1561,
  [1618] = 1550,
  [1619] = 1252,
  [1620] = 1257,
  [1621] = 1563,
  [1622] = 1315,
  [1623] = 1623,
  [1624] = 1255,
  [1625] = 1561,
  [1626] = 1281,
  [1627] = 1314,
  [1628] = 1284,
  [1629] = 1321,
  [1630] = 1289,
  [1631] = 1288,
  [1632] = 1286,
  [1633] = 1255,
  [1634] = 1257,
  [1635] = 1286,
  [1636] = 1314,
  [1637] = 1563,
  [1638] = 1549,
  [1639] = 1639,
  [1640] = 1375,
  [1641] = 1366,
  [1642] = 1288,
  [1643] = 1353,
  [1644] = 1644,
  [1645] = 1324,
  [1646] = 155,
  [1647] = 1315,
  [1648] = 1296,
  [1649] = 1376,
  [1650] = 1367,
  [1651] = 810,
  [1652] = 1652,
  [1653] = 1255,
  [1654] = 1314,
  [1655] = 1406,
  [1656] = 1258,
  [1657] = 1410,
  [1658] = 1623,
  [1659] = 1263,
  [1660] = 1266,
  [1661] = 1352,
  [1662] = 1252,
  [1663] = 1663,
  [1664] = 1338,
  [1665] = 1339,
  [1666] = 1270,
  [1667] = 1343,
  [1668] = 1272,
  [1669] = 1274,
  [1670] = 1344,
  [1671] = 1347,
  [1672] = 1319,
  [1673] = 1350,
  [1674] = 1321,
  [1675] = 1351,
  [1676] = 1354,
  [1677] = 1355,
  [1678] = 1356,
  [1679] = 1361,
  [1680] = 1364,
  [1681] = 560,
  [1682] = 1682,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1257,
  [1688] = 1663,
  [1689] = 1689,
  [1690] = 1340,
  [1691] = 1691,
  [1692] = 1348,
  [1693] = 1693,
  [1694] = 1257,
  [1695] = 1255,
  [1696] = 1379,
  [1697] = 1362,
  [1698] = 1275,
  [1699] = 1359,
  [1700] = 1349,
  [1701] = 1410,
  [1702] = 1346,
  [1703] = 1353,
  [1704] = 1277,
  [1705] = 1345,
  [1706] = 1278,
  [1707] = 1342,
  [1708] = 1280,
  [1709] = 1284,
  [1710] = 1357,
  [1711] = 1282,
  [1712] = 1283,
  [1713] = 1328,
  [1714] = 557,
  [1715] = 1358,
  [1716] = 1281,
  [1717] = 1360,
  [1718] = 1267,
  [1719] = 1312,
  [1720] = 1720,
  [1721] = 1301,
  [1722] = 1559,
  [1723] = 1723,
  [1724] = 1273,
  [1725] = 558,
  [1726] = 1269,
  [1727] = 1727,
  [1728] = 561,
  [1729] = 1290,
  [1730] = 1336,
  [1731] = 1335,
  [1732] = 1291,
  [1733] = 1292,
  [1734] = 1293,
  [1735] = 1294,
  [1736] = 1295,
  [1737] = 1297,
  [1738] = 1298,
  [1739] = 1299,
  [1740] = 1300,
  [1741] = 1302,
  [1742] = 1303,
  [1743] = 1304,
  [1744] = 1257,
  [1745] = 1334,
  [1746] = 559,
  [1747] = 1332,
  [1748] = 1330,
  [1749] = 1329,
  [1750] = 1327,
  [1751] = 1723,
  [1752] = 1559,
  [1753] = 1693,
  [1754] = 1268,
  [1755] = 1693,
  [1756] = 808,
  [1757] = 1693,
  [1758] = 1306,
  [1759] = 1378,
  [1760] = 1489,
  [1761] = 1256,
  [1762] = 1254,
  [1763] = 1489,
  [1764] = 1255,
  [1765] = 1406,
  [1766] = 1254,
  [1767] = 1644,
  [1768] = 1683,
  [1769] = 1769,
  [1770] = 1693,
  [1771] = 1326,
  [1772] = 1489,
  [1773] = 1727,
  [1774] = 1774,
  [1775] = 1377,
  [1776] = 1776,
  [1777] = 1289,
  [1778] = 1778,
  [1779] = 1341,
  [1780] = 1780,
  [1781] = 1363,
  [1782] = 1288,
  [1783] = 1286,
  [1784] = 1259,
  [1785] = 1366,
  [1786] = 1368,
  [1787] = 1370,
  [1788] = 1371,
  [1789] = 1260,
  [1790] = 1261,
  [1791] = 1720,
  [1792] = 1410,
  [1793] = 1262,
  [1794] = 1623,
  [1795] = 1264,
  [1796] = 1265,
  [1797] = 1271,
  [1798] = 1798,
  [1799] = 1325,
  [1800] = 1800,
  [1801] = 1521,
  [1802] = 1502,
  [1803] = 1486,
  [1804] = 1623,
  [1805] = 1323,
  [1806] = 1806,
  [1807] = 1320,
  [1808] = 1310,
  [1809] = 1318,
  [1810] = 1317,
  [1811] = 1313,
  [1812] = 1311,
  [1813] = 1319,
  [1814] = 1322,
  [1815] = 1308,
  [1816] = 1369,
  [1817] = 1406,
  [1818] = 1251,
  [1819] = 1309,
  [1820] = 1307,
  [1821] = 1821,
  [1822] = 1720,
  [1823] = 1373,
  [1824] = 1652,
  [1825] = 809,
  [1826] = 155,
  [1827] = 1452,
  [1828] = 1406,
  [1829] = 1829,
  [1830] = 1314,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1486,
  [1834] = 1829,
  [1835] = 1489,
  [1836] = 186,
  [1837] = 1371,
  [1838] = 1384,
  [1839] = 1839,
  [1840] = 1286,
  [1841] = 163,
  [1842] = 1390,
  [1843] = 169,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1829,
  [1847] = 1847,
  [1848] = 174,
  [1849] = 176,
  [1850] = 1798,
  [1851] = 1494,
  [1852] = 182,
  [1853] = 1853,
  [1854] = 168,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1388,
  [1858] = 163,
  [1859] = 1859,
  [1860] = 1373,
  [1861] = 1288,
  [1862] = 177,
  [1863] = 1863,
  [1864] = 1457,
  [1865] = 1289,
  [1866] = 1315,
  [1867] = 1252,
  [1868] = 1623,
  [1869] = 1510,
  [1870] = 1353,
  [1871] = 1497,
  [1872] = 1322,
  [1873] = 1378,
  [1874] = 1446,
  [1875] = 169,
  [1876] = 1306,
  [1877] = 1296,
  [1878] = 1878,
  [1879] = 1417,
  [1880] = 1357,
  [1881] = 156,
  [1882] = 1829,
  [1883] = 1455,
  [1884] = 1456,
  [1885] = 1798,
  [1886] = 165,
  [1887] = 1559,
  [1888] = 1853,
  [1889] = 1418,
  [1890] = 1436,
  [1891] = 1360,
  [1892] = 1377,
  [1893] = 1463,
  [1894] = 1464,
  [1895] = 1363,
  [1896] = 1515,
  [1897] = 178,
  [1898] = 186,
  [1899] = 1366,
  [1900] = 1536,
  [1901] = 1425,
  [1902] = 1428,
  [1903] = 1431,
  [1904] = 1467,
  [1905] = 1465,
  [1906] = 1255,
  [1907] = 1432,
  [1908] = 1829,
  [1909] = 1433,
  [1910] = 1368,
  [1911] = 1424,
  [1912] = 1502,
  [1913] = 1449,
  [1914] = 1470,
  [1915] = 1321,
  [1916] = 1468,
  [1917] = 1469,
  [1918] = 1623,
  [1919] = 165,
  [1920] = 1482,
  [1921] = 1257,
  [1922] = 156,
  [1923] = 1447,
  [1924] = 1448,
  [1925] = 1453,
  [1926] = 1521,
  [1927] = 1927,
  [1928] = 1381,
  [1929] = 1462,
  [1930] = 1319,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1442,
  [1934] = 1511,
  [1935] = 1471,
  [1936] = 1829,
  [1937] = 180,
  [1938] = 1473,
  [1939] = 1268,
  [1940] = 1520,
  [1941] = 1517,
  [1942] = 168,
  [1943] = 180,
  [1944] = 1477,
  [1945] = 1319,
  [1946] = 1946,
  [1947] = 176,
  [1948] = 182,
  [1949] = 178,
  [1950] = 1370,
  [1951] = 1478,
  [1952] = 1404,
  [1953] = 174,
  [1954] = 1829,
  [1955] = 1414,
  [1956] = 1839,
  [1957] = 1459,
  [1958] = 1451,
  [1959] = 177,
  [1960] = 1358,
  [1961] = 1961,
  [1962] = 171,
  [1963] = 1499,
  [1964] = 1489,
  [1965] = 1518,
  [1966] = 1269,
  [1967] = 171,
  [1968] = 1845,
  [1969] = 1254,
  [1970] = 1484,
  [1971] = 1255,
  [1972] = 1385,
  [1973] = 1832,
  [1974] = 1257,
  [1975] = 1487,
  [1976] = 1516,
  [1977] = 1832,
  [1978] = 1829,
  [1979] = 1396,
  [1980] = 1284,
  [1981] = 1262,
  [1982] = 1982,
  [1983] = 1845,
  [1984] = 1398,
  [1985] = 1281,
  [1986] = 1498,
  [1987] = 1406,
  [1988] = 1845,
  [1989] = 1439,
  [1990] = 1832,
  [1991] = 1490,
  [1992] = 1832,
  [1993] = 1513,
  [1994] = 1878,
  [1995] = 1380,
  [1996] = 1532,
  [1997] = 1531,
  [1998] = 1529,
  [1999] = 1527,
  [2000] = 2000,
  [2001] = 1460,
  [2002] = 1845,
  [2003] = 2003,
  [2004] = 1252,
  [2005] = 2005,
  [2006] = 2006,
  [2007] = 2006,
  [2008] = 1296,
  [2009] = 1306,
  [2010] = 2006,
  [2011] = 1410,
  [2012] = 1286,
  [2013] = 1378,
  [2014] = 1288,
  [2015] = 1322,
  [2016] = 1289,
  [2017] = 1406,
  [2018] = 1373,
  [2019] = 1489,
  [2020] = 1315,
  [2021] = 1254,
  [2022] = 1353,
  [2023] = 1357,
  [2024] = 1358,
  [2025] = 1360,
  [2026] = 1377,
  [2027] = 2027,
  [2028] = 1262,
  [2029] = 1319,
  [2030] = 1319,
  [2031] = 1268,
  [2032] = 1410,
  [2033] = 2005,
  [2034] = 1502,
  [2035] = 1363,
  [2036] = 1623,
  [2037] = 1366,
  [2038] = 1368,
  [2039] = 1370,
  [2040] = 1321,
  [2041] = 1371,
  [2042] = 1284,
  [2043] = 1544,
  [2044] = 1281,
  [2045] = 1269,
  [2046] = 1623,
  [2047] = 2006,
  [2048] = 2048,
  [2049] = 1255,
  [2050] = 1257,
  [2051] = 1314,
  [2052] = 2006,
  [2053] = 1798,
  [2054] = 2054,
  [2055] = 1521,
  [2056] = 1489,
  [2057] = 2057,
  [2058] = 2058,
  [2059] = 2059,
  [2060] = 1410,
  [2061] = 2061,
  [2062] = 1256,
  [2063] = 2063,
  [2064] = 2064,
  [2065] = 2065,
  [2066] = 1623,
  [2067] = 2061,
  [2068] = 2068,
  [2069] = 2069,
  [2070] = 2054,
  [2071] = 1319,
  [2072] = 2072,
  [2073] = 2073,
  [2074] = 1406,
  [2075] = 1556,
  [2076] = 2076,
  [2077] = 2061,
  [2078] = 2061,
  [2079] = 2061,
  [2080] = 2059,
  [2081] = 1502,
  [2082] = 2082,
  [2083] = 2061,
  [2084] = 2084,
  [2085] = 1410,
  [2086] = 2086,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 1486,
  [2090] = 2061,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 2093,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 2098,
  [2099] = 2099,
  [2100] = 2095,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 1486,
  [2105] = 1502,
  [2106] = 2106,
  [2107] = 2106,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 2097,
  [2111] = 2109,
  [2112] = 2108,
  [2113] = 2106,
  [2114] = 2114,
  [2115] = 2106,
  [2116] = 2109,
  [2117] = 2117,
  [2118] = 2097,
  [2119] = 2119,
  [2120] = 1798,
  [2121] = 2106,
  [2122] = 2122,
  [2123] = 1319,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2109,
  [2127] = 2093,
  [2128] = 1521,
  [2129] = 2129,
  [2130] = 2095,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2133,
  [2134] = 2095,
  [2135] = 2135,
  [2136] = 2109,
  [2137] = 1982,
  [2138] = 2106,
  [2139] = 2109,
  [2140] = 2106,
  [2141] = 2133,
  [2142] = 2119,
  [2143] = 2109,
  [2144] = 2144,
  [2145] = 2097,
  [2146] = 2095,
  [2147] = 2147,
  [2148] = 2097,
  [2149] = 2149,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2152,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2154,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 2161,
  [2162] = 2152,
  [2163] = 2163,
  [2164] = 2155,
  [2165] = 2165,
  [2166] = 2152,
  [2167] = 2157,
  [2168] = 2152,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 2169,
  [2172] = 2172,
  [2173] = 2173,
  [2174] = 2152,
  [2175] = 2152,
  [2176] = 2152,
  [2177] = 2177,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2095,
  [2188] = 2095,
  [2189] = 2095,
  [2190] = 2097,
  [2191] = 2097,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2095,
  [2195] = 2095,
  [2196] = 2097,
  [2197] = 2097,
  [2198] = 2097,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2097,
  [2202] = 2095,
  [2203] = 2097,
  [2204] = 2095,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2206,
  [2208] = 2206,
  [2209] = 1143,
  [2210] = 2210,
  [2211] = 2210,
  [2212] = 2184,
  [2213] = 2185,
  [2214] = 2206,
  [2215] = 2215,
  [2216] = 2210,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 1168,
  [2230] = 158,
  [2231] = 167,
  [2232] = 183,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 160,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2155,
  [2256] = 158,
  [2257] = 2257,
  [2258] = 2157,
  [2259] = 2149,
  [2260] = 2161,
  [2261] = 2157,
  [2262] = 183,
  [2263] = 2155,
  [2264] = 2264,
  [2265] = 2154,
  [2266] = 2266,
  [2267] = 2173,
  [2268] = 2169,
  [2269] = 2269,
  [2270] = 2169,
  [2271] = 2271,
  [2272] = 2153,
  [2273] = 2273,
  [2274] = 2271,
  [2275] = 2275,
  [2276] = 2154,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 160,
  [2280] = 2280,
  [2281] = 1179,
  [2282] = 1182,
  [2283] = 2280,
  [2284] = 2284,
  [2285] = 809,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 808,
  [2290] = 2290,
  [2291] = 2286,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2287,
  [2296] = 2296,
  [2297] = 2292,
  [2298] = 167,
  [2299] = 810,
  [2300] = 2284,
  [2301] = 2301,
  [2302] = 2158,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2317,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2327,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2326,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2336,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2320,
  [2347] = 2347,
  [2348] = 2328,
  [2349] = 2349,
  [2350] = 1232,
  [2351] = 1280,
  [2352] = 1230,
  [2353] = 1283,
  [2354] = 2354,
  [2355] = 1282,
  [2356] = 1336,
  [2357] = 1298,
  [2358] = 1335,
  [2359] = 1299,
  [2360] = 1334,
  [2361] = 1300,
  [2362] = 1302,
  [2363] = 1332,
  [2364] = 1303,
  [2365] = 1278,
  [2366] = 1304,
  [2367] = 1330,
  [2368] = 1341,
  [2369] = 1277,
  [2370] = 1367,
  [2371] = 1293,
  [2372] = 1329,
  [2373] = 1348,
  [2374] = 1249,
  [2375] = 1294,
  [2376] = 1247,
  [2377] = 1275,
  [2378] = 1266,
  [2379] = 1250,
  [2380] = 1295,
  [2381] = 1274,
  [2382] = 1272,
  [2383] = 1270,
  [2384] = 1317,
  [2385] = 1318,
  [2386] = 2354,
  [2387] = 1320,
  [2388] = 1323,
  [2389] = 1327,
  [2390] = 1324,
  [2391] = 1326,
  [2392] = 1325,
  [2393] = 1297,
  [2394] = 1356,
  [2395] = 1361,
  [2396] = 1364,
  [2397] = 1273,
  [2398] = 1350,
  [2399] = 1239,
  [2400] = 175,
  [2401] = 185,
  [2402] = 1248,
  [2403] = 2403,
  [2404] = 2403,
  [2405] = 1249,
  [2406] = 1354,
  [2407] = 1292,
  [2408] = 1313,
  [2409] = 1311,
  [2410] = 1309,
  [2411] = 1251,
  [2412] = 1263,
  [2413] = 1271,
  [2414] = 1351,
  [2415] = 1301,
  [2416] = 1312,
  [2417] = 2403,
  [2418] = 1235,
  [2419] = 2403,
  [2420] = 1230,
  [2421] = 1259,
  [2422] = 2403,
  [2423] = 1343,
  [2424] = 1247,
  [2425] = 1328,
  [2426] = 1342,
  [2427] = 1344,
  [2428] = 1338,
  [2429] = 1345,
  [2430] = 1355,
  [2431] = 1349,
  [2432] = 1359,
  [2433] = 1362,
  [2434] = 1236,
  [2435] = 2403,
  [2436] = 1265,
  [2437] = 1379,
  [2438] = 1264,
  [2439] = 2403,
  [2440] = 1291,
  [2441] = 1290,
  [2442] = 1250,
  [2443] = 1261,
  [2444] = 2403,
  [2445] = 1260,
  [2446] = 2446,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 2447,
  [2450] = 2450,
  [2451] = 2447,
  [2452] = 2446,
  [2453] = 2453,
  [2454] = 2448,
  [2455] = 2455,
  [2456] = 2446,
  [2457] = 2457,
  [2458] = 1339,
  [2459] = 2459,
  [2460] = 1347,
  [2461] = 1232,
  [2462] = 2462,
  [2463] = 2463,
  [2464] = 1346,
  [2465] = 1258,
  [2466] = 2466,
  [2467] = 2467,
  [2468] = 2450,
  [2469] = 2446,
  [2470] = 1307,
  [2471] = 2448,
  [2472] = 1336,
  [2473] = 1335,
  [2474] = 1334,
  [2475] = 1332,
  [2476] = 1330,
  [2477] = 1329,
  [2478] = 1327,
  [2479] = 1326,
  [2480] = 1325,
  [2481] = 1324,
  [2482] = 1323,
  [2483] = 1320,
  [2484] = 1318,
  [2485] = 1317,
  [2486] = 2450,
  [2487] = 1267,
  [2488] = 2446,
  [2489] = 2448,
  [2490] = 2447,
  [2491] = 1266,
  [2492] = 1270,
  [2493] = 1272,
  [2494] = 1274,
  [2495] = 1308,
  [2496] = 1275,
  [2497] = 1304,
  [2498] = 1303,
  [2499] = 1302,
  [2500] = 1300,
  [2501] = 1299,
  [2502] = 1298,
  [2503] = 1297,
  [2504] = 1295,
  [2505] = 1294,
  [2506] = 1293,
  [2507] = 2448,
  [2508] = 2447,
  [2509] = 2450,
  [2510] = 1310,
  [2511] = 2450,
  [2512] = 1283,
  [2513] = 1282,
  [2514] = 1280,
  [2515] = 1278,
  [2516] = 1277,
  [2517] = 2517,
  [2518] = 2518,
  [2519] = 1273,
  [2520] = 1250,
  [2521] = 1247,
  [2522] = 2522,
  [2523] = 809,
  [2524] = 2524,
  [2525] = 2525,
  [2526] = 810,
  [2527] = 2522,
  [2528] = 2528,
  [2529] = 1350,
  [2530] = 1361,
  [2531] = 2531,
  [2532] = 2522,
  [2533] = 2533,
  [2534] = 2534,
  [2535] = 1230,
  [2536] = 1239,
  [2537] = 2537,
  [2538] = 2524,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 808,
  [2542] = 1249,
  [2543] = 1364,
  [2544] = 1356,
  [2545] = 2545,
  [2546] = 1278,
  [2547] = 1232,
  [2548] = 2548,
  [2549] = 2549,
  [2550] = 2550,
  [2551] = 2551,
  [2552] = 2552,
  [2553] = 1336,
  [2554] = 1335,
  [2555] = 1334,
  [2556] = 1332,
  [2557] = 1330,
  [2558] = 1329,
  [2559] = 1327,
  [2560] = 1326,
  [2561] = 1325,
  [2562] = 2562,
  [2563] = 1324,
  [2564] = 2564,
  [2565] = 1323,
  [2566] = 1320,
  [2567] = 1318,
  [2568] = 1317,
  [2569] = 1304,
  [2570] = 2570,
  [2571] = 1248,
  [2572] = 1236,
  [2573] = 1235,
  [2574] = 1303,
  [2575] = 2575,
  [2576] = 2562,
  [2577] = 1302,
  [2578] = 2578,
  [2579] = 1300,
  [2580] = 1299,
  [2581] = 2581,
  [2582] = 1298,
  [2583] = 2583,
  [2584] = 2583,
  [2585] = 1297,
  [2586] = 1295,
  [2587] = 2587,
  [2588] = 1294,
  [2589] = 1293,
  [2590] = 2583,
  [2591] = 2562,
  [2592] = 1283,
  [2593] = 2593,
  [2594] = 1282,
  [2595] = 1280,
  [2596] = 2583,
  [2597] = 2597,
  [2598] = 175,
  [2599] = 2599,
  [2600] = 2600,
  [2601] = 1277,
  [2602] = 2583,
  [2603] = 185,
  [2604] = 2562,
  [2605] = 1266,
  [2606] = 1270,
  [2607] = 1272,
  [2608] = 1274,
  [2609] = 1275,
  [2610] = 2610,
  [2611] = 2611,
  [2612] = 1343,
  [2613] = 1260,
  [2614] = 2614,
  [2615] = 1239,
  [2616] = 560,
  [2617] = 1309,
  [2618] = 810,
  [2619] = 1307,
  [2620] = 1313,
  [2621] = 1348,
  [2622] = 1273,
  [2623] = 808,
  [2624] = 1350,
  [2625] = 1251,
  [2626] = 1364,
  [2627] = 1361,
  [2628] = 1311,
  [2629] = 1356,
  [2630] = 1367,
  [2631] = 1379,
  [2632] = 1310,
  [2633] = 1308,
  [2634] = 1362,
  [2635] = 1355,
  [2636] = 1354,
  [2637] = 1359,
  [2638] = 1349,
  [2639] = 1346,
  [2640] = 1345,
  [2641] = 1342,
  [2642] = 1328,
  [2643] = 1267,
  [2644] = 1312,
  [2645] = 1301,
  [2646] = 809,
  [2647] = 1351,
  [2648] = 558,
  [2649] = 559,
  [2650] = 1347,
  [2651] = 1292,
  [2652] = 1291,
  [2653] = 1344,
  [2654] = 1290,
  [2655] = 1339,
  [2656] = 557,
  [2657] = 1271,
  [2658] = 1341,
  [2659] = 1263,
  [2660] = 1259,
  [2661] = 1258,
  [2662] = 1261,
  [2663] = 1338,
  [2664] = 2664,
  [2665] = 1264,
  [2666] = 1265,
  [2667] = 561,
  [2668] = 1235,
  [2669] = 2669,
  [2670] = 2670,
  [2671] = 2671,
  [2672] = 2669,
  [2673] = 1249,
  [2674] = 2674,
  [2675] = 2675,
  [2676] = 1250,
  [2677] = 2677,
  [2678] = 2678,
  [2679] = 2679,
  [2680] = 2675,
  [2681] = 2681,
  [2682] = 2682,
  [2683] = 2681,
  [2684] = 2684,
  [2685] = 2669,
  [2686] = 2686,
  [2687] = 2687,
  [2688] = 1247,
  [2689] = 2675,
  [2690] = 2690,
  [2691] = 2691,
  [2692] = 1236,
  [2693] = 1230,
  [2694] = 2694,
  [2695] = 2686,
  [2696] = 2684,
  [2697] = 2686,
  [2698] = 2698,
  [2699] = 2698,
  [2700] = 2669,
  [2701] = 2701,
  [2702] = 2675,
  [2703] = 2703,
  [2704] = 2684,
  [2705] = 2682,
  [2706] = 2684,
  [2707] = 1248,
  [2708] = 2682,
  [2709] = 2709,
  [2710] = 2710,
  [2711] = 2711,
  [2712] = 1265,
  [2713] = 1264,
  [2714] = 2714,
  [2715] = 2715,
  [2716] = 2716,
  [2717] = 2717,
  [2718] = 1261,
  [2719] = 1260,
  [2720] = 1259,
  [2721] = 2721,
  [2722] = 2583,
  [2723] = 2717,
  [2724] = 2724,
  [2725] = 2725,
  [2726] = 2726,
  [2727] = 2721,
  [2728] = 2728,
  [2729] = 2729,
  [2730] = 2730,
  [2731] = 2583,
  [2732] = 2721,
  [2733] = 2690,
  [2734] = 558,
  [2735] = 2735,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 2738,
  [2739] = 1301,
  [2740] = 1312,
  [2741] = 1267,
  [2742] = 1328,
  [2743] = 1342,
  [2744] = 2714,
  [2745] = 1346,
  [2746] = 1349,
  [2747] = 1359,
  [2748] = 1362,
  [2749] = 2730,
  [2750] = 1310,
  [2751] = 2751,
  [2752] = 2752,
  [2753] = 2753,
  [2754] = 1271,
  [2755] = 2755,
  [2756] = 2701,
  [2757] = 2757,
  [2758] = 2758,
  [2759] = 1348,
  [2760] = 560,
  [2761] = 2583,
  [2762] = 2583,
  [2763] = 2583,
  [2764] = 1355,
  [2765] = 1354,
  [2766] = 2766,
  [2767] = 1351,
  [2768] = 2768,
  [2769] = 1347,
  [2770] = 1344,
  [2771] = 1343,
  [2772] = 1339,
  [2773] = 1338,
  [2774] = 2709,
  [2775] = 175,
  [2776] = 1367,
  [2777] = 2777,
  [2778] = 2724,
  [2779] = 561,
  [2780] = 2729,
  [2781] = 2736,
  [2782] = 2782,
  [2783] = 2687,
  [2784] = 2583,
  [2785] = 2737,
  [2786] = 2755,
  [2787] = 185,
  [2788] = 2788,
  [2789] = 2735,
  [2790] = 2790,
  [2791] = 2788,
  [2792] = 2751,
  [2793] = 2793,
  [2794] = 1313,
  [2795] = 1311,
  [2796] = 2735,
  [2797] = 2797,
  [2798] = 1309,
  [2799] = 1307,
  [2800] = 1251,
  [2801] = 1341,
  [2802] = 559,
  [2803] = 2803,
  [2804] = 2804,
  [2805] = 2729,
  [2806] = 2714,
  [2807] = 2807,
  [2808] = 2753,
  [2809] = 2717,
  [2810] = 2717,
  [2811] = 2788,
  [2812] = 2583,
  [2813] = 1292,
  [2814] = 1291,
  [2815] = 1290,
  [2816] = 2753,
  [2817] = 557,
  [2818] = 2777,
  [2819] = 2735,
  [2820] = 2729,
  [2821] = 2737,
  [2822] = 2788,
  [2823] = 2736,
  [2824] = 2730,
  [2825] = 1379,
  [2826] = 2826,
  [2827] = 2736,
  [2828] = 1263,
  [2829] = 1345,
  [2830] = 1258,
  [2831] = 2726,
  [2832] = 2737,
  [2833] = 2721,
  [2834] = 2755,
  [2835] = 2755,
  [2836] = 2753,
  [2837] = 2757,
  [2838] = 1308,
  [2839] = 810,
  [2840] = 2840,
  [2841] = 2841,
  [2842] = 2841,
  [2843] = 2843,
  [2844] = 2844,
  [2845] = 2841,
  [2846] = 2846,
  [2847] = 2847,
  [2848] = 157,
  [2849] = 2841,
  [2850] = 2850,
  [2851] = 2690,
  [2852] = 2841,
  [2853] = 2841,
  [2854] = 809,
  [2855] = 2841,
  [2856] = 808,
  [2857] = 152,
  [2858] = 2858,
  [2859] = 2840,
  [2860] = 2841,
  [2861] = 2861,
  [2862] = 2694,
  [2863] = 2863,
  [2864] = 2864,
  [2865] = 2865,
  [2866] = 2866,
  [2867] = 2867,
  [2868] = 2868,
  [2869] = 2869,
  [2870] = 2870,
  [2871] = 2871,
  [2872] = 2872,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 2875,
  [2876] = 2876,
  [2877] = 2877,
  [2878] = 2878,
  [2879] = 2879,
  [2880] = 2880,
  [2881] = 2881,
  [2882] = 2882,
  [2883] = 2883,
  [2884] = 1348,
  [2885] = 1341,
  [2886] = 2886,
  [2887] = 2887,
  [2888] = 2888,
  [2889] = 2865,
  [2890] = 2890,
  [2891] = 2891,
  [2892] = 2892,
  [2893] = 2893,
  [2894] = 2894,
  [2895] = 2895,
  [2896] = 2872,
  [2897] = 153,
  [2898] = 2898,
  [2899] = 2899,
  [2900] = 2900,
  [2901] = 2901,
  [2902] = 2758,
  [2903] = 2903,
  [2904] = 2904,
  [2905] = 2905,
  [2906] = 2664,
  [2907] = 2907,
  [2908] = 2908,
  [2909] = 2909,
  [2910] = 2910,
  [2911] = 2725,
  [2912] = 2715,
  [2913] = 2913,
  [2914] = 2803,
  [2915] = 2915,
  [2916] = 157,
  [2917] = 2797,
  [2918] = 2918,
  [2919] = 2919,
  [2920] = 2920,
  [2921] = 2921,
  [2922] = 2922,
  [2923] = 2923,
  [2924] = 2924,
  [2925] = 2925,
  [2926] = 2926,
  [2927] = 2870,
  [2928] = 2910,
  [2929] = 2929,
  [2930] = 2930,
  [2931] = 2878,
  [2932] = 2905,
  [2933] = 2933,
  [2934] = 2934,
  [2935] = 2935,
  [2936] = 2894,
  [2937] = 2937,
  [2938] = 2938,
  [2939] = 2939,
  [2940] = 2940,
  [2941] = 2883,
  [2942] = 2942,
  [2943] = 2943,
  [2944] = 2907,
  [2945] = 2945,
  [2946] = 2900,
  [2947] = 2898,
  [2948] = 2948,
  [2949] = 2949,
  [2950] = 2950,
  [2951] = 2882,
  [2952] = 2919,
  [2953] = 2877,
  [2954] = 2954,
  [2955] = 2865,
  [2956] = 2956,
  [2957] = 2910,
  [2958] = 1235,
  [2959] = 2959,
  [2960] = 2960,
  [2961] = 2904,
  [2962] = 1367,
  [2963] = 2963,
  [2964] = 2964,
  [2965] = 2908,
  [2966] = 1236,
  [2967] = 2898,
  [2968] = 2954,
  [2969] = 2878,
  [2970] = 2970,
  [2971] = 2930,
  [2972] = 2899,
  [2973] = 2870,
  [2974] = 2926,
  [2975] = 2975,
  [2976] = 2976,
  [2977] = 2977,
  [2978] = 2978,
  [2979] = 2979,
  [2980] = 2980,
  [2981] = 2981,
  [2982] = 2982,
  [2983] = 2983,
  [2984] = 2984,
  [2985] = 2982,
  [2986] = 2986,
  [2987] = 2987,
  [2988] = 2988,
  [2989] = 2982,
  [2990] = 2990,
  [2991] = 2977,
  [2992] = 2992,
  [2993] = 2915,
  [2994] = 2994,
  [2995] = 2995,
  [2996] = 2996,
  [2997] = 2997,
  [2998] = 2998,
  [2999] = 2938,
  [3000] = 3000,
  [3001] = 2976,
  [3002] = 2940,
  [3003] = 558,
  [3004] = 3004,
  [3005] = 2950,
  [3006] = 3006,
  [3007] = 3007,
  [3008] = 3008,
  [3009] = 3009,
  [3010] = 3010,
  [3011] = 3011,
  [3012] = 1346,
  [3013] = 1267,
  [3014] = 2982,
  [3015] = 2990,
  [3016] = 3016,
  [3017] = 3017,
  [3018] = 2975,
  [3019] = 2929,
  [3020] = 2923,
  [3021] = 3021,
  [3022] = 3022,
  [3023] = 2920,
  [3024] = 2977,
  [3025] = 3025,
  [3026] = 3026,
  [3027] = 3027,
  [3028] = 3028,
  [3029] = 3029,
  [3030] = 3030,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 557,
  [3034] = 559,
  [3035] = 3035,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 561,
  [3039] = 2922,
  [3040] = 560,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3009,
  [3044] = 3044,
  [3045] = 3037,
  [3046] = 2868,
  [3047] = 3047,
  [3048] = 2867,
  [3049] = 3049,
  [3050] = 2866,
  [3051] = 3021,
  [3052] = 2975,
  [3053] = 2939,
  [3054] = 3028,
  [3055] = 3010,
  [3056] = 3008,
  [3057] = 3006,
  [3058] = 2987,
  [3059] = 3021,
  [3060] = 3060,
  [3061] = 3061,
  [3062] = 3016,
  [3063] = 3063,
  [3064] = 3064,
  [3065] = 2977,
  [3066] = 2975,
  [3067] = 3036,
  [3068] = 3028,
  [3069] = 3010,
  [3070] = 3008,
  [3071] = 2987,
  [3072] = 3021,
  [3073] = 3073,
  [3074] = 2975,
  [3075] = 3075,
  [3076] = 2935,
  [3077] = 2925,
  [3078] = 3078,
  [3079] = 3079,
  [3080] = 3080,
  [3081] = 3028,
  [3082] = 2863,
  [3083] = 3010,
  [3084] = 3008,
  [3085] = 3025,
  [3086] = 3086,
  [3087] = 3021,
  [3088] = 2987,
  [3089] = 3021,
  [3090] = 3090,
  [3091] = 2886,
  [3092] = 3092,
  [3093] = 2975,
  [3094] = 3094,
  [3095] = 2614,
  [3096] = 3096,
  [3097] = 3097,
  [3098] = 3098,
  [3099] = 3099,
  [3100] = 3100,
  [3101] = 3101,
  [3102] = 2861,
  [3103] = 2909,
  [3104] = 2687,
  [3105] = 3063,
  [3106] = 3028,
  [3107] = 2997,
  [3108] = 3010,
  [3109] = 3109,
  [3110] = 3008,
  [3111] = 2924,
  [3112] = 3061,
  [3113] = 2987,
  [3114] = 3114,
  [3115] = 3021,
  [3116] = 2933,
  [3117] = 2934,
  [3118] = 3035,
  [3119] = 3119,
  [3120] = 2970,
  [3121] = 2959,
  [3122] = 2903,
  [3123] = 2701,
  [3124] = 2876,
  [3125] = 3035,
  [3126] = 2869,
  [3127] = 1258,
  [3128] = 3109,
  [3129] = 2986,
  [3130] = 3080,
  [3131] = 2987,
  [3132] = 3049,
  [3133] = 1307,
  [3134] = 3063,
  [3135] = 2864,
  [3136] = 3061,
  [3137] = 3063,
  [3138] = 3009,
  [3139] = 3008,
  [3140] = 3028,
  [3141] = 3006,
  [3142] = 3010,
  [3143] = 1310,
  [3144] = 3036,
  [3145] = 1347,
  [3146] = 1339,
  [3147] = 1308,
  [3148] = 3022,
  [3149] = 3149,
  [3150] = 701,
  [3151] = 691,
  [3152] = 3152,
  [3153] = 3153,
  [3154] = 619,
  [3155] = 3155,
  [3156] = 758,
  [3157] = 3157,
  [3158] = 3158,
  [3159] = 757,
  [3160] = 679,
  [3161] = 3161,
  [3162] = 3162,
  [3163] = 670,
  [3164] = 3164,
  [3165] = 3165,
  [3166] = 3166,
  [3167] = 3167,
  [3168] = 667,
  [3169] = 3169,
  [3170] = 662,
  [3171] = 1424,
  [3172] = 3172,
  [3173] = 639,
  [3174] = 3174,
  [3175] = 1447,
  [3176] = 3176,
  [3177] = 1468,
  [3178] = 638,
  [3179] = 3179,
  [3180] = 635,
  [3181] = 3181,
  [3182] = 3182,
  [3183] = 683,
  [3184] = 3184,
  [3185] = 628,
  [3186] = 1433,
  [3187] = 3187,
  [3188] = 623,
  [3189] = 3189,
  [3190] = 625,
  [3191] = 3191,
  [3192] = 3192,
  [3193] = 3193,
  [3194] = 3192,
  [3195] = 3195,
  [3196] = 613,
  [3197] = 675,
  [3198] = 3198,
  [3199] = 1432,
  [3200] = 3200,
  [3201] = 655,
  [3202] = 3202,
  [3203] = 3203,
  [3204] = 3204,
  [3205] = 3205,
  [3206] = 671,
  [3207] = 3207,
  [3208] = 657,
  [3209] = 3189,
  [3210] = 3210,
  [3211] = 753,
  [3212] = 3158,
  [3213] = 3213,
  [3214] = 654,
  [3215] = 3215,
  [3216] = 652,
  [3217] = 1516,
  [3218] = 651,
  [3219] = 3219,
  [3220] = 647,
  [3221] = 3165,
  [3222] = 3169,
  [3223] = 646,
  [3224] = 622,
  [3225] = 624,
  [3226] = 3226,
  [3227] = 3172,
  [3228] = 3228,
  [3229] = 643,
  [3230] = 3230,
  [3231] = 642,
  [3232] = 3232,
  [3233] = 3233,
  [3234] = 3207,
  [3235] = 3192,
  [3236] = 3187,
  [3237] = 3191,
  [3238] = 3238,
  [3239] = 1431,
  [3240] = 3240,
  [3241] = 1428,
  [3242] = 3242,
  [3243] = 3243,
  [3244] = 661,
  [3245] = 3245,
  [3246] = 3246,
  [3247] = 3247,
  [3248] = 680,
  [3249] = 612,
  [3250] = 3250,
  [3251] = 618,
  [3252] = 3252,
  [3253] = 3253,
  [3254] = 630,
  [3255] = 3210,
  [3256] = 3256,
  [3257] = 3257,
  [3258] = 3258,
  [3259] = 3259,
  [3260] = 3157,
  [3261] = 3261,
  [3262] = 3262,
  [3263] = 3263,
  [3264] = 3264,
  [3265] = 632,
  [3266] = 3266,
  [3267] = 3166,
  [3268] = 3268,
  [3269] = 692,
  [3270] = 3270,
  [3271] = 3271,
  [3272] = 3272,
  [3273] = 3273,
  [3274] = 694,
  [3275] = 695,
  [3276] = 704,
  [3277] = 3094,
  [3278] = 3278,
  [3279] = 3279,
  [3280] = 735,
  [3281] = 736,
  [3282] = 738,
  [3283] = 741,
  [3284] = 748,
  [3285] = 660,
  [3286] = 3200,
  [3287] = 3287,
  [3288] = 3288,
  [3289] = 762,
  [3290] = 763,
  [3291] = 767,
  [3292] = 2895,
  [3293] = 718,
  [3294] = 717,
  [3295] = 716,
  [3296] = 715,
  [3297] = 629,
  [3298] = 3298,
  [3299] = 700,
  [3300] = 699,
  [3301] = 698,
  [3302] = 690,
  [3303] = 3096,
  [3304] = 3097,
  [3305] = 3305,
  [3306] = 3306,
  [3307] = 637,
  [3308] = 744,
  [3309] = 760,
  [3310] = 3310,
  [3311] = 3311,
  [3312] = 3312,
  [3313] = 714,
  [3314] = 705,
  [3315] = 2892,
  [3316] = 2893,
  [3317] = 706,
  [3318] = 773,
  [3319] = 3101,
  [3320] = 3320,
  [3321] = 3192,
  [3322] = 3198,
  [3323] = 3323,
  [3324] = 653,
  [3325] = 650,
  [3326] = 1425,
  [3327] = 636,
  [3328] = 665,
  [3329] = 649,
  [3330] = 3330,
  [3331] = 3331,
  [3332] = 3332,
  [3333] = 3333,
  [3334] = 693,
  [3335] = 3270,
  [3336] = 3336,
  [3337] = 3337,
  [3338] = 3338,
  [3339] = 702,
  [3340] = 3340,
  [3341] = 3341,
  [3342] = 3342,
  [3343] = 3343,
  [3344] = 3344,
  [3345] = 3345,
  [3346] = 703,
  [3347] = 3347,
  [3348] = 2881,
  [3349] = 3273,
  [3350] = 1384,
  [3351] = 3351,
  [3352] = 3352,
  [3353] = 3353,
  [3354] = 1471,
  [3355] = 3355,
  [3356] = 3356,
  [3357] = 3157,
  [3358] = 3358,
  [3359] = 3240,
  [3360] = 3360,
  [3361] = 3361,
  [3362] = 3232,
  [3363] = 3363,
  [3364] = 3364,
  [3365] = 3157,
  [3366] = 3189,
  [3367] = 1473,
  [3368] = 3243,
  [3369] = 3369,
  [3370] = 3157,
  [3371] = 3371,
  [3372] = 3372,
  [3373] = 3373,
  [3374] = 3374,
  [3375] = 3375,
  [3376] = 710,
  [3377] = 3377,
  [3378] = 3378,
  [3379] = 3379,
  [3380] = 3380,
  [3381] = 184,
  [3382] = 3382,
  [3383] = 3383,
  [3384] = 3384,
  [3385] = 3195,
  [3386] = 3205,
  [3387] = 162,
  [3388] = 3219,
  [3389] = 3389,
  [3390] = 3258,
  [3391] = 3391,
  [3392] = 3392,
  [3393] = 3192,
  [3394] = 3394,
  [3395] = 3395,
  [3396] = 3396,
  [3397] = 3397,
  [3398] = 3158,
  [3399] = 3399,
  [3400] = 3400,
  [3401] = 3401,
  [3402] = 3402,
  [3403] = 3230,
  [3404] = 3202,
  [3405] = 3204,
  [3406] = 3246,
  [3407] = 3228,
  [3408] = 3252,
  [3409] = 1350,
  [3410] = 3410,
  [3411] = 672,
  [3412] = 3250,
  [3413] = 3413,
  [3414] = 3266,
  [3415] = 3415,
  [3416] = 3416,
  [3417] = 3312,
  [3418] = 3215,
  [3419] = 3419,
  [3420] = 3420,
  [3421] = 175,
  [3422] = 3422,
  [3423] = 3423,
  [3424] = 3424,
  [3425] = 3425,
  [3426] = 3426,
  [3427] = 3427,
  [3428] = 3428,
  [3429] = 185,
  [3430] = 3430,
  [3431] = 3431,
  [3432] = 3384,
  [3433] = 3433,
  [3434] = 3228,
  [3435] = 3203,
  [3436] = 3436,
  [3437] = 3416,
  [3438] = 3204,
  [3439] = 3439,
  [3440] = 3243,
  [3441] = 3202,
  [3442] = 3215,
  [3443] = 3443,
  [3444] = 3444,
  [3445] = 3247,
  [3446] = 3446,
  [3447] = 3447,
  [3448] = 3448,
  [3449] = 3449,
  [3450] = 3450,
  [3451] = 3451,
  [3452] = 3452,
  [3453] = 3453,
  [3454] = 3454,
  [3455] = 3455,
  [3456] = 3456,
  [3457] = 3457,
  [3458] = 3458,
  [3459] = 3459,
  [3460] = 3460,
  [3461] = 3461,
  [3462] = 3462,
  [3463] = 3463,
  [3464] = 3464,
  [3465] = 3462,
  [3466] = 3457,
  [3467] = 3463,
  [3468] = 3460,
  [3469] = 3469,
  [3470] = 3469,
  [3471] = 3460,
  [3472] = 3472,
  [3473] = 3473,
  [3474] = 3464,
  [3475] = 3469,
  [3476] = 3449,
  [3477] = 3477,
  [3478] = 3478,
  [3479] = 3463,
  [3480] = 3463,
  [3481] = 3462,
  [3482] = 3482,
  [3483] = 3483,
  [3484] = 3484,
  [3485] = 3462,
  [3486] = 3463,
  [3487] = 3487,
  [3488] = 3488,
  [3489] = 3489,
  [3490] = 3460,
  [3491] = 3469,
  [3492] = 3477,
  [3493] = 3493,
  [3494] = 3494,
  [3495] = 3448,
  [3496] = 3461,
  [3497] = 3469,
  [3498] = 3498,
  [3499] = 3463,
  [3500] = 3500,
  [3501] = 3456,
  [3502] = 3502,
  [3503] = 3503,
  [3504] = 3504,
  [3505] = 3460,
  [3506] = 3462,
  [3507] = 3463,
  [3508] = 152,
  [3509] = 3455,
  [3510] = 3478,
  [3511] = 3511,
  [3512] = 3512,
  [3513] = 3446,
  [3514] = 3514,
  [3515] = 3460,
  [3516] = 3462,
  [3517] = 3463,
  [3518] = 3469,
  [3519] = 3519,
  [3520] = 3520,
  [3521] = 3521,
  [3522] = 3460,
  [3523] = 3469,
  [3524] = 3446,
  [3525] = 3525,
  [3526] = 3514,
  [3527] = 3456,
  [3528] = 3494,
  [3529] = 3456,
  [3530] = 3464,
  [3531] = 3531,
  [3532] = 3532,
  [3533] = 3533,
  [3534] = 3520,
  [3535] = 3478,
  [3536] = 3536,
  [3537] = 3464,
  [3538] = 3462,
  [3539] = 3461,
  [3540] = 3450,
  [3541] = 3541,
  [3542] = 3542,
  [3543] = 3543,
  [3544] = 3544,
  [3545] = 3461,
  [3546] = 3448,
  [3547] = 3547,
  [3548] = 3461,
  [3549] = 3464,
  [3550] = 3448,
  [3551] = 3446,
  [3552] = 3446,
  [3553] = 3446,
  [3554] = 3447,
  [3555] = 3477,
  [3556] = 3478,
  [3557] = 3454,
  [3558] = 3448,
  [3559] = 3456,
  [3560] = 3462,
  [3561] = 3478,
  [3562] = 3562,
  [3563] = 3563,
  [3564] = 3519,
  [3565] = 3565,
  [3566] = 3456,
  [3567] = 3448,
  [3568] = 3477,
  [3569] = 3464,
  [3570] = 3570,
  [3571] = 3469,
  [3572] = 3460,
  [3573] = 3573,
  [3574] = 3574,
  [3575] = 3483,
  [3576] = 3576,
  [3577] = 3577,
  [3578] = 3578,
  [3579] = 3579,
  [3580] = 2903,
  [3581] = 3581,
  [3582] = 1384,
  [3583] = 3583,
  [3584] = 3584,
  [3585] = 3585,
  [3586] = 3586,
  [3587] = 3587,
  [3588] = 3588,
  [3589] = 3589,
  [3590] = 3590,
  [3591] = 3585,
  [3592] = 3584,
  [3593] = 2876,
  [3594] = 3594,
  [3595] = 3595,
  [3596] = 3596,
  [3597] = 1345,
  [3598] = 3598,
  [3599] = 3599,
  [3600] = 3578,
  [3601] = 3601,
  [3602] = 3602,
  [3603] = 3603,
  [3604] = 3604,
  [3605] = 3605,
  [3606] = 3606,
  [3607] = 3607,
  [3608] = 3608,
  [3609] = 3609,
  [3610] = 3610,
  [3611] = 3611,
  [3612] = 3612,
  [3613] = 3613,
  [3614] = 3614,
  [3615] = 3615,
  [3616] = 3616,
  [3617] = 3617,
  [3618] = 3608,
  [3619] = 3619,
  [3620] = 3610,
  [3621] = 3621,
  [3622] = 3622,
  [3623] = 3595,
  [3624] = 3624,
  [3625] = 3625,
  [3626] = 3626,
  [3627] = 3627,
  [3628] = 3628,
  [3629] = 3629,
  [3630] = 3630,
  [3631] = 3631,
  [3632] = 3632,
  [3633] = 3633,
  [3634] = 3634,
  [3635] = 1516,
  [3636] = 3636,
  [3637] = 3637,
  [3638] = 1473,
  [3639] = 3639,
  [3640] = 3640,
  [3641] = 3641,
  [3642] = 3642,
  [3643] = 3643,
  [3644] = 3644,
  [3645] = 3645,
  [3646] = 3601,
  [3647] = 3647,
  [3648] = 3605,
  [3649] = 3649,
  [3650] = 3595,
  [3651] = 3651,
  [3652] = 3652,
  [3653] = 1471,
  [3654] = 3654,
  [3655] = 3652,
  [3656] = 3656,
  [3657] = 3657,
  [3658] = 3634,
  [3659] = 3598,
  [3660] = 3610,
  [3661] = 3661,
  [3662] = 3608,
  [3663] = 1425,
  [3664] = 3605,
  [3665] = 3665,
  [3666] = 3666,
  [3667] = 3601,
  [3668] = 3585,
  [3669] = 3584,
  [3670] = 3599,
  [3671] = 3608,
  [3672] = 1428,
  [3673] = 3673,
  [3674] = 3674,
  [3675] = 1431,
  [3676] = 3608,
  [3677] = 3677,
  [3678] = 3610,
  [3679] = 1432,
  [3680] = 3680,
  [3681] = 3681,
  [3682] = 3682,
  [3683] = 3584,
  [3684] = 3585,
  [3685] = 3685,
  [3686] = 3686,
  [3687] = 1433,
  [3688] = 3688,
  [3689] = 3610,
  [3690] = 1447,
  [3691] = 3691,
  [3692] = 1424,
  [3693] = 3693,
  [3694] = 3279,
  [3695] = 3695,
  [3696] = 3696,
  [3697] = 3585,
  [3698] = 3584,
  [3699] = 3699,
  [3700] = 3700,
  [3701] = 3701,
  [3702] = 3702,
  [3703] = 3608,
  [3704] = 3634,
  [3705] = 3610,
  [3706] = 3706,
  [3707] = 3707,
  [3708] = 2869,
  [3709] = 3709,
  [3710] = 3710,
  [3711] = 3711,
  [3712] = 1379,
  [3713] = 3713,
  [3714] = 3714,
  [3715] = 3614,
  [3716] = 3645,
  [3717] = 3632,
  [3718] = 3651,
  [3719] = 2907,
  [3720] = 3720,
  [3721] = 3612,
  [3722] = 3606,
  [3723] = 3278,
  [3724] = 3724,
  [3725] = 3725,
  [3726] = 3644,
  [3727] = 3727,
  [3728] = 3707,
  [3729] = 3601,
  [3730] = 2959,
  [3731] = 3642,
  [3732] = 2864,
  [3733] = 626,
  [3734] = 3734,
  [3735] = 3636,
  [3736] = 3581,
  [3737] = 3737,
  [3738] = 3738,
  [3739] = 3739,
  [3740] = 3740,
  [3741] = 3741,
  [3742] = 3738,
  [3743] = 3724,
  [3744] = 3744,
  [3745] = 3745,
  [3746] = 3174,
  [3747] = 3747,
  [3748] = 3748,
  [3749] = 3749,
  [3750] = 3750,
  [3751] = 3751,
  [3752] = 3752,
  [3753] = 3753,
  [3754] = 3754,
  [3755] = 1468,
  [3756] = 3756,
  [3757] = 3757,
  [3758] = 3758,
  [3759] = 3759,
  [3760] = 3760,
  [3761] = 3761,
  [3762] = 3762,
  [3763] = 3763,
  [3764] = 3764,
  [3765] = 3763,
  [3766] = 3766,
  [3767] = 3611,
  [3768] = 3768,
  [3769] = 3642,
  [3770] = 3585,
  [3771] = 3584,
  [3772] = 3772,
  [3773] = 3773,
  [3774] = 3774,
  [3775] = 3775,
  [3776] = 3706,
  [3777] = 3777,
  [3778] = 3615,
  [3779] = 3595,
  [3780] = 3621,
  [3781] = 1348,
  [3782] = 3617,
  [3783] = 3619,
  [3784] = 3784,
  [3785] = 3785,
  [3786] = 3673,
  [3787] = 3787,
  [3788] = 3788,
  [3789] = 3617,
  [3790] = 3619,
  [3791] = 3791,
  [3792] = 3621,
  [3793] = 3793,
  [3794] = 3794,
  [3795] = 3615,
  [3796] = 3796,
  [3797] = 3674,
  [3798] = 3696,
  [3799] = 3581,
  [3800] = 626,
  [3801] = 3801,
  [3802] = 3702,
  [3803] = 3803,
  [3804] = 3595,
  [3805] = 3805,
  [3806] = 3806,
  [3807] = 3720,
  [3808] = 3808,
  [3809] = 3585,
  [3810] = 1367,
  [3811] = 3605,
  [3812] = 3584,
  [3813] = 3644,
  [3814] = 3586,
  [3815] = 3588,
  [3816] = 3601,
  [3817] = 3590,
  [3818] = 3656,
  [3819] = 3629,
  [3820] = 3657,
  [3821] = 3634,
  [3822] = 3605,
  [3823] = 3610,
  [3824] = 3710,
  [3825] = 3825,
  [3826] = 1341,
  [3827] = 3608,
  [3828] = 3257,
  [3829] = 3305,
  [3830] = 3830,
  [3831] = 3750,
  [3832] = 3605,
  [3833] = 3833,
  [3834] = 3834,
  [3835] = 3835,
  [3836] = 3836,
  [3837] = 3837,
  [3838] = 3838,
  [3839] = 3839,
  [3840] = 3840,
  [3841] = 3841,
  [3842] = 2239,
  [3843] = 3843,
  [3844] = 2241,
  [3845] = 3845,
  [3846] = 3846,
  [3847] = 3847,
  [3848] = 3848,
  [3849] = 3849,
  [3850] = 3850,
  [3851] = 3851,
  [3852] = 3852,
  [3853] = 3853,
  [3854] = 3854,
  [3855] = 3855,
  [3856] = 3856,
  [3857] = 2235,
  [3858] = 3858,
  [3859] = 3859,
  [3860] = 3860,
  [3861] = 3861,
  [3862] = 3862,
  [3863] = 3863,
  [3864] = 3864,
  [3865] = 3865,
  [3866] = 3863,
  [3867] = 3856,
  [3868] = 3868,
  [3869] = 3869,
  [3870] = 3870,
  [3871] = 3871,
  [3872] = 3872,
  [3873] = 3871,
  [3874] = 2228,
  [3875] = 3875,
  [3876] = 3097,
  [3877] = 2245,
  [3878] = 3878,
  [3879] = 3879,
  [3880] = 3880,
  [3881] = 2253,
  [3882] = 3882,
  [3883] = 3096,
  [3884] = 3884,
  [3885] = 3885,
  [3886] = 3886,
  [3887] = 2252,
  [3888] = 3888,
  [3889] = 3889,
  [3890] = 3890,
  [3891] = 3891,
  [3892] = 3892,
  [3893] = 3893,
  [3894] = 3894,
  [3895] = 3882,
  [3896] = 3896,
  [3897] = 3897,
  [3898] = 3847,
  [3899] = 3899,
  [3900] = 3900,
  [3901] = 3901,
  [3902] = 3902,
  [3903] = 3903,
  [3904] = 3882,
  [3905] = 3905,
  [3906] = 3906,
  [3907] = 3905,
  [3908] = 3906,
  [3909] = 3903,
  [3910] = 3902,
  [3911] = 3894,
  [3912] = 3912,
  [3913] = 3846,
  [3914] = 3835,
  [3915] = 3915,
  [3916] = 3916,
  [3917] = 3917,
  [3918] = 3851,
  [3919] = 3889,
  [3920] = 3920,
  [3921] = 3893,
  [3922] = 3521,
  [3923] = 3923,
  [3924] = 3924,
  [3925] = 2254,
  [3926] = 3926,
  [3927] = 2251,
  [3928] = 3101,
  [3929] = 3926,
  [3930] = 3930,
  [3931] = 3931,
  [3932] = 3932,
  [3933] = 3920,
  [3934] = 3917,
  [3935] = 3935,
  [3936] = 3924,
  [3937] = 3917,
  [3938] = 3872,
  [3939] = 3939,
  [3940] = 3940,
  [3941] = 3941,
  [3942] = 3942,
  [3943] = 3943,
  [3944] = 3944,
  [3945] = 3858,
  [3946] = 2246,
  [3947] = 3856,
  [3948] = 3948,
  [3949] = 3949,
  [3950] = 3950,
  [3951] = 3951,
  [3952] = 3952,
  [3953] = 3953,
  [3954] = 2247,
  [3955] = 3955,
  [3956] = 2218,
  [3957] = 3853,
  [3958] = 3896,
  [3959] = 3959,
  [3960] = 3920,
  [3961] = 3961,
  [3962] = 3835,
  [3963] = 3963,
  [3964] = 3964,
  [3965] = 3965,
  [3966] = 3966,
  [3967] = 3923,
  [3968] = 3878,
  [3969] = 3869,
  [3970] = 3970,
  [3971] = 3971,
  [3972] = 3972,
  [3973] = 3845,
  [3974] = 3974,
  [3975] = 3975,
  [3976] = 3976,
  [3977] = 3977,
  [3978] = 3978,
  [3979] = 3979,
  [3980] = 2237,
  [3981] = 3863,
  [3982] = 3982,
  [3983] = 2249,
  [3984] = 2217,
  [3985] = 3985,
  [3986] = 3888,
  [3987] = 3987,
  [3988] = 3886,
  [3989] = 3989,
  [3990] = 3964,
  [3991] = 3991,
  [3992] = 3992,
  [3993] = 3993,
  [3994] = 3994,
  [3995] = 3995,
  [3996] = 3996,
  [3997] = 3997,
  [3998] = 3998,
  [3999] = 3970,
  [4000] = 2243,
  [4001] = 3094,
  [4002] = 4002,
  [4003] = 2242,
  [4004] = 3860,
  [4005] = 4005,
  [4006] = 3861,
  [4007] = 3865,
  [4008] = 3859,
  [4009] = 807,
  [4010] = 2225,
  [4011] = 3837,
  [4012] = 4012,
  [4013] = 3838,
  [4014] = 3884,
  [4015] = 3879,
  [4016] = 4016,
  [4017] = 4017,
  [4018] = 3856,
  [4019] = 3850,
  [4020] = 4020,
  [4021] = 3851,
  [4022] = 3878,
  [4023] = 3859,
  [4024] = 3875,
  [4025] = 4025,
  [4026] = 3870,
  [4027] = 3861,
  [4028] = 3839,
  [4029] = 3868,
  [4030] = 4030,
  [4031] = 3846,
  [4032] = 4032,
  [4033] = 4033,
  [4034] = 3863,
  [4035] = 3902,
  [4036] = 3903,
  [4037] = 3888,
  [4038] = 3905,
  [4039] = 3906,
  [4040] = 3906,
  [4041] = 3902,
  [4042] = 3975,
  [4043] = 3871,
  [4044] = 3976,
  [4045] = 3869,
  [4046] = 3890,
  [4047] = 3965,
  [4048] = 3871,
  [4049] = 3977,
  [4050] = 3979,
  [4051] = 3935,
  [4052] = 4052,
  [4053] = 3882,
  [4054] = 4054,
  [4055] = 3987,
  [4056] = 3856,
  [4057] = 3991,
  [4058] = 3998,
  [4059] = 3905,
  [4060] = 3903,
  [4061] = 3970,
  [4062] = 2238,
  [4063] = 3858,
  [4064] = 3940,
  [4065] = 3941,
  [4066] = 4066,
  [4067] = 3882,
  [4068] = 3861,
  [4069] = 3841,
  [4070] = 4070,
  [4071] = 3930,
  [4072] = 4072,
  [4073] = 4073,
  [4074] = 3871,
  [4075] = 4075,
  [4076] = 4076,
  [4077] = 3863,
  [4078] = 3859,
  [4079] = 3871,
  [4080] = 4080,
  [4081] = 3863,
  [4082] = 4082,
  [4083] = 3834,
  [4084] = 4084,
  [4085] = 3903,
  [4086] = 3905,
  [4087] = 3906,
  [4088] = 4088,
  [4089] = 3902,
  [4090] = 3882,
  [4091] = 4091,
  [4092] = 4092,
  [4093] = 3942,
  [4094] = 4025,
  [4095] = 4095,
  [4096] = 4096,
  [4097] = 3839,
  [4098] = 4098,
  [4099] = 4030,
  [4100] = 3856,
  [4101] = 794,
  [4102] = 2221,
  [4103] = 4103,
  [4104] = 4104,
  [4105] = 3854,
  [4106] = 2248,
  [4107] = 4107,
  [4108] = 2220,
  [4109] = 4109,
  [4110] = 4012,
  [4111] = 4111,
  [4112] = 4112,
  [4113] = 4113,
  [4114] = 4114,
  [4115] = 4115,
  [4116] = 4116,
  [4117] = 4117,
  [4118] = 4118,
  [4119] = 4119,
  [4120] = 4120,
  [4121] = 4121,
  [4122] = 4122,
  [4123] = 4123,
  [4124] = 4124,
  [4125] = 4125,
  [4126] = 4126,
  [4127] = 4127,
  [4128] = 4128,
  [4129] = 4129,
  [4130] = 4130,
  [4131] = 4131,
  [4132] = 4132,
  [4133] = 4133,
  [4134] = 4134,
  [4135] = 4135,
  [4136] = 4136,
  [4137] = 4137,
  [4138] = 4138,
  [4139] = 4139,
  [4140] = 4123,
  [4141] = 4141,
  [4142] = 4142,
  [4143] = 4143,
  [4144] = 4144,
  [4145] = 4115,
  [4146] = 4146,
  [4147] = 4147,
  [4148] = 4148,
  [4149] = 4113,
  [4150] = 4112,
  [4151] = 4116,
  [4152] = 4152,
  [4153] = 4153,
  [4154] = 4154,
  [4155] = 4114,
  [4156] = 4156,
  [4157] = 4157,
  [4158] = 4158,
  [4159] = 4159,
  [4160] = 4160,
  [4161] = 4161,
  [4162] = 4142,
  [4163] = 4163,
  [4164] = 4164,
  [4165] = 4165,
  [4166] = 4163,
  [4167] = 4157,
  [4168] = 4161,
  [4169] = 4139,
  [4170] = 4114,
  [4171] = 4171,
  [4172] = 4116,
  [4173] = 4112,
  [4174] = 4113,
  [4175] = 4137,
  [4176] = 4115,
  [4177] = 4165,
  [4178] = 4178,
  [4179] = 4179,
  [4180] = 4180,
  [4181] = 4123,
  [4182] = 4182,
  [4183] = 4183,
  [4184] = 4184,
  [4185] = 4185,
  [4186] = 4123,
  [4187] = 4187,
  [4188] = 4188,
  [4189] = 4189,
  [4190] = 4190,
  [4191] = 4191,
  [4192] = 4192,
  [4193] = 4193,
  [4194] = 4194,
  [4195] = 4195,
  [4196] = 4123,
  [4197] = 4197,
  [4198] = 4198,
  [4199] = 4199,
  [4200] = 4200,
  [4201] = 4201,
  [4202] = 4202,
  [4203] = 4203,
  [4204] = 4204,
  [4205] = 4205,
  [4206] = 4206,
  [4207] = 4207,
  [4208] = 4208,
  [4209] = 4209,
  [4210] = 4210,
  [4211] = 4115,
  [4212] = 4212,
  [4213] = 4213,
  [4214] = 4185,
  [4215] = 4114,
  [4216] = 4123,
  [4217] = 4153,
  [4218] = 4218,
  [4219] = 4219,
  [4220] = 4220,
  [4221] = 4221,
  [4222] = 4222,
  [4223] = 4138,
  [4224] = 4111,
  [4225] = 4225,
  [4226] = 4226,
  [4227] = 4227,
  [4228] = 4228,
  [4229] = 4163,
  [4230] = 4230,
  [4231] = 4116,
  [4232] = 4232,
  [4233] = 4112,
  [4234] = 4113,
  [4235] = 4235,
  [4236] = 4236,
  [4237] = 4237,
  [4238] = 4238,
  [4239] = 4239,
  [4240] = 4240,
  [4241] = 4241,
  [4242] = 4242,
  [4243] = 4228,
  [4244] = 4226,
  [4245] = 4245,
  [4246] = 4242,
  [4247] = 4247,
  [4248] = 4161,
  [4249] = 4241,
  [4250] = 4204,
  [4251] = 4251,
  [4252] = 4203,
  [4253] = 4202,
  [4254] = 4201,
  [4255] = 4200,
  [4256] = 4198,
  [4257] = 4225,
  [4258] = 4194,
  [4259] = 4193,
  [4260] = 4191,
  [4261] = 4190,
  [4262] = 4239,
  [4263] = 4236,
  [4264] = 4142,
  [4265] = 4141,
  [4266] = 4122,
  [4267] = 4235,
  [4268] = 4232,
  [4269] = 4230,
  [4270] = 4139,
  [4271] = 4206,
  [4272] = 4138,
  [4273] = 4137,
  [4274] = 4136,
  [4275] = 4185,
  [4276] = 4221,
  [4277] = 4227,
  [4278] = 4111,
  [4279] = 4279,
  [4280] = 4206,
  [4281] = 4230,
  [4282] = 4232,
  [4283] = 4283,
  [4284] = 4235,
  [4285] = 4236,
  [4286] = 4239,
  [4287] = 4241,
  [4288] = 4242,
  [4289] = 4228,
  [4290] = 4226,
  [4291] = 4161,
  [4292] = 4204,
  [4293] = 4203,
  [4294] = 4294,
  [4295] = 4202,
  [4296] = 4201,
  [4297] = 4200,
  [4298] = 4198,
  [4299] = 4194,
  [4300] = 4300,
  [4301] = 4193,
  [4302] = 4302,
  [4303] = 4303,
  [4304] = 4191,
  [4305] = 4190,
  [4306] = 4142,
  [4307] = 4163,
  [4308] = 4159,
  [4309] = 4309,
  [4310] = 4158,
  [4311] = 4143,
  [4312] = 4139,
  [4313] = 4138,
  [4314] = 4137,
  [4315] = 4136,
  [4316] = 4130,
  [4317] = 4129,
  [4318] = 4126,
  [4319] = 4125,
  [4320] = 4124,
  [4321] = 4202,
  [4322] = 4322,
  [4323] = 4185,
  [4324] = 4221,
  [4325] = 4227,
  [4326] = 4251,
  [4327] = 4283,
  [4328] = 4111,
  [4329] = 4247,
  [4330] = 4187,
  [4331] = 4111,
  [4332] = 4279,
  [4333] = 4333,
  [4334] = 4334,
  [4335] = 4206,
  [4336] = 4245,
  [4337] = 4230,
  [4338] = 4232,
  [4339] = 4235,
  [4340] = 4340,
  [4341] = 4236,
  [4342] = 4114,
  [4343] = 4189,
  [4344] = 4153,
  [4345] = 4239,
  [4346] = 4241,
  [4347] = 4242,
  [4348] = 4228,
  [4349] = 4226,
  [4350] = 4116,
  [4351] = 4112,
  [4352] = 4113,
  [4353] = 4240,
  [4354] = 4161,
  [4355] = 4204,
  [4356] = 4203,
  [4357] = 4185,
  [4358] = 4201,
  [4359] = 4200,
  [4360] = 4198,
  [4361] = 4194,
  [4362] = 4193,
  [4363] = 4192,
  [4364] = 4191,
  [4365] = 4237,
  [4366] = 4190,
  [4367] = 4142,
  [4368] = 4163,
  [4369] = 4369,
  [4370] = 4159,
  [4371] = 4158,
  [4372] = 4144,
  [4373] = 4113,
  [4374] = 4112,
  [4375] = 4116,
  [4376] = 4376,
  [4377] = 4143,
  [4378] = 4139,
  [4379] = 4138,
  [4380] = 4279,
  [4381] = 4137,
  [4382] = 4136,
  [4383] = 4130,
  [4384] = 4129,
  [4385] = 4126,
  [4386] = 4125,
  [4387] = 4124,
  [4388] = 4122,
  [4389] = 4202,
  [4390] = 4221,
  [4391] = 4227,
  [4392] = 4251,
  [4393] = 4283,
  [4394] = 4279,
  [4395] = 4333,
  [4396] = 4206,
  [4397] = 4397,
  [4398] = 4230,
  [4399] = 4157,
  [4400] = 4333,
  [4401] = 4232,
  [4402] = 4235,
  [4403] = 4236,
  [4404] = 4239,
  [4405] = 4205,
  [4406] = 4241,
  [4407] = 4153,
  [4408] = 4242,
  [4409] = 4228,
  [4410] = 4226,
  [4411] = 4411,
  [4412] = 4161,
  [4413] = 4204,
  [4414] = 4114,
  [4415] = 4415,
  [4416] = 4153,
  [4417] = 4203,
  [4418] = 4122,
  [4419] = 4201,
  [4420] = 4116,
  [4421] = 4200,
  [4422] = 4112,
  [4423] = 4113,
  [4424] = 4198,
  [4425] = 4194,
  [4426] = 4193,
  [4427] = 4427,
  [4428] = 4191,
  [4429] = 4225,
  [4430] = 4190,
  [4431] = 4142,
  [4432] = 4163,
  [4433] = 4159,
  [4434] = 4158,
  [4435] = 4144,
  [4436] = 4143,
  [4437] = 4120,
  [4438] = 4438,
  [4439] = 4207,
  [4440] = 4440,
  [4441] = 4139,
  [4442] = 4218,
  [4443] = 4153,
  [4444] = 4138,
  [4445] = 4137,
  [4446] = 4136,
  [4447] = 4225,
  [4448] = 4130,
  [4449] = 4129,
  [4450] = 4126,
  [4451] = 4125,
  [4452] = 4225,
  [4453] = 4124,
  [4454] = 4279,
  [4455] = 4153,
  [4456] = 4114,
  [4457] = 4171,
  [4458] = 4440,
  [4459] = 4438,
  [4460] = 4460,
  [4461] = 4208,
  [4462] = 4209,
  [4463] = 4334,
  [4464] = 4225,
  [4465] = 4195,
  [4466] = 4154,
  [4467] = 4213,
  [4468] = 1470,
  [4469] = 4188,
  [4470] = 4197,
  [4471] = 4185,
  [4472] = 4221,
  [4473] = 4115,
  [4474] = 4227,
  [4475] = 4251,
  [4476] = 4283,
  [4477] = 4111,
  [4478] = 4114,
  [4479] = 4153,
  [4480] = 4333,
  [4481] = 4369,
  [4482] = 4113,
  [4483] = 4112,
  [4484] = 4116,
};

static inline bool anon_sym_BANG_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym__glimmer_template_content_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '{' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 8192
    ? (c < 160
      ? (c < 0
        ? c == 0
        : c <= '~')
      : (c <= 160 || c == 5760))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '|' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_private_property_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < '['
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '@')))
      : (c <= '^' || (c < '{'
        ? c == '`'
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(95);
      if (lookahead == '!') ADVANCE(109);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '$') ADVANCE(241);
      if (lookahead == '%') ADVANCE(190);
      if (lookahead == '&') ADVANCE(172);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(184);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '/') ADVANCE(226);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(124);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '>') ADVANCE(129);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(53);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '^') ADVANCE(175);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(105);
      if (lookahead == '|') ADVANCE(178);
      if (lookahead == '}') ADVANCE(107);
      if (lookahead == '~') ADVANCE(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(92)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(242);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(1)
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '<') ADVANCE(119);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(118);
      if (lookahead != 0) ADVANCE(116);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(28)
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '[') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(91);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(227);
      if (lookahead != 0) ADVANCE(228);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(109);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '#') ADVANCE(36);
      if (lookahead == '%') ADVANCE(190);
      if (lookahead == '&') ADVANCE(172);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(184);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(132);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '>') ADVANCE(129);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '^') ADVANCE(175);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(105);
      if (lookahead == '|') ADVANCE(178);
      if (lookahead == '}') ADVANCE(107);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(3)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '~') ADVANCE(242);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(109);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '%') ADVANCE(190);
      if (lookahead == '&') ADVANCE(172);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(184);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '/') ADVANCE(132);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == '<') ADVANCE(124);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '>') ADVANCE(129);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == '^') ADVANCE(175);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(105);
      if (lookahead == '|') ADVANCE(177);
      if (lookahead == '~') ADVANCE(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(4)
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(242);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(109);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '%') ADVANCE(190);
      if (lookahead == '&') ADVANCE(172);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(184);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '/') ADVANCE(132);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == '<') ADVANCE(124);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '>') ADVANCE(129);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == '^') ADVANCE(175);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '|') ADVANCE(177);
      if (lookahead == '~') ADVANCE(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(242);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(109);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '%') ADVANCE(190);
      if (lookahead == '&') ADVANCE(172);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(184);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(140);
      if (lookahead == '/') ADVANCE(132);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '>') ADVANCE(129);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '^') ADVANCE(175);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '|') ADVANCE(177);
      if (lookahead == '}') ADVANCE(107);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(6)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != '~') ADVANCE(242);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(109);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '%') ADVANCE(189);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(99);
      if (lookahead == '+') ADVANCE(183);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(186);
      if (lookahead == '.') ADVANCE(140);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '?') ADVANCE(248);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '^') ADVANCE(174);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '|') ADVANCE(180);
      if (lookahead == '}') ADVANCE(107);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(7)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '0' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(242);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(109);
      if (lookahead == '%') ADVANCE(189);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(99);
      if (lookahead == '+') ADVANCE(183);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(186);
      if (lookahead == '.') ADVANCE(140);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(32);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '?') ADVANCE(26);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '^') ADVANCE(174);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '|') ADVANCE(179);
      if (lookahead == '}') ADVANCE(107);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(9)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(229);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(242);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(109);
      if (lookahead == '%') ADVANCE(189);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(99);
      if (lookahead == '+') ADVANCE(183);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(186);
      if (lookahead == '.') ADVANCE(140);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(32);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '?') ADVANCE(26);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '^') ADVANCE(174);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '|') ADVANCE(179);
      if (lookahead == '}') ADVANCE(107);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(9)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(242);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(96);
      if (lookahead == '\\') ADVANCE(54);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(243);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(108);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '#') ADVANCE(36);
      if (lookahead == '&') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(185);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(245);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(107);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(11)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || '+' < lookahead) &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(242);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(108);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '#') ADVANCE(36);
      if (lookahead == '&') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(182);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(185);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '/') ADVANCE(226);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(245);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(105);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(107);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(13)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || ')' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(242);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(108);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '#') ADVANCE(36);
      if (lookahead == '&') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(182);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(185);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(245);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(105);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(107);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(13)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || ')' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(242);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(108);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '&') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(183);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(186);
      if (lookahead == '.') ADVANCE(25);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '?') ADVANCE(245);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(105);
      if (lookahead == '|') ADVANCE(176);
      if (lookahead == '~') ADVANCE(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(14)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(242);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(108);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '&') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '+') ADVANCE(183);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(186);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(246);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(107);
      if (lookahead == '~') ADVANCE(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(15)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '*' < lookahead) &&
          lookahead != '^') ADVANCE(242);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '&') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(182);
      if (lookahead == '-') ADVANCE(185);
      if (lookahead == '.') ADVANCE(70);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(245);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(105);
      if (lookahead == '|') ADVANCE(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(16)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(240);
      if (lookahead != 0 &&
          lookahead > '~') ADVANCE(242);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '/') ADVANCE(207);
      if (lookahead == '\\') ADVANCE(56);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(210);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 18:
      if (lookahead == '$') ADVANCE(57);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '`') ADVANCE(224);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(19)
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(57);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '`') ADVANCE(224);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(19)
      END_STATE();
    case 20:
      if (lookahead == '&') ADVANCE(171);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(35);
      if (lookahead == '.') ADVANCE(140);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(31);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '|') ADVANCE(176);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(20)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(240);
      if (lookahead != 0 &&
          lookahead > '~') ADVANCE(242);
      END_STATE();
    case 21:
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '/') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(56);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(216);
      if (lookahead != 0) ADVANCE(217);
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(223);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(222);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '?') ADVANCE(199);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(160);
      END_STATE();
    case 28:
      if (lookahead == '/') ADVANCE(22);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(28)
      END_STATE();
    case 29:
      if (lookahead == '/') ADVANCE(134);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '{') ADVANCE(104);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(138);
      END_STATE();
    case 30:
      if (lookahead == ':') ADVANCE(249);
      END_STATE();
    case 31:
      if (lookahead == ':') ADVANCE(250);
      END_STATE();
    case 32:
      if (lookahead == '=') ADVANCE(194);
      END_STATE();
    case 33:
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 34:
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 35:
      if (lookahead == '?') ADVANCE(30);
      END_STATE();
    case 36:
      if (lookahead == '\\') ADVANCE(54);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(243);
      END_STATE();
    case 37:
      if (lookahead == '\\') ADVANCE(90);
      if (lookahead == ']') ADVANCE(228);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(37);
      END_STATE();
    case 38:
      if (lookahead == 'a') ADVANCE(50);
      END_STATE();
    case 39:
      if (lookahead == 'a') ADVANCE(51);
      END_STATE();
    case 40:
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 44:
      if (lookahead == 'l') ADVANCE(38);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 46:
      if (lookahead == 'm') ADVANCE(48);
      END_STATE();
    case 47:
      if (lookahead == 'm') ADVANCE(49);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(44);
      END_STATE();
    case 49:
      if (lookahead == 'p') ADVANCE(45);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(41);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 53:
      if (lookahead == 'u') ADVANCE(58);
      if (lookahead == 'x') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(221);
      if (lookahead != 0) ADVANCE(218);
      END_STATE();
    case 54:
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 55:
      if (lookahead == 'u') ADVANCE(60);
      END_STATE();
    case 56:
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'x') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(221);
      if (lookahead != 0) ADVANCE(218);
      END_STATE();
    case 57:
      if (lookahead == '{') ADVANCE(225);
      END_STATE();
    case 58:
      if (lookahead == '{') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      END_STATE();
    case 59:
      if (lookahead == '{') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 60:
      if (lookahead == '{') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(89);
      END_STATE();
    case 61:
      if (lookahead == '{') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(79);
      END_STATE();
    case 62:
      if (lookahead == '}') ADVANCE(242);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 63:
      if (lookahead == '}') ADVANCE(243);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 64:
      if (lookahead == '}') ADVANCE(218);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 65:
      if (lookahead == '}') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 66:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(237);
      END_STATE();
    case 67:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(233);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(234);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(236);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(237);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(242);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(243);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(218);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(235);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 78:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(219);
      END_STATE();
    case 79:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(82);
      END_STATE();
    case 80:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 81:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 82:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 83:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 84:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 85:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 86:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      END_STATE();
    case 87:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(85);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(86);
      END_STATE();
    case 90:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(37);
      END_STATE();
    case 91:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(228);
      END_STATE();
    case 92:
      if (eof) ADVANCE(95);
      if (lookahead == '!') ADVANCE(109);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '$') ADVANCE(241);
      if (lookahead == '%') ADVANCE(190);
      if (lookahead == '&') ADVANCE(172);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(184);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(124);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '>') ADVANCE(129);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '^') ADVANCE(175);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(105);
      if (lookahead == '|') ADVANCE(178);
      if (lookahead == '}') ADVANCE(107);
      if (lookahead == '~') ADVANCE(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(92)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(242);
      END_STATE();
    case 93:
      if (eof) ADVANCE(95);
      if (lookahead == '!') ADVANCE(109);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '%') ADVANCE(189);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(99);
      if (lookahead == '+') ADVANCE(183);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(186);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '?') ADVANCE(26);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '^') ADVANCE(174);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '|') ADVANCE(179);
      if (lookahead == '}') ADVANCE(107);
      if (lookahead == '~') ADVANCE(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(93)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(242);
      END_STATE();
    case 94:
      if (eof) ADVANCE(95);
      if (lookahead == '!') ADVANCE(108);
      if (lookahead == '"') ADVANCE(204);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '&') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(205);
      if (lookahead == '(') ADVANCE(110);
      if (lookahead == ')') ADVANCE(111);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(183);
      if (lookahead == ',') ADVANCE(106);
      if (lookahead == '-') ADVANCE(186);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '0') ADVANCE(231);
      if (lookahead == ':') ADVANCE(113);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(245);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(114);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(115);
      if (lookahead == '`') ADVANCE(224);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(107);
      if (lookahead == '~') ADVANCE(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(94)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(242);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(192);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(191);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(194);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(194);
      if (lookahead == '>') ADVANCE(143);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(143);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(251);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(196);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(223);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '<') ADVANCE(119);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(116);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(52);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LTtemplate_GT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT_SLASHtemplate_GT);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(170);
      if (lookahead == '=') ADVANCE(193);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(170);
      if (lookahead == '=') ADVANCE(193);
      if (lookahead == 't') ADVANCE(40);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(169);
      if (lookahead == '=') ADVANCE(193);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(169);
      if (lookahead == '=') ADVANCE(193);
      if (lookahead == 't') ADVANCE(40);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == 't') ADVANCE(40);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(198);
      if (lookahead == '>') ADVANCE(165);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(198);
      if (lookahead == '>') ADVANCE(166);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(223);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(223);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '\n') ADVANCE(138);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(223);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(136);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(138);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(135);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(24);
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(135);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(24);
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/') ADVANCE(134);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(157);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(158);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(168);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(154);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(155);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(161);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '|') ADVANCE(164);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '|') ADVANCE(164);
      if (lookahead == '}') ADVANCE(252);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(163);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(163);
      if (lookahead == '}') ADVANCE(252);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(252);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(202);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(203);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(203);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(203);
      if (lookahead == '=') ADVANCE(146);
      if (lookahead == '?') ADVANCE(30);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(156);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(195);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(197);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(159);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '\n') ADVANCE(211);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(206);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(209);
      if (lookahead == '/') ADVANCE(206);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(208);
      if (lookahead == '/') ADVANCE(211);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(209);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(209);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(207);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(210);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '\n') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(212);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(215);
      if (lookahead == '/') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(217);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(214);
      if (lookahead == '/') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(215);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(214);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(215);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(213);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(217);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(217);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(55);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(242);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(218);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(220);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(223);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(223);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(28)
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '[') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(91);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(227);
      if (lookahead != 0) ADVANCE(228);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(91);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(228);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(55);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(229);
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(242);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(239);
      if (lookahead == '0') ADVANCE(236);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(67);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(68);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(76);
      if (lookahead == '_') ADVANCE(71);
      if (lookahead == 'n') ADVANCE(230);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(239);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == '_') ADVANCE(69);
      if (lookahead == 'n') ADVANCE(230);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(67);
      if (lookahead == 'n') ADVANCE(230);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(233);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'n') ADVANCE(230);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(234);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(76);
      if (lookahead == 'n') ADVANCE(230);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(235);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(71);
      if (lookahead == 'n') ADVANCE(230);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(236);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(237);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == '_') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(240);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(242);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == '{') ADVANCE(225);
      if (!sym_identifier_character_set_4(lookahead)) ADVANCE(242);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(55);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(242);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(54);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(243);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(144);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '?') ADVANCE(200);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '?') ADVANCE(199);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8203) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 8288 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'b') ADVANCE(53);
      if (lookahead == 'f') ADVANCE(54);
      if (lookahead == 'v') ADVANCE(55);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(59);
      if (lookahead == 'e') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      if (lookahead == 'u') ADVANCE(62);
      if (lookahead == 'w') ADVANCE(63);
      if (lookahead == 'y') ADVANCE(64);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'h') ADVANCE(66);
      if (lookahead == 'r') ADVANCE(67);
      if (lookahead == 'y') ADVANCE(68);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(69);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(70);
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(73);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(74);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(75);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(76);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(77);
      if (lookahead == 'y') ADVANCE(78);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(82);
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(84);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(85);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(86);
      if (lookahead == 'c') ADVANCE(87);
      if (lookahead == 'f') ADVANCE(88);
      if (lookahead == 'l') ADVANCE(89);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(90);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(91);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(92);
      if (lookahead == 't') ADVANCE(93);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(94);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(98);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(100);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(101);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(102);
      if (lookahead == 's') ADVANCE(103);
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(105);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(107);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(108);
      END_STATE();
    case 51:
      if (lookahead == 'v') ADVANCE(109);
      if (lookahead == 'w') ADVANCE(110);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(111);
      if (lookahead == 'm') ADVANCE(112);
      END_STATE();
    case 53:
      if (lookahead == 'j') ADVANCE(113);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(114);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(115);
      if (lookahead == 'o') ADVANCE(116);
      END_STATE();
    case 57:
      if (lookahead == 'b') ADVANCE(117);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(118);
      if (lookahead == 'q') ADVANCE(119);
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 60:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 61:
      if (lookahead == 'a') ADVANCE(123);
      if (lookahead == 'r') ADVANCE(124);
      END_STATE();
    case 62:
      if (lookahead == 'p') ADVANCE(125);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 64:
      if (lookahead == 'm') ADVANCE(127);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(129);
      if (lookahead == 'r') ADVANCE(130);
      END_STATE();
    case 67:
      if (lookahead == 'u') ADVANCE(131);
      if (lookahead == 'y') ADVANCE(132);
      END_STATE();
    case 68:
      if (lookahead == 'p') ADVANCE(133);
      END_STATE();
    case 69:
      if (lookahead == 'd') ADVANCE(134);
      if (lookahead == 'k') ADVANCE(135);
      END_STATE();
    case 70:
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(137);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(138);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 78:
      if (lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 79:
      if (lookahead == 'i') ADVANCE(144);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(146);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 83:
      if (lookahead == 'c') ADVANCE(148);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 85:
      if (lookahead == 's') ADVANCE(150);
      if (lookahead == 't') ADVANCE(151);
      END_STATE();
    case 86:
      if (lookahead == 'u') ADVANCE(152);
      END_STATE();
    case 87:
      if (lookahead == 'l') ADVANCE(153);
      END_STATE();
    case 88:
      if (lookahead == 'a') ADVANCE(154);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(155);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 91:
      if (lookahead == 'm') ADVANCE(157);
      END_STATE();
    case 92:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 94:
      if (lookahead == 's') ADVANCE(160);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(161);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 97:
      if (lookahead == 'm') ADVANCE(162);
      END_STATE();
    case 98:
      if (lookahead == 'c') ADVANCE(163);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 100:
      if (lookahead == 'b') ADVANCE(164);
      END_STATE();
    case 101:
      if (lookahead == 'l') ADVANCE(165);
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 103:
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(169);
      END_STATE();
    case 105:
      if (lookahead == 'o') ADVANCE(170);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 107:
      if (lookahead == 'u') ADVANCE(171);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(173);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 112:
      if (lookahead == 'b') ADVANCE(175);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 114:
      if (lookahead == 'r') ADVANCE(177);
      END_STATE();
    case 115:
      if (lookahead == 'v') ADVANCE(178);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(180);
      END_STATE();
    case 118:
      if (lookahead == 'd') ADVANCE(181);
      END_STATE();
    case 119:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 120:
      if (lookahead == 'u') ADVANCE(183);
      END_STATE();
    case 121:
      if (lookahead == 'i') ADVANCE(184);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 124:
      if (lookahead == 'i') ADVANCE(186);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 126:
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 127:
      if (lookahead == 'b') ADVANCE(189);
      END_STATE();
    case 128:
      if (lookahead == 'g') ADVANCE(190);
      END_STATE();
    case 129:
      if (lookahead == 's') ADVANCE(191);
      END_STATE();
    case 130:
      if (lookahead == 'o') ADVANCE(192);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(193);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(194);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(195);
      END_STATE();
    case 135:
      if (lookahead == 'n') ADVANCE(196);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 137:
      if (lookahead == 'd') ADVANCE(197);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(198);
      END_STATE();
    case 139:
      if (lookahead == 'h') ADVANCE(199);
      END_STATE();
    case 140:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 141:
      if (lookahead == 'r') ADVANCE(201);
      END_STATE();
    case 142:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 143:
      if (lookahead == 'c') ADVANCE(203);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(204);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 146:
      if (lookahead == 'k') ADVANCE(206);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 148:
      if (lookahead == 'h') ADVANCE(207);
      END_STATE();
    case 149:
      if (lookahead == 's') ADVANCE(208);
      END_STATE();
    case 150:
      if (lookahead == 't') ADVANCE(209);
      END_STATE();
    case 151:
      if (lookahead == 'i') ADVANCE(210);
      END_STATE();
    case 152:
      if (lookahead == 'g') ADVANCE(211);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(212);
      END_STATE();
    case 154:
      if (lookahead == 'u') ADVANCE(213);
      END_STATE();
    case 155:
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 158:
      if (lookahead == 'r') ADVANCE(215);
      END_STATE();
    case 159:
      if (lookahead == 'n') ADVANCE(216);
      END_STATE();
    case 160:
      if (lookahead == 'e') ADVANCE(217);
      END_STATE();
    case 161:
      if (lookahead == 'l') ADVANCE(218);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 163:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 164:
      if (lookahead == 'a') ADVANCE(220);
      END_STATE();
    case 165:
      if (lookahead == 'e') ADVANCE(221);
      END_STATE();
    case 166:
      if (lookahead == 'r') ADVANCE(222);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(223);
      END_STATE();
    case 168:
      if (lookahead == 'a') ADVANCE(224);
      END_STATE();
    case 169:
      if (lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 170:
      if (lookahead == 'f') ADVANCE(226);
      END_STATE();
    case 171:
      if (lookahead == 'l') ADVANCE(227);
      END_STATE();
    case 172:
      if (lookahead == 's') ADVANCE(228);
      END_STATE();
    case 173:
      if (lookahead == 'r') ADVANCE(229);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 175:
      if (lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 176:
      if (lookahead == 'c') ADVANCE(231);
      END_STATE();
    case 177:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 178:
      if (lookahead == 'a') ADVANCE(233);
      END_STATE();
    case 179:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 180:
      if (lookahead == 'i') ADVANCE(235);
      END_STATE();
    case 181:
      if (lookahead == 'o') ADVANCE(236);
      END_STATE();
    case 182:
      if (lookahead == 'i') ADVANCE(237);
      END_STATE();
    case 183:
      if (lookahead == 'r') ADVANCE(238);
      END_STATE();
    case 184:
      if (lookahead == 's') ADVANCE(239);
      END_STATE();
    case 185:
      if (lookahead == 'i') ADVANCE(240);
      END_STATE();
    case 186:
      if (lookahead == 'n') ADVANCE(241);
      END_STATE();
    case 187:
      if (lookahead == 'r') ADVANCE(242);
      END_STATE();
    case 188:
      if (lookahead == 'c') ADVANCE(243);
      END_STATE();
    case 189:
      if (lookahead == 'o') ADVANCE(244);
      END_STATE();
    case 190:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 192:
      if (lookahead == 'w') ADVANCE(246);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(247);
      END_STATE();
    case 195:
      if (lookahead == 'f') ADVANCE(248);
      END_STATE();
    case 196:
      if (lookahead == 'o') ADVANCE(249);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 198:
      if (lookahead == 'e') ADVANCE(250);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 200:
      if (lookahead == 'd') ADVANCE(251);
      END_STATE();
    case 201:
      if (lookahead == 'a') ADVANCE(252);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(253);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 205:
      if (lookahead == 'a') ADVANCE(254);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 210:
      if (lookahead == 'n') ADVANCE(255);
      END_STATE();
    case 211:
      if (lookahead == 'g') ADVANCE(256);
      END_STATE();
    case 212:
      if (lookahead == 'r') ADVANCE(257);
      END_STATE();
    case 213:
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(259);
      END_STATE();
    case 215:
      if (lookahead == 't') ADVANCE(260);
      END_STATE();
    case 216:
      if (lookahead == 'd') ADVANCE(261);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 218:
      if (lookahead == 'l') ADVANCE(262);
      END_STATE();
    case 219:
      if (lookahead == 'i') ADVANCE(263);
      END_STATE();
    case 220:
      if (lookahead == 'l') ADVANCE(264);
      END_STATE();
    case 221:
      if (lookahead == 'm') ADVANCE(265);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(266);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(267);
      END_STATE();
    case 225:
      if (lookahead == 'f') ADVANCE(268);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 227:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 228:
      if (lookahead == 'p') ADVANCE(270);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 230:
      if (lookahead == 'r') ADVANCE(271);
      END_STATE();
    case 231:
      if (lookahead == 't') ADVANCE(272);
      END_STATE();
    case 232:
      if (lookahead == 'i') ADVANCE(273);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(275);
      END_STATE();
    case 235:
      if (lookahead == 'c') ADVANCE(276);
      END_STATE();
    case 236:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 237:
      if (lookahead == 'r') ADVANCE(278);
      END_STATE();
    case 238:
      if (lookahead == 'n') ADVANCE(279);
      END_STATE();
    case 239:
      if (lookahead == 'f') ADVANCE(280);
      END_STATE();
    case 240:
      if (lookahead == 'c') ADVANCE(281);
      END_STATE();
    case 241:
      if (lookahead == 'g') ADVANCE(282);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 243:
      if (lookahead == 'h') ADVANCE(283);
      END_STATE();
    case 244:
      if (lookahead == 'l') ADVANCE(284);
      END_STATE();
    case 245:
      if (lookahead == 't') ADVANCE(285);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 247:
      if (lookahead == 'f') ADVANCE(286);
      END_STATE();
    case 248:
      if (lookahead == 'i') ADVANCE(287);
      END_STATE();
    case 249:
      if (lookahead == 'w') ADVANCE(288);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 252:
      if (lookahead == 'c') ADVANCE(289);
      END_STATE();
    case 253:
      if (lookahead == 's') ADVANCE(290);
      END_STATE();
    case 254:
      if (lookahead == 'n') ADVANCE(291);
      END_STATE();
    case 255:
      if (lookahead == 'u') ADVANCE(292);
      END_STATE();
    case 256:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 257:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 258:
      if (lookahead == 't') ADVANCE(295);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 261:
      if (lookahead == 's') ADVANCE(296);
      END_STATE();
    case 262:
      if (lookahead == 'y') ADVANCE(297);
      END_STATE();
    case 263:
      if (lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 265:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 267:
      if (lookahead == 'c') ADVANCE(300);
      END_STATE();
    case 268:
      if (lookahead == 'a') ADVANCE(301);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 270:
      if (lookahead == 'a') ADVANCE(302);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 273:
      if (lookahead == 'd') ADVANCE(303);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(304);
      END_STATE();
    case 275:
      if (lookahead == 't') ADVANCE(305);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 277:
      if (lookahead == 'l') ADVANCE(306);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(307);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 280:
      if (lookahead == 'i') ADVANCE(308);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 287:
      if (lookahead == 'n') ADVANCE(309);
      END_STATE();
    case 288:
      if (lookahead == 'n') ADVANCE(310);
      END_STATE();
    case 289:
      if (lookahead == 't') ADVANCE(311);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(312);
      END_STATE();
    case 293:
      if (lookahead == 'r') ADVANCE(313);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 298:
      if (lookahead == 'n') ADVANCE(314);
      END_STATE();
    case 299:
      if (lookahead == 'n') ADVANCE(315);
      END_STATE();
    case 300:
      if (lookahead == 'e') ADVANCE(316);
      END_STATE();
    case 301:
      if (lookahead == 'c') ADVANCE(317);
      END_STATE();
    case 302:
      if (lookahead == 'c') ADVANCE(318);
      END_STATE();
    case 303:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 305:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 306:
      if (lookahead == 'y') ADVANCE(321);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 308:
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 309:
      if (lookahead == 'e') ADVANCE(323);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 315:
      if (lookahead == 't') ADVANCE(324);
      END_STATE();
    case 316:
      if (lookahead == 'o') ADVANCE(325);
      END_STATE();
    case 317:
      if (lookahead == 'e') ADVANCE(326);
      END_STATE();
    case 318:
      if (lookahead == 'e') ADVANCE(327);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 320:
      if (lookahead == 'd') ADVANCE(328);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 322:
      if (lookahead == 's') ADVANCE(329);
      END_STATE();
    case 323:
      if (lookahead == 'd') ADVANCE(330);
      END_STATE();
    case 324:
      if (lookahead == 's') ADVANCE(331);
      END_STATE();
    case 325:
      if (lookahead == 'f') ADVANCE(332);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_satisfies);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 94},
  [2] = {.lex_state = 4, .external_lex_state = 2},
  [3] = {.lex_state = 4, .external_lex_state = 2},
  [4] = {.lex_state = 94},
  [5] = {.lex_state = 94},
  [6] = {.lex_state = 94},
  [7] = {.lex_state = 94},
  [8] = {.lex_state = 94},
  [9] = {.lex_state = 94},
  [10] = {.lex_state = 94},
  [11] = {.lex_state = 94},
  [12] = {.lex_state = 94},
  [13] = {.lex_state = 94},
  [14] = {.lex_state = 94},
  [15] = {.lex_state = 94},
  [16] = {.lex_state = 94},
  [17] = {.lex_state = 94},
  [18] = {.lex_state = 94},
  [19] = {.lex_state = 94},
  [20] = {.lex_state = 94},
  [21] = {.lex_state = 94},
  [22] = {.lex_state = 94},
  [23] = {.lex_state = 94},
  [24] = {.lex_state = 94},
  [25] = {.lex_state = 94},
  [26] = {.lex_state = 94},
  [27] = {.lex_state = 94},
  [28] = {.lex_state = 94},
  [29] = {.lex_state = 94},
  [30] = {.lex_state = 94},
  [31] = {.lex_state = 94},
  [32] = {.lex_state = 94},
  [33] = {.lex_state = 94},
  [34] = {.lex_state = 94},
  [35] = {.lex_state = 94},
  [36] = {.lex_state = 94},
  [37] = {.lex_state = 94},
  [38] = {.lex_state = 94},
  [39] = {.lex_state = 94},
  [40] = {.lex_state = 94},
  [41] = {.lex_state = 94},
  [42] = {.lex_state = 94},
  [43] = {.lex_state = 94},
  [44] = {.lex_state = 94},
  [45] = {.lex_state = 94},
  [46] = {.lex_state = 94},
  [47] = {.lex_state = 94},
  [48] = {.lex_state = 94},
  [49] = {.lex_state = 94},
  [50] = {.lex_state = 94},
  [51] = {.lex_state = 94},
  [52] = {.lex_state = 94},
  [53] = {.lex_state = 94},
  [54] = {.lex_state = 94},
  [55] = {.lex_state = 94},
  [56] = {.lex_state = 94},
  [57] = {.lex_state = 94},
  [58] = {.lex_state = 94},
  [59] = {.lex_state = 14},
  [60] = {.lex_state = 5, .external_lex_state = 2},
  [61] = {.lex_state = 14},
  [62] = {.lex_state = 14},
  [63] = {.lex_state = 5, .external_lex_state = 2},
  [64] = {.lex_state = 14},
  [65] = {.lex_state = 5, .external_lex_state = 2},
  [66] = {.lex_state = 14},
  [67] = {.lex_state = 14},
  [68] = {.lex_state = 5, .external_lex_state = 2},
  [69] = {.lex_state = 14},
  [70] = {.lex_state = 5, .external_lex_state = 2},
  [71] = {.lex_state = 14},
  [72] = {.lex_state = 5, .external_lex_state = 2},
  [73] = {.lex_state = 14},
  [74] = {.lex_state = 5, .external_lex_state = 2},
  [75] = {.lex_state = 5, .external_lex_state = 2},
  [76] = {.lex_state = 14},
  [77] = {.lex_state = 14},
  [78] = {.lex_state = 14},
  [79] = {.lex_state = 14},
  [80] = {.lex_state = 14},
  [81] = {.lex_state = 14},
  [82] = {.lex_state = 14},
  [83] = {.lex_state = 14},
  [84] = {.lex_state = 14},
  [85] = {.lex_state = 14},
  [86] = {.lex_state = 14},
  [87] = {.lex_state = 14},
  [88] = {.lex_state = 14},
  [89] = {.lex_state = 14},
  [90] = {.lex_state = 14},
  [91] = {.lex_state = 14},
  [92] = {.lex_state = 14},
  [93] = {.lex_state = 14},
  [94] = {.lex_state = 14},
  [95] = {.lex_state = 14},
  [96] = {.lex_state = 14},
  [97] = {.lex_state = 14},
  [98] = {.lex_state = 93, .external_lex_state = 2},
  [99] = {.lex_state = 93, .external_lex_state = 3},
  [100] = {.lex_state = 93, .external_lex_state = 3},
  [101] = {.lex_state = 93, .external_lex_state = 2},
  [102] = {.lex_state = 93, .external_lex_state = 2},
  [103] = {.lex_state = 93, .external_lex_state = 3},
  [104] = {.lex_state = 93, .external_lex_state = 2},
  [105] = {.lex_state = 93, .external_lex_state = 2},
  [106] = {.lex_state = 94},
  [107] = {.lex_state = 94},
  [108] = {.lex_state = 94},
  [109] = {.lex_state = 94},
  [110] = {.lex_state = 94},
  [111] = {.lex_state = 94},
  [112] = {.lex_state = 94},
  [113] = {.lex_state = 94},
  [114] = {.lex_state = 3, .external_lex_state = 2},
  [115] = {.lex_state = 3, .external_lex_state = 3},
  [116] = {.lex_state = 3, .external_lex_state = 3},
  [117] = {.lex_state = 3, .external_lex_state = 2},
  [118] = {.lex_state = 3, .external_lex_state = 2},
  [119] = {.lex_state = 3, .external_lex_state = 2},
  [120] = {.lex_state = 3, .external_lex_state = 3},
  [121] = {.lex_state = 3, .external_lex_state = 2},
  [122] = {.lex_state = 3, .external_lex_state = 2},
  [123] = {.lex_state = 3, .external_lex_state = 2},
  [124] = {.lex_state = 3, .external_lex_state = 2},
  [125] = {.lex_state = 3, .external_lex_state = 2},
  [126] = {.lex_state = 3, .external_lex_state = 2},
  [127] = {.lex_state = 94},
  [128] = {.lex_state = 94},
  [129] = {.lex_state = 94},
  [130] = {.lex_state = 94},
  [131] = {.lex_state = 94},
  [132] = {.lex_state = 94},
  [133] = {.lex_state = 94},
  [134] = {.lex_state = 94},
  [135] = {.lex_state = 94},
  [136] = {.lex_state = 94},
  [137] = {.lex_state = 94},
  [138] = {.lex_state = 94},
  [139] = {.lex_state = 94},
  [140] = {.lex_state = 94},
  [141] = {.lex_state = 94},
  [142] = {.lex_state = 94},
  [143] = {.lex_state = 94},
  [144] = {.lex_state = 94},
  [145] = {.lex_state = 94},
  [146] = {.lex_state = 94},
  [147] = {.lex_state = 94},
  [148] = {.lex_state = 94},
  [149] = {.lex_state = 94},
  [150] = {.lex_state = 94},
  [151] = {.lex_state = 94, .external_lex_state = 4},
  [152] = {.lex_state = 93, .external_lex_state = 3},
  [153] = {.lex_state = 93, .external_lex_state = 3},
  [154] = {.lex_state = 94},
  [155] = {.lex_state = 93, .external_lex_state = 3},
  [156] = {.lex_state = 93, .external_lex_state = 3},
  [157] = {.lex_state = 93, .external_lex_state = 3},
  [158] = {.lex_state = 93, .external_lex_state = 3},
  [159] = {.lex_state = 94},
  [160] = {.lex_state = 93, .external_lex_state = 3},
  [161] = {.lex_state = 94},
  [162] = {.lex_state = 93, .external_lex_state = 3},
  [163] = {.lex_state = 93, .external_lex_state = 3},
  [164] = {.lex_state = 93, .external_lex_state = 3},
  [165] = {.lex_state = 93, .external_lex_state = 3},
  [166] = {.lex_state = 94},
  [167] = {.lex_state = 93, .external_lex_state = 3},
  [168] = {.lex_state = 93, .external_lex_state = 3},
  [169] = {.lex_state = 93, .external_lex_state = 3},
  [170] = {.lex_state = 94},
  [171] = {.lex_state = 93, .external_lex_state = 3},
  [172] = {.lex_state = 94},
  [173] = {.lex_state = 94},
  [174] = {.lex_state = 93, .external_lex_state = 3},
  [175] = {.lex_state = 93, .external_lex_state = 3},
  [176] = {.lex_state = 93, .external_lex_state = 3},
  [177] = {.lex_state = 93, .external_lex_state = 3},
  [178] = {.lex_state = 93, .external_lex_state = 3},
  [179] = {.lex_state = 94},
  [180] = {.lex_state = 93, .external_lex_state = 3},
  [181] = {.lex_state = 93, .external_lex_state = 3},
  [182] = {.lex_state = 93, .external_lex_state = 3},
  [183] = {.lex_state = 93, .external_lex_state = 3},
  [184] = {.lex_state = 93, .external_lex_state = 3},
  [185] = {.lex_state = 93, .external_lex_state = 3},
  [186] = {.lex_state = 93, .external_lex_state = 3},
  [187] = {.lex_state = 94},
  [188] = {.lex_state = 94},
  [189] = {.lex_state = 94},
  [190] = {.lex_state = 94},
  [191] = {.lex_state = 94},
  [192] = {.lex_state = 94},
  [193] = {.lex_state = 94},
  [194] = {.lex_state = 94},
  [195] = {.lex_state = 94},
  [196] = {.lex_state = 94},
  [197] = {.lex_state = 94},
  [198] = {.lex_state = 94},
  [199] = {.lex_state = 94},
  [200] = {.lex_state = 94},
  [201] = {.lex_state = 94},
  [202] = {.lex_state = 94},
  [203] = {.lex_state = 94},
  [204] = {.lex_state = 94},
  [205] = {.lex_state = 94},
  [206] = {.lex_state = 94},
  [207] = {.lex_state = 94},
  [208] = {.lex_state = 94},
  [209] = {.lex_state = 94},
  [210] = {.lex_state = 94},
  [211] = {.lex_state = 94},
  [212] = {.lex_state = 94},
  [213] = {.lex_state = 94},
  [214] = {.lex_state = 94},
  [215] = {.lex_state = 94},
  [216] = {.lex_state = 94},
  [217] = {.lex_state = 94},
  [218] = {.lex_state = 5, .external_lex_state = 2},
  [219] = {.lex_state = 94},
  [220] = {.lex_state = 94},
  [221] = {.lex_state = 94},
  [222] = {.lex_state = 94},
  [223] = {.lex_state = 94},
  [224] = {.lex_state = 94},
  [225] = {.lex_state = 94, .external_lex_state = 4},
  [226] = {.lex_state = 94},
  [227] = {.lex_state = 94},
  [228] = {.lex_state = 94},
  [229] = {.lex_state = 5, .external_lex_state = 2},
  [230] = {.lex_state = 94},
  [231] = {.lex_state = 5, .external_lex_state = 2},
  [232] = {.lex_state = 5, .external_lex_state = 2},
  [233] = {.lex_state = 94},
  [234] = {.lex_state = 94},
  [235] = {.lex_state = 94},
  [236] = {.lex_state = 94},
  [237] = {.lex_state = 94},
  [238] = {.lex_state = 94},
  [239] = {.lex_state = 94},
  [240] = {.lex_state = 94},
  [241] = {.lex_state = 94},
  [242] = {.lex_state = 94},
  [243] = {.lex_state = 94},
  [244] = {.lex_state = 94},
  [245] = {.lex_state = 94},
  [246] = {.lex_state = 94},
  [247] = {.lex_state = 94},
  [248] = {.lex_state = 94},
  [249] = {.lex_state = 94},
  [250] = {.lex_state = 94},
  [251] = {.lex_state = 94},
  [252] = {.lex_state = 94},
  [253] = {.lex_state = 94},
  [254] = {.lex_state = 94},
  [255] = {.lex_state = 94},
  [256] = {.lex_state = 94},
  [257] = {.lex_state = 94},
  [258] = {.lex_state = 94},
  [259] = {.lex_state = 94},
  [260] = {.lex_state = 94},
  [261] = {.lex_state = 94},
  [262] = {.lex_state = 94},
  [263] = {.lex_state = 94},
  [264] = {.lex_state = 94},
  [265] = {.lex_state = 94},
  [266] = {.lex_state = 94},
  [267] = {.lex_state = 94},
  [268] = {.lex_state = 94},
  [269] = {.lex_state = 94},
  [270] = {.lex_state = 94},
  [271] = {.lex_state = 94},
  [272] = {.lex_state = 94},
  [273] = {.lex_state = 94},
  [274] = {.lex_state = 94},
  [275] = {.lex_state = 94},
  [276] = {.lex_state = 94},
  [277] = {.lex_state = 94},
  [278] = {.lex_state = 94},
  [279] = {.lex_state = 94},
  [280] = {.lex_state = 94},
  [281] = {.lex_state = 94},
  [282] = {.lex_state = 94},
  [283] = {.lex_state = 94},
  [284] = {.lex_state = 94},
  [285] = {.lex_state = 94},
  [286] = {.lex_state = 94},
  [287] = {.lex_state = 94},
  [288] = {.lex_state = 94},
  [289] = {.lex_state = 94},
  [290] = {.lex_state = 94},
  [291] = {.lex_state = 94},
  [292] = {.lex_state = 94},
  [293] = {.lex_state = 94},
  [294] = {.lex_state = 94},
  [295] = {.lex_state = 94},
  [296] = {.lex_state = 94},
  [297] = {.lex_state = 94},
  [298] = {.lex_state = 94},
  [299] = {.lex_state = 94},
  [300] = {.lex_state = 94},
  [301] = {.lex_state = 94},
  [302] = {.lex_state = 94},
  [303] = {.lex_state = 94},
  [304] = {.lex_state = 94},
  [305] = {.lex_state = 94},
  [306] = {.lex_state = 94},
  [307] = {.lex_state = 94},
  [308] = {.lex_state = 94},
  [309] = {.lex_state = 94},
  [310] = {.lex_state = 94},
  [311] = {.lex_state = 94},
  [312] = {.lex_state = 94},
  [313] = {.lex_state = 94},
  [314] = {.lex_state = 94},
  [315] = {.lex_state = 94},
  [316] = {.lex_state = 94},
  [317] = {.lex_state = 94},
  [318] = {.lex_state = 94},
  [319] = {.lex_state = 94},
  [320] = {.lex_state = 94},
  [321] = {.lex_state = 94},
  [322] = {.lex_state = 94},
  [323] = {.lex_state = 94},
  [324] = {.lex_state = 94},
  [325] = {.lex_state = 94},
  [326] = {.lex_state = 94},
  [327] = {.lex_state = 94},
  [328] = {.lex_state = 94},
  [329] = {.lex_state = 94},
  [330] = {.lex_state = 94},
  [331] = {.lex_state = 6, .external_lex_state = 3},
  [332] = {.lex_state = 94},
  [333] = {.lex_state = 94},
  [334] = {.lex_state = 94},
  [335] = {.lex_state = 94},
  [336] = {.lex_state = 94},
  [337] = {.lex_state = 94},
  [338] = {.lex_state = 94},
  [339] = {.lex_state = 94},
  [340] = {.lex_state = 94},
  [341] = {.lex_state = 94},
  [342] = {.lex_state = 94},
  [343] = {.lex_state = 94},
  [344] = {.lex_state = 94},
  [345] = {.lex_state = 94},
  [346] = {.lex_state = 94},
  [347] = {.lex_state = 94},
  [348] = {.lex_state = 94},
  [349] = {.lex_state = 94},
  [350] = {.lex_state = 94},
  [351] = {.lex_state = 94},
  [352] = {.lex_state = 94},
  [353] = {.lex_state = 94},
  [354] = {.lex_state = 94},
  [355] = {.lex_state = 94},
  [356] = {.lex_state = 94},
  [357] = {.lex_state = 94},
  [358] = {.lex_state = 94},
  [359] = {.lex_state = 94},
  [360] = {.lex_state = 94},
  [361] = {.lex_state = 94},
  [362] = {.lex_state = 94},
  [363] = {.lex_state = 94},
  [364] = {.lex_state = 94},
  [365] = {.lex_state = 94},
  [366] = {.lex_state = 94},
  [367] = {.lex_state = 94},
  [368] = {.lex_state = 94},
  [369] = {.lex_state = 94},
  [370] = {.lex_state = 94},
  [371] = {.lex_state = 94},
  [372] = {.lex_state = 94},
  [373] = {.lex_state = 94},
  [374] = {.lex_state = 94},
  [375] = {.lex_state = 94},
  [376] = {.lex_state = 94},
  [377] = {.lex_state = 94},
  [378] = {.lex_state = 94},
  [379] = {.lex_state = 94},
  [380] = {.lex_state = 94},
  [381] = {.lex_state = 94},
  [382] = {.lex_state = 94},
  [383] = {.lex_state = 94},
  [384] = {.lex_state = 94},
  [385] = {.lex_state = 94},
  [386] = {.lex_state = 94},
  [387] = {.lex_state = 94},
  [388] = {.lex_state = 94},
  [389] = {.lex_state = 94},
  [390] = {.lex_state = 94},
  [391] = {.lex_state = 94},
  [392] = {.lex_state = 94},
  [393] = {.lex_state = 94},
  [394] = {.lex_state = 94},
  [395] = {.lex_state = 94},
  [396] = {.lex_state = 94},
  [397] = {.lex_state = 94},
  [398] = {.lex_state = 94},
  [399] = {.lex_state = 94},
  [400] = {.lex_state = 94},
  [401] = {.lex_state = 94},
  [402] = {.lex_state = 94},
  [403] = {.lex_state = 94},
  [404] = {.lex_state = 94},
  [405] = {.lex_state = 94},
  [406] = {.lex_state = 94},
  [407] = {.lex_state = 94},
  [408] = {.lex_state = 94},
  [409] = {.lex_state = 94},
  [410] = {.lex_state = 94},
  [411] = {.lex_state = 94},
  [412] = {.lex_state = 94},
  [413] = {.lex_state = 94},
  [414] = {.lex_state = 94},
  [415] = {.lex_state = 94},
  [416] = {.lex_state = 94},
  [417] = {.lex_state = 94},
  [418] = {.lex_state = 94},
  [419] = {.lex_state = 94},
  [420] = {.lex_state = 94},
  [421] = {.lex_state = 94},
  [422] = {.lex_state = 94},
  [423] = {.lex_state = 94},
  [424] = {.lex_state = 94},
  [425] = {.lex_state = 94},
  [426] = {.lex_state = 94},
  [427] = {.lex_state = 94},
  [428] = {.lex_state = 94},
  [429] = {.lex_state = 94},
  [430] = {.lex_state = 94},
  [431] = {.lex_state = 94},
  [432] = {.lex_state = 94},
  [433] = {.lex_state = 94},
  [434] = {.lex_state = 94},
  [435] = {.lex_state = 94},
  [436] = {.lex_state = 94},
  [437] = {.lex_state = 94},
  [438] = {.lex_state = 94},
  [439] = {.lex_state = 94},
  [440] = {.lex_state = 94},
  [441] = {.lex_state = 94},
  [442] = {.lex_state = 94},
  [443] = {.lex_state = 94},
  [444] = {.lex_state = 94},
  [445] = {.lex_state = 94},
  [446] = {.lex_state = 94},
  [447] = {.lex_state = 94},
  [448] = {.lex_state = 94},
  [449] = {.lex_state = 94},
  [450] = {.lex_state = 94},
  [451] = {.lex_state = 94},
  [452] = {.lex_state = 94},
  [453] = {.lex_state = 94},
  [454] = {.lex_state = 6, .external_lex_state = 3},
  [455] = {.lex_state = 94},
  [456] = {.lex_state = 94},
  [457] = {.lex_state = 94},
  [458] = {.lex_state = 94},
  [459] = {.lex_state = 6, .external_lex_state = 3},
  [460] = {.lex_state = 94},
  [461] = {.lex_state = 94},
  [462] = {.lex_state = 94},
  [463] = {.lex_state = 94},
  [464] = {.lex_state = 94},
  [465] = {.lex_state = 94},
  [466] = {.lex_state = 94},
  [467] = {.lex_state = 94},
  [468] = {.lex_state = 94},
  [469] = {.lex_state = 94},
  [470] = {.lex_state = 94},
  [471] = {.lex_state = 94},
  [472] = {.lex_state = 94},
  [473] = {.lex_state = 94},
  [474] = {.lex_state = 94},
  [475] = {.lex_state = 94},
  [476] = {.lex_state = 94},
  [477] = {.lex_state = 94},
  [478] = {.lex_state = 94},
  [479] = {.lex_state = 94},
  [480] = {.lex_state = 94},
  [481] = {.lex_state = 94},
  [482] = {.lex_state = 94},
  [483] = {.lex_state = 94},
  [484] = {.lex_state = 94},
  [485] = {.lex_state = 94},
  [486] = {.lex_state = 94},
  [487] = {.lex_state = 94},
  [488] = {.lex_state = 94},
  [489] = {.lex_state = 94},
  [490] = {.lex_state = 94},
  [491] = {.lex_state = 94},
  [492] = {.lex_state = 94},
  [493] = {.lex_state = 94},
  [494] = {.lex_state = 94},
  [495] = {.lex_state = 94},
  [496] = {.lex_state = 94},
  [497] = {.lex_state = 94},
  [498] = {.lex_state = 94},
  [499] = {.lex_state = 94},
  [500] = {.lex_state = 94},
  [501] = {.lex_state = 94},
  [502] = {.lex_state = 94},
  [503] = {.lex_state = 94},
  [504] = {.lex_state = 94},
  [505] = {.lex_state = 94},
  [506] = {.lex_state = 94},
  [507] = {.lex_state = 94},
  [508] = {.lex_state = 94},
  [509] = {.lex_state = 94},
  [510] = {.lex_state = 94},
  [511] = {.lex_state = 94},
  [512] = {.lex_state = 94},
  [513] = {.lex_state = 94},
  [514] = {.lex_state = 94},
  [515] = {.lex_state = 94},
  [516] = {.lex_state = 94},
  [517] = {.lex_state = 94},
  [518] = {.lex_state = 94},
  [519] = {.lex_state = 94},
  [520] = {.lex_state = 94},
  [521] = {.lex_state = 94},
  [522] = {.lex_state = 94},
  [523] = {.lex_state = 94},
  [524] = {.lex_state = 94},
  [525] = {.lex_state = 94},
  [526] = {.lex_state = 94},
  [527] = {.lex_state = 94},
  [528] = {.lex_state = 94},
  [529] = {.lex_state = 94},
  [530] = {.lex_state = 94},
  [531] = {.lex_state = 3, .external_lex_state = 3},
  [532] = {.lex_state = 3, .external_lex_state = 3},
  [533] = {.lex_state = 3, .external_lex_state = 3},
  [534] = {.lex_state = 6, .external_lex_state = 3},
  [535] = {.lex_state = 6, .external_lex_state = 3},
  [536] = {.lex_state = 6, .external_lex_state = 3},
  [537] = {.lex_state = 3, .external_lex_state = 3},
  [538] = {.lex_state = 3, .external_lex_state = 3},
  [539] = {.lex_state = 3, .external_lex_state = 3},
  [540] = {.lex_state = 3, .external_lex_state = 3},
  [541] = {.lex_state = 3, .external_lex_state = 3},
  [542] = {.lex_state = 3, .external_lex_state = 3},
  [543] = {.lex_state = 3, .external_lex_state = 3},
  [544] = {.lex_state = 3, .external_lex_state = 3},
  [545] = {.lex_state = 3, .external_lex_state = 3},
  [546] = {.lex_state = 3, .external_lex_state = 3},
  [547] = {.lex_state = 3, .external_lex_state = 3},
  [548] = {.lex_state = 3, .external_lex_state = 3},
  [549] = {.lex_state = 94},
  [550] = {.lex_state = 3, .external_lex_state = 3},
  [551] = {.lex_state = 3, .external_lex_state = 3},
  [552] = {.lex_state = 94},
  [553] = {.lex_state = 3, .external_lex_state = 3},
  [554] = {.lex_state = 3, .external_lex_state = 3},
  [555] = {.lex_state = 3, .external_lex_state = 3},
  [556] = {.lex_state = 3, .external_lex_state = 3},
  [557] = {.lex_state = 94},
  [558] = {.lex_state = 94},
  [559] = {.lex_state = 94},
  [560] = {.lex_state = 94},
  [561] = {.lex_state = 94},
  [562] = {.lex_state = 3, .external_lex_state = 3},
  [563] = {.lex_state = 3, .external_lex_state = 3},
  [564] = {.lex_state = 3, .external_lex_state = 3},
  [565] = {.lex_state = 3, .external_lex_state = 3},
  [566] = {.lex_state = 3, .external_lex_state = 3},
  [567] = {.lex_state = 3, .external_lex_state = 3},
  [568] = {.lex_state = 3, .external_lex_state = 2},
  [569] = {.lex_state = 3, .external_lex_state = 2},
  [570] = {.lex_state = 3, .external_lex_state = 2},
  [571] = {.lex_state = 3, .external_lex_state = 2},
  [572] = {.lex_state = 3, .external_lex_state = 2},
  [573] = {.lex_state = 3, .external_lex_state = 3},
  [574] = {.lex_state = 3, .external_lex_state = 3},
  [575] = {.lex_state = 3, .external_lex_state = 3},
  [576] = {.lex_state = 3, .external_lex_state = 3},
  [577] = {.lex_state = 3, .external_lex_state = 3},
  [578] = {.lex_state = 3, .external_lex_state = 3},
  [579] = {.lex_state = 3, .external_lex_state = 3},
  [580] = {.lex_state = 3, .external_lex_state = 3},
  [581] = {.lex_state = 3, .external_lex_state = 2},
  [582] = {.lex_state = 94, .external_lex_state = 4},
  [583] = {.lex_state = 3, .external_lex_state = 2},
  [584] = {.lex_state = 94},
  [585] = {.lex_state = 6, .external_lex_state = 2},
  [586] = {.lex_state = 94, .external_lex_state = 4},
  [587] = {.lex_state = 3, .external_lex_state = 2},
  [588] = {.lex_state = 6, .external_lex_state = 2},
  [589] = {.lex_state = 3, .external_lex_state = 2},
  [590] = {.lex_state = 3, .external_lex_state = 3},
  [591] = {.lex_state = 94, .external_lex_state = 4},
  [592] = {.lex_state = 94, .external_lex_state = 4},
  [593] = {.lex_state = 3, .external_lex_state = 2},
  [594] = {.lex_state = 3, .external_lex_state = 3},
  [595] = {.lex_state = 3, .external_lex_state = 3},
  [596] = {.lex_state = 3, .external_lex_state = 3},
  [597] = {.lex_state = 94},
  [598] = {.lex_state = 94, .external_lex_state = 4},
  [599] = {.lex_state = 94},
  [600] = {.lex_state = 94, .external_lex_state = 4},
  [601] = {.lex_state = 3, .external_lex_state = 2},
  [602] = {.lex_state = 94, .external_lex_state = 4},
  [603] = {.lex_state = 3, .external_lex_state = 3},
  [604] = {.lex_state = 3, .external_lex_state = 2},
  [605] = {.lex_state = 94, .external_lex_state = 4},
  [606] = {.lex_state = 3, .external_lex_state = 2},
  [607] = {.lex_state = 3, .external_lex_state = 2},
  [608] = {.lex_state = 94},
  [609] = {.lex_state = 94},
  [610] = {.lex_state = 3, .external_lex_state = 2},
  [611] = {.lex_state = 3, .external_lex_state = 2},
  [612] = {.lex_state = 94, .external_lex_state = 4},
  [613] = {.lex_state = 94, .external_lex_state = 4},
  [614] = {.lex_state = 94},
  [615] = {.lex_state = 94},
  [616] = {.lex_state = 94},
  [617] = {.lex_state = 3, .external_lex_state = 2},
  [618] = {.lex_state = 94, .external_lex_state = 4},
  [619] = {.lex_state = 94, .external_lex_state = 4},
  [620] = {.lex_state = 94},
  [621] = {.lex_state = 94},
  [622] = {.lex_state = 94, .external_lex_state = 4},
  [623] = {.lex_state = 94, .external_lex_state = 4},
  [624] = {.lex_state = 94, .external_lex_state = 4},
  [625] = {.lex_state = 94, .external_lex_state = 4},
  [626] = {.lex_state = 94},
  [627] = {.lex_state = 94},
  [628] = {.lex_state = 94, .external_lex_state = 4},
  [629] = {.lex_state = 94, .external_lex_state = 4},
  [630] = {.lex_state = 94, .external_lex_state = 4},
  [631] = {.lex_state = 94},
  [632] = {.lex_state = 94, .external_lex_state = 4},
  [633] = {.lex_state = 94},
  [634] = {.lex_state = 94},
  [635] = {.lex_state = 94},
  [636] = {.lex_state = 94},
  [637] = {.lex_state = 94},
  [638] = {.lex_state = 94},
  [639] = {.lex_state = 94},
  [640] = {.lex_state = 94},
  [641] = {.lex_state = 94},
  [642] = {.lex_state = 94},
  [643] = {.lex_state = 94},
  [644] = {.lex_state = 94},
  [645] = {.lex_state = 94},
  [646] = {.lex_state = 94},
  [647] = {.lex_state = 94},
  [648] = {.lex_state = 94},
  [649] = {.lex_state = 94},
  [650] = {.lex_state = 94},
  [651] = {.lex_state = 94},
  [652] = {.lex_state = 94},
  [653] = {.lex_state = 94},
  [654] = {.lex_state = 94},
  [655] = {.lex_state = 94},
  [656] = {.lex_state = 94},
  [657] = {.lex_state = 94},
  [658] = {.lex_state = 94},
  [659] = {.lex_state = 94},
  [660] = {.lex_state = 94},
  [661] = {.lex_state = 94},
  [662] = {.lex_state = 94},
  [663] = {.lex_state = 94},
  [664] = {.lex_state = 94},
  [665] = {.lex_state = 94},
  [666] = {.lex_state = 94},
  [667] = {.lex_state = 94},
  [668] = {.lex_state = 94},
  [669] = {.lex_state = 94},
  [670] = {.lex_state = 94},
  [671] = {.lex_state = 94},
  [672] = {.lex_state = 94},
  [673] = {.lex_state = 94},
  [674] = {.lex_state = 94},
  [675] = {.lex_state = 94},
  [676] = {.lex_state = 94},
  [677] = {.lex_state = 94},
  [678] = {.lex_state = 94},
  [679] = {.lex_state = 94},
  [680] = {.lex_state = 94},
  [681] = {.lex_state = 94},
  [682] = {.lex_state = 94},
  [683] = {.lex_state = 94},
  [684] = {.lex_state = 94},
  [685] = {.lex_state = 94},
  [686] = {.lex_state = 94},
  [687] = {.lex_state = 94},
  [688] = {.lex_state = 94},
  [689] = {.lex_state = 94},
  [690] = {.lex_state = 94},
  [691] = {.lex_state = 94},
  [692] = {.lex_state = 94},
  [693] = {.lex_state = 94},
  [694] = {.lex_state = 94},
  [695] = {.lex_state = 94},
  [696] = {.lex_state = 94},
  [697] = {.lex_state = 94},
  [698] = {.lex_state = 94},
  [699] = {.lex_state = 94},
  [700] = {.lex_state = 94},
  [701] = {.lex_state = 94},
  [702] = {.lex_state = 94},
  [703] = {.lex_state = 94},
  [704] = {.lex_state = 94},
  [705] = {.lex_state = 94},
  [706] = {.lex_state = 94},
  [707] = {.lex_state = 94},
  [708] = {.lex_state = 94},
  [709] = {.lex_state = 94},
  [710] = {.lex_state = 94},
  [711] = {.lex_state = 94},
  [712] = {.lex_state = 94},
  [713] = {.lex_state = 94},
  [714] = {.lex_state = 94},
  [715] = {.lex_state = 94},
  [716] = {.lex_state = 94},
  [717] = {.lex_state = 94},
  [718] = {.lex_state = 94},
  [719] = {.lex_state = 94},
  [720] = {.lex_state = 94},
  [721] = {.lex_state = 94},
  [722] = {.lex_state = 94},
  [723] = {.lex_state = 94},
  [724] = {.lex_state = 94},
  [725] = {.lex_state = 94},
  [726] = {.lex_state = 94},
  [727] = {.lex_state = 94},
  [728] = {.lex_state = 94},
  [729] = {.lex_state = 94},
  [730] = {.lex_state = 94},
  [731] = {.lex_state = 94},
  [732] = {.lex_state = 94},
  [733] = {.lex_state = 94},
  [734] = {.lex_state = 94},
  [735] = {.lex_state = 94},
  [736] = {.lex_state = 94},
  [737] = {.lex_state = 94},
  [738] = {.lex_state = 94},
  [739] = {.lex_state = 94},
  [740] = {.lex_state = 94},
  [741] = {.lex_state = 94},
  [742] = {.lex_state = 94},
  [743] = {.lex_state = 94},
  [744] = {.lex_state = 94},
  [745] = {.lex_state = 94},
  [746] = {.lex_state = 94},
  [747] = {.lex_state = 94},
  [748] = {.lex_state = 94},
  [749] = {.lex_state = 94},
  [750] = {.lex_state = 94},
  [751] = {.lex_state = 94},
  [752] = {.lex_state = 94},
  [753] = {.lex_state = 94},
  [754] = {.lex_state = 94},
  [755] = {.lex_state = 94},
  [756] = {.lex_state = 94},
  [757] = {.lex_state = 94},
  [758] = {.lex_state = 94},
  [759] = {.lex_state = 94},
  [760] = {.lex_state = 94},
  [761] = {.lex_state = 94},
  [762] = {.lex_state = 94},
  [763] = {.lex_state = 94},
  [764] = {.lex_state = 94},
  [765] = {.lex_state = 94},
  [766] = {.lex_state = 94},
  [767] = {.lex_state = 94},
  [768] = {.lex_state = 94},
  [769] = {.lex_state = 94},
  [770] = {.lex_state = 94},
  [771] = {.lex_state = 94},
  [772] = {.lex_state = 94},
  [773] = {.lex_state = 94},
  [774] = {.lex_state = 94},
  [775] = {.lex_state = 94},
  [776] = {.lex_state = 94},
  [777] = {.lex_state = 94},
  [778] = {.lex_state = 94},
  [779] = {.lex_state = 12},
  [780] = {.lex_state = 12},
  [781] = {.lex_state = 12},
  [782] = {.lex_state = 12},
  [783] = {.lex_state = 12},
  [784] = {.lex_state = 12},
  [785] = {.lex_state = 12},
  [786] = {.lex_state = 12},
  [787] = {.lex_state = 12},
  [788] = {.lex_state = 12},
  [789] = {.lex_state = 12},
  [790] = {.lex_state = 12},
  [791] = {.lex_state = 12},
  [792] = {.lex_state = 12},
  [793] = {.lex_state = 12},
  [794] = {.lex_state = 94},
  [795] = {.lex_state = 94},
  [796] = {.lex_state = 94},
  [797] = {.lex_state = 94},
  [798] = {.lex_state = 94},
  [799] = {.lex_state = 94},
  [800] = {.lex_state = 94},
  [801] = {.lex_state = 94},
  [802] = {.lex_state = 94},
  [803] = {.lex_state = 94},
  [804] = {.lex_state = 94},
  [805] = {.lex_state = 12},
  [806] = {.lex_state = 94},
  [807] = {.lex_state = 94},
  [808] = {.lex_state = 15},
  [809] = {.lex_state = 15},
  [810] = {.lex_state = 15},
  [811] = {.lex_state = 3, .external_lex_state = 3},
  [812] = {.lex_state = 3, .external_lex_state = 3},
  [813] = {.lex_state = 3, .external_lex_state = 3},
  [814] = {.lex_state = 3, .external_lex_state = 3},
  [815] = {.lex_state = 3, .external_lex_state = 3},
  [816] = {.lex_state = 3, .external_lex_state = 3},
  [817] = {.lex_state = 12},
  [818] = {.lex_state = 12},
  [819] = {.lex_state = 12},
  [820] = {.lex_state = 12},
  [821] = {.lex_state = 12},
  [822] = {.lex_state = 11},
  [823] = {.lex_state = 11},
  [824] = {.lex_state = 11},
  [825] = {.lex_state = 12},
  [826] = {.lex_state = 12},
  [827] = {.lex_state = 12},
  [828] = {.lex_state = 3, .external_lex_state = 2},
  [829] = {.lex_state = 11},
  [830] = {.lex_state = 12},
  [831] = {.lex_state = 12},
  [832] = {.lex_state = 12},
  [833] = {.lex_state = 12},
  [834] = {.lex_state = 11},
  [835] = {.lex_state = 11},
  [836] = {.lex_state = 11},
  [837] = {.lex_state = 11},
  [838] = {.lex_state = 12},
  [839] = {.lex_state = 12},
  [840] = {.lex_state = 11},
  [841] = {.lex_state = 12},
  [842] = {.lex_state = 12},
  [843] = {.lex_state = 12},
  [844] = {.lex_state = 3, .external_lex_state = 2},
  [845] = {.lex_state = 12},
  [846] = {.lex_state = 12},
  [847] = {.lex_state = 12},
  [848] = {.lex_state = 12},
  [849] = {.lex_state = 12},
  [850] = {.lex_state = 11},
  [851] = {.lex_state = 12},
  [852] = {.lex_state = 12},
  [853] = {.lex_state = 12},
  [854] = {.lex_state = 12},
  [855] = {.lex_state = 11},
  [856] = {.lex_state = 12},
  [857] = {.lex_state = 12},
  [858] = {.lex_state = 11},
  [859] = {.lex_state = 12},
  [860] = {.lex_state = 12},
  [861] = {.lex_state = 12},
  [862] = {.lex_state = 12},
  [863] = {.lex_state = 3, .external_lex_state = 2},
  [864] = {.lex_state = 12},
  [865] = {.lex_state = 16},
  [866] = {.lex_state = 12},
  [867] = {.lex_state = 12},
  [868] = {.lex_state = 12},
  [869] = {.lex_state = 12},
  [870] = {.lex_state = 12},
  [871] = {.lex_state = 12},
  [872] = {.lex_state = 12},
  [873] = {.lex_state = 12},
  [874] = {.lex_state = 12},
  [875] = {.lex_state = 12},
  [876] = {.lex_state = 12},
  [877] = {.lex_state = 12},
  [878] = {.lex_state = 12},
  [879] = {.lex_state = 12},
  [880] = {.lex_state = 12},
  [881] = {.lex_state = 12},
  [882] = {.lex_state = 12},
  [883] = {.lex_state = 12},
  [884] = {.lex_state = 12},
  [885] = {.lex_state = 12},
  [886] = {.lex_state = 12},
  [887] = {.lex_state = 12},
  [888] = {.lex_state = 12},
  [889] = {.lex_state = 12},
  [890] = {.lex_state = 12},
  [891] = {.lex_state = 12},
  [892] = {.lex_state = 12},
  [893] = {.lex_state = 12},
  [894] = {.lex_state = 12},
  [895] = {.lex_state = 12},
  [896] = {.lex_state = 12},
  [897] = {.lex_state = 12},
  [898] = {.lex_state = 12},
  [899] = {.lex_state = 12},
  [900] = {.lex_state = 12},
  [901] = {.lex_state = 12},
  [902] = {.lex_state = 12},
  [903] = {.lex_state = 12},
  [904] = {.lex_state = 12},
  [905] = {.lex_state = 12},
  [906] = {.lex_state = 12},
  [907] = {.lex_state = 12},
  [908] = {.lex_state = 12},
  [909] = {.lex_state = 12},
  [910] = {.lex_state = 12},
  [911] = {.lex_state = 12},
  [912] = {.lex_state = 12},
  [913] = {.lex_state = 12},
  [914] = {.lex_state = 12},
  [915] = {.lex_state = 12},
  [916] = {.lex_state = 12},
  [917] = {.lex_state = 12},
  [918] = {.lex_state = 12},
  [919] = {.lex_state = 12},
  [920] = {.lex_state = 12},
  [921] = {.lex_state = 12},
  [922] = {.lex_state = 12},
  [923] = {.lex_state = 12},
  [924] = {.lex_state = 12},
  [925] = {.lex_state = 12},
  [926] = {.lex_state = 12},
  [927] = {.lex_state = 12},
  [928] = {.lex_state = 12},
  [929] = {.lex_state = 12},
  [930] = {.lex_state = 12},
  [931] = {.lex_state = 12},
  [932] = {.lex_state = 12},
  [933] = {.lex_state = 12},
  [934] = {.lex_state = 12},
  [935] = {.lex_state = 12},
  [936] = {.lex_state = 12},
  [937] = {.lex_state = 12},
  [938] = {.lex_state = 12},
  [939] = {.lex_state = 12},
  [940] = {.lex_state = 12},
  [941] = {.lex_state = 12},
  [942] = {.lex_state = 12},
  [943] = {.lex_state = 12},
  [944] = {.lex_state = 12},
  [945] = {.lex_state = 12},
  [946] = {.lex_state = 12},
  [947] = {.lex_state = 12},
  [948] = {.lex_state = 12},
  [949] = {.lex_state = 12},
  [950] = {.lex_state = 12},
  [951] = {.lex_state = 12},
  [952] = {.lex_state = 12},
  [953] = {.lex_state = 12},
  [954] = {.lex_state = 12},
  [955] = {.lex_state = 12},
  [956] = {.lex_state = 12},
  [957] = {.lex_state = 12},
  [958] = {.lex_state = 12},
  [959] = {.lex_state = 12},
  [960] = {.lex_state = 12},
  [961] = {.lex_state = 12},
  [962] = {.lex_state = 12},
  [963] = {.lex_state = 3, .external_lex_state = 2},
  [964] = {.lex_state = 12},
  [965] = {.lex_state = 12},
  [966] = {.lex_state = 12},
  [967] = {.lex_state = 12},
  [968] = {.lex_state = 12},
  [969] = {.lex_state = 12},
  [970] = {.lex_state = 12},
  [971] = {.lex_state = 12},
  [972] = {.lex_state = 12},
  [973] = {.lex_state = 12},
  [974] = {.lex_state = 12},
  [975] = {.lex_state = 12},
  [976] = {.lex_state = 12},
  [977] = {.lex_state = 12},
  [978] = {.lex_state = 12},
  [979] = {.lex_state = 12},
  [980] = {.lex_state = 12},
  [981] = {.lex_state = 12},
  [982] = {.lex_state = 12},
  [983] = {.lex_state = 12},
  [984] = {.lex_state = 12},
  [985] = {.lex_state = 3, .external_lex_state = 2},
  [986] = {.lex_state = 12},
  [987] = {.lex_state = 12},
  [988] = {.lex_state = 12},
  [989] = {.lex_state = 12},
  [990] = {.lex_state = 12},
  [991] = {.lex_state = 12},
  [992] = {.lex_state = 12},
  [993] = {.lex_state = 12},
  [994] = {.lex_state = 12},
  [995] = {.lex_state = 12},
  [996] = {.lex_state = 12},
  [997] = {.lex_state = 12},
  [998] = {.lex_state = 12},
  [999] = {.lex_state = 3, .external_lex_state = 3},
  [1000] = {.lex_state = 3, .external_lex_state = 2},
  [1001] = {.lex_state = 3, .external_lex_state = 3},
  [1002] = {.lex_state = 3, .external_lex_state = 3},
  [1003] = {.lex_state = 3, .external_lex_state = 3},
  [1004] = {.lex_state = 3, .external_lex_state = 3},
  [1005] = {.lex_state = 3, .external_lex_state = 3},
  [1006] = {.lex_state = 3, .external_lex_state = 3},
  [1007] = {.lex_state = 3, .external_lex_state = 3},
  [1008] = {.lex_state = 3, .external_lex_state = 3},
  [1009] = {.lex_state = 3, .external_lex_state = 3},
  [1010] = {.lex_state = 3, .external_lex_state = 3},
  [1011] = {.lex_state = 3, .external_lex_state = 3},
  [1012] = {.lex_state = 6, .external_lex_state = 2},
  [1013] = {.lex_state = 3, .external_lex_state = 3},
  [1014] = {.lex_state = 3, .external_lex_state = 2},
  [1015] = {.lex_state = 3, .external_lex_state = 2},
  [1016] = {.lex_state = 3, .external_lex_state = 3},
  [1017] = {.lex_state = 3, .external_lex_state = 2},
  [1018] = {.lex_state = 6, .external_lex_state = 2},
  [1019] = {.lex_state = 6, .external_lex_state = 2},
  [1020] = {.lex_state = 3, .external_lex_state = 3},
  [1021] = {.lex_state = 3, .external_lex_state = 3},
  [1022] = {.lex_state = 3, .external_lex_state = 3},
  [1023] = {.lex_state = 3, .external_lex_state = 3},
  [1024] = {.lex_state = 3, .external_lex_state = 3},
  [1025] = {.lex_state = 11},
  [1026] = {.lex_state = 3, .external_lex_state = 3},
  [1027] = {.lex_state = 11},
  [1028] = {.lex_state = 6, .external_lex_state = 2},
  [1029] = {.lex_state = 3, .external_lex_state = 3},
  [1030] = {.lex_state = 6, .external_lex_state = 2},
  [1031] = {.lex_state = 6, .external_lex_state = 2},
  [1032] = {.lex_state = 3, .external_lex_state = 2},
  [1033] = {.lex_state = 3, .external_lex_state = 3},
  [1034] = {.lex_state = 3, .external_lex_state = 2},
  [1035] = {.lex_state = 3, .external_lex_state = 3},
  [1036] = {.lex_state = 6, .external_lex_state = 2},
  [1037] = {.lex_state = 6, .external_lex_state = 2},
  [1038] = {.lex_state = 3, .external_lex_state = 3},
  [1039] = {.lex_state = 6, .external_lex_state = 2},
  [1040] = {.lex_state = 3, .external_lex_state = 3},
  [1041] = {.lex_state = 3, .external_lex_state = 3},
  [1042] = {.lex_state = 3, .external_lex_state = 2},
  [1043] = {.lex_state = 6, .external_lex_state = 2},
  [1044] = {.lex_state = 6, .external_lex_state = 2},
  [1045] = {.lex_state = 3, .external_lex_state = 2},
  [1046] = {.lex_state = 3, .external_lex_state = 2},
  [1047] = {.lex_state = 3, .external_lex_state = 2},
  [1048] = {.lex_state = 3, .external_lex_state = 2},
  [1049] = {.lex_state = 3, .external_lex_state = 2},
  [1050] = {.lex_state = 3, .external_lex_state = 2},
  [1051] = {.lex_state = 3, .external_lex_state = 2},
  [1052] = {.lex_state = 3, .external_lex_state = 3},
  [1053] = {.lex_state = 6, .external_lex_state = 2},
  [1054] = {.lex_state = 3, .external_lex_state = 3},
  [1055] = {.lex_state = 3, .external_lex_state = 2},
  [1056] = {.lex_state = 3, .external_lex_state = 2},
  [1057] = {.lex_state = 3, .external_lex_state = 2},
  [1058] = {.lex_state = 3, .external_lex_state = 3},
  [1059] = {.lex_state = 3, .external_lex_state = 3},
  [1060] = {.lex_state = 3, .external_lex_state = 2},
  [1061] = {.lex_state = 3, .external_lex_state = 2},
  [1062] = {.lex_state = 3, .external_lex_state = 2},
  [1063] = {.lex_state = 3, .external_lex_state = 3},
  [1064] = {.lex_state = 3, .external_lex_state = 2},
  [1065] = {.lex_state = 3, .external_lex_state = 2},
  [1066] = {.lex_state = 3, .external_lex_state = 2},
  [1067] = {.lex_state = 3, .external_lex_state = 2},
  [1068] = {.lex_state = 3, .external_lex_state = 2},
  [1069] = {.lex_state = 3, .external_lex_state = 2},
  [1070] = {.lex_state = 3, .external_lex_state = 2},
  [1071] = {.lex_state = 3, .external_lex_state = 3},
  [1072] = {.lex_state = 3, .external_lex_state = 3},
  [1073] = {.lex_state = 3, .external_lex_state = 3},
  [1074] = {.lex_state = 3, .external_lex_state = 2},
  [1075] = {.lex_state = 3, .external_lex_state = 2},
  [1076] = {.lex_state = 3, .external_lex_state = 3},
  [1077] = {.lex_state = 3, .external_lex_state = 3},
  [1078] = {.lex_state = 3, .external_lex_state = 2},
  [1079] = {.lex_state = 3, .external_lex_state = 2},
  [1080] = {.lex_state = 3, .external_lex_state = 2},
  [1081] = {.lex_state = 6, .external_lex_state = 2},
  [1082] = {.lex_state = 3, .external_lex_state = 3},
  [1083] = {.lex_state = 3, .external_lex_state = 2},
  [1084] = {.lex_state = 3, .external_lex_state = 2},
  [1085] = {.lex_state = 3, .external_lex_state = 2},
  [1086] = {.lex_state = 3, .external_lex_state = 2},
  [1087] = {.lex_state = 3, .external_lex_state = 3},
  [1088] = {.lex_state = 3, .external_lex_state = 2},
  [1089] = {.lex_state = 3, .external_lex_state = 2},
  [1090] = {.lex_state = 3, .external_lex_state = 2},
  [1091] = {.lex_state = 3, .external_lex_state = 3},
  [1092] = {.lex_state = 6, .external_lex_state = 2},
  [1093] = {.lex_state = 3, .external_lex_state = 3},
  [1094] = {.lex_state = 3, .external_lex_state = 2},
  [1095] = {.lex_state = 3, .external_lex_state = 3},
  [1096] = {.lex_state = 3, .external_lex_state = 3},
  [1097] = {.lex_state = 3, .external_lex_state = 3},
  [1098] = {.lex_state = 3, .external_lex_state = 3},
  [1099] = {.lex_state = 3, .external_lex_state = 3},
  [1100] = {.lex_state = 3, .external_lex_state = 3},
  [1101] = {.lex_state = 3, .external_lex_state = 2},
  [1102] = {.lex_state = 3, .external_lex_state = 3},
  [1103] = {.lex_state = 3, .external_lex_state = 2},
  [1104] = {.lex_state = 3, .external_lex_state = 2},
  [1105] = {.lex_state = 3, .external_lex_state = 3},
  [1106] = {.lex_state = 3, .external_lex_state = 3},
  [1107] = {.lex_state = 3, .external_lex_state = 2},
  [1108] = {.lex_state = 3, .external_lex_state = 2},
  [1109] = {.lex_state = 3, .external_lex_state = 3},
  [1110] = {.lex_state = 3, .external_lex_state = 3},
  [1111] = {.lex_state = 3, .external_lex_state = 3},
  [1112] = {.lex_state = 3, .external_lex_state = 2},
  [1113] = {.lex_state = 3, .external_lex_state = 3},
  [1114] = {.lex_state = 3, .external_lex_state = 3},
  [1115] = {.lex_state = 6, .external_lex_state = 2},
  [1116] = {.lex_state = 3, .external_lex_state = 3},
  [1117] = {.lex_state = 3, .external_lex_state = 3},
  [1118] = {.lex_state = 3, .external_lex_state = 3},
  [1119] = {.lex_state = 3, .external_lex_state = 3},
  [1120] = {.lex_state = 3, .external_lex_state = 3},
  [1121] = {.lex_state = 3, .external_lex_state = 3},
  [1122] = {.lex_state = 3, .external_lex_state = 3},
  [1123] = {.lex_state = 3, .external_lex_state = 3},
  [1124] = {.lex_state = 3, .external_lex_state = 3},
  [1125] = {.lex_state = 3, .external_lex_state = 3},
  [1126] = {.lex_state = 3, .external_lex_state = 3},
  [1127] = {.lex_state = 3, .external_lex_state = 2},
  [1128] = {.lex_state = 3, .external_lex_state = 3},
  [1129] = {.lex_state = 3, .external_lex_state = 2},
  [1130] = {.lex_state = 3, .external_lex_state = 2},
  [1131] = {.lex_state = 3, .external_lex_state = 3},
  [1132] = {.lex_state = 6, .external_lex_state = 2},
  [1133] = {.lex_state = 6, .external_lex_state = 2},
  [1134] = {.lex_state = 3, .external_lex_state = 2},
  [1135] = {.lex_state = 3, .external_lex_state = 2},
  [1136] = {.lex_state = 6, .external_lex_state = 2},
  [1137] = {.lex_state = 3, .external_lex_state = 2},
  [1138] = {.lex_state = 3, .external_lex_state = 2},
  [1139] = {.lex_state = 3, .external_lex_state = 3},
  [1140] = {.lex_state = 3, .external_lex_state = 2},
  [1141] = {.lex_state = 3, .external_lex_state = 2},
  [1142] = {.lex_state = 3, .external_lex_state = 2},
  [1143] = {.lex_state = 94},
  [1144] = {.lex_state = 6, .external_lex_state = 2},
  [1145] = {.lex_state = 3, .external_lex_state = 2},
  [1146] = {.lex_state = 3, .external_lex_state = 2},
  [1147] = {.lex_state = 3, .external_lex_state = 2},
  [1148] = {.lex_state = 3, .external_lex_state = 2},
  [1149] = {.lex_state = 3, .external_lex_state = 3},
  [1150] = {.lex_state = 3, .external_lex_state = 2},
  [1151] = {.lex_state = 94},
  [1152] = {.lex_state = 3, .external_lex_state = 3},
  [1153] = {.lex_state = 3, .external_lex_state = 2},
  [1154] = {.lex_state = 3, .external_lex_state = 3},
  [1155] = {.lex_state = 3, .external_lex_state = 3},
  [1156] = {.lex_state = 3, .external_lex_state = 2},
  [1157] = {.lex_state = 3, .external_lex_state = 2},
  [1158] = {.lex_state = 3, .external_lex_state = 2},
  [1159] = {.lex_state = 3, .external_lex_state = 3},
  [1160] = {.lex_state = 3, .external_lex_state = 2},
  [1161] = {.lex_state = 3, .external_lex_state = 2},
  [1162] = {.lex_state = 3, .external_lex_state = 3},
  [1163] = {.lex_state = 3, .external_lex_state = 2},
  [1164] = {.lex_state = 3, .external_lex_state = 3},
  [1165] = {.lex_state = 6, .external_lex_state = 2},
  [1166] = {.lex_state = 3, .external_lex_state = 2},
  [1167] = {.lex_state = 3, .external_lex_state = 2},
  [1168] = {.lex_state = 94},
  [1169] = {.lex_state = 94},
  [1170] = {.lex_state = 3, .external_lex_state = 3},
  [1171] = {.lex_state = 94},
  [1172] = {.lex_state = 3, .external_lex_state = 2},
  [1173] = {.lex_state = 3, .external_lex_state = 2},
  [1174] = {.lex_state = 3, .external_lex_state = 2},
  [1175] = {.lex_state = 3, .external_lex_state = 2},
  [1176] = {.lex_state = 3, .external_lex_state = 3},
  [1177] = {.lex_state = 3, .external_lex_state = 2},
  [1178] = {.lex_state = 3, .external_lex_state = 2},
  [1179] = {.lex_state = 94},
  [1180] = {.lex_state = 3, .external_lex_state = 2},
  [1181] = {.lex_state = 3, .external_lex_state = 2},
  [1182] = {.lex_state = 94},
  [1183] = {.lex_state = 3, .external_lex_state = 2},
  [1184] = {.lex_state = 3, .external_lex_state = 2},
  [1185] = {.lex_state = 3, .external_lex_state = 2},
  [1186] = {.lex_state = 3, .external_lex_state = 2},
  [1187] = {.lex_state = 3, .external_lex_state = 2},
  [1188] = {.lex_state = 12},
  [1189] = {.lex_state = 12},
  [1190] = {.lex_state = 12},
  [1191] = {.lex_state = 12},
  [1192] = {.lex_state = 12},
  [1193] = {.lex_state = 12},
  [1194] = {.lex_state = 12},
  [1195] = {.lex_state = 11, .external_lex_state = 4},
  [1196] = {.lex_state = 12},
  [1197] = {.lex_state = 11, .external_lex_state = 4},
  [1198] = {.lex_state = 12},
  [1199] = {.lex_state = 12},
  [1200] = {.lex_state = 7, .external_lex_state = 3},
  [1201] = {.lex_state = 12},
  [1202] = {.lex_state = 12},
  [1203] = {.lex_state = 12},
  [1204] = {.lex_state = 12},
  [1205] = {.lex_state = 12},
  [1206] = {.lex_state = 11, .external_lex_state = 4},
  [1207] = {.lex_state = 12},
  [1208] = {.lex_state = 11, .external_lex_state = 4},
  [1209] = {.lex_state = 12},
  [1210] = {.lex_state = 12},
  [1211] = {.lex_state = 12},
  [1212] = {.lex_state = 11, .external_lex_state = 4},
  [1213] = {.lex_state = 12},
  [1214] = {.lex_state = 12},
  [1215] = {.lex_state = 12},
  [1216] = {.lex_state = 12},
  [1217] = {.lex_state = 12},
  [1218] = {.lex_state = 12},
  [1219] = {.lex_state = 11, .external_lex_state = 4},
  [1220] = {.lex_state = 12},
  [1221] = {.lex_state = 12},
  [1222] = {.lex_state = 12},
  [1223] = {.lex_state = 7, .external_lex_state = 3},
  [1224] = {.lex_state = 12},
  [1225] = {.lex_state = 12},
  [1226] = {.lex_state = 7, .external_lex_state = 3},
  [1227] = {.lex_state = 11, .external_lex_state = 4},
  [1228] = {.lex_state = 12},
  [1229] = {.lex_state = 7, .external_lex_state = 2},
  [1230] = {.lex_state = 7, .external_lex_state = 2},
  [1231] = {.lex_state = 94},
  [1232] = {.lex_state = 7, .external_lex_state = 2},
  [1233] = {.lex_state = 94},
  [1234] = {.lex_state = 7, .external_lex_state = 3},
  [1235] = {.lex_state = 7, .external_lex_state = 2},
  [1236] = {.lex_state = 7, .external_lex_state = 2},
  [1237] = {.lex_state = 94},
  [1238] = {.lex_state = 7, .external_lex_state = 2},
  [1239] = {.lex_state = 7, .external_lex_state = 2},
  [1240] = {.lex_state = 94},
  [1241] = {.lex_state = 7, .external_lex_state = 3},
  [1242] = {.lex_state = 94},
  [1243] = {.lex_state = 7, .external_lex_state = 2},
  [1244] = {.lex_state = 7, .external_lex_state = 3},
  [1245] = {.lex_state = 94},
  [1246] = {.lex_state = 94},
  [1247] = {.lex_state = 7, .external_lex_state = 2},
  [1248] = {.lex_state = 7, .external_lex_state = 2},
  [1249] = {.lex_state = 7, .external_lex_state = 2},
  [1250] = {.lex_state = 7, .external_lex_state = 2},
  [1251] = {.lex_state = 7, .external_lex_state = 2},
  [1252] = {.lex_state = 7, .external_lex_state = 2},
  [1253] = {.lex_state = 7, .external_lex_state = 3},
  [1254] = {.lex_state = 7, .external_lex_state = 2},
  [1255] = {.lex_state = 7, .external_lex_state = 2},
  [1256] = {.lex_state = 7, .external_lex_state = 2},
  [1257] = {.lex_state = 7, .external_lex_state = 2},
  [1258] = {.lex_state = 7, .external_lex_state = 2},
  [1259] = {.lex_state = 7, .external_lex_state = 2},
  [1260] = {.lex_state = 7, .external_lex_state = 2},
  [1261] = {.lex_state = 7, .external_lex_state = 2},
  [1262] = {.lex_state = 7, .external_lex_state = 2},
  [1263] = {.lex_state = 7, .external_lex_state = 2},
  [1264] = {.lex_state = 7, .external_lex_state = 2},
  [1265] = {.lex_state = 7, .external_lex_state = 2},
  [1266] = {.lex_state = 7, .external_lex_state = 2},
  [1267] = {.lex_state = 7, .external_lex_state = 2},
  [1268] = {.lex_state = 7, .external_lex_state = 2},
  [1269] = {.lex_state = 7, .external_lex_state = 2},
  [1270] = {.lex_state = 7, .external_lex_state = 2},
  [1271] = {.lex_state = 7, .external_lex_state = 2},
  [1272] = {.lex_state = 7, .external_lex_state = 2},
  [1273] = {.lex_state = 7, .external_lex_state = 2},
  [1274] = {.lex_state = 7, .external_lex_state = 2},
  [1275] = {.lex_state = 7, .external_lex_state = 2},
  [1276] = {.lex_state = 7, .external_lex_state = 2},
  [1277] = {.lex_state = 7, .external_lex_state = 2},
  [1278] = {.lex_state = 7, .external_lex_state = 2},
  [1279] = {.lex_state = 7, .external_lex_state = 3},
  [1280] = {.lex_state = 7, .external_lex_state = 2},
  [1281] = {.lex_state = 7, .external_lex_state = 2},
  [1282] = {.lex_state = 7, .external_lex_state = 2},
  [1283] = {.lex_state = 7, .external_lex_state = 2},
  [1284] = {.lex_state = 7, .external_lex_state = 2},
  [1285] = {.lex_state = 7, .external_lex_state = 2},
  [1286] = {.lex_state = 7, .external_lex_state = 2},
  [1287] = {.lex_state = 7, .external_lex_state = 2},
  [1288] = {.lex_state = 7, .external_lex_state = 2},
  [1289] = {.lex_state = 7, .external_lex_state = 2},
  [1290] = {.lex_state = 7, .external_lex_state = 2},
  [1291] = {.lex_state = 7, .external_lex_state = 2},
  [1292] = {.lex_state = 7, .external_lex_state = 2},
  [1293] = {.lex_state = 7, .external_lex_state = 2},
  [1294] = {.lex_state = 7, .external_lex_state = 2},
  [1295] = {.lex_state = 7, .external_lex_state = 2},
  [1296] = {.lex_state = 7, .external_lex_state = 2},
  [1297] = {.lex_state = 7, .external_lex_state = 2},
  [1298] = {.lex_state = 7, .external_lex_state = 2},
  [1299] = {.lex_state = 7, .external_lex_state = 2},
  [1300] = {.lex_state = 7, .external_lex_state = 2},
  [1301] = {.lex_state = 7, .external_lex_state = 2},
  [1302] = {.lex_state = 7, .external_lex_state = 2},
  [1303] = {.lex_state = 7, .external_lex_state = 2},
  [1304] = {.lex_state = 7, .external_lex_state = 2},
  [1305] = {.lex_state = 7, .external_lex_state = 2},
  [1306] = {.lex_state = 7, .external_lex_state = 2},
  [1307] = {.lex_state = 7, .external_lex_state = 2},
  [1308] = {.lex_state = 7, .external_lex_state = 2},
  [1309] = {.lex_state = 7, .external_lex_state = 2},
  [1310] = {.lex_state = 7, .external_lex_state = 2},
  [1311] = {.lex_state = 7, .external_lex_state = 2},
  [1312] = {.lex_state = 7, .external_lex_state = 2},
  [1313] = {.lex_state = 7, .external_lex_state = 2},
  [1314] = {.lex_state = 7, .external_lex_state = 2},
  [1315] = {.lex_state = 7, .external_lex_state = 2},
  [1316] = {.lex_state = 7, .external_lex_state = 3},
  [1317] = {.lex_state = 7, .external_lex_state = 2},
  [1318] = {.lex_state = 7, .external_lex_state = 2},
  [1319] = {.lex_state = 7, .external_lex_state = 2},
  [1320] = {.lex_state = 7, .external_lex_state = 2},
  [1321] = {.lex_state = 7, .external_lex_state = 2},
  [1322] = {.lex_state = 7, .external_lex_state = 2},
  [1323] = {.lex_state = 7, .external_lex_state = 2},
  [1324] = {.lex_state = 7, .external_lex_state = 2},
  [1325] = {.lex_state = 7, .external_lex_state = 2},
  [1326] = {.lex_state = 7, .external_lex_state = 2},
  [1327] = {.lex_state = 7, .external_lex_state = 2},
  [1328] = {.lex_state = 7, .external_lex_state = 2},
  [1329] = {.lex_state = 7, .external_lex_state = 2},
  [1330] = {.lex_state = 7, .external_lex_state = 2},
  [1331] = {.lex_state = 7, .external_lex_state = 2},
  [1332] = {.lex_state = 7, .external_lex_state = 2},
  [1333] = {.lex_state = 7, .external_lex_state = 2},
  [1334] = {.lex_state = 7, .external_lex_state = 2},
  [1335] = {.lex_state = 7, .external_lex_state = 2},
  [1336] = {.lex_state = 7, .external_lex_state = 2},
  [1337] = {.lex_state = 7, .external_lex_state = 2},
  [1338] = {.lex_state = 7, .external_lex_state = 2},
  [1339] = {.lex_state = 7, .external_lex_state = 2},
  [1340] = {.lex_state = 7, .external_lex_state = 2},
  [1341] = {.lex_state = 7, .external_lex_state = 2},
  [1342] = {.lex_state = 7, .external_lex_state = 2},
  [1343] = {.lex_state = 7, .external_lex_state = 2},
  [1344] = {.lex_state = 7, .external_lex_state = 2},
  [1345] = {.lex_state = 7, .external_lex_state = 2},
  [1346] = {.lex_state = 7, .external_lex_state = 2},
  [1347] = {.lex_state = 7, .external_lex_state = 2},
  [1348] = {.lex_state = 7, .external_lex_state = 2},
  [1349] = {.lex_state = 7, .external_lex_state = 2},
  [1350] = {.lex_state = 7, .external_lex_state = 2},
  [1351] = {.lex_state = 7, .external_lex_state = 2},
  [1352] = {.lex_state = 7, .external_lex_state = 2},
  [1353] = {.lex_state = 7, .external_lex_state = 2},
  [1354] = {.lex_state = 7, .external_lex_state = 2},
  [1355] = {.lex_state = 7, .external_lex_state = 2},
  [1356] = {.lex_state = 7, .external_lex_state = 2},
  [1357] = {.lex_state = 7, .external_lex_state = 2},
  [1358] = {.lex_state = 7, .external_lex_state = 2},
  [1359] = {.lex_state = 7, .external_lex_state = 2},
  [1360] = {.lex_state = 7, .external_lex_state = 2},
  [1361] = {.lex_state = 7, .external_lex_state = 2},
  [1362] = {.lex_state = 7, .external_lex_state = 2},
  [1363] = {.lex_state = 7, .external_lex_state = 2},
  [1364] = {.lex_state = 7, .external_lex_state = 2},
  [1365] = {.lex_state = 7, .external_lex_state = 2},
  [1366] = {.lex_state = 7, .external_lex_state = 2},
  [1367] = {.lex_state = 7, .external_lex_state = 2},
  [1368] = {.lex_state = 7, .external_lex_state = 2},
  [1369] = {.lex_state = 7, .external_lex_state = 2},
  [1370] = {.lex_state = 7, .external_lex_state = 2},
  [1371] = {.lex_state = 7, .external_lex_state = 2},
  [1372] = {.lex_state = 7, .external_lex_state = 2},
  [1373] = {.lex_state = 7, .external_lex_state = 2},
  [1374] = {.lex_state = 7, .external_lex_state = 2},
  [1375] = {.lex_state = 7, .external_lex_state = 2},
  [1376] = {.lex_state = 7, .external_lex_state = 2},
  [1377] = {.lex_state = 7, .external_lex_state = 2},
  [1378] = {.lex_state = 7, .external_lex_state = 2},
  [1379] = {.lex_state = 7, .external_lex_state = 2},
  [1380] = {.lex_state = 7, .external_lex_state = 2},
  [1381] = {.lex_state = 7, .external_lex_state = 2},
  [1382] = {.lex_state = 7, .external_lex_state = 3},
  [1383] = {.lex_state = 7, .external_lex_state = 3},
  [1384] = {.lex_state = 7, .external_lex_state = 2},
  [1385] = {.lex_state = 7, .external_lex_state = 2},
  [1386] = {.lex_state = 7, .external_lex_state = 3},
  [1387] = {.lex_state = 7, .external_lex_state = 3},
  [1388] = {.lex_state = 7, .external_lex_state = 2},
  [1389] = {.lex_state = 7, .external_lex_state = 3},
  [1390] = {.lex_state = 7, .external_lex_state = 2},
  [1391] = {.lex_state = 7, .external_lex_state = 3},
  [1392] = {.lex_state = 7, .external_lex_state = 3},
  [1393] = {.lex_state = 7, .external_lex_state = 3},
  [1394] = {.lex_state = 7, .external_lex_state = 3},
  [1395] = {.lex_state = 7, .external_lex_state = 3},
  [1396] = {.lex_state = 7, .external_lex_state = 2},
  [1397] = {.lex_state = 7, .external_lex_state = 3},
  [1398] = {.lex_state = 7, .external_lex_state = 2},
  [1399] = {.lex_state = 7, .external_lex_state = 3},
  [1400] = {.lex_state = 7, .external_lex_state = 3},
  [1401] = {.lex_state = 7, .external_lex_state = 3},
  [1402] = {.lex_state = 7, .external_lex_state = 2},
  [1403] = {.lex_state = 7, .external_lex_state = 3},
  [1404] = {.lex_state = 7, .external_lex_state = 2},
  [1405] = {.lex_state = 7, .external_lex_state = 3},
  [1406] = {.lex_state = 7, .external_lex_state = 2},
  [1407] = {.lex_state = 7, .external_lex_state = 3},
  [1408] = {.lex_state = 7, .external_lex_state = 3},
  [1409] = {.lex_state = 7, .external_lex_state = 3},
  [1410] = {.lex_state = 7, .external_lex_state = 2},
  [1411] = {.lex_state = 7, .external_lex_state = 3},
  [1412] = {.lex_state = 7, .external_lex_state = 3},
  [1413] = {.lex_state = 7, .external_lex_state = 3},
  [1414] = {.lex_state = 7, .external_lex_state = 2},
  [1415] = {.lex_state = 7, .external_lex_state = 3},
  [1416] = {.lex_state = 7, .external_lex_state = 3},
  [1417] = {.lex_state = 7, .external_lex_state = 2},
  [1418] = {.lex_state = 7, .external_lex_state = 2},
  [1419] = {.lex_state = 7, .external_lex_state = 3},
  [1420] = {.lex_state = 7, .external_lex_state = 3},
  [1421] = {.lex_state = 7, .external_lex_state = 3},
  [1422] = {.lex_state = 7, .external_lex_state = 3},
  [1423] = {.lex_state = 7, .external_lex_state = 3},
  [1424] = {.lex_state = 7, .external_lex_state = 2},
  [1425] = {.lex_state = 7, .external_lex_state = 2},
  [1426] = {.lex_state = 7, .external_lex_state = 3},
  [1427] = {.lex_state = 7, .external_lex_state = 3},
  [1428] = {.lex_state = 7, .external_lex_state = 2},
  [1429] = {.lex_state = 7, .external_lex_state = 3},
  [1430] = {.lex_state = 7, .external_lex_state = 3},
  [1431] = {.lex_state = 7, .external_lex_state = 2},
  [1432] = {.lex_state = 7, .external_lex_state = 2},
  [1433] = {.lex_state = 7, .external_lex_state = 2},
  [1434] = {.lex_state = 7, .external_lex_state = 3},
  [1435] = {.lex_state = 7, .external_lex_state = 3},
  [1436] = {.lex_state = 7, .external_lex_state = 2},
  [1437] = {.lex_state = 7, .external_lex_state = 2},
  [1438] = {.lex_state = 7, .external_lex_state = 3},
  [1439] = {.lex_state = 7, .external_lex_state = 2},
  [1440] = {.lex_state = 7, .external_lex_state = 3},
  [1441] = {.lex_state = 7, .external_lex_state = 3},
  [1442] = {.lex_state = 7, .external_lex_state = 2},
  [1443] = {.lex_state = 7, .external_lex_state = 3},
  [1444] = {.lex_state = 7, .external_lex_state = 3},
  [1445] = {.lex_state = 7, .external_lex_state = 3},
  [1446] = {.lex_state = 7, .external_lex_state = 2},
  [1447] = {.lex_state = 7, .external_lex_state = 2},
  [1448] = {.lex_state = 7, .external_lex_state = 2},
  [1449] = {.lex_state = 7, .external_lex_state = 2},
  [1450] = {.lex_state = 7, .external_lex_state = 2},
  [1451] = {.lex_state = 7, .external_lex_state = 2},
  [1452] = {.lex_state = 7, .external_lex_state = 2},
  [1453] = {.lex_state = 7, .external_lex_state = 2},
  [1454] = {.lex_state = 7, .external_lex_state = 3},
  [1455] = {.lex_state = 7, .external_lex_state = 2},
  [1456] = {.lex_state = 7, .external_lex_state = 2},
  [1457] = {.lex_state = 7, .external_lex_state = 2},
  [1458] = {.lex_state = 7, .external_lex_state = 2},
  [1459] = {.lex_state = 7, .external_lex_state = 2},
  [1460] = {.lex_state = 7, .external_lex_state = 2},
  [1461] = {.lex_state = 7, .external_lex_state = 2},
  [1462] = {.lex_state = 7, .external_lex_state = 2},
  [1463] = {.lex_state = 7, .external_lex_state = 2},
  [1464] = {.lex_state = 7, .external_lex_state = 2},
  [1465] = {.lex_state = 7, .external_lex_state = 2},
  [1466] = {.lex_state = 7, .external_lex_state = 3},
  [1467] = {.lex_state = 7, .external_lex_state = 2},
  [1468] = {.lex_state = 7, .external_lex_state = 2},
  [1469] = {.lex_state = 7, .external_lex_state = 2},
  [1470] = {.lex_state = 7, .external_lex_state = 2},
  [1471] = {.lex_state = 7, .external_lex_state = 2},
  [1472] = {.lex_state = 7, .external_lex_state = 3},
  [1473] = {.lex_state = 7, .external_lex_state = 2},
  [1474] = {.lex_state = 7, .external_lex_state = 3},
  [1475] = {.lex_state = 7, .external_lex_state = 3},
  [1476] = {.lex_state = 7, .external_lex_state = 3},
  [1477] = {.lex_state = 7, .external_lex_state = 2},
  [1478] = {.lex_state = 7, .external_lex_state = 2},
  [1479] = {.lex_state = 7, .external_lex_state = 3},
  [1480] = {.lex_state = 94},
  [1481] = {.lex_state = 7, .external_lex_state = 3},
  [1482] = {.lex_state = 7, .external_lex_state = 2},
  [1483] = {.lex_state = 7, .external_lex_state = 2},
  [1484] = {.lex_state = 7, .external_lex_state = 2},
  [1485] = {.lex_state = 7, .external_lex_state = 2},
  [1486] = {.lex_state = 7, .external_lex_state = 2},
  [1487] = {.lex_state = 7, .external_lex_state = 2},
  [1488] = {.lex_state = 7, .external_lex_state = 3},
  [1489] = {.lex_state = 7, .external_lex_state = 2},
  [1490] = {.lex_state = 7, .external_lex_state = 2},
  [1491] = {.lex_state = 7, .external_lex_state = 3},
  [1492] = {.lex_state = 7, .external_lex_state = 2},
  [1493] = {.lex_state = 7, .external_lex_state = 3},
  [1494] = {.lex_state = 7, .external_lex_state = 2},
  [1495] = {.lex_state = 7, .external_lex_state = 3},
  [1496] = {.lex_state = 7, .external_lex_state = 2},
  [1497] = {.lex_state = 7, .external_lex_state = 3},
  [1498] = {.lex_state = 7, .external_lex_state = 2},
  [1499] = {.lex_state = 7, .external_lex_state = 2},
  [1500] = {.lex_state = 7, .external_lex_state = 3},
  [1501] = {.lex_state = 7, .external_lex_state = 3},
  [1502] = {.lex_state = 7, .external_lex_state = 2},
  [1503] = {.lex_state = 7, .external_lex_state = 3},
  [1504] = {.lex_state = 7, .external_lex_state = 2},
  [1505] = {.lex_state = 7, .external_lex_state = 3},
  [1506] = {.lex_state = 7, .external_lex_state = 3},
  [1507] = {.lex_state = 7, .external_lex_state = 3},
  [1508] = {.lex_state = 7, .external_lex_state = 3},
  [1509] = {.lex_state = 7, .external_lex_state = 3},
  [1510] = {.lex_state = 7, .external_lex_state = 2},
  [1511] = {.lex_state = 7, .external_lex_state = 2},
  [1512] = {.lex_state = 7, .external_lex_state = 2},
  [1513] = {.lex_state = 7, .external_lex_state = 2},
  [1514] = {.lex_state = 7, .external_lex_state = 3},
  [1515] = {.lex_state = 7, .external_lex_state = 2},
  [1516] = {.lex_state = 7, .external_lex_state = 2},
  [1517] = {.lex_state = 7, .external_lex_state = 2},
  [1518] = {.lex_state = 7, .external_lex_state = 2},
  [1519] = {.lex_state = 7, .external_lex_state = 2},
  [1520] = {.lex_state = 7, .external_lex_state = 2},
  [1521] = {.lex_state = 7, .external_lex_state = 2},
  [1522] = {.lex_state = 7, .external_lex_state = 2},
  [1523] = {.lex_state = 7, .external_lex_state = 3},
  [1524] = {.lex_state = 7, .external_lex_state = 3},
  [1525] = {.lex_state = 7, .external_lex_state = 3},
  [1526] = {.lex_state = 7, .external_lex_state = 3},
  [1527] = {.lex_state = 7, .external_lex_state = 2},
  [1528] = {.lex_state = 7, .external_lex_state = 2},
  [1529] = {.lex_state = 7, .external_lex_state = 2},
  [1530] = {.lex_state = 7, .external_lex_state = 2},
  [1531] = {.lex_state = 7, .external_lex_state = 2},
  [1532] = {.lex_state = 7, .external_lex_state = 2},
  [1533] = {.lex_state = 7, .external_lex_state = 3},
  [1534] = {.lex_state = 7, .external_lex_state = 3},
  [1535] = {.lex_state = 7, .external_lex_state = 3},
  [1536] = {.lex_state = 7, .external_lex_state = 2},
  [1537] = {.lex_state = 7, .external_lex_state = 2},
  [1538] = {.lex_state = 7, .external_lex_state = 3},
  [1539] = {.lex_state = 7, .external_lex_state = 3},
  [1540] = {.lex_state = 7, .external_lex_state = 3},
  [1541] = {.lex_state = 7, .external_lex_state = 2},
  [1542] = {.lex_state = 7, .external_lex_state = 2},
  [1543] = {.lex_state = 7, .external_lex_state = 2},
  [1544] = {.lex_state = 7, .external_lex_state = 2},
  [1545] = {.lex_state = 7, .external_lex_state = 2},
  [1546] = {.lex_state = 7, .external_lex_state = 2},
  [1547] = {.lex_state = 7, .external_lex_state = 2},
  [1548] = {.lex_state = 7, .external_lex_state = 2},
  [1549] = {.lex_state = 7, .external_lex_state = 2},
  [1550] = {.lex_state = 12},
  [1551] = {.lex_state = 7, .external_lex_state = 2},
  [1552] = {.lex_state = 7, .external_lex_state = 2},
  [1553] = {.lex_state = 7, .external_lex_state = 2},
  [1554] = {.lex_state = 7, .external_lex_state = 2},
  [1555] = {.lex_state = 7, .external_lex_state = 2},
  [1556] = {.lex_state = 7, .external_lex_state = 2},
  [1557] = {.lex_state = 7, .external_lex_state = 3},
  [1558] = {.lex_state = 7, .external_lex_state = 3},
  [1559] = {.lex_state = 7, .external_lex_state = 3},
  [1560] = {.lex_state = 7, .external_lex_state = 3},
  [1561] = {.lex_state = 12},
  [1562] = {.lex_state = 7, .external_lex_state = 3},
  [1563] = {.lex_state = 7, .external_lex_state = 2},
  [1564] = {.lex_state = 7, .external_lex_state = 2},
  [1565] = {.lex_state = 7, .external_lex_state = 2},
  [1566] = {.lex_state = 7, .external_lex_state = 3},
  [1567] = {.lex_state = 7, .external_lex_state = 3},
  [1568] = {.lex_state = 12},
  [1569] = {.lex_state = 7, .external_lex_state = 2},
  [1570] = {.lex_state = 7, .external_lex_state = 2},
  [1571] = {.lex_state = 12},
  [1572] = {.lex_state = 7, .external_lex_state = 3},
  [1573] = {.lex_state = 12},
  [1574] = {.lex_state = 7, .external_lex_state = 2},
  [1575] = {.lex_state = 7, .external_lex_state = 2},
  [1576] = {.lex_state = 7, .external_lex_state = 3},
  [1577] = {.lex_state = 7, .external_lex_state = 2},
  [1578] = {.lex_state = 7, .external_lex_state = 2},
  [1579] = {.lex_state = 7, .external_lex_state = 2},
  [1580] = {.lex_state = 7, .external_lex_state = 2},
  [1581] = {.lex_state = 7, .external_lex_state = 3},
  [1582] = {.lex_state = 12},
  [1583] = {.lex_state = 7, .external_lex_state = 2},
  [1584] = {.lex_state = 7, .external_lex_state = 2},
  [1585] = {.lex_state = 7, .external_lex_state = 2},
  [1586] = {.lex_state = 12},
  [1587] = {.lex_state = 7, .external_lex_state = 2},
  [1588] = {.lex_state = 7, .external_lex_state = 2},
  [1589] = {.lex_state = 7, .external_lex_state = 2},
  [1590] = {.lex_state = 7, .external_lex_state = 2},
  [1591] = {.lex_state = 7, .external_lex_state = 2},
  [1592] = {.lex_state = 7, .external_lex_state = 2},
  [1593] = {.lex_state = 7, .external_lex_state = 2},
  [1594] = {.lex_state = 7, .external_lex_state = 2},
  [1595] = {.lex_state = 7, .external_lex_state = 2},
  [1596] = {.lex_state = 7, .external_lex_state = 2},
  [1597] = {.lex_state = 7, .external_lex_state = 2},
  [1598] = {.lex_state = 7, .external_lex_state = 2},
  [1599] = {.lex_state = 7, .external_lex_state = 2},
  [1600] = {.lex_state = 7, .external_lex_state = 2},
  [1601] = {.lex_state = 7, .external_lex_state = 2},
  [1602] = {.lex_state = 7, .external_lex_state = 2},
  [1603] = {.lex_state = 7, .external_lex_state = 2},
  [1604] = {.lex_state = 7, .external_lex_state = 2},
  [1605] = {.lex_state = 7, .external_lex_state = 2},
  [1606] = {.lex_state = 7, .external_lex_state = 2},
  [1607] = {.lex_state = 7, .external_lex_state = 2},
  [1608] = {.lex_state = 12},
  [1609] = {.lex_state = 7, .external_lex_state = 3},
  [1610] = {.lex_state = 7, .external_lex_state = 2},
  [1611] = {.lex_state = 7, .external_lex_state = 2},
  [1612] = {.lex_state = 7, .external_lex_state = 2},
  [1613] = {.lex_state = 7, .external_lex_state = 2},
  [1614] = {.lex_state = 7, .external_lex_state = 2},
  [1615] = {.lex_state = 7, .external_lex_state = 3},
  [1616] = {.lex_state = 7, .external_lex_state = 2},
  [1617] = {.lex_state = 12},
  [1618] = {.lex_state = 12},
  [1619] = {.lex_state = 7, .external_lex_state = 2},
  [1620] = {.lex_state = 7, .external_lex_state = 3},
  [1621] = {.lex_state = 7, .external_lex_state = 2},
  [1622] = {.lex_state = 7, .external_lex_state = 2},
  [1623] = {.lex_state = 7, .external_lex_state = 2},
  [1624] = {.lex_state = 7, .external_lex_state = 3},
  [1625] = {.lex_state = 12},
  [1626] = {.lex_state = 7, .external_lex_state = 2},
  [1627] = {.lex_state = 7, .external_lex_state = 2},
  [1628] = {.lex_state = 7, .external_lex_state = 2},
  [1629] = {.lex_state = 7, .external_lex_state = 2},
  [1630] = {.lex_state = 7, .external_lex_state = 2},
  [1631] = {.lex_state = 7, .external_lex_state = 2},
  [1632] = {.lex_state = 7, .external_lex_state = 2},
  [1633] = {.lex_state = 7, .external_lex_state = 2},
  [1634] = {.lex_state = 7, .external_lex_state = 2},
  [1635] = {.lex_state = 7, .external_lex_state = 2},
  [1636] = {.lex_state = 7, .external_lex_state = 2},
  [1637] = {.lex_state = 7, .external_lex_state = 2},
  [1638] = {.lex_state = 7, .external_lex_state = 2},
  [1639] = {.lex_state = 7, .external_lex_state = 3},
  [1640] = {.lex_state = 7, .external_lex_state = 3},
  [1641] = {.lex_state = 7, .external_lex_state = 2},
  [1642] = {.lex_state = 7, .external_lex_state = 2},
  [1643] = {.lex_state = 7, .external_lex_state = 2},
  [1644] = {.lex_state = 7, .external_lex_state = 2},
  [1645] = {.lex_state = 7, .external_lex_state = 3},
  [1646] = {.lex_state = 7, .external_lex_state = 3},
  [1647] = {.lex_state = 7, .external_lex_state = 3},
  [1648] = {.lex_state = 7, .external_lex_state = 3},
  [1649] = {.lex_state = 7, .external_lex_state = 3},
  [1650] = {.lex_state = 7, .external_lex_state = 3},
  [1651] = {.lex_state = 7, .external_lex_state = 3},
  [1652] = {.lex_state = 7, .external_lex_state = 2},
  [1653] = {.lex_state = 7, .external_lex_state = 2},
  [1654] = {.lex_state = 7, .external_lex_state = 3},
  [1655] = {.lex_state = 7, .external_lex_state = 3},
  [1656] = {.lex_state = 7, .external_lex_state = 3},
  [1657] = {.lex_state = 7, .external_lex_state = 3},
  [1658] = {.lex_state = 7, .external_lex_state = 3},
  [1659] = {.lex_state = 7, .external_lex_state = 3},
  [1660] = {.lex_state = 7, .external_lex_state = 3},
  [1661] = {.lex_state = 7, .external_lex_state = 3},
  [1662] = {.lex_state = 7, .external_lex_state = 3},
  [1663] = {.lex_state = 7, .external_lex_state = 2},
  [1664] = {.lex_state = 7, .external_lex_state = 3},
  [1665] = {.lex_state = 7, .external_lex_state = 3},
  [1666] = {.lex_state = 7, .external_lex_state = 3},
  [1667] = {.lex_state = 7, .external_lex_state = 3},
  [1668] = {.lex_state = 7, .external_lex_state = 3},
  [1669] = {.lex_state = 7, .external_lex_state = 3},
  [1670] = {.lex_state = 7, .external_lex_state = 3},
  [1671] = {.lex_state = 7, .external_lex_state = 3},
  [1672] = {.lex_state = 7, .external_lex_state = 3},
  [1673] = {.lex_state = 7, .external_lex_state = 3},
  [1674] = {.lex_state = 7, .external_lex_state = 3},
  [1675] = {.lex_state = 7, .external_lex_state = 3},
  [1676] = {.lex_state = 7, .external_lex_state = 3},
  [1677] = {.lex_state = 7, .external_lex_state = 3},
  [1678] = {.lex_state = 7, .external_lex_state = 3},
  [1679] = {.lex_state = 7, .external_lex_state = 3},
  [1680] = {.lex_state = 7, .external_lex_state = 3},
  [1681] = {.lex_state = 7, .external_lex_state = 3},
  [1682] = {.lex_state = 7, .external_lex_state = 2},
  [1683] = {.lex_state = 7, .external_lex_state = 3},
  [1684] = {.lex_state = 7, .external_lex_state = 2},
  [1685] = {.lex_state = 7, .external_lex_state = 2},
  [1686] = {.lex_state = 7, .external_lex_state = 2},
  [1687] = {.lex_state = 7, .external_lex_state = 2},
  [1688] = {.lex_state = 7, .external_lex_state = 2},
  [1689] = {.lex_state = 7, .external_lex_state = 2},
  [1690] = {.lex_state = 7, .external_lex_state = 3},
  [1691] = {.lex_state = 7, .external_lex_state = 2},
  [1692] = {.lex_state = 7, .external_lex_state = 3},
  [1693] = {.lex_state = 12, .external_lex_state = 4},
  [1694] = {.lex_state = 7, .external_lex_state = 2},
  [1695] = {.lex_state = 7, .external_lex_state = 2},
  [1696] = {.lex_state = 7, .external_lex_state = 3},
  [1697] = {.lex_state = 7, .external_lex_state = 3},
  [1698] = {.lex_state = 7, .external_lex_state = 3},
  [1699] = {.lex_state = 7, .external_lex_state = 3},
  [1700] = {.lex_state = 7, .external_lex_state = 3},
  [1701] = {.lex_state = 7, .external_lex_state = 2},
  [1702] = {.lex_state = 7, .external_lex_state = 3},
  [1703] = {.lex_state = 7, .external_lex_state = 3},
  [1704] = {.lex_state = 7, .external_lex_state = 3},
  [1705] = {.lex_state = 7, .external_lex_state = 3},
  [1706] = {.lex_state = 7, .external_lex_state = 3},
  [1707] = {.lex_state = 7, .external_lex_state = 3},
  [1708] = {.lex_state = 7, .external_lex_state = 3},
  [1709] = {.lex_state = 7, .external_lex_state = 3},
  [1710] = {.lex_state = 7, .external_lex_state = 3},
  [1711] = {.lex_state = 7, .external_lex_state = 3},
  [1712] = {.lex_state = 7, .external_lex_state = 3},
  [1713] = {.lex_state = 7, .external_lex_state = 3},
  [1714] = {.lex_state = 7, .external_lex_state = 3},
  [1715] = {.lex_state = 7, .external_lex_state = 3},
  [1716] = {.lex_state = 7, .external_lex_state = 3},
  [1717] = {.lex_state = 7, .external_lex_state = 3},
  [1718] = {.lex_state = 7, .external_lex_state = 3},
  [1719] = {.lex_state = 7, .external_lex_state = 3},
  [1720] = {.lex_state = 7, .external_lex_state = 2},
  [1721] = {.lex_state = 7, .external_lex_state = 3},
  [1722] = {.lex_state = 7, .external_lex_state = 2},
  [1723] = {.lex_state = 7, .external_lex_state = 2},
  [1724] = {.lex_state = 7, .external_lex_state = 3},
  [1725] = {.lex_state = 7, .external_lex_state = 3},
  [1726] = {.lex_state = 7, .external_lex_state = 3},
  [1727] = {.lex_state = 7, .external_lex_state = 3},
  [1728] = {.lex_state = 7, .external_lex_state = 3},
  [1729] = {.lex_state = 7, .external_lex_state = 3},
  [1730] = {.lex_state = 7, .external_lex_state = 3},
  [1731] = {.lex_state = 7, .external_lex_state = 3},
  [1732] = {.lex_state = 7, .external_lex_state = 3},
  [1733] = {.lex_state = 7, .external_lex_state = 3},
  [1734] = {.lex_state = 7, .external_lex_state = 3},
  [1735] = {.lex_state = 7, .external_lex_state = 3},
  [1736] = {.lex_state = 7, .external_lex_state = 3},
  [1737] = {.lex_state = 7, .external_lex_state = 3},
  [1738] = {.lex_state = 7, .external_lex_state = 3},
  [1739] = {.lex_state = 7, .external_lex_state = 3},
  [1740] = {.lex_state = 7, .external_lex_state = 3},
  [1741] = {.lex_state = 7, .external_lex_state = 3},
  [1742] = {.lex_state = 7, .external_lex_state = 3},
  [1743] = {.lex_state = 7, .external_lex_state = 3},
  [1744] = {.lex_state = 7, .external_lex_state = 2},
  [1745] = {.lex_state = 7, .external_lex_state = 3},
  [1746] = {.lex_state = 7, .external_lex_state = 3},
  [1747] = {.lex_state = 7, .external_lex_state = 3},
  [1748] = {.lex_state = 7, .external_lex_state = 3},
  [1749] = {.lex_state = 7, .external_lex_state = 3},
  [1750] = {.lex_state = 7, .external_lex_state = 3},
  [1751] = {.lex_state = 7, .external_lex_state = 2},
  [1752] = {.lex_state = 7, .external_lex_state = 2},
  [1753] = {.lex_state = 12, .external_lex_state = 4},
  [1754] = {.lex_state = 7, .external_lex_state = 3},
  [1755] = {.lex_state = 12, .external_lex_state = 4},
  [1756] = {.lex_state = 7, .external_lex_state = 3},
  [1757] = {.lex_state = 12, .external_lex_state = 4},
  [1758] = {.lex_state = 7, .external_lex_state = 3},
  [1759] = {.lex_state = 7, .external_lex_state = 3},
  [1760] = {.lex_state = 7, .external_lex_state = 2},
  [1761] = {.lex_state = 7, .external_lex_state = 3},
  [1762] = {.lex_state = 7, .external_lex_state = 3},
  [1763] = {.lex_state = 7, .external_lex_state = 3},
  [1764] = {.lex_state = 7, .external_lex_state = 2},
  [1765] = {.lex_state = 7, .external_lex_state = 3},
  [1766] = {.lex_state = 7, .external_lex_state = 3},
  [1767] = {.lex_state = 7, .external_lex_state = 2},
  [1768] = {.lex_state = 7, .external_lex_state = 3},
  [1769] = {.lex_state = 7, .external_lex_state = 3},
  [1770] = {.lex_state = 12, .external_lex_state = 4},
  [1771] = {.lex_state = 7, .external_lex_state = 3},
  [1772] = {.lex_state = 7, .external_lex_state = 3},
  [1773] = {.lex_state = 7, .external_lex_state = 3},
  [1774] = {.lex_state = 7, .external_lex_state = 2},
  [1775] = {.lex_state = 7, .external_lex_state = 3},
  [1776] = {.lex_state = 7, .external_lex_state = 2},
  [1777] = {.lex_state = 7, .external_lex_state = 3},
  [1778] = {.lex_state = 7, .external_lex_state = 2},
  [1779] = {.lex_state = 7, .external_lex_state = 3},
  [1780] = {.lex_state = 7, .external_lex_state = 2},
  [1781] = {.lex_state = 7, .external_lex_state = 3},
  [1782] = {.lex_state = 7, .external_lex_state = 3},
  [1783] = {.lex_state = 7, .external_lex_state = 3},
  [1784] = {.lex_state = 7, .external_lex_state = 3},
  [1785] = {.lex_state = 7, .external_lex_state = 3},
  [1786] = {.lex_state = 7, .external_lex_state = 3},
  [1787] = {.lex_state = 7, .external_lex_state = 3},
  [1788] = {.lex_state = 7, .external_lex_state = 3},
  [1789] = {.lex_state = 7, .external_lex_state = 3},
  [1790] = {.lex_state = 7, .external_lex_state = 3},
  [1791] = {.lex_state = 7, .external_lex_state = 2},
  [1792] = {.lex_state = 7, .external_lex_state = 3},
  [1793] = {.lex_state = 7, .external_lex_state = 3},
  [1794] = {.lex_state = 7, .external_lex_state = 2},
  [1795] = {.lex_state = 7, .external_lex_state = 3},
  [1796] = {.lex_state = 7, .external_lex_state = 3},
  [1797] = {.lex_state = 7, .external_lex_state = 3},
  [1798] = {.lex_state = 8, .external_lex_state = 2},
  [1799] = {.lex_state = 7, .external_lex_state = 3},
  [1800] = {.lex_state = 7, .external_lex_state = 2},
  [1801] = {.lex_state = 7, .external_lex_state = 3},
  [1802] = {.lex_state = 7, .external_lex_state = 3},
  [1803] = {.lex_state = 7, .external_lex_state = 3},
  [1804] = {.lex_state = 7, .external_lex_state = 3},
  [1805] = {.lex_state = 7, .external_lex_state = 3},
  [1806] = {.lex_state = 7, .external_lex_state = 2},
  [1807] = {.lex_state = 7, .external_lex_state = 3},
  [1808] = {.lex_state = 7, .external_lex_state = 3},
  [1809] = {.lex_state = 7, .external_lex_state = 3},
  [1810] = {.lex_state = 7, .external_lex_state = 3},
  [1811] = {.lex_state = 7, .external_lex_state = 3},
  [1812] = {.lex_state = 7, .external_lex_state = 3},
  [1813] = {.lex_state = 7, .external_lex_state = 2},
  [1814] = {.lex_state = 7, .external_lex_state = 3},
  [1815] = {.lex_state = 7, .external_lex_state = 3},
  [1816] = {.lex_state = 7, .external_lex_state = 3},
  [1817] = {.lex_state = 7, .external_lex_state = 2},
  [1818] = {.lex_state = 7, .external_lex_state = 3},
  [1819] = {.lex_state = 7, .external_lex_state = 3},
  [1820] = {.lex_state = 7, .external_lex_state = 3},
  [1821] = {.lex_state = 7, .external_lex_state = 2},
  [1822] = {.lex_state = 7, .external_lex_state = 2},
  [1823] = {.lex_state = 7, .external_lex_state = 3},
  [1824] = {.lex_state = 7, .external_lex_state = 2},
  [1825] = {.lex_state = 7, .external_lex_state = 3},
  [1826] = {.lex_state = 7, .external_lex_state = 3},
  [1827] = {.lex_state = 7, .external_lex_state = 3},
  [1828] = {.lex_state = 7, .external_lex_state = 2},
  [1829] = {.lex_state = 7, .external_lex_state = 2},
  [1830] = {.lex_state = 7, .external_lex_state = 2},
  [1831] = {.lex_state = 7, .external_lex_state = 3},
  [1832] = {.lex_state = 12, .external_lex_state = 4},
  [1833] = {.lex_state = 7, .external_lex_state = 3},
  [1834] = {.lex_state = 7, .external_lex_state = 2},
  [1835] = {.lex_state = 7, .external_lex_state = 2},
  [1836] = {.lex_state = 7, .external_lex_state = 3},
  [1837] = {.lex_state = 7, .external_lex_state = 2},
  [1838] = {.lex_state = 7, .external_lex_state = 3},
  [1839] = {.lex_state = 7, .external_lex_state = 2},
  [1840] = {.lex_state = 7, .external_lex_state = 2},
  [1841] = {.lex_state = 7, .external_lex_state = 3},
  [1842] = {.lex_state = 7, .external_lex_state = 3},
  [1843] = {.lex_state = 7, .external_lex_state = 3},
  [1844] = {.lex_state = 7, .external_lex_state = 2},
  [1845] = {.lex_state = 12, .external_lex_state = 4},
  [1846] = {.lex_state = 7, .external_lex_state = 2},
  [1847] = {.lex_state = 11, .external_lex_state = 4},
  [1848] = {.lex_state = 7, .external_lex_state = 3},
  [1849] = {.lex_state = 7, .external_lex_state = 3},
  [1850] = {.lex_state = 8, .external_lex_state = 3},
  [1851] = {.lex_state = 7, .external_lex_state = 3},
  [1852] = {.lex_state = 7, .external_lex_state = 3},
  [1853] = {.lex_state = 7, .external_lex_state = 2},
  [1854] = {.lex_state = 7, .external_lex_state = 3},
  [1855] = {.lex_state = 7, .external_lex_state = 2},
  [1856] = {.lex_state = 7, .external_lex_state = 2},
  [1857] = {.lex_state = 7, .external_lex_state = 3},
  [1858] = {.lex_state = 7, .external_lex_state = 3},
  [1859] = {.lex_state = 7, .external_lex_state = 2},
  [1860] = {.lex_state = 7, .external_lex_state = 2},
  [1861] = {.lex_state = 7, .external_lex_state = 2},
  [1862] = {.lex_state = 7, .external_lex_state = 3},
  [1863] = {.lex_state = 7, .external_lex_state = 2},
  [1864] = {.lex_state = 7, .external_lex_state = 3},
  [1865] = {.lex_state = 7, .external_lex_state = 2},
  [1866] = {.lex_state = 7, .external_lex_state = 2},
  [1867] = {.lex_state = 7, .external_lex_state = 2},
  [1868] = {.lex_state = 7, .external_lex_state = 3},
  [1869] = {.lex_state = 7, .external_lex_state = 3},
  [1870] = {.lex_state = 7, .external_lex_state = 2},
  [1871] = {.lex_state = 7, .external_lex_state = 2},
  [1872] = {.lex_state = 7, .external_lex_state = 2},
  [1873] = {.lex_state = 7, .external_lex_state = 2},
  [1874] = {.lex_state = 7, .external_lex_state = 3},
  [1875] = {.lex_state = 7, .external_lex_state = 3},
  [1876] = {.lex_state = 7, .external_lex_state = 2},
  [1877] = {.lex_state = 7, .external_lex_state = 2},
  [1878] = {.lex_state = 7, .external_lex_state = 2},
  [1879] = {.lex_state = 7, .external_lex_state = 3},
  [1880] = {.lex_state = 7, .external_lex_state = 2},
  [1881] = {.lex_state = 7, .external_lex_state = 3},
  [1882] = {.lex_state = 7, .external_lex_state = 2},
  [1883] = {.lex_state = 7, .external_lex_state = 3},
  [1884] = {.lex_state = 7, .external_lex_state = 3},
  [1885] = {.lex_state = 8, .external_lex_state = 3},
  [1886] = {.lex_state = 7, .external_lex_state = 3},
  [1887] = {.lex_state = 7, .external_lex_state = 2},
  [1888] = {.lex_state = 7, .external_lex_state = 2},
  [1889] = {.lex_state = 7, .external_lex_state = 3},
  [1890] = {.lex_state = 7, .external_lex_state = 3},
  [1891] = {.lex_state = 7, .external_lex_state = 2},
  [1892] = {.lex_state = 7, .external_lex_state = 2},
  [1893] = {.lex_state = 7, .external_lex_state = 3},
  [1894] = {.lex_state = 7, .external_lex_state = 3},
  [1895] = {.lex_state = 7, .external_lex_state = 2},
  [1896] = {.lex_state = 7, .external_lex_state = 3},
  [1897] = {.lex_state = 7, .external_lex_state = 3},
  [1898] = {.lex_state = 7, .external_lex_state = 3},
  [1899] = {.lex_state = 7, .external_lex_state = 2},
  [1900] = {.lex_state = 7, .external_lex_state = 3},
  [1901] = {.lex_state = 7, .external_lex_state = 3},
  [1902] = {.lex_state = 7, .external_lex_state = 3},
  [1903] = {.lex_state = 7, .external_lex_state = 3},
  [1904] = {.lex_state = 7, .external_lex_state = 3},
  [1905] = {.lex_state = 7, .external_lex_state = 3},
  [1906] = {.lex_state = 7, .external_lex_state = 2},
  [1907] = {.lex_state = 7, .external_lex_state = 3},
  [1908] = {.lex_state = 7, .external_lex_state = 2},
  [1909] = {.lex_state = 7, .external_lex_state = 3},
  [1910] = {.lex_state = 7, .external_lex_state = 2},
  [1911] = {.lex_state = 7, .external_lex_state = 3},
  [1912] = {.lex_state = 7, .external_lex_state = 3},
  [1913] = {.lex_state = 7, .external_lex_state = 3},
  [1914] = {.lex_state = 7, .external_lex_state = 3},
  [1915] = {.lex_state = 7, .external_lex_state = 2},
  [1916] = {.lex_state = 7, .external_lex_state = 3},
  [1917] = {.lex_state = 7, .external_lex_state = 3},
  [1918] = {.lex_state = 7, .external_lex_state = 2},
  [1919] = {.lex_state = 7, .external_lex_state = 3},
  [1920] = {.lex_state = 7, .external_lex_state = 3},
  [1921] = {.lex_state = 7, .external_lex_state = 2},
  [1922] = {.lex_state = 7, .external_lex_state = 3},
  [1923] = {.lex_state = 7, .external_lex_state = 3},
  [1924] = {.lex_state = 7, .external_lex_state = 3},
  [1925] = {.lex_state = 7, .external_lex_state = 3},
  [1926] = {.lex_state = 7, .external_lex_state = 3},
  [1927] = {.lex_state = 7, .external_lex_state = 2},
  [1928] = {.lex_state = 7, .external_lex_state = 3},
  [1929] = {.lex_state = 7, .external_lex_state = 3},
  [1930] = {.lex_state = 7, .external_lex_state = 3},
  [1931] = {.lex_state = 7, .external_lex_state = 2},
  [1932] = {.lex_state = 7, .external_lex_state = 2},
  [1933] = {.lex_state = 7, .external_lex_state = 3},
  [1934] = {.lex_state = 7, .external_lex_state = 3},
  [1935] = {.lex_state = 7, .external_lex_state = 3},
  [1936] = {.lex_state = 7, .external_lex_state = 2},
  [1937] = {.lex_state = 7, .external_lex_state = 3},
  [1938] = {.lex_state = 7, .external_lex_state = 3},
  [1939] = {.lex_state = 7, .external_lex_state = 2},
  [1940] = {.lex_state = 7, .external_lex_state = 3},
  [1941] = {.lex_state = 7, .external_lex_state = 3},
  [1942] = {.lex_state = 7, .external_lex_state = 3},
  [1943] = {.lex_state = 7, .external_lex_state = 3},
  [1944] = {.lex_state = 7, .external_lex_state = 3},
  [1945] = {.lex_state = 7, .external_lex_state = 3},
  [1946] = {.lex_state = 7, .external_lex_state = 2},
  [1947] = {.lex_state = 7, .external_lex_state = 3},
  [1948] = {.lex_state = 7, .external_lex_state = 3},
  [1949] = {.lex_state = 7, .external_lex_state = 3},
  [1950] = {.lex_state = 7, .external_lex_state = 2},
  [1951] = {.lex_state = 7, .external_lex_state = 3},
  [1952] = {.lex_state = 7, .external_lex_state = 2},
  [1953] = {.lex_state = 7, .external_lex_state = 3},
  [1954] = {.lex_state = 7, .external_lex_state = 2},
  [1955] = {.lex_state = 7, .external_lex_state = 3},
  [1956] = {.lex_state = 7, .external_lex_state = 2},
  [1957] = {.lex_state = 7, .external_lex_state = 3},
  [1958] = {.lex_state = 7, .external_lex_state = 3},
  [1959] = {.lex_state = 7, .external_lex_state = 3},
  [1960] = {.lex_state = 7, .external_lex_state = 2},
  [1961] = {.lex_state = 7, .external_lex_state = 2},
  [1962] = {.lex_state = 7, .external_lex_state = 3},
  [1963] = {.lex_state = 7, .external_lex_state = 3},
  [1964] = {.lex_state = 7, .external_lex_state = 2},
  [1965] = {.lex_state = 7, .external_lex_state = 3},
  [1966] = {.lex_state = 7, .external_lex_state = 2},
  [1967] = {.lex_state = 7, .external_lex_state = 3},
  [1968] = {.lex_state = 12, .external_lex_state = 4},
  [1969] = {.lex_state = 7, .external_lex_state = 2},
  [1970] = {.lex_state = 7, .external_lex_state = 3},
  [1971] = {.lex_state = 7, .external_lex_state = 3},
  [1972] = {.lex_state = 7, .external_lex_state = 3},
  [1973] = {.lex_state = 12, .external_lex_state = 4},
  [1974] = {.lex_state = 7, .external_lex_state = 3},
  [1975] = {.lex_state = 7, .external_lex_state = 3},
  [1976] = {.lex_state = 7, .external_lex_state = 3},
  [1977] = {.lex_state = 12, .external_lex_state = 4},
  [1978] = {.lex_state = 7, .external_lex_state = 2},
  [1979] = {.lex_state = 7, .external_lex_state = 3},
  [1980] = {.lex_state = 7, .external_lex_state = 2},
  [1981] = {.lex_state = 7, .external_lex_state = 2},
  [1982] = {.lex_state = 7, .external_lex_state = 3},
  [1983] = {.lex_state = 12, .external_lex_state = 4},
  [1984] = {.lex_state = 7, .external_lex_state = 3},
  [1985] = {.lex_state = 7, .external_lex_state = 2},
  [1986] = {.lex_state = 7, .external_lex_state = 3},
  [1987] = {.lex_state = 7, .external_lex_state = 2},
  [1988] = {.lex_state = 12, .external_lex_state = 4},
  [1989] = {.lex_state = 7, .external_lex_state = 3},
  [1990] = {.lex_state = 12, .external_lex_state = 4},
  [1991] = {.lex_state = 7, .external_lex_state = 3},
  [1992] = {.lex_state = 12, .external_lex_state = 4},
  [1993] = {.lex_state = 7, .external_lex_state = 3},
  [1994] = {.lex_state = 7, .external_lex_state = 2},
  [1995] = {.lex_state = 7, .external_lex_state = 3},
  [1996] = {.lex_state = 7, .external_lex_state = 3},
  [1997] = {.lex_state = 7, .external_lex_state = 3},
  [1998] = {.lex_state = 7, .external_lex_state = 3},
  [1999] = {.lex_state = 7, .external_lex_state = 3},
  [2000] = {.lex_state = 7, .external_lex_state = 2},
  [2001] = {.lex_state = 7, .external_lex_state = 3},
  [2002] = {.lex_state = 12, .external_lex_state = 4},
  [2003] = {.lex_state = 7, .external_lex_state = 3},
  [2004] = {.lex_state = 7, .external_lex_state = 2},
  [2005] = {.lex_state = 7, .external_lex_state = 2},
  [2006] = {.lex_state = 12, .external_lex_state = 4},
  [2007] = {.lex_state = 12, .external_lex_state = 4},
  [2008] = {.lex_state = 7, .external_lex_state = 2},
  [2009] = {.lex_state = 7, .external_lex_state = 2},
  [2010] = {.lex_state = 12, .external_lex_state = 4},
  [2011] = {.lex_state = 7, .external_lex_state = 3},
  [2012] = {.lex_state = 7, .external_lex_state = 2},
  [2013] = {.lex_state = 7, .external_lex_state = 2},
  [2014] = {.lex_state = 7, .external_lex_state = 2},
  [2015] = {.lex_state = 7, .external_lex_state = 2},
  [2016] = {.lex_state = 7, .external_lex_state = 2},
  [2017] = {.lex_state = 7, .external_lex_state = 3},
  [2018] = {.lex_state = 7, .external_lex_state = 2},
  [2019] = {.lex_state = 7, .external_lex_state = 3},
  [2020] = {.lex_state = 7, .external_lex_state = 2},
  [2021] = {.lex_state = 7, .external_lex_state = 2},
  [2022] = {.lex_state = 7, .external_lex_state = 2},
  [2023] = {.lex_state = 7, .external_lex_state = 2},
  [2024] = {.lex_state = 7, .external_lex_state = 2},
  [2025] = {.lex_state = 7, .external_lex_state = 2},
  [2026] = {.lex_state = 7, .external_lex_state = 2},
  [2027] = {.lex_state = 12, .external_lex_state = 4},
  [2028] = {.lex_state = 7, .external_lex_state = 2},
  [2029] = {.lex_state = 7, .external_lex_state = 2},
  [2030] = {.lex_state = 7, .external_lex_state = 2},
  [2031] = {.lex_state = 7, .external_lex_state = 2},
  [2032] = {.lex_state = 7, .external_lex_state = 2},
  [2033] = {.lex_state = 7, .external_lex_state = 2},
  [2034] = {.lex_state = 7, .external_lex_state = 2},
  [2035] = {.lex_state = 7, .external_lex_state = 2},
  [2036] = {.lex_state = 7, .external_lex_state = 2},
  [2037] = {.lex_state = 7, .external_lex_state = 2},
  [2038] = {.lex_state = 7, .external_lex_state = 2},
  [2039] = {.lex_state = 7, .external_lex_state = 2},
  [2040] = {.lex_state = 7, .external_lex_state = 2},
  [2041] = {.lex_state = 7, .external_lex_state = 2},
  [2042] = {.lex_state = 7, .external_lex_state = 2},
  [2043] = {.lex_state = 7, .external_lex_state = 2},
  [2044] = {.lex_state = 7, .external_lex_state = 2},
  [2045] = {.lex_state = 7, .external_lex_state = 2},
  [2046] = {.lex_state = 7, .external_lex_state = 2},
  [2047] = {.lex_state = 12, .external_lex_state = 4},
  [2048] = {.lex_state = 12, .external_lex_state = 4},
  [2049] = {.lex_state = 7, .external_lex_state = 2},
  [2050] = {.lex_state = 7, .external_lex_state = 2},
  [2051] = {.lex_state = 7, .external_lex_state = 2},
  [2052] = {.lex_state = 12, .external_lex_state = 4},
  [2053] = {.lex_state = 8, .external_lex_state = 2},
  [2054] = {.lex_state = 94},
  [2055] = {.lex_state = 7, .external_lex_state = 2},
  [2056] = {.lex_state = 7, .external_lex_state = 2},
  [2057] = {.lex_state = 7, .external_lex_state = 2},
  [2058] = {.lex_state = 7, .external_lex_state = 2},
  [2059] = {.lex_state = 7, .external_lex_state = 3},
  [2060] = {.lex_state = 7, .external_lex_state = 2},
  [2061] = {.lex_state = 12},
  [2062] = {.lex_state = 7, .external_lex_state = 2},
  [2063] = {.lex_state = 7, .external_lex_state = 2},
  [2064] = {.lex_state = 7, .external_lex_state = 2},
  [2065] = {.lex_state = 7, .external_lex_state = 2},
  [2066] = {.lex_state = 7, .external_lex_state = 2},
  [2067] = {.lex_state = 12},
  [2068] = {.lex_state = 7, .external_lex_state = 2},
  [2069] = {.lex_state = 7, .external_lex_state = 2},
  [2070] = {.lex_state = 94},
  [2071] = {.lex_state = 7, .external_lex_state = 3},
  [2072] = {.lex_state = 12, .external_lex_state = 4},
  [2073] = {.lex_state = 7, .external_lex_state = 2},
  [2074] = {.lex_state = 7, .external_lex_state = 2},
  [2075] = {.lex_state = 7, .external_lex_state = 2},
  [2076] = {.lex_state = 12, .external_lex_state = 4},
  [2077] = {.lex_state = 12},
  [2078] = {.lex_state = 12},
  [2079] = {.lex_state = 12},
  [2080] = {.lex_state = 7, .external_lex_state = 3},
  [2081] = {.lex_state = 7, .external_lex_state = 2},
  [2082] = {.lex_state = 12, .external_lex_state = 4},
  [2083] = {.lex_state = 12},
  [2084] = {.lex_state = 12, .external_lex_state = 4},
  [2085] = {.lex_state = 7, .external_lex_state = 2},
  [2086] = {.lex_state = 12, .external_lex_state = 4},
  [2087] = {.lex_state = 12, .external_lex_state = 4},
  [2088] = {.lex_state = 12, .external_lex_state = 4},
  [2089] = {.lex_state = 7, .external_lex_state = 2},
  [2090] = {.lex_state = 12},
  [2091] = {.lex_state = 12, .external_lex_state = 4},
  [2092] = {.lex_state = 12, .external_lex_state = 4},
  [2093] = {.lex_state = 12, .external_lex_state = 4},
  [2094] = {.lex_state = 12, .external_lex_state = 4},
  [2095] = {.lex_state = 12, .external_lex_state = 4},
  [2096] = {.lex_state = 12, .external_lex_state = 4},
  [2097] = {.lex_state = 12, .external_lex_state = 4},
  [2098] = {.lex_state = 12, .external_lex_state = 4},
  [2099] = {.lex_state = 12, .external_lex_state = 4},
  [2100] = {.lex_state = 12, .external_lex_state = 4},
  [2101] = {.lex_state = 12, .external_lex_state = 4},
  [2102] = {.lex_state = 12, .external_lex_state = 4},
  [2103] = {.lex_state = 12, .external_lex_state = 4},
  [2104] = {.lex_state = 7, .external_lex_state = 2},
  [2105] = {.lex_state = 7, .external_lex_state = 2},
  [2106] = {.lex_state = 12},
  [2107] = {.lex_state = 12},
  [2108] = {.lex_state = 12, .external_lex_state = 4},
  [2109] = {.lex_state = 12},
  [2110] = {.lex_state = 12, .external_lex_state = 4},
  [2111] = {.lex_state = 12},
  [2112] = {.lex_state = 12, .external_lex_state = 4},
  [2113] = {.lex_state = 12},
  [2114] = {.lex_state = 12, .external_lex_state = 4},
  [2115] = {.lex_state = 12},
  [2116] = {.lex_state = 12},
  [2117] = {.lex_state = 12, .external_lex_state = 4},
  [2118] = {.lex_state = 12, .external_lex_state = 4},
  [2119] = {.lex_state = 12, .external_lex_state = 4},
  [2120] = {.lex_state = 8, .external_lex_state = 2},
  [2121] = {.lex_state = 12},
  [2122] = {.lex_state = 12, .external_lex_state = 4},
  [2123] = {.lex_state = 7, .external_lex_state = 2},
  [2124] = {.lex_state = 12, .external_lex_state = 4},
  [2125] = {.lex_state = 12, .external_lex_state = 4},
  [2126] = {.lex_state = 12},
  [2127] = {.lex_state = 12, .external_lex_state = 4},
  [2128] = {.lex_state = 7, .external_lex_state = 2},
  [2129] = {.lex_state = 12, .external_lex_state = 4},
  [2130] = {.lex_state = 12, .external_lex_state = 4},
  [2131] = {.lex_state = 12, .external_lex_state = 4},
  [2132] = {.lex_state = 12, .external_lex_state = 4},
  [2133] = {.lex_state = 12, .external_lex_state = 4},
  [2134] = {.lex_state = 12, .external_lex_state = 4},
  [2135] = {.lex_state = 12, .external_lex_state = 4},
  [2136] = {.lex_state = 12},
  [2137] = {.lex_state = 7, .external_lex_state = 2},
  [2138] = {.lex_state = 12},
  [2139] = {.lex_state = 12},
  [2140] = {.lex_state = 12},
  [2141] = {.lex_state = 12, .external_lex_state = 4},
  [2142] = {.lex_state = 12, .external_lex_state = 4},
  [2143] = {.lex_state = 12},
  [2144] = {.lex_state = 94},
  [2145] = {.lex_state = 12, .external_lex_state = 4},
  [2146] = {.lex_state = 12, .external_lex_state = 4},
  [2147] = {.lex_state = 12, .external_lex_state = 4},
  [2148] = {.lex_state = 12, .external_lex_state = 4},
  [2149] = {.lex_state = 12, .external_lex_state = 4},
  [2150] = {.lex_state = 12, .external_lex_state = 4},
  [2151] = {.lex_state = 12},
  [2152] = {.lex_state = 12},
  [2153] = {.lex_state = 12, .external_lex_state = 4},
  [2154] = {.lex_state = 12, .external_lex_state = 4},
  [2155] = {.lex_state = 12, .external_lex_state = 4},
  [2156] = {.lex_state = 12, .external_lex_state = 4},
  [2157] = {.lex_state = 12, .external_lex_state = 4},
  [2158] = {.lex_state = 12, .external_lex_state = 4},
  [2159] = {.lex_state = 12, .external_lex_state = 4},
  [2160] = {.lex_state = 94},
  [2161] = {.lex_state = 12, .external_lex_state = 4},
  [2162] = {.lex_state = 12},
  [2163] = {.lex_state = 12, .external_lex_state = 4},
  [2164] = {.lex_state = 12, .external_lex_state = 4},
  [2165] = {.lex_state = 12, .external_lex_state = 4},
  [2166] = {.lex_state = 12},
  [2167] = {.lex_state = 12, .external_lex_state = 4},
  [2168] = {.lex_state = 12},
  [2169] = {.lex_state = 12, .external_lex_state = 4},
  [2170] = {.lex_state = 12, .external_lex_state = 4},
  [2171] = {.lex_state = 12, .external_lex_state = 4},
  [2172] = {.lex_state = 12, .external_lex_state = 4},
  [2173] = {.lex_state = 12, .external_lex_state = 4},
  [2174] = {.lex_state = 12},
  [2175] = {.lex_state = 12},
  [2176] = {.lex_state = 12},
  [2177] = {.lex_state = 94, .external_lex_state = 4},
  [2178] = {.lex_state = 12},
  [2179] = {.lex_state = 94, .external_lex_state = 4},
  [2180] = {.lex_state = 12},
  [2181] = {.lex_state = 94, .external_lex_state = 4},
  [2182] = {.lex_state = 12},
  [2183] = {.lex_state = 94, .external_lex_state = 4},
  [2184] = {.lex_state = 12, .external_lex_state = 4},
  [2185] = {.lex_state = 12, .external_lex_state = 4},
  [2186] = {.lex_state = 12},
  [2187] = {.lex_state = 12},
  [2188] = {.lex_state = 12},
  [2189] = {.lex_state = 12},
  [2190] = {.lex_state = 12},
  [2191] = {.lex_state = 12},
  [2192] = {.lex_state = 12},
  [2193] = {.lex_state = 94, .external_lex_state = 4},
  [2194] = {.lex_state = 12},
  [2195] = {.lex_state = 12},
  [2196] = {.lex_state = 12},
  [2197] = {.lex_state = 12},
  [2198] = {.lex_state = 12},
  [2199] = {.lex_state = 12},
  [2200] = {.lex_state = 94, .external_lex_state = 4},
  [2201] = {.lex_state = 12},
  [2202] = {.lex_state = 12},
  [2203] = {.lex_state = 12},
  [2204] = {.lex_state = 12},
  [2205] = {.lex_state = 12},
  [2206] = {.lex_state = 94},
  [2207] = {.lex_state = 94},
  [2208] = {.lex_state = 94},
  [2209] = {.lex_state = 12},
  [2210] = {.lex_state = 94},
  [2211] = {.lex_state = 94},
  [2212] = {.lex_state = 12},
  [2213] = {.lex_state = 12},
  [2214] = {.lex_state = 94},
  [2215] = {.lex_state = 12},
  [2216] = {.lex_state = 94},
  [2217] = {.lex_state = 12, .external_lex_state = 4},
  [2218] = {.lex_state = 12, .external_lex_state = 4},
  [2219] = {.lex_state = 12},
  [2220] = {.lex_state = 12, .external_lex_state = 4},
  [2221] = {.lex_state = 12, .external_lex_state = 4},
  [2222] = {.lex_state = 12},
  [2223] = {.lex_state = 12},
  [2224] = {.lex_state = 12},
  [2225] = {.lex_state = 12, .external_lex_state = 4},
  [2226] = {.lex_state = 12},
  [2227] = {.lex_state = 12},
  [2228] = {.lex_state = 12, .external_lex_state = 4},
  [2229] = {.lex_state = 12},
  [2230] = {.lex_state = 12, .external_lex_state = 4},
  [2231] = {.lex_state = 12, .external_lex_state = 4},
  [2232] = {.lex_state = 12, .external_lex_state = 4},
  [2233] = {.lex_state = 12},
  [2234] = {.lex_state = 12},
  [2235] = {.lex_state = 12, .external_lex_state = 4},
  [2236] = {.lex_state = 12},
  [2237] = {.lex_state = 12, .external_lex_state = 4},
  [2238] = {.lex_state = 12, .external_lex_state = 4},
  [2239] = {.lex_state = 12, .external_lex_state = 4},
  [2240] = {.lex_state = 12, .external_lex_state = 4},
  [2241] = {.lex_state = 12, .external_lex_state = 4},
  [2242] = {.lex_state = 12, .external_lex_state = 4},
  [2243] = {.lex_state = 12, .external_lex_state = 4},
  [2244] = {.lex_state = 12},
  [2245] = {.lex_state = 12, .external_lex_state = 4},
  [2246] = {.lex_state = 12, .external_lex_state = 4},
  [2247] = {.lex_state = 12, .external_lex_state = 4},
  [2248] = {.lex_state = 12, .external_lex_state = 4},
  [2249] = {.lex_state = 12, .external_lex_state = 4},
  [2250] = {.lex_state = 12, .external_lex_state = 4},
  [2251] = {.lex_state = 12, .external_lex_state = 4},
  [2252] = {.lex_state = 12, .external_lex_state = 4},
  [2253] = {.lex_state = 12, .external_lex_state = 4},
  [2254] = {.lex_state = 12, .external_lex_state = 4},
  [2255] = {.lex_state = 12},
  [2256] = {.lex_state = 12, .external_lex_state = 4},
  [2257] = {.lex_state = 12},
  [2258] = {.lex_state = 12},
  [2259] = {.lex_state = 12},
  [2260] = {.lex_state = 12},
  [2261] = {.lex_state = 12},
  [2262] = {.lex_state = 12, .external_lex_state = 4},
  [2263] = {.lex_state = 12},
  [2264] = {.lex_state = 12},
  [2265] = {.lex_state = 12},
  [2266] = {.lex_state = 94},
  [2267] = {.lex_state = 12},
  [2268] = {.lex_state = 12},
  [2269] = {.lex_state = 12},
  [2270] = {.lex_state = 12},
  [2271] = {.lex_state = 12},
  [2272] = {.lex_state = 12},
  [2273] = {.lex_state = 12},
  [2274] = {.lex_state = 12},
  [2275] = {.lex_state = 12},
  [2276] = {.lex_state = 12},
  [2277] = {.lex_state = 12},
  [2278] = {.lex_state = 94},
  [2279] = {.lex_state = 12},
  [2280] = {.lex_state = 94},
  [2281] = {.lex_state = 12},
  [2282] = {.lex_state = 12},
  [2283] = {.lex_state = 94},
  [2284] = {.lex_state = 94},
  [2285] = {.lex_state = 12},
  [2286] = {.lex_state = 94},
  [2287] = {.lex_state = 94},
  [2288] = {.lex_state = 94},
  [2289] = {.lex_state = 12},
  [2290] = {.lex_state = 12},
  [2291] = {.lex_state = 94},
  [2292] = {.lex_state = 94},
  [2293] = {.lex_state = 12},
  [2294] = {.lex_state = 94},
  [2295] = {.lex_state = 94},
  [2296] = {.lex_state = 94},
  [2297] = {.lex_state = 94},
  [2298] = {.lex_state = 12},
  [2299] = {.lex_state = 12},
  [2300] = {.lex_state = 94},
  [2301] = {.lex_state = 94},
  [2302] = {.lex_state = 12},
  [2303] = {.lex_state = 94},
  [2304] = {.lex_state = 94},
  [2305] = {.lex_state = 94},
  [2306] = {.lex_state = 94},
  [2307] = {.lex_state = 94},
  [2308] = {.lex_state = 94},
  [2309] = {.lex_state = 94},
  [2310] = {.lex_state = 94},
  [2311] = {.lex_state = 94},
  [2312] = {.lex_state = 94},
  [2313] = {.lex_state = 94},
  [2314] = {.lex_state = 94},
  [2315] = {.lex_state = 94},
  [2316] = {.lex_state = 94},
  [2317] = {.lex_state = 94},
  [2318] = {.lex_state = 94},
  [2319] = {.lex_state = 94},
  [2320] = {.lex_state = 94},
  [2321] = {.lex_state = 94},
  [2322] = {.lex_state = 94},
  [2323] = {.lex_state = 94},
  [2324] = {.lex_state = 94},
  [2325] = {.lex_state = 94},
  [2326] = {.lex_state = 94},
  [2327] = {.lex_state = 94},
  [2328] = {.lex_state = 94},
  [2329] = {.lex_state = 94},
  [2330] = {.lex_state = 94},
  [2331] = {.lex_state = 94},
  [2332] = {.lex_state = 94},
  [2333] = {.lex_state = 94},
  [2334] = {.lex_state = 94},
  [2335] = {.lex_state = 94},
  [2336] = {.lex_state = 94},
  [2337] = {.lex_state = 94},
  [2338] = {.lex_state = 94},
  [2339] = {.lex_state = 94},
  [2340] = {.lex_state = 94},
  [2341] = {.lex_state = 94},
  [2342] = {.lex_state = 94},
  [2343] = {.lex_state = 94},
  [2344] = {.lex_state = 94},
  [2345] = {.lex_state = 94},
  [2346] = {.lex_state = 94},
  [2347] = {.lex_state = 94},
  [2348] = {.lex_state = 94},
  [2349] = {.lex_state = 94},
  [2350] = {.lex_state = 11},
  [2351] = {.lex_state = 15},
  [2352] = {.lex_state = 11},
  [2353] = {.lex_state = 15},
  [2354] = {.lex_state = 20},
  [2355] = {.lex_state = 15},
  [2356] = {.lex_state = 15},
  [2357] = {.lex_state = 15},
  [2358] = {.lex_state = 15},
  [2359] = {.lex_state = 15},
  [2360] = {.lex_state = 15},
  [2361] = {.lex_state = 15},
  [2362] = {.lex_state = 15},
  [2363] = {.lex_state = 15},
  [2364] = {.lex_state = 15},
  [2365] = {.lex_state = 15},
  [2366] = {.lex_state = 15},
  [2367] = {.lex_state = 15},
  [2368] = {.lex_state = 94},
  [2369] = {.lex_state = 15},
  [2370] = {.lex_state = 94},
  [2371] = {.lex_state = 15},
  [2372] = {.lex_state = 15},
  [2373] = {.lex_state = 94},
  [2374] = {.lex_state = 15},
  [2375] = {.lex_state = 15},
  [2376] = {.lex_state = 15},
  [2377] = {.lex_state = 15},
  [2378] = {.lex_state = 15},
  [2379] = {.lex_state = 15},
  [2380] = {.lex_state = 15},
  [2381] = {.lex_state = 15},
  [2382] = {.lex_state = 15},
  [2383] = {.lex_state = 15},
  [2384] = {.lex_state = 15},
  [2385] = {.lex_state = 15},
  [2386] = {.lex_state = 20},
  [2387] = {.lex_state = 15},
  [2388] = {.lex_state = 15},
  [2389] = {.lex_state = 15},
  [2390] = {.lex_state = 15},
  [2391] = {.lex_state = 15},
  [2392] = {.lex_state = 15},
  [2393] = {.lex_state = 15},
  [2394] = {.lex_state = 15},
  [2395] = {.lex_state = 15},
  [2396] = {.lex_state = 15},
  [2397] = {.lex_state = 15},
  [2398] = {.lex_state = 11},
  [2399] = {.lex_state = 11},
  [2400] = {.lex_state = 11, .external_lex_state = 4},
  [2401] = {.lex_state = 11, .external_lex_state = 4},
  [2402] = {.lex_state = 94},
  [2403] = {.lex_state = 4},
  [2404] = {.lex_state = 4},
  [2405] = {.lex_state = 15, .external_lex_state = 4},
  [2406] = {.lex_state = 94},
  [2407] = {.lex_state = 94},
  [2408] = {.lex_state = 94},
  [2409] = {.lex_state = 94},
  [2410] = {.lex_state = 94},
  [2411] = {.lex_state = 94},
  [2412] = {.lex_state = 94},
  [2413] = {.lex_state = 94},
  [2414] = {.lex_state = 94},
  [2415] = {.lex_state = 94},
  [2416] = {.lex_state = 94},
  [2417] = {.lex_state = 4},
  [2418] = {.lex_state = 94},
  [2419] = {.lex_state = 4},
  [2420] = {.lex_state = 11, .external_lex_state = 4},
  [2421] = {.lex_state = 94},
  [2422] = {.lex_state = 4},
  [2423] = {.lex_state = 94},
  [2424] = {.lex_state = 15, .external_lex_state = 4},
  [2425] = {.lex_state = 94},
  [2426] = {.lex_state = 94},
  [2427] = {.lex_state = 94},
  [2428] = {.lex_state = 94},
  [2429] = {.lex_state = 94},
  [2430] = {.lex_state = 94},
  [2431] = {.lex_state = 94},
  [2432] = {.lex_state = 94},
  [2433] = {.lex_state = 94},
  [2434] = {.lex_state = 94},
  [2435] = {.lex_state = 4},
  [2436] = {.lex_state = 94},
  [2437] = {.lex_state = 94},
  [2438] = {.lex_state = 94},
  [2439] = {.lex_state = 4},
  [2440] = {.lex_state = 94},
  [2441] = {.lex_state = 94},
  [2442] = {.lex_state = 15, .external_lex_state = 4},
  [2443] = {.lex_state = 94},
  [2444] = {.lex_state = 4},
  [2445] = {.lex_state = 94},
  [2446] = {.lex_state = 94},
  [2447] = {.lex_state = 94},
  [2448] = {.lex_state = 94},
  [2449] = {.lex_state = 94},
  [2450] = {.lex_state = 94},
  [2451] = {.lex_state = 94},
  [2452] = {.lex_state = 94},
  [2453] = {.lex_state = 12, .external_lex_state = 4},
  [2454] = {.lex_state = 94},
  [2455] = {.lex_state = 20},
  [2456] = {.lex_state = 94},
  [2457] = {.lex_state = 12, .external_lex_state = 4},
  [2458] = {.lex_state = 94},
  [2459] = {.lex_state = 12, .external_lex_state = 4},
  [2460] = {.lex_state = 94},
  [2461] = {.lex_state = 11, .external_lex_state = 4},
  [2462] = {.lex_state = 12, .external_lex_state = 4},
  [2463] = {.lex_state = 12, .external_lex_state = 4},
  [2464] = {.lex_state = 94},
  [2465] = {.lex_state = 94},
  [2466] = {.lex_state = 12, .external_lex_state = 4},
  [2467] = {.lex_state = 12, .external_lex_state = 4},
  [2468] = {.lex_state = 94},
  [2469] = {.lex_state = 94},
  [2470] = {.lex_state = 94},
  [2471] = {.lex_state = 94},
  [2472] = {.lex_state = 15, .external_lex_state = 4},
  [2473] = {.lex_state = 15, .external_lex_state = 4},
  [2474] = {.lex_state = 15, .external_lex_state = 4},
  [2475] = {.lex_state = 15, .external_lex_state = 4},
  [2476] = {.lex_state = 15, .external_lex_state = 4},
  [2477] = {.lex_state = 15, .external_lex_state = 4},
  [2478] = {.lex_state = 15, .external_lex_state = 4},
  [2479] = {.lex_state = 15, .external_lex_state = 4},
  [2480] = {.lex_state = 15, .external_lex_state = 4},
  [2481] = {.lex_state = 15, .external_lex_state = 4},
  [2482] = {.lex_state = 15, .external_lex_state = 4},
  [2483] = {.lex_state = 15, .external_lex_state = 4},
  [2484] = {.lex_state = 15, .external_lex_state = 4},
  [2485] = {.lex_state = 15, .external_lex_state = 4},
  [2486] = {.lex_state = 94},
  [2487] = {.lex_state = 94},
  [2488] = {.lex_state = 94},
  [2489] = {.lex_state = 94},
  [2490] = {.lex_state = 94},
  [2491] = {.lex_state = 15, .external_lex_state = 4},
  [2492] = {.lex_state = 15, .external_lex_state = 4},
  [2493] = {.lex_state = 15, .external_lex_state = 4},
  [2494] = {.lex_state = 15, .external_lex_state = 4},
  [2495] = {.lex_state = 94},
  [2496] = {.lex_state = 15, .external_lex_state = 4},
  [2497] = {.lex_state = 15, .external_lex_state = 4},
  [2498] = {.lex_state = 15, .external_lex_state = 4},
  [2499] = {.lex_state = 15, .external_lex_state = 4},
  [2500] = {.lex_state = 15, .external_lex_state = 4},
  [2501] = {.lex_state = 15, .external_lex_state = 4},
  [2502] = {.lex_state = 15, .external_lex_state = 4},
  [2503] = {.lex_state = 15, .external_lex_state = 4},
  [2504] = {.lex_state = 15, .external_lex_state = 4},
  [2505] = {.lex_state = 15, .external_lex_state = 4},
  [2506] = {.lex_state = 15, .external_lex_state = 4},
  [2507] = {.lex_state = 94},
  [2508] = {.lex_state = 94},
  [2509] = {.lex_state = 94},
  [2510] = {.lex_state = 94},
  [2511] = {.lex_state = 94},
  [2512] = {.lex_state = 15, .external_lex_state = 4},
  [2513] = {.lex_state = 15, .external_lex_state = 4},
  [2514] = {.lex_state = 15, .external_lex_state = 4},
  [2515] = {.lex_state = 15, .external_lex_state = 4},
  [2516] = {.lex_state = 15, .external_lex_state = 4},
  [2517] = {.lex_state = 12, .external_lex_state = 4},
  [2518] = {.lex_state = 12, .external_lex_state = 4},
  [2519] = {.lex_state = 15, .external_lex_state = 4},
  [2520] = {.lex_state = 15, .external_lex_state = 5},
  [2521] = {.lex_state = 15, .external_lex_state = 5},
  [2522] = {.lex_state = 94},
  [2523] = {.lex_state = 15, .external_lex_state = 4},
  [2524] = {.lex_state = 20},
  [2525] = {.lex_state = 12, .external_lex_state = 4},
  [2526] = {.lex_state = 15, .external_lex_state = 4},
  [2527] = {.lex_state = 94},
  [2528] = {.lex_state = 12, .external_lex_state = 4},
  [2529] = {.lex_state = 11, .external_lex_state = 4},
  [2530] = {.lex_state = 15, .external_lex_state = 4},
  [2531] = {.lex_state = 12, .external_lex_state = 4},
  [2532] = {.lex_state = 94},
  [2533] = {.lex_state = 12, .external_lex_state = 4},
  [2534] = {.lex_state = 12, .external_lex_state = 4},
  [2535] = {.lex_state = 11, .external_lex_state = 5},
  [2536] = {.lex_state = 11, .external_lex_state = 4},
  [2537] = {.lex_state = 12, .external_lex_state = 4},
  [2538] = {.lex_state = 20},
  [2539] = {.lex_state = 12, .external_lex_state = 4},
  [2540] = {.lex_state = 12, .external_lex_state = 4},
  [2541] = {.lex_state = 15, .external_lex_state = 4},
  [2542] = {.lex_state = 15, .external_lex_state = 5},
  [2543] = {.lex_state = 15, .external_lex_state = 4},
  [2544] = {.lex_state = 15, .external_lex_state = 4},
  [2545] = {.lex_state = 12, .external_lex_state = 4},
  [2546] = {.lex_state = 15, .external_lex_state = 5},
  [2547] = {.lex_state = 11, .external_lex_state = 5},
  [2548] = {.lex_state = 12, .external_lex_state = 4},
  [2549] = {.lex_state = 12, .external_lex_state = 4},
  [2550] = {.lex_state = 12, .external_lex_state = 4},
  [2551] = {.lex_state = 12, .external_lex_state = 4},
  [2552] = {.lex_state = 12, .external_lex_state = 4},
  [2553] = {.lex_state = 15, .external_lex_state = 5},
  [2554] = {.lex_state = 15, .external_lex_state = 5},
  [2555] = {.lex_state = 15, .external_lex_state = 5},
  [2556] = {.lex_state = 15, .external_lex_state = 5},
  [2557] = {.lex_state = 15, .external_lex_state = 5},
  [2558] = {.lex_state = 15, .external_lex_state = 5},
  [2559] = {.lex_state = 15, .external_lex_state = 5},
  [2560] = {.lex_state = 15, .external_lex_state = 5},
  [2561] = {.lex_state = 15, .external_lex_state = 5},
  [2562] = {.lex_state = 20},
  [2563] = {.lex_state = 15, .external_lex_state = 5},
  [2564] = {.lex_state = 12, .external_lex_state = 4},
  [2565] = {.lex_state = 15, .external_lex_state = 5},
  [2566] = {.lex_state = 15, .external_lex_state = 5},
  [2567] = {.lex_state = 15, .external_lex_state = 5},
  [2568] = {.lex_state = 15, .external_lex_state = 5},
  [2569] = {.lex_state = 15, .external_lex_state = 5},
  [2570] = {.lex_state = 12, .external_lex_state = 4},
  [2571] = {.lex_state = 94, .external_lex_state = 4},
  [2572] = {.lex_state = 94, .external_lex_state = 4},
  [2573] = {.lex_state = 94, .external_lex_state = 4},
  [2574] = {.lex_state = 15, .external_lex_state = 5},
  [2575] = {.lex_state = 12, .external_lex_state = 4},
  [2576] = {.lex_state = 20},
  [2577] = {.lex_state = 15, .external_lex_state = 5},
  [2578] = {.lex_state = 12, .external_lex_state = 4},
  [2579] = {.lex_state = 15, .external_lex_state = 5},
  [2580] = {.lex_state = 15, .external_lex_state = 5},
  [2581] = {.lex_state = 12, .external_lex_state = 4},
  [2582] = {.lex_state = 15, .external_lex_state = 5},
  [2583] = {.lex_state = 12, .external_lex_state = 4},
  [2584] = {.lex_state = 12, .external_lex_state = 4},
  [2585] = {.lex_state = 15, .external_lex_state = 5},
  [2586] = {.lex_state = 15, .external_lex_state = 5},
  [2587] = {.lex_state = 12, .external_lex_state = 4},
  [2588] = {.lex_state = 15, .external_lex_state = 5},
  [2589] = {.lex_state = 15, .external_lex_state = 5},
  [2590] = {.lex_state = 12, .external_lex_state = 4},
  [2591] = {.lex_state = 20},
  [2592] = {.lex_state = 15, .external_lex_state = 5},
  [2593] = {.lex_state = 12},
  [2594] = {.lex_state = 15, .external_lex_state = 5},
  [2595] = {.lex_state = 15, .external_lex_state = 5},
  [2596] = {.lex_state = 12, .external_lex_state = 4},
  [2597] = {.lex_state = 12, .external_lex_state = 4},
  [2598] = {.lex_state = 12},
  [2599] = {.lex_state = 12, .external_lex_state = 4},
  [2600] = {.lex_state = 12, .external_lex_state = 4},
  [2601] = {.lex_state = 15, .external_lex_state = 5},
  [2602] = {.lex_state = 12, .external_lex_state = 4},
  [2603] = {.lex_state = 12},
  [2604] = {.lex_state = 20},
  [2605] = {.lex_state = 15, .external_lex_state = 5},
  [2606] = {.lex_state = 15, .external_lex_state = 5},
  [2607] = {.lex_state = 15, .external_lex_state = 5},
  [2608] = {.lex_state = 15, .external_lex_state = 5},
  [2609] = {.lex_state = 15, .external_lex_state = 5},
  [2610] = {.lex_state = 12, .external_lex_state = 4},
  [2611] = {.lex_state = 12, .external_lex_state = 4},
  [2612] = {.lex_state = 94, .external_lex_state = 4},
  [2613] = {.lex_state = 94, .external_lex_state = 4},
  [2614] = {.lex_state = 12, .external_lex_state = 4},
  [2615] = {.lex_state = 11, .external_lex_state = 5},
  [2616] = {.lex_state = 94, .external_lex_state = 4},
  [2617] = {.lex_state = 94, .external_lex_state = 4},
  [2618] = {.lex_state = 15, .external_lex_state = 5},
  [2619] = {.lex_state = 94, .external_lex_state = 4},
  [2620] = {.lex_state = 94, .external_lex_state = 4},
  [2621] = {.lex_state = 94, .external_lex_state = 4},
  [2622] = {.lex_state = 15, .external_lex_state = 5},
  [2623] = {.lex_state = 15, .external_lex_state = 5},
  [2624] = {.lex_state = 11, .external_lex_state = 5},
  [2625] = {.lex_state = 94, .external_lex_state = 4},
  [2626] = {.lex_state = 15, .external_lex_state = 5},
  [2627] = {.lex_state = 15, .external_lex_state = 5},
  [2628] = {.lex_state = 94, .external_lex_state = 4},
  [2629] = {.lex_state = 15, .external_lex_state = 5},
  [2630] = {.lex_state = 94, .external_lex_state = 4},
  [2631] = {.lex_state = 94, .external_lex_state = 4},
  [2632] = {.lex_state = 94, .external_lex_state = 4},
  [2633] = {.lex_state = 94, .external_lex_state = 4},
  [2634] = {.lex_state = 94, .external_lex_state = 4},
  [2635] = {.lex_state = 94, .external_lex_state = 4},
  [2636] = {.lex_state = 94, .external_lex_state = 4},
  [2637] = {.lex_state = 94, .external_lex_state = 4},
  [2638] = {.lex_state = 94, .external_lex_state = 4},
  [2639] = {.lex_state = 94, .external_lex_state = 4},
  [2640] = {.lex_state = 94, .external_lex_state = 4},
  [2641] = {.lex_state = 94, .external_lex_state = 4},
  [2642] = {.lex_state = 94, .external_lex_state = 4},
  [2643] = {.lex_state = 94, .external_lex_state = 4},
  [2644] = {.lex_state = 94, .external_lex_state = 4},
  [2645] = {.lex_state = 94, .external_lex_state = 4},
  [2646] = {.lex_state = 15, .external_lex_state = 5},
  [2647] = {.lex_state = 94, .external_lex_state = 4},
  [2648] = {.lex_state = 94, .external_lex_state = 4},
  [2649] = {.lex_state = 94, .external_lex_state = 4},
  [2650] = {.lex_state = 94, .external_lex_state = 4},
  [2651] = {.lex_state = 94, .external_lex_state = 4},
  [2652] = {.lex_state = 94, .external_lex_state = 4},
  [2653] = {.lex_state = 94, .external_lex_state = 4},
  [2654] = {.lex_state = 94, .external_lex_state = 4},
  [2655] = {.lex_state = 94, .external_lex_state = 4},
  [2656] = {.lex_state = 94, .external_lex_state = 4},
  [2657] = {.lex_state = 94, .external_lex_state = 4},
  [2658] = {.lex_state = 94, .external_lex_state = 4},
  [2659] = {.lex_state = 94, .external_lex_state = 4},
  [2660] = {.lex_state = 94, .external_lex_state = 4},
  [2661] = {.lex_state = 94, .external_lex_state = 4},
  [2662] = {.lex_state = 94, .external_lex_state = 4},
  [2663] = {.lex_state = 94, .external_lex_state = 4},
  [2664] = {.lex_state = 12, .external_lex_state = 4},
  [2665] = {.lex_state = 94, .external_lex_state = 4},
  [2666] = {.lex_state = 94, .external_lex_state = 4},
  [2667] = {.lex_state = 94, .external_lex_state = 4},
  [2668] = {.lex_state = 94, .external_lex_state = 5},
  [2669] = {.lex_state = 29},
  [2670] = {.lex_state = 11},
  [2671] = {.lex_state = 11},
  [2672] = {.lex_state = 29},
  [2673] = {.lex_state = 15},
  [2674] = {.lex_state = 94},
  [2675] = {.lex_state = 20},
  [2676] = {.lex_state = 15},
  [2677] = {.lex_state = 94, .external_lex_state = 4},
  [2678] = {.lex_state = 94},
  [2679] = {.lex_state = 94, .external_lex_state = 4},
  [2680] = {.lex_state = 20},
  [2681] = {.lex_state = 11},
  [2682] = {.lex_state = 11},
  [2683] = {.lex_state = 11},
  [2684] = {.lex_state = 29},
  [2685] = {.lex_state = 29},
  [2686] = {.lex_state = 11},
  [2687] = {.lex_state = 94, .external_lex_state = 4},
  [2688] = {.lex_state = 15},
  [2689] = {.lex_state = 20},
  [2690] = {.lex_state = 94, .external_lex_state = 4},
  [2691] = {.lex_state = 94},
  [2692] = {.lex_state = 94, .external_lex_state = 5},
  [2693] = {.lex_state = 12},
  [2694] = {.lex_state = 12, .external_lex_state = 4},
  [2695] = {.lex_state = 11},
  [2696] = {.lex_state = 29},
  [2697] = {.lex_state = 11},
  [2698] = {.lex_state = 11},
  [2699] = {.lex_state = 11},
  [2700] = {.lex_state = 29},
  [2701] = {.lex_state = 94, .external_lex_state = 4},
  [2702] = {.lex_state = 20},
  [2703] = {.lex_state = 11},
  [2704] = {.lex_state = 29},
  [2705] = {.lex_state = 11},
  [2706] = {.lex_state = 29},
  [2707] = {.lex_state = 94, .external_lex_state = 5},
  [2708] = {.lex_state = 11},
  [2709] = {.lex_state = 11},
  [2710] = {.lex_state = 94},
  [2711] = {.lex_state = 94, .external_lex_state = 4},
  [2712] = {.lex_state = 94, .external_lex_state = 5},
  [2713] = {.lex_state = 94, .external_lex_state = 5},
  [2714] = {.lex_state = 11},
  [2715] = {.lex_state = 94},
  [2716] = {.lex_state = 94, .external_lex_state = 4},
  [2717] = {.lex_state = 29},
  [2718] = {.lex_state = 94, .external_lex_state = 5},
  [2719] = {.lex_state = 94, .external_lex_state = 5},
  [2720] = {.lex_state = 94, .external_lex_state = 5},
  [2721] = {.lex_state = 29},
  [2722] = {.lex_state = 12},
  [2723] = {.lex_state = 29},
  [2724] = {.lex_state = 11},
  [2725] = {.lex_state = 94},
  [2726] = {.lex_state = 11},
  [2727] = {.lex_state = 29},
  [2728] = {.lex_state = 94},
  [2729] = {.lex_state = 20},
  [2730] = {.lex_state = 11},
  [2731] = {.lex_state = 12},
  [2732] = {.lex_state = 29},
  [2733] = {.lex_state = 94},
  [2734] = {.lex_state = 94, .external_lex_state = 5},
  [2735] = {.lex_state = 20},
  [2736] = {.lex_state = 20},
  [2737] = {.lex_state = 20},
  [2738] = {.lex_state = 94, .external_lex_state = 4},
  [2739] = {.lex_state = 94, .external_lex_state = 5},
  [2740] = {.lex_state = 94, .external_lex_state = 5},
  [2741] = {.lex_state = 94, .external_lex_state = 5},
  [2742] = {.lex_state = 94, .external_lex_state = 5},
  [2743] = {.lex_state = 94, .external_lex_state = 5},
  [2744] = {.lex_state = 11},
  [2745] = {.lex_state = 94, .external_lex_state = 5},
  [2746] = {.lex_state = 94, .external_lex_state = 5},
  [2747] = {.lex_state = 94, .external_lex_state = 5},
  [2748] = {.lex_state = 94, .external_lex_state = 5},
  [2749] = {.lex_state = 11},
  [2750] = {.lex_state = 94, .external_lex_state = 5},
  [2751] = {.lex_state = 11},
  [2752] = {.lex_state = 29},
  [2753] = {.lex_state = 20},
  [2754] = {.lex_state = 94, .external_lex_state = 5},
  [2755] = {.lex_state = 20},
  [2756] = {.lex_state = 94, .external_lex_state = 5},
  [2757] = {.lex_state = 11},
  [2758] = {.lex_state = 94},
  [2759] = {.lex_state = 94, .external_lex_state = 5},
  [2760] = {.lex_state = 94, .external_lex_state = 5},
  [2761] = {.lex_state = 12},
  [2762] = {.lex_state = 12},
  [2763] = {.lex_state = 12},
  [2764] = {.lex_state = 94, .external_lex_state = 5},
  [2765] = {.lex_state = 94, .external_lex_state = 5},
  [2766] = {.lex_state = 94},
  [2767] = {.lex_state = 94, .external_lex_state = 5},
  [2768] = {.lex_state = 94, .external_lex_state = 4},
  [2769] = {.lex_state = 94, .external_lex_state = 5},
  [2770] = {.lex_state = 94, .external_lex_state = 5},
  [2771] = {.lex_state = 94, .external_lex_state = 5},
  [2772] = {.lex_state = 94, .external_lex_state = 5},
  [2773] = {.lex_state = 94, .external_lex_state = 5},
  [2774] = {.lex_state = 11},
  [2775] = {.lex_state = 94, .external_lex_state = 5},
  [2776] = {.lex_state = 94, .external_lex_state = 5},
  [2777] = {.lex_state = 11},
  [2778] = {.lex_state = 11},
  [2779] = {.lex_state = 94, .external_lex_state = 5},
  [2780] = {.lex_state = 20},
  [2781] = {.lex_state = 20},
  [2782] = {.lex_state = 94},
  [2783] = {.lex_state = 94, .external_lex_state = 5},
  [2784] = {.lex_state = 12},
  [2785] = {.lex_state = 20},
  [2786] = {.lex_state = 20},
  [2787] = {.lex_state = 94, .external_lex_state = 5},
  [2788] = {.lex_state = 20},
  [2789] = {.lex_state = 20},
  [2790] = {.lex_state = 94, .external_lex_state = 4},
  [2791] = {.lex_state = 20},
  [2792] = {.lex_state = 11},
  [2793] = {.lex_state = 11},
  [2794] = {.lex_state = 94, .external_lex_state = 5},
  [2795] = {.lex_state = 94, .external_lex_state = 5},
  [2796] = {.lex_state = 20},
  [2797] = {.lex_state = 94},
  [2798] = {.lex_state = 94, .external_lex_state = 5},
  [2799] = {.lex_state = 94, .external_lex_state = 5},
  [2800] = {.lex_state = 94, .external_lex_state = 5},
  [2801] = {.lex_state = 94, .external_lex_state = 5},
  [2802] = {.lex_state = 94, .external_lex_state = 5},
  [2803] = {.lex_state = 94},
  [2804] = {.lex_state = 20},
  [2805] = {.lex_state = 20},
  [2806] = {.lex_state = 11},
  [2807] = {.lex_state = 94, .external_lex_state = 4},
  [2808] = {.lex_state = 20},
  [2809] = {.lex_state = 29},
  [2810] = {.lex_state = 29},
  [2811] = {.lex_state = 20},
  [2812] = {.lex_state = 12},
  [2813] = {.lex_state = 94, .external_lex_state = 5},
  [2814] = {.lex_state = 94, .external_lex_state = 5},
  [2815] = {.lex_state = 94, .external_lex_state = 5},
  [2816] = {.lex_state = 20},
  [2817] = {.lex_state = 94, .external_lex_state = 5},
  [2818] = {.lex_state = 11},
  [2819] = {.lex_state = 20},
  [2820] = {.lex_state = 20},
  [2821] = {.lex_state = 20},
  [2822] = {.lex_state = 20},
  [2823] = {.lex_state = 20},
  [2824] = {.lex_state = 11},
  [2825] = {.lex_state = 94, .external_lex_state = 5},
  [2826] = {.lex_state = 94, .external_lex_state = 4},
  [2827] = {.lex_state = 20},
  [2828] = {.lex_state = 94, .external_lex_state = 5},
  [2829] = {.lex_state = 94, .external_lex_state = 5},
  [2830] = {.lex_state = 94, .external_lex_state = 5},
  [2831] = {.lex_state = 11},
  [2832] = {.lex_state = 20},
  [2833] = {.lex_state = 29},
  [2834] = {.lex_state = 20},
  [2835] = {.lex_state = 20},
  [2836] = {.lex_state = 20},
  [2837] = {.lex_state = 11},
  [2838] = {.lex_state = 94, .external_lex_state = 5},
  [2839] = {.lex_state = 15},
  [2840] = {.lex_state = 94},
  [2841] = {.lex_state = 18, .external_lex_state = 6},
  [2842] = {.lex_state = 18, .external_lex_state = 6},
  [2843] = {.lex_state = 94},
  [2844] = {.lex_state = 94},
  [2845] = {.lex_state = 18, .external_lex_state = 6},
  [2846] = {.lex_state = 94, .external_lex_state = 4},
  [2847] = {.lex_state = 94, .external_lex_state = 4},
  [2848] = {.lex_state = 20},
  [2849] = {.lex_state = 18, .external_lex_state = 6},
  [2850] = {.lex_state = 94, .external_lex_state = 4},
  [2851] = {.lex_state = 94, .external_lex_state = 5},
  [2852] = {.lex_state = 18, .external_lex_state = 6},
  [2853] = {.lex_state = 18, .external_lex_state = 6},
  [2854] = {.lex_state = 15},
  [2855] = {.lex_state = 18, .external_lex_state = 6},
  [2856] = {.lex_state = 15},
  [2857] = {.lex_state = 94, .external_lex_state = 4},
  [2858] = {.lex_state = 94},
  [2859] = {.lex_state = 94},
  [2860] = {.lex_state = 18, .external_lex_state = 6},
  [2861] = {.lex_state = 94, .external_lex_state = 4},
  [2862] = {.lex_state = 12},
  [2863] = {.lex_state = 94, .external_lex_state = 4},
  [2864] = {.lex_state = 94, .external_lex_state = 4},
  [2865] = {.lex_state = 94},
  [2866] = {.lex_state = 94, .external_lex_state = 4},
  [2867] = {.lex_state = 94, .external_lex_state = 4},
  [2868] = {.lex_state = 94, .external_lex_state = 4},
  [2869] = {.lex_state = 94, .external_lex_state = 4},
  [2870] = {.lex_state = 94},
  [2871] = {.lex_state = 12},
  [2872] = {.lex_state = 12},
  [2873] = {.lex_state = 94},
  [2874] = {.lex_state = 0, .external_lex_state = 4},
  [2875] = {.lex_state = 0, .external_lex_state = 4},
  [2876] = {.lex_state = 94, .external_lex_state = 4},
  [2877] = {.lex_state = 94},
  [2878] = {.lex_state = 94},
  [2879] = {.lex_state = 0, .external_lex_state = 4},
  [2880] = {.lex_state = 20},
  [2881] = {.lex_state = 94},
  [2882] = {.lex_state = 12},
  [2883] = {.lex_state = 94},
  [2884] = {.lex_state = 20},
  [2885] = {.lex_state = 20},
  [2886] = {.lex_state = 94, .external_lex_state = 4},
  [2887] = {.lex_state = 94},
  [2888] = {.lex_state = 94},
  [2889] = {.lex_state = 94},
  [2890] = {.lex_state = 94},
  [2891] = {.lex_state = 94},
  [2892] = {.lex_state = 94, .external_lex_state = 4},
  [2893] = {.lex_state = 94, .external_lex_state = 4},
  [2894] = {.lex_state = 12},
  [2895] = {.lex_state = 94, .external_lex_state = 4},
  [2896] = {.lex_state = 12},
  [2897] = {.lex_state = 94, .external_lex_state = 4},
  [2898] = {.lex_state = 12},
  [2899] = {.lex_state = 94},
  [2900] = {.lex_state = 94},
  [2901] = {.lex_state = 0, .external_lex_state = 4},
  [2902] = {.lex_state = 94, .external_lex_state = 4},
  [2903] = {.lex_state = 94, .external_lex_state = 4},
  [2904] = {.lex_state = 94},
  [2905] = {.lex_state = 94},
  [2906] = {.lex_state = 12},
  [2907] = {.lex_state = 94},
  [2908] = {.lex_state = 94},
  [2909] = {.lex_state = 94, .external_lex_state = 4},
  [2910] = {.lex_state = 12},
  [2911] = {.lex_state = 94, .external_lex_state = 4},
  [2912] = {.lex_state = 94, .external_lex_state = 4},
  [2913] = {.lex_state = 94},
  [2914] = {.lex_state = 94, .external_lex_state = 4},
  [2915] = {.lex_state = 94, .external_lex_state = 4},
  [2916] = {.lex_state = 94, .external_lex_state = 4},
  [2917] = {.lex_state = 94, .external_lex_state = 4},
  [2918] = {.lex_state = 0, .external_lex_state = 4},
  [2919] = {.lex_state = 94},
  [2920] = {.lex_state = 94, .external_lex_state = 4},
  [2921] = {.lex_state = 0, .external_lex_state = 4},
  [2922] = {.lex_state = 94, .external_lex_state = 4},
  [2923] = {.lex_state = 94, .external_lex_state = 4},
  [2924] = {.lex_state = 94, .external_lex_state = 4},
  [2925] = {.lex_state = 94, .external_lex_state = 4},
  [2926] = {.lex_state = 12},
  [2927] = {.lex_state = 94},
  [2928] = {.lex_state = 12},
  [2929] = {.lex_state = 94, .external_lex_state = 4},
  [2930] = {.lex_state = 94},
  [2931] = {.lex_state = 94},
  [2932] = {.lex_state = 94},
  [2933] = {.lex_state = 94, .external_lex_state = 4},
  [2934] = {.lex_state = 94, .external_lex_state = 4},
  [2935] = {.lex_state = 94, .external_lex_state = 4},
  [2936] = {.lex_state = 12},
  [2937] = {.lex_state = 0, .external_lex_state = 4},
  [2938] = {.lex_state = 94, .external_lex_state = 4},
  [2939] = {.lex_state = 94, .external_lex_state = 4},
  [2940] = {.lex_state = 94, .external_lex_state = 4},
  [2941] = {.lex_state = 94},
  [2942] = {.lex_state = 94},
  [2943] = {.lex_state = 94},
  [2944] = {.lex_state = 94},
  [2945] = {.lex_state = 0, .external_lex_state = 4},
  [2946] = {.lex_state = 94},
  [2947] = {.lex_state = 12},
  [2948] = {.lex_state = 0, .external_lex_state = 4},
  [2949] = {.lex_state = 94},
  [2950] = {.lex_state = 94, .external_lex_state = 4},
  [2951] = {.lex_state = 12},
  [2952] = {.lex_state = 94},
  [2953] = {.lex_state = 94},
  [2954] = {.lex_state = 94},
  [2955] = {.lex_state = 94},
  [2956] = {.lex_state = 12},
  [2957] = {.lex_state = 12},
  [2958] = {.lex_state = 94},
  [2959] = {.lex_state = 94, .external_lex_state = 4},
  [2960] = {.lex_state = 0, .external_lex_state = 4},
  [2961] = {.lex_state = 94},
  [2962] = {.lex_state = 20},
  [2963] = {.lex_state = 0, .external_lex_state = 4},
  [2964] = {.lex_state = 12},
  [2965] = {.lex_state = 94},
  [2966] = {.lex_state = 94},
  [2967] = {.lex_state = 12},
  [2968] = {.lex_state = 94},
  [2969] = {.lex_state = 94},
  [2970] = {.lex_state = 94, .external_lex_state = 4},
  [2971] = {.lex_state = 94},
  [2972] = {.lex_state = 94},
  [2973] = {.lex_state = 94},
  [2974] = {.lex_state = 12},
  [2975] = {.lex_state = 94},
  [2976] = {.lex_state = 12},
  [2977] = {.lex_state = 16},
  [2978] = {.lex_state = 94},
  [2979] = {.lex_state = 94},
  [2980] = {.lex_state = 94},
  [2981] = {.lex_state = 94},
  [2982] = {.lex_state = 16},
  [2983] = {.lex_state = 20},
  [2984] = {.lex_state = 94},
  [2985] = {.lex_state = 16},
  [2986] = {.lex_state = 12},
  [2987] = {.lex_state = 0, .external_lex_state = 4},
  [2988] = {.lex_state = 94},
  [2989] = {.lex_state = 16},
  [2990] = {.lex_state = 12},
  [2991] = {.lex_state = 16},
  [2992] = {.lex_state = 12},
  [2993] = {.lex_state = 94, .external_lex_state = 5},
  [2994] = {.lex_state = 12},
  [2995] = {.lex_state = 12},
  [2996] = {.lex_state = 12},
  [2997] = {.lex_state = 18, .external_lex_state = 6},
  [2998] = {.lex_state = 94},
  [2999] = {.lex_state = 94, .external_lex_state = 5},
  [3000] = {.lex_state = 20},
  [3001] = {.lex_state = 12},
  [3002] = {.lex_state = 94, .external_lex_state = 5},
  [3003] = {.lex_state = 94},
  [3004] = {.lex_state = 12},
  [3005] = {.lex_state = 94, .external_lex_state = 5},
  [3006] = {.lex_state = 94},
  [3007] = {.lex_state = 12},
  [3008] = {.lex_state = 0, .external_lex_state = 4},
  [3009] = {.lex_state = 94},
  [3010] = {.lex_state = 0, .external_lex_state = 4},
  [3011] = {.lex_state = 94},
  [3012] = {.lex_state = 94},
  [3013] = {.lex_state = 94},
  [3014] = {.lex_state = 16},
  [3015] = {.lex_state = 12},
  [3016] = {.lex_state = 18, .external_lex_state = 6},
  [3017] = {.lex_state = 12},
  [3018] = {.lex_state = 94},
  [3019] = {.lex_state = 94, .external_lex_state = 5},
  [3020] = {.lex_state = 94, .external_lex_state = 5},
  [3021] = {.lex_state = 94},
  [3022] = {.lex_state = 12},
  [3023] = {.lex_state = 94, .external_lex_state = 5},
  [3024] = {.lex_state = 16},
  [3025] = {.lex_state = 12},
  [3026] = {.lex_state = 20},
  [3027] = {.lex_state = 12},
  [3028] = {.lex_state = 0, .external_lex_state = 4},
  [3029] = {.lex_state = 12},
  [3030] = {.lex_state = 0, .external_lex_state = 4},
  [3031] = {.lex_state = 18, .external_lex_state = 6},
  [3032] = {.lex_state = 12},
  [3033] = {.lex_state = 94},
  [3034] = {.lex_state = 94},
  [3035] = {.lex_state = 94},
  [3036] = {.lex_state = 12},
  [3037] = {.lex_state = 16},
  [3038] = {.lex_state = 94},
  [3039] = {.lex_state = 94, .external_lex_state = 5},
  [3040] = {.lex_state = 94},
  [3041] = {.lex_state = 12},
  [3042] = {.lex_state = 94},
  [3043] = {.lex_state = 94},
  [3044] = {.lex_state = 20},
  [3045] = {.lex_state = 16},
  [3046] = {.lex_state = 94, .external_lex_state = 5},
  [3047] = {.lex_state = 20},
  [3048] = {.lex_state = 94, .external_lex_state = 5},
  [3049] = {.lex_state = 12},
  [3050] = {.lex_state = 94, .external_lex_state = 5},
  [3051] = {.lex_state = 94},
  [3052] = {.lex_state = 94},
  [3053] = {.lex_state = 94, .external_lex_state = 5},
  [3054] = {.lex_state = 0, .external_lex_state = 4},
  [3055] = {.lex_state = 0, .external_lex_state = 4},
  [3056] = {.lex_state = 0, .external_lex_state = 4},
  [3057] = {.lex_state = 94},
  [3058] = {.lex_state = 0, .external_lex_state = 4},
  [3059] = {.lex_state = 94},
  [3060] = {.lex_state = 12},
  [3061] = {.lex_state = 12},
  [3062] = {.lex_state = 18, .external_lex_state = 6},
  [3063] = {.lex_state = 16},
  [3064] = {.lex_state = 20},
  [3065] = {.lex_state = 16},
  [3066] = {.lex_state = 94},
  [3067] = {.lex_state = 12},
  [3068] = {.lex_state = 0, .external_lex_state = 4},
  [3069] = {.lex_state = 0, .external_lex_state = 4},
  [3070] = {.lex_state = 0, .external_lex_state = 4},
  [3071] = {.lex_state = 0, .external_lex_state = 4},
  [3072] = {.lex_state = 94},
  [3073] = {.lex_state = 20},
  [3074] = {.lex_state = 94},
  [3075] = {.lex_state = 12},
  [3076] = {.lex_state = 94, .external_lex_state = 5},
  [3077] = {.lex_state = 94, .external_lex_state = 5},
  [3078] = {.lex_state = 0},
  [3079] = {.lex_state = 94},
  [3080] = {.lex_state = 12},
  [3081] = {.lex_state = 0, .external_lex_state = 4},
  [3082] = {.lex_state = 94, .external_lex_state = 5},
  [3083] = {.lex_state = 0, .external_lex_state = 4},
  [3084] = {.lex_state = 0, .external_lex_state = 4},
  [3085] = {.lex_state = 12},
  [3086] = {.lex_state = 20},
  [3087] = {.lex_state = 94},
  [3088] = {.lex_state = 0, .external_lex_state = 4},
  [3089] = {.lex_state = 94},
  [3090] = {.lex_state = 20},
  [3091] = {.lex_state = 94, .external_lex_state = 5},
  [3092] = {.lex_state = 12},
  [3093] = {.lex_state = 94},
  [3094] = {.lex_state = 94, .external_lex_state = 4},
  [3095] = {.lex_state = 12},
  [3096] = {.lex_state = 94, .external_lex_state = 4},
  [3097] = {.lex_state = 94, .external_lex_state = 4},
  [3098] = {.lex_state = 12},
  [3099] = {.lex_state = 20},
  [3100] = {.lex_state = 20},
  [3101] = {.lex_state = 94, .external_lex_state = 4},
  [3102] = {.lex_state = 94, .external_lex_state = 5},
  [3103] = {.lex_state = 94, .external_lex_state = 5},
  [3104] = {.lex_state = 94},
  [3105] = {.lex_state = 16},
  [3106] = {.lex_state = 0, .external_lex_state = 4},
  [3107] = {.lex_state = 18, .external_lex_state = 6},
  [3108] = {.lex_state = 0, .external_lex_state = 4},
  [3109] = {.lex_state = 12},
  [3110] = {.lex_state = 0, .external_lex_state = 4},
  [3111] = {.lex_state = 94, .external_lex_state = 5},
  [3112] = {.lex_state = 12},
  [3113] = {.lex_state = 0, .external_lex_state = 4},
  [3114] = {.lex_state = 12},
  [3115] = {.lex_state = 94},
  [3116] = {.lex_state = 94, .external_lex_state = 5},
  [3117] = {.lex_state = 94, .external_lex_state = 5},
  [3118] = {.lex_state = 94},
  [3119] = {.lex_state = 12},
  [3120] = {.lex_state = 94, .external_lex_state = 5},
  [3121] = {.lex_state = 94, .external_lex_state = 5},
  [3122] = {.lex_state = 94, .external_lex_state = 5},
  [3123] = {.lex_state = 94},
  [3124] = {.lex_state = 94, .external_lex_state = 5},
  [3125] = {.lex_state = 94},
  [3126] = {.lex_state = 94, .external_lex_state = 5},
  [3127] = {.lex_state = 94},
  [3128] = {.lex_state = 12},
  [3129] = {.lex_state = 12},
  [3130] = {.lex_state = 12},
  [3131] = {.lex_state = 0, .external_lex_state = 4},
  [3132] = {.lex_state = 12},
  [3133] = {.lex_state = 94},
  [3134] = {.lex_state = 16},
  [3135] = {.lex_state = 94, .external_lex_state = 5},
  [3136] = {.lex_state = 12},
  [3137] = {.lex_state = 16},
  [3138] = {.lex_state = 94},
  [3139] = {.lex_state = 0, .external_lex_state = 4},
  [3140] = {.lex_state = 0, .external_lex_state = 4},
  [3141] = {.lex_state = 94},
  [3142] = {.lex_state = 0, .external_lex_state = 4},
  [3143] = {.lex_state = 94},
  [3144] = {.lex_state = 12},
  [3145] = {.lex_state = 94},
  [3146] = {.lex_state = 94},
  [3147] = {.lex_state = 94},
  [3148] = {.lex_state = 12},
  [3149] = {.lex_state = 94},
  [3150] = {.lex_state = 0, .external_lex_state = 4},
  [3151] = {.lex_state = 0, .external_lex_state = 4},
  [3152] = {.lex_state = 0, .external_lex_state = 4},
  [3153] = {.lex_state = 0, .external_lex_state = 4},
  [3154] = {.lex_state = 0, .external_lex_state = 4},
  [3155] = {.lex_state = 94},
  [3156] = {.lex_state = 0, .external_lex_state = 4},
  [3157] = {.lex_state = 18, .external_lex_state = 6},
  [3158] = {.lex_state = 94, .external_lex_state = 5},
  [3159] = {.lex_state = 0, .external_lex_state = 4},
  [3160] = {.lex_state = 0, .external_lex_state = 4},
  [3161] = {.lex_state = 94},
  [3162] = {.lex_state = 94},
  [3163] = {.lex_state = 0, .external_lex_state = 4},
  [3164] = {.lex_state = 94},
  [3165] = {.lex_state = 0},
  [3166] = {.lex_state = 12},
  [3167] = {.lex_state = 94},
  [3168] = {.lex_state = 0, .external_lex_state = 4},
  [3169] = {.lex_state = 0},
  [3170] = {.lex_state = 0, .external_lex_state = 4},
  [3171] = {.lex_state = 20},
  [3172] = {.lex_state = 0},
  [3173] = {.lex_state = 0, .external_lex_state = 4},
  [3174] = {.lex_state = 94},
  [3175] = {.lex_state = 20},
  [3176] = {.lex_state = 0, .external_lex_state = 4},
  [3177] = {.lex_state = 20},
  [3178] = {.lex_state = 0, .external_lex_state = 4},
  [3179] = {.lex_state = 94},
  [3180] = {.lex_state = 0, .external_lex_state = 4},
  [3181] = {.lex_state = 0, .external_lex_state = 4},
  [3182] = {.lex_state = 0, .external_lex_state = 4},
  [3183] = {.lex_state = 0, .external_lex_state = 4},
  [3184] = {.lex_state = 94},
  [3185] = {.lex_state = 0, .external_lex_state = 4},
  [3186] = {.lex_state = 20},
  [3187] = {.lex_state = 94, .external_lex_state = 5},
  [3188] = {.lex_state = 0, .external_lex_state = 4},
  [3189] = {.lex_state = 12},
  [3190] = {.lex_state = 0, .external_lex_state = 4},
  [3191] = {.lex_state = 94, .external_lex_state = 4},
  [3192] = {.lex_state = 18, .external_lex_state = 6},
  [3193] = {.lex_state = 0, .external_lex_state = 4},
  [3194] = {.lex_state = 18, .external_lex_state = 6},
  [3195] = {.lex_state = 12},
  [3196] = {.lex_state = 0, .external_lex_state = 4},
  [3197] = {.lex_state = 0, .external_lex_state = 4},
  [3198] = {.lex_state = 94},
  [3199] = {.lex_state = 20},
  [3200] = {.lex_state = 12},
  [3201] = {.lex_state = 0, .external_lex_state = 4},
  [3202] = {.lex_state = 12},
  [3203] = {.lex_state = 0},
  [3204] = {.lex_state = 12},
  [3205] = {.lex_state = 12},
  [3206] = {.lex_state = 0, .external_lex_state = 4},
  [3207] = {.lex_state = 12},
  [3208] = {.lex_state = 0, .external_lex_state = 4},
  [3209] = {.lex_state = 12},
  [3210] = {.lex_state = 12},
  [3211] = {.lex_state = 0, .external_lex_state = 4},
  [3212] = {.lex_state = 94, .external_lex_state = 5},
  [3213] = {.lex_state = 94},
  [3214] = {.lex_state = 0, .external_lex_state = 4},
  [3215] = {.lex_state = 94},
  [3216] = {.lex_state = 0, .external_lex_state = 4},
  [3217] = {.lex_state = 20},
  [3218] = {.lex_state = 0, .external_lex_state = 4},
  [3219] = {.lex_state = 0},
  [3220] = {.lex_state = 0, .external_lex_state = 4},
  [3221] = {.lex_state = 0},
  [3222] = {.lex_state = 0},
  [3223] = {.lex_state = 0, .external_lex_state = 4},
  [3224] = {.lex_state = 0, .external_lex_state = 4},
  [3225] = {.lex_state = 0, .external_lex_state = 4},
  [3226] = {.lex_state = 0, .external_lex_state = 4},
  [3227] = {.lex_state = 0},
  [3228] = {.lex_state = 12},
  [3229] = {.lex_state = 0, .external_lex_state = 4},
  [3230] = {.lex_state = 12},
  [3231] = {.lex_state = 0, .external_lex_state = 4},
  [3232] = {.lex_state = 16},
  [3233] = {.lex_state = 94},
  [3234] = {.lex_state = 12},
  [3235] = {.lex_state = 18, .external_lex_state = 6},
  [3236] = {.lex_state = 94, .external_lex_state = 5},
  [3237] = {.lex_state = 94, .external_lex_state = 4},
  [3238] = {.lex_state = 12},
  [3239] = {.lex_state = 20},
  [3240] = {.lex_state = 12},
  [3241] = {.lex_state = 20},
  [3242] = {.lex_state = 0},
  [3243] = {.lex_state = 94, .external_lex_state = 5},
  [3244] = {.lex_state = 0, .external_lex_state = 4},
  [3245] = {.lex_state = 12},
  [3246] = {.lex_state = 94, .external_lex_state = 4},
  [3247] = {.lex_state = 94, .external_lex_state = 4},
  [3248] = {.lex_state = 0, .external_lex_state = 4},
  [3249] = {.lex_state = 0, .external_lex_state = 4},
  [3250] = {.lex_state = 94, .external_lex_state = 5},
  [3251] = {.lex_state = 0, .external_lex_state = 4},
  [3252] = {.lex_state = 12},
  [3253] = {.lex_state = 20},
  [3254] = {.lex_state = 0, .external_lex_state = 4},
  [3255] = {.lex_state = 12},
  [3256] = {.lex_state = 94, .external_lex_state = 4},
  [3257] = {.lex_state = 94},
  [3258] = {.lex_state = 12},
  [3259] = {.lex_state = 94, .external_lex_state = 4},
  [3260] = {.lex_state = 18, .external_lex_state = 6},
  [3261] = {.lex_state = 94},
  [3262] = {.lex_state = 94},
  [3263] = {.lex_state = 94},
  [3264] = {.lex_state = 94},
  [3265] = {.lex_state = 0, .external_lex_state = 4},
  [3266] = {.lex_state = 12},
  [3267] = {.lex_state = 12},
  [3268] = {.lex_state = 94},
  [3269] = {.lex_state = 0, .external_lex_state = 4},
  [3270] = {.lex_state = 12},
  [3271] = {.lex_state = 20},
  [3272] = {.lex_state = 20},
  [3273] = {.lex_state = 12},
  [3274] = {.lex_state = 0, .external_lex_state = 4},
  [3275] = {.lex_state = 0, .external_lex_state = 4},
  [3276] = {.lex_state = 0, .external_lex_state = 4},
  [3277] = {.lex_state = 94, .external_lex_state = 5},
  [3278] = {.lex_state = 94},
  [3279] = {.lex_state = 20},
  [3280] = {.lex_state = 0, .external_lex_state = 4},
  [3281] = {.lex_state = 0, .external_lex_state = 4},
  [3282] = {.lex_state = 0, .external_lex_state = 4},
  [3283] = {.lex_state = 0, .external_lex_state = 4},
  [3284] = {.lex_state = 0, .external_lex_state = 4},
  [3285] = {.lex_state = 0, .external_lex_state = 4},
  [3286] = {.lex_state = 12},
  [3287] = {.lex_state = 0, .external_lex_state = 4},
  [3288] = {.lex_state = 0, .external_lex_state = 4},
  [3289] = {.lex_state = 0, .external_lex_state = 4},
  [3290] = {.lex_state = 0, .external_lex_state = 4},
  [3291] = {.lex_state = 0, .external_lex_state = 4},
  [3292] = {.lex_state = 94},
  [3293] = {.lex_state = 0, .external_lex_state = 4},
  [3294] = {.lex_state = 0, .external_lex_state = 4},
  [3295] = {.lex_state = 0, .external_lex_state = 4},
  [3296] = {.lex_state = 0, .external_lex_state = 4},
  [3297] = {.lex_state = 0, .external_lex_state = 4},
  [3298] = {.lex_state = 12},
  [3299] = {.lex_state = 0, .external_lex_state = 4},
  [3300] = {.lex_state = 0, .external_lex_state = 4},
  [3301] = {.lex_state = 0, .external_lex_state = 4},
  [3302] = {.lex_state = 0, .external_lex_state = 4},
  [3303] = {.lex_state = 94, .external_lex_state = 5},
  [3304] = {.lex_state = 94, .external_lex_state = 5},
  [3305] = {.lex_state = 20},
  [3306] = {.lex_state = 0, .external_lex_state = 4},
  [3307] = {.lex_state = 0, .external_lex_state = 4},
  [3308] = {.lex_state = 0, .external_lex_state = 4},
  [3309] = {.lex_state = 0, .external_lex_state = 4},
  [3310] = {.lex_state = 0, .external_lex_state = 4},
  [3311] = {.lex_state = 0, .external_lex_state = 4},
  [3312] = {.lex_state = 0},
  [3313] = {.lex_state = 0, .external_lex_state = 4},
  [3314] = {.lex_state = 0, .external_lex_state = 4},
  [3315] = {.lex_state = 94},
  [3316] = {.lex_state = 94},
  [3317] = {.lex_state = 0, .external_lex_state = 4},
  [3318] = {.lex_state = 0, .external_lex_state = 4},
  [3319] = {.lex_state = 94, .external_lex_state = 5},
  [3320] = {.lex_state = 0, .external_lex_state = 4},
  [3321] = {.lex_state = 18, .external_lex_state = 6},
  [3322] = {.lex_state = 94},
  [3323] = {.lex_state = 0, .external_lex_state = 4},
  [3324] = {.lex_state = 0, .external_lex_state = 4},
  [3325] = {.lex_state = 0, .external_lex_state = 4},
  [3326] = {.lex_state = 20},
  [3327] = {.lex_state = 0, .external_lex_state = 4},
  [3328] = {.lex_state = 0, .external_lex_state = 4},
  [3329] = {.lex_state = 0, .external_lex_state = 4},
  [3330] = {.lex_state = 0, .external_lex_state = 4},
  [3331] = {.lex_state = 0, .external_lex_state = 4},
  [3332] = {.lex_state = 12},
  [3333] = {.lex_state = 0, .external_lex_state = 4},
  [3334] = {.lex_state = 0, .external_lex_state = 4},
  [3335] = {.lex_state = 12},
  [3336] = {.lex_state = 0, .external_lex_state = 4},
  [3337] = {.lex_state = 0, .external_lex_state = 4},
  [3338] = {.lex_state = 0, .external_lex_state = 4},
  [3339] = {.lex_state = 0, .external_lex_state = 4},
  [3340] = {.lex_state = 0, .external_lex_state = 4},
  [3341] = {.lex_state = 0, .external_lex_state = 4},
  [3342] = {.lex_state = 12},
  [3343] = {.lex_state = 12},
  [3344] = {.lex_state = 12},
  [3345] = {.lex_state = 0, .external_lex_state = 4},
  [3346] = {.lex_state = 0, .external_lex_state = 4},
  [3347] = {.lex_state = 0, .external_lex_state = 4},
  [3348] = {.lex_state = 0},
  [3349] = {.lex_state = 12},
  [3350] = {.lex_state = 20},
  [3351] = {.lex_state = 0, .external_lex_state = 4},
  [3352] = {.lex_state = 0, .external_lex_state = 4},
  [3353] = {.lex_state = 0, .external_lex_state = 4},
  [3354] = {.lex_state = 20},
  [3355] = {.lex_state = 94},
  [3356] = {.lex_state = 94},
  [3357] = {.lex_state = 18, .external_lex_state = 6},
  [3358] = {.lex_state = 18, .external_lex_state = 6},
  [3359] = {.lex_state = 12},
  [3360] = {.lex_state = 0, .external_lex_state = 4},
  [3361] = {.lex_state = 0, .external_lex_state = 4},
  [3362] = {.lex_state = 16},
  [3363] = {.lex_state = 0, .external_lex_state = 4},
  [3364] = {.lex_state = 12},
  [3365] = {.lex_state = 18, .external_lex_state = 6},
  [3366] = {.lex_state = 12},
  [3367] = {.lex_state = 20},
  [3368] = {.lex_state = 94, .external_lex_state = 5},
  [3369] = {.lex_state = 0, .external_lex_state = 4},
  [3370] = {.lex_state = 18, .external_lex_state = 6},
  [3371] = {.lex_state = 0, .external_lex_state = 4},
  [3372] = {.lex_state = 0, .external_lex_state = 4},
  [3373] = {.lex_state = 0, .external_lex_state = 4},
  [3374] = {.lex_state = 0, .external_lex_state = 4},
  [3375] = {.lex_state = 0, .external_lex_state = 4},
  [3376] = {.lex_state = 0, .external_lex_state = 4},
  [3377] = {.lex_state = 94},
  [3378] = {.lex_state = 0, .external_lex_state = 4},
  [3379] = {.lex_state = 12},
  [3380] = {.lex_state = 0, .external_lex_state = 4},
  [3381] = {.lex_state = 0, .external_lex_state = 4},
  [3382] = {.lex_state = 12},
  [3383] = {.lex_state = 0, .external_lex_state = 4},
  [3384] = {.lex_state = 4},
  [3385] = {.lex_state = 12},
  [3386] = {.lex_state = 12},
  [3387] = {.lex_state = 0, .external_lex_state = 4},
  [3388] = {.lex_state = 0},
  [3389] = {.lex_state = 0, .external_lex_state = 4},
  [3390] = {.lex_state = 12},
  [3391] = {.lex_state = 0, .external_lex_state = 4},
  [3392] = {.lex_state = 12},
  [3393] = {.lex_state = 18, .external_lex_state = 6},
  [3394] = {.lex_state = 0, .external_lex_state = 4},
  [3395] = {.lex_state = 0, .external_lex_state = 4},
  [3396] = {.lex_state = 0, .external_lex_state = 4},
  [3397] = {.lex_state = 94},
  [3398] = {.lex_state = 94, .external_lex_state = 5},
  [3399] = {.lex_state = 0, .external_lex_state = 4},
  [3400] = {.lex_state = 0, .external_lex_state = 4},
  [3401] = {.lex_state = 12},
  [3402] = {.lex_state = 0, .external_lex_state = 4},
  [3403] = {.lex_state = 12},
  [3404] = {.lex_state = 12},
  [3405] = {.lex_state = 12},
  [3406] = {.lex_state = 94, .external_lex_state = 4},
  [3407] = {.lex_state = 12},
  [3408] = {.lex_state = 12},
  [3409] = {.lex_state = 12},
  [3410] = {.lex_state = 0, .external_lex_state = 4},
  [3411] = {.lex_state = 0, .external_lex_state = 4},
  [3412] = {.lex_state = 94, .external_lex_state = 5},
  [3413] = {.lex_state = 0, .external_lex_state = 4},
  [3414] = {.lex_state = 12},
  [3415] = {.lex_state = 12},
  [3416] = {.lex_state = 12},
  [3417] = {.lex_state = 0},
  [3418] = {.lex_state = 94},
  [3419] = {.lex_state = 12},
  [3420] = {.lex_state = 0, .external_lex_state = 4},
  [3421] = {.lex_state = 20},
  [3422] = {.lex_state = 0, .external_lex_state = 4},
  [3423] = {.lex_state = 0, .external_lex_state = 4},
  [3424] = {.lex_state = 0, .external_lex_state = 4},
  [3425] = {.lex_state = 12},
  [3426] = {.lex_state = 0, .external_lex_state = 4},
  [3427] = {.lex_state = 12},
  [3428] = {.lex_state = 0, .external_lex_state = 4},
  [3429] = {.lex_state = 20},
  [3430] = {.lex_state = 0, .external_lex_state = 4},
  [3431] = {.lex_state = 0, .external_lex_state = 4},
  [3432] = {.lex_state = 4},
  [3433] = {.lex_state = 0, .external_lex_state = 4},
  [3434] = {.lex_state = 12},
  [3435] = {.lex_state = 0},
  [3436] = {.lex_state = 0, .external_lex_state = 4},
  [3437] = {.lex_state = 12},
  [3438] = {.lex_state = 12},
  [3439] = {.lex_state = 94},
  [3440] = {.lex_state = 94, .external_lex_state = 5},
  [3441] = {.lex_state = 12},
  [3442] = {.lex_state = 94},
  [3443] = {.lex_state = 0, .external_lex_state = 4},
  [3444] = {.lex_state = 94},
  [3445] = {.lex_state = 94, .external_lex_state = 4},
  [3446] = {.lex_state = 94},
  [3447] = {.lex_state = 0, .external_lex_state = 4},
  [3448] = {.lex_state = 12},
  [3449] = {.lex_state = 94, .external_lex_state = 4},
  [3450] = {.lex_state = 94},
  [3451] = {.lex_state = 0},
  [3452] = {.lex_state = 0},
  [3453] = {.lex_state = 17},
  [3454] = {.lex_state = 0, .external_lex_state = 4},
  [3455] = {.lex_state = 0},
  [3456] = {.lex_state = 94},
  [3457] = {.lex_state = 0, .external_lex_state = 4},
  [3458] = {.lex_state = 21},
  [3459] = {.lex_state = 94},
  [3460] = {.lex_state = 21},
  [3461] = {.lex_state = 94},
  [3462] = {.lex_state = 21},
  [3463] = {.lex_state = 17},
  [3464] = {.lex_state = 12},
  [3465] = {.lex_state = 21},
  [3466] = {.lex_state = 0, .external_lex_state = 4},
  [3467] = {.lex_state = 17},
  [3468] = {.lex_state = 21},
  [3469] = {.lex_state = 17},
  [3470] = {.lex_state = 17},
  [3471] = {.lex_state = 21},
  [3472] = {.lex_state = 94},
  [3473] = {.lex_state = 94},
  [3474] = {.lex_state = 12},
  [3475] = {.lex_state = 17},
  [3476] = {.lex_state = 94, .external_lex_state = 4},
  [3477] = {.lex_state = 16},
  [3478] = {.lex_state = 94},
  [3479] = {.lex_state = 17},
  [3480] = {.lex_state = 17},
  [3481] = {.lex_state = 21},
  [3482] = {.lex_state = 0},
  [3483] = {.lex_state = 0},
  [3484] = {.lex_state = 0},
  [3485] = {.lex_state = 21},
  [3486] = {.lex_state = 17},
  [3487] = {.lex_state = 0},
  [3488] = {.lex_state = 94},
  [3489] = {.lex_state = 94},
  [3490] = {.lex_state = 21},
  [3491] = {.lex_state = 17},
  [3492] = {.lex_state = 16},
  [3493] = {.lex_state = 94},
  [3494] = {.lex_state = 1},
  [3495] = {.lex_state = 12},
  [3496] = {.lex_state = 94},
  [3497] = {.lex_state = 17},
  [3498] = {.lex_state = 94},
  [3499] = {.lex_state = 17},
  [3500] = {.lex_state = 94},
  [3501] = {.lex_state = 94},
  [3502] = {.lex_state = 12},
  [3503] = {.lex_state = 12},
  [3504] = {.lex_state = 12},
  [3505] = {.lex_state = 21},
  [3506] = {.lex_state = 21},
  [3507] = {.lex_state = 17},
  [3508] = {.lex_state = 94},
  [3509] = {.lex_state = 0},
  [3510] = {.lex_state = 94},
  [3511] = {.lex_state = 94},
  [3512] = {.lex_state = 94},
  [3513] = {.lex_state = 94},
  [3514] = {.lex_state = 1},
  [3515] = {.lex_state = 21},
  [3516] = {.lex_state = 21},
  [3517] = {.lex_state = 17},
  [3518] = {.lex_state = 17},
  [3519] = {.lex_state = 94, .external_lex_state = 4},
  [3520] = {.lex_state = 0, .external_lex_state = 4},
  [3521] = {.lex_state = 0},
  [3522] = {.lex_state = 21},
  [3523] = {.lex_state = 17},
  [3524] = {.lex_state = 94},
  [3525] = {.lex_state = 0, .external_lex_state = 4},
  [3526] = {.lex_state = 1},
  [3527] = {.lex_state = 94},
  [3528] = {.lex_state = 1},
  [3529] = {.lex_state = 94},
  [3530] = {.lex_state = 12},
  [3531] = {.lex_state = 0, .external_lex_state = 5},
  [3532] = {.lex_state = 94},
  [3533] = {.lex_state = 94},
  [3534] = {.lex_state = 0, .external_lex_state = 4},
  [3535] = {.lex_state = 94},
  [3536] = {.lex_state = 0},
  [3537] = {.lex_state = 12},
  [3538] = {.lex_state = 21},
  [3539] = {.lex_state = 94},
  [3540] = {.lex_state = 94},
  [3541] = {.lex_state = 0},
  [3542] = {.lex_state = 18, .external_lex_state = 6},
  [3543] = {.lex_state = 0},
  [3544] = {.lex_state = 18, .external_lex_state = 6},
  [3545] = {.lex_state = 94},
  [3546] = {.lex_state = 12},
  [3547] = {.lex_state = 94},
  [3548] = {.lex_state = 94},
  [3549] = {.lex_state = 12},
  [3550] = {.lex_state = 12},
  [3551] = {.lex_state = 94},
  [3552] = {.lex_state = 94},
  [3553] = {.lex_state = 94},
  [3554] = {.lex_state = 0, .external_lex_state = 4},
  [3555] = {.lex_state = 16},
  [3556] = {.lex_state = 94},
  [3557] = {.lex_state = 0, .external_lex_state = 4},
  [3558] = {.lex_state = 12},
  [3559] = {.lex_state = 94},
  [3560] = {.lex_state = 21},
  [3561] = {.lex_state = 94},
  [3562] = {.lex_state = 94},
  [3563] = {.lex_state = 12},
  [3564] = {.lex_state = 94, .external_lex_state = 4},
  [3565] = {.lex_state = 94},
  [3566] = {.lex_state = 94},
  [3567] = {.lex_state = 12},
  [3568] = {.lex_state = 16},
  [3569] = {.lex_state = 12},
  [3570] = {.lex_state = 0},
  [3571] = {.lex_state = 17},
  [3572] = {.lex_state = 21},
  [3573] = {.lex_state = 94},
  [3574] = {.lex_state = 94},
  [3575] = {.lex_state = 0},
  [3576] = {.lex_state = 0},
  [3577] = {.lex_state = 94},
  [3578] = {.lex_state = 94},
  [3579] = {.lex_state = 94},
  [3580] = {.lex_state = 94},
  [3581] = {.lex_state = 0},
  [3582] = {.lex_state = 29},
  [3583] = {.lex_state = 0, .external_lex_state = 4},
  [3584] = {.lex_state = 0},
  [3585] = {.lex_state = 0},
  [3586] = {.lex_state = 0},
  [3587] = {.lex_state = 0, .external_lex_state = 4},
  [3588] = {.lex_state = 0},
  [3589] = {.lex_state = 94},
  [3590] = {.lex_state = 0},
  [3591] = {.lex_state = 0},
  [3592] = {.lex_state = 0},
  [3593] = {.lex_state = 94},
  [3594] = {.lex_state = 0, .external_lex_state = 4},
  [3595] = {.lex_state = 0},
  [3596] = {.lex_state = 0},
  [3597] = {.lex_state = 0},
  [3598] = {.lex_state = 0},
  [3599] = {.lex_state = 0},
  [3600] = {.lex_state = 94},
  [3601] = {.lex_state = 0},
  [3602] = {.lex_state = 0},
  [3603] = {.lex_state = 0, .external_lex_state = 4},
  [3604] = {.lex_state = 0},
  [3605] = {.lex_state = 94},
  [3606] = {.lex_state = 0},
  [3607] = {.lex_state = 0, .external_lex_state = 4},
  [3608] = {.lex_state = 0},
  [3609] = {.lex_state = 0},
  [3610] = {.lex_state = 94},
  [3611] = {.lex_state = 0},
  [3612] = {.lex_state = 0},
  [3613] = {.lex_state = 0, .external_lex_state = 4},
  [3614] = {.lex_state = 0},
  [3615] = {.lex_state = 94},
  [3616] = {.lex_state = 29},
  [3617] = {.lex_state = 94},
  [3618] = {.lex_state = 0},
  [3619] = {.lex_state = 94},
  [3620] = {.lex_state = 94},
  [3621] = {.lex_state = 94},
  [3622] = {.lex_state = 29},
  [3623] = {.lex_state = 0},
  [3624] = {.lex_state = 29},
  [3625] = {.lex_state = 29},
  [3626] = {.lex_state = 94},
  [3627] = {.lex_state = 0},
  [3628] = {.lex_state = 94},
  [3629] = {.lex_state = 94},
  [3630] = {.lex_state = 0},
  [3631] = {.lex_state = 0, .external_lex_state = 4},
  [3632] = {.lex_state = 0},
  [3633] = {.lex_state = 29},
  [3634] = {.lex_state = 94},
  [3635] = {.lex_state = 29},
  [3636] = {.lex_state = 94},
  [3637] = {.lex_state = 29},
  [3638] = {.lex_state = 29},
  [3639] = {.lex_state = 94},
  [3640] = {.lex_state = 0, .external_lex_state = 4},
  [3641] = {.lex_state = 94},
  [3642] = {.lex_state = 0},
  [3643] = {.lex_state = 94},
  [3644] = {.lex_state = 94},
  [3645] = {.lex_state = 94},
  [3646] = {.lex_state = 0},
  [3647] = {.lex_state = 0, .external_lex_state = 4},
  [3648] = {.lex_state = 94},
  [3649] = {.lex_state = 94},
  [3650] = {.lex_state = 0},
  [3651] = {.lex_state = 94},
  [3652] = {.lex_state = 12},
  [3653] = {.lex_state = 29},
  [3654] = {.lex_state = 0, .external_lex_state = 4},
  [3655] = {.lex_state = 12},
  [3656] = {.lex_state = 0},
  [3657] = {.lex_state = 0},
  [3658] = {.lex_state = 94},
  [3659] = {.lex_state = 0},
  [3660] = {.lex_state = 94},
  [3661] = {.lex_state = 0, .external_lex_state = 4},
  [3662] = {.lex_state = 0},
  [3663] = {.lex_state = 29},
  [3664] = {.lex_state = 94},
  [3665] = {.lex_state = 0},
  [3666] = {.lex_state = 0},
  [3667] = {.lex_state = 0},
  [3668] = {.lex_state = 0},
  [3669] = {.lex_state = 0},
  [3670] = {.lex_state = 0},
  [3671] = {.lex_state = 0},
  [3672] = {.lex_state = 29},
  [3673] = {.lex_state = 0},
  [3674] = {.lex_state = 0},
  [3675] = {.lex_state = 29},
  [3676] = {.lex_state = 0},
  [3677] = {.lex_state = 0, .external_lex_state = 4},
  [3678] = {.lex_state = 94},
  [3679] = {.lex_state = 29},
  [3680] = {.lex_state = 0, .external_lex_state = 4},
  [3681] = {.lex_state = 0, .external_lex_state = 4},
  [3682] = {.lex_state = 0, .external_lex_state = 4},
  [3683] = {.lex_state = 0},
  [3684] = {.lex_state = 0},
  [3685] = {.lex_state = 0, .external_lex_state = 4},
  [3686] = {.lex_state = 0, .external_lex_state = 4},
  [3687] = {.lex_state = 29},
  [3688] = {.lex_state = 94, .external_lex_state = 4},
  [3689] = {.lex_state = 94},
  [3690] = {.lex_state = 29},
  [3691] = {.lex_state = 0, .external_lex_state = 4},
  [3692] = {.lex_state = 29},
  [3693] = {.lex_state = 0, .external_lex_state = 4},
  [3694] = {.lex_state = 29},
  [3695] = {.lex_state = 0, .external_lex_state = 4},
  [3696] = {.lex_state = 0},
  [3697] = {.lex_state = 0},
  [3698] = {.lex_state = 0},
  [3699] = {.lex_state = 0, .external_lex_state = 4},
  [3700] = {.lex_state = 0, .external_lex_state = 4},
  [3701] = {.lex_state = 0, .external_lex_state = 4},
  [3702] = {.lex_state = 0},
  [3703] = {.lex_state = 0},
  [3704] = {.lex_state = 94},
  [3705] = {.lex_state = 94},
  [3706] = {.lex_state = 0},
  [3707] = {.lex_state = 0},
  [3708] = {.lex_state = 94},
  [3709] = {.lex_state = 0},
  [3710] = {.lex_state = 0, .external_lex_state = 4},
  [3711] = {.lex_state = 0, .external_lex_state = 4},
  [3712] = {.lex_state = 0},
  [3713] = {.lex_state = 94, .external_lex_state = 4},
  [3714] = {.lex_state = 0},
  [3715] = {.lex_state = 0},
  [3716] = {.lex_state = 94},
  [3717] = {.lex_state = 0},
  [3718] = {.lex_state = 94},
  [3719] = {.lex_state = 0},
  [3720] = {.lex_state = 0},
  [3721] = {.lex_state = 0},
  [3722] = {.lex_state = 0},
  [3723] = {.lex_state = 4},
  [3724] = {.lex_state = 94},
  [3725] = {.lex_state = 0},
  [3726] = {.lex_state = 94},
  [3727] = {.lex_state = 0},
  [3728] = {.lex_state = 0},
  [3729] = {.lex_state = 0},
  [3730] = {.lex_state = 94},
  [3731] = {.lex_state = 0},
  [3732] = {.lex_state = 94},
  [3733] = {.lex_state = 94},
  [3734] = {.lex_state = 0},
  [3735] = {.lex_state = 94},
  [3736] = {.lex_state = 0},
  [3737] = {.lex_state = 0},
  [3738] = {.lex_state = 94},
  [3739] = {.lex_state = 29},
  [3740] = {.lex_state = 0},
  [3741] = {.lex_state = 0, .external_lex_state = 4},
  [3742] = {.lex_state = 94},
  [3743] = {.lex_state = 94},
  [3744] = {.lex_state = 94},
  [3745] = {.lex_state = 94},
  [3746] = {.lex_state = 4},
  [3747] = {.lex_state = 0},
  [3748] = {.lex_state = 0},
  [3749] = {.lex_state = 94, .external_lex_state = 4},
  [3750] = {.lex_state = 94},
  [3751] = {.lex_state = 0},
  [3752] = {.lex_state = 0, .external_lex_state = 4},
  [3753] = {.lex_state = 18, .external_lex_state = 6},
  [3754] = {.lex_state = 0, .external_lex_state = 4},
  [3755] = {.lex_state = 29},
  [3756] = {.lex_state = 0},
  [3757] = {.lex_state = 0, .external_lex_state = 4},
  [3758] = {.lex_state = 94, .external_lex_state = 4},
  [3759] = {.lex_state = 0, .external_lex_state = 4},
  [3760] = {.lex_state = 0, .external_lex_state = 4},
  [3761] = {.lex_state = 0, .external_lex_state = 4},
  [3762] = {.lex_state = 0, .external_lex_state = 4},
  [3763] = {.lex_state = 94},
  [3764] = {.lex_state = 94},
  [3765] = {.lex_state = 94},
  [3766] = {.lex_state = 0, .external_lex_state = 4},
  [3767] = {.lex_state = 0},
  [3768] = {.lex_state = 0, .external_lex_state = 4},
  [3769] = {.lex_state = 0},
  [3770] = {.lex_state = 0},
  [3771] = {.lex_state = 0},
  [3772] = {.lex_state = 0, .external_lex_state = 4},
  [3773] = {.lex_state = 0, .external_lex_state = 4},
  [3774] = {.lex_state = 0, .external_lex_state = 4},
  [3775] = {.lex_state = 0, .external_lex_state = 4},
  [3776] = {.lex_state = 0},
  [3777] = {.lex_state = 0, .external_lex_state = 4},
  [3778] = {.lex_state = 94},
  [3779] = {.lex_state = 0},
  [3780] = {.lex_state = 94},
  [3781] = {.lex_state = 0},
  [3782] = {.lex_state = 94},
  [3783] = {.lex_state = 94},
  [3784] = {.lex_state = 0, .external_lex_state = 4},
  [3785] = {.lex_state = 0, .external_lex_state = 4},
  [3786] = {.lex_state = 0},
  [3787] = {.lex_state = 0, .external_lex_state = 4},
  [3788] = {.lex_state = 94},
  [3789] = {.lex_state = 94},
  [3790] = {.lex_state = 94},
  [3791] = {.lex_state = 0, .external_lex_state = 4},
  [3792] = {.lex_state = 94},
  [3793] = {.lex_state = 0, .external_lex_state = 4},
  [3794] = {.lex_state = 0, .external_lex_state = 4},
  [3795] = {.lex_state = 94},
  [3796] = {.lex_state = 0, .external_lex_state = 4},
  [3797] = {.lex_state = 0},
  [3798] = {.lex_state = 0},
  [3799] = {.lex_state = 0},
  [3800] = {.lex_state = 94},
  [3801] = {.lex_state = 0, .external_lex_state = 4},
  [3802] = {.lex_state = 0},
  [3803] = {.lex_state = 0, .external_lex_state = 4},
  [3804] = {.lex_state = 0},
  [3805] = {.lex_state = 94, .external_lex_state = 4},
  [3806] = {.lex_state = 0, .external_lex_state = 4},
  [3807] = {.lex_state = 0},
  [3808] = {.lex_state = 0, .external_lex_state = 4},
  [3809] = {.lex_state = 0},
  [3810] = {.lex_state = 0},
  [3811] = {.lex_state = 94},
  [3812] = {.lex_state = 0},
  [3813] = {.lex_state = 94},
  [3814] = {.lex_state = 0},
  [3815] = {.lex_state = 0},
  [3816] = {.lex_state = 0},
  [3817] = {.lex_state = 0},
  [3818] = {.lex_state = 0},
  [3819] = {.lex_state = 94},
  [3820] = {.lex_state = 0},
  [3821] = {.lex_state = 94},
  [3822] = {.lex_state = 94},
  [3823] = {.lex_state = 94},
  [3824] = {.lex_state = 0, .external_lex_state = 4},
  [3825] = {.lex_state = 0, .external_lex_state = 4},
  [3826] = {.lex_state = 0},
  [3827] = {.lex_state = 0},
  [3828] = {.lex_state = 4},
  [3829] = {.lex_state = 29},
  [3830] = {.lex_state = 94, .external_lex_state = 4},
  [3831] = {.lex_state = 94},
  [3832] = {.lex_state = 94},
  [3833] = {.lex_state = 1},
  [3834] = {.lex_state = 94},
  [3835] = {.lex_state = 0},
  [3836] = {.lex_state = 0},
  [3837] = {.lex_state = 94},
  [3838] = {.lex_state = 94},
  [3839] = {.lex_state = 94},
  [3840] = {.lex_state = 94},
  [3841] = {.lex_state = 94},
  [3842] = {.lex_state = 0},
  [3843] = {.lex_state = 94},
  [3844] = {.lex_state = 0},
  [3845] = {.lex_state = 0},
  [3846] = {.lex_state = 94},
  [3847] = {.lex_state = 94},
  [3848] = {.lex_state = 94},
  [3849] = {.lex_state = 0},
  [3850] = {.lex_state = 94},
  [3851] = {.lex_state = 94},
  [3852] = {.lex_state = 94},
  [3853] = {.lex_state = 94},
  [3854] = {.lex_state = 94},
  [3855] = {.lex_state = 94},
  [3856] = {.lex_state = 0},
  [3857] = {.lex_state = 0},
  [3858] = {.lex_state = 94},
  [3859] = {.lex_state = 94},
  [3860] = {.lex_state = 0, .external_lex_state = 4},
  [3861] = {.lex_state = 94},
  [3862] = {.lex_state = 0},
  [3863] = {.lex_state = 0},
  [3864] = {.lex_state = 94},
  [3865] = {.lex_state = 0, .external_lex_state = 4},
  [3866] = {.lex_state = 0},
  [3867] = {.lex_state = 0},
  [3868] = {.lex_state = 94},
  [3869] = {.lex_state = 0},
  [3870] = {.lex_state = 94},
  [3871] = {.lex_state = 0},
  [3872] = {.lex_state = 0, .external_lex_state = 4},
  [3873] = {.lex_state = 0},
  [3874] = {.lex_state = 0},
  [3875] = {.lex_state = 94},
  [3876] = {.lex_state = 94},
  [3877] = {.lex_state = 0},
  [3878] = {.lex_state = 0},
  [3879] = {.lex_state = 94},
  [3880] = {.lex_state = 0, .external_lex_state = 4},
  [3881] = {.lex_state = 0},
  [3882] = {.lex_state = 0},
  [3883] = {.lex_state = 94},
  [3884] = {.lex_state = 0},
  [3885] = {.lex_state = 94},
  [3886] = {.lex_state = 94},
  [3887] = {.lex_state = 0},
  [3888] = {.lex_state = 94},
  [3889] = {.lex_state = 94},
  [3890] = {.lex_state = 94},
  [3891] = {.lex_state = 0, .external_lex_state = 4},
  [3892] = {.lex_state = 0, .external_lex_state = 4},
  [3893] = {.lex_state = 0, .external_lex_state = 4},
  [3894] = {.lex_state = 0, .external_lex_state = 4},
  [3895] = {.lex_state = 0},
  [3896] = {.lex_state = 94},
  [3897] = {.lex_state = 0},
  [3898] = {.lex_state = 94},
  [3899] = {.lex_state = 0},
  [3900] = {.lex_state = 0},
  [3901] = {.lex_state = 0, .external_lex_state = 4},
  [3902] = {.lex_state = 94},
  [3903] = {.lex_state = 94},
  [3904] = {.lex_state = 0},
  [3905] = {.lex_state = 94},
  [3906] = {.lex_state = 94},
  [3907] = {.lex_state = 94},
  [3908] = {.lex_state = 94},
  [3909] = {.lex_state = 94},
  [3910] = {.lex_state = 94},
  [3911] = {.lex_state = 0, .external_lex_state = 4},
  [3912] = {.lex_state = 0, .external_lex_state = 4},
  [3913] = {.lex_state = 94},
  [3914] = {.lex_state = 0},
  [3915] = {.lex_state = 0},
  [3916] = {.lex_state = 0},
  [3917] = {.lex_state = 0},
  [3918] = {.lex_state = 94},
  [3919] = {.lex_state = 94},
  [3920] = {.lex_state = 0},
  [3921] = {.lex_state = 0, .external_lex_state = 4},
  [3922] = {.lex_state = 0, .external_lex_state = 4},
  [3923] = {.lex_state = 94},
  [3924] = {.lex_state = 94},
  [3925] = {.lex_state = 0},
  [3926] = {.lex_state = 94},
  [3927] = {.lex_state = 0},
  [3928] = {.lex_state = 94},
  [3929] = {.lex_state = 94},
  [3930] = {.lex_state = 94},
  [3931] = {.lex_state = 0},
  [3932] = {.lex_state = 0},
  [3933] = {.lex_state = 0},
  [3934] = {.lex_state = 0},
  [3935] = {.lex_state = 94},
  [3936] = {.lex_state = 94},
  [3937] = {.lex_state = 0},
  [3938] = {.lex_state = 0, .external_lex_state = 4},
  [3939] = {.lex_state = 94},
  [3940] = {.lex_state = 94},
  [3941] = {.lex_state = 94},
  [3942] = {.lex_state = 94},
  [3943] = {.lex_state = 1},
  [3944] = {.lex_state = 0},
  [3945] = {.lex_state = 94},
  [3946] = {.lex_state = 0},
  [3947] = {.lex_state = 0},
  [3948] = {.lex_state = 0},
  [3949] = {.lex_state = 0, .external_lex_state = 4},
  [3950] = {.lex_state = 94},
  [3951] = {.lex_state = 94},
  [3952] = {.lex_state = 0},
  [3953] = {.lex_state = 94},
  [3954] = {.lex_state = 0},
  [3955] = {.lex_state = 94},
  [3956] = {.lex_state = 0},
  [3957] = {.lex_state = 94},
  [3958] = {.lex_state = 94},
  [3959] = {.lex_state = 94},
  [3960] = {.lex_state = 0},
  [3961] = {.lex_state = 94},
  [3962] = {.lex_state = 0},
  [3963] = {.lex_state = 0, .external_lex_state = 4},
  [3964] = {.lex_state = 94},
  [3965] = {.lex_state = 94},
  [3966] = {.lex_state = 94},
  [3967] = {.lex_state = 94},
  [3968] = {.lex_state = 0},
  [3969] = {.lex_state = 0},
  [3970] = {.lex_state = 94},
  [3971] = {.lex_state = 0},
  [3972] = {.lex_state = 0, .external_lex_state = 4},
  [3973] = {.lex_state = 0},
  [3974] = {.lex_state = 0, .external_lex_state = 4},
  [3975] = {.lex_state = 94},
  [3976] = {.lex_state = 94},
  [3977] = {.lex_state = 94},
  [3978] = {.lex_state = 94},
  [3979] = {.lex_state = 94},
  [3980] = {.lex_state = 0},
  [3981] = {.lex_state = 0},
  [3982] = {.lex_state = 94},
  [3983] = {.lex_state = 0},
  [3984] = {.lex_state = 0},
  [3985] = {.lex_state = 94},
  [3986] = {.lex_state = 94},
  [3987] = {.lex_state = 94},
  [3988] = {.lex_state = 94},
  [3989] = {.lex_state = 94},
  [3990] = {.lex_state = 94},
  [3991] = {.lex_state = 94},
  [3992] = {.lex_state = 0},
  [3993] = {.lex_state = 0},
  [3994] = {.lex_state = 0, .external_lex_state = 4},
  [3995] = {.lex_state = 0},
  [3996] = {.lex_state = 94},
  [3997] = {.lex_state = 0},
  [3998] = {.lex_state = 94},
  [3999] = {.lex_state = 94},
  [4000] = {.lex_state = 0},
  [4001] = {.lex_state = 94},
  [4002] = {.lex_state = 94},
  [4003] = {.lex_state = 0},
  [4004] = {.lex_state = 0, .external_lex_state = 4},
  [4005] = {.lex_state = 94},
  [4006] = {.lex_state = 94},
  [4007] = {.lex_state = 0, .external_lex_state = 4},
  [4008] = {.lex_state = 94},
  [4009] = {.lex_state = 0, .external_lex_state = 4},
  [4010] = {.lex_state = 0},
  [4011] = {.lex_state = 94},
  [4012] = {.lex_state = 0},
  [4013] = {.lex_state = 94},
  [4014] = {.lex_state = 0},
  [4015] = {.lex_state = 94},
  [4016] = {.lex_state = 0},
  [4017] = {.lex_state = 0},
  [4018] = {.lex_state = 0},
  [4019] = {.lex_state = 94},
  [4020] = {.lex_state = 94},
  [4021] = {.lex_state = 94},
  [4022] = {.lex_state = 0},
  [4023] = {.lex_state = 94},
  [4024] = {.lex_state = 94},
  [4025] = {.lex_state = 94},
  [4026] = {.lex_state = 94},
  [4027] = {.lex_state = 94},
  [4028] = {.lex_state = 94},
  [4029] = {.lex_state = 94},
  [4030] = {.lex_state = 94},
  [4031] = {.lex_state = 94},
  [4032] = {.lex_state = 94},
  [4033] = {.lex_state = 94},
  [4034] = {.lex_state = 0},
  [4035] = {.lex_state = 94},
  [4036] = {.lex_state = 94},
  [4037] = {.lex_state = 94},
  [4038] = {.lex_state = 94},
  [4039] = {.lex_state = 94},
  [4040] = {.lex_state = 94},
  [4041] = {.lex_state = 94},
  [4042] = {.lex_state = 94},
  [4043] = {.lex_state = 0},
  [4044] = {.lex_state = 94},
  [4045] = {.lex_state = 0},
  [4046] = {.lex_state = 94},
  [4047] = {.lex_state = 94},
  [4048] = {.lex_state = 0},
  [4049] = {.lex_state = 94},
  [4050] = {.lex_state = 94},
  [4051] = {.lex_state = 94},
  [4052] = {.lex_state = 0},
  [4053] = {.lex_state = 0},
  [4054] = {.lex_state = 0, .external_lex_state = 4},
  [4055] = {.lex_state = 94},
  [4056] = {.lex_state = 0},
  [4057] = {.lex_state = 94},
  [4058] = {.lex_state = 94},
  [4059] = {.lex_state = 94},
  [4060] = {.lex_state = 94},
  [4061] = {.lex_state = 94},
  [4062] = {.lex_state = 0},
  [4063] = {.lex_state = 94},
  [4064] = {.lex_state = 94},
  [4065] = {.lex_state = 94},
  [4066] = {.lex_state = 0},
  [4067] = {.lex_state = 0},
  [4068] = {.lex_state = 94},
  [4069] = {.lex_state = 94},
  [4070] = {.lex_state = 94},
  [4071] = {.lex_state = 94},
  [4072] = {.lex_state = 94},
  [4073] = {.lex_state = 16},
  [4074] = {.lex_state = 0},
  [4075] = {.lex_state = 0, .external_lex_state = 4},
  [4076] = {.lex_state = 0, .external_lex_state = 4},
  [4077] = {.lex_state = 0},
  [4078] = {.lex_state = 94},
  [4079] = {.lex_state = 0},
  [4080] = {.lex_state = 94},
  [4081] = {.lex_state = 0},
  [4082] = {.lex_state = 0, .external_lex_state = 4},
  [4083] = {.lex_state = 94},
  [4084] = {.lex_state = 0},
  [4085] = {.lex_state = 94},
  [4086] = {.lex_state = 94},
  [4087] = {.lex_state = 94},
  [4088] = {.lex_state = 0},
  [4089] = {.lex_state = 94},
  [4090] = {.lex_state = 0},
  [4091] = {.lex_state = 0, .external_lex_state = 4},
  [4092] = {.lex_state = 0},
  [4093] = {.lex_state = 94},
  [4094] = {.lex_state = 94},
  [4095] = {.lex_state = 94},
  [4096] = {.lex_state = 0},
  [4097] = {.lex_state = 94},
  [4098] = {.lex_state = 0},
  [4099] = {.lex_state = 94},
  [4100] = {.lex_state = 0},
  [4101] = {.lex_state = 0, .external_lex_state = 4},
  [4102] = {.lex_state = 0},
  [4103] = {.lex_state = 94},
  [4104] = {.lex_state = 94},
  [4105] = {.lex_state = 94},
  [4106] = {.lex_state = 0},
  [4107] = {.lex_state = 0},
  [4108] = {.lex_state = 0},
  [4109] = {.lex_state = 94},
  [4110] = {.lex_state = 0},
  [4111] = {.lex_state = 94},
  [4112] = {.lex_state = 0},
  [4113] = {.lex_state = 0},
  [4114] = {.lex_state = 0},
  [4115] = {.lex_state = 2},
  [4116] = {.lex_state = 0},
  [4117] = {.lex_state = 94},
  [4118] = {.lex_state = 0},
  [4119] = {.lex_state = 0},
  [4120] = {.lex_state = 0},
  [4121] = {.lex_state = 94},
  [4122] = {.lex_state = 94},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 94},
  [4125] = {.lex_state = 94},
  [4126] = {.lex_state = 94},
  [4127] = {.lex_state = 94},
  [4128] = {.lex_state = 94},
  [4129] = {.lex_state = 94},
  [4130] = {.lex_state = 94},
  [4131] = {.lex_state = 0},
  [4132] = {.lex_state = 0},
  [4133] = {.lex_state = 94},
  [4134] = {.lex_state = 94},
  [4135] = {.lex_state = 94},
  [4136] = {.lex_state = 0},
  [4137] = {.lex_state = 0},
  [4138] = {.lex_state = 94},
  [4139] = {.lex_state = 0},
  [4140] = {.lex_state = 0},
  [4141] = {.lex_state = 0},
  [4142] = {.lex_state = 0},
  [4143] = {.lex_state = 94},
  [4144] = {.lex_state = 94},
  [4145] = {.lex_state = 2},
  [4146] = {.lex_state = 94},
  [4147] = {.lex_state = 94},
  [4148] = {.lex_state = 0},
  [4149] = {.lex_state = 0},
  [4150] = {.lex_state = 0},
  [4151] = {.lex_state = 0},
  [4152] = {.lex_state = 0},
  [4153] = {.lex_state = 0},
  [4154] = {.lex_state = 94},
  [4155] = {.lex_state = 0},
  [4156] = {.lex_state = 0},
  [4157] = {.lex_state = 0},
  [4158] = {.lex_state = 94},
  [4159] = {.lex_state = 94},
  [4160] = {.lex_state = 0},
  [4161] = {.lex_state = 0},
  [4162] = {.lex_state = 0},
  [4163] = {.lex_state = 0},
  [4164] = {.lex_state = 94},
  [4165] = {.lex_state = 94},
  [4166] = {.lex_state = 0},
  [4167] = {.lex_state = 0},
  [4168] = {.lex_state = 0},
  [4169] = {.lex_state = 0},
  [4170] = {.lex_state = 0},
  [4171] = {.lex_state = 0},
  [4172] = {.lex_state = 0},
  [4173] = {.lex_state = 0},
  [4174] = {.lex_state = 0},
  [4175] = {.lex_state = 0},
  [4176] = {.lex_state = 2},
  [4177] = {.lex_state = 94},
  [4178] = {.lex_state = 94},
  [4179] = {.lex_state = 0},
  [4180] = {.lex_state = 0},
  [4181] = {.lex_state = 0},
  [4182] = {.lex_state = 0},
  [4183] = {.lex_state = 0},
  [4184] = {.lex_state = 0},
  [4185] = {.lex_state = 0},
  [4186] = {.lex_state = 0},
  [4187] = {.lex_state = 94},
  [4188] = {.lex_state = 0},
  [4189] = {.lex_state = 94},
  [4190] = {.lex_state = 0},
  [4191] = {.lex_state = 0},
  [4192] = {.lex_state = 94},
  [4193] = {.lex_state = 0},
  [4194] = {.lex_state = 0},
  [4195] = {.lex_state = 94},
  [4196] = {.lex_state = 0},
  [4197] = {.lex_state = 94},
  [4198] = {.lex_state = 0},
  [4199] = {.lex_state = 0},
  [4200] = {.lex_state = 0},
  [4201] = {.lex_state = 0},
  [4202] = {.lex_state = 0},
  [4203] = {.lex_state = 0},
  [4204] = {.lex_state = 0},
  [4205] = {.lex_state = 94},
  [4206] = {.lex_state = 0},
  [4207] = {.lex_state = 94},
  [4208] = {.lex_state = 94},
  [4209] = {.lex_state = 94},
  [4210] = {.lex_state = 94},
  [4211] = {.lex_state = 2},
  [4212] = {.lex_state = 0},
  [4213] = {.lex_state = 94},
  [4214] = {.lex_state = 0},
  [4215] = {.lex_state = 0},
  [4216] = {.lex_state = 0},
  [4217] = {.lex_state = 0},
  [4218] = {.lex_state = 94},
  [4219] = {.lex_state = 0},
  [4220] = {.lex_state = 0},
  [4221] = {.lex_state = 94},
  [4222] = {.lex_state = 0},
  [4223] = {.lex_state = 94},
  [4224] = {.lex_state = 94},
  [4225] = {.lex_state = 94},
  [4226] = {.lex_state = 0},
  [4227] = {.lex_state = 0},
  [4228] = {.lex_state = 0},
  [4229] = {.lex_state = 0},
  [4230] = {.lex_state = 0},
  [4231] = {.lex_state = 0},
  [4232] = {.lex_state = 0},
  [4233] = {.lex_state = 0},
  [4234] = {.lex_state = 0},
  [4235] = {.lex_state = 0},
  [4236] = {.lex_state = 0},
  [4237] = {.lex_state = 94},
  [4238] = {.lex_state = 94},
  [4239] = {.lex_state = 0},
  [4240] = {.lex_state = 94},
  [4241] = {.lex_state = 0},
  [4242] = {.lex_state = 0},
  [4243] = {.lex_state = 0},
  [4244] = {.lex_state = 0},
  [4245] = {.lex_state = 0},
  [4246] = {.lex_state = 0},
  [4247] = {.lex_state = 0},
  [4248] = {.lex_state = 0},
  [4249] = {.lex_state = 0},
  [4250] = {.lex_state = 0},
  [4251] = {.lex_state = 94},
  [4252] = {.lex_state = 0},
  [4253] = {.lex_state = 0},
  [4254] = {.lex_state = 0},
  [4255] = {.lex_state = 0},
  [4256] = {.lex_state = 0},
  [4257] = {.lex_state = 94},
  [4258] = {.lex_state = 0},
  [4259] = {.lex_state = 0},
  [4260] = {.lex_state = 0},
  [4261] = {.lex_state = 0},
  [4262] = {.lex_state = 0},
  [4263] = {.lex_state = 0},
  [4264] = {.lex_state = 0},
  [4265] = {.lex_state = 0},
  [4266] = {.lex_state = 94},
  [4267] = {.lex_state = 0},
  [4268] = {.lex_state = 0},
  [4269] = {.lex_state = 0},
  [4270] = {.lex_state = 0},
  [4271] = {.lex_state = 0},
  [4272] = {.lex_state = 94},
  [4273] = {.lex_state = 0},
  [4274] = {.lex_state = 0},
  [4275] = {.lex_state = 0},
  [4276] = {.lex_state = 94},
  [4277] = {.lex_state = 0},
  [4278] = {.lex_state = 94},
  [4279] = {.lex_state = 12},
  [4280] = {.lex_state = 0},
  [4281] = {.lex_state = 0},
  [4282] = {.lex_state = 0},
  [4283] = {.lex_state = 0},
  [4284] = {.lex_state = 0},
  [4285] = {.lex_state = 0},
  [4286] = {.lex_state = 0},
  [4287] = {.lex_state = 0},
  [4288] = {.lex_state = 0},
  [4289] = {.lex_state = 0},
  [4290] = {.lex_state = 0},
  [4291] = {.lex_state = 0},
  [4292] = {.lex_state = 0},
  [4293] = {.lex_state = 0},
  [4294] = {.lex_state = 0},
  [4295] = {.lex_state = 0},
  [4296] = {.lex_state = 0},
  [4297] = {.lex_state = 0},
  [4298] = {.lex_state = 0},
  [4299] = {.lex_state = 0},
  [4300] = {.lex_state = 94},
  [4301] = {.lex_state = 0},
  [4302] = {.lex_state = 94},
  [4303] = {.lex_state = 0},
  [4304] = {.lex_state = 0},
  [4305] = {.lex_state = 0},
  [4306] = {.lex_state = 0},
  [4307] = {.lex_state = 0},
  [4308] = {.lex_state = 94},
  [4309] = {.lex_state = 94},
  [4310] = {.lex_state = 94},
  [4311] = {.lex_state = 94},
  [4312] = {.lex_state = 0},
  [4313] = {.lex_state = 94},
  [4314] = {.lex_state = 0},
  [4315] = {.lex_state = 0},
  [4316] = {.lex_state = 94},
  [4317] = {.lex_state = 94},
  [4318] = {.lex_state = 94},
  [4319] = {.lex_state = 94},
  [4320] = {.lex_state = 94},
  [4321] = {.lex_state = 0},
  [4322] = {.lex_state = 0},
  [4323] = {.lex_state = 0},
  [4324] = {.lex_state = 94},
  [4325] = {.lex_state = 0},
  [4326] = {.lex_state = 94},
  [4327] = {.lex_state = 0},
  [4328] = {.lex_state = 94},
  [4329] = {.lex_state = 0},
  [4330] = {.lex_state = 94},
  [4331] = {.lex_state = 94},
  [4332] = {.lex_state = 12},
  [4333] = {.lex_state = 0},
  [4334] = {.lex_state = 94},
  [4335] = {.lex_state = 0},
  [4336] = {.lex_state = 0},
  [4337] = {.lex_state = 0},
  [4338] = {.lex_state = 0},
  [4339] = {.lex_state = 0},
  [4340] = {.lex_state = 0},
  [4341] = {.lex_state = 0},
  [4342] = {.lex_state = 0},
  [4343] = {.lex_state = 94},
  [4344] = {.lex_state = 0},
  [4345] = {.lex_state = 0},
  [4346] = {.lex_state = 0},
  [4347] = {.lex_state = 0},
  [4348] = {.lex_state = 0},
  [4349] = {.lex_state = 0},
  [4350] = {.lex_state = 0},
  [4351] = {.lex_state = 0},
  [4352] = {.lex_state = 0},
  [4353] = {.lex_state = 94},
  [4354] = {.lex_state = 0},
  [4355] = {.lex_state = 0},
  [4356] = {.lex_state = 0},
  [4357] = {.lex_state = 0},
  [4358] = {.lex_state = 0},
  [4359] = {.lex_state = 0},
  [4360] = {.lex_state = 0},
  [4361] = {.lex_state = 0},
  [4362] = {.lex_state = 0},
  [4363] = {.lex_state = 94},
  [4364] = {.lex_state = 0},
  [4365] = {.lex_state = 94},
  [4366] = {.lex_state = 0},
  [4367] = {.lex_state = 0},
  [4368] = {.lex_state = 0},
  [4369] = {.lex_state = 94},
  [4370] = {.lex_state = 94},
  [4371] = {.lex_state = 94},
  [4372] = {.lex_state = 94},
  [4373] = {.lex_state = 0},
  [4374] = {.lex_state = 0},
  [4375] = {.lex_state = 0},
  [4376] = {.lex_state = 94},
  [4377] = {.lex_state = 94},
  [4378] = {.lex_state = 0},
  [4379] = {.lex_state = 94},
  [4380] = {.lex_state = 12},
  [4381] = {.lex_state = 0},
  [4382] = {.lex_state = 0},
  [4383] = {.lex_state = 94},
  [4384] = {.lex_state = 94},
  [4385] = {.lex_state = 94},
  [4386] = {.lex_state = 94},
  [4387] = {.lex_state = 94},
  [4388] = {.lex_state = 94},
  [4389] = {.lex_state = 0},
  [4390] = {.lex_state = 94},
  [4391] = {.lex_state = 0},
  [4392] = {.lex_state = 94},
  [4393] = {.lex_state = 0},
  [4394] = {.lex_state = 12},
  [4395] = {.lex_state = 0},
  [4396] = {.lex_state = 0},
  [4397] = {.lex_state = 94},
  [4398] = {.lex_state = 0},
  [4399] = {.lex_state = 0},
  [4400] = {.lex_state = 0},
  [4401] = {.lex_state = 0},
  [4402] = {.lex_state = 0},
  [4403] = {.lex_state = 0},
  [4404] = {.lex_state = 0},
  [4405] = {.lex_state = 94},
  [4406] = {.lex_state = 0},
  [4407] = {.lex_state = 0},
  [4408] = {.lex_state = 0},
  [4409] = {.lex_state = 0},
  [4410] = {.lex_state = 0},
  [4411] = {.lex_state = 94},
  [4412] = {.lex_state = 0},
  [4413] = {.lex_state = 0},
  [4414] = {.lex_state = 0},
  [4415] = {.lex_state = 94},
  [4416] = {.lex_state = 0},
  [4417] = {.lex_state = 0},
  [4418] = {.lex_state = 94},
  [4419] = {.lex_state = 0},
  [4420] = {.lex_state = 0},
  [4421] = {.lex_state = 0},
  [4422] = {.lex_state = 0},
  [4423] = {.lex_state = 0},
  [4424] = {.lex_state = 0},
  [4425] = {.lex_state = 0},
  [4426] = {.lex_state = 0},
  [4427] = {.lex_state = 0},
  [4428] = {.lex_state = 0},
  [4429] = {.lex_state = 94},
  [4430] = {.lex_state = 0},
  [4431] = {.lex_state = 0},
  [4432] = {.lex_state = 0},
  [4433] = {.lex_state = 94},
  [4434] = {.lex_state = 94},
  [4435] = {.lex_state = 94},
  [4436] = {.lex_state = 94},
  [4437] = {.lex_state = 0},
  [4438] = {.lex_state = 94},
  [4439] = {.lex_state = 94},
  [4440] = {.lex_state = 94},
  [4441] = {.lex_state = 0},
  [4442] = {.lex_state = 94},
  [4443] = {.lex_state = 0},
  [4444] = {.lex_state = 94},
  [4445] = {.lex_state = 0},
  [4446] = {.lex_state = 0},
  [4447] = {.lex_state = 94},
  [4448] = {.lex_state = 94},
  [4449] = {.lex_state = 94},
  [4450] = {.lex_state = 94},
  [4451] = {.lex_state = 94},
  [4452] = {.lex_state = 94},
  [4453] = {.lex_state = 94},
  [4454] = {.lex_state = 12},
  [4455] = {.lex_state = 0},
  [4456] = {.lex_state = 0},
  [4457] = {.lex_state = 0},
  [4458] = {.lex_state = 94},
  [4459] = {.lex_state = 94},
  [4460] = {.lex_state = 0},
  [4461] = {.lex_state = 94},
  [4462] = {.lex_state = 94},
  [4463] = {.lex_state = 94},
  [4464] = {.lex_state = 94},
  [4465] = {.lex_state = 94},
  [4466] = {.lex_state = 94},
  [4467] = {.lex_state = 94},
  [4468] = {.lex_state = 0},
  [4469] = {.lex_state = 0},
  [4470] = {.lex_state = 94},
  [4471] = {.lex_state = 0},
  [4472] = {.lex_state = 94},
  [4473] = {.lex_state = 2},
  [4474] = {.lex_state = 0},
  [4475] = {.lex_state = 94},
  [4476] = {.lex_state = 0},
  [4477] = {.lex_state = 94},
  [4478] = {.lex_state = 0},
  [4479] = {.lex_state = 0},
  [4480] = {.lex_state = 0},
  [4481] = {.lex_state = 94},
  [4482] = {.lex_state = 0},
  [4483] = {.lex_state = 0},
  [4484] = {.lex_state = 0},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_PIPE_PIPE = 3,
  ts_external_token__function_signature_automatic_semicolon = 4,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__template_chars] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LTtemplate_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_private_property_identifier] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_satisfies] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(4460),
    [sym_export_statement] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [2] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3184),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(120),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(124),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(128),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(137),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(154),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(191),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(195),
    [anon_sym_number] = ACTIONS(195),
    [anon_sym_boolean] = ACTIONS(195),
    [anon_sym_string] = ACTIONS(195),
    [anon_sym_symbol] = ACTIONS(195),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [3] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3184),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(120),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_typeof] = ACTIONS(124),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(128),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(210),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(137),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(154),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(191),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(195),
    [anon_sym_number] = ACTIONS(195),
    [anon_sym_boolean] = ACTIONS(195),
    [anon_sym_string] = ACTIONS(195),
    [anon_sym_symbol] = ACTIONS(195),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [4] = {
    [sym_export_statement] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4427),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4427),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4427),
    [sym_spread_element] = STATE(3707),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1831),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3707),
    [sym_pair] = STATE(3707),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2956),
    [sym_computed_property_name] = STATE(2956),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_accessibility_modifier] = STATE(2294),
    [sym_override_modifier] = STATE(2303),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [aux_sym_object_repeat1] = STATE(3715),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(215),
    [anon_sym_export] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(221),
    [anon_sym_namespace] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(225),
    [anon_sym_RBRACE] = ACTIONS(227),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(231),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(235),
    [sym_private_property_identifier] = ACTIONS(237),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_readonly] = ACTIONS(241),
    [anon_sym_get] = ACTIONS(243),
    [anon_sym_set] = ACTIONS(243),
    [anon_sym_declare] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(247),
    [anon_sym_private] = ACTIONS(247),
    [anon_sym_protected] = ACTIONS(247),
    [anon_sym_override] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_any] = ACTIONS(253),
    [anon_sym_number] = ACTIONS(253),
    [anon_sym_boolean] = ACTIONS(253),
    [anon_sym_string] = ACTIONS(253),
    [anon_sym_symbol] = ACTIONS(253),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [5] = {
    [sym_export_statement] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_for_in_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_debugger_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_throw_statement] = STATE(29),
    [sym_empty_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4427),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4427),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4427),
    [sym_spread_element] = STATE(3707),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1831),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3707),
    [sym_pair] = STATE(3707),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2956),
    [sym_computed_property_name] = STATE(2956),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_accessibility_modifier] = STATE(2294),
    [sym_override_modifier] = STATE(2303),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [aux_sym_object_repeat1] = STATE(3715),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(215),
    [anon_sym_export] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(221),
    [anon_sym_namespace] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(225),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(231),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(235),
    [sym_private_property_identifier] = ACTIONS(237),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_readonly] = ACTIONS(241),
    [anon_sym_get] = ACTIONS(243),
    [anon_sym_set] = ACTIONS(243),
    [anon_sym_declare] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(247),
    [anon_sym_private] = ACTIONS(247),
    [anon_sym_protected] = ACTIONS(247),
    [anon_sym_override] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_any] = ACTIONS(253),
    [anon_sym_number] = ACTIONS(253),
    [anon_sym_boolean] = ACTIONS(253),
    [anon_sym_string] = ACTIONS(253),
    [anon_sym_symbol] = ACTIONS(253),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [6] = {
    [sym_export_statement] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4427),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4427),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4427),
    [sym_spread_element] = STATE(3707),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1831),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3707),
    [sym_pair] = STATE(3707),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2956),
    [sym_computed_property_name] = STATE(2956),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_accessibility_modifier] = STATE(2294),
    [sym_override_modifier] = STATE(2303),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [aux_sym_object_repeat1] = STATE(3715),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(215),
    [anon_sym_export] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(221),
    [anon_sym_namespace] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(225),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(231),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(235),
    [sym_private_property_identifier] = ACTIONS(237),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_readonly] = ACTIONS(241),
    [anon_sym_get] = ACTIONS(243),
    [anon_sym_set] = ACTIONS(243),
    [anon_sym_declare] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(247),
    [anon_sym_private] = ACTIONS(247),
    [anon_sym_protected] = ACTIONS(247),
    [anon_sym_override] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_any] = ACTIONS(253),
    [anon_sym_number] = ACTIONS(253),
    [anon_sym_boolean] = ACTIONS(253),
    [anon_sym_string] = ACTIONS(253),
    [anon_sym_symbol] = ACTIONS(253),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [7] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4427),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4427),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4427),
    [sym_spread_element] = STATE(3728),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1831),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2956),
    [sym_computed_property_name] = STATE(2956),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_accessibility_modifier] = STATE(2294),
    [sym_override_modifier] = STATE(2303),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(259),
    [anon_sym_export] = ACTIONS(261),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(263),
    [anon_sym_namespace] = ACTIONS(265),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(225),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(235),
    [sym_private_property_identifier] = ACTIONS(237),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(271),
    [anon_sym_readonly] = ACTIONS(273),
    [anon_sym_get] = ACTIONS(275),
    [anon_sym_set] = ACTIONS(275),
    [anon_sym_declare] = ACTIONS(277),
    [anon_sym_public] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_override] = ACTIONS(281),
    [anon_sym_module] = ACTIONS(283),
    [anon_sym_any] = ACTIONS(285),
    [anon_sym_number] = ACTIONS(285),
    [anon_sym_boolean] = ACTIONS(285),
    [anon_sym_string] = ACTIONS(285),
    [anon_sym_symbol] = ACTIONS(285),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [8] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4427),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4427),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4427),
    [sym_spread_element] = STATE(3728),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1831),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2956),
    [sym_computed_property_name] = STATE(2956),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_accessibility_modifier] = STATE(2294),
    [sym_override_modifier] = STATE(2303),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_namespace] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(225),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(235),
    [sym_private_property_identifier] = ACTIONS(237),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(297),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_get] = ACTIONS(301),
    [anon_sym_set] = ACTIONS(301),
    [anon_sym_declare] = ACTIONS(303),
    [anon_sym_public] = ACTIONS(305),
    [anon_sym_private] = ACTIONS(305),
    [anon_sym_protected] = ACTIONS(305),
    [anon_sym_override] = ACTIONS(307),
    [anon_sym_module] = ACTIONS(309),
    [anon_sym_any] = ACTIONS(311),
    [anon_sym_number] = ACTIONS(311),
    [anon_sym_boolean] = ACTIONS(311),
    [anon_sym_string] = ACTIONS(311),
    [anon_sym_symbol] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [9] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [ts_builtin_sym_end] = ACTIONS(313),
    [sym_identifier] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(318),
    [anon_sym_default] = ACTIONS(321),
    [anon_sym_type] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(326),
    [anon_sym_LBRACE] = ACTIONS(329),
    [anon_sym_RBRACE] = ACTIONS(313),
    [anon_sym_typeof] = ACTIONS(332),
    [anon_sym_import] = ACTIONS(335),
    [anon_sym_var] = ACTIONS(338),
    [anon_sym_let] = ACTIONS(341),
    [anon_sym_const] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_switch] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(356),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_await] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(368),
    [anon_sym_try] = ACTIONS(371),
    [anon_sym_with] = ACTIONS(374),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_continue] = ACTIONS(380),
    [anon_sym_debugger] = ACTIONS(383),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_throw] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(392),
    [anon_sym_case] = ACTIONS(321),
    [anon_sym_yield] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(398),
    [anon_sym_LTtemplate_GT] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(404),
    [anon_sym_SLASH] = ACTIONS(407),
    [anon_sym_class] = ACTIONS(410),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(416),
    [anon_sym_new] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(332),
    [anon_sym_DASH] = ACTIONS(332),
    [anon_sym_TILDE] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(332),
    [anon_sym_delete] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(422),
    [anon_sym_DASH_DASH] = ACTIONS(422),
    [anon_sym_DQUOTE] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(431),
    [sym_number] = ACTIONS(434),
    [sym_this] = ACTIONS(437),
    [sym_super] = ACTIONS(437),
    [sym_true] = ACTIONS(437),
    [sym_false] = ACTIONS(437),
    [sym_null] = ACTIONS(437),
    [sym_undefined] = ACTIONS(440),
    [anon_sym_AT] = ACTIONS(443),
    [anon_sym_static] = ACTIONS(446),
    [anon_sym_readonly] = ACTIONS(446),
    [anon_sym_get] = ACTIONS(446),
    [anon_sym_set] = ACTIONS(446),
    [anon_sym_declare] = ACTIONS(449),
    [anon_sym_public] = ACTIONS(446),
    [anon_sym_private] = ACTIONS(446),
    [anon_sym_protected] = ACTIONS(446),
    [anon_sym_override] = ACTIONS(446),
    [anon_sym_module] = ACTIONS(452),
    [anon_sym_any] = ACTIONS(446),
    [anon_sym_number] = ACTIONS(446),
    [anon_sym_boolean] = ACTIONS(446),
    [anon_sym_string] = ACTIONS(446),
    [anon_sym_symbol] = ACTIONS(446),
    [anon_sym_abstract] = ACTIONS(455),
    [anon_sym_interface] = ACTIONS(458),
    [anon_sym_enum] = ACTIONS(461),
  },
  [10] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(464),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(466),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(464),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [11] = {
    [sym_export_statement] = STATE(13),
    [sym_declaration] = STATE(13),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(470),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(468),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [12] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(472),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(474),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(472),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [13] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(478),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(476),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [14] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(480),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [15] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [ts_builtin_sym_end] = ACTIONS(482),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [16] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [ts_builtin_sym_end] = ACTIONS(482),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [17] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(484),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [18] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [ts_builtin_sym_end] = ACTIONS(486),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [19] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(488),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [20] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(490),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [21] = {
    [sym_export_statement] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_for_in_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_debugger_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_throw_statement] = STATE(29),
    [sym_empty_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(492),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [22] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [23] = {
    [sym_export_statement] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(496),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [24] = {
    [sym_export_statement] = STATE(14),
    [sym_declaration] = STATE(14),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(498),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [25] = {
    [sym_export_statement] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(500),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [26] = {
    [sym_export_statement] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(502),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [27] = {
    [sym_export_statement] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(504),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [28] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [29] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [30] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(510),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [31] = {
    [sym_export_statement] = STATE(676),
    [sym_declaration] = STATE(676),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(676),
    [sym_expression_statement] = STATE(676),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(676),
    [sym_if_statement] = STATE(676),
    [sym_switch_statement] = STATE(676),
    [sym_for_statement] = STATE(676),
    [sym_for_in_statement] = STATE(676),
    [sym_while_statement] = STATE(676),
    [sym_do_statement] = STATE(676),
    [sym_try_statement] = STATE(676),
    [sym_with_statement] = STATE(676),
    [sym_break_statement] = STATE(676),
    [sym_continue_statement] = STATE(676),
    [sym_debugger_statement] = STATE(676),
    [sym_return_statement] = STATE(676),
    [sym_throw_statement] = STATE(676),
    [sym_empty_statement] = STATE(676),
    [sym_labeled_statement] = STATE(676),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [32] = {
    [sym_export_statement] = STATE(659),
    [sym_declaration] = STATE(659),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(659),
    [sym_expression_statement] = STATE(659),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(659),
    [sym_if_statement] = STATE(659),
    [sym_switch_statement] = STATE(659),
    [sym_for_statement] = STATE(659),
    [sym_for_in_statement] = STATE(659),
    [sym_while_statement] = STATE(659),
    [sym_do_statement] = STATE(659),
    [sym_try_statement] = STATE(659),
    [sym_with_statement] = STATE(659),
    [sym_break_statement] = STATE(659),
    [sym_continue_statement] = STATE(659),
    [sym_debugger_statement] = STATE(659),
    [sym_return_statement] = STATE(659),
    [sym_throw_statement] = STATE(659),
    [sym_empty_statement] = STATE(659),
    [sym_labeled_statement] = STATE(659),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3035),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(516),
    [anon_sym_namespace] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [33] = {
    [sym_export_statement] = STATE(756),
    [sym_declaration] = STATE(756),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(756),
    [sym_expression_statement] = STATE(756),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(756),
    [sym_if_statement] = STATE(756),
    [sym_switch_statement] = STATE(756),
    [sym_for_statement] = STATE(756),
    [sym_for_in_statement] = STATE(756),
    [sym_while_statement] = STATE(756),
    [sym_do_statement] = STATE(756),
    [sym_try_statement] = STATE(756),
    [sym_with_statement] = STATE(756),
    [sym_break_statement] = STATE(756),
    [sym_continue_statement] = STATE(756),
    [sym_debugger_statement] = STATE(756),
    [sym_return_statement] = STATE(756),
    [sym_throw_statement] = STATE(756),
    [sym_empty_statement] = STATE(756),
    [sym_labeled_statement] = STATE(756),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3035),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(516),
    [anon_sym_namespace] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [34] = {
    [sym_export_statement] = STATE(713),
    [sym_declaration] = STATE(713),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(713),
    [sym_expression_statement] = STATE(713),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(713),
    [sym_if_statement] = STATE(713),
    [sym_switch_statement] = STATE(713),
    [sym_for_statement] = STATE(713),
    [sym_for_in_statement] = STATE(713),
    [sym_while_statement] = STATE(713),
    [sym_do_statement] = STATE(713),
    [sym_try_statement] = STATE(713),
    [sym_with_statement] = STATE(713),
    [sym_break_statement] = STATE(713),
    [sym_continue_statement] = STATE(713),
    [sym_debugger_statement] = STATE(713),
    [sym_return_statement] = STATE(713),
    [sym_throw_statement] = STATE(713),
    [sym_empty_statement] = STATE(713),
    [sym_labeled_statement] = STATE(713),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [35] = {
    [sym_export_statement] = STATE(749),
    [sym_declaration] = STATE(745),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(634),
    [sym_expression_statement] = STATE(743),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(742),
    [sym_if_statement] = STATE(729),
    [sym_switch_statement] = STATE(724),
    [sym_for_statement] = STATE(723),
    [sym_for_in_statement] = STATE(722),
    [sym_while_statement] = STATE(720),
    [sym_do_statement] = STATE(719),
    [sym_try_statement] = STATE(712),
    [sym_with_statement] = STATE(711),
    [sym_break_statement] = STATE(709),
    [sym_continue_statement] = STATE(707),
    [sym_debugger_statement] = STATE(697),
    [sym_return_statement] = STATE(696),
    [sym_throw_statement] = STATE(688),
    [sym_empty_statement] = STATE(687),
    [sym_labeled_statement] = STATE(685),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3118),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(546),
    [anon_sym_namespace] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_readonly] = ACTIONS(560),
    [anon_sym_get] = ACTIONS(560),
    [anon_sym_set] = ACTIONS(560),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(560),
    [anon_sym_number] = ACTIONS(560),
    [anon_sym_boolean] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_symbol] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [36] = {
    [sym_export_statement] = STATE(730),
    [sym_declaration] = STATE(730),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(730),
    [sym_expression_statement] = STATE(730),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(730),
    [sym_if_statement] = STATE(730),
    [sym_switch_statement] = STATE(730),
    [sym_for_statement] = STATE(730),
    [sym_for_in_statement] = STATE(730),
    [sym_while_statement] = STATE(730),
    [sym_do_statement] = STATE(730),
    [sym_try_statement] = STATE(730),
    [sym_with_statement] = STATE(730),
    [sym_break_statement] = STATE(730),
    [sym_continue_statement] = STATE(730),
    [sym_debugger_statement] = STATE(730),
    [sym_return_statement] = STATE(730),
    [sym_throw_statement] = STATE(730),
    [sym_empty_statement] = STATE(730),
    [sym_labeled_statement] = STATE(730),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3035),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(516),
    [anon_sym_namespace] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [37] = {
    [sym_export_statement] = STATE(676),
    [sym_declaration] = STATE(676),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(676),
    [sym_expression_statement] = STATE(676),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(676),
    [sym_if_statement] = STATE(676),
    [sym_switch_statement] = STATE(676),
    [sym_for_statement] = STATE(676),
    [sym_for_in_statement] = STATE(676),
    [sym_while_statement] = STATE(676),
    [sym_do_statement] = STATE(676),
    [sym_try_statement] = STATE(676),
    [sym_with_statement] = STATE(676),
    [sym_break_statement] = STATE(676),
    [sym_continue_statement] = STATE(676),
    [sym_debugger_statement] = STATE(676),
    [sym_return_statement] = STATE(676),
    [sym_throw_statement] = STATE(676),
    [sym_empty_statement] = STATE(676),
    [sym_labeled_statement] = STATE(676),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3118),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(546),
    [anon_sym_namespace] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_readonly] = ACTIONS(560),
    [anon_sym_get] = ACTIONS(560),
    [anon_sym_set] = ACTIONS(560),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(560),
    [anon_sym_number] = ACTIONS(560),
    [anon_sym_boolean] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_symbol] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [38] = {
    [sym_export_statement] = STATE(676),
    [sym_declaration] = STATE(676),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(676),
    [sym_expression_statement] = STATE(676),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(676),
    [sym_if_statement] = STATE(676),
    [sym_switch_statement] = STATE(676),
    [sym_for_statement] = STATE(676),
    [sym_for_in_statement] = STATE(676),
    [sym_while_statement] = STATE(676),
    [sym_do_statement] = STATE(676),
    [sym_try_statement] = STATE(676),
    [sym_with_statement] = STATE(676),
    [sym_break_statement] = STATE(676),
    [sym_continue_statement] = STATE(676),
    [sym_debugger_statement] = STATE(676),
    [sym_return_statement] = STATE(676),
    [sym_throw_statement] = STATE(676),
    [sym_empty_statement] = STATE(676),
    [sym_labeled_statement] = STATE(676),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3035),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(516),
    [anon_sym_namespace] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [39] = {
    [sym_export_statement] = STATE(684),
    [sym_declaration] = STATE(684),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(684),
    [sym_expression_statement] = STATE(684),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(684),
    [sym_if_statement] = STATE(684),
    [sym_switch_statement] = STATE(684),
    [sym_for_statement] = STATE(684),
    [sym_for_in_statement] = STATE(684),
    [sym_while_statement] = STATE(684),
    [sym_do_statement] = STATE(684),
    [sym_try_statement] = STATE(684),
    [sym_with_statement] = STATE(684),
    [sym_break_statement] = STATE(684),
    [sym_continue_statement] = STATE(684),
    [sym_debugger_statement] = STATE(684),
    [sym_return_statement] = STATE(684),
    [sym_throw_statement] = STATE(684),
    [sym_empty_statement] = STATE(684),
    [sym_labeled_statement] = STATE(684),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3118),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(546),
    [anon_sym_namespace] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_readonly] = ACTIONS(560),
    [anon_sym_get] = ACTIONS(560),
    [anon_sym_set] = ACTIONS(560),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(560),
    [anon_sym_number] = ACTIONS(560),
    [anon_sym_boolean] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_symbol] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [40] = {
    [sym_export_statement] = STATE(749),
    [sym_declaration] = STATE(745),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(634),
    [sym_expression_statement] = STATE(743),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(742),
    [sym_if_statement] = STATE(729),
    [sym_switch_statement] = STATE(724),
    [sym_for_statement] = STATE(723),
    [sym_for_in_statement] = STATE(722),
    [sym_while_statement] = STATE(720),
    [sym_do_statement] = STATE(719),
    [sym_try_statement] = STATE(712),
    [sym_with_statement] = STATE(711),
    [sym_break_statement] = STATE(709),
    [sym_continue_statement] = STATE(707),
    [sym_debugger_statement] = STATE(697),
    [sym_return_statement] = STATE(696),
    [sym_throw_statement] = STATE(688),
    [sym_empty_statement] = STATE(687),
    [sym_labeled_statement] = STATE(685),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [41] = {
    [sym_export_statement] = STATE(713),
    [sym_declaration] = STATE(713),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(713),
    [sym_expression_statement] = STATE(713),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(713),
    [sym_if_statement] = STATE(713),
    [sym_switch_statement] = STATE(713),
    [sym_for_statement] = STATE(713),
    [sym_for_in_statement] = STATE(713),
    [sym_while_statement] = STATE(713),
    [sym_do_statement] = STATE(713),
    [sym_try_statement] = STATE(713),
    [sym_with_statement] = STATE(713),
    [sym_break_statement] = STATE(713),
    [sym_continue_statement] = STATE(713),
    [sym_debugger_statement] = STATE(713),
    [sym_return_statement] = STATE(713),
    [sym_throw_statement] = STATE(713),
    [sym_empty_statement] = STATE(713),
    [sym_labeled_statement] = STATE(713),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3118),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(546),
    [anon_sym_namespace] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_readonly] = ACTIONS(560),
    [anon_sym_get] = ACTIONS(560),
    [anon_sym_set] = ACTIONS(560),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(560),
    [anon_sym_number] = ACTIONS(560),
    [anon_sym_boolean] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_symbol] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [42] = {
    [sym_export_statement] = STATE(725),
    [sym_declaration] = STATE(726),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(727),
    [sym_expression_statement] = STATE(728),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(731),
    [sym_if_statement] = STATE(732),
    [sym_switch_statement] = STATE(733),
    [sym_for_statement] = STATE(734),
    [sym_for_in_statement] = STATE(658),
    [sym_while_statement] = STATE(737),
    [sym_do_statement] = STATE(633),
    [sym_try_statement] = STATE(740),
    [sym_with_statement] = STATE(747),
    [sym_break_statement] = STATE(764),
    [sym_continue_statement] = STATE(766),
    [sym_debugger_statement] = STATE(771),
    [sym_return_statement] = STATE(775),
    [sym_throw_statement] = STATE(778),
    [sym_empty_statement] = STATE(774),
    [sym_labeled_statement] = STATE(770),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3118),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(546),
    [anon_sym_namespace] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_readonly] = ACTIONS(560),
    [anon_sym_get] = ACTIONS(560),
    [anon_sym_set] = ACTIONS(560),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(560),
    [anon_sym_number] = ACTIONS(560),
    [anon_sym_boolean] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_symbol] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [43] = {
    [sym_export_statement] = STATE(730),
    [sym_declaration] = STATE(730),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(730),
    [sym_expression_statement] = STATE(730),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(730),
    [sym_if_statement] = STATE(730),
    [sym_switch_statement] = STATE(730),
    [sym_for_statement] = STATE(730),
    [sym_for_in_statement] = STATE(730),
    [sym_while_statement] = STATE(730),
    [sym_do_statement] = STATE(730),
    [sym_try_statement] = STATE(730),
    [sym_with_statement] = STATE(730),
    [sym_break_statement] = STATE(730),
    [sym_continue_statement] = STATE(730),
    [sym_debugger_statement] = STATE(730),
    [sym_return_statement] = STATE(730),
    [sym_throw_statement] = STATE(730),
    [sym_empty_statement] = STATE(730),
    [sym_labeled_statement] = STATE(730),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3118),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(546),
    [anon_sym_namespace] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_readonly] = ACTIONS(560),
    [anon_sym_get] = ACTIONS(560),
    [anon_sym_set] = ACTIONS(560),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(560),
    [anon_sym_number] = ACTIONS(560),
    [anon_sym_boolean] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_symbol] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [44] = {
    [sym_export_statement] = STATE(756),
    [sym_declaration] = STATE(756),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(756),
    [sym_expression_statement] = STATE(756),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(756),
    [sym_if_statement] = STATE(756),
    [sym_switch_statement] = STATE(756),
    [sym_for_statement] = STATE(756),
    [sym_for_in_statement] = STATE(756),
    [sym_while_statement] = STATE(756),
    [sym_do_statement] = STATE(756),
    [sym_try_statement] = STATE(756),
    [sym_with_statement] = STATE(756),
    [sym_break_statement] = STATE(756),
    [sym_continue_statement] = STATE(756),
    [sym_debugger_statement] = STATE(756),
    [sym_return_statement] = STATE(756),
    [sym_throw_statement] = STATE(756),
    [sym_empty_statement] = STATE(756),
    [sym_labeled_statement] = STATE(756),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3118),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(546),
    [anon_sym_namespace] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_readonly] = ACTIONS(560),
    [anon_sym_get] = ACTIONS(560),
    [anon_sym_set] = ACTIONS(560),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(560),
    [anon_sym_number] = ACTIONS(560),
    [anon_sym_boolean] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_symbol] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [45] = {
    [sym_export_statement] = STATE(659),
    [sym_declaration] = STATE(659),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(659),
    [sym_expression_statement] = STATE(659),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(659),
    [sym_if_statement] = STATE(659),
    [sym_switch_statement] = STATE(659),
    [sym_for_statement] = STATE(659),
    [sym_for_in_statement] = STATE(659),
    [sym_while_statement] = STATE(659),
    [sym_do_statement] = STATE(659),
    [sym_try_statement] = STATE(659),
    [sym_with_statement] = STATE(659),
    [sym_break_statement] = STATE(659),
    [sym_continue_statement] = STATE(659),
    [sym_debugger_statement] = STATE(659),
    [sym_return_statement] = STATE(659),
    [sym_throw_statement] = STATE(659),
    [sym_empty_statement] = STATE(659),
    [sym_labeled_statement] = STATE(659),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [46] = {
    [sym_export_statement] = STATE(730),
    [sym_declaration] = STATE(730),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(730),
    [sym_expression_statement] = STATE(730),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(730),
    [sym_if_statement] = STATE(730),
    [sym_switch_statement] = STATE(730),
    [sym_for_statement] = STATE(730),
    [sym_for_in_statement] = STATE(730),
    [sym_while_statement] = STATE(730),
    [sym_do_statement] = STATE(730),
    [sym_try_statement] = STATE(730),
    [sym_with_statement] = STATE(730),
    [sym_break_statement] = STATE(730),
    [sym_continue_statement] = STATE(730),
    [sym_debugger_statement] = STATE(730),
    [sym_return_statement] = STATE(730),
    [sym_throw_statement] = STATE(730),
    [sym_empty_statement] = STATE(730),
    [sym_labeled_statement] = STATE(730),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [47] = {
    [sym_export_statement] = STATE(626),
    [sym_declaration] = STATE(626),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(626),
    [sym_expression_statement] = STATE(626),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(626),
    [sym_if_statement] = STATE(626),
    [sym_switch_statement] = STATE(626),
    [sym_for_statement] = STATE(626),
    [sym_for_in_statement] = STATE(626),
    [sym_while_statement] = STATE(626),
    [sym_do_statement] = STATE(626),
    [sym_try_statement] = STATE(626),
    [sym_with_statement] = STATE(626),
    [sym_break_statement] = STATE(626),
    [sym_continue_statement] = STATE(626),
    [sym_debugger_statement] = STATE(626),
    [sym_return_statement] = STATE(626),
    [sym_throw_statement] = STATE(626),
    [sym_empty_statement] = STATE(626),
    [sym_labeled_statement] = STATE(626),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [48] = {
    [sym_export_statement] = STATE(725),
    [sym_declaration] = STATE(726),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(727),
    [sym_expression_statement] = STATE(728),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(731),
    [sym_if_statement] = STATE(732),
    [sym_switch_statement] = STATE(733),
    [sym_for_statement] = STATE(734),
    [sym_for_in_statement] = STATE(658),
    [sym_while_statement] = STATE(737),
    [sym_do_statement] = STATE(633),
    [sym_try_statement] = STATE(740),
    [sym_with_statement] = STATE(747),
    [sym_break_statement] = STATE(764),
    [sym_continue_statement] = STATE(766),
    [sym_debugger_statement] = STATE(771),
    [sym_return_statement] = STATE(775),
    [sym_throw_statement] = STATE(778),
    [sym_empty_statement] = STATE(774),
    [sym_labeled_statement] = STATE(770),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [49] = {
    [sym_export_statement] = STATE(713),
    [sym_declaration] = STATE(713),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(713),
    [sym_expression_statement] = STATE(713),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(713),
    [sym_if_statement] = STATE(713),
    [sym_switch_statement] = STATE(713),
    [sym_for_statement] = STATE(713),
    [sym_for_in_statement] = STATE(713),
    [sym_while_statement] = STATE(713),
    [sym_do_statement] = STATE(713),
    [sym_try_statement] = STATE(713),
    [sym_with_statement] = STATE(713),
    [sym_break_statement] = STATE(713),
    [sym_continue_statement] = STATE(713),
    [sym_debugger_statement] = STATE(713),
    [sym_return_statement] = STATE(713),
    [sym_throw_statement] = STATE(713),
    [sym_empty_statement] = STATE(713),
    [sym_labeled_statement] = STATE(713),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3035),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(516),
    [anon_sym_namespace] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [50] = {
    [sym_export_statement] = STATE(684),
    [sym_declaration] = STATE(684),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(684),
    [sym_expression_statement] = STATE(684),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(684),
    [sym_if_statement] = STATE(684),
    [sym_switch_statement] = STATE(684),
    [sym_for_statement] = STATE(684),
    [sym_for_in_statement] = STATE(684),
    [sym_while_statement] = STATE(684),
    [sym_do_statement] = STATE(684),
    [sym_try_statement] = STATE(684),
    [sym_with_statement] = STATE(684),
    [sym_break_statement] = STATE(684),
    [sym_continue_statement] = STATE(684),
    [sym_debugger_statement] = STATE(684),
    [sym_return_statement] = STATE(684),
    [sym_throw_statement] = STATE(684),
    [sym_empty_statement] = STATE(684),
    [sym_labeled_statement] = STATE(684),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [51] = {
    [sym_export_statement] = STATE(3800),
    [sym_declaration] = STATE(3800),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(3800),
    [sym_expression_statement] = STATE(3800),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(3800),
    [sym_if_statement] = STATE(3800),
    [sym_switch_statement] = STATE(3800),
    [sym_for_statement] = STATE(3800),
    [sym_for_in_statement] = STATE(3800),
    [sym_while_statement] = STATE(3800),
    [sym_do_statement] = STATE(3800),
    [sym_try_statement] = STATE(3800),
    [sym_with_statement] = STATE(3800),
    [sym_break_statement] = STATE(3800),
    [sym_continue_statement] = STATE(3800),
    [sym_debugger_statement] = STATE(3800),
    [sym_return_statement] = STATE(3800),
    [sym_throw_statement] = STATE(3800),
    [sym_empty_statement] = STATE(3800),
    [sym_labeled_statement] = STATE(3800),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3118),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(546),
    [anon_sym_namespace] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_readonly] = ACTIONS(560),
    [anon_sym_get] = ACTIONS(560),
    [anon_sym_set] = ACTIONS(560),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(560),
    [anon_sym_number] = ACTIONS(560),
    [anon_sym_boolean] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_symbol] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [52] = {
    [sym_export_statement] = STATE(725),
    [sym_declaration] = STATE(726),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(727),
    [sym_expression_statement] = STATE(728),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(731),
    [sym_if_statement] = STATE(732),
    [sym_switch_statement] = STATE(733),
    [sym_for_statement] = STATE(734),
    [sym_for_in_statement] = STATE(658),
    [sym_while_statement] = STATE(737),
    [sym_do_statement] = STATE(633),
    [sym_try_statement] = STATE(740),
    [sym_with_statement] = STATE(747),
    [sym_break_statement] = STATE(764),
    [sym_continue_statement] = STATE(766),
    [sym_debugger_statement] = STATE(771),
    [sym_return_statement] = STATE(775),
    [sym_throw_statement] = STATE(778),
    [sym_empty_statement] = STATE(774),
    [sym_labeled_statement] = STATE(770),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3035),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(516),
    [anon_sym_namespace] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [53] = {
    [sym_export_statement] = STATE(4397),
    [sym_declaration] = STATE(4397),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(4397),
    [sym_expression_statement] = STATE(4397),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(4397),
    [sym_if_statement] = STATE(4397),
    [sym_switch_statement] = STATE(4397),
    [sym_for_statement] = STATE(4397),
    [sym_for_in_statement] = STATE(4397),
    [sym_while_statement] = STATE(4397),
    [sym_do_statement] = STATE(4397),
    [sym_try_statement] = STATE(4397),
    [sym_with_statement] = STATE(4397),
    [sym_break_statement] = STATE(4397),
    [sym_continue_statement] = STATE(4397),
    [sym_debugger_statement] = STATE(4397),
    [sym_return_statement] = STATE(4397),
    [sym_throw_statement] = STATE(4397),
    [sym_empty_statement] = STATE(4397),
    [sym_labeled_statement] = STATE(4397),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3035),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(516),
    [anon_sym_namespace] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [54] = {
    [sym_export_statement] = STATE(749),
    [sym_declaration] = STATE(745),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(634),
    [sym_expression_statement] = STATE(743),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(742),
    [sym_if_statement] = STATE(729),
    [sym_switch_statement] = STATE(724),
    [sym_for_statement] = STATE(723),
    [sym_for_in_statement] = STATE(722),
    [sym_while_statement] = STATE(720),
    [sym_do_statement] = STATE(719),
    [sym_try_statement] = STATE(712),
    [sym_with_statement] = STATE(711),
    [sym_break_statement] = STATE(709),
    [sym_continue_statement] = STATE(707),
    [sym_debugger_statement] = STATE(697),
    [sym_return_statement] = STATE(696),
    [sym_throw_statement] = STATE(688),
    [sym_empty_statement] = STATE(687),
    [sym_labeled_statement] = STATE(685),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3035),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(516),
    [anon_sym_namespace] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [55] = {
    [sym_export_statement] = STATE(3733),
    [sym_declaration] = STATE(3733),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(3733),
    [sym_expression_statement] = STATE(3733),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(3733),
    [sym_if_statement] = STATE(3733),
    [sym_switch_statement] = STATE(3733),
    [sym_for_statement] = STATE(3733),
    [sym_for_in_statement] = STATE(3733),
    [sym_while_statement] = STATE(3733),
    [sym_do_statement] = STATE(3733),
    [sym_try_statement] = STATE(3733),
    [sym_with_statement] = STATE(3733),
    [sym_break_statement] = STATE(3733),
    [sym_continue_statement] = STATE(3733),
    [sym_debugger_statement] = STATE(3733),
    [sym_return_statement] = STATE(3733),
    [sym_throw_statement] = STATE(3733),
    [sym_empty_statement] = STATE(3733),
    [sym_labeled_statement] = STATE(3733),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3118),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(546),
    [anon_sym_namespace] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_readonly] = ACTIONS(560),
    [anon_sym_get] = ACTIONS(560),
    [anon_sym_set] = ACTIONS(560),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(560),
    [anon_sym_number] = ACTIONS(560),
    [anon_sym_boolean] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_symbol] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [56] = {
    [sym_export_statement] = STATE(756),
    [sym_declaration] = STATE(756),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(756),
    [sym_expression_statement] = STATE(756),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(756),
    [sym_if_statement] = STATE(756),
    [sym_switch_statement] = STATE(756),
    [sym_for_statement] = STATE(756),
    [sym_for_in_statement] = STATE(756),
    [sym_while_statement] = STATE(756),
    [sym_do_statement] = STATE(756),
    [sym_try_statement] = STATE(756),
    [sym_with_statement] = STATE(756),
    [sym_break_statement] = STATE(756),
    [sym_continue_statement] = STATE(756),
    [sym_debugger_statement] = STATE(756),
    [sym_return_statement] = STATE(756),
    [sym_throw_statement] = STATE(756),
    [sym_empty_statement] = STATE(756),
    [sym_labeled_statement] = STATE(756),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3125),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(95),
    [anon_sym_set] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(95),
    [anon_sym_private] = ACTIONS(95),
    [anon_sym_protected] = ACTIONS(95),
    [anon_sym_override] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(95),
    [anon_sym_number] = ACTIONS(95),
    [anon_sym_boolean] = ACTIONS(95),
    [anon_sym_string] = ACTIONS(95),
    [anon_sym_symbol] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [57] = {
    [sym_export_statement] = STATE(684),
    [sym_declaration] = STATE(684),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(684),
    [sym_expression_statement] = STATE(684),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(684),
    [sym_if_statement] = STATE(684),
    [sym_switch_statement] = STATE(684),
    [sym_for_statement] = STATE(684),
    [sym_for_in_statement] = STATE(684),
    [sym_while_statement] = STATE(684),
    [sym_do_statement] = STATE(684),
    [sym_try_statement] = STATE(684),
    [sym_with_statement] = STATE(684),
    [sym_break_statement] = STATE(684),
    [sym_continue_statement] = STATE(684),
    [sym_debugger_statement] = STATE(684),
    [sym_return_statement] = STATE(684),
    [sym_throw_statement] = STATE(684),
    [sym_empty_statement] = STATE(684),
    [sym_labeled_statement] = STATE(684),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3035),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_export] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(516),
    [anon_sym_namespace] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [58] = {
    [sym_export_statement] = STATE(659),
    [sym_declaration] = STATE(659),
    [sym_import] = STATE(1955),
    [sym_import_statement] = STATE(659),
    [sym_expression_statement] = STATE(659),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_statement_block] = STATE(659),
    [sym_if_statement] = STATE(659),
    [sym_switch_statement] = STATE(659),
    [sym_for_statement] = STATE(659),
    [sym_for_in_statement] = STATE(659),
    [sym_while_statement] = STATE(659),
    [sym_do_statement] = STATE(659),
    [sym_try_statement] = STATE(659),
    [sym_with_statement] = STATE(659),
    [sym_break_statement] = STATE(659),
    [sym_continue_statement] = STATE(659),
    [sym_debugger_statement] = STATE(659),
    [sym_return_statement] = STATE(659),
    [sym_throw_statement] = STATE(659),
    [sym_empty_statement] = STATE(659),
    [sym_labeled_statement] = STATE(659),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3118),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(546),
    [anon_sym_namespace] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_readonly] = ACTIONS(560),
    [anon_sym_get] = ACTIONS(560),
    [anon_sym_set] = ACTIONS(560),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(560),
    [anon_sym_number] = ACTIONS(560),
    [anon_sym_boolean] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_symbol] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [59] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(3242),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3646),
    [sym_optional_tuple_parameter] = STATE(3646),
    [sym_optional_type] = STATE(3646),
    [sym_rest_type] = STATE(3646),
    [sym__tuple_type_member] = STATE(3646),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(588),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(614),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(618),
    [anon_sym_number] = ACTIONS(618),
    [anon_sym_boolean] = ACTIONS(618),
    [anon_sym_string] = ACTIONS(618),
    [anon_sym_symbol] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [60] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3155),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(128),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(128),
    [anon_sym_DASH] = ACTIONS(128),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [61] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(3242),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3646),
    [sym_optional_tuple_parameter] = STATE(3646),
    [sym_optional_type] = STATE(3646),
    [sym_rest_type] = STATE(3646),
    [sym__tuple_type_member] = STATE(3646),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(614),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(618),
    [anon_sym_number] = ACTIONS(618),
    [anon_sym_boolean] = ACTIONS(618),
    [anon_sym_string] = ACTIONS(618),
    [anon_sym_symbol] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [62] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1638),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3814),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(3242),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3646),
    [sym_optional_tuple_parameter] = STATE(3646),
    [sym_optional_type] = STATE(3646),
    [sym_rest_type] = STATE(3646),
    [sym__tuple_type_member] = STATE(3646),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3815),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(648),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(614),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(618),
    [anon_sym_number] = ACTIONS(618),
    [anon_sym_boolean] = ACTIONS(618),
    [anon_sym_string] = ACTIONS(618),
    [anon_sym_symbol] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [63] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3184),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(128),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(210),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(128),
    [anon_sym_DASH] = ACTIONS(128),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(650),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [64] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(3242),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3646),
    [sym_optional_tuple_parameter] = STATE(3646),
    [sym_optional_type] = STATE(3646),
    [sym_rest_type] = STATE(3646),
    [sym__tuple_type_member] = STATE(3646),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(652),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(614),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(618),
    [anon_sym_number] = ACTIONS(618),
    [anon_sym_boolean] = ACTIONS(618),
    [anon_sym_string] = ACTIONS(618),
    [anon_sym_symbol] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [65] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3184),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(128),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(128),
    [anon_sym_DASH] = ACTIONS(128),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(650),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [66] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(3242),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3816),
    [sym_optional_tuple_parameter] = STATE(3816),
    [sym_optional_type] = STATE(3816),
    [sym_rest_type] = STATE(3816),
    [sym__tuple_type_member] = STATE(3816),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(654),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(656),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(614),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(618),
    [anon_sym_number] = ACTIONS(618),
    [anon_sym_boolean] = ACTIONS(618),
    [anon_sym_string] = ACTIONS(618),
    [anon_sym_symbol] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [67] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1638),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3814),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(3242),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3646),
    [sym_optional_tuple_parameter] = STATE(3646),
    [sym_optional_type] = STATE(3646),
    [sym_rest_type] = STATE(3646),
    [sym__tuple_type_member] = STATE(3646),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3815),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(658),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(614),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(618),
    [anon_sym_number] = ACTIONS(618),
    [anon_sym_boolean] = ACTIONS(618),
    [anon_sym_string] = ACTIONS(618),
    [anon_sym_symbol] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [68] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3397),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(128),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(128),
    [anon_sym_DASH] = ACTIONS(128),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(660),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [69] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(3242),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3646),
    [sym_optional_tuple_parameter] = STATE(3646),
    [sym_optional_type] = STATE(3646),
    [sym_rest_type] = STATE(3646),
    [sym__tuple_type_member] = STATE(3646),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(662),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(614),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(618),
    [anon_sym_number] = ACTIONS(618),
    [anon_sym_boolean] = ACTIONS(618),
    [anon_sym_string] = ACTIONS(618),
    [anon_sym_symbol] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [70] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3263),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(128),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(128),
    [anon_sym_DASH] = ACTIONS(128),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(664),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [71] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(3242),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3646),
    [sym_optional_tuple_parameter] = STATE(3646),
    [sym_optional_type] = STATE(3646),
    [sym_rest_type] = STATE(3646),
    [sym__tuple_type_member] = STATE(3646),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(666),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(614),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(618),
    [anon_sym_number] = ACTIONS(618),
    [anon_sym_boolean] = ACTIONS(618),
    [anon_sym_string] = ACTIONS(618),
    [anon_sym_symbol] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [72] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3161),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(128),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(128),
    [anon_sym_DASH] = ACTIONS(128),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(668),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [73] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(3242),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3646),
    [sym_optional_tuple_parameter] = STATE(3646),
    [sym_optional_type] = STATE(3646),
    [sym_rest_type] = STATE(3646),
    [sym__tuple_type_member] = STATE(3646),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(670),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(614),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(618),
    [anon_sym_number] = ACTIONS(618),
    [anon_sym_boolean] = ACTIONS(618),
    [anon_sym_string] = ACTIONS(618),
    [anon_sym_symbol] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [74] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3264),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(128),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(128),
    [anon_sym_DASH] = ACTIONS(128),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(672),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [75] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3261),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(128),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(128),
    [anon_sym_DASH] = ACTIONS(128),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(172),
    [anon_sym_DASH_DASH] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(674),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [76] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(3242),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3646),
    [sym_optional_tuple_parameter] = STATE(3646),
    [sym_optional_type] = STATE(3646),
    [sym_rest_type] = STATE(3646),
    [sym__tuple_type_member] = STATE(3646),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(566),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(676),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(614),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(618),
    [anon_sym_number] = ACTIONS(618),
    [anon_sym_boolean] = ACTIONS(618),
    [anon_sym_string] = ACTIONS(618),
    [anon_sym_symbol] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [77] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1483),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4400),
    [sym_string] = STATE(1987),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym__type] = STATE(3561),
    [sym_constructor_type] = STATE(3561),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3561),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3561),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3561),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(678),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(680),
    [anon_sym_typeof] = ACTIONS(682),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(688),
    [anon_sym_DASH] = ACTIONS(688),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(696),
    [sym_false] = ACTIONS(696),
    [sym_null] = ACTIONS(696),
    [sym_undefined] = ACTIONS(698),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(706),
    [anon_sym_number] = ACTIONS(706),
    [anon_sym_boolean] = ACTIONS(706),
    [anon_sym_string] = ACTIONS(706),
    [anon_sym_symbol] = ACTIONS(706),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [78] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1402),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4395),
    [sym_string] = STATE(1987),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym__type] = STATE(3561),
    [sym_constructor_type] = STATE(3561),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3561),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3561),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3561),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(678),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(680),
    [anon_sym_typeof] = ACTIONS(682),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(688),
    [anon_sym_DASH] = ACTIONS(688),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(696),
    [sym_false] = ACTIONS(696),
    [sym_null] = ACTIONS(696),
    [sym_undefined] = ACTIONS(698),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(706),
    [anon_sym_number] = ACTIONS(706),
    [anon_sym_boolean] = ACTIONS(706),
    [anon_sym_string] = ACTIONS(706),
    [anon_sym_symbol] = ACTIONS(706),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [79] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1402),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4395),
    [sym_string] = STATE(1987),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym__type] = STATE(3478),
    [sym_constructor_type] = STATE(3478),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3478),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3478),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3478),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(678),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(680),
    [anon_sym_typeof] = ACTIONS(682),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(688),
    [anon_sym_DASH] = ACTIONS(688),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(696),
    [sym_false] = ACTIONS(696),
    [sym_null] = ACTIONS(696),
    [sym_undefined] = ACTIONS(698),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(700),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(706),
    [anon_sym_number] = ACTIONS(706),
    [anon_sym_boolean] = ACTIONS(706),
    [anon_sym_string] = ACTIONS(706),
    [anon_sym_symbol] = ACTIONS(706),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [80] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym__type] = STATE(3561),
    [sym_constructor_type] = STATE(3561),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3561),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3561),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3561),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(124),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(137),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(710),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(712),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(195),
    [anon_sym_number] = ACTIONS(195),
    [anon_sym_boolean] = ACTIONS(195),
    [anon_sym_string] = ACTIONS(195),
    [anon_sym_symbol] = ACTIONS(195),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [81] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym__type] = STATE(3535),
    [sym_constructor_type] = STATE(3535),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3535),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3535),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3535),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(124),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(137),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(710),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(712),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(195),
    [anon_sym_number] = ACTIONS(195),
    [anon_sym_boolean] = ACTIONS(195),
    [anon_sym_string] = ACTIONS(195),
    [anon_sym_symbol] = ACTIONS(195),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [82] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym__type] = STATE(3510),
    [sym_constructor_type] = STATE(3510),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3510),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3510),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3510),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(124),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(137),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(710),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(712),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(195),
    [anon_sym_number] = ACTIONS(195),
    [anon_sym_boolean] = ACTIONS(195),
    [anon_sym_string] = ACTIONS(195),
    [anon_sym_symbol] = ACTIONS(195),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [83] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym__type] = STATE(3556),
    [sym_constructor_type] = STATE(3556),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3556),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3556),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3556),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(124),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(137),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(710),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(712),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(195),
    [anon_sym_number] = ACTIONS(195),
    [anon_sym_boolean] = ACTIONS(195),
    [anon_sym_string] = ACTIONS(195),
    [anon_sym_symbol] = ACTIONS(195),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [84] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym__type] = STATE(3478),
    [sym_constructor_type] = STATE(3478),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3478),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3478),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3478),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(124),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(137),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(710),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(712),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(195),
    [anon_sym_number] = ACTIONS(195),
    [anon_sym_boolean] = ACTIONS(195),
    [anon_sym_string] = ACTIONS(195),
    [anon_sym_symbol] = ACTIONS(195),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [85] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1691),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4140),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1765),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3312),
    [sym_pattern] = STATE(3709),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2690),
    [sym_constructor_type] = STATE(2690),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2690),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(3973),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2690),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2690),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(718),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(722),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(740),
    [sym_number] = ACTIONS(742),
    [sym_this] = ACTIONS(744),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(746),
    [sym_false] = ACTIONS(746),
    [sym_null] = ACTIONS(746),
    [sym_undefined] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(750),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(754),
    [anon_sym_number] = ACTIONS(754),
    [anon_sym_boolean] = ACTIONS(754),
    [anon_sym_string] = ACTIONS(754),
    [anon_sym_symbol] = ACTIONS(754),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [86] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1689),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4199),
    [sym_string] = STATE(1987),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3648),
    [sym_constructor_type] = STATE(3648),
    [sym__primary_type] = STATE(3356),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3500),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3648),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3648),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(682),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(774),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(688),
    [anon_sym_DASH] = ACTIONS(688),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(778),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(696),
    [sym_false] = ACTIONS(696),
    [sym_null] = ACTIONS(696),
    [sym_undefined] = ACTIONS(780),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(782),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(784),
    [anon_sym_number] = ACTIONS(784),
    [anon_sym_boolean] = ACTIONS(784),
    [anon_sym_string] = ACTIONS(784),
    [anon_sym_symbol] = ACTIONS(784),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [87] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2881),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2881),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1184),
    [sym_subscript_expression] = STATE(1184),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2881),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(2074),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1184),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3355),
    [sym_constructor_type] = STATE(3355),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3355),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3355),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3355),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(786),
    [anon_sym_export] = ACTIONS(788),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(788),
    [anon_sym_namespace] = ACTIONS(790),
    [anon_sym_LBRACE] = ACTIONS(792),
    [anon_sym_typeof] = ACTIONS(794),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(796),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(798),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(154),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(800),
    [anon_sym_DASH] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(802),
    [sym_number] = ACTIONS(804),
    [sym_this] = ACTIONS(806),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(808),
    [sym_false] = ACTIONS(808),
    [sym_null] = ACTIONS(808),
    [sym_undefined] = ACTIONS(810),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(788),
    [anon_sym_readonly] = ACTIONS(812),
    [anon_sym_get] = ACTIONS(788),
    [anon_sym_set] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(788),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(788),
    [anon_sym_module] = ACTIONS(788),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [88] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1575),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1406),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3021),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(822),
    [anon_sym_typeof] = ACTIONS(824),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(832),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(838),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(842),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(848),
    [sym_number] = ACTIONS(850),
    [sym_this] = ACTIONS(852),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(854),
    [sym_false] = ACTIONS(854),
    [sym_null] = ACTIONS(854),
    [sym_undefined] = ACTIONS(856),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(858),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(860),
    [anon_sym_number] = ACTIONS(860),
    [anon_sym_boolean] = ACTIONS(860),
    [anon_sym_string] = ACTIONS(860),
    [anon_sym_symbol] = ACTIONS(860),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [89] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1860),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1817),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3021),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(868),
    [anon_sym_typeof] = ACTIONS(870),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(878),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(884),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(888),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(894),
    [sym_number] = ACTIONS(896),
    [sym_this] = ACTIONS(898),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(900),
    [sym_false] = ACTIONS(900),
    [sym_null] = ACTIONS(900),
    [sym_undefined] = ACTIONS(902),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(904),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(906),
    [anon_sym_number] = ACTIONS(906),
    [anon_sym_boolean] = ACTIONS(906),
    [anon_sym_string] = ACTIONS(906),
    [anon_sym_symbol] = ACTIONS(906),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [90] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1598),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1817),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3021),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(914),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(878),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(926),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(930),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(894),
    [sym_number] = ACTIONS(896),
    [sym_this] = ACTIONS(898),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(900),
    [sym_false] = ACTIONS(900),
    [sym_null] = ACTIONS(900),
    [sym_undefined] = ACTIONS(936),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(938),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(940),
    [anon_sym_number] = ACTIONS(940),
    [anon_sym_boolean] = ACTIONS(940),
    [anon_sym_string] = ACTIONS(940),
    [anon_sym_symbol] = ACTIONS(940),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [91] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1387),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1655),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3021),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_typeof] = ACTIONS(950),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(954),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(956),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(964),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(966),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(970),
    [sym_number] = ACTIONS(972),
    [sym_this] = ACTIONS(974),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [sym_undefined] = ACTIONS(978),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(982),
    [anon_sym_number] = ACTIONS(982),
    [anon_sym_boolean] = ACTIONS(982),
    [anon_sym_string] = ACTIONS(982),
    [anon_sym_symbol] = ACTIONS(982),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [92] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1404),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(3348),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(3348),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1150),
    [sym_subscript_expression] = STATE(1150),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(3348),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1150),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3355),
    [sym_constructor_type] = STATE(3355),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3355),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3355),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3355),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(984),
    [anon_sym_export] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(986),
    [anon_sym_namespace] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(992),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(179),
    [sym_number] = ACTIONS(181),
    [sym_this] = ACTIONS(610),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(187),
    [sym_false] = ACTIONS(187),
    [sym_null] = ACTIONS(187),
    [sym_undefined] = ACTIONS(994),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(986),
    [anon_sym_readonly] = ACTIONS(996),
    [anon_sym_get] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(986),
    [anon_sym_private] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(986),
    [anon_sym_override] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(998),
    [anon_sym_number] = ACTIONS(998),
    [anon_sym_boolean] = ACTIONS(998),
    [anon_sym_string] = ACTIONS(998),
    [anon_sym_symbol] = ACTIONS(998),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [93] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1575),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1406),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3089),
    [sym_constructor_type] = STATE(3089),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3089),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3089),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3089),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(822),
    [anon_sym_typeof] = ACTIONS(824),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(832),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(838),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(842),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(848),
    [sym_number] = ACTIONS(850),
    [sym_this] = ACTIONS(852),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(854),
    [sym_false] = ACTIONS(854),
    [sym_null] = ACTIONS(854),
    [sym_undefined] = ACTIONS(856),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(858),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(860),
    [anon_sym_number] = ACTIONS(860),
    [anon_sym_boolean] = ACTIONS(860),
    [anon_sym_string] = ACTIONS(860),
    [anon_sym_symbol] = ACTIONS(860),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [94] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1407),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1655),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3021),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_typeof] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(954),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(956),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1022),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(970),
    [sym_number] = ACTIONS(972),
    [sym_this] = ACTIONS(974),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [sym_undefined] = ACTIONS(1028),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1030),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1032),
    [anon_sym_number] = ACTIONS(1032),
    [anon_sym_boolean] = ACTIONS(1032),
    [anon_sym_string] = ACTIONS(1032),
    [anon_sym_symbol] = ACTIONS(1032),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [95] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1373),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1406),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3021),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(822),
    [anon_sym_typeof] = ACTIONS(1036),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(832),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(594),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(848),
    [sym_number] = ACTIONS(850),
    [sym_this] = ACTIONS(852),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(854),
    [sym_false] = ACTIONS(854),
    [sym_null] = ACTIONS(854),
    [sym_undefined] = ACTIONS(1040),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(782),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [96] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2018),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1817),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3021),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1044),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(868),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(878),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(154),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(894),
    [sym_number] = ACTIONS(896),
    [sym_this] = ACTIONS(898),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(900),
    [sym_false] = ACTIONS(900),
    [sym_null] = ACTIONS(900),
    [sym_undefined] = ACTIONS(1056),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1058),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1060),
    [anon_sym_number] = ACTIONS(1060),
    [anon_sym_boolean] = ACTIONS(1060),
    [anon_sym_string] = ACTIONS(1060),
    [anon_sym_symbol] = ACTIONS(1060),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [97] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1823),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_nested_identifier] = STATE(4216),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(2017),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3417),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3845),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3021),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1062),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1068),
    [anon_sym_typeof] = ACTIONS(1070),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(954),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(1078),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1086),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1092),
    [sym_number] = ACTIONS(1094),
    [sym_this] = ACTIONS(1096),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(1098),
    [sym_false] = ACTIONS(1098),
    [sym_null] = ACTIONS(1098),
    [sym_undefined] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1102),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1104),
    [anon_sym_number] = ACTIONS(1104),
    [anon_sym_boolean] = ACTIONS(1104),
    [anon_sym_string] = ACTIONS(1104),
    [anon_sym_symbol] = ACTIONS(1104),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [98] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1281),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(606),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1114),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_COLON] = ACTIONS(1114),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_RBRACK] = ACTIONS(1114),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [99] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1503),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_STAR] = ACTIONS(1128),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1024),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__automatic_semicolon] = ACTIONS(1114),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [100] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1526),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_STAR] = ACTIONS(1138),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__automatic_semicolon] = ACTIONS(1114),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [101] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1543),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(932),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_COLON] = ACTIONS(1114),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_RBRACK] = ACTIONS(1114),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [102] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1626),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
    [anon_sym_satisfies] = ACTIONS(1110),
    [anon_sym_implements] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [103] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1716),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1088),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__automatic_semicolon] = ACTIONS(1114),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [104] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1985),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_STAR] = ACTIONS(1166),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [105] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2044),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_STAR] = ACTIONS(1178),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(170),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
    [anon_sym_satisfies] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1114),
  },
  [106] = {
    [sym_declaration] = STATE(704),
    [sym_import] = STATE(1955),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1768),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3442),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(1186),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(1188),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1190),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1192),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [107] = {
    [sym_declaration] = STATE(3276),
    [sym_import] = STATE(1955),
    [sym_variable_declaration] = STATE(3329),
    [sym_lexical_declaration] = STATE(3329),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1683),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(3329),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(3329),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(3329),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_function_signature] = STATE(3329),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(3329),
    [sym_abstract_class_declaration] = STATE(3329),
    [sym_module] = STATE(3329),
    [sym_internal_module] = STATE(1841),
    [sym_import_alias] = STATE(3329),
    [sym_interface_declaration] = STATE(3329),
    [sym_enum_declaration] = STATE(3329),
    [sym_type_alias_declaration] = STATE(3329),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3215),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1194),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(1196),
    [anon_sym_var] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(1200),
    [anon_sym_const] = ACTIONS(1202),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(1204),
    [anon_sym_async] = ACTIONS(1206),
    [anon_sym_function] = ACTIONS(1208),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1210),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1212),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(1214),
    [anon_sym_interface] = ACTIONS(1216),
    [anon_sym_enum] = ACTIONS(1218),
  },
  [108] = {
    [sym_declaration] = STATE(704),
    [sym_import] = STATE(1955),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1768),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(1186),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1190),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1192),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [109] = {
    [sym_declaration] = STATE(704),
    [sym_import] = STATE(1955),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1768),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(1186),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1222),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1224),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [110] = {
    [sym_declaration] = STATE(3318),
    [sym_import] = STATE(1955),
    [sym_variable_declaration] = STATE(3329),
    [sym_lexical_declaration] = STATE(3329),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1727),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(3329),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(3329),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(3329),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_function_signature] = STATE(3329),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(3329),
    [sym_abstract_class_declaration] = STATE(3329),
    [sym_module] = STATE(3329),
    [sym_internal_module] = STATE(1841),
    [sym_import_alias] = STATE(3329),
    [sym_interface_declaration] = STATE(3329),
    [sym_enum_declaration] = STATE(3329),
    [sym_type_alias_declaration] = STATE(3329),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3215),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1194),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(1196),
    [anon_sym_var] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(1200),
    [anon_sym_const] = ACTIONS(1202),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(1204),
    [anon_sym_async] = ACTIONS(1206),
    [anon_sym_function] = ACTIONS(1208),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1210),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1212),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(1214),
    [anon_sym_interface] = ACTIONS(1216),
    [anon_sym_enum] = ACTIONS(1218),
  },
  [111] = {
    [sym_declaration] = STATE(773),
    [sym_import] = STATE(1955),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1773),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(1186),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1222),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1224),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [112] = {
    [sym_declaration] = STATE(773),
    [sym_import] = STATE(1955),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1773),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3442),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(1186),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(1188),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1190),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1192),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [113] = {
    [sym_declaration] = STATE(773),
    [sym_import] = STATE(1955),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1773),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_class_declaration] = STATE(649),
    [sym_function] = STATE(1955),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function] = STATE(1955),
    [sym_generator_function_declaration] = STATE(649),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_function_signature] = STATE(649),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(1858),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3418),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(1186),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1190),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1192),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_interface] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(105),
  },
  [114] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1228),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_RPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [115] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_of] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(1260),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [116] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [117] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [118] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1266),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(1268),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [119] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1228),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [120] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(1277),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [121] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1279),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_implements] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [122] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [123] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2639),
    [sym_constructor_type] = STATE(2639),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2639),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2639),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2639),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(210),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(1297),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(1299),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(1317),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [124] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [125] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_of] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [126] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [127] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1483),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4400),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1327),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(1331),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [128] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1402),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4395),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1327),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(1331),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [129] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(4066),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(4066),
    [sym_optional_parameter] = STATE(4066),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1337),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [130] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(4066),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(4066),
    [sym_optional_parameter] = STATE(4066),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1337),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [131] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(4066),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(4066),
    [sym_optional_parameter] = STATE(4066),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1343),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1337),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [132] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(3642),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3642),
    [sym_optional_parameter] = STATE(3642),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1345),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1337),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [133] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(4066),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(4066),
    [sym_optional_parameter] = STATE(4066),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1347),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1337),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [134] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(3769),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3769),
    [sym_optional_parameter] = STATE(3769),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1349),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1337),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [135] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(3731),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(3731),
    [sym_optional_parameter] = STATE(3731),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1337),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [136] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(4066),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(4066),
    [sym_optional_parameter] = STATE(4066),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1337),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [137] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(4066),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(4066),
    [sym_optional_parameter] = STATE(4066),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1337),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [138] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1638),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3814),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3815),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1357),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [139] = {
    [sym_import] = STATE(1955),
    [sym_expression_statement] = STATE(205),
    [sym_variable_declaration] = STATE(205),
    [sym_lexical_declaration] = STATE(205),
    [sym_empty_statement] = STATE(205),
    [sym_parenthesized_expression] = STATE(1154),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(3831),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(3831),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1154),
    [sym_subscript_expression] = STATE(1154),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(3831),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1154),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_export] = ACTIONS(1361),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_namespace] = ACTIONS(1363),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_var] = ACTIONS(1367),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_get] = ACTIONS(1361),
    [anon_sym_set] = ACTIONS(1361),
    [anon_sym_declare] = ACTIONS(1361),
    [anon_sym_public] = ACTIONS(1361),
    [anon_sym_private] = ACTIONS(1361),
    [anon_sym_protected] = ACTIONS(1361),
    [anon_sym_override] = ACTIONS(1361),
    [anon_sym_module] = ACTIONS(1361),
    [anon_sym_any] = ACTIONS(1361),
    [anon_sym_number] = ACTIONS(1361),
    [anon_sym_boolean] = ACTIONS(1361),
    [anon_sym_string] = ACTIONS(1361),
    [anon_sym_symbol] = ACTIONS(1361),
  },
  [140] = {
    [sym_import] = STATE(1955),
    [sym_expression_statement] = STATE(211),
    [sym_variable_declaration] = STATE(211),
    [sym_lexical_declaration] = STATE(211),
    [sym_empty_statement] = STATE(211),
    [sym_parenthesized_expression] = STATE(1154),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(3831),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(3831),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1154),
    [sym_subscript_expression] = STATE(1154),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(3831),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1154),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_export] = ACTIONS(1361),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_namespace] = ACTIONS(1363),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_var] = ACTIONS(1367),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_get] = ACTIONS(1361),
    [anon_sym_set] = ACTIONS(1361),
    [anon_sym_declare] = ACTIONS(1361),
    [anon_sym_public] = ACTIONS(1361),
    [anon_sym_private] = ACTIONS(1361),
    [anon_sym_protected] = ACTIONS(1361),
    [anon_sym_override] = ACTIONS(1361),
    [anon_sym_module] = ACTIONS(1361),
    [anon_sym_any] = ACTIONS(1361),
    [anon_sym_number] = ACTIONS(1361),
    [anon_sym_boolean] = ACTIONS(1361),
    [anon_sym_string] = ACTIONS(1361),
    [anon_sym_symbol] = ACTIONS(1361),
  },
  [141] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1569),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3814),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3815),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1357),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [142] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1377),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [143] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1379),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [144] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_RBRACE] = ACTIONS(1381),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1381),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_RBRACK] = ACTIONS(1381),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_QMARK] = ACTIONS(1381),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [anon_sym_extends] = ACTIONS(1383),
  },
  [145] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1385),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [146] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1638),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3814),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3815),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1387),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [147] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym__formal_parameter] = STATE(4066),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3262),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(204),
    [sym_override_modifier] = STATE(228),
    [sym_required_parameter] = STATE(4066),
    [sym_optional_parameter] = STATE(4066),
    [sym__parameter_name] = STATE(2942),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(194),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1337),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [148] = {
    [sym_import] = STATE(1955),
    [sym_expression_statement] = STATE(208),
    [sym_variable_declaration] = STATE(208),
    [sym_lexical_declaration] = STATE(208),
    [sym_empty_statement] = STATE(208),
    [sym_parenthesized_expression] = STATE(1154),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(3831),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(3831),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1154),
    [sym_subscript_expression] = STATE(1154),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(3831),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1154),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_export] = ACTIONS(1361),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_namespace] = ACTIONS(1363),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_var] = ACTIONS(1367),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_get] = ACTIONS(1361),
    [anon_sym_set] = ACTIONS(1361),
    [anon_sym_declare] = ACTIONS(1361),
    [anon_sym_public] = ACTIONS(1361),
    [anon_sym_private] = ACTIONS(1361),
    [anon_sym_protected] = ACTIONS(1361),
    [anon_sym_override] = ACTIONS(1361),
    [anon_sym_module] = ACTIONS(1361),
    [anon_sym_any] = ACTIONS(1361),
    [anon_sym_number] = ACTIONS(1361),
    [anon_sym_boolean] = ACTIONS(1361),
    [anon_sym_string] = ACTIONS(1361),
    [anon_sym_symbol] = ACTIONS(1361),
  },
  [149] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1389),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [150] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3588),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1391),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [151] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_RBRACE] = ACTIONS(1381),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [anon_sym_extends] = ACTIONS(1383),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1381),
    [sym__automatic_semicolon] = ACTIONS(1381),
  },
  [152] = {
    [sym_statement_block] = STATE(162),
    [ts_builtin_sym_end] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_default] = ACTIONS(1395),
    [anon_sym_type] = ACTIONS(1395),
    [anon_sym_as] = ACTIONS(1395),
    [anon_sym_namespace] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_COMMA] = ACTIONS(1393),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_typeof] = ACTIONS(1395),
    [anon_sym_import] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1395),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_const] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_else] = ACTIONS(1395),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_switch] = ACTIONS(1395),
    [anon_sym_for] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_in] = ACTIONS(1395),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_do] = ACTIONS(1395),
    [anon_sym_try] = ACTIONS(1395),
    [anon_sym_with] = ACTIONS(1395),
    [anon_sym_break] = ACTIONS(1395),
    [anon_sym_continue] = ACTIONS(1395),
    [anon_sym_debugger] = ACTIONS(1395),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_throw] = ACTIONS(1395),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_LTtemplate_GT] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_GT] = ACTIONS(1395),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_DOT] = ACTIONS(1399),
    [anon_sym_class] = ACTIONS(1395),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_function] = ACTIONS(1395),
    [anon_sym_QMARK_DOT] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1395),
    [anon_sym_AMP_AMP] = ACTIONS(1393),
    [anon_sym_PIPE_PIPE] = ACTIONS(1393),
    [anon_sym_GT_GT] = ACTIONS(1395),
    [anon_sym_GT_GT_GT] = ACTIONS(1393),
    [anon_sym_LT_LT] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_CARET] = ACTIONS(1393),
    [anon_sym_PIPE] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_STAR] = ACTIONS(1393),
    [anon_sym_LT_EQ] = ACTIONS(1393),
    [anon_sym_EQ_EQ] = ACTIONS(1395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1393),
    [anon_sym_BANG_EQ] = ACTIONS(1395),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1393),
    [anon_sym_GT_EQ] = ACTIONS(1393),
    [anon_sym_QMARK_QMARK] = ACTIONS(1393),
    [anon_sym_instanceof] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1393),
    [anon_sym_void] = ACTIONS(1395),
    [anon_sym_delete] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1393),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1393),
    [sym_number] = ACTIONS(1393),
    [sym_this] = ACTIONS(1395),
    [sym_super] = ACTIONS(1395),
    [sym_true] = ACTIONS(1395),
    [sym_false] = ACTIONS(1395),
    [sym_null] = ACTIONS(1395),
    [sym_undefined] = ACTIONS(1395),
    [anon_sym_AT] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1395),
    [anon_sym_readonly] = ACTIONS(1395),
    [anon_sym_get] = ACTIONS(1395),
    [anon_sym_set] = ACTIONS(1395),
    [anon_sym_declare] = ACTIONS(1395),
    [anon_sym_public] = ACTIONS(1395),
    [anon_sym_private] = ACTIONS(1395),
    [anon_sym_protected] = ACTIONS(1395),
    [anon_sym_override] = ACTIONS(1395),
    [anon_sym_module] = ACTIONS(1395),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1395),
    [anon_sym_satisfies] = ACTIONS(1395),
    [anon_sym_interface] = ACTIONS(1395),
    [anon_sym_enum] = ACTIONS(1395),
    [sym__automatic_semicolon] = ACTIONS(1393),
    [sym__ternary_qmark] = ACTIONS(1393),
  },
  [153] = {
    [sym_statement_block] = STATE(162),
    [ts_builtin_sym_end] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_default] = ACTIONS(1395),
    [anon_sym_type] = ACTIONS(1395),
    [anon_sym_as] = ACTIONS(1395),
    [anon_sym_namespace] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_COMMA] = ACTIONS(1393),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_typeof] = ACTIONS(1395),
    [anon_sym_import] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1395),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_const] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_else] = ACTIONS(1395),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_switch] = ACTIONS(1395),
    [anon_sym_for] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_in] = ACTIONS(1395),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_do] = ACTIONS(1395),
    [anon_sym_try] = ACTIONS(1395),
    [anon_sym_with] = ACTIONS(1395),
    [anon_sym_break] = ACTIONS(1395),
    [anon_sym_continue] = ACTIONS(1395),
    [anon_sym_debugger] = ACTIONS(1395),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_throw] = ACTIONS(1395),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_LTtemplate_GT] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_GT] = ACTIONS(1395),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_DOT] = ACTIONS(1395),
    [anon_sym_class] = ACTIONS(1395),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_function] = ACTIONS(1395),
    [anon_sym_QMARK_DOT] = ACTIONS(1393),
    [anon_sym_new] = ACTIONS(1395),
    [anon_sym_AMP_AMP] = ACTIONS(1393),
    [anon_sym_PIPE_PIPE] = ACTIONS(1393),
    [anon_sym_GT_GT] = ACTIONS(1395),
    [anon_sym_GT_GT_GT] = ACTIONS(1393),
    [anon_sym_LT_LT] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_CARET] = ACTIONS(1393),
    [anon_sym_PIPE] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_STAR] = ACTIONS(1393),
    [anon_sym_LT_EQ] = ACTIONS(1393),
    [anon_sym_EQ_EQ] = ACTIONS(1395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1393),
    [anon_sym_BANG_EQ] = ACTIONS(1395),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1393),
    [anon_sym_GT_EQ] = ACTIONS(1393),
    [anon_sym_QMARK_QMARK] = ACTIONS(1393),
    [anon_sym_instanceof] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1393),
    [anon_sym_void] = ACTIONS(1395),
    [anon_sym_delete] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1393),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1393),
    [sym_number] = ACTIONS(1393),
    [sym_this] = ACTIONS(1395),
    [sym_super] = ACTIONS(1395),
    [sym_true] = ACTIONS(1395),
    [sym_false] = ACTIONS(1395),
    [sym_null] = ACTIONS(1395),
    [sym_undefined] = ACTIONS(1395),
    [anon_sym_AT] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1395),
    [anon_sym_readonly] = ACTIONS(1395),
    [anon_sym_get] = ACTIONS(1395),
    [anon_sym_set] = ACTIONS(1395),
    [anon_sym_declare] = ACTIONS(1395),
    [anon_sym_public] = ACTIONS(1395),
    [anon_sym_private] = ACTIONS(1395),
    [anon_sym_protected] = ACTIONS(1395),
    [anon_sym_override] = ACTIONS(1395),
    [anon_sym_module] = ACTIONS(1395),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1395),
    [anon_sym_satisfies] = ACTIONS(1395),
    [anon_sym_interface] = ACTIONS(1395),
    [anon_sym_enum] = ACTIONS(1395),
    [sym__automatic_semicolon] = ACTIONS(1393),
    [sym__ternary_qmark] = ACTIONS(1393),
  },
  [154] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1878),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(3719),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(3719),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1180),
    [sym_subscript_expression] = STATE(1180),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(3719),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1180),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_mapped_type_clause] = STATE(4131),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(1401),
    [anon_sym_export] = ACTIONS(1403),
    [anon_sym_type] = ACTIONS(1403),
    [anon_sym_namespace] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_COMMA] = ACTIONS(1409),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_RBRACK] = ACTIONS(1413),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1415),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1417),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1403),
    [anon_sym_readonly] = ACTIONS(1403),
    [anon_sym_get] = ACTIONS(1403),
    [anon_sym_set] = ACTIONS(1403),
    [anon_sym_declare] = ACTIONS(1403),
    [anon_sym_public] = ACTIONS(1403),
    [anon_sym_private] = ACTIONS(1403),
    [anon_sym_protected] = ACTIONS(1403),
    [anon_sym_override] = ACTIONS(1403),
    [anon_sym_module] = ACTIONS(1403),
    [anon_sym_any] = ACTIONS(1403),
    [anon_sym_number] = ACTIONS(1403),
    [anon_sym_boolean] = ACTIONS(1403),
    [anon_sym_string] = ACTIONS(1403),
    [anon_sym_symbol] = ACTIONS(1403),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(1419),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_export] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_type] = ACTIONS(1421),
    [anon_sym_EQ] = ACTIONS(1425),
    [anon_sym_as] = ACTIONS(1423),
    [anon_sym_namespace] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1419),
    [anon_sym_COMMA] = ACTIONS(1427),
    [anon_sym_RBRACE] = ACTIONS(1419),
    [anon_sym_typeof] = ACTIONS(1421),
    [anon_sym_import] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1421),
    [anon_sym_let] = ACTIONS(1421),
    [anon_sym_const] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_else] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1421),
    [anon_sym_for] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_await] = ACTIONS(1421),
    [anon_sym_in] = ACTIONS(1423),
    [anon_sym_while] = ACTIONS(1421),
    [anon_sym_do] = ACTIONS(1421),
    [anon_sym_try] = ACTIONS(1421),
    [anon_sym_with] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1421),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_debugger] = ACTIONS(1421),
    [anon_sym_return] = ACTIONS(1421),
    [anon_sym_throw] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1419),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_yield] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1419),
    [anon_sym_LTtemplate_GT] = ACTIONS(1419),
    [anon_sym_LT] = ACTIONS(1421),
    [anon_sym_GT] = ACTIONS(1423),
    [anon_sym_SLASH] = ACTIONS(1421),
    [anon_sym_DOT] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1421),
    [anon_sym_function] = ACTIONS(1421),
    [anon_sym_QMARK_DOT] = ACTIONS(1427),
    [anon_sym_new] = ACTIONS(1421),
    [anon_sym_AMP_AMP] = ACTIONS(1427),
    [anon_sym_PIPE_PIPE] = ACTIONS(1427),
    [anon_sym_GT_GT] = ACTIONS(1423),
    [anon_sym_GT_GT_GT] = ACTIONS(1427),
    [anon_sym_LT_LT] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1427),
    [anon_sym_PIPE] = ACTIONS(1423),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_STAR_STAR] = ACTIONS(1427),
    [anon_sym_LT_EQ] = ACTIONS(1427),
    [anon_sym_EQ_EQ] = ACTIONS(1423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1427),
    [anon_sym_BANG_EQ] = ACTIONS(1423),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1427),
    [anon_sym_GT_EQ] = ACTIONS(1427),
    [anon_sym_QMARK_QMARK] = ACTIONS(1427),
    [anon_sym_instanceof] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_void] = ACTIONS(1421),
    [anon_sym_delete] = ACTIONS(1421),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_DQUOTE] = ACTIONS(1419),
    [anon_sym_SQUOTE] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1419),
    [sym_this] = ACTIONS(1421),
    [sym_super] = ACTIONS(1421),
    [sym_true] = ACTIONS(1421),
    [sym_false] = ACTIONS(1421),
    [sym_null] = ACTIONS(1421),
    [sym_undefined] = ACTIONS(1421),
    [anon_sym_AT] = ACTIONS(1419),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_readonly] = ACTIONS(1421),
    [anon_sym_get] = ACTIONS(1421),
    [anon_sym_set] = ACTIONS(1421),
    [anon_sym_declare] = ACTIONS(1421),
    [anon_sym_public] = ACTIONS(1421),
    [anon_sym_private] = ACTIONS(1421),
    [anon_sym_protected] = ACTIONS(1421),
    [anon_sym_override] = ACTIONS(1421),
    [anon_sym_module] = ACTIONS(1421),
    [anon_sym_any] = ACTIONS(1421),
    [anon_sym_number] = ACTIONS(1421),
    [anon_sym_boolean] = ACTIONS(1421),
    [anon_sym_string] = ACTIONS(1421),
    [anon_sym_symbol] = ACTIONS(1421),
    [anon_sym_abstract] = ACTIONS(1421),
    [anon_sym_satisfies] = ACTIONS(1423),
    [anon_sym_interface] = ACTIONS(1421),
    [anon_sym_enum] = ACTIONS(1421),
    [sym__automatic_semicolon] = ACTIONS(1429),
    [sym__ternary_qmark] = ACTIONS(1427),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_export] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_type] = ACTIONS(1433),
    [anon_sym_as] = ACTIONS(1435),
    [anon_sym_namespace] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1431),
    [anon_sym_typeof] = ACTIONS(1433),
    [anon_sym_import] = ACTIONS(1433),
    [anon_sym_var] = ACTIONS(1433),
    [anon_sym_let] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_BANG] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(1431),
    [anon_sym_await] = ACTIONS(1433),
    [anon_sym_in] = ACTIONS(1435),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_try] = ACTIONS(1433),
    [anon_sym_with] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_debugger] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_throw] = ACTIONS(1433),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_yield] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1431),
    [anon_sym_LTtemplate_GT] = ACTIONS(1431),
    [anon_sym_LT] = ACTIONS(1433),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_SLASH] = ACTIONS(1433),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_class] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1433),
    [anon_sym_function] = ACTIONS(1433),
    [anon_sym_QMARK_DOT] = ACTIONS(1437),
    [anon_sym_new] = ACTIONS(1433),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_CARET] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PERCENT] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1437),
    [anon_sym_LT_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ] = ACTIONS(1435),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1437),
    [anon_sym_BANG_EQ] = ACTIONS(1435),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1437),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_QMARK_QMARK] = ACTIONS(1437),
    [anon_sym_instanceof] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_void] = ACTIONS(1433),
    [anon_sym_delete] = ACTIONS(1433),
    [anon_sym_PLUS_PLUS] = ACTIONS(1431),
    [anon_sym_DASH_DASH] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [anon_sym_SQUOTE] = ACTIONS(1431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1431),
    [sym_number] = ACTIONS(1431),
    [sym_this] = ACTIONS(1433),
    [sym_super] = ACTIONS(1433),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [sym_null] = ACTIONS(1433),
    [sym_undefined] = ACTIONS(1433),
    [anon_sym_AT] = ACTIONS(1431),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_readonly] = ACTIONS(1433),
    [anon_sym_get] = ACTIONS(1433),
    [anon_sym_set] = ACTIONS(1433),
    [anon_sym_declare] = ACTIONS(1433),
    [anon_sym_public] = ACTIONS(1433),
    [anon_sym_private] = ACTIONS(1433),
    [anon_sym_protected] = ACTIONS(1433),
    [anon_sym_override] = ACTIONS(1433),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_any] = ACTIONS(1433),
    [anon_sym_number] = ACTIONS(1433),
    [anon_sym_boolean] = ACTIONS(1433),
    [anon_sym_string] = ACTIONS(1433),
    [anon_sym_symbol] = ACTIONS(1433),
    [anon_sym_abstract] = ACTIONS(1433),
    [anon_sym_satisfies] = ACTIONS(1435),
    [anon_sym_interface] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [sym__automatic_semicolon] = ACTIONS(1439),
    [sym__ternary_qmark] = ACTIONS(1437),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1443),
    [anon_sym_export] = ACTIONS(1443),
    [anon_sym_STAR] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1443),
    [anon_sym_type] = ACTIONS(1443),
    [anon_sym_as] = ACTIONS(1443),
    [anon_sym_namespace] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_typeof] = ACTIONS(1443),
    [anon_sym_import] = ACTIONS(1443),
    [anon_sym_var] = ACTIONS(1443),
    [anon_sym_let] = ACTIONS(1443),
    [anon_sym_const] = ACTIONS(1443),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_else] = ACTIONS(1443),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_in] = ACTIONS(1443),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1443),
    [anon_sym_try] = ACTIONS(1443),
    [anon_sym_with] = ACTIONS(1443),
    [anon_sym_break] = ACTIONS(1443),
    [anon_sym_continue] = ACTIONS(1443),
    [anon_sym_debugger] = ACTIONS(1443),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_throw] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_case] = ACTIONS(1443),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_LTtemplate_GT] = ACTIONS(1441),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_class] = ACTIONS(1443),
    [anon_sym_async] = ACTIONS(1443),
    [anon_sym_function] = ACTIONS(1443),
    [anon_sym_QMARK_DOT] = ACTIONS(1441),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_AMP_AMP] = ACTIONS(1441),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1443),
    [anon_sym_GT_GT_GT] = ACTIONS(1441),
    [anon_sym_LT_LT] = ACTIONS(1441),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1441),
    [anon_sym_STAR_STAR] = ACTIONS(1441),
    [anon_sym_LT_EQ] = ACTIONS(1441),
    [anon_sym_EQ_EQ] = ACTIONS(1443),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1441),
    [anon_sym_BANG_EQ] = ACTIONS(1443),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1441),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_QMARK_QMARK] = ACTIONS(1441),
    [anon_sym_instanceof] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(1441),
    [anon_sym_void] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1443),
    [anon_sym_PLUS_PLUS] = ACTIONS(1441),
    [anon_sym_DASH_DASH] = ACTIONS(1441),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1441),
    [sym_number] = ACTIONS(1441),
    [sym_this] = ACTIONS(1443),
    [sym_super] = ACTIONS(1443),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_undefined] = ACTIONS(1443),
    [anon_sym_AT] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1443),
    [anon_sym_readonly] = ACTIONS(1443),
    [anon_sym_get] = ACTIONS(1443),
    [anon_sym_set] = ACTIONS(1443),
    [anon_sym_declare] = ACTIONS(1443),
    [anon_sym_public] = ACTIONS(1443),
    [anon_sym_private] = ACTIONS(1443),
    [anon_sym_protected] = ACTIONS(1443),
    [anon_sym_override] = ACTIONS(1443),
    [anon_sym_module] = ACTIONS(1443),
    [anon_sym_any] = ACTIONS(1443),
    [anon_sym_number] = ACTIONS(1443),
    [anon_sym_boolean] = ACTIONS(1443),
    [anon_sym_string] = ACTIONS(1443),
    [anon_sym_symbol] = ACTIONS(1443),
    [anon_sym_abstract] = ACTIONS(1443),
    [anon_sym_satisfies] = ACTIONS(1443),
    [anon_sym_interface] = ACTIONS(1443),
    [anon_sym_enum] = ACTIONS(1443),
    [sym__automatic_semicolon] = ACTIONS(1441),
    [sym__ternary_qmark] = ACTIONS(1441),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(1445),
    [sym_identifier] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1447),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_default] = ACTIONS(1447),
    [anon_sym_type] = ACTIONS(1447),
    [anon_sym_as] = ACTIONS(1447),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_typeof] = ACTIONS(1447),
    [anon_sym_import] = ACTIONS(1447),
    [anon_sym_var] = ACTIONS(1447),
    [anon_sym_let] = ACTIONS(1447),
    [anon_sym_const] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_await] = ACTIONS(1447),
    [anon_sym_in] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_do] = ACTIONS(1447),
    [anon_sym_try] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1447),
    [anon_sym_break] = ACTIONS(1447),
    [anon_sym_continue] = ACTIONS(1447),
    [anon_sym_debugger] = ACTIONS(1447),
    [anon_sym_return] = ACTIONS(1447),
    [anon_sym_throw] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1447),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [anon_sym_LTtemplate_GT] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_SLASH] = ACTIONS(1447),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_class] = ACTIONS(1447),
    [anon_sym_async] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_QMARK_DOT] = ACTIONS(1445),
    [anon_sym_new] = ACTIONS(1447),
    [anon_sym_AMP_AMP] = ACTIONS(1445),
    [anon_sym_PIPE_PIPE] = ACTIONS(1445),
    [anon_sym_GT_GT] = ACTIONS(1447),
    [anon_sym_GT_GT_GT] = ACTIONS(1445),
    [anon_sym_LT_LT] = ACTIONS(1445),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_CARET] = ACTIONS(1445),
    [anon_sym_PIPE] = ACTIONS(1447),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1445),
    [anon_sym_STAR_STAR] = ACTIONS(1445),
    [anon_sym_LT_EQ] = ACTIONS(1445),
    [anon_sym_EQ_EQ] = ACTIONS(1447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1447),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1445),
    [anon_sym_GT_EQ] = ACTIONS(1445),
    [anon_sym_QMARK_QMARK] = ACTIONS(1445),
    [anon_sym_instanceof] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1445),
    [anon_sym_void] = ACTIONS(1447),
    [anon_sym_delete] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1445),
    [anon_sym_DASH_DASH] = ACTIONS(1445),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1445),
    [sym_number] = ACTIONS(1445),
    [sym_this] = ACTIONS(1447),
    [sym_super] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_undefined] = ACTIONS(1447),
    [anon_sym_AT] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1447),
    [anon_sym_readonly] = ACTIONS(1447),
    [anon_sym_get] = ACTIONS(1447),
    [anon_sym_set] = ACTIONS(1447),
    [anon_sym_declare] = ACTIONS(1447),
    [anon_sym_public] = ACTIONS(1447),
    [anon_sym_private] = ACTIONS(1447),
    [anon_sym_protected] = ACTIONS(1447),
    [anon_sym_override] = ACTIONS(1447),
    [anon_sym_module] = ACTIONS(1447),
    [anon_sym_any] = ACTIONS(1447),
    [anon_sym_number] = ACTIONS(1447),
    [anon_sym_boolean] = ACTIONS(1447),
    [anon_sym_string] = ACTIONS(1447),
    [anon_sym_symbol] = ACTIONS(1447),
    [anon_sym_abstract] = ACTIONS(1447),
    [anon_sym_satisfies] = ACTIONS(1447),
    [anon_sym_interface] = ACTIONS(1447),
    [anon_sym_enum] = ACTIONS(1447),
    [sym__automatic_semicolon] = ACTIONS(1449),
    [sym__ternary_qmark] = ACTIONS(1445),
  },
  [159] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(1409),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_RBRACK] = ACTIONS(1413),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(1445),
    [sym_identifier] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1447),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_default] = ACTIONS(1447),
    [anon_sym_type] = ACTIONS(1447),
    [anon_sym_as] = ACTIONS(1447),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_typeof] = ACTIONS(1447),
    [anon_sym_import] = ACTIONS(1447),
    [anon_sym_var] = ACTIONS(1447),
    [anon_sym_let] = ACTIONS(1447),
    [anon_sym_const] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_await] = ACTIONS(1447),
    [anon_sym_in] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_do] = ACTIONS(1447),
    [anon_sym_try] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1447),
    [anon_sym_break] = ACTIONS(1447),
    [anon_sym_continue] = ACTIONS(1447),
    [anon_sym_debugger] = ACTIONS(1447),
    [anon_sym_return] = ACTIONS(1447),
    [anon_sym_throw] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1447),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [anon_sym_LTtemplate_GT] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_SLASH] = ACTIONS(1447),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_class] = ACTIONS(1447),
    [anon_sym_async] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_QMARK_DOT] = ACTIONS(1445),
    [anon_sym_new] = ACTIONS(1447),
    [anon_sym_AMP_AMP] = ACTIONS(1445),
    [anon_sym_PIPE_PIPE] = ACTIONS(1445),
    [anon_sym_GT_GT] = ACTIONS(1447),
    [anon_sym_GT_GT_GT] = ACTIONS(1445),
    [anon_sym_LT_LT] = ACTIONS(1445),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_CARET] = ACTIONS(1445),
    [anon_sym_PIPE] = ACTIONS(1447),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1445),
    [anon_sym_STAR_STAR] = ACTIONS(1445),
    [anon_sym_LT_EQ] = ACTIONS(1445),
    [anon_sym_EQ_EQ] = ACTIONS(1447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1447),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1445),
    [anon_sym_GT_EQ] = ACTIONS(1445),
    [anon_sym_QMARK_QMARK] = ACTIONS(1445),
    [anon_sym_instanceof] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1445),
    [anon_sym_void] = ACTIONS(1447),
    [anon_sym_delete] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1445),
    [anon_sym_DASH_DASH] = ACTIONS(1445),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1445),
    [sym_number] = ACTIONS(1445),
    [sym_this] = ACTIONS(1447),
    [sym_super] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_undefined] = ACTIONS(1447),
    [anon_sym_AT] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1447),
    [anon_sym_readonly] = ACTIONS(1447),
    [anon_sym_get] = ACTIONS(1447),
    [anon_sym_set] = ACTIONS(1447),
    [anon_sym_declare] = ACTIONS(1447),
    [anon_sym_public] = ACTIONS(1447),
    [anon_sym_private] = ACTIONS(1447),
    [anon_sym_protected] = ACTIONS(1447),
    [anon_sym_override] = ACTIONS(1447),
    [anon_sym_module] = ACTIONS(1447),
    [anon_sym_any] = ACTIONS(1447),
    [anon_sym_number] = ACTIONS(1447),
    [anon_sym_boolean] = ACTIONS(1447),
    [anon_sym_string] = ACTIONS(1447),
    [anon_sym_symbol] = ACTIONS(1447),
    [anon_sym_abstract] = ACTIONS(1447),
    [anon_sym_satisfies] = ACTIONS(1447),
    [anon_sym_interface] = ACTIONS(1447),
    [anon_sym_enum] = ACTIONS(1447),
    [sym__automatic_semicolon] = ACTIONS(1445),
    [sym__ternary_qmark] = ACTIONS(1445),
  },
  [161] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1994),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(3719),
    [sym_assignment_pattern] = STATE(3807),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(3719),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1180),
    [sym_subscript_expression] = STATE(1180),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(3719),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3483),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1180),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_pattern_repeat1] = STATE(3817),
    [sym_identifier] = ACTIONS(1451),
    [anon_sym_export] = ACTIONS(1453),
    [anon_sym_type] = ACTIONS(1453),
    [anon_sym_namespace] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_COMMA] = ACTIONS(1409),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_RBRACK] = ACTIONS(1413),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1457),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1417),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1453),
    [anon_sym_readonly] = ACTIONS(1453),
    [anon_sym_get] = ACTIONS(1453),
    [anon_sym_set] = ACTIONS(1453),
    [anon_sym_declare] = ACTIONS(1453),
    [anon_sym_public] = ACTIONS(1453),
    [anon_sym_private] = ACTIONS(1453),
    [anon_sym_protected] = ACTIONS(1453),
    [anon_sym_override] = ACTIONS(1453),
    [anon_sym_module] = ACTIONS(1453),
    [anon_sym_any] = ACTIONS(1453),
    [anon_sym_number] = ACTIONS(1453),
    [anon_sym_boolean] = ACTIONS(1453),
    [anon_sym_string] = ACTIONS(1453),
    [anon_sym_symbol] = ACTIONS(1453),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_as] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_typeof] = ACTIONS(1461),
    [anon_sym_import] = ACTIONS(1461),
    [anon_sym_var] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_BANG] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_await] = ACTIONS(1461),
    [anon_sym_in] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_try] = ACTIONS(1461),
    [anon_sym_with] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_debugger] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_throw] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_yield] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LTtemplate_GT] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1461),
    [anon_sym_SLASH] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1461),
    [anon_sym_class] = ACTIONS(1461),
    [anon_sym_async] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1461),
    [anon_sym_QMARK_DOT] = ACTIONS(1459),
    [anon_sym_new] = ACTIONS(1461),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1461),
    [anon_sym_GT_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_STAR_STAR] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1459),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1459),
    [anon_sym_QMARK_QMARK] = ACTIONS(1459),
    [anon_sym_instanceof] = ACTIONS(1461),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_void] = ACTIONS(1461),
    [anon_sym_delete] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(1461),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_override] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [anon_sym_abstract] = ACTIONS(1461),
    [anon_sym_satisfies] = ACTIONS(1461),
    [anon_sym_interface] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [sym__automatic_semicolon] = ACTIONS(1459),
    [sym__ternary_qmark] = ACTIONS(1459),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1465),
    [anon_sym_export] = ACTIONS(1465),
    [anon_sym_STAR] = ACTIONS(1467),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_type] = ACTIONS(1465),
    [anon_sym_as] = ACTIONS(1467),
    [anon_sym_namespace] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1469),
    [anon_sym_RBRACE] = ACTIONS(1463),
    [anon_sym_typeof] = ACTIONS(1465),
    [anon_sym_import] = ACTIONS(1465),
    [anon_sym_var] = ACTIONS(1465),
    [anon_sym_let] = ACTIONS(1465),
    [anon_sym_const] = ACTIONS(1465),
    [anon_sym_BANG] = ACTIONS(1465),
    [anon_sym_else] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_switch] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1465),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_in] = ACTIONS(1467),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_try] = ACTIONS(1465),
    [anon_sym_with] = ACTIONS(1465),
    [anon_sym_break] = ACTIONS(1465),
    [anon_sym_continue] = ACTIONS(1465),
    [anon_sym_debugger] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(1465),
    [anon_sym_throw] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_case] = ACTIONS(1465),
    [anon_sym_yield] = ACTIONS(1465),
    [anon_sym_LBRACK] = ACTIONS(1463),
    [anon_sym_LTtemplate_GT] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1467),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_DOT] = ACTIONS(1467),
    [anon_sym_class] = ACTIONS(1465),
    [anon_sym_async] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(1465),
    [anon_sym_QMARK_DOT] = ACTIONS(1469),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_AMP_AMP] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1469),
    [anon_sym_GT_GT] = ACTIONS(1467),
    [anon_sym_GT_GT_GT] = ACTIONS(1469),
    [anon_sym_LT_LT] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1467),
    [anon_sym_CARET] = ACTIONS(1469),
    [anon_sym_PIPE] = ACTIONS(1467),
    [anon_sym_PLUS] = ACTIONS(1465),
    [anon_sym_DASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1469),
    [anon_sym_STAR_STAR] = ACTIONS(1469),
    [anon_sym_LT_EQ] = ACTIONS(1469),
    [anon_sym_EQ_EQ] = ACTIONS(1467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1469),
    [anon_sym_BANG_EQ] = ACTIONS(1467),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1469),
    [anon_sym_GT_EQ] = ACTIONS(1469),
    [anon_sym_QMARK_QMARK] = ACTIONS(1469),
    [anon_sym_instanceof] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(1463),
    [anon_sym_void] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(1465),
    [anon_sym_PLUS_PLUS] = ACTIONS(1463),
    [anon_sym_DASH_DASH] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [sym_number] = ACTIONS(1463),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(1465),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_undefined] = ACTIONS(1465),
    [anon_sym_AT] = ACTIONS(1463),
    [anon_sym_static] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(1465),
    [anon_sym_get] = ACTIONS(1465),
    [anon_sym_set] = ACTIONS(1465),
    [anon_sym_declare] = ACTIONS(1465),
    [anon_sym_public] = ACTIONS(1465),
    [anon_sym_private] = ACTIONS(1465),
    [anon_sym_protected] = ACTIONS(1465),
    [anon_sym_override] = ACTIONS(1465),
    [anon_sym_module] = ACTIONS(1465),
    [anon_sym_any] = ACTIONS(1465),
    [anon_sym_number] = ACTIONS(1465),
    [anon_sym_boolean] = ACTIONS(1465),
    [anon_sym_string] = ACTIONS(1465),
    [anon_sym_symbol] = ACTIONS(1465),
    [anon_sym_abstract] = ACTIONS(1465),
    [anon_sym_satisfies] = ACTIONS(1467),
    [anon_sym_interface] = ACTIONS(1465),
    [anon_sym_enum] = ACTIONS(1465),
    [sym__automatic_semicolon] = ACTIONS(1469),
    [sym__ternary_qmark] = ACTIONS(1469),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(1471),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_as] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [anon_sym_typeof] = ACTIONS(1473),
    [anon_sym_import] = ACTIONS(1473),
    [anon_sym_var] = ACTIONS(1473),
    [anon_sym_let] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(1471),
    [anon_sym_await] = ACTIONS(1473),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_try] = ACTIONS(1473),
    [anon_sym_with] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_debugger] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_throw] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1471),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_yield] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1471),
    [anon_sym_LTtemplate_GT] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1473),
    [anon_sym_SLASH] = ACTIONS(1473),
    [anon_sym_DOT] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(1473),
    [anon_sym_QMARK_DOT] = ACTIONS(1471),
    [anon_sym_new] = ACTIONS(1473),
    [anon_sym_AMP_AMP] = ACTIONS(1471),
    [anon_sym_PIPE_PIPE] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_GT_GT_GT] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_CARET] = ACTIONS(1471),
    [anon_sym_PIPE] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PERCENT] = ACTIONS(1471),
    [anon_sym_STAR_STAR] = ACTIONS(1471),
    [anon_sym_LT_EQ] = ACTIONS(1471),
    [anon_sym_EQ_EQ] = ACTIONS(1473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1473),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1471),
    [anon_sym_GT_EQ] = ACTIONS(1471),
    [anon_sym_QMARK_QMARK] = ACTIONS(1471),
    [anon_sym_instanceof] = ACTIONS(1473),
    [anon_sym_TILDE] = ACTIONS(1471),
    [anon_sym_void] = ACTIONS(1473),
    [anon_sym_delete] = ACTIONS(1473),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(1471),
    [anon_sym_SQUOTE] = ACTIONS(1471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [sym_number] = ACTIONS(1471),
    [sym_this] = ACTIONS(1473),
    [sym_super] = ACTIONS(1473),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [sym_null] = ACTIONS(1473),
    [sym_undefined] = ACTIONS(1473),
    [anon_sym_AT] = ACTIONS(1471),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_override] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [anon_sym_abstract] = ACTIONS(1473),
    [anon_sym_satisfies] = ACTIONS(1473),
    [anon_sym_interface] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [sym__automatic_semicolon] = ACTIONS(1471),
    [sym__ternary_qmark] = ACTIONS(1471),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1477),
    [anon_sym_export] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_default] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1477),
    [anon_sym_as] = ACTIONS(1479),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_typeof] = ACTIONS(1477),
    [anon_sym_import] = ACTIONS(1477),
    [anon_sym_var] = ACTIONS(1477),
    [anon_sym_let] = ACTIONS(1477),
    [anon_sym_const] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_switch] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1477),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_in] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_with] = ACTIONS(1477),
    [anon_sym_break] = ACTIONS(1477),
    [anon_sym_continue] = ACTIONS(1477),
    [anon_sym_debugger] = ACTIONS(1477),
    [anon_sym_return] = ACTIONS(1477),
    [anon_sym_throw] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1475),
    [anon_sym_LTtemplate_GT] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1477),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_SLASH] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_class] = ACTIONS(1477),
    [anon_sym_async] = ACTIONS(1477),
    [anon_sym_function] = ACTIONS(1477),
    [anon_sym_QMARK_DOT] = ACTIONS(1481),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1479),
    [anon_sym_GT_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_PERCENT] = ACTIONS(1481),
    [anon_sym_STAR_STAR] = ACTIONS(1481),
    [anon_sym_LT_EQ] = ACTIONS(1481),
    [anon_sym_EQ_EQ] = ACTIONS(1479),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(1479),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1481),
    [anon_sym_GT_EQ] = ACTIONS(1481),
    [anon_sym_QMARK_QMARK] = ACTIONS(1481),
    [anon_sym_instanceof] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_void] = ACTIONS(1477),
    [anon_sym_delete] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [sym_number] = ACTIONS(1475),
    [sym_this] = ACTIONS(1477),
    [sym_super] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_null] = ACTIONS(1477),
    [sym_undefined] = ACTIONS(1477),
    [anon_sym_AT] = ACTIONS(1475),
    [anon_sym_static] = ACTIONS(1477),
    [anon_sym_readonly] = ACTIONS(1477),
    [anon_sym_get] = ACTIONS(1477),
    [anon_sym_set] = ACTIONS(1477),
    [anon_sym_declare] = ACTIONS(1477),
    [anon_sym_public] = ACTIONS(1477),
    [anon_sym_private] = ACTIONS(1477),
    [anon_sym_protected] = ACTIONS(1477),
    [anon_sym_override] = ACTIONS(1477),
    [anon_sym_module] = ACTIONS(1477),
    [anon_sym_any] = ACTIONS(1477),
    [anon_sym_number] = ACTIONS(1477),
    [anon_sym_boolean] = ACTIONS(1477),
    [anon_sym_string] = ACTIONS(1477),
    [anon_sym_symbol] = ACTIONS(1477),
    [anon_sym_abstract] = ACTIONS(1477),
    [anon_sym_satisfies] = ACTIONS(1479),
    [anon_sym_interface] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(1477),
    [sym__automatic_semicolon] = ACTIONS(1483),
    [sym__ternary_qmark] = ACTIONS(1481),
  },
  [166] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1381),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_RBRACK] = ACTIONS(1381),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
    [anon_sym_extends] = ACTIONS(1383),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(1485),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_as] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_RBRACE] = ACTIONS(1485),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_import] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_await] = ACTIONS(1487),
    [anon_sym_in] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_try] = ACTIONS(1487),
    [anon_sym_with] = ACTIONS(1487),
    [anon_sym_break] = ACTIONS(1487),
    [anon_sym_continue] = ACTIONS(1487),
    [anon_sym_debugger] = ACTIONS(1487),
    [anon_sym_return] = ACTIONS(1487),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_case] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [anon_sym_LTtemplate_GT] = ACTIONS(1485),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_GT] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(1487),
    [anon_sym_class] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_QMARK_DOT] = ACTIONS(1485),
    [anon_sym_new] = ACTIONS(1487),
    [anon_sym_AMP_AMP] = ACTIONS(1485),
    [anon_sym_PIPE_PIPE] = ACTIONS(1485),
    [anon_sym_GT_GT] = ACTIONS(1487),
    [anon_sym_GT_GT_GT] = ACTIONS(1485),
    [anon_sym_LT_LT] = ACTIONS(1485),
    [anon_sym_AMP] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1485),
    [anon_sym_PIPE] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(1485),
    [anon_sym_STAR_STAR] = ACTIONS(1485),
    [anon_sym_LT_EQ] = ACTIONS(1485),
    [anon_sym_EQ_EQ] = ACTIONS(1487),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1485),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1485),
    [anon_sym_GT_EQ] = ACTIONS(1485),
    [anon_sym_QMARK_QMARK] = ACTIONS(1485),
    [anon_sym_instanceof] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1485),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_DQUOTE] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1485),
    [sym_number] = ACTIONS(1485),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_satisfies] = ACTIONS(1487),
    [anon_sym_interface] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
    [sym__automatic_semicolon] = ACTIONS(1485),
    [sym__ternary_qmark] = ACTIONS(1485),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(1489),
    [sym_identifier] = ACTIONS(1491),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_STAR] = ACTIONS(1493),
    [anon_sym_default] = ACTIONS(1491),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_as] = ACTIONS(1493),
    [anon_sym_namespace] = ACTIONS(1491),
    [anon_sym_LBRACE] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1495),
    [anon_sym_RBRACE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1491),
    [anon_sym_import] = ACTIONS(1491),
    [anon_sym_var] = ACTIONS(1491),
    [anon_sym_let] = ACTIONS(1491),
    [anon_sym_const] = ACTIONS(1491),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_else] = ACTIONS(1491),
    [anon_sym_if] = ACTIONS(1491),
    [anon_sym_switch] = ACTIONS(1491),
    [anon_sym_for] = ACTIONS(1491),
    [anon_sym_LPAREN] = ACTIONS(1489),
    [anon_sym_await] = ACTIONS(1491),
    [anon_sym_in] = ACTIONS(1493),
    [anon_sym_while] = ACTIONS(1491),
    [anon_sym_do] = ACTIONS(1491),
    [anon_sym_try] = ACTIONS(1491),
    [anon_sym_with] = ACTIONS(1491),
    [anon_sym_break] = ACTIONS(1491),
    [anon_sym_continue] = ACTIONS(1491),
    [anon_sym_debugger] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1491),
    [anon_sym_throw] = ACTIONS(1491),
    [anon_sym_SEMI] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(1491),
    [anon_sym_yield] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1489),
    [anon_sym_LTtemplate_GT] = ACTIONS(1489),
    [anon_sym_LT] = ACTIONS(1491),
    [anon_sym_GT] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1491),
    [anon_sym_DOT] = ACTIONS(1493),
    [anon_sym_class] = ACTIONS(1491),
    [anon_sym_async] = ACTIONS(1491),
    [anon_sym_function] = ACTIONS(1491),
    [anon_sym_QMARK_DOT] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(1491),
    [anon_sym_AMP_AMP] = ACTIONS(1495),
    [anon_sym_PIPE_PIPE] = ACTIONS(1495),
    [anon_sym_GT_GT] = ACTIONS(1493),
    [anon_sym_GT_GT_GT] = ACTIONS(1495),
    [anon_sym_LT_LT] = ACTIONS(1495),
    [anon_sym_AMP] = ACTIONS(1493),
    [anon_sym_CARET] = ACTIONS(1495),
    [anon_sym_PIPE] = ACTIONS(1493),
    [anon_sym_PLUS] = ACTIONS(1491),
    [anon_sym_DASH] = ACTIONS(1491),
    [anon_sym_PERCENT] = ACTIONS(1495),
    [anon_sym_STAR_STAR] = ACTIONS(1495),
    [anon_sym_LT_EQ] = ACTIONS(1495),
    [anon_sym_EQ_EQ] = ACTIONS(1493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1495),
    [anon_sym_BANG_EQ] = ACTIONS(1493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1495),
    [anon_sym_GT_EQ] = ACTIONS(1495),
    [anon_sym_QMARK_QMARK] = ACTIONS(1495),
    [anon_sym_instanceof] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_void] = ACTIONS(1491),
    [anon_sym_delete] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1489),
    [anon_sym_DASH_DASH] = ACTIONS(1489),
    [anon_sym_DQUOTE] = ACTIONS(1489),
    [anon_sym_SQUOTE] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1489),
    [sym_number] = ACTIONS(1489),
    [sym_this] = ACTIONS(1491),
    [sym_super] = ACTIONS(1491),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_undefined] = ACTIONS(1491),
    [anon_sym_AT] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_override] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
    [anon_sym_abstract] = ACTIONS(1491),
    [anon_sym_satisfies] = ACTIONS(1493),
    [anon_sym_interface] = ACTIONS(1491),
    [anon_sym_enum] = ACTIONS(1491),
    [sym__automatic_semicolon] = ACTIONS(1497),
    [sym__ternary_qmark] = ACTIONS(1495),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(1499),
    [sym_identifier] = ACTIONS(1501),
    [anon_sym_export] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_type] = ACTIONS(1501),
    [anon_sym_as] = ACTIONS(1503),
    [anon_sym_namespace] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_RBRACE] = ACTIONS(1499),
    [anon_sym_typeof] = ACTIONS(1501),
    [anon_sym_import] = ACTIONS(1501),
    [anon_sym_var] = ACTIONS(1501),
    [anon_sym_let] = ACTIONS(1501),
    [anon_sym_const] = ACTIONS(1501),
    [anon_sym_BANG] = ACTIONS(1501),
    [anon_sym_else] = ACTIONS(1501),
    [anon_sym_if] = ACTIONS(1501),
    [anon_sym_switch] = ACTIONS(1501),
    [anon_sym_for] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1499),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1501),
    [anon_sym_do] = ACTIONS(1501),
    [anon_sym_try] = ACTIONS(1501),
    [anon_sym_with] = ACTIONS(1501),
    [anon_sym_break] = ACTIONS(1501),
    [anon_sym_continue] = ACTIONS(1501),
    [anon_sym_debugger] = ACTIONS(1501),
    [anon_sym_return] = ACTIONS(1501),
    [anon_sym_throw] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_case] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1501),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [anon_sym_LTtemplate_GT] = ACTIONS(1499),
    [anon_sym_LT] = ACTIONS(1501),
    [anon_sym_GT] = ACTIONS(1503),
    [anon_sym_SLASH] = ACTIONS(1501),
    [anon_sym_DOT] = ACTIONS(1503),
    [anon_sym_class] = ACTIONS(1501),
    [anon_sym_async] = ACTIONS(1501),
    [anon_sym_function] = ACTIONS(1501),
    [anon_sym_QMARK_DOT] = ACTIONS(1505),
    [anon_sym_new] = ACTIONS(1501),
    [anon_sym_AMP_AMP] = ACTIONS(1505),
    [anon_sym_PIPE_PIPE] = ACTIONS(1505),
    [anon_sym_GT_GT] = ACTIONS(1503),
    [anon_sym_GT_GT_GT] = ACTIONS(1505),
    [anon_sym_LT_LT] = ACTIONS(1505),
    [anon_sym_AMP] = ACTIONS(1503),
    [anon_sym_CARET] = ACTIONS(1505),
    [anon_sym_PIPE] = ACTIONS(1503),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_PERCENT] = ACTIONS(1505),
    [anon_sym_STAR_STAR] = ACTIONS(1505),
    [anon_sym_LT_EQ] = ACTIONS(1505),
    [anon_sym_EQ_EQ] = ACTIONS(1503),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1505),
    [anon_sym_BANG_EQ] = ACTIONS(1503),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1505),
    [anon_sym_GT_EQ] = ACTIONS(1505),
    [anon_sym_QMARK_QMARK] = ACTIONS(1505),
    [anon_sym_instanceof] = ACTIONS(1503),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1501),
    [anon_sym_delete] = ACTIONS(1501),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1499),
    [sym_number] = ACTIONS(1499),
    [sym_this] = ACTIONS(1501),
    [sym_super] = ACTIONS(1501),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [sym_null] = ACTIONS(1501),
    [sym_undefined] = ACTIONS(1501),
    [anon_sym_AT] = ACTIONS(1499),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_readonly] = ACTIONS(1501),
    [anon_sym_get] = ACTIONS(1501),
    [anon_sym_set] = ACTIONS(1501),
    [anon_sym_declare] = ACTIONS(1501),
    [anon_sym_public] = ACTIONS(1501),
    [anon_sym_private] = ACTIONS(1501),
    [anon_sym_protected] = ACTIONS(1501),
    [anon_sym_override] = ACTIONS(1501),
    [anon_sym_module] = ACTIONS(1501),
    [anon_sym_any] = ACTIONS(1501),
    [anon_sym_number] = ACTIONS(1501),
    [anon_sym_boolean] = ACTIONS(1501),
    [anon_sym_string] = ACTIONS(1501),
    [anon_sym_symbol] = ACTIONS(1501),
    [anon_sym_abstract] = ACTIONS(1501),
    [anon_sym_satisfies] = ACTIONS(1503),
    [anon_sym_interface] = ACTIONS(1501),
    [anon_sym_enum] = ACTIONS(1501),
    [sym__automatic_semicolon] = ACTIONS(1507),
    [sym__ternary_qmark] = ACTIONS(1505),
  },
  [170] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1553),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(4092),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3602),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3604),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1509),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1512),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(1516),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_export] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1520),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_type] = ACTIONS(1518),
    [anon_sym_as] = ACTIONS(1520),
    [anon_sym_namespace] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1516),
    [anon_sym_typeof] = ACTIONS(1518),
    [anon_sym_import] = ACTIONS(1518),
    [anon_sym_var] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1518),
    [anon_sym_BANG] = ACTIONS(1518),
    [anon_sym_else] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1518),
    [anon_sym_switch] = ACTIONS(1518),
    [anon_sym_for] = ACTIONS(1518),
    [anon_sym_LPAREN] = ACTIONS(1516),
    [anon_sym_await] = ACTIONS(1518),
    [anon_sym_in] = ACTIONS(1520),
    [anon_sym_while] = ACTIONS(1518),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_try] = ACTIONS(1518),
    [anon_sym_with] = ACTIONS(1518),
    [anon_sym_break] = ACTIONS(1518),
    [anon_sym_continue] = ACTIONS(1518),
    [anon_sym_debugger] = ACTIONS(1518),
    [anon_sym_return] = ACTIONS(1518),
    [anon_sym_throw] = ACTIONS(1518),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym_case] = ACTIONS(1518),
    [anon_sym_yield] = ACTIONS(1518),
    [anon_sym_LBRACK] = ACTIONS(1516),
    [anon_sym_LTtemplate_GT] = ACTIONS(1516),
    [anon_sym_LT] = ACTIONS(1518),
    [anon_sym_GT] = ACTIONS(1520),
    [anon_sym_SLASH] = ACTIONS(1518),
    [anon_sym_DOT] = ACTIONS(1520),
    [anon_sym_class] = ACTIONS(1518),
    [anon_sym_async] = ACTIONS(1518),
    [anon_sym_function] = ACTIONS(1518),
    [anon_sym_QMARK_DOT] = ACTIONS(1522),
    [anon_sym_new] = ACTIONS(1518),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_GT_GT] = ACTIONS(1520),
    [anon_sym_GT_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(1522),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym_CARET] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1520),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_STAR_STAR] = ACTIONS(1522),
    [anon_sym_LT_EQ] = ACTIONS(1522),
    [anon_sym_EQ_EQ] = ACTIONS(1520),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1522),
    [anon_sym_BANG_EQ] = ACTIONS(1520),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1522),
    [anon_sym_GT_EQ] = ACTIONS(1522),
    [anon_sym_QMARK_QMARK] = ACTIONS(1522),
    [anon_sym_instanceof] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_void] = ACTIONS(1518),
    [anon_sym_delete] = ACTIONS(1518),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1516),
    [sym_number] = ACTIONS(1516),
    [sym_this] = ACTIONS(1518),
    [sym_super] = ACTIONS(1518),
    [sym_true] = ACTIONS(1518),
    [sym_false] = ACTIONS(1518),
    [sym_null] = ACTIONS(1518),
    [sym_undefined] = ACTIONS(1518),
    [anon_sym_AT] = ACTIONS(1516),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_readonly] = ACTIONS(1518),
    [anon_sym_get] = ACTIONS(1518),
    [anon_sym_set] = ACTIONS(1518),
    [anon_sym_declare] = ACTIONS(1518),
    [anon_sym_public] = ACTIONS(1518),
    [anon_sym_private] = ACTIONS(1518),
    [anon_sym_protected] = ACTIONS(1518),
    [anon_sym_override] = ACTIONS(1518),
    [anon_sym_module] = ACTIONS(1518),
    [anon_sym_any] = ACTIONS(1518),
    [anon_sym_number] = ACTIONS(1518),
    [anon_sym_boolean] = ACTIONS(1518),
    [anon_sym_string] = ACTIONS(1518),
    [anon_sym_symbol] = ACTIONS(1518),
    [anon_sym_abstract] = ACTIONS(1518),
    [anon_sym_satisfies] = ACTIONS(1520),
    [anon_sym_interface] = ACTIONS(1518),
    [anon_sym_enum] = ACTIONS(1518),
    [sym__automatic_semicolon] = ACTIONS(1524),
    [sym__ternary_qmark] = ACTIONS(1522),
  },
  [172] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_assignment_pattern] = STATE(3720),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3575),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_pattern_repeat1] = STATE(3590),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(1409),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_RBRACK] = ACTIONS(1526),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [173] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1553),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(4092),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3602),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3604),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1509),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1528),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(1532),
    [sym_identifier] = ACTIONS(1534),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_STAR] = ACTIONS(1536),
    [anon_sym_default] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_as] = ACTIONS(1536),
    [anon_sym_namespace] = ACTIONS(1534),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_COMMA] = ACTIONS(1538),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_typeof] = ACTIONS(1534),
    [anon_sym_import] = ACTIONS(1534),
    [anon_sym_var] = ACTIONS(1534),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_const] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1534),
    [anon_sym_else] = ACTIONS(1534),
    [anon_sym_if] = ACTIONS(1534),
    [anon_sym_switch] = ACTIONS(1534),
    [anon_sym_for] = ACTIONS(1534),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [anon_sym_await] = ACTIONS(1534),
    [anon_sym_in] = ACTIONS(1536),
    [anon_sym_while] = ACTIONS(1534),
    [anon_sym_do] = ACTIONS(1534),
    [anon_sym_try] = ACTIONS(1534),
    [anon_sym_with] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1534),
    [anon_sym_continue] = ACTIONS(1534),
    [anon_sym_debugger] = ACTIONS(1534),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_throw] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_case] = ACTIONS(1534),
    [anon_sym_yield] = ACTIONS(1534),
    [anon_sym_LBRACK] = ACTIONS(1532),
    [anon_sym_LTtemplate_GT] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1536),
    [anon_sym_SLASH] = ACTIONS(1534),
    [anon_sym_DOT] = ACTIONS(1536),
    [anon_sym_class] = ACTIONS(1534),
    [anon_sym_async] = ACTIONS(1534),
    [anon_sym_function] = ACTIONS(1534),
    [anon_sym_QMARK_DOT] = ACTIONS(1538),
    [anon_sym_new] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1536),
    [anon_sym_GT_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_AMP] = ACTIONS(1536),
    [anon_sym_CARET] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1534),
    [anon_sym_DASH] = ACTIONS(1534),
    [anon_sym_PERCENT] = ACTIONS(1538),
    [anon_sym_STAR_STAR] = ACTIONS(1538),
    [anon_sym_LT_EQ] = ACTIONS(1538),
    [anon_sym_EQ_EQ] = ACTIONS(1536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1538),
    [anon_sym_BANG_EQ] = ACTIONS(1536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1538),
    [anon_sym_GT_EQ] = ACTIONS(1538),
    [anon_sym_QMARK_QMARK] = ACTIONS(1538),
    [anon_sym_instanceof] = ACTIONS(1536),
    [anon_sym_TILDE] = ACTIONS(1532),
    [anon_sym_void] = ACTIONS(1534),
    [anon_sym_delete] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [sym_number] = ACTIONS(1532),
    [sym_this] = ACTIONS(1534),
    [sym_super] = ACTIONS(1534),
    [sym_true] = ACTIONS(1534),
    [sym_false] = ACTIONS(1534),
    [sym_null] = ACTIONS(1534),
    [sym_undefined] = ACTIONS(1534),
    [anon_sym_AT] = ACTIONS(1532),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_abstract] = ACTIONS(1534),
    [anon_sym_satisfies] = ACTIONS(1536),
    [anon_sym_interface] = ACTIONS(1534),
    [anon_sym_enum] = ACTIONS(1534),
    [sym__automatic_semicolon] = ACTIONS(1540),
    [sym__ternary_qmark] = ACTIONS(1538),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(1542),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_export] = ACTIONS(1544),
    [anon_sym_STAR] = ACTIONS(1544),
    [anon_sym_default] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(1544),
    [anon_sym_as] = ACTIONS(1544),
    [anon_sym_namespace] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_COMMA] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_typeof] = ACTIONS(1544),
    [anon_sym_import] = ACTIONS(1544),
    [anon_sym_var] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(1544),
    [anon_sym_const] = ACTIONS(1544),
    [anon_sym_BANG] = ACTIONS(1544),
    [anon_sym_else] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_switch] = ACTIONS(1544),
    [anon_sym_for] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_await] = ACTIONS(1544),
    [anon_sym_in] = ACTIONS(1544),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_try] = ACTIONS(1544),
    [anon_sym_with] = ACTIONS(1544),
    [anon_sym_break] = ACTIONS(1544),
    [anon_sym_continue] = ACTIONS(1544),
    [anon_sym_debugger] = ACTIONS(1544),
    [anon_sym_return] = ACTIONS(1544),
    [anon_sym_throw] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_case] = ACTIONS(1544),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_LTtemplate_GT] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1544),
    [anon_sym_DOT] = ACTIONS(1544),
    [anon_sym_class] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1544),
    [anon_sym_function] = ACTIONS(1544),
    [anon_sym_QMARK_DOT] = ACTIONS(1542),
    [anon_sym_new] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_GT_GT_GT] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_CARET] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [anon_sym_STAR_STAR] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1544),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1542),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [anon_sym_QMARK_QMARK] = ACTIONS(1542),
    [anon_sym_instanceof] = ACTIONS(1544),
    [anon_sym_TILDE] = ACTIONS(1542),
    [anon_sym_void] = ACTIONS(1544),
    [anon_sym_delete] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [sym_number] = ACTIONS(1542),
    [sym_this] = ACTIONS(1544),
    [sym_super] = ACTIONS(1544),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_undefined] = ACTIONS(1544),
    [anon_sym_AT] = ACTIONS(1542),
    [anon_sym_static] = ACTIONS(1544),
    [anon_sym_readonly] = ACTIONS(1544),
    [anon_sym_get] = ACTIONS(1544),
    [anon_sym_set] = ACTIONS(1544),
    [anon_sym_declare] = ACTIONS(1544),
    [anon_sym_public] = ACTIONS(1544),
    [anon_sym_private] = ACTIONS(1544),
    [anon_sym_protected] = ACTIONS(1544),
    [anon_sym_override] = ACTIONS(1544),
    [anon_sym_module] = ACTIONS(1544),
    [anon_sym_any] = ACTIONS(1544),
    [anon_sym_number] = ACTIONS(1544),
    [anon_sym_boolean] = ACTIONS(1544),
    [anon_sym_string] = ACTIONS(1544),
    [anon_sym_symbol] = ACTIONS(1544),
    [anon_sym_abstract] = ACTIONS(1544),
    [anon_sym_satisfies] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1544),
    [anon_sym_enum] = ACTIONS(1544),
    [sym__automatic_semicolon] = ACTIONS(1542),
    [sym__ternary_qmark] = ACTIONS(1542),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(1546),
    [sym_identifier] = ACTIONS(1548),
    [anon_sym_export] = ACTIONS(1548),
    [anon_sym_STAR] = ACTIONS(1550),
    [anon_sym_default] = ACTIONS(1548),
    [anon_sym_type] = ACTIONS(1548),
    [anon_sym_as] = ACTIONS(1550),
    [anon_sym_namespace] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1552),
    [anon_sym_RBRACE] = ACTIONS(1546),
    [anon_sym_typeof] = ACTIONS(1548),
    [anon_sym_import] = ACTIONS(1548),
    [anon_sym_var] = ACTIONS(1548),
    [anon_sym_let] = ACTIONS(1548),
    [anon_sym_const] = ACTIONS(1548),
    [anon_sym_BANG] = ACTIONS(1548),
    [anon_sym_else] = ACTIONS(1548),
    [anon_sym_if] = ACTIONS(1548),
    [anon_sym_switch] = ACTIONS(1548),
    [anon_sym_for] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_await] = ACTIONS(1548),
    [anon_sym_in] = ACTIONS(1550),
    [anon_sym_while] = ACTIONS(1548),
    [anon_sym_do] = ACTIONS(1548),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_with] = ACTIONS(1548),
    [anon_sym_break] = ACTIONS(1548),
    [anon_sym_continue] = ACTIONS(1548),
    [anon_sym_debugger] = ACTIONS(1548),
    [anon_sym_return] = ACTIONS(1548),
    [anon_sym_throw] = ACTIONS(1548),
    [anon_sym_SEMI] = ACTIONS(1546),
    [anon_sym_case] = ACTIONS(1548),
    [anon_sym_yield] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1546),
    [anon_sym_LTtemplate_GT] = ACTIONS(1546),
    [anon_sym_LT] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1548),
    [anon_sym_DOT] = ACTIONS(1550),
    [anon_sym_class] = ACTIONS(1548),
    [anon_sym_async] = ACTIONS(1548),
    [anon_sym_function] = ACTIONS(1548),
    [anon_sym_QMARK_DOT] = ACTIONS(1552),
    [anon_sym_new] = ACTIONS(1548),
    [anon_sym_AMP_AMP] = ACTIONS(1552),
    [anon_sym_PIPE_PIPE] = ACTIONS(1552),
    [anon_sym_GT_GT] = ACTIONS(1550),
    [anon_sym_GT_GT_GT] = ACTIONS(1552),
    [anon_sym_LT_LT] = ACTIONS(1552),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_CARET] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1548),
    [anon_sym_DASH] = ACTIONS(1548),
    [anon_sym_PERCENT] = ACTIONS(1552),
    [anon_sym_STAR_STAR] = ACTIONS(1552),
    [anon_sym_LT_EQ] = ACTIONS(1552),
    [anon_sym_EQ_EQ] = ACTIONS(1550),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1552),
    [anon_sym_BANG_EQ] = ACTIONS(1550),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1552),
    [anon_sym_GT_EQ] = ACTIONS(1552),
    [anon_sym_QMARK_QMARK] = ACTIONS(1552),
    [anon_sym_instanceof] = ACTIONS(1550),
    [anon_sym_TILDE] = ACTIONS(1546),
    [anon_sym_void] = ACTIONS(1548),
    [anon_sym_delete] = ACTIONS(1548),
    [anon_sym_PLUS_PLUS] = ACTIONS(1546),
    [anon_sym_DASH_DASH] = ACTIONS(1546),
    [anon_sym_DQUOTE] = ACTIONS(1546),
    [anon_sym_SQUOTE] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1546),
    [sym_number] = ACTIONS(1546),
    [sym_this] = ACTIONS(1548),
    [sym_super] = ACTIONS(1548),
    [sym_true] = ACTIONS(1548),
    [sym_false] = ACTIONS(1548),
    [sym_null] = ACTIONS(1548),
    [sym_undefined] = ACTIONS(1548),
    [anon_sym_AT] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(1548),
    [anon_sym_readonly] = ACTIONS(1548),
    [anon_sym_get] = ACTIONS(1548),
    [anon_sym_set] = ACTIONS(1548),
    [anon_sym_declare] = ACTIONS(1548),
    [anon_sym_public] = ACTIONS(1548),
    [anon_sym_private] = ACTIONS(1548),
    [anon_sym_protected] = ACTIONS(1548),
    [anon_sym_override] = ACTIONS(1548),
    [anon_sym_module] = ACTIONS(1548),
    [anon_sym_any] = ACTIONS(1548),
    [anon_sym_number] = ACTIONS(1548),
    [anon_sym_boolean] = ACTIONS(1548),
    [anon_sym_string] = ACTIONS(1548),
    [anon_sym_symbol] = ACTIONS(1548),
    [anon_sym_abstract] = ACTIONS(1548),
    [anon_sym_satisfies] = ACTIONS(1550),
    [anon_sym_interface] = ACTIONS(1548),
    [anon_sym_enum] = ACTIONS(1548),
    [sym__automatic_semicolon] = ACTIONS(1554),
    [sym__ternary_qmark] = ACTIONS(1552),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(1556),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_export] = ACTIONS(1558),
    [anon_sym_STAR] = ACTIONS(1560),
    [anon_sym_default] = ACTIONS(1558),
    [anon_sym_type] = ACTIONS(1558),
    [anon_sym_as] = ACTIONS(1560),
    [anon_sym_namespace] = ACTIONS(1558),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_COMMA] = ACTIONS(1562),
    [anon_sym_RBRACE] = ACTIONS(1556),
    [anon_sym_typeof] = ACTIONS(1558),
    [anon_sym_import] = ACTIONS(1558),
    [anon_sym_var] = ACTIONS(1558),
    [anon_sym_let] = ACTIONS(1558),
    [anon_sym_const] = ACTIONS(1558),
    [anon_sym_BANG] = ACTIONS(1558),
    [anon_sym_else] = ACTIONS(1558),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1558),
    [anon_sym_for] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_await] = ACTIONS(1558),
    [anon_sym_in] = ACTIONS(1560),
    [anon_sym_while] = ACTIONS(1558),
    [anon_sym_do] = ACTIONS(1558),
    [anon_sym_try] = ACTIONS(1558),
    [anon_sym_with] = ACTIONS(1558),
    [anon_sym_break] = ACTIONS(1558),
    [anon_sym_continue] = ACTIONS(1558),
    [anon_sym_debugger] = ACTIONS(1558),
    [anon_sym_return] = ACTIONS(1558),
    [anon_sym_throw] = ACTIONS(1558),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_case] = ACTIONS(1558),
    [anon_sym_yield] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1556),
    [anon_sym_LTtemplate_GT] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1560),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_DOT] = ACTIONS(1560),
    [anon_sym_class] = ACTIONS(1558),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_function] = ACTIONS(1558),
    [anon_sym_QMARK_DOT] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1558),
    [anon_sym_AMP_AMP] = ACTIONS(1562),
    [anon_sym_PIPE_PIPE] = ACTIONS(1562),
    [anon_sym_GT_GT] = ACTIONS(1560),
    [anon_sym_GT_GT_GT] = ACTIONS(1562),
    [anon_sym_LT_LT] = ACTIONS(1562),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_CARET] = ACTIONS(1562),
    [anon_sym_PIPE] = ACTIONS(1560),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1562),
    [anon_sym_STAR_STAR] = ACTIONS(1562),
    [anon_sym_LT_EQ] = ACTIONS(1562),
    [anon_sym_EQ_EQ] = ACTIONS(1560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1562),
    [anon_sym_BANG_EQ] = ACTIONS(1560),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1562),
    [anon_sym_GT_EQ] = ACTIONS(1562),
    [anon_sym_QMARK_QMARK] = ACTIONS(1562),
    [anon_sym_instanceof] = ACTIONS(1560),
    [anon_sym_TILDE] = ACTIONS(1556),
    [anon_sym_void] = ACTIONS(1558),
    [anon_sym_delete] = ACTIONS(1558),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_DQUOTE] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1556),
    [sym_number] = ACTIONS(1556),
    [sym_this] = ACTIONS(1558),
    [sym_super] = ACTIONS(1558),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_null] = ACTIONS(1558),
    [sym_undefined] = ACTIONS(1558),
    [anon_sym_AT] = ACTIONS(1556),
    [anon_sym_static] = ACTIONS(1558),
    [anon_sym_readonly] = ACTIONS(1558),
    [anon_sym_get] = ACTIONS(1558),
    [anon_sym_set] = ACTIONS(1558),
    [anon_sym_declare] = ACTIONS(1558),
    [anon_sym_public] = ACTIONS(1558),
    [anon_sym_private] = ACTIONS(1558),
    [anon_sym_protected] = ACTIONS(1558),
    [anon_sym_override] = ACTIONS(1558),
    [anon_sym_module] = ACTIONS(1558),
    [anon_sym_any] = ACTIONS(1558),
    [anon_sym_number] = ACTIONS(1558),
    [anon_sym_boolean] = ACTIONS(1558),
    [anon_sym_string] = ACTIONS(1558),
    [anon_sym_symbol] = ACTIONS(1558),
    [anon_sym_abstract] = ACTIONS(1558),
    [anon_sym_satisfies] = ACTIONS(1560),
    [anon_sym_interface] = ACTIONS(1558),
    [anon_sym_enum] = ACTIONS(1558),
    [sym__automatic_semicolon] = ACTIONS(1564),
    [sym__ternary_qmark] = ACTIONS(1562),
  },
  [178] = {
    [ts_builtin_sym_end] = ACTIONS(1566),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_STAR] = ACTIONS(1570),
    [anon_sym_default] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_as] = ACTIONS(1570),
    [anon_sym_namespace] = ACTIONS(1568),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_COMMA] = ACTIONS(1572),
    [anon_sym_RBRACE] = ACTIONS(1566),
    [anon_sym_typeof] = ACTIONS(1568),
    [anon_sym_import] = ACTIONS(1568),
    [anon_sym_var] = ACTIONS(1568),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_const] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1568),
    [anon_sym_else] = ACTIONS(1568),
    [anon_sym_if] = ACTIONS(1568),
    [anon_sym_switch] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [anon_sym_await] = ACTIONS(1568),
    [anon_sym_in] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1568),
    [anon_sym_do] = ACTIONS(1568),
    [anon_sym_try] = ACTIONS(1568),
    [anon_sym_with] = ACTIONS(1568),
    [anon_sym_break] = ACTIONS(1568),
    [anon_sym_continue] = ACTIONS(1568),
    [anon_sym_debugger] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(1568),
    [anon_sym_throw] = ACTIONS(1568),
    [anon_sym_SEMI] = ACTIONS(1566),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_yield] = ACTIONS(1568),
    [anon_sym_LBRACK] = ACTIONS(1566),
    [anon_sym_LTtemplate_GT] = ACTIONS(1566),
    [anon_sym_LT] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_SLASH] = ACTIONS(1568),
    [anon_sym_DOT] = ACTIONS(1570),
    [anon_sym_class] = ACTIONS(1568),
    [anon_sym_async] = ACTIONS(1568),
    [anon_sym_function] = ACTIONS(1568),
    [anon_sym_QMARK_DOT] = ACTIONS(1572),
    [anon_sym_new] = ACTIONS(1568),
    [anon_sym_AMP_AMP] = ACTIONS(1572),
    [anon_sym_PIPE_PIPE] = ACTIONS(1572),
    [anon_sym_GT_GT] = ACTIONS(1570),
    [anon_sym_GT_GT_GT] = ACTIONS(1572),
    [anon_sym_LT_LT] = ACTIONS(1572),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_CARET] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_PLUS] = ACTIONS(1568),
    [anon_sym_DASH] = ACTIONS(1568),
    [anon_sym_PERCENT] = ACTIONS(1572),
    [anon_sym_STAR_STAR] = ACTIONS(1572),
    [anon_sym_LT_EQ] = ACTIONS(1572),
    [anon_sym_EQ_EQ] = ACTIONS(1570),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1572),
    [anon_sym_BANG_EQ] = ACTIONS(1570),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1572),
    [anon_sym_GT_EQ] = ACTIONS(1572),
    [anon_sym_QMARK_QMARK] = ACTIONS(1572),
    [anon_sym_instanceof] = ACTIONS(1570),
    [anon_sym_TILDE] = ACTIONS(1566),
    [anon_sym_void] = ACTIONS(1568),
    [anon_sym_delete] = ACTIONS(1568),
    [anon_sym_PLUS_PLUS] = ACTIONS(1566),
    [anon_sym_DASH_DASH] = ACTIONS(1566),
    [anon_sym_DQUOTE] = ACTIONS(1566),
    [anon_sym_SQUOTE] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1566),
    [sym_number] = ACTIONS(1566),
    [sym_this] = ACTIONS(1568),
    [sym_super] = ACTIONS(1568),
    [sym_true] = ACTIONS(1568),
    [sym_false] = ACTIONS(1568),
    [sym_null] = ACTIONS(1568),
    [sym_undefined] = ACTIONS(1568),
    [anon_sym_AT] = ACTIONS(1566),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_abstract] = ACTIONS(1568),
    [anon_sym_satisfies] = ACTIONS(1570),
    [anon_sym_interface] = ACTIONS(1568),
    [anon_sym_enum] = ACTIONS(1568),
    [sym__automatic_semicolon] = ACTIONS(1574),
    [sym__ternary_qmark] = ACTIONS(1572),
  },
  [179] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1553),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(4092),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_spread_element] = STATE(3602),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3604),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1509),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_RBRACK] = ACTIONS(1509),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(1576),
    [sym_identifier] = ACTIONS(1578),
    [anon_sym_export] = ACTIONS(1578),
    [anon_sym_STAR] = ACTIONS(1580),
    [anon_sym_default] = ACTIONS(1578),
    [anon_sym_type] = ACTIONS(1578),
    [anon_sym_as] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(1578),
    [anon_sym_LBRACE] = ACTIONS(1576),
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_RBRACE] = ACTIONS(1576),
    [anon_sym_typeof] = ACTIONS(1578),
    [anon_sym_import] = ACTIONS(1578),
    [anon_sym_var] = ACTIONS(1578),
    [anon_sym_let] = ACTIONS(1578),
    [anon_sym_const] = ACTIONS(1578),
    [anon_sym_BANG] = ACTIONS(1578),
    [anon_sym_else] = ACTIONS(1578),
    [anon_sym_if] = ACTIONS(1578),
    [anon_sym_switch] = ACTIONS(1578),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1576),
    [anon_sym_await] = ACTIONS(1578),
    [anon_sym_in] = ACTIONS(1580),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_do] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1578),
    [anon_sym_with] = ACTIONS(1578),
    [anon_sym_break] = ACTIONS(1578),
    [anon_sym_continue] = ACTIONS(1578),
    [anon_sym_debugger] = ACTIONS(1578),
    [anon_sym_return] = ACTIONS(1578),
    [anon_sym_throw] = ACTIONS(1578),
    [anon_sym_SEMI] = ACTIONS(1576),
    [anon_sym_case] = ACTIONS(1578),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_LTtemplate_GT] = ACTIONS(1576),
    [anon_sym_LT] = ACTIONS(1578),
    [anon_sym_GT] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1578),
    [anon_sym_DOT] = ACTIONS(1580),
    [anon_sym_class] = ACTIONS(1578),
    [anon_sym_async] = ACTIONS(1578),
    [anon_sym_function] = ACTIONS(1578),
    [anon_sym_QMARK_DOT] = ACTIONS(1582),
    [anon_sym_new] = ACTIONS(1578),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_GT_GT] = ACTIONS(1580),
    [anon_sym_GT_GT_GT] = ACTIONS(1582),
    [anon_sym_LT_LT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1582),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PLUS] = ACTIONS(1578),
    [anon_sym_DASH] = ACTIONS(1578),
    [anon_sym_PERCENT] = ACTIONS(1582),
    [anon_sym_STAR_STAR] = ACTIONS(1582),
    [anon_sym_LT_EQ] = ACTIONS(1582),
    [anon_sym_EQ_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1582),
    [anon_sym_BANG_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1582),
    [anon_sym_GT_EQ] = ACTIONS(1582),
    [anon_sym_QMARK_QMARK] = ACTIONS(1582),
    [anon_sym_instanceof] = ACTIONS(1580),
    [anon_sym_TILDE] = ACTIONS(1576),
    [anon_sym_void] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(1578),
    [anon_sym_PLUS_PLUS] = ACTIONS(1576),
    [anon_sym_DASH_DASH] = ACTIONS(1576),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_SQUOTE] = ACTIONS(1576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1576),
    [sym_number] = ACTIONS(1576),
    [sym_this] = ACTIONS(1578),
    [sym_super] = ACTIONS(1578),
    [sym_true] = ACTIONS(1578),
    [sym_false] = ACTIONS(1578),
    [sym_null] = ACTIONS(1578),
    [sym_undefined] = ACTIONS(1578),
    [anon_sym_AT] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(1578),
    [anon_sym_readonly] = ACTIONS(1578),
    [anon_sym_get] = ACTIONS(1578),
    [anon_sym_set] = ACTIONS(1578),
    [anon_sym_declare] = ACTIONS(1578),
    [anon_sym_public] = ACTIONS(1578),
    [anon_sym_private] = ACTIONS(1578),
    [anon_sym_protected] = ACTIONS(1578),
    [anon_sym_override] = ACTIONS(1578),
    [anon_sym_module] = ACTIONS(1578),
    [anon_sym_any] = ACTIONS(1578),
    [anon_sym_number] = ACTIONS(1578),
    [anon_sym_boolean] = ACTIONS(1578),
    [anon_sym_string] = ACTIONS(1578),
    [anon_sym_symbol] = ACTIONS(1578),
    [anon_sym_abstract] = ACTIONS(1578),
    [anon_sym_satisfies] = ACTIONS(1580),
    [anon_sym_interface] = ACTIONS(1578),
    [anon_sym_enum] = ACTIONS(1578),
    [sym__automatic_semicolon] = ACTIONS(1584),
    [sym__ternary_qmark] = ACTIONS(1582),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [anon_sym_export] = ACTIONS(1588),
    [anon_sym_STAR] = ACTIONS(1588),
    [anon_sym_default] = ACTIONS(1588),
    [anon_sym_type] = ACTIONS(1588),
    [anon_sym_as] = ACTIONS(1588),
    [anon_sym_namespace] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_COMMA] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_typeof] = ACTIONS(1588),
    [anon_sym_import] = ACTIONS(1588),
    [anon_sym_var] = ACTIONS(1588),
    [anon_sym_let] = ACTIONS(1588),
    [anon_sym_const] = ACTIONS(1588),
    [anon_sym_BANG] = ACTIONS(1588),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_switch] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1586),
    [anon_sym_await] = ACTIONS(1588),
    [anon_sym_in] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_try] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_break] = ACTIONS(1588),
    [anon_sym_continue] = ACTIONS(1588),
    [anon_sym_debugger] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_throw] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym_case] = ACTIONS(1588),
    [anon_sym_yield] = ACTIONS(1588),
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_LTtemplate_GT] = ACTIONS(1586),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_SLASH] = ACTIONS(1588),
    [anon_sym_DOT] = ACTIONS(1588),
    [anon_sym_class] = ACTIONS(1588),
    [anon_sym_async] = ACTIONS(1588),
    [anon_sym_function] = ACTIONS(1588),
    [anon_sym_QMARK_DOT] = ACTIONS(1586),
    [anon_sym_new] = ACTIONS(1588),
    [anon_sym_AMP_AMP] = ACTIONS(1586),
    [anon_sym_PIPE_PIPE] = ACTIONS(1586),
    [anon_sym_GT_GT] = ACTIONS(1588),
    [anon_sym_GT_GT_GT] = ACTIONS(1586),
    [anon_sym_LT_LT] = ACTIONS(1586),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_CARET] = ACTIONS(1586),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_PERCENT] = ACTIONS(1586),
    [anon_sym_STAR_STAR] = ACTIONS(1586),
    [anon_sym_LT_EQ] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1586),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1586),
    [anon_sym_GT_EQ] = ACTIONS(1586),
    [anon_sym_QMARK_QMARK] = ACTIONS(1586),
    [anon_sym_instanceof] = ACTIONS(1588),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1586),
    [sym_number] = ACTIONS(1586),
    [sym_this] = ACTIONS(1588),
    [sym_super] = ACTIONS(1588),
    [sym_true] = ACTIONS(1588),
    [sym_false] = ACTIONS(1588),
    [sym_null] = ACTIONS(1588),
    [sym_undefined] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(1586),
    [anon_sym_static] = ACTIONS(1588),
    [anon_sym_readonly] = ACTIONS(1588),
    [anon_sym_get] = ACTIONS(1588),
    [anon_sym_set] = ACTIONS(1588),
    [anon_sym_declare] = ACTIONS(1588),
    [anon_sym_public] = ACTIONS(1588),
    [anon_sym_private] = ACTIONS(1588),
    [anon_sym_protected] = ACTIONS(1588),
    [anon_sym_override] = ACTIONS(1588),
    [anon_sym_module] = ACTIONS(1588),
    [anon_sym_any] = ACTIONS(1588),
    [anon_sym_number] = ACTIONS(1588),
    [anon_sym_boolean] = ACTIONS(1588),
    [anon_sym_string] = ACTIONS(1588),
    [anon_sym_symbol] = ACTIONS(1588),
    [anon_sym_abstract] = ACTIONS(1588),
    [anon_sym_satisfies] = ACTIONS(1588),
    [anon_sym_interface] = ACTIONS(1588),
    [anon_sym_enum] = ACTIONS(1588),
    [sym__automatic_semicolon] = ACTIONS(1586),
    [sym__ternary_qmark] = ACTIONS(1586),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(1590),
    [sym_identifier] = ACTIONS(1592),
    [anon_sym_export] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_default] = ACTIONS(1592),
    [anon_sym_type] = ACTIONS(1592),
    [anon_sym_as] = ACTIONS(1594),
    [anon_sym_namespace] = ACTIONS(1592),
    [anon_sym_LBRACE] = ACTIONS(1590),
    [anon_sym_COMMA] = ACTIONS(1596),
    [anon_sym_RBRACE] = ACTIONS(1590),
    [anon_sym_typeof] = ACTIONS(1592),
    [anon_sym_import] = ACTIONS(1592),
    [anon_sym_var] = ACTIONS(1592),
    [anon_sym_let] = ACTIONS(1592),
    [anon_sym_const] = ACTIONS(1592),
    [anon_sym_BANG] = ACTIONS(1592),
    [anon_sym_else] = ACTIONS(1592),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_switch] = ACTIONS(1592),
    [anon_sym_for] = ACTIONS(1592),
    [anon_sym_LPAREN] = ACTIONS(1590),
    [anon_sym_await] = ACTIONS(1592),
    [anon_sym_in] = ACTIONS(1594),
    [anon_sym_while] = ACTIONS(1592),
    [anon_sym_do] = ACTIONS(1592),
    [anon_sym_try] = ACTIONS(1592),
    [anon_sym_with] = ACTIONS(1592),
    [anon_sym_break] = ACTIONS(1592),
    [anon_sym_continue] = ACTIONS(1592),
    [anon_sym_debugger] = ACTIONS(1592),
    [anon_sym_return] = ACTIONS(1592),
    [anon_sym_throw] = ACTIONS(1592),
    [anon_sym_SEMI] = ACTIONS(1590),
    [anon_sym_case] = ACTIONS(1592),
    [anon_sym_yield] = ACTIONS(1592),
    [anon_sym_LBRACK] = ACTIONS(1590),
    [anon_sym_LTtemplate_GT] = ACTIONS(1590),
    [anon_sym_LT] = ACTIONS(1592),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_SLASH] = ACTIONS(1592),
    [anon_sym_DOT] = ACTIONS(1594),
    [anon_sym_class] = ACTIONS(1592),
    [anon_sym_async] = ACTIONS(1592),
    [anon_sym_function] = ACTIONS(1592),
    [anon_sym_QMARK_DOT] = ACTIONS(1596),
    [anon_sym_new] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1596),
    [anon_sym_PIPE_PIPE] = ACTIONS(1596),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_GT_GT_GT] = ACTIONS(1596),
    [anon_sym_LT_LT] = ACTIONS(1596),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1592),
    [anon_sym_DASH] = ACTIONS(1592),
    [anon_sym_PERCENT] = ACTIONS(1596),
    [anon_sym_STAR_STAR] = ACTIONS(1596),
    [anon_sym_LT_EQ] = ACTIONS(1596),
    [anon_sym_EQ_EQ] = ACTIONS(1594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1596),
    [anon_sym_BANG_EQ] = ACTIONS(1594),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1596),
    [anon_sym_GT_EQ] = ACTIONS(1596),
    [anon_sym_QMARK_QMARK] = ACTIONS(1596),
    [anon_sym_instanceof] = ACTIONS(1594),
    [anon_sym_TILDE] = ACTIONS(1590),
    [anon_sym_void] = ACTIONS(1592),
    [anon_sym_delete] = ACTIONS(1592),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [anon_sym_DQUOTE] = ACTIONS(1590),
    [anon_sym_SQUOTE] = ACTIONS(1590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1590),
    [sym_number] = ACTIONS(1590),
    [sym_this] = ACTIONS(1592),
    [sym_super] = ACTIONS(1592),
    [sym_true] = ACTIONS(1592),
    [sym_false] = ACTIONS(1592),
    [sym_null] = ACTIONS(1592),
    [sym_undefined] = ACTIONS(1592),
    [anon_sym_AT] = ACTIONS(1590),
    [anon_sym_static] = ACTIONS(1592),
    [anon_sym_readonly] = ACTIONS(1592),
    [anon_sym_get] = ACTIONS(1592),
    [anon_sym_set] = ACTIONS(1592),
    [anon_sym_declare] = ACTIONS(1592),
    [anon_sym_public] = ACTIONS(1592),
    [anon_sym_private] = ACTIONS(1592),
    [anon_sym_protected] = ACTIONS(1592),
    [anon_sym_override] = ACTIONS(1592),
    [anon_sym_module] = ACTIONS(1592),
    [anon_sym_any] = ACTIONS(1592),
    [anon_sym_number] = ACTIONS(1592),
    [anon_sym_boolean] = ACTIONS(1592),
    [anon_sym_string] = ACTIONS(1592),
    [anon_sym_symbol] = ACTIONS(1592),
    [anon_sym_abstract] = ACTIONS(1592),
    [anon_sym_satisfies] = ACTIONS(1594),
    [anon_sym_interface] = ACTIONS(1592),
    [anon_sym_enum] = ACTIONS(1592),
    [sym__automatic_semicolon] = ACTIONS(1598),
    [sym__ternary_qmark] = ACTIONS(1596),
  },
  [183] = {
    [ts_builtin_sym_end] = ACTIONS(1419),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_export] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_type] = ACTIONS(1421),
    [anon_sym_as] = ACTIONS(1421),
    [anon_sym_namespace] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1419),
    [anon_sym_COMMA] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1419),
    [anon_sym_typeof] = ACTIONS(1421),
    [anon_sym_import] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1421),
    [anon_sym_let] = ACTIONS(1421),
    [anon_sym_const] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_else] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1421),
    [anon_sym_for] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_await] = ACTIONS(1421),
    [anon_sym_in] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(1421),
    [anon_sym_do] = ACTIONS(1421),
    [anon_sym_try] = ACTIONS(1421),
    [anon_sym_with] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1421),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_debugger] = ACTIONS(1421),
    [anon_sym_return] = ACTIONS(1421),
    [anon_sym_throw] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1419),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_yield] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1419),
    [anon_sym_LTtemplate_GT] = ACTIONS(1419),
    [anon_sym_LT] = ACTIONS(1421),
    [anon_sym_GT] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(1421),
    [anon_sym_DOT] = ACTIONS(1421),
    [anon_sym_class] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1421),
    [anon_sym_function] = ACTIONS(1421),
    [anon_sym_QMARK_DOT] = ACTIONS(1419),
    [anon_sym_new] = ACTIONS(1421),
    [anon_sym_AMP_AMP] = ACTIONS(1419),
    [anon_sym_PIPE_PIPE] = ACTIONS(1419),
    [anon_sym_GT_GT] = ACTIONS(1421),
    [anon_sym_GT_GT_GT] = ACTIONS(1419),
    [anon_sym_LT_LT] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_PIPE] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_PERCENT] = ACTIONS(1419),
    [anon_sym_STAR_STAR] = ACTIONS(1419),
    [anon_sym_LT_EQ] = ACTIONS(1419),
    [anon_sym_EQ_EQ] = ACTIONS(1421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1419),
    [anon_sym_BANG_EQ] = ACTIONS(1421),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1419),
    [anon_sym_GT_EQ] = ACTIONS(1419),
    [anon_sym_QMARK_QMARK] = ACTIONS(1419),
    [anon_sym_instanceof] = ACTIONS(1421),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_void] = ACTIONS(1421),
    [anon_sym_delete] = ACTIONS(1421),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_DQUOTE] = ACTIONS(1419),
    [anon_sym_SQUOTE] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1419),
    [sym_this] = ACTIONS(1421),
    [sym_super] = ACTIONS(1421),
    [sym_true] = ACTIONS(1421),
    [sym_false] = ACTIONS(1421),
    [sym_null] = ACTIONS(1421),
    [sym_undefined] = ACTIONS(1421),
    [anon_sym_AT] = ACTIONS(1419),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_readonly] = ACTIONS(1421),
    [anon_sym_get] = ACTIONS(1421),
    [anon_sym_set] = ACTIONS(1421),
    [anon_sym_declare] = ACTIONS(1421),
    [anon_sym_public] = ACTIONS(1421),
    [anon_sym_private] = ACTIONS(1421),
    [anon_sym_protected] = ACTIONS(1421),
    [anon_sym_override] = ACTIONS(1421),
    [anon_sym_module] = ACTIONS(1421),
    [anon_sym_any] = ACTIONS(1421),
    [anon_sym_number] = ACTIONS(1421),
    [anon_sym_boolean] = ACTIONS(1421),
    [anon_sym_string] = ACTIONS(1421),
    [anon_sym_symbol] = ACTIONS(1421),
    [anon_sym_abstract] = ACTIONS(1421),
    [anon_sym_satisfies] = ACTIONS(1421),
    [anon_sym_interface] = ACTIONS(1421),
    [anon_sym_enum] = ACTIONS(1421),
    [sym__automatic_semicolon] = ACTIONS(1600),
    [sym__ternary_qmark] = ACTIONS(1419),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(1602),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_export] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1604),
    [anon_sym_default] = ACTIONS(1604),
    [anon_sym_type] = ACTIONS(1604),
    [anon_sym_as] = ACTIONS(1604),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1602),
    [anon_sym_COMMA] = ACTIONS(1602),
    [anon_sym_RBRACE] = ACTIONS(1602),
    [anon_sym_typeof] = ACTIONS(1604),
    [anon_sym_import] = ACTIONS(1604),
    [anon_sym_var] = ACTIONS(1604),
    [anon_sym_let] = ACTIONS(1604),
    [anon_sym_const] = ACTIONS(1604),
    [anon_sym_BANG] = ACTIONS(1604),
    [anon_sym_else] = ACTIONS(1604),
    [anon_sym_if] = ACTIONS(1604),
    [anon_sym_switch] = ACTIONS(1604),
    [anon_sym_for] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_await] = ACTIONS(1604),
    [anon_sym_in] = ACTIONS(1604),
    [anon_sym_while] = ACTIONS(1604),
    [anon_sym_do] = ACTIONS(1604),
    [anon_sym_try] = ACTIONS(1604),
    [anon_sym_with] = ACTIONS(1604),
    [anon_sym_break] = ACTIONS(1604),
    [anon_sym_continue] = ACTIONS(1604),
    [anon_sym_debugger] = ACTIONS(1604),
    [anon_sym_return] = ACTIONS(1604),
    [anon_sym_throw] = ACTIONS(1604),
    [anon_sym_SEMI] = ACTIONS(1602),
    [anon_sym_case] = ACTIONS(1604),
    [anon_sym_yield] = ACTIONS(1604),
    [anon_sym_LBRACK] = ACTIONS(1602),
    [anon_sym_LTtemplate_GT] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(1604),
    [anon_sym_GT] = ACTIONS(1604),
    [anon_sym_SLASH] = ACTIONS(1604),
    [anon_sym_DOT] = ACTIONS(1604),
    [anon_sym_class] = ACTIONS(1604),
    [anon_sym_async] = ACTIONS(1604),
    [anon_sym_function] = ACTIONS(1604),
    [anon_sym_QMARK_DOT] = ACTIONS(1602),
    [anon_sym_new] = ACTIONS(1604),
    [anon_sym_AMP_AMP] = ACTIONS(1602),
    [anon_sym_PIPE_PIPE] = ACTIONS(1602),
    [anon_sym_GT_GT] = ACTIONS(1604),
    [anon_sym_GT_GT_GT] = ACTIONS(1602),
    [anon_sym_LT_LT] = ACTIONS(1602),
    [anon_sym_AMP] = ACTIONS(1604),
    [anon_sym_CARET] = ACTIONS(1602),
    [anon_sym_PIPE] = ACTIONS(1604),
    [anon_sym_PLUS] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [anon_sym_PERCENT] = ACTIONS(1602),
    [anon_sym_STAR_STAR] = ACTIONS(1602),
    [anon_sym_LT_EQ] = ACTIONS(1602),
    [anon_sym_EQ_EQ] = ACTIONS(1604),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1602),
    [anon_sym_BANG_EQ] = ACTIONS(1604),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1602),
    [anon_sym_GT_EQ] = ACTIONS(1602),
    [anon_sym_QMARK_QMARK] = ACTIONS(1602),
    [anon_sym_instanceof] = ACTIONS(1604),
    [anon_sym_TILDE] = ACTIONS(1602),
    [anon_sym_void] = ACTIONS(1604),
    [anon_sym_delete] = ACTIONS(1604),
    [anon_sym_PLUS_PLUS] = ACTIONS(1602),
    [anon_sym_DASH_DASH] = ACTIONS(1602),
    [anon_sym_DQUOTE] = ACTIONS(1602),
    [anon_sym_SQUOTE] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1602),
    [sym_number] = ACTIONS(1602),
    [sym_this] = ACTIONS(1604),
    [sym_super] = ACTIONS(1604),
    [sym_true] = ACTIONS(1604),
    [sym_false] = ACTIONS(1604),
    [sym_null] = ACTIONS(1604),
    [sym_undefined] = ACTIONS(1604),
    [anon_sym_AT] = ACTIONS(1602),
    [anon_sym_static] = ACTIONS(1604),
    [anon_sym_readonly] = ACTIONS(1604),
    [anon_sym_get] = ACTIONS(1604),
    [anon_sym_set] = ACTIONS(1604),
    [anon_sym_declare] = ACTIONS(1604),
    [anon_sym_public] = ACTIONS(1604),
    [anon_sym_private] = ACTIONS(1604),
    [anon_sym_protected] = ACTIONS(1604),
    [anon_sym_override] = ACTIONS(1604),
    [anon_sym_module] = ACTIONS(1604),
    [anon_sym_any] = ACTIONS(1604),
    [anon_sym_number] = ACTIONS(1604),
    [anon_sym_boolean] = ACTIONS(1604),
    [anon_sym_string] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1604),
    [anon_sym_abstract] = ACTIONS(1604),
    [anon_sym_satisfies] = ACTIONS(1604),
    [anon_sym_interface] = ACTIONS(1604),
    [anon_sym_enum] = ACTIONS(1604),
    [sym__automatic_semicolon] = ACTIONS(1602),
    [sym__ternary_qmark] = ACTIONS(1602),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(1606),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_export] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1608),
    [anon_sym_default] = ACTIONS(1608),
    [anon_sym_type] = ACTIONS(1608),
    [anon_sym_as] = ACTIONS(1608),
    [anon_sym_namespace] = ACTIONS(1608),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_COMMA] = ACTIONS(1606),
    [anon_sym_RBRACE] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_import] = ACTIONS(1608),
    [anon_sym_var] = ACTIONS(1608),
    [anon_sym_let] = ACTIONS(1608),
    [anon_sym_const] = ACTIONS(1608),
    [anon_sym_BANG] = ACTIONS(1608),
    [anon_sym_else] = ACTIONS(1608),
    [anon_sym_if] = ACTIONS(1608),
    [anon_sym_switch] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_await] = ACTIONS(1608),
    [anon_sym_in] = ACTIONS(1608),
    [anon_sym_while] = ACTIONS(1608),
    [anon_sym_do] = ACTIONS(1608),
    [anon_sym_try] = ACTIONS(1608),
    [anon_sym_with] = ACTIONS(1608),
    [anon_sym_break] = ACTIONS(1608),
    [anon_sym_continue] = ACTIONS(1608),
    [anon_sym_debugger] = ACTIONS(1608),
    [anon_sym_return] = ACTIONS(1608),
    [anon_sym_throw] = ACTIONS(1608),
    [anon_sym_SEMI] = ACTIONS(1606),
    [anon_sym_case] = ACTIONS(1608),
    [anon_sym_yield] = ACTIONS(1608),
    [anon_sym_LBRACK] = ACTIONS(1606),
    [anon_sym_LTtemplate_GT] = ACTIONS(1606),
    [anon_sym_LT] = ACTIONS(1608),
    [anon_sym_GT] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1608),
    [anon_sym_DOT] = ACTIONS(1608),
    [anon_sym_class] = ACTIONS(1608),
    [anon_sym_async] = ACTIONS(1608),
    [anon_sym_function] = ACTIONS(1608),
    [anon_sym_QMARK_DOT] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1608),
    [anon_sym_AMP_AMP] = ACTIONS(1606),
    [anon_sym_PIPE_PIPE] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1608),
    [anon_sym_GT_GT_GT] = ACTIONS(1606),
    [anon_sym_LT_LT] = ACTIONS(1606),
    [anon_sym_AMP] = ACTIONS(1608),
    [anon_sym_CARET] = ACTIONS(1606),
    [anon_sym_PIPE] = ACTIONS(1608),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_PERCENT] = ACTIONS(1606),
    [anon_sym_STAR_STAR] = ACTIONS(1606),
    [anon_sym_LT_EQ] = ACTIONS(1606),
    [anon_sym_EQ_EQ] = ACTIONS(1608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1606),
    [anon_sym_BANG_EQ] = ACTIONS(1608),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1606),
    [anon_sym_GT_EQ] = ACTIONS(1606),
    [anon_sym_QMARK_QMARK] = ACTIONS(1606),
    [anon_sym_instanceof] = ACTIONS(1608),
    [anon_sym_TILDE] = ACTIONS(1606),
    [anon_sym_void] = ACTIONS(1608),
    [anon_sym_delete] = ACTIONS(1608),
    [anon_sym_PLUS_PLUS] = ACTIONS(1606),
    [anon_sym_DASH_DASH] = ACTIONS(1606),
    [anon_sym_DQUOTE] = ACTIONS(1606),
    [anon_sym_SQUOTE] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_number] = ACTIONS(1606),
    [sym_this] = ACTIONS(1608),
    [sym_super] = ACTIONS(1608),
    [sym_true] = ACTIONS(1608),
    [sym_false] = ACTIONS(1608),
    [sym_null] = ACTIONS(1608),
    [sym_undefined] = ACTIONS(1608),
    [anon_sym_AT] = ACTIONS(1606),
    [anon_sym_static] = ACTIONS(1608),
    [anon_sym_readonly] = ACTIONS(1608),
    [anon_sym_get] = ACTIONS(1608),
    [anon_sym_set] = ACTIONS(1608),
    [anon_sym_declare] = ACTIONS(1608),
    [anon_sym_public] = ACTIONS(1608),
    [anon_sym_private] = ACTIONS(1608),
    [anon_sym_protected] = ACTIONS(1608),
    [anon_sym_override] = ACTIONS(1608),
    [anon_sym_module] = ACTIONS(1608),
    [anon_sym_any] = ACTIONS(1608),
    [anon_sym_number] = ACTIONS(1608),
    [anon_sym_boolean] = ACTIONS(1608),
    [anon_sym_string] = ACTIONS(1608),
    [anon_sym_symbol] = ACTIONS(1608),
    [anon_sym_abstract] = ACTIONS(1608),
    [anon_sym_satisfies] = ACTIONS(1608),
    [anon_sym_interface] = ACTIONS(1608),
    [anon_sym_enum] = ACTIONS(1608),
    [sym__automatic_semicolon] = ACTIONS(1606),
    [sym__ternary_qmark] = ACTIONS(1606),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(1610),
    [sym_identifier] = ACTIONS(1612),
    [anon_sym_export] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_default] = ACTIONS(1612),
    [anon_sym_type] = ACTIONS(1612),
    [anon_sym_as] = ACTIONS(1614),
    [anon_sym_namespace] = ACTIONS(1612),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(1616),
    [anon_sym_RBRACE] = ACTIONS(1610),
    [anon_sym_typeof] = ACTIONS(1612),
    [anon_sym_import] = ACTIONS(1612),
    [anon_sym_var] = ACTIONS(1612),
    [anon_sym_let] = ACTIONS(1612),
    [anon_sym_const] = ACTIONS(1612),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_else] = ACTIONS(1612),
    [anon_sym_if] = ACTIONS(1612),
    [anon_sym_switch] = ACTIONS(1612),
    [anon_sym_for] = ACTIONS(1612),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_in] = ACTIONS(1614),
    [anon_sym_while] = ACTIONS(1612),
    [anon_sym_do] = ACTIONS(1612),
    [anon_sym_try] = ACTIONS(1612),
    [anon_sym_with] = ACTIONS(1612),
    [anon_sym_break] = ACTIONS(1612),
    [anon_sym_continue] = ACTIONS(1612),
    [anon_sym_debugger] = ACTIONS(1612),
    [anon_sym_return] = ACTIONS(1612),
    [anon_sym_throw] = ACTIONS(1612),
    [anon_sym_SEMI] = ACTIONS(1610),
    [anon_sym_case] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1612),
    [anon_sym_LBRACK] = ACTIONS(1610),
    [anon_sym_LTtemplate_GT] = ACTIONS(1610),
    [anon_sym_LT] = ACTIONS(1612),
    [anon_sym_GT] = ACTIONS(1614),
    [anon_sym_SLASH] = ACTIONS(1612),
    [anon_sym_DOT] = ACTIONS(1614),
    [anon_sym_class] = ACTIONS(1612),
    [anon_sym_async] = ACTIONS(1612),
    [anon_sym_function] = ACTIONS(1612),
    [anon_sym_QMARK_DOT] = ACTIONS(1616),
    [anon_sym_new] = ACTIONS(1612),
    [anon_sym_AMP_AMP] = ACTIONS(1616),
    [anon_sym_PIPE_PIPE] = ACTIONS(1616),
    [anon_sym_GT_GT] = ACTIONS(1614),
    [anon_sym_GT_GT_GT] = ACTIONS(1616),
    [anon_sym_LT_LT] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1614),
    [anon_sym_CARET] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1614),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_PERCENT] = ACTIONS(1616),
    [anon_sym_STAR_STAR] = ACTIONS(1616),
    [anon_sym_LT_EQ] = ACTIONS(1616),
    [anon_sym_EQ_EQ] = ACTIONS(1614),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1616),
    [anon_sym_BANG_EQ] = ACTIONS(1614),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1616),
    [anon_sym_GT_EQ] = ACTIONS(1616),
    [anon_sym_QMARK_QMARK] = ACTIONS(1616),
    [anon_sym_instanceof] = ACTIONS(1614),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1612),
    [anon_sym_delete] = ACTIONS(1612),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_DQUOTE] = ACTIONS(1610),
    [anon_sym_SQUOTE] = ACTIONS(1610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1610),
    [sym_number] = ACTIONS(1610),
    [sym_this] = ACTIONS(1612),
    [sym_super] = ACTIONS(1612),
    [sym_true] = ACTIONS(1612),
    [sym_false] = ACTIONS(1612),
    [sym_null] = ACTIONS(1612),
    [sym_undefined] = ACTIONS(1612),
    [anon_sym_AT] = ACTIONS(1610),
    [anon_sym_static] = ACTIONS(1612),
    [anon_sym_readonly] = ACTIONS(1612),
    [anon_sym_get] = ACTIONS(1612),
    [anon_sym_set] = ACTIONS(1612),
    [anon_sym_declare] = ACTIONS(1612),
    [anon_sym_public] = ACTIONS(1612),
    [anon_sym_private] = ACTIONS(1612),
    [anon_sym_protected] = ACTIONS(1612),
    [anon_sym_override] = ACTIONS(1612),
    [anon_sym_module] = ACTIONS(1612),
    [anon_sym_any] = ACTIONS(1612),
    [anon_sym_number] = ACTIONS(1612),
    [anon_sym_boolean] = ACTIONS(1612),
    [anon_sym_string] = ACTIONS(1612),
    [anon_sym_symbol] = ACTIONS(1612),
    [anon_sym_abstract] = ACTIONS(1612),
    [anon_sym_satisfies] = ACTIONS(1614),
    [anon_sym_interface] = ACTIONS(1612),
    [anon_sym_enum] = ACTIONS(1612),
    [sym__automatic_semicolon] = ACTIONS(1618),
    [sym__ternary_qmark] = ACTIONS(1616),
  },
  [187] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_assignment_pattern] = STATE(4092),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3604),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(1620),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_RBRACK] = ACTIONS(1620),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [188] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1674),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_extends] = ACTIONS(1383),
  },
  [189] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1574),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_spread_element] = STATE(3585),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3584),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1624),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1626),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [190] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1613),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_spread_element] = STATE(3809),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3812),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1626),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [191] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1395),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_extends] = ACTIONS(1383),
  },
  [192] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1565),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
    [anon_sym_extends] = ACTIONS(1383),
  },
  [193] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1629),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
    [anon_sym_extends] = ACTIONS(1383),
  },
  [194] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3179),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_accessibility_modifier] = STATE(207),
    [sym_override_modifier] = STATE(233),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(1169),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(1630),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1632),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1634),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [195] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1595),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_spread_element] = STATE(3697),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3698),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1626),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [196] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
    [anon_sym_extends] = ACTIONS(1383),
  },
  [197] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1591),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_spread_element] = STATE(3591),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3592),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1626),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [198] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1637),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_spread_element] = STATE(3770),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3771),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1640),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1626),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [199] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1488),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
    [anon_sym_extends] = ACTIONS(1383),
  },
  [200] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1553),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_spread_element] = STATE(3602),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_RBRACK] = ACTIONS(1642),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1626),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [201] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1563),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_spread_element] = STATE(3684),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3683),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1626),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [202] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1621),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_spread_element] = STATE(3668),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [aux_sym_array_repeat1] = STATE(3669),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1646),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1626),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [203] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1663),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_spread_element] = STATE(4457),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4457),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1650),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [204] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3184),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_override_modifier] = STATE(220),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(650),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1652),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [205] = {
    [sym_import] = STATE(1955),
    [sym_expression_statement] = STATE(236),
    [sym_empty_statement] = STATE(236),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [206] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1688),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_spread_element] = STATE(4171),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4171),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1654),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1650),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [207] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3162),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_override_modifier] = STATE(227),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1656),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1658),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(716),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [208] = {
    [sym_import] = STATE(1955),
    [sym_expression_statement] = STATE(237),
    [sym_empty_statement] = STATE(237),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [209] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1691),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2944),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2944),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1078),
    [sym_subscript_expression] = STATE(1078),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2944),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3709),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1078),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(568),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_readonly] = ACTIONS(568),
    [anon_sym_get] = ACTIONS(568),
    [anon_sym_set] = ACTIONS(568),
    [anon_sym_declare] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_any] = ACTIONS(568),
    [anon_sym_number] = ACTIONS(568),
    [anon_sym_boolean] = ACTIONS(568),
    [anon_sym_string] = ACTIONS(568),
    [anon_sym_symbol] = ACTIONS(568),
  },
  [210] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3709),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [211] = {
    [sym_import] = STATE(1955),
    [sym_expression_statement] = STATE(235),
    [sym_empty_statement] = STATE(235),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1639),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3994),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [212] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1565),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [213] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1662),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [214] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(3750),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(3750),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1183),
    [sym_subscript_expression] = STATE(1183),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(3750),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1183),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1664),
    [anon_sym_export] = ACTIONS(1666),
    [anon_sym_type] = ACTIONS(1666),
    [anon_sym_namespace] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_var] = ACTIONS(1672),
    [anon_sym_let] = ACTIONS(1674),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1676),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1678),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1680),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1666),
    [anon_sym_readonly] = ACTIONS(1666),
    [anon_sym_get] = ACTIONS(1666),
    [anon_sym_set] = ACTIONS(1666),
    [anon_sym_declare] = ACTIONS(1666),
    [anon_sym_public] = ACTIONS(1666),
    [anon_sym_private] = ACTIONS(1666),
    [anon_sym_protected] = ACTIONS(1666),
    [anon_sym_override] = ACTIONS(1666),
    [anon_sym_module] = ACTIONS(1666),
    [anon_sym_any] = ACTIONS(1666),
    [anon_sym_number] = ACTIONS(1666),
    [anon_sym_boolean] = ACTIONS(1666),
    [anon_sym_string] = ACTIONS(1666),
    [anon_sym_symbol] = ACTIONS(1666),
  },
  [215] = {
    [sym_import] = STATE(2062),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym__type_query_member_expression] = STATE(2424),
    [sym__type_query_subscript_expression] = STATE(2405),
    [sym__type_query_call_expression] = STATE(2519),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1682),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [216] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1684),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [217] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [218] = {
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(1688),
    [anon_sym_import] = ACTIONS(1688),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_LPAREN] = ACTIONS(1690),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(1688),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(1688),
    [anon_sym_LBRACK] = ACTIONS(1690),
    [anon_sym_LTtemplate_GT] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(1688),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(1688),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_function] = ACTIONS(1688),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1688),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1690),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(1690),
    [anon_sym_void] = ACTIONS(1688),
    [anon_sym_delete] = ACTIONS(1688),
    [anon_sym_PLUS_PLUS] = ACTIONS(1690),
    [anon_sym_DASH_DASH] = ACTIONS(1690),
    [anon_sym_DQUOTE] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1690),
    [sym_number] = ACTIONS(1690),
    [sym_this] = ACTIONS(1688),
    [sym_super] = ACTIONS(1688),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_undefined] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(1690),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_readonly] = ACTIONS(1688),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_override] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [219] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1629),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1692),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [220] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3155),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1694),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [221] = {
    [sym_import] = STATE(1761),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1395),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1696),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [222] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1698),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [223] = {
    [sym_import] = STATE(1761),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1488),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [224] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1702),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [225] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1558),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3891),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(1704),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [sym__automatic_semicolon] = ACTIONS(1704),
  },
  [226] = {
    [sym_import] = STATE(1761),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1674),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1706),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [227] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3377),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1708),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1710),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [228] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3184),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(650),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1652),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [229] = {
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_export] = ACTIONS(1712),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1712),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1712),
    [anon_sym_LBRACE] = ACTIONS(1714),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(1712),
    [anon_sym_import] = ACTIONS(1712),
    [anon_sym_BANG] = ACTIONS(1712),
    [anon_sym_LPAREN] = ACTIONS(1714),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(1712),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(1712),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LTtemplate_GT] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1712),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(1712),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(1712),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_function] = ACTIONS(1712),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1712),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1714),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(1712),
    [anon_sym_DASH] = ACTIONS(1712),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(1714),
    [anon_sym_void] = ACTIONS(1712),
    [anon_sym_delete] = ACTIONS(1712),
    [anon_sym_PLUS_PLUS] = ACTIONS(1714),
    [anon_sym_DASH_DASH] = ACTIONS(1714),
    [anon_sym_DQUOTE] = ACTIONS(1714),
    [anon_sym_SQUOTE] = ACTIONS(1714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1714),
    [sym_number] = ACTIONS(1714),
    [sym_this] = ACTIONS(1712),
    [sym_super] = ACTIONS(1712),
    [sym_true] = ACTIONS(1712),
    [sym_false] = ACTIONS(1712),
    [sym_null] = ACTIONS(1712),
    [sym_undefined] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_static] = ACTIONS(1712),
    [anon_sym_readonly] = ACTIONS(1712),
    [anon_sym_get] = ACTIONS(1712),
    [anon_sym_set] = ACTIONS(1712),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(1712),
    [anon_sym_public] = ACTIONS(1712),
    [anon_sym_private] = ACTIONS(1712),
    [anon_sym_protected] = ACTIONS(1712),
    [anon_sym_override] = ACTIONS(1712),
    [anon_sym_module] = ACTIONS(1712),
    [anon_sym_any] = ACTIONS(1712),
    [anon_sym_number] = ACTIONS(1712),
    [anon_sym_boolean] = ACTIONS(1712),
    [anon_sym_string] = ACTIONS(1712),
    [anon_sym_symbol] = ACTIONS(1712),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [230] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [231] = {
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_typeof] = ACTIONS(1688),
    [anon_sym_import] = ACTIONS(1688),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_LPAREN] = ACTIONS(1690),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_await] = ACTIONS(1688),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(210),
    [anon_sym_yield] = ACTIONS(1688),
    [anon_sym_LBRACK] = ACTIONS(1690),
    [anon_sym_LTtemplate_GT] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(1688),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(1688),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_function] = ACTIONS(1688),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1688),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1690),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(1690),
    [anon_sym_void] = ACTIONS(1688),
    [anon_sym_delete] = ACTIONS(1688),
    [anon_sym_PLUS_PLUS] = ACTIONS(1690),
    [anon_sym_DASH_DASH] = ACTIONS(1690),
    [anon_sym_DQUOTE] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1690),
    [sym_number] = ACTIONS(1690),
    [sym_this] = ACTIONS(1688),
    [sym_super] = ACTIONS(1688),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_undefined] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(1690),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_readonly] = ACTIONS(1688),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_override] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [232] = {
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_export] = ACTIONS(1712),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1712),
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1712),
    [anon_sym_LBRACE] = ACTIONS(1714),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_typeof] = ACTIONS(1712),
    [anon_sym_import] = ACTIONS(1712),
    [anon_sym_BANG] = ACTIONS(1712),
    [anon_sym_LPAREN] = ACTIONS(1714),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_await] = ACTIONS(1712),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(210),
    [anon_sym_yield] = ACTIONS(1712),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LTtemplate_GT] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1712),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(1712),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_class] = ACTIONS(1712),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_function] = ACTIONS(1712),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1712),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1714),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(1712),
    [anon_sym_DASH] = ACTIONS(1712),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(1714),
    [anon_sym_void] = ACTIONS(1712),
    [anon_sym_delete] = ACTIONS(1712),
    [anon_sym_PLUS_PLUS] = ACTIONS(1714),
    [anon_sym_DASH_DASH] = ACTIONS(1714),
    [anon_sym_DQUOTE] = ACTIONS(1714),
    [anon_sym_SQUOTE] = ACTIONS(1714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1714),
    [sym_number] = ACTIONS(1714),
    [sym_this] = ACTIONS(1712),
    [sym_super] = ACTIONS(1712),
    [sym_true] = ACTIONS(1712),
    [sym_false] = ACTIONS(1712),
    [sym_null] = ACTIONS(1712),
    [sym_undefined] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_static] = ACTIONS(1712),
    [anon_sym_readonly] = ACTIONS(1712),
    [anon_sym_get] = ACTIONS(1712),
    [anon_sym_set] = ACTIONS(1712),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(1712),
    [anon_sym_public] = ACTIONS(1712),
    [anon_sym_private] = ACTIONS(1712),
    [anon_sym_protected] = ACTIONS(1712),
    [anon_sym_override] = ACTIONS(1712),
    [anon_sym_module] = ACTIONS(1712),
    [anon_sym_any] = ACTIONS(1712),
    [anon_sym_number] = ACTIONS(1712),
    [anon_sym_boolean] = ACTIONS(1712),
    [anon_sym_string] = ACTIONS(1712),
    [anon_sym_symbol] = ACTIONS(1712),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [233] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2907),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2907),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1084),
    [sym_subscript_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2907),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_pattern] = STATE(3164),
    [sym_rest_pattern] = STATE(2943),
    [sym_non_null_expression] = STATE(1084),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(1718),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_readonly] = ACTIONS(1720),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
    [anon_sym_declare] = ACTIONS(109),
    [anon_sym_public] = ACTIONS(109),
    [anon_sym_private] = ACTIONS(109),
    [anon_sym_protected] = ACTIONS(109),
    [anon_sym_override] = ACTIONS(109),
    [anon_sym_module] = ACTIONS(109),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
  },
  [234] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym__type_query_member_expression] = STATE(2376),
    [sym__type_query_subscript_expression] = STATE(2374),
    [sym__type_query_call_expression] = STATE(2397),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [235] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1720),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4399),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [236] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4157),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [237] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1822),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4167),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1728),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [238] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1730),
    [anon_sym_export] = ACTIONS(1732),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_namespace] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1738),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1732),
    [anon_sym_readonly] = ACTIONS(1732),
    [anon_sym_get] = ACTIONS(1732),
    [anon_sym_set] = ACTIONS(1732),
    [anon_sym_declare] = ACTIONS(1732),
    [anon_sym_public] = ACTIONS(1732),
    [anon_sym_private] = ACTIONS(1732),
    [anon_sym_protected] = ACTIONS(1732),
    [anon_sym_override] = ACTIONS(1732),
    [anon_sym_module] = ACTIONS(1732),
    [anon_sym_any] = ACTIONS(1732),
    [anon_sym_number] = ACTIONS(1732),
    [anon_sym_boolean] = ACTIONS(1732),
    [anon_sym_string] = ACTIONS(1732),
    [anon_sym_symbol] = ACTIONS(1732),
  },
  [239] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1686),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4212),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [240] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_expression] = STATE(2005),
    [sym_primary_expression] = STATE(1506),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1102),
    [sym_subscript_expression] = STATE(1102),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3222),
    [sym_non_null_expression] = STATE(1102),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(4014),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1740),
    [anon_sym_export] = ACTIONS(1742),
    [anon_sym_type] = ACTIONS(1742),
    [anon_sym_namespace] = ACTIONS(1744),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1748),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1742),
    [anon_sym_readonly] = ACTIONS(1742),
    [anon_sym_get] = ACTIONS(1742),
    [anon_sym_set] = ACTIONS(1742),
    [anon_sym_declare] = ACTIONS(1742),
    [anon_sym_public] = ACTIONS(1742),
    [anon_sym_private] = ACTIONS(1742),
    [anon_sym_protected] = ACTIONS(1742),
    [anon_sym_override] = ACTIONS(1742),
    [anon_sym_module] = ACTIONS(1742),
    [anon_sym_any] = ACTIONS(1742),
    [anon_sym_number] = ACTIONS(1742),
    [anon_sym_boolean] = ACTIONS(1742),
    [anon_sym_string] = ACTIONS(1742),
    [anon_sym_symbol] = ACTIONS(1742),
  },
  [241] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1485),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4333),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [242] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3169),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3884),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1754),
    [anon_sym_export] = ACTIONS(1756),
    [anon_sym_type] = ACTIONS(1756),
    [anon_sym_namespace] = ACTIONS(1758),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1760),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1756),
    [anon_sym_readonly] = ACTIONS(1756),
    [anon_sym_get] = ACTIONS(1756),
    [anon_sym_set] = ACTIONS(1756),
    [anon_sym_declare] = ACTIONS(1756),
    [anon_sym_public] = ACTIONS(1756),
    [anon_sym_private] = ACTIONS(1756),
    [anon_sym_protected] = ACTIONS(1756),
    [anon_sym_override] = ACTIONS(1756),
    [anon_sym_module] = ACTIONS(1756),
    [anon_sym_any] = ACTIONS(1756),
    [anon_sym_number] = ACTIONS(1756),
    [anon_sym_boolean] = ACTIONS(1756),
    [anon_sym_string] = ACTIONS(1756),
    [anon_sym_symbol] = ACTIONS(1756),
  },
  [243] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_expression] = STATE(2005),
    [sym_primary_expression] = STATE(1506),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1102),
    [sym_subscript_expression] = STATE(1102),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1102),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1762),
    [anon_sym_export] = ACTIONS(1764),
    [anon_sym_type] = ACTIONS(1764),
    [anon_sym_namespace] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1768),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1764),
    [anon_sym_readonly] = ACTIONS(1764),
    [anon_sym_get] = ACTIONS(1764),
    [anon_sym_set] = ACTIONS(1764),
    [anon_sym_declare] = ACTIONS(1764),
    [anon_sym_public] = ACTIONS(1764),
    [anon_sym_private] = ACTIONS(1764),
    [anon_sym_protected] = ACTIONS(1764),
    [anon_sym_override] = ACTIONS(1764),
    [anon_sym_module] = ACTIONS(1764),
    [anon_sym_any] = ACTIONS(1764),
    [anon_sym_number] = ACTIONS(1764),
    [anon_sym_boolean] = ACTIONS(1764),
    [anon_sym_string] = ACTIONS(1764),
    [anon_sym_symbol] = ACTIONS(1764),
  },
  [244] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1767),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4120),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [245] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1581),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3880),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [246] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1759),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [247] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3222),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(4014),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1754),
    [anon_sym_export] = ACTIONS(1756),
    [anon_sym_type] = ACTIONS(1756),
    [anon_sym_namespace] = ACTIONS(1758),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1760),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1756),
    [anon_sym_readonly] = ACTIONS(1756),
    [anon_sym_get] = ACTIONS(1756),
    [anon_sym_set] = ACTIONS(1756),
    [anon_sym_declare] = ACTIONS(1756),
    [anon_sym_public] = ACTIONS(1756),
    [anon_sym_private] = ACTIONS(1756),
    [anon_sym_protected] = ACTIONS(1756),
    [anon_sym_override] = ACTIONS(1756),
    [anon_sym_module] = ACTIONS(1756),
    [anon_sym_any] = ACTIONS(1756),
    [anon_sym_number] = ACTIONS(1756),
    [anon_sym_boolean] = ACTIONS(1756),
    [anon_sym_string] = ACTIONS(1756),
    [anon_sym_symbol] = ACTIONS(1756),
  },
  [248] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1995),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1427),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [249] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1996),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1430),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [250] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1380),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1840),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [251] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1998),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1438),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [252] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1640),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_sequence_expression] = STATE(3922),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [253] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1824),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4469),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [254] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1851),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1793),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [255] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1532),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1861),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [256] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1652),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4188),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [257] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1689),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4199),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [258] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1529),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1865),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [259] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_expression] = STATE(2005),
    [sym_primary_expression] = STATE(1506),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1102),
    [sym_subscript_expression] = STATE(1102),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1102),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1776),
    [anon_sym_namespace] = ACTIONS(1778),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1780),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1776),
    [anon_sym_readonly] = ACTIONS(1776),
    [anon_sym_get] = ACTIONS(1776),
    [anon_sym_set] = ACTIONS(1776),
    [anon_sym_declare] = ACTIONS(1776),
    [anon_sym_public] = ACTIONS(1776),
    [anon_sym_private] = ACTIONS(1776),
    [anon_sym_protected] = ACTIONS(1776),
    [anon_sym_override] = ACTIONS(1776),
    [anon_sym_module] = ACTIONS(1776),
    [anon_sym_any] = ACTIONS(1776),
    [anon_sym_number] = ACTIONS(1776),
    [anon_sym_boolean] = ACTIONS(1776),
    [anon_sym_string] = ACTIONS(1776),
    [anon_sym_symbol] = ACTIONS(1776),
  },
  [260] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1469),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1867),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [261] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_expression] = STATE(2005),
    [sym_primary_expression] = STATE(1506),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1102),
    [sym_subscript_expression] = STATE(1102),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1102),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1740),
    [anon_sym_export] = ACTIONS(1742),
    [anon_sym_type] = ACTIONS(1742),
    [anon_sym_namespace] = ACTIONS(1744),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1748),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1742),
    [anon_sym_readonly] = ACTIONS(1742),
    [anon_sym_get] = ACTIONS(1742),
    [anon_sym_set] = ACTIONS(1742),
    [anon_sym_declare] = ACTIONS(1742),
    [anon_sym_public] = ACTIONS(1742),
    [anon_sym_private] = ACTIONS(1742),
    [anon_sym_protected] = ACTIONS(1742),
    [anon_sym_override] = ACTIONS(1742),
    [anon_sym_module] = ACTIONS(1742),
    [anon_sym_any] = ACTIONS(1742),
    [anon_sym_number] = ACTIONS(1742),
    [anon_sym_boolean] = ACTIONS(1742),
    [anon_sym_string] = ACTIONS(1742),
    [anon_sym_symbol] = ACTIONS(1742),
  },
  [262] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1873),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [263] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1981),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [264] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1380),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1286),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [265] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1532),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1288),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [266] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1529),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1289),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [267] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1800),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4148),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [268] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1778),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4152),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [269] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1780),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4156),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [270] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1469),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1252),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [271] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1878),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_mapped_type_clause] = STATE(4131),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_export] = ACTIONS(1786),
    [anon_sym_type] = ACTIONS(1786),
    [anon_sym_namespace] = ACTIONS(1788),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1790),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1786),
    [anon_sym_readonly] = ACTIONS(1786),
    [anon_sym_get] = ACTIONS(1786),
    [anon_sym_set] = ACTIONS(1786),
    [anon_sym_declare] = ACTIONS(1786),
    [anon_sym_public] = ACTIONS(1786),
    [anon_sym_private] = ACTIONS(1786),
    [anon_sym_protected] = ACTIONS(1786),
    [anon_sym_override] = ACTIONS(1786),
    [anon_sym_module] = ACTIONS(1786),
    [anon_sym_any] = ACTIONS(1786),
    [anon_sym_number] = ACTIONS(1786),
    [anon_sym_boolean] = ACTIONS(1786),
    [anon_sym_string] = ACTIONS(1786),
    [anon_sym_symbol] = ACTIONS(1786),
  },
  [272] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1481),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [273] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [274] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3222),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(4014),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_export] = ACTIONS(1794),
    [anon_sym_type] = ACTIONS(1794),
    [anon_sym_namespace] = ACTIONS(1796),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1798),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1794),
    [anon_sym_readonly] = ACTIONS(1794),
    [anon_sym_get] = ACTIONS(1794),
    [anon_sym_set] = ACTIONS(1794),
    [anon_sym_declare] = ACTIONS(1794),
    [anon_sym_public] = ACTIONS(1794),
    [anon_sym_private] = ACTIONS(1794),
    [anon_sym_protected] = ACTIONS(1794),
    [anon_sym_override] = ACTIONS(1794),
    [anon_sym_module] = ACTIONS(1794),
    [anon_sym_any] = ACTIONS(1794),
    [anon_sym_number] = ACTIONS(1794),
    [anon_sym_boolean] = ACTIONS(1794),
    [anon_sym_string] = ACTIONS(1794),
    [anon_sym_symbol] = ACTIONS(1794),
  },
  [275] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1754),
    [anon_sym_export] = ACTIONS(1756),
    [anon_sym_type] = ACTIONS(1756),
    [anon_sym_namespace] = ACTIONS(1758),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1760),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1756),
    [anon_sym_readonly] = ACTIONS(1756),
    [anon_sym_get] = ACTIONS(1756),
    [anon_sym_set] = ACTIONS(1756),
    [anon_sym_declare] = ACTIONS(1756),
    [anon_sym_public] = ACTIONS(1756),
    [anon_sym_private] = ACTIONS(1756),
    [anon_sym_protected] = ACTIONS(1756),
    [anon_sym_override] = ACTIONS(1756),
    [anon_sym_module] = ACTIONS(1756),
    [anon_sym_any] = ACTIONS(1756),
    [anon_sym_number] = ACTIONS(1756),
    [anon_sym_boolean] = ACTIONS(1756),
    [anon_sym_string] = ACTIONS(1756),
    [anon_sym_symbol] = ACTIONS(1756),
  },
  [276] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1380),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1632),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [277] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1532),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1631),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [278] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1529),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1630),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [279] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1469),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1619),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [280] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_expression] = STATE(2005),
    [sym_primary_expression] = STATE(1506),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1102),
    [sym_subscript_expression] = STATE(1102),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3222),
    [sym_non_null_expression] = STATE(1102),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(4014),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1776),
    [anon_sym_namespace] = ACTIONS(1778),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1780),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1776),
    [anon_sym_readonly] = ACTIONS(1776),
    [anon_sym_get] = ACTIONS(1776),
    [anon_sym_set] = ACTIONS(1776),
    [anon_sym_declare] = ACTIONS(1776),
    [anon_sym_public] = ACTIONS(1776),
    [anon_sym_private] = ACTIONS(1776),
    [anon_sym_protected] = ACTIONS(1776),
    [anon_sym_override] = ACTIONS(1776),
    [anon_sym_module] = ACTIONS(1776),
    [anon_sym_any] = ACTIONS(1776),
    [anon_sym_number] = ACTIONS(1776),
    [anon_sym_boolean] = ACTIONS(1776),
    [anon_sym_string] = ACTIONS(1776),
    [anon_sym_symbol] = ACTIONS(1776),
  },
  [281] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1594),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [282] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1878),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_mapped_type_clause] = STATE(4160),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1800),
    [anon_sym_export] = ACTIONS(1802),
    [anon_sym_type] = ACTIONS(1802),
    [anon_sym_namespace] = ACTIONS(1804),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1806),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1802),
    [anon_sym_readonly] = ACTIONS(1802),
    [anon_sym_get] = ACTIONS(1802),
    [anon_sym_set] = ACTIONS(1802),
    [anon_sym_declare] = ACTIONS(1802),
    [anon_sym_public] = ACTIONS(1802),
    [anon_sym_private] = ACTIONS(1802),
    [anon_sym_protected] = ACTIONS(1802),
    [anon_sym_override] = ACTIONS(1802),
    [anon_sym_module] = ACTIONS(1802),
    [anon_sym_any] = ACTIONS(1802),
    [anon_sym_number] = ACTIONS(1802),
    [anon_sym_boolean] = ACTIONS(1802),
    [anon_sym_string] = ACTIONS(1802),
    [anon_sym_symbol] = ACTIONS(1802),
  },
  [283] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1917),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [284] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1588),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [285] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1604),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [286] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_export] = ACTIONS(1810),
    [anon_sym_type] = ACTIONS(1810),
    [anon_sym_namespace] = ACTIONS(1812),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1814),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1810),
    [anon_sym_readonly] = ACTIONS(1810),
    [anon_sym_get] = ACTIONS(1810),
    [anon_sym_set] = ACTIONS(1810),
    [anon_sym_declare] = ACTIONS(1810),
    [anon_sym_public] = ACTIONS(1810),
    [anon_sym_private] = ACTIONS(1810),
    [anon_sym_protected] = ACTIONS(1810),
    [anon_sym_override] = ACTIONS(1810),
    [anon_sym_module] = ACTIONS(1810),
    [anon_sym_any] = ACTIONS(1810),
    [anon_sym_number] = ACTIONS(1810),
    [anon_sym_boolean] = ACTIONS(1810),
    [anon_sym_string] = ACTIONS(1810),
    [anon_sym_symbol] = ACTIONS(1810),
  },
  [287] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1375),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(3521),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [288] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3222),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(4014),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_export] = ACTIONS(1810),
    [anon_sym_type] = ACTIONS(1810),
    [anon_sym_namespace] = ACTIONS(1812),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1814),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1810),
    [anon_sym_readonly] = ACTIONS(1810),
    [anon_sym_get] = ACTIONS(1810),
    [anon_sym_set] = ACTIONS(1810),
    [anon_sym_declare] = ACTIONS(1810),
    [anon_sym_public] = ACTIONS(1810),
    [anon_sym_private] = ACTIONS(1810),
    [anon_sym_protected] = ACTIONS(1810),
    [anon_sym_override] = ACTIONS(1810),
    [anon_sym_module] = ACTIONS(1810),
    [anon_sym_any] = ACTIONS(1810),
    [anon_sym_number] = ACTIONS(1810),
    [anon_sym_boolean] = ACTIONS(1810),
    [anon_sym_string] = ACTIONS(1810),
    [anon_sym_symbol] = ACTIONS(1810),
  },
  [289] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1378),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [290] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_export] = ACTIONS(1794),
    [anon_sym_type] = ACTIONS(1794),
    [anon_sym_namespace] = ACTIONS(1796),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1798),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1794),
    [anon_sym_readonly] = ACTIONS(1794),
    [anon_sym_get] = ACTIONS(1794),
    [anon_sym_set] = ACTIONS(1794),
    [anon_sym_declare] = ACTIONS(1794),
    [anon_sym_public] = ACTIONS(1794),
    [anon_sym_private] = ACTIONS(1794),
    [anon_sym_protected] = ACTIONS(1794),
    [anon_sym_override] = ACTIONS(1794),
    [anon_sym_module] = ACTIONS(1794),
    [anon_sym_any] = ACTIONS(1794),
    [anon_sym_number] = ACTIONS(1794),
    [anon_sym_boolean] = ACTIONS(1794),
    [anon_sym_string] = ACTIONS(1794),
    [anon_sym_symbol] = ACTIONS(1794),
  },
  [291] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1579),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [292] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1851),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1401),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [293] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1995),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1514),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [294] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1996),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1535),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [295] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1998),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1534),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [296] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1917),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1440),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [297] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1412),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [298] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1469),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1610),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [299] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1851),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1444),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [300] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1262),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [301] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1917),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1662),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [302] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1529),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1552),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [303] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1532),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1642),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [304] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1380),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1635),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [305] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1806),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4180),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [306] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3222),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(4014),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1730),
    [anon_sym_export] = ACTIONS(1732),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_namespace] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1738),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1732),
    [anon_sym_readonly] = ACTIONS(1732),
    [anon_sym_get] = ACTIONS(1732),
    [anon_sym_set] = ACTIONS(1732),
    [anon_sym_declare] = ACTIONS(1732),
    [anon_sym_public] = ACTIONS(1732),
    [anon_sym_private] = ACTIONS(1732),
    [anon_sym_protected] = ACTIONS(1732),
    [anon_sym_override] = ACTIONS(1732),
    [anon_sym_module] = ACTIONS(1732),
    [anon_sym_any] = ACTIONS(1732),
    [anon_sym_number] = ACTIONS(1732),
    [anon_sym_boolean] = ACTIONS(1732),
    [anon_sym_string] = ACTIONS(1732),
    [anon_sym_symbol] = ACTIONS(1732),
  },
  [307] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3222),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(4014),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [308] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1380),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2012),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [309] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1532),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [310] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1998),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1777),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [311] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1996),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1782),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [312] = {
    [sym_import] = STATE(1955),
    [sym_statement_block] = STATE(1995),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1783),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [313] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1529),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2016),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [314] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1469),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2004),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [315] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1644),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4437),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [316] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_expression] = STATE(2005),
    [sym_primary_expression] = STATE(1506),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1102),
    [sym_subscript_expression] = STATE(1102),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3222),
    [sym_non_null_expression] = STATE(1102),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(4014),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1762),
    [anon_sym_export] = ACTIONS(1764),
    [anon_sym_type] = ACTIONS(1764),
    [anon_sym_namespace] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1768),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1764),
    [anon_sym_readonly] = ACTIONS(1764),
    [anon_sym_get] = ACTIONS(1764),
    [anon_sym_set] = ACTIONS(1764),
    [anon_sym_declare] = ACTIONS(1764),
    [anon_sym_public] = ACTIONS(1764),
    [anon_sym_private] = ACTIONS(1764),
    [anon_sym_protected] = ACTIONS(1764),
    [anon_sym_override] = ACTIONS(1764),
    [anon_sym_module] = ACTIONS(1764),
    [anon_sym_any] = ACTIONS(1764),
    [anon_sym_number] = ACTIONS(1764),
    [anon_sym_boolean] = ACTIONS(1764),
    [anon_sym_string] = ACTIONS(1764),
    [anon_sym_symbol] = ACTIONS(1764),
  },
  [317] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2013),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [318] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1229),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [319] = {
    [sym_import] = STATE(1414),
    [sym_statement_block] = STATE(1494),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2028),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [320] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1682),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4222),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [321] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1684),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4220),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [322] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1450),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4480),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [323] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1685),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_sequence_expression] = STATE(4219),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [324] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1816),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [325] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1577),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [326] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1674),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1818),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [327] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1648),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [328] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [329] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1627),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [330] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1395),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [331] = {
    [sym_namespace_export] = STATE(4064),
    [sym_export_clause] = STATE(3564),
    [sym_declaration] = STATE(665),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [anon_sym_STAR] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1822),
    [anon_sym_type] = ACTIONS(1824),
    [anon_sym_EQ] = ACTIONS(1826),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1863),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [332] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(2881),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(2881),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1083),
    [sym_subscript_expression] = STATE(1083),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(2881),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1083),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_export] = ACTIONS(1873),
    [anon_sym_type] = ACTIONS(1873),
    [anon_sym_namespace] = ACTIONS(1875),
    [anon_sym_LBRACE] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1335),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1877),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1879),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1873),
    [anon_sym_readonly] = ACTIONS(1873),
    [anon_sym_get] = ACTIONS(1873),
    [anon_sym_set] = ACTIONS(1873),
    [anon_sym_declare] = ACTIONS(1873),
    [anon_sym_public] = ACTIONS(1873),
    [anon_sym_private] = ACTIONS(1873),
    [anon_sym_protected] = ACTIONS(1873),
    [anon_sym_override] = ACTIONS(1873),
    [anon_sym_module] = ACTIONS(1873),
    [anon_sym_any] = ACTIONS(1873),
    [anon_sym_number] = ACTIONS(1873),
    [anon_sym_boolean] = ACTIONS(1873),
    [anon_sym_string] = ACTIONS(1873),
    [anon_sym_symbol] = ACTIONS(1873),
  },
  [333] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1466),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [334] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1871),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [335] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1314),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [336] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1994),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [337] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1404),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [338] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1472),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [339] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1488),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [340] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1491),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [341] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1816),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [342] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1533),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [343] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1395),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1818),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [344] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1493),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [345] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1758),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [346] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1654),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [347] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1908),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [348] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1980),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [349] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [350] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1846),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [351] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1830),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [352] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2045),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [353] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2031),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [354] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1769),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [355] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1882),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [356] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1881),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [357] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1881),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [358] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2008),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [359] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2009),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [360] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [361] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1814),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [362] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1475),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [363] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2018),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [364] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1829),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [365] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2041),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [366] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2039),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [367] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [368] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2037),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [369] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2035),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [370] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2026),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [371] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1479),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [372] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2025),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [373] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2024),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [374] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2023),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [375] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1371),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [376] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2022),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [377] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1386),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [378] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2020),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [379] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1823),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [380] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1674),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [381] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1709),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [382] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1952),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [383] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1883),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [384] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1387),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [385] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1629),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [386] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1754),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [387] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1881),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [388] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1416),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [389] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1866),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [390] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2051),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [391] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1392),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [392] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1393),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [393] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1870),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [394] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1269),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [395] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1629),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1881),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [396] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [397] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1880),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [398] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [399] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [400] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1726),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [401] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1960),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [402] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1891),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [403] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1878),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [404] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1509),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [405] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1647),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [406] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1691),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [407] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1892),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [408] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [409] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1703),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [410] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1443),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [411] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1394),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [412] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1895),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [413] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1605),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [414] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1899),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [415] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1774),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [416] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1562),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [417] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1545),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [418] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1429),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [419] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1542),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [420] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1564),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [421] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1413),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [422] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1776),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [423] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [424] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1578),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [425] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1954),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [426] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1641),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [427] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1555),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [428] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1409),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [429] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1547),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [430] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1407),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [431] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1382),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [432] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1445),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [433] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1910),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [434] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1391),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [435] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1950),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [436] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1400),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [437] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1419),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [438] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1837),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [439] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1420),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [440] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1546),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [441] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1860),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [442] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1268),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [443] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1872),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [444] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1404),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(3348),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(3348),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1150),
    [sym_subscript_expression] = STATE(1150),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(3348),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1150),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1885),
    [anon_sym_export] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(986),
    [anon_sym_namespace] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(992),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1887),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(986),
    [anon_sym_readonly] = ACTIONS(986),
    [anon_sym_get] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(986),
    [anon_sym_declare] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(986),
    [anon_sym_private] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(986),
    [anon_sym_override] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(986),
    [anon_sym_number] = ACTIONS(986),
    [anon_sym_boolean] = ACTIONS(986),
    [anon_sym_string] = ACTIONS(986),
    [anon_sym_symbol] = ACTIONS(986),
  },
  [445] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1397),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [446] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1876),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [447] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [448] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1476),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [449] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1422),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [450] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1423),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [451] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1426),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [452] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1710),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [453] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1441),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [454] = {
    [sym_namespace_export] = STATE(4064),
    [sym_export_clause] = STATE(3564),
    [sym_declaration] = STATE(665),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [anon_sym_STAR] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1822),
    [anon_sym_type] = ACTIONS(1824),
    [anon_sym_EQ] = ACTIONS(1826),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1863),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [455] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1508),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [456] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1715),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [457] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1877),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [458] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4479),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4479),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4155),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1044),
    [sym_subscript_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2444),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4479),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1044),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_export] = ACTIONS(1046),
    [anon_sym_type] = ACTIONS(1046),
    [anon_sym_namespace] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(170),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(166),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_TILDE] = ACTIONS(166),
    [anon_sym_void] = ACTIONS(170),
    [anon_sym_delete] = ACTIONS(170),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1883),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(1046),
    [anon_sym_set] = ACTIONS(1046),
    [anon_sym_declare] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_module] = ACTIONS(1046),
    [anon_sym_any] = ACTIONS(1046),
    [anon_sym_number] = ACTIONS(1046),
    [anon_sym_boolean] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_symbol] = ACTIONS(1046),
  },
  [459] = {
    [sym_namespace_export] = STATE(4064),
    [sym_export_clause] = STATE(3564),
    [sym_declaration] = STATE(665),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [aux_sym_object_repeat1] = STATE(3702),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [anon_sym_STAR] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1822),
    [anon_sym_type] = ACTIONS(1824),
    [anon_sym_EQ] = ACTIONS(1826),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1863),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [460] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1488),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1818),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [461] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [462] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1296),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [463] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1501),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [464] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1551),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [465] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1306),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [466] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1575),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [467] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1939),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [468] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1399),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [469] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1717),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [470] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1403),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [471] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [472] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1580),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [473] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1585),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [474] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1322),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [475] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1405),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [476] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1408),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [477] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1373),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [478] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1587),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [479] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1609),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [480] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1284),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [481] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_expression] = STATE(1966),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4443),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4443),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4170),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2417),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4443),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1185),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(864),
    [anon_sym_namespace] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(882),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_void] = ACTIONS(890),
    [anon_sym_delete] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(864),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(864),
    [anon_sym_set] = ACTIONS(864),
    [anon_sym_declare] = ACTIONS(864),
    [anon_sym_public] = ACTIONS(864),
    [anon_sym_private] = ACTIONS(864),
    [anon_sym_protected] = ACTIONS(864),
    [anon_sym_override] = ACTIONS(864),
    [anon_sym_module] = ACTIONS(864),
    [anon_sym_any] = ACTIONS(864),
    [anon_sym_number] = ACTIONS(864),
    [anon_sym_boolean] = ACTIONS(864),
    [anon_sym_string] = ACTIONS(864),
    [anon_sym_symbol] = ACTIONS(864),
  },
  [482] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1834),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [483] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1321),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1893),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [484] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1411),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [485] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1415),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [486] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1592),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [487] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1788),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [488] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1548),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [489] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1589),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [490] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1370),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [491] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1554),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [492] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_expression] = STATE(1435),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4455),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4455),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4456),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1152),
    [sym_subscript_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2404),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4455),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1152),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
  },
  [493] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1565),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [494] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1590),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [495] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1593),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [496] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1583),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [497] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1368),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [498] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_expression] = STATE(1492),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4407),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4407),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4342),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1165),
    [sym_subscript_expression] = STATE(1165),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2419),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1165),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_namespace] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(828),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_readonly] = ACTIONS(818),
    [anon_sym_get] = ACTIONS(818),
    [anon_sym_set] = ACTIONS(818),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_override] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(818),
    [anon_sym_number] = ACTIONS(818),
    [anon_sym_boolean] = ACTIONS(818),
    [anon_sym_string] = ACTIONS(818),
    [anon_sym_symbol] = ACTIONS(818),
  },
  [499] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1366),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [500] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1597),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [501] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1363),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [502] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1598),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [503] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1775),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [504] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1541),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [505] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [506] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1601),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [507] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1377),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [508] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [509] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1603),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [510] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1537),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [511] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1936),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [512] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1606),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [513] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1607),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [514] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1611),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [515] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1612),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [516] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1643),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [517] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1781),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [518] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1622),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [519] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1636),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [520] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1315),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [521] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1785),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [522] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1787),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [523] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1497),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [524] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1360),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [525] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1358),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [526] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_expression] = STATE(1786),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4217),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4217),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4215),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1176),
    [sym_subscript_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2439),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4217),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_readonly] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_override] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
  },
  [527] = {
    [sym_import] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_expression] = STATE(1525),
    [sym_primary_expression] = STATE(1816),
    [sym_yield_expression] = STATE(1874),
    [sym_object] = STATE(1955),
    [sym_object_pattern] = STATE(4416),
    [sym_array] = STATE(1955),
    [sym_array_pattern] = STATE(4416),
    [sym_glimmer_template] = STATE(1874),
    [sym_glimmer_opening_tag] = STATE(3528),
    [sym_jsx_element] = STATE(1874),
    [sym_jsx_fragment] = STATE(1874),
    [sym_jsx_opening_element] = STATE(2706),
    [sym_jsx_self_closing_element] = STATE(1874),
    [sym_class] = STATE(1955),
    [sym_function] = STATE(1955),
    [sym_generator_function] = STATE(1955),
    [sym_arrow_function] = STATE(1955),
    [sym__call_signature] = STATE(4414),
    [sym_call_expression] = STATE(1955),
    [sym_new_expression] = STATE(1874),
    [sym_await_expression] = STATE(1874),
    [sym_member_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1874),
    [sym__augmented_assignment_lhs] = STATE(2435),
    [sym_augmented_assignment_expression] = STATE(1874),
    [sym__destructuring_pattern] = STATE(4416),
    [sym_ternary_expression] = STATE(1874),
    [sym_binary_expression] = STATE(1874),
    [sym_unary_expression] = STATE(1874),
    [sym_update_expression] = STATE(1874),
    [sym_string] = STATE(1955),
    [sym_template_string] = STATE(1955),
    [sym_regex] = STATE(1955),
    [sym_meta_property] = STATE(1955),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1874),
    [sym_satisfies_expression] = STATE(1874),
    [sym_internal_module] = STATE(1874),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3540),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_typeof] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1024),
    [anon_sym_delete] = ACTIONS(1024),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
  },
  [528] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1357),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [529] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1353),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4153),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4153),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4478),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2403),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4153),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1101),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(606),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_void] = ACTIONS(606),
    [anon_sym_delete] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_readonly] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_override] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
  },
  [530] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_expression] = STATE(1565),
    [sym_primary_expression] = STATE(1369),
    [sym_yield_expression] = STATE(1446),
    [sym_object] = STATE(1414),
    [sym_object_pattern] = STATE(4344),
    [sym_array] = STATE(1414),
    [sym_array_pattern] = STATE(4344),
    [sym_glimmer_template] = STATE(1446),
    [sym_glimmer_opening_tag] = STATE(3494),
    [sym_jsx_element] = STATE(1446),
    [sym_jsx_fragment] = STATE(1446),
    [sym_jsx_opening_element] = STATE(2684),
    [sym_jsx_self_closing_element] = STATE(1446),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(4114),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1446),
    [sym_await_expression] = STATE(1446),
    [sym_member_expression] = STATE(1167),
    [sym_subscript_expression] = STATE(1167),
    [sym_assignment_expression] = STATE(1446),
    [sym__augmented_assignment_lhs] = STATE(2422),
    [sym_augmented_assignment_expression] = STATE(1446),
    [sym__destructuring_pattern] = STATE(4344),
    [sym_ternary_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_update_expression] = STATE(1446),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(3123),
    [sym_non_null_expression] = STATE(1167),
    [sym_as_expression] = STATE(1446),
    [sym_satisfies_expression] = STATE(1446),
    [sym_internal_module] = STATE(1446),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_export_statement_repeat1] = STATE(3450),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_typeof] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_class] = ACTIONS(144),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(148),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(932),
    [anon_sym_delete] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_number] = ACTIONS(1881),
    [sym_this] = ACTIONS(185),
    [sym_super] = ACTIONS(185),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_readonly] = ACTIONS(910),
    [anon_sym_get] = ACTIONS(910),
    [anon_sym_set] = ACTIONS(910),
    [anon_sym_declare] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_override] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_any] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_boolean] = ACTIONS(910),
    [anon_sym_string] = ACTIONS(910),
    [anon_sym_symbol] = ACTIONS(910),
  },
  [531] = {
    [sym_declaration] = STATE(650),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1899),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_global] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [532] = {
    [sym_declaration] = STATE(650),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [aux_sym_object_repeat1] = STATE(3702),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1899),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_global] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [533] = {
    [sym_declaration] = STATE(650),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1899),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_global] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [534] = {
    [sym_namespace_export] = STATE(4064),
    [sym_export_clause] = STATE(3564),
    [sym_declaration] = STATE(665),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [anon_sym_STAR] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1903),
    [anon_sym_type] = ACTIONS(1824),
    [anon_sym_EQ] = ACTIONS(1905),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_namespace] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(1911),
    [anon_sym_module] = ACTIONS(1913),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [535] = {
    [sym_namespace_export] = STATE(4064),
    [sym_export_clause] = STATE(3564),
    [sym_declaration] = STATE(665),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [anon_sym_STAR] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1915),
    [anon_sym_type] = ACTIONS(1824),
    [anon_sym_EQ] = ACTIONS(1905),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1863),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [536] = {
    [sym_namespace_export] = STATE(4064),
    [sym_export_clause] = STATE(3564),
    [sym_declaration] = STATE(665),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [anon_sym_STAR] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1822),
    [anon_sym_type] = ACTIONS(1824),
    [anon_sym_EQ] = ACTIONS(1905),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1919),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1863),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [537] = {
    [sym__call_signature] = STATE(4373),
    [sym_string] = STATE(3092),
    [sym_formal_parameters] = STATE(3123),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_object_repeat1] = STATE(3702),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1921),
    [anon_sym_export] = ACTIONS(1923),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_type] = ACTIONS(1923),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1923),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1928),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1935),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1923),
    [anon_sym_function] = ACTIONS(1939),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_readonly] = ACTIONS(1923),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1923),
    [anon_sym_public] = ACTIONS(1923),
    [anon_sym_private] = ACTIONS(1923),
    [anon_sym_protected] = ACTIONS(1923),
    [anon_sym_override] = ACTIONS(1923),
    [anon_sym_module] = ACTIONS(1923),
    [anon_sym_any] = ACTIONS(1923),
    [anon_sym_number] = ACTIONS(1923),
    [anon_sym_boolean] = ACTIONS(1923),
    [anon_sym_string] = ACTIONS(1923),
    [anon_sym_symbol] = ACTIONS(1923),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [538] = {
    [sym__call_signature] = STATE(4373),
    [sym_string] = STATE(3092),
    [sym_formal_parameters] = STATE(3123),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1921),
    [anon_sym_export] = ACTIONS(1923),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_type] = ACTIONS(1923),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1923),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1928),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1935),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1923),
    [anon_sym_function] = ACTIONS(1939),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_readonly] = ACTIONS(1923),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1923),
    [anon_sym_public] = ACTIONS(1923),
    [anon_sym_private] = ACTIONS(1923),
    [anon_sym_protected] = ACTIONS(1923),
    [anon_sym_override] = ACTIONS(1923),
    [anon_sym_module] = ACTIONS(1923),
    [anon_sym_any] = ACTIONS(1923),
    [anon_sym_number] = ACTIONS(1923),
    [anon_sym_boolean] = ACTIONS(1923),
    [anon_sym_string] = ACTIONS(1923),
    [anon_sym_symbol] = ACTIONS(1923),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [539] = {
    [sym__call_signature] = STATE(4373),
    [sym_string] = STATE(3092),
    [sym_formal_parameters] = STATE(3123),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [sym_type_parameters] = STATE(3937),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1921),
    [anon_sym_export] = ACTIONS(1923),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_type] = ACTIONS(1923),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1923),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1928),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1935),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1923),
    [anon_sym_function] = ACTIONS(1939),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_readonly] = ACTIONS(1923),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1923),
    [anon_sym_public] = ACTIONS(1923),
    [anon_sym_private] = ACTIONS(1923),
    [anon_sym_protected] = ACTIONS(1923),
    [anon_sym_override] = ACTIONS(1923),
    [anon_sym_module] = ACTIONS(1923),
    [anon_sym_any] = ACTIONS(1923),
    [anon_sym_number] = ACTIONS(1923),
    [anon_sym_boolean] = ACTIONS(1923),
    [anon_sym_string] = ACTIONS(1923),
    [anon_sym_symbol] = ACTIONS(1923),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [540] = {
    [sym_declaration] = STATE(650),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1899),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_global] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [541] = {
    [sym_declaration] = STATE(650),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1919),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1899),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_global] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [542] = {
    [sym_declaration] = STATE(650),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1907),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(1911),
    [anon_sym_module] = ACTIONS(1949),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_global] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [543] = {
    [sym_string] = STATE(3092),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [sym_override_modifier] = STATE(2308),
    [aux_sym_object_repeat1] = STATE(3702),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_readonly] = ACTIONS(1955),
    [anon_sym_get] = ACTIONS(1957),
    [anon_sym_set] = ACTIONS(1957),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_override] = ACTIONS(1959),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_any] = ACTIONS(1951),
    [anon_sym_number] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [544] = {
    [sym_string] = STATE(3092),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [sym_override_modifier] = STATE(2308),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_readonly] = ACTIONS(1955),
    [anon_sym_get] = ACTIONS(1957),
    [anon_sym_set] = ACTIONS(1957),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_override] = ACTIONS(1959),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_any] = ACTIONS(1951),
    [anon_sym_number] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [545] = {
    [sym_string] = STATE(3092),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [sym_override_modifier] = STATE(2308),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_readonly] = ACTIONS(1955),
    [anon_sym_get] = ACTIONS(1957),
    [anon_sym_set] = ACTIONS(1957),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_override] = ACTIONS(1959),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_any] = ACTIONS(1951),
    [anon_sym_number] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [546] = {
    [sym_declaration] = STATE(3325),
    [sym_variable_declaration] = STATE(3329),
    [sym_lexical_declaration] = STATE(3329),
    [sym_class_declaration] = STATE(3329),
    [sym_function_declaration] = STATE(3329),
    [sym_generator_function_declaration] = STATE(3329),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(3329),
    [sym_ambient_declaration] = STATE(3329),
    [sym_abstract_class_declaration] = STATE(3329),
    [sym_module] = STATE(3329),
    [sym_internal_module] = STATE(3327),
    [sym_import_alias] = STATE(3329),
    [sym_interface_declaration] = STATE(3329),
    [sym_enum_declaration] = STATE(3329),
    [sym_type_alias_declaration] = STATE(3329),
    [aux_sym_export_statement_repeat1] = STATE(3322),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1961),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1963),
    [anon_sym_import] = ACTIONS(1965),
    [anon_sym_var] = ACTIONS(1967),
    [anon_sym_let] = ACTIONS(1969),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1973),
    [anon_sym_async] = ACTIONS(1975),
    [anon_sym_function] = ACTIONS(1977),
    [anon_sym_EQ_GT] = ACTIONS(1277),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(1979),
    [anon_sym_module] = ACTIONS(1981),
    [anon_sym_abstract] = ACTIONS(1983),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_global] = ACTIONS(1985),
    [anon_sym_interface] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1989),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [547] = {
    [sym_string] = STATE(3092),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1951),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_readonly] = ACTIONS(1951),
    [anon_sym_get] = ACTIONS(1951),
    [anon_sym_set] = ACTIONS(1951),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_override] = ACTIONS(1951),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_any] = ACTIONS(1951),
    [anon_sym_number] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [548] = {
    [sym_string] = STATE(3092),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_readonly] = ACTIONS(1951),
    [anon_sym_get] = ACTIONS(1957),
    [anon_sym_set] = ACTIONS(1957),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_override] = ACTIONS(1951),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_any] = ACTIONS(1951),
    [anon_sym_number] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(1606),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_export] = ACTIONS(1608),
    [anon_sym_default] = ACTIONS(1608),
    [anon_sym_type] = ACTIONS(1608),
    [anon_sym_EQ] = ACTIONS(1608),
    [anon_sym_namespace] = ACTIONS(1608),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_COMMA] = ACTIONS(1606),
    [anon_sym_RBRACE] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_import] = ACTIONS(1608),
    [anon_sym_from] = ACTIONS(1608),
    [anon_sym_var] = ACTIONS(1608),
    [anon_sym_let] = ACTIONS(1608),
    [anon_sym_const] = ACTIONS(1608),
    [anon_sym_BANG] = ACTIONS(1606),
    [anon_sym_else] = ACTIONS(1608),
    [anon_sym_if] = ACTIONS(1608),
    [anon_sym_switch] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_RPAREN] = ACTIONS(1606),
    [anon_sym_await] = ACTIONS(1608),
    [anon_sym_while] = ACTIONS(1608),
    [anon_sym_do] = ACTIONS(1608),
    [anon_sym_try] = ACTIONS(1608),
    [anon_sym_with] = ACTIONS(1608),
    [anon_sym_break] = ACTIONS(1608),
    [anon_sym_continue] = ACTIONS(1608),
    [anon_sym_debugger] = ACTIONS(1608),
    [anon_sym_return] = ACTIONS(1608),
    [anon_sym_throw] = ACTIONS(1608),
    [anon_sym_SEMI] = ACTIONS(1606),
    [anon_sym_COLON] = ACTIONS(1606),
    [anon_sym_case] = ACTIONS(1608),
    [anon_sym_yield] = ACTIONS(1608),
    [anon_sym_LBRACK] = ACTIONS(1606),
    [anon_sym_RBRACK] = ACTIONS(1606),
    [anon_sym_LTtemplate_GT] = ACTIONS(1606),
    [anon_sym_LT] = ACTIONS(1608),
    [anon_sym_GT] = ACTIONS(1606),
    [anon_sym_SLASH] = ACTIONS(1608),
    [anon_sym_class] = ACTIONS(1608),
    [anon_sym_async] = ACTIONS(1608),
    [anon_sym_function] = ACTIONS(1608),
    [anon_sym_EQ_GT] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1608),
    [anon_sym_AMP] = ACTIONS(1606),
    [anon_sym_PIPE] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_TILDE] = ACTIONS(1606),
    [anon_sym_void] = ACTIONS(1608),
    [anon_sym_delete] = ACTIONS(1608),
    [anon_sym_PLUS_PLUS] = ACTIONS(1606),
    [anon_sym_DASH_DASH] = ACTIONS(1606),
    [anon_sym_DQUOTE] = ACTIONS(1606),
    [anon_sym_SQUOTE] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_number] = ACTIONS(1606),
    [sym_this] = ACTIONS(1608),
    [sym_super] = ACTIONS(1608),
    [sym_true] = ACTIONS(1608),
    [sym_false] = ACTIONS(1608),
    [sym_null] = ACTIONS(1608),
    [sym_undefined] = ACTIONS(1608),
    [anon_sym_AT] = ACTIONS(1606),
    [anon_sym_static] = ACTIONS(1608),
    [anon_sym_readonly] = ACTIONS(1608),
    [anon_sym_get] = ACTIONS(1608),
    [anon_sym_set] = ACTIONS(1608),
    [anon_sym_QMARK] = ACTIONS(1606),
    [anon_sym_declare] = ACTIONS(1608),
    [anon_sym_public] = ACTIONS(1608),
    [anon_sym_private] = ACTIONS(1608),
    [anon_sym_protected] = ACTIONS(1608),
    [anon_sym_override] = ACTIONS(1608),
    [anon_sym_module] = ACTIONS(1608),
    [anon_sym_any] = ACTIONS(1608),
    [anon_sym_number] = ACTIONS(1608),
    [anon_sym_boolean] = ACTIONS(1608),
    [anon_sym_string] = ACTIONS(1608),
    [anon_sym_symbol] = ACTIONS(1608),
    [anon_sym_abstract] = ACTIONS(1608),
    [anon_sym_extends] = ACTIONS(1608),
    [anon_sym_interface] = ACTIONS(1608),
    [anon_sym_enum] = ACTIONS(1608),
  },
  [550] = {
    [sym_string] = STATE(3092),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [aux_sym_object_repeat1] = STATE(3702),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_readonly] = ACTIONS(1951),
    [anon_sym_get] = ACTIONS(1957),
    [anon_sym_set] = ACTIONS(1957),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_override] = ACTIONS(1951),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_any] = ACTIONS(1951),
    [anon_sym_number] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [551] = {
    [sym_declaration] = STATE(650),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1277),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1899),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_global] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(1542),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_export] = ACTIONS(1544),
    [anon_sym_default] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(1544),
    [anon_sym_EQ] = ACTIONS(1544),
    [anon_sym_namespace] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_COMMA] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_typeof] = ACTIONS(1544),
    [anon_sym_import] = ACTIONS(1544),
    [anon_sym_from] = ACTIONS(1544),
    [anon_sym_var] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(1544),
    [anon_sym_const] = ACTIONS(1544),
    [anon_sym_BANG] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_switch] = ACTIONS(1544),
    [anon_sym_for] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_await] = ACTIONS(1544),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_try] = ACTIONS(1544),
    [anon_sym_with] = ACTIONS(1544),
    [anon_sym_break] = ACTIONS(1544),
    [anon_sym_continue] = ACTIONS(1544),
    [anon_sym_debugger] = ACTIONS(1544),
    [anon_sym_return] = ACTIONS(1544),
    [anon_sym_throw] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_COLON] = ACTIONS(1542),
    [anon_sym_case] = ACTIONS(1544),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_RBRACK] = ACTIONS(1542),
    [anon_sym_LTtemplate_GT] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_SLASH] = ACTIONS(1544),
    [anon_sym_class] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1544),
    [anon_sym_function] = ACTIONS(1544),
    [anon_sym_EQ_GT] = ACTIONS(1542),
    [anon_sym_new] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_TILDE] = ACTIONS(1542),
    [anon_sym_void] = ACTIONS(1544),
    [anon_sym_delete] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [sym_number] = ACTIONS(1542),
    [sym_this] = ACTIONS(1544),
    [sym_super] = ACTIONS(1544),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_undefined] = ACTIONS(1544),
    [anon_sym_AT] = ACTIONS(1542),
    [anon_sym_static] = ACTIONS(1544),
    [anon_sym_readonly] = ACTIONS(1544),
    [anon_sym_get] = ACTIONS(1544),
    [anon_sym_set] = ACTIONS(1544),
    [anon_sym_QMARK] = ACTIONS(1542),
    [anon_sym_declare] = ACTIONS(1544),
    [anon_sym_public] = ACTIONS(1544),
    [anon_sym_private] = ACTIONS(1544),
    [anon_sym_protected] = ACTIONS(1544),
    [anon_sym_override] = ACTIONS(1544),
    [anon_sym_module] = ACTIONS(1544),
    [anon_sym_any] = ACTIONS(1544),
    [anon_sym_number] = ACTIONS(1544),
    [anon_sym_boolean] = ACTIONS(1544),
    [anon_sym_string] = ACTIONS(1544),
    [anon_sym_symbol] = ACTIONS(1544),
    [anon_sym_abstract] = ACTIONS(1544),
    [anon_sym_extends] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1544),
    [anon_sym_enum] = ACTIONS(1544),
  },
  [553] = {
    [sym_string] = STATE(3092),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_readonly] = ACTIONS(1951),
    [anon_sym_get] = ACTIONS(1957),
    [anon_sym_set] = ACTIONS(1957),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_override] = ACTIONS(1951),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_any] = ACTIONS(1951),
    [anon_sym_number] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [554] = {
    [sym_declaration] = STATE(650),
    [sym_variable_declaration] = STATE(649),
    [sym_lexical_declaration] = STATE(649),
    [sym_class_declaration] = STATE(649),
    [sym_function_declaration] = STATE(649),
    [sym_generator_function_declaration] = STATE(649),
    [sym_decorator] = STATE(1171),
    [sym_function_signature] = STATE(649),
    [sym_ambient_declaration] = STATE(649),
    [sym_abstract_class_declaration] = STATE(649),
    [sym_module] = STATE(649),
    [sym_internal_module] = STATE(636),
    [sym_import_alias] = STATE(649),
    [sym_interface_declaration] = STATE(649),
    [sym_enum_declaration] = STATE(649),
    [sym_type_alias_declaration] = STATE(649),
    [aux_sym_export_statement_repeat1] = STATE(3198),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1907),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_EQ_GT] = ACTIONS(1277),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(152),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(1911),
    [anon_sym_module] = ACTIONS(1949),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_satisfies] = ACTIONS(152),
    [anon_sym_global] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1869),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [555] = {
    [sym_string] = STATE(3092),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [aux_sym_object_repeat1] = STATE(3702),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1951),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_readonly] = ACTIONS(1951),
    [anon_sym_get] = ACTIONS(1951),
    [anon_sym_set] = ACTIONS(1951),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_override] = ACTIONS(1951),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_any] = ACTIONS(1951),
    [anon_sym_number] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [556] = {
    [sym_string] = STATE(3092),
    [sym__property_name] = STATE(3092),
    [sym_computed_property_name] = STATE(3092),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1951),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1945),
    [sym_private_property_identifier] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_readonly] = ACTIONS(1951),
    [anon_sym_get] = ACTIONS(1951),
    [anon_sym_set] = ACTIONS(1951),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_override] = ACTIONS(1951),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_any] = ACTIONS(1951),
    [anon_sym_number] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(1991),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_default] = ACTIONS(1993),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1993),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_LBRACE] = ACTIONS(1991),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_typeof] = ACTIONS(1993),
    [anon_sym_import] = ACTIONS(1993),
    [anon_sym_var] = ACTIONS(1993),
    [anon_sym_let] = ACTIONS(1993),
    [anon_sym_const] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_else] = ACTIONS(1993),
    [anon_sym_if] = ACTIONS(1993),
    [anon_sym_switch] = ACTIONS(1993),
    [anon_sym_for] = ACTIONS(1993),
    [anon_sym_LPAREN] = ACTIONS(1991),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_await] = ACTIONS(1993),
    [anon_sym_while] = ACTIONS(1993),
    [anon_sym_do] = ACTIONS(1993),
    [anon_sym_try] = ACTIONS(1993),
    [anon_sym_with] = ACTIONS(1993),
    [anon_sym_break] = ACTIONS(1993),
    [anon_sym_continue] = ACTIONS(1993),
    [anon_sym_debugger] = ACTIONS(1993),
    [anon_sym_return] = ACTIONS(1993),
    [anon_sym_throw] = ACTIONS(1993),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_case] = ACTIONS(1993),
    [anon_sym_yield] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_LTtemplate_GT] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1993),
    [anon_sym_class] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(1993),
    [anon_sym_EQ_GT] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1991),
    [anon_sym_void] = ACTIONS(1993),
    [anon_sym_delete] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1991),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1991),
    [sym_number] = ACTIONS(1991),
    [sym_this] = ACTIONS(1993),
    [sym_super] = ACTIONS(1993),
    [sym_true] = ACTIONS(1993),
    [sym_false] = ACTIONS(1993),
    [sym_null] = ACTIONS(1993),
    [sym_undefined] = ACTIONS(1993),
    [anon_sym_AT] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_readonly] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [anon_sym_abstract] = ACTIONS(1993),
    [anon_sym_extends] = ACTIONS(1993),
    [anon_sym_interface] = ACTIONS(1993),
    [anon_sym_enum] = ACTIONS(1993),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_export] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1997),
    [anon_sym_type] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [anon_sym_typeof] = ACTIONS(1997),
    [anon_sym_import] = ACTIONS(1997),
    [anon_sym_var] = ACTIONS(1997),
    [anon_sym_let] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_else] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_for] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(1995),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_await] = ACTIONS(1997),
    [anon_sym_while] = ACTIONS(1997),
    [anon_sym_do] = ACTIONS(1997),
    [anon_sym_try] = ACTIONS(1997),
    [anon_sym_with] = ACTIONS(1997),
    [anon_sym_break] = ACTIONS(1997),
    [anon_sym_continue] = ACTIONS(1997),
    [anon_sym_debugger] = ACTIONS(1997),
    [anon_sym_return] = ACTIONS(1997),
    [anon_sym_throw] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_yield] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [anon_sym_LTtemplate_GT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_GT] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_class] = ACTIONS(1997),
    [anon_sym_async] = ACTIONS(1997),
    [anon_sym_function] = ACTIONS(1997),
    [anon_sym_EQ_GT] = ACTIONS(1995),
    [anon_sym_new] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_TILDE] = ACTIONS(1995),
    [anon_sym_void] = ACTIONS(1997),
    [anon_sym_delete] = ACTIONS(1997),
    [anon_sym_PLUS_PLUS] = ACTIONS(1995),
    [anon_sym_DASH_DASH] = ACTIONS(1995),
    [anon_sym_DQUOTE] = ACTIONS(1995),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1995),
    [sym_number] = ACTIONS(1995),
    [sym_this] = ACTIONS(1997),
    [sym_super] = ACTIONS(1997),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [sym_null] = ACTIONS(1997),
    [sym_undefined] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_readonly] = ACTIONS(1997),
    [anon_sym_get] = ACTIONS(1997),
    [anon_sym_set] = ACTIONS(1997),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_declare] = ACTIONS(1997),
    [anon_sym_public] = ACTIONS(1997),
    [anon_sym_private] = ACTIONS(1997),
    [anon_sym_protected] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_module] = ACTIONS(1997),
    [anon_sym_any] = ACTIONS(1997),
    [anon_sym_number] = ACTIONS(1997),
    [anon_sym_boolean] = ACTIONS(1997),
    [anon_sym_string] = ACTIONS(1997),
    [anon_sym_symbol] = ACTIONS(1997),
    [anon_sym_abstract] = ACTIONS(1997),
    [anon_sym_extends] = ACTIONS(1997),
    [anon_sym_interface] = ACTIONS(1997),
    [anon_sym_enum] = ACTIONS(1997),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1999),
    [sym_identifier] = ACTIONS(2001),
    [anon_sym_export] = ACTIONS(2001),
    [anon_sym_default] = ACTIONS(2001),
    [anon_sym_type] = ACTIONS(2001),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_namespace] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_typeof] = ACTIONS(2001),
    [anon_sym_import] = ACTIONS(2001),
    [anon_sym_var] = ACTIONS(2001),
    [anon_sym_let] = ACTIONS(2001),
    [anon_sym_const] = ACTIONS(2001),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_else] = ACTIONS(2001),
    [anon_sym_if] = ACTIONS(2001),
    [anon_sym_switch] = ACTIONS(2001),
    [anon_sym_for] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_await] = ACTIONS(2001),
    [anon_sym_while] = ACTIONS(2001),
    [anon_sym_do] = ACTIONS(2001),
    [anon_sym_try] = ACTIONS(2001),
    [anon_sym_with] = ACTIONS(2001),
    [anon_sym_break] = ACTIONS(2001),
    [anon_sym_continue] = ACTIONS(2001),
    [anon_sym_debugger] = ACTIONS(2001),
    [anon_sym_return] = ACTIONS(2001),
    [anon_sym_throw] = ACTIONS(2001),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_case] = ACTIONS(2001),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_LBRACK] = ACTIONS(1999),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_LTtemplate_GT] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_GT] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_class] = ACTIONS(2001),
    [anon_sym_async] = ACTIONS(2001),
    [anon_sym_function] = ACTIONS(2001),
    [anon_sym_EQ_GT] = ACTIONS(1999),
    [anon_sym_new] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_void] = ACTIONS(2001),
    [anon_sym_delete] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(1999),
    [anon_sym_SQUOTE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(1999),
    [sym_this] = ACTIONS(2001),
    [sym_super] = ACTIONS(2001),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_AT] = ACTIONS(1999),
    [anon_sym_static] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2001),
    [anon_sym_get] = ACTIONS(2001),
    [anon_sym_set] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_declare] = ACTIONS(2001),
    [anon_sym_public] = ACTIONS(2001),
    [anon_sym_private] = ACTIONS(2001),
    [anon_sym_protected] = ACTIONS(2001),
    [anon_sym_override] = ACTIONS(2001),
    [anon_sym_module] = ACTIONS(2001),
    [anon_sym_any] = ACTIONS(2001),
    [anon_sym_number] = ACTIONS(2001),
    [anon_sym_boolean] = ACTIONS(2001),
    [anon_sym_string] = ACTIONS(2001),
    [anon_sym_symbol] = ACTIONS(2001),
    [anon_sym_abstract] = ACTIONS(2001),
    [anon_sym_extends] = ACTIONS(2001),
    [anon_sym_interface] = ACTIONS(2001),
    [anon_sym_enum] = ACTIONS(2001),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(2003),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_export] = ACTIONS(2005),
    [anon_sym_default] = ACTIONS(2005),
    [anon_sym_type] = ACTIONS(2005),
    [anon_sym_EQ] = ACTIONS(2005),
    [anon_sym_namespace] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2003),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_RBRACE] = ACTIONS(2003),
    [anon_sym_typeof] = ACTIONS(2005),
    [anon_sym_import] = ACTIONS(2005),
    [anon_sym_var] = ACTIONS(2005),
    [anon_sym_let] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_BANG] = ACTIONS(2003),
    [anon_sym_else] = ACTIONS(2005),
    [anon_sym_if] = ACTIONS(2005),
    [anon_sym_switch] = ACTIONS(2005),
    [anon_sym_for] = ACTIONS(2005),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_RPAREN] = ACTIONS(2003),
    [anon_sym_await] = ACTIONS(2005),
    [anon_sym_while] = ACTIONS(2005),
    [anon_sym_do] = ACTIONS(2005),
    [anon_sym_try] = ACTIONS(2005),
    [anon_sym_with] = ACTIONS(2005),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_continue] = ACTIONS(2005),
    [anon_sym_debugger] = ACTIONS(2005),
    [anon_sym_return] = ACTIONS(2005),
    [anon_sym_throw] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_COLON] = ACTIONS(2003),
    [anon_sym_case] = ACTIONS(2005),
    [anon_sym_yield] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2003),
    [anon_sym_RBRACK] = ACTIONS(2003),
    [anon_sym_LTtemplate_GT] = ACTIONS(2003),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2003),
    [anon_sym_SLASH] = ACTIONS(2005),
    [anon_sym_class] = ACTIONS(2005),
    [anon_sym_async] = ACTIONS(2005),
    [anon_sym_function] = ACTIONS(2005),
    [anon_sym_EQ_GT] = ACTIONS(2003),
    [anon_sym_new] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2003),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_TILDE] = ACTIONS(2003),
    [anon_sym_void] = ACTIONS(2005),
    [anon_sym_delete] = ACTIONS(2005),
    [anon_sym_PLUS_PLUS] = ACTIONS(2003),
    [anon_sym_DASH_DASH] = ACTIONS(2003),
    [anon_sym_DQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2003),
    [sym_number] = ACTIONS(2003),
    [sym_this] = ACTIONS(2005),
    [sym_super] = ACTIONS(2005),
    [sym_true] = ACTIONS(2005),
    [sym_false] = ACTIONS(2005),
    [sym_null] = ACTIONS(2005),
    [sym_undefined] = ACTIONS(2005),
    [anon_sym_AT] = ACTIONS(2003),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_get] = ACTIONS(2005),
    [anon_sym_set] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(2003),
    [anon_sym_declare] = ACTIONS(2005),
    [anon_sym_public] = ACTIONS(2005),
    [anon_sym_private] = ACTIONS(2005),
    [anon_sym_protected] = ACTIONS(2005),
    [anon_sym_override] = ACTIONS(2005),
    [anon_sym_module] = ACTIONS(2005),
    [anon_sym_any] = ACTIONS(2005),
    [anon_sym_number] = ACTIONS(2005),
    [anon_sym_boolean] = ACTIONS(2005),
    [anon_sym_string] = ACTIONS(2005),
    [anon_sym_symbol] = ACTIONS(2005),
    [anon_sym_abstract] = ACTIONS(2005),
    [anon_sym_extends] = ACTIONS(2005),
    [anon_sym_interface] = ACTIONS(2005),
    [anon_sym_enum] = ACTIONS(2005),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(2007),
    [sym_identifier] = ACTIONS(2009),
    [anon_sym_export] = ACTIONS(2009),
    [anon_sym_default] = ACTIONS(2009),
    [anon_sym_type] = ACTIONS(2009),
    [anon_sym_EQ] = ACTIONS(2009),
    [anon_sym_namespace] = ACTIONS(2009),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_COMMA] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(2007),
    [anon_sym_typeof] = ACTIONS(2009),
    [anon_sym_import] = ACTIONS(2009),
    [anon_sym_var] = ACTIONS(2009),
    [anon_sym_let] = ACTIONS(2009),
    [anon_sym_const] = ACTIONS(2009),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_else] = ACTIONS(2009),
    [anon_sym_if] = ACTIONS(2009),
    [anon_sym_switch] = ACTIONS(2009),
    [anon_sym_for] = ACTIONS(2009),
    [anon_sym_LPAREN] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2007),
    [anon_sym_await] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(2009),
    [anon_sym_do] = ACTIONS(2009),
    [anon_sym_try] = ACTIONS(2009),
    [anon_sym_with] = ACTIONS(2009),
    [anon_sym_break] = ACTIONS(2009),
    [anon_sym_continue] = ACTIONS(2009),
    [anon_sym_debugger] = ACTIONS(2009),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_throw] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_COLON] = ACTIONS(2007),
    [anon_sym_case] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2007),
    [anon_sym_RBRACK] = ACTIONS(2007),
    [anon_sym_LTtemplate_GT] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2009),
    [anon_sym_class] = ACTIONS(2009),
    [anon_sym_async] = ACTIONS(2009),
    [anon_sym_function] = ACTIONS(2009),
    [anon_sym_EQ_GT] = ACTIONS(2007),
    [anon_sym_new] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2007),
    [anon_sym_PLUS] = ACTIONS(2009),
    [anon_sym_DASH] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_void] = ACTIONS(2009),
    [anon_sym_delete] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2007),
    [anon_sym_DASH_DASH] = ACTIONS(2007),
    [anon_sym_DQUOTE] = ACTIONS(2007),
    [anon_sym_SQUOTE] = ACTIONS(2007),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2007),
    [sym_number] = ACTIONS(2007),
    [sym_this] = ACTIONS(2009),
    [sym_super] = ACTIONS(2009),
    [sym_true] = ACTIONS(2009),
    [sym_false] = ACTIONS(2009),
    [sym_null] = ACTIONS(2009),
    [sym_undefined] = ACTIONS(2009),
    [anon_sym_AT] = ACTIONS(2007),
    [anon_sym_static] = ACTIONS(2009),
    [anon_sym_readonly] = ACTIONS(2009),
    [anon_sym_get] = ACTIONS(2009),
    [anon_sym_set] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2007),
    [anon_sym_declare] = ACTIONS(2009),
    [anon_sym_public] = ACTIONS(2009),
    [anon_sym_private] = ACTIONS(2009),
    [anon_sym_protected] = ACTIONS(2009),
    [anon_sym_override] = ACTIONS(2009),
    [anon_sym_module] = ACTIONS(2009),
    [anon_sym_any] = ACTIONS(2009),
    [anon_sym_number] = ACTIONS(2009),
    [anon_sym_boolean] = ACTIONS(2009),
    [anon_sym_string] = ACTIONS(2009),
    [anon_sym_symbol] = ACTIONS(2009),
    [anon_sym_abstract] = ACTIONS(2009),
    [anon_sym_extends] = ACTIONS(2009),
    [anon_sym_interface] = ACTIONS(2009),
    [anon_sym_enum] = ACTIONS(2009),
  },
  [562] = {
    [aux_sym_object_repeat1] = STATE(3702),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_export] = ACTIONS(1712),
    [anon_sym_STAR] = ACTIONS(1712),
    [anon_sym_type] = ACTIONS(1712),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1712),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1714),
    [anon_sym_SQUOTE] = ACTIONS(1714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1714),
    [sym_private_property_identifier] = ACTIONS(1714),
    [anon_sym_static] = ACTIONS(1712),
    [anon_sym_readonly] = ACTIONS(1712),
    [anon_sym_get] = ACTIONS(1712),
    [anon_sym_set] = ACTIONS(1712),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1712),
    [anon_sym_public] = ACTIONS(1712),
    [anon_sym_private] = ACTIONS(1712),
    [anon_sym_protected] = ACTIONS(1712),
    [anon_sym_override] = ACTIONS(1712),
    [anon_sym_module] = ACTIONS(1712),
    [anon_sym_any] = ACTIONS(1712),
    [anon_sym_number] = ACTIONS(1712),
    [anon_sym_boolean] = ACTIONS(1712),
    [anon_sym_string] = ACTIONS(1712),
    [anon_sym_symbol] = ACTIONS(1712),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [563] = {
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1690),
    [sym_private_property_identifier] = ACTIONS(1690),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_readonly] = ACTIONS(1688),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_override] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [564] = {
    [aux_sym_object_repeat1] = STATE(3702),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1690),
    [sym_private_property_identifier] = ACTIONS(1690),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_readonly] = ACTIONS(1688),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_override] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [565] = {
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1690),
    [sym_private_property_identifier] = ACTIONS(1690),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_readonly] = ACTIONS(1688),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_override] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [566] = {
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_export] = ACTIONS(1712),
    [anon_sym_STAR] = ACTIONS(1712),
    [anon_sym_type] = ACTIONS(1712),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1712),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1714),
    [anon_sym_SQUOTE] = ACTIONS(1714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1714),
    [sym_private_property_identifier] = ACTIONS(1714),
    [anon_sym_static] = ACTIONS(1712),
    [anon_sym_readonly] = ACTIONS(1712),
    [anon_sym_get] = ACTIONS(1712),
    [anon_sym_set] = ACTIONS(1712),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1712),
    [anon_sym_public] = ACTIONS(1712),
    [anon_sym_private] = ACTIONS(1712),
    [anon_sym_protected] = ACTIONS(1712),
    [anon_sym_override] = ACTIONS(1712),
    [anon_sym_module] = ACTIONS(1712),
    [anon_sym_any] = ACTIONS(1712),
    [anon_sym_number] = ACTIONS(1712),
    [anon_sym_boolean] = ACTIONS(1712),
    [anon_sym_string] = ACTIONS(1712),
    [anon_sym_symbol] = ACTIONS(1712),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [567] = {
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_export] = ACTIONS(1712),
    [anon_sym_STAR] = ACTIONS(1712),
    [anon_sym_type] = ACTIONS(1712),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(1712),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(116),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1714),
    [anon_sym_SQUOTE] = ACTIONS(1714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [sym_number] = ACTIONS(1714),
    [sym_private_property_identifier] = ACTIONS(1714),
    [anon_sym_static] = ACTIONS(1712),
    [anon_sym_readonly] = ACTIONS(1712),
    [anon_sym_get] = ACTIONS(1712),
    [anon_sym_set] = ACTIONS(1712),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1712),
    [anon_sym_public] = ACTIONS(1712),
    [anon_sym_private] = ACTIONS(1712),
    [anon_sym_protected] = ACTIONS(1712),
    [anon_sym_override] = ACTIONS(1712),
    [anon_sym_module] = ACTIONS(1712),
    [anon_sym_any] = ACTIONS(1712),
    [anon_sym_number] = ACTIONS(1712),
    [anon_sym_boolean] = ACTIONS(1712),
    [anon_sym_string] = ACTIONS(1712),
    [anon_sym_symbol] = ACTIONS(1712),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [568] = {
    [sym__call_signature] = STATE(4482),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_export] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(210),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2013),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2013),
    [anon_sym_readonly] = ACTIONS(2013),
    [anon_sym_get] = ACTIONS(2013),
    [anon_sym_set] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(2013),
    [anon_sym_public] = ACTIONS(2013),
    [anon_sym_private] = ACTIONS(2013),
    [anon_sym_protected] = ACTIONS(2013),
    [anon_sym_override] = ACTIONS(2013),
    [anon_sym_module] = ACTIONS(2013),
    [anon_sym_any] = ACTIONS(2013),
    [anon_sym_number] = ACTIONS(2013),
    [anon_sym_boolean] = ACTIONS(2013),
    [anon_sym_string] = ACTIONS(2013),
    [anon_sym_symbol] = ACTIONS(2013),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [569] = {
    [sym__call_signature] = STATE(4149),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2023),
    [anon_sym_export] = ACTIONS(2025),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2025),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2025),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2025),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2025),
    [anon_sym_readonly] = ACTIONS(2025),
    [anon_sym_get] = ACTIONS(2025),
    [anon_sym_set] = ACTIONS(2025),
    [anon_sym_QMARK] = ACTIONS(2027),
    [anon_sym_declare] = ACTIONS(2025),
    [anon_sym_public] = ACTIONS(2025),
    [anon_sym_private] = ACTIONS(2025),
    [anon_sym_protected] = ACTIONS(2025),
    [anon_sym_override] = ACTIONS(2025),
    [anon_sym_module] = ACTIONS(2025),
    [anon_sym_any] = ACTIONS(2025),
    [anon_sym_number] = ACTIONS(2025),
    [anon_sym_boolean] = ACTIONS(2025),
    [anon_sym_string] = ACTIONS(2025),
    [anon_sym_symbol] = ACTIONS(2025),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [570] = {
    [sym__call_signature] = STATE(4149),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2023),
    [anon_sym_export] = ACTIONS(2025),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2025),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2025),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_RBRACE] = ACTIONS(122),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(122),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2025),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2025),
    [anon_sym_readonly] = ACTIONS(2025),
    [anon_sym_get] = ACTIONS(2025),
    [anon_sym_set] = ACTIONS(2025),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(2025),
    [anon_sym_public] = ACTIONS(2025),
    [anon_sym_private] = ACTIONS(2025),
    [anon_sym_protected] = ACTIONS(2025),
    [anon_sym_override] = ACTIONS(2025),
    [anon_sym_module] = ACTIONS(2025),
    [anon_sym_any] = ACTIONS(2025),
    [anon_sym_number] = ACTIONS(2025),
    [anon_sym_boolean] = ACTIONS(2025),
    [anon_sym_string] = ACTIONS(2025),
    [anon_sym_symbol] = ACTIONS(2025),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [571] = {
    [sym__call_signature] = STATE(4482),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_export] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(1228),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_RPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2013),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2013),
    [anon_sym_readonly] = ACTIONS(2013),
    [anon_sym_get] = ACTIONS(2013),
    [anon_sym_set] = ACTIONS(2013),
    [anon_sym_declare] = ACTIONS(2013),
    [anon_sym_public] = ACTIONS(2013),
    [anon_sym_private] = ACTIONS(2013),
    [anon_sym_protected] = ACTIONS(2013),
    [anon_sym_override] = ACTIONS(2013),
    [anon_sym_module] = ACTIONS(2013),
    [anon_sym_any] = ACTIONS(2013),
    [anon_sym_number] = ACTIONS(2013),
    [anon_sym_boolean] = ACTIONS(2013),
    [anon_sym_string] = ACTIONS(2013),
    [anon_sym_symbol] = ACTIONS(2013),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [572] = {
    [sym__call_signature] = STATE(4482),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_export] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_RPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2013),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2013),
    [anon_sym_readonly] = ACTIONS(2013),
    [anon_sym_get] = ACTIONS(2013),
    [anon_sym_set] = ACTIONS(2013),
    [anon_sym_declare] = ACTIONS(2013),
    [anon_sym_public] = ACTIONS(2013),
    [anon_sym_private] = ACTIONS(2013),
    [anon_sym_protected] = ACTIONS(2013),
    [anon_sym_override] = ACTIONS(2013),
    [anon_sym_module] = ACTIONS(2013),
    [anon_sym_any] = ACTIONS(2013),
    [anon_sym_number] = ACTIONS(2013),
    [anon_sym_boolean] = ACTIONS(2013),
    [anon_sym_string] = ACTIONS(2013),
    [anon_sym_symbol] = ACTIONS(2013),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [573] = {
    [sym__call_signature] = STATE(4373),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1919),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(1939),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_readonly] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_override] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_any] = ACTIONS(2031),
    [anon_sym_number] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [574] = {
    [sym__call_signature] = STATE(4373),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2033),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_readonly] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_override] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_any] = ACTIONS(2031),
    [anon_sym_number] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [575] = {
    [sym__call_signature] = STATE(4373),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2035),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_readonly] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_override] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_any] = ACTIONS(2031),
    [anon_sym_number] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [576] = {
    [sym__call_signature] = STATE(4373),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(2037),
    [anon_sym_of] = ACTIONS(2040),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2033),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_readonly] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_override] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_any] = ACTIONS(2031),
    [anon_sym_number] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [577] = {
    [sym__call_signature] = STATE(4423),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_export] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2044),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2044),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_of] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2044),
    [anon_sym_function] = ACTIONS(2033),
    [anon_sym_EQ_GT] = ACTIONS(1260),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_readonly] = ACTIONS(2044),
    [anon_sym_get] = ACTIONS(2044),
    [anon_sym_set] = ACTIONS(2044),
    [anon_sym_declare] = ACTIONS(2044),
    [anon_sym_public] = ACTIONS(2044),
    [anon_sym_private] = ACTIONS(2044),
    [anon_sym_protected] = ACTIONS(2044),
    [anon_sym_override] = ACTIONS(2044),
    [anon_sym_module] = ACTIONS(2044),
    [anon_sym_any] = ACTIONS(2044),
    [anon_sym_number] = ACTIONS(2044),
    [anon_sym_boolean] = ACTIONS(2044),
    [anon_sym_string] = ACTIONS(2044),
    [anon_sym_symbol] = ACTIONS(2044),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [578] = {
    [sym__call_signature] = STATE(4423),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_export] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2044),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2044),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_of] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2044),
    [anon_sym_function] = ACTIONS(2033),
    [anon_sym_EQ_GT] = ACTIONS(1260),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_readonly] = ACTIONS(2044),
    [anon_sym_get] = ACTIONS(2044),
    [anon_sym_set] = ACTIONS(2044),
    [anon_sym_declare] = ACTIONS(2044),
    [anon_sym_public] = ACTIONS(2044),
    [anon_sym_private] = ACTIONS(2044),
    [anon_sym_protected] = ACTIONS(2044),
    [anon_sym_override] = ACTIONS(2044),
    [anon_sym_module] = ACTIONS(2044),
    [anon_sym_any] = ACTIONS(2044),
    [anon_sym_number] = ACTIONS(2044),
    [anon_sym_boolean] = ACTIONS(2044),
    [anon_sym_string] = ACTIONS(2044),
    [anon_sym_symbol] = ACTIONS(2044),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [579] = {
    [sym__call_signature] = STATE(4373),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2035),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_readonly] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_override] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_any] = ACTIONS(2031),
    [anon_sym_number] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [580] = {
    [sym__call_signature] = STATE(4373),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2033),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_readonly] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_override] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_any] = ACTIONS(2031),
    [anon_sym_number] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [581] = {
    [sym__call_signature] = STATE(4482),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_export] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(1228),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(1270),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2013),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2013),
    [anon_sym_readonly] = ACTIONS(2013),
    [anon_sym_get] = ACTIONS(2013),
    [anon_sym_set] = ACTIONS(2013),
    [anon_sym_declare] = ACTIONS(2013),
    [anon_sym_public] = ACTIONS(2013),
    [anon_sym_private] = ACTIONS(2013),
    [anon_sym_protected] = ACTIONS(2013),
    [anon_sym_override] = ACTIONS(2013),
    [anon_sym_module] = ACTIONS(2013),
    [anon_sym_any] = ACTIONS(2013),
    [anon_sym_number] = ACTIONS(2013),
    [anon_sym_boolean] = ACTIONS(2013),
    [anon_sym_string] = ACTIONS(2013),
    [anon_sym_symbol] = ACTIONS(2013),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(1445),
    [sym_identifier] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1447),
    [anon_sym_default] = ACTIONS(1447),
    [anon_sym_type] = ACTIONS(1447),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_typeof] = ACTIONS(1447),
    [anon_sym_import] = ACTIONS(1447),
    [anon_sym_var] = ACTIONS(1447),
    [anon_sym_let] = ACTIONS(1447),
    [anon_sym_const] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_await] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_do] = ACTIONS(1447),
    [anon_sym_try] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1447),
    [anon_sym_break] = ACTIONS(1447),
    [anon_sym_continue] = ACTIONS(1447),
    [anon_sym_debugger] = ACTIONS(1447),
    [anon_sym_return] = ACTIONS(1447),
    [anon_sym_throw] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1447),
    [anon_sym_catch] = ACTIONS(1447),
    [anon_sym_finally] = ACTIONS(1447),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [anon_sym_LTtemplate_GT] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_SLASH] = ACTIONS(1447),
    [anon_sym_class] = ACTIONS(1447),
    [anon_sym_async] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_new] = ACTIONS(1447),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1445),
    [anon_sym_void] = ACTIONS(1447),
    [anon_sym_delete] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1445),
    [anon_sym_DASH_DASH] = ACTIONS(1445),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1445),
    [sym_number] = ACTIONS(1445),
    [sym_this] = ACTIONS(1447),
    [sym_super] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_undefined] = ACTIONS(1447),
    [anon_sym_AT] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1447),
    [anon_sym_readonly] = ACTIONS(1447),
    [anon_sym_get] = ACTIONS(1447),
    [anon_sym_set] = ACTIONS(1447),
    [anon_sym_declare] = ACTIONS(1447),
    [anon_sym_public] = ACTIONS(1447),
    [anon_sym_private] = ACTIONS(1447),
    [anon_sym_protected] = ACTIONS(1447),
    [anon_sym_override] = ACTIONS(1447),
    [anon_sym_module] = ACTIONS(1447),
    [anon_sym_any] = ACTIONS(1447),
    [anon_sym_number] = ACTIONS(1447),
    [anon_sym_boolean] = ACTIONS(1447),
    [anon_sym_string] = ACTIONS(1447),
    [anon_sym_symbol] = ACTIONS(1447),
    [anon_sym_abstract] = ACTIONS(1447),
    [anon_sym_interface] = ACTIONS(1447),
    [anon_sym_enum] = ACTIONS(1447),
    [sym__automatic_semicolon] = ACTIONS(2046),
  },
  [583] = {
    [sym__call_signature] = STATE(4113),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_export] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(1266),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(1268),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2050),
    [anon_sym_readonly] = ACTIONS(2050),
    [anon_sym_get] = ACTIONS(2050),
    [anon_sym_set] = ACTIONS(2050),
    [anon_sym_declare] = ACTIONS(2050),
    [anon_sym_public] = ACTIONS(2050),
    [anon_sym_private] = ACTIONS(2050),
    [anon_sym_protected] = ACTIONS(2050),
    [anon_sym_override] = ACTIONS(2050),
    [anon_sym_module] = ACTIONS(2050),
    [anon_sym_any] = ACTIONS(2050),
    [anon_sym_number] = ACTIONS(2050),
    [anon_sym_boolean] = ACTIONS(2050),
    [anon_sym_string] = ACTIONS(2050),
    [anon_sym_symbol] = ACTIONS(2050),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [584] = {
    [sym_catch_clause] = STATE(608),
    [sym_finally_clause] = STATE(681),
    [ts_builtin_sym_end] = ACTIONS(2052),
    [sym_identifier] = ACTIONS(2054),
    [anon_sym_export] = ACTIONS(2054),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_type] = ACTIONS(2054),
    [anon_sym_namespace] = ACTIONS(2054),
    [anon_sym_LBRACE] = ACTIONS(2052),
    [anon_sym_RBRACE] = ACTIONS(2052),
    [anon_sym_typeof] = ACTIONS(2054),
    [anon_sym_import] = ACTIONS(2054),
    [anon_sym_var] = ACTIONS(2054),
    [anon_sym_let] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_BANG] = ACTIONS(2052),
    [anon_sym_else] = ACTIONS(2054),
    [anon_sym_if] = ACTIONS(2054),
    [anon_sym_switch] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [anon_sym_await] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2054),
    [anon_sym_do] = ACTIONS(2054),
    [anon_sym_try] = ACTIONS(2054),
    [anon_sym_with] = ACTIONS(2054),
    [anon_sym_break] = ACTIONS(2054),
    [anon_sym_continue] = ACTIONS(2054),
    [anon_sym_debugger] = ACTIONS(2054),
    [anon_sym_return] = ACTIONS(2054),
    [anon_sym_throw] = ACTIONS(2054),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_case] = ACTIONS(2054),
    [anon_sym_catch] = ACTIONS(2056),
    [anon_sym_finally] = ACTIONS(2058),
    [anon_sym_yield] = ACTIONS(2054),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_LTtemplate_GT] = ACTIONS(2052),
    [anon_sym_LT] = ACTIONS(2054),
    [anon_sym_SLASH] = ACTIONS(2054),
    [anon_sym_class] = ACTIONS(2054),
    [anon_sym_async] = ACTIONS(2054),
    [anon_sym_function] = ACTIONS(2054),
    [anon_sym_new] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2054),
    [anon_sym_TILDE] = ACTIONS(2052),
    [anon_sym_void] = ACTIONS(2054),
    [anon_sym_delete] = ACTIONS(2054),
    [anon_sym_PLUS_PLUS] = ACTIONS(2052),
    [anon_sym_DASH_DASH] = ACTIONS(2052),
    [anon_sym_DQUOTE] = ACTIONS(2052),
    [anon_sym_SQUOTE] = ACTIONS(2052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2052),
    [sym_number] = ACTIONS(2052),
    [sym_this] = ACTIONS(2054),
    [sym_super] = ACTIONS(2054),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_undefined] = ACTIONS(2054),
    [anon_sym_AT] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_readonly] = ACTIONS(2054),
    [anon_sym_get] = ACTIONS(2054),
    [anon_sym_set] = ACTIONS(2054),
    [anon_sym_declare] = ACTIONS(2054),
    [anon_sym_public] = ACTIONS(2054),
    [anon_sym_private] = ACTIONS(2054),
    [anon_sym_protected] = ACTIONS(2054),
    [anon_sym_override] = ACTIONS(2054),
    [anon_sym_module] = ACTIONS(2054),
    [anon_sym_any] = ACTIONS(2054),
    [anon_sym_number] = ACTIONS(2054),
    [anon_sym_boolean] = ACTIONS(2054),
    [anon_sym_string] = ACTIONS(2054),
    [anon_sym_symbol] = ACTIONS(2054),
    [anon_sym_abstract] = ACTIONS(2054),
    [anon_sym_interface] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
  },
  [585] = {
    [sym__call_signature] = STATE(4352),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2062),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2062),
    [anon_sym_LBRACE] = ACTIONS(152),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2062),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2062),
    [anon_sym_readonly] = ACTIONS(2062),
    [anon_sym_get] = ACTIONS(2062),
    [anon_sym_set] = ACTIONS(2062),
    [anon_sym_declare] = ACTIONS(2062),
    [anon_sym_public] = ACTIONS(2062),
    [anon_sym_private] = ACTIONS(2062),
    [anon_sym_protected] = ACTIONS(2062),
    [anon_sym_override] = ACTIONS(2062),
    [anon_sym_module] = ACTIONS(2062),
    [anon_sym_any] = ACTIONS(2062),
    [anon_sym_number] = ACTIONS(2062),
    [anon_sym_boolean] = ACTIONS(2062),
    [anon_sym_string] = ACTIONS(2062),
    [anon_sym_symbol] = ACTIONS(2062),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_implements] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(1419),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_export] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_type] = ACTIONS(1421),
    [anon_sym_namespace] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1419),
    [anon_sym_COMMA] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1419),
    [anon_sym_typeof] = ACTIONS(1421),
    [anon_sym_import] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1421),
    [anon_sym_let] = ACTIONS(1421),
    [anon_sym_const] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_else] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1421),
    [anon_sym_for] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_await] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(1421),
    [anon_sym_do] = ACTIONS(1421),
    [anon_sym_try] = ACTIONS(1421),
    [anon_sym_with] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1421),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_debugger] = ACTIONS(1421),
    [anon_sym_return] = ACTIONS(1421),
    [anon_sym_throw] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1419),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_catch] = ACTIONS(1421),
    [anon_sym_finally] = ACTIONS(1421),
    [anon_sym_yield] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1419),
    [anon_sym_LTtemplate_GT] = ACTIONS(1419),
    [anon_sym_LT] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(1421),
    [anon_sym_class] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1421),
    [anon_sym_function] = ACTIONS(1421),
    [anon_sym_new] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_void] = ACTIONS(1421),
    [anon_sym_delete] = ACTIONS(1421),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_DQUOTE] = ACTIONS(1419),
    [anon_sym_SQUOTE] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1419),
    [sym_this] = ACTIONS(1421),
    [sym_super] = ACTIONS(1421),
    [sym_true] = ACTIONS(1421),
    [sym_false] = ACTIONS(1421),
    [sym_null] = ACTIONS(1421),
    [sym_undefined] = ACTIONS(1421),
    [anon_sym_AT] = ACTIONS(1419),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_readonly] = ACTIONS(1421),
    [anon_sym_get] = ACTIONS(1421),
    [anon_sym_set] = ACTIONS(1421),
    [anon_sym_declare] = ACTIONS(1421),
    [anon_sym_public] = ACTIONS(1421),
    [anon_sym_private] = ACTIONS(1421),
    [anon_sym_protected] = ACTIONS(1421),
    [anon_sym_override] = ACTIONS(1421),
    [anon_sym_module] = ACTIONS(1421),
    [anon_sym_any] = ACTIONS(1421),
    [anon_sym_number] = ACTIONS(1421),
    [anon_sym_boolean] = ACTIONS(1421),
    [anon_sym_string] = ACTIONS(1421),
    [anon_sym_symbol] = ACTIONS(1421),
    [anon_sym_abstract] = ACTIONS(1421),
    [anon_sym_interface] = ACTIONS(1421),
    [anon_sym_enum] = ACTIONS(1421),
    [sym__automatic_semicolon] = ACTIONS(1429),
  },
  [587] = {
    [sym__call_signature] = STATE(4113),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_export] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(2064),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(1268),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2050),
    [anon_sym_readonly] = ACTIONS(2050),
    [anon_sym_get] = ACTIONS(2050),
    [anon_sym_set] = ACTIONS(2050),
    [anon_sym_declare] = ACTIONS(2050),
    [anon_sym_public] = ACTIONS(2050),
    [anon_sym_private] = ACTIONS(2050),
    [anon_sym_protected] = ACTIONS(2050),
    [anon_sym_override] = ACTIONS(2050),
    [anon_sym_module] = ACTIONS(2050),
    [anon_sym_any] = ACTIONS(2050),
    [anon_sym_number] = ACTIONS(2050),
    [anon_sym_boolean] = ACTIONS(2050),
    [anon_sym_string] = ACTIONS(2050),
    [anon_sym_symbol] = ACTIONS(2050),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [588] = {
    [sym__call_signature] = STATE(4352),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2062),
    [anon_sym_EQ] = ACTIONS(1279),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2062),
    [anon_sym_LBRACE] = ACTIONS(152),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2062),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2062),
    [anon_sym_readonly] = ACTIONS(2062),
    [anon_sym_get] = ACTIONS(2062),
    [anon_sym_set] = ACTIONS(2062),
    [anon_sym_declare] = ACTIONS(2062),
    [anon_sym_public] = ACTIONS(2062),
    [anon_sym_private] = ACTIONS(2062),
    [anon_sym_protected] = ACTIONS(2062),
    [anon_sym_override] = ACTIONS(2062),
    [anon_sym_module] = ACTIONS(2062),
    [anon_sym_any] = ACTIONS(2062),
    [anon_sym_number] = ACTIONS(2062),
    [anon_sym_boolean] = ACTIONS(2062),
    [anon_sym_string] = ACTIONS(2062),
    [anon_sym_symbol] = ACTIONS(2062),
    [anon_sym_satisfies] = ACTIONS(116),
    [anon_sym_implements] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [589] = {
    [sym__call_signature] = STATE(4113),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_export] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(1268),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2050),
    [anon_sym_readonly] = ACTIONS(2050),
    [anon_sym_get] = ACTIONS(2050),
    [anon_sym_set] = ACTIONS(2050),
    [anon_sym_declare] = ACTIONS(2050),
    [anon_sym_public] = ACTIONS(2050),
    [anon_sym_private] = ACTIONS(2050),
    [anon_sym_protected] = ACTIONS(2050),
    [anon_sym_override] = ACTIONS(2050),
    [anon_sym_module] = ACTIONS(2050),
    [anon_sym_any] = ACTIONS(2050),
    [anon_sym_number] = ACTIONS(2050),
    [anon_sym_boolean] = ACTIONS(2050),
    [anon_sym_string] = ACTIONS(2050),
    [anon_sym_symbol] = ACTIONS(2050),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [590] = {
    [sym__call_signature] = STATE(4234),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_function] = ACTIONS(1939),
    [anon_sym_EQ_GT] = ACTIONS(1277),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_readonly] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_override] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_any] = ACTIONS(2071),
    [anon_sym_number] = ACTIONS(2071),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_symbol] = ACTIONS(2071),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [anon_sym_export] = ACTIONS(1588),
    [anon_sym_default] = ACTIONS(1588),
    [anon_sym_type] = ACTIONS(1588),
    [anon_sym_namespace] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_COMMA] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_typeof] = ACTIONS(1588),
    [anon_sym_import] = ACTIONS(1588),
    [anon_sym_var] = ACTIONS(1588),
    [anon_sym_let] = ACTIONS(1588),
    [anon_sym_const] = ACTIONS(1588),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_switch] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1586),
    [anon_sym_await] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_try] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_break] = ACTIONS(1588),
    [anon_sym_continue] = ACTIONS(1588),
    [anon_sym_debugger] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_throw] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym_case] = ACTIONS(1588),
    [anon_sym_yield] = ACTIONS(1588),
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_LTtemplate_GT] = ACTIONS(1586),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_SLASH] = ACTIONS(1588),
    [anon_sym_class] = ACTIONS(1588),
    [anon_sym_async] = ACTIONS(1588),
    [anon_sym_function] = ACTIONS(1588),
    [anon_sym_new] = ACTIONS(1588),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1586),
    [sym_number] = ACTIONS(1586),
    [sym_this] = ACTIONS(1588),
    [sym_super] = ACTIONS(1588),
    [sym_true] = ACTIONS(1588),
    [sym_false] = ACTIONS(1588),
    [sym_null] = ACTIONS(1588),
    [sym_undefined] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(1586),
    [anon_sym_static] = ACTIONS(1588),
    [anon_sym_readonly] = ACTIONS(1588),
    [anon_sym_get] = ACTIONS(1588),
    [anon_sym_set] = ACTIONS(1588),
    [anon_sym_declare] = ACTIONS(1588),
    [anon_sym_public] = ACTIONS(1588),
    [anon_sym_private] = ACTIONS(1588),
    [anon_sym_protected] = ACTIONS(1588),
    [anon_sym_override] = ACTIONS(1588),
    [anon_sym_module] = ACTIONS(1588),
    [anon_sym_any] = ACTIONS(1588),
    [anon_sym_number] = ACTIONS(1588),
    [anon_sym_boolean] = ACTIONS(1588),
    [anon_sym_string] = ACTIONS(1588),
    [anon_sym_symbol] = ACTIONS(1588),
    [anon_sym_abstract] = ACTIONS(1588),
    [anon_sym_interface] = ACTIONS(1588),
    [anon_sym_enum] = ACTIONS(1588),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1586),
    [sym__automatic_semicolon] = ACTIONS(1586),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(1471),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [anon_sym_typeof] = ACTIONS(1473),
    [anon_sym_import] = ACTIONS(1473),
    [anon_sym_var] = ACTIONS(1473),
    [anon_sym_let] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(1471),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(1471),
    [anon_sym_await] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_try] = ACTIONS(1473),
    [anon_sym_with] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_debugger] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_throw] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1471),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_yield] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1471),
    [anon_sym_LTtemplate_GT] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_SLASH] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(1473),
    [anon_sym_new] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_TILDE] = ACTIONS(1471),
    [anon_sym_void] = ACTIONS(1473),
    [anon_sym_delete] = ACTIONS(1473),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(1471),
    [anon_sym_SQUOTE] = ACTIONS(1471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [sym_number] = ACTIONS(1471),
    [sym_this] = ACTIONS(1473),
    [sym_super] = ACTIONS(1473),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [sym_null] = ACTIONS(1473),
    [sym_undefined] = ACTIONS(1473),
    [anon_sym_AT] = ACTIONS(1471),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_override] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [anon_sym_abstract] = ACTIONS(1473),
    [anon_sym_interface] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1471),
    [sym__automatic_semicolon] = ACTIONS(1471),
  },
  [593] = {
    [sym__call_signature] = STATE(4113),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_export] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(2064),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(1268),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2050),
    [anon_sym_readonly] = ACTIONS(2050),
    [anon_sym_get] = ACTIONS(2050),
    [anon_sym_set] = ACTIONS(2050),
    [anon_sym_declare] = ACTIONS(2050),
    [anon_sym_public] = ACTIONS(2050),
    [anon_sym_private] = ACTIONS(2050),
    [anon_sym_protected] = ACTIONS(2050),
    [anon_sym_override] = ACTIONS(2050),
    [anon_sym_module] = ACTIONS(2050),
    [anon_sym_any] = ACTIONS(2050),
    [anon_sym_number] = ACTIONS(2050),
    [anon_sym_boolean] = ACTIONS(2050),
    [anon_sym_string] = ACTIONS(2050),
    [anon_sym_symbol] = ACTIONS(2050),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [594] = {
    [sym__call_signature] = STATE(4234),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_function] = ACTIONS(2033),
    [anon_sym_EQ_GT] = ACTIONS(1277),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_readonly] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_override] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_any] = ACTIONS(2071),
    [anon_sym_number] = ACTIONS(2071),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_symbol] = ACTIONS(2071),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [595] = {
    [sym__call_signature] = STATE(4234),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_function] = ACTIONS(2073),
    [anon_sym_EQ_GT] = ACTIONS(1277),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_readonly] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_override] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_any] = ACTIONS(2071),
    [anon_sym_number] = ACTIONS(2071),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_symbol] = ACTIONS(2071),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [596] = {
    [sym__call_signature] = STATE(4234),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_function] = ACTIONS(2033),
    [anon_sym_EQ_GT] = ACTIONS(1277),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_readonly] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_override] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_any] = ACTIONS(2071),
    [anon_sym_number] = ACTIONS(2071),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_symbol] = ACTIONS(2071),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(1445),
    [sym_identifier] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1447),
    [anon_sym_default] = ACTIONS(1447),
    [anon_sym_type] = ACTIONS(1447),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_typeof] = ACTIONS(1447),
    [anon_sym_import] = ACTIONS(1447),
    [anon_sym_var] = ACTIONS(1447),
    [anon_sym_let] = ACTIONS(1447),
    [anon_sym_const] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_await] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_do] = ACTIONS(1447),
    [anon_sym_try] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1447),
    [anon_sym_break] = ACTIONS(1447),
    [anon_sym_continue] = ACTIONS(1447),
    [anon_sym_debugger] = ACTIONS(1447),
    [anon_sym_return] = ACTIONS(1447),
    [anon_sym_throw] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1447),
    [anon_sym_catch] = ACTIONS(1447),
    [anon_sym_finally] = ACTIONS(1447),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [anon_sym_LTtemplate_GT] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_SLASH] = ACTIONS(1447),
    [anon_sym_class] = ACTIONS(1447),
    [anon_sym_async] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_new] = ACTIONS(1447),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1445),
    [anon_sym_void] = ACTIONS(1447),
    [anon_sym_delete] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1445),
    [anon_sym_DASH_DASH] = ACTIONS(1445),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1445),
    [sym_number] = ACTIONS(1445),
    [sym_this] = ACTIONS(1447),
    [sym_super] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_undefined] = ACTIONS(1447),
    [anon_sym_AT] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1447),
    [anon_sym_readonly] = ACTIONS(1447),
    [anon_sym_get] = ACTIONS(1447),
    [anon_sym_set] = ACTIONS(1447),
    [anon_sym_declare] = ACTIONS(1447),
    [anon_sym_public] = ACTIONS(1447),
    [anon_sym_private] = ACTIONS(1447),
    [anon_sym_protected] = ACTIONS(1447),
    [anon_sym_override] = ACTIONS(1447),
    [anon_sym_module] = ACTIONS(1447),
    [anon_sym_any] = ACTIONS(1447),
    [anon_sym_number] = ACTIONS(1447),
    [anon_sym_boolean] = ACTIONS(1447),
    [anon_sym_string] = ACTIONS(1447),
    [anon_sym_symbol] = ACTIONS(1447),
    [anon_sym_abstract] = ACTIONS(1447),
    [anon_sym_interface] = ACTIONS(1447),
    [anon_sym_enum] = ACTIONS(1447),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(1445),
    [sym_identifier] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1447),
    [anon_sym_default] = ACTIONS(1447),
    [anon_sym_type] = ACTIONS(1447),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_typeof] = ACTIONS(1447),
    [anon_sym_import] = ACTIONS(1447),
    [anon_sym_var] = ACTIONS(1447),
    [anon_sym_let] = ACTIONS(1447),
    [anon_sym_const] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_await] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_do] = ACTIONS(1447),
    [anon_sym_try] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1447),
    [anon_sym_break] = ACTIONS(1447),
    [anon_sym_continue] = ACTIONS(1447),
    [anon_sym_debugger] = ACTIONS(1447),
    [anon_sym_return] = ACTIONS(1447),
    [anon_sym_throw] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1447),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [anon_sym_LTtemplate_GT] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_SLASH] = ACTIONS(1447),
    [anon_sym_class] = ACTIONS(1447),
    [anon_sym_async] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_new] = ACTIONS(1447),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1445),
    [anon_sym_void] = ACTIONS(1447),
    [anon_sym_delete] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1445),
    [anon_sym_DASH_DASH] = ACTIONS(1445),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1445),
    [sym_number] = ACTIONS(1445),
    [sym_this] = ACTIONS(1447),
    [sym_super] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_undefined] = ACTIONS(1447),
    [anon_sym_AT] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1447),
    [anon_sym_readonly] = ACTIONS(1447),
    [anon_sym_get] = ACTIONS(1447),
    [anon_sym_set] = ACTIONS(1447),
    [anon_sym_declare] = ACTIONS(1447),
    [anon_sym_public] = ACTIONS(1447),
    [anon_sym_private] = ACTIONS(1447),
    [anon_sym_protected] = ACTIONS(1447),
    [anon_sym_override] = ACTIONS(1447),
    [anon_sym_module] = ACTIONS(1447),
    [anon_sym_any] = ACTIONS(1447),
    [anon_sym_number] = ACTIONS(1447),
    [anon_sym_boolean] = ACTIONS(1447),
    [anon_sym_string] = ACTIONS(1447),
    [anon_sym_symbol] = ACTIONS(1447),
    [anon_sym_abstract] = ACTIONS(1447),
    [anon_sym_interface] = ACTIONS(1447),
    [anon_sym_enum] = ACTIONS(1447),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1445),
    [sym__automatic_semicolon] = ACTIONS(1445),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(1485),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_RBRACE] = ACTIONS(1485),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_import] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1485),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_await] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_try] = ACTIONS(1487),
    [anon_sym_with] = ACTIONS(1487),
    [anon_sym_break] = ACTIONS(1487),
    [anon_sym_continue] = ACTIONS(1487),
    [anon_sym_debugger] = ACTIONS(1487),
    [anon_sym_return] = ACTIONS(1487),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_case] = ACTIONS(1487),
    [anon_sym_catch] = ACTIONS(1487),
    [anon_sym_finally] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [anon_sym_LTtemplate_GT] = ACTIONS(1485),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_class] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_new] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1485),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_DQUOTE] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1485),
    [sym_number] = ACTIONS(1485),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_interface] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(1445),
    [sym_identifier] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1447),
    [anon_sym_default] = ACTIONS(1447),
    [anon_sym_type] = ACTIONS(1447),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_typeof] = ACTIONS(1447),
    [anon_sym_import] = ACTIONS(1447),
    [anon_sym_var] = ACTIONS(1447),
    [anon_sym_let] = ACTIONS(1447),
    [anon_sym_const] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1445),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_await] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_do] = ACTIONS(1447),
    [anon_sym_try] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1447),
    [anon_sym_break] = ACTIONS(1447),
    [anon_sym_continue] = ACTIONS(1447),
    [anon_sym_debugger] = ACTIONS(1447),
    [anon_sym_return] = ACTIONS(1447),
    [anon_sym_throw] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1447),
    [anon_sym_yield] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [anon_sym_LTtemplate_GT] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_SLASH] = ACTIONS(1447),
    [anon_sym_class] = ACTIONS(1447),
    [anon_sym_async] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_new] = ACTIONS(1447),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1445),
    [anon_sym_void] = ACTIONS(1447),
    [anon_sym_delete] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1445),
    [anon_sym_DASH_DASH] = ACTIONS(1445),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1445),
    [sym_number] = ACTIONS(1445),
    [sym_this] = ACTIONS(1447),
    [sym_super] = ACTIONS(1447),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_undefined] = ACTIONS(1447),
    [anon_sym_AT] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1447),
    [anon_sym_readonly] = ACTIONS(1447),
    [anon_sym_get] = ACTIONS(1447),
    [anon_sym_set] = ACTIONS(1447),
    [anon_sym_declare] = ACTIONS(1447),
    [anon_sym_public] = ACTIONS(1447),
    [anon_sym_private] = ACTIONS(1447),
    [anon_sym_protected] = ACTIONS(1447),
    [anon_sym_override] = ACTIONS(1447),
    [anon_sym_module] = ACTIONS(1447),
    [anon_sym_any] = ACTIONS(1447),
    [anon_sym_number] = ACTIONS(1447),
    [anon_sym_boolean] = ACTIONS(1447),
    [anon_sym_string] = ACTIONS(1447),
    [anon_sym_symbol] = ACTIONS(1447),
    [anon_sym_abstract] = ACTIONS(1447),
    [anon_sym_interface] = ACTIONS(1447),
    [anon_sym_enum] = ACTIONS(1447),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1445),
    [sym__automatic_semicolon] = ACTIONS(2075),
  },
  [601] = {
    [sym__call_signature] = STATE(4113),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_export] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(1266),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2050),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(1268),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2050),
    [anon_sym_readonly] = ACTIONS(2050),
    [anon_sym_get] = ACTIONS(2050),
    [anon_sym_set] = ACTIONS(2050),
    [anon_sym_declare] = ACTIONS(2050),
    [anon_sym_public] = ACTIONS(2050),
    [anon_sym_private] = ACTIONS(2050),
    [anon_sym_protected] = ACTIONS(2050),
    [anon_sym_override] = ACTIONS(2050),
    [anon_sym_module] = ACTIONS(2050),
    [anon_sym_any] = ACTIONS(2050),
    [anon_sym_number] = ACTIONS(2050),
    [anon_sym_boolean] = ACTIONS(2050),
    [anon_sym_string] = ACTIONS(2050),
    [anon_sym_symbol] = ACTIONS(2050),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(1485),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_RBRACE] = ACTIONS(1485),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_import] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1485),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_await] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_try] = ACTIONS(1487),
    [anon_sym_with] = ACTIONS(1487),
    [anon_sym_break] = ACTIONS(1487),
    [anon_sym_continue] = ACTIONS(1487),
    [anon_sym_debugger] = ACTIONS(1487),
    [anon_sym_return] = ACTIONS(1487),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_case] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [anon_sym_LTtemplate_GT] = ACTIONS(1485),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_class] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_new] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1485),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_DQUOTE] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1485),
    [sym_number] = ACTIONS(1485),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_interface] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1485),
    [sym__automatic_semicolon] = ACTIONS(1485),
  },
  [603] = {
    [sym__call_signature] = STATE(4234),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_function] = ACTIONS(2035),
    [anon_sym_EQ_GT] = ACTIONS(1277),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_readonly] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_override] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_any] = ACTIONS(2071),
    [anon_sym_number] = ACTIONS(2071),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_symbol] = ACTIONS(2071),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [604] = {
    [sym__call_signature] = STATE(4113),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_export] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(1266),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2050),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(1268),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2050),
    [anon_sym_readonly] = ACTIONS(2050),
    [anon_sym_get] = ACTIONS(2050),
    [anon_sym_set] = ACTIONS(2050),
    [anon_sym_declare] = ACTIONS(2050),
    [anon_sym_public] = ACTIONS(2050),
    [anon_sym_private] = ACTIONS(2050),
    [anon_sym_protected] = ACTIONS(2050),
    [anon_sym_override] = ACTIONS(2050),
    [anon_sym_module] = ACTIONS(2050),
    [anon_sym_any] = ACTIONS(2050),
    [anon_sym_number] = ACTIONS(2050),
    [anon_sym_boolean] = ACTIONS(2050),
    [anon_sym_string] = ACTIONS(2050),
    [anon_sym_symbol] = ACTIONS(2050),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(1419),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_export] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_type] = ACTIONS(1421),
    [anon_sym_namespace] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1419),
    [anon_sym_COMMA] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1419),
    [anon_sym_typeof] = ACTIONS(1421),
    [anon_sym_import] = ACTIONS(1421),
    [anon_sym_var] = ACTIONS(1421),
    [anon_sym_let] = ACTIONS(1421),
    [anon_sym_const] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_else] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1421),
    [anon_sym_for] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_await] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(1421),
    [anon_sym_do] = ACTIONS(1421),
    [anon_sym_try] = ACTIONS(1421),
    [anon_sym_with] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1421),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_debugger] = ACTIONS(1421),
    [anon_sym_return] = ACTIONS(1421),
    [anon_sym_throw] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1419),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_yield] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1419),
    [anon_sym_LTtemplate_GT] = ACTIONS(1419),
    [anon_sym_LT] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(1421),
    [anon_sym_class] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1421),
    [anon_sym_function] = ACTIONS(1421),
    [anon_sym_new] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_void] = ACTIONS(1421),
    [anon_sym_delete] = ACTIONS(1421),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_DQUOTE] = ACTIONS(1419),
    [anon_sym_SQUOTE] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_number] = ACTIONS(1419),
    [sym_this] = ACTIONS(1421),
    [sym_super] = ACTIONS(1421),
    [sym_true] = ACTIONS(1421),
    [sym_false] = ACTIONS(1421),
    [sym_null] = ACTIONS(1421),
    [sym_undefined] = ACTIONS(1421),
    [anon_sym_AT] = ACTIONS(1419),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_readonly] = ACTIONS(1421),
    [anon_sym_get] = ACTIONS(1421),
    [anon_sym_set] = ACTIONS(1421),
    [anon_sym_declare] = ACTIONS(1421),
    [anon_sym_public] = ACTIONS(1421),
    [anon_sym_private] = ACTIONS(1421),
    [anon_sym_protected] = ACTIONS(1421),
    [anon_sym_override] = ACTIONS(1421),
    [anon_sym_module] = ACTIONS(1421),
    [anon_sym_any] = ACTIONS(1421),
    [anon_sym_number] = ACTIONS(1421),
    [anon_sym_boolean] = ACTIONS(1421),
    [anon_sym_string] = ACTIONS(1421),
    [anon_sym_symbol] = ACTIONS(1421),
    [anon_sym_abstract] = ACTIONS(1421),
    [anon_sym_interface] = ACTIONS(1421),
    [anon_sym_enum] = ACTIONS(1421),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1419),
    [sym__automatic_semicolon] = ACTIONS(2079),
  },
  [606] = {
    [sym__call_signature] = STATE(4174),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2081),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_of] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [607] = {
    [sym__call_signature] = STATE(4174),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2081),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_of] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [608] = {
    [sym_finally_clause] = STATE(644),
    [ts_builtin_sym_end] = ACTIONS(2085),
    [sym_identifier] = ACTIONS(2087),
    [anon_sym_export] = ACTIONS(2087),
    [anon_sym_default] = ACTIONS(2087),
    [anon_sym_type] = ACTIONS(2087),
    [anon_sym_namespace] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(2085),
    [anon_sym_RBRACE] = ACTIONS(2085),
    [anon_sym_typeof] = ACTIONS(2087),
    [anon_sym_import] = ACTIONS(2087),
    [anon_sym_var] = ACTIONS(2087),
    [anon_sym_let] = ACTIONS(2087),
    [anon_sym_const] = ACTIONS(2087),
    [anon_sym_BANG] = ACTIONS(2085),
    [anon_sym_else] = ACTIONS(2087),
    [anon_sym_if] = ACTIONS(2087),
    [anon_sym_switch] = ACTIONS(2087),
    [anon_sym_for] = ACTIONS(2087),
    [anon_sym_LPAREN] = ACTIONS(2085),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_while] = ACTIONS(2087),
    [anon_sym_do] = ACTIONS(2087),
    [anon_sym_try] = ACTIONS(2087),
    [anon_sym_with] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_continue] = ACTIONS(2087),
    [anon_sym_debugger] = ACTIONS(2087),
    [anon_sym_return] = ACTIONS(2087),
    [anon_sym_throw] = ACTIONS(2087),
    [anon_sym_SEMI] = ACTIONS(2085),
    [anon_sym_case] = ACTIONS(2087),
    [anon_sym_finally] = ACTIONS(2058),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_LBRACK] = ACTIONS(2085),
    [anon_sym_LTtemplate_GT] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2087),
    [anon_sym_SLASH] = ACTIONS(2087),
    [anon_sym_class] = ACTIONS(2087),
    [anon_sym_async] = ACTIONS(2087),
    [anon_sym_function] = ACTIONS(2087),
    [anon_sym_new] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2087),
    [anon_sym_DASH] = ACTIONS(2087),
    [anon_sym_TILDE] = ACTIONS(2085),
    [anon_sym_void] = ACTIONS(2087),
    [anon_sym_delete] = ACTIONS(2087),
    [anon_sym_PLUS_PLUS] = ACTIONS(2085),
    [anon_sym_DASH_DASH] = ACTIONS(2085),
    [anon_sym_DQUOTE] = ACTIONS(2085),
    [anon_sym_SQUOTE] = ACTIONS(2085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2085),
    [sym_number] = ACTIONS(2085),
    [sym_this] = ACTIONS(2087),
    [sym_super] = ACTIONS(2087),
    [sym_true] = ACTIONS(2087),
    [sym_false] = ACTIONS(2087),
    [sym_null] = ACTIONS(2087),
    [sym_undefined] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(2085),
    [anon_sym_static] = ACTIONS(2087),
    [anon_sym_readonly] = ACTIONS(2087),
    [anon_sym_get] = ACTIONS(2087),
    [anon_sym_set] = ACTIONS(2087),
    [anon_sym_declare] = ACTIONS(2087),
    [anon_sym_public] = ACTIONS(2087),
    [anon_sym_private] = ACTIONS(2087),
    [anon_sym_protected] = ACTIONS(2087),
    [anon_sym_override] = ACTIONS(2087),
    [anon_sym_module] = ACTIONS(2087),
    [anon_sym_any] = ACTIONS(2087),
    [anon_sym_number] = ACTIONS(2087),
    [anon_sym_boolean] = ACTIONS(2087),
    [anon_sym_string] = ACTIONS(2087),
    [anon_sym_symbol] = ACTIONS(2087),
    [anon_sym_abstract] = ACTIONS(2087),
    [anon_sym_interface] = ACTIONS(2087),
    [anon_sym_enum] = ACTIONS(2087),
  },
  [609] = {
    [sym_statement_block] = STATE(678),
    [ts_builtin_sym_end] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(1395),
    [anon_sym_default] = ACTIONS(1395),
    [anon_sym_type] = ACTIONS(1395),
    [anon_sym_namespace] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(2089),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_typeof] = ACTIONS(1395),
    [anon_sym_import] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1395),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_const] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_else] = ACTIONS(1395),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_switch] = ACTIONS(1395),
    [anon_sym_for] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_do] = ACTIONS(1395),
    [anon_sym_try] = ACTIONS(1395),
    [anon_sym_with] = ACTIONS(1395),
    [anon_sym_break] = ACTIONS(1395),
    [anon_sym_continue] = ACTIONS(1395),
    [anon_sym_debugger] = ACTIONS(1395),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_throw] = ACTIONS(1395),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_LTtemplate_GT] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_DOT] = ACTIONS(2091),
    [anon_sym_class] = ACTIONS(1395),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_function] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1393),
    [anon_sym_void] = ACTIONS(1395),
    [anon_sym_delete] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1393),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1393),
    [sym_number] = ACTIONS(1393),
    [sym_this] = ACTIONS(1395),
    [sym_super] = ACTIONS(1395),
    [sym_true] = ACTIONS(1395),
    [sym_false] = ACTIONS(1395),
    [sym_null] = ACTIONS(1395),
    [sym_undefined] = ACTIONS(1395),
    [anon_sym_AT] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1395),
    [anon_sym_readonly] = ACTIONS(1395),
    [anon_sym_get] = ACTIONS(1395),
    [anon_sym_set] = ACTIONS(1395),
    [anon_sym_declare] = ACTIONS(1395),
    [anon_sym_public] = ACTIONS(1395),
    [anon_sym_private] = ACTIONS(1395),
    [anon_sym_protected] = ACTIONS(1395),
    [anon_sym_override] = ACTIONS(1395),
    [anon_sym_module] = ACTIONS(1395),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1395),
    [anon_sym_interface] = ACTIONS(1395),
    [anon_sym_enum] = ACTIONS(1395),
  },
  [610] = {
    [sym__call_signature] = STATE(4149),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2023),
    [anon_sym_export] = ACTIONS(2025),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2025),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2025),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2025),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2025),
    [anon_sym_readonly] = ACTIONS(2025),
    [anon_sym_get] = ACTIONS(2025),
    [anon_sym_set] = ACTIONS(2025),
    [anon_sym_declare] = ACTIONS(2025),
    [anon_sym_public] = ACTIONS(2025),
    [anon_sym_private] = ACTIONS(2025),
    [anon_sym_protected] = ACTIONS(2025),
    [anon_sym_override] = ACTIONS(2025),
    [anon_sym_module] = ACTIONS(2025),
    [anon_sym_any] = ACTIONS(2025),
    [anon_sym_number] = ACTIONS(2025),
    [anon_sym_boolean] = ACTIONS(2025),
    [anon_sym_string] = ACTIONS(2025),
    [anon_sym_symbol] = ACTIONS(2025),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [611] = {
    [sym__call_signature] = STATE(4149),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2023),
    [anon_sym_export] = ACTIONS(2025),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2025),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2025),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(2037),
    [anon_sym_of] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2025),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2025),
    [anon_sym_readonly] = ACTIONS(2025),
    [anon_sym_get] = ACTIONS(2025),
    [anon_sym_set] = ACTIONS(2025),
    [anon_sym_declare] = ACTIONS(2025),
    [anon_sym_public] = ACTIONS(2025),
    [anon_sym_private] = ACTIONS(2025),
    [anon_sym_protected] = ACTIONS(2025),
    [anon_sym_override] = ACTIONS(2025),
    [anon_sym_module] = ACTIONS(2025),
    [anon_sym_any] = ACTIONS(2025),
    [anon_sym_number] = ACTIONS(2025),
    [anon_sym_boolean] = ACTIONS(2025),
    [anon_sym_string] = ACTIONS(2025),
    [anon_sym_symbol] = ACTIONS(2025),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(1516),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_export] = ACTIONS(1518),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_type] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_RBRACE] = ACTIONS(1516),
    [anon_sym_typeof] = ACTIONS(1518),
    [anon_sym_import] = ACTIONS(1518),
    [anon_sym_var] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1518),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_else] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1518),
    [anon_sym_switch] = ACTIONS(1518),
    [anon_sym_for] = ACTIONS(1518),
    [anon_sym_LPAREN] = ACTIONS(1516),
    [anon_sym_await] = ACTIONS(1518),
    [anon_sym_while] = ACTIONS(1518),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_try] = ACTIONS(1518),
    [anon_sym_with] = ACTIONS(1518),
    [anon_sym_break] = ACTIONS(1518),
    [anon_sym_continue] = ACTIONS(1518),
    [anon_sym_debugger] = ACTIONS(1518),
    [anon_sym_return] = ACTIONS(1518),
    [anon_sym_throw] = ACTIONS(1518),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym_case] = ACTIONS(1518),
    [anon_sym_yield] = ACTIONS(1518),
    [anon_sym_LBRACK] = ACTIONS(1516),
    [anon_sym_LTtemplate_GT] = ACTIONS(1516),
    [anon_sym_LT] = ACTIONS(1518),
    [anon_sym_SLASH] = ACTIONS(1518),
    [anon_sym_class] = ACTIONS(1518),
    [anon_sym_async] = ACTIONS(1518),
    [anon_sym_function] = ACTIONS(1518),
    [anon_sym_new] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_void] = ACTIONS(1518),
    [anon_sym_delete] = ACTIONS(1518),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1516),
    [sym_number] = ACTIONS(1516),
    [sym_this] = ACTIONS(1518),
    [sym_super] = ACTIONS(1518),
    [sym_true] = ACTIONS(1518),
    [sym_false] = ACTIONS(1518),
    [sym_null] = ACTIONS(1518),
    [sym_undefined] = ACTIONS(1518),
    [anon_sym_AT] = ACTIONS(1516),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_readonly] = ACTIONS(1518),
    [anon_sym_get] = ACTIONS(1518),
    [anon_sym_set] = ACTIONS(1518),
    [anon_sym_declare] = ACTIONS(1518),
    [anon_sym_public] = ACTIONS(1518),
    [anon_sym_private] = ACTIONS(1518),
    [anon_sym_protected] = ACTIONS(1518),
    [anon_sym_override] = ACTIONS(1518),
    [anon_sym_module] = ACTIONS(1518),
    [anon_sym_any] = ACTIONS(1518),
    [anon_sym_number] = ACTIONS(1518),
    [anon_sym_boolean] = ACTIONS(1518),
    [anon_sym_string] = ACTIONS(1518),
    [anon_sym_symbol] = ACTIONS(1518),
    [anon_sym_abstract] = ACTIONS(1518),
    [anon_sym_interface] = ACTIONS(1518),
    [anon_sym_enum] = ACTIONS(1518),
    [sym__automatic_semicolon] = ACTIONS(1524),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(1566),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1568),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_RBRACE] = ACTIONS(1566),
    [anon_sym_typeof] = ACTIONS(1568),
    [anon_sym_import] = ACTIONS(1568),
    [anon_sym_var] = ACTIONS(1568),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_const] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1566),
    [anon_sym_else] = ACTIONS(1568),
    [anon_sym_if] = ACTIONS(1568),
    [anon_sym_switch] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [anon_sym_await] = ACTIONS(1568),
    [anon_sym_while] = ACTIONS(1568),
    [anon_sym_do] = ACTIONS(1568),
    [anon_sym_try] = ACTIONS(1568),
    [anon_sym_with] = ACTIONS(1568),
    [anon_sym_break] = ACTIONS(1568),
    [anon_sym_continue] = ACTIONS(1568),
    [anon_sym_debugger] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(1568),
    [anon_sym_throw] = ACTIONS(1568),
    [anon_sym_SEMI] = ACTIONS(1566),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_yield] = ACTIONS(1568),
    [anon_sym_LBRACK] = ACTIONS(1566),
    [anon_sym_LTtemplate_GT] = ACTIONS(1566),
    [anon_sym_LT] = ACTIONS(1568),
    [anon_sym_SLASH] = ACTIONS(1568),
    [anon_sym_class] = ACTIONS(1568),
    [anon_sym_async] = ACTIONS(1568),
    [anon_sym_function] = ACTIONS(1568),
    [anon_sym_new] = ACTIONS(1568),
    [anon_sym_PLUS] = ACTIONS(1568),
    [anon_sym_DASH] = ACTIONS(1568),
    [anon_sym_TILDE] = ACTIONS(1566),
    [anon_sym_void] = ACTIONS(1568),
    [anon_sym_delete] = ACTIONS(1568),
    [anon_sym_PLUS_PLUS] = ACTIONS(1566),
    [anon_sym_DASH_DASH] = ACTIONS(1566),
    [anon_sym_DQUOTE] = ACTIONS(1566),
    [anon_sym_SQUOTE] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1566),
    [sym_number] = ACTIONS(1566),
    [sym_this] = ACTIONS(1568),
    [sym_super] = ACTIONS(1568),
    [sym_true] = ACTIONS(1568),
    [sym_false] = ACTIONS(1568),
    [sym_null] = ACTIONS(1568),
    [sym_undefined] = ACTIONS(1568),
    [anon_sym_AT] = ACTIONS(1566),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_abstract] = ACTIONS(1568),
    [anon_sym_interface] = ACTIONS(1568),
    [anon_sym_enum] = ACTIONS(1568),
    [sym__automatic_semicolon] = ACTIONS(1574),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(2093),
    [sym_identifier] = ACTIONS(2095),
    [anon_sym_export] = ACTIONS(2095),
    [anon_sym_default] = ACTIONS(2095),
    [anon_sym_type] = ACTIONS(2095),
    [anon_sym_namespace] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_typeof] = ACTIONS(2095),
    [anon_sym_import] = ACTIONS(2095),
    [anon_sym_var] = ACTIONS(2095),
    [anon_sym_let] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(2095),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_else] = ACTIONS(2095),
    [anon_sym_if] = ACTIONS(2095),
    [anon_sym_switch] = ACTIONS(2095),
    [anon_sym_for] = ACTIONS(2095),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym_await] = ACTIONS(2095),
    [anon_sym_while] = ACTIONS(2095),
    [anon_sym_do] = ACTIONS(2095),
    [anon_sym_try] = ACTIONS(2095),
    [anon_sym_with] = ACTIONS(2095),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_continue] = ACTIONS(2095),
    [anon_sym_debugger] = ACTIONS(2095),
    [anon_sym_return] = ACTIONS(2095),
    [anon_sym_throw] = ACTIONS(2095),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_case] = ACTIONS(2095),
    [anon_sym_finally] = ACTIONS(2095),
    [anon_sym_yield] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(2093),
    [anon_sym_LTtemplate_GT] = ACTIONS(2093),
    [anon_sym_LT] = ACTIONS(2095),
    [anon_sym_SLASH] = ACTIONS(2095),
    [anon_sym_class] = ACTIONS(2095),
    [anon_sym_async] = ACTIONS(2095),
    [anon_sym_function] = ACTIONS(2095),
    [anon_sym_new] = ACTIONS(2095),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_DASH] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_void] = ACTIONS(2095),
    [anon_sym_delete] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2093),
    [sym_number] = ACTIONS(2093),
    [sym_this] = ACTIONS(2095),
    [sym_super] = ACTIONS(2095),
    [sym_true] = ACTIONS(2095),
    [sym_false] = ACTIONS(2095),
    [sym_null] = ACTIONS(2095),
    [sym_undefined] = ACTIONS(2095),
    [anon_sym_AT] = ACTIONS(2093),
    [anon_sym_static] = ACTIONS(2095),
    [anon_sym_readonly] = ACTIONS(2095),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_declare] = ACTIONS(2095),
    [anon_sym_public] = ACTIONS(2095),
    [anon_sym_private] = ACTIONS(2095),
    [anon_sym_protected] = ACTIONS(2095),
    [anon_sym_override] = ACTIONS(2095),
    [anon_sym_module] = ACTIONS(2095),
    [anon_sym_any] = ACTIONS(2095),
    [anon_sym_number] = ACTIONS(2095),
    [anon_sym_boolean] = ACTIONS(2095),
    [anon_sym_string] = ACTIONS(2095),
    [anon_sym_symbol] = ACTIONS(2095),
    [anon_sym_abstract] = ACTIONS(2095),
    [anon_sym_interface] = ACTIONS(2095),
    [anon_sym_enum] = ACTIONS(2095),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1443),
    [anon_sym_export] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1443),
    [anon_sym_type] = ACTIONS(1443),
    [anon_sym_namespace] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_typeof] = ACTIONS(1443),
    [anon_sym_import] = ACTIONS(1443),
    [anon_sym_var] = ACTIONS(1443),
    [anon_sym_let] = ACTIONS(1443),
    [anon_sym_const] = ACTIONS(1443),
    [anon_sym_BANG] = ACTIONS(1441),
    [anon_sym_else] = ACTIONS(1443),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1443),
    [anon_sym_try] = ACTIONS(1443),
    [anon_sym_with] = ACTIONS(1443),
    [anon_sym_break] = ACTIONS(1443),
    [anon_sym_continue] = ACTIONS(1443),
    [anon_sym_debugger] = ACTIONS(1443),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_throw] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_case] = ACTIONS(1443),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_LTtemplate_GT] = ACTIONS(1441),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_class] = ACTIONS(1443),
    [anon_sym_async] = ACTIONS(1443),
    [anon_sym_function] = ACTIONS(1443),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(1441),
    [anon_sym_void] = ACTIONS(1443),
    [anon_sym_delete] = ACTIONS(1443),
    [anon_sym_PLUS_PLUS] = ACTIONS(1441),
    [anon_sym_DASH_DASH] = ACTIONS(1441),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1441),
    [sym_number] = ACTIONS(1441),
    [sym_this] = ACTIONS(1443),
    [sym_super] = ACTIONS(1443),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_undefined] = ACTIONS(1443),
    [anon_sym_AT] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1443),
    [anon_sym_readonly] = ACTIONS(1443),
    [anon_sym_get] = ACTIONS(1443),
    [anon_sym_set] = ACTIONS(1443),
    [anon_sym_declare] = ACTIONS(1443),
    [anon_sym_public] = ACTIONS(1443),
    [anon_sym_private] = ACTIONS(1443),
    [anon_sym_protected] = ACTIONS(1443),
    [anon_sym_override] = ACTIONS(1443),
    [anon_sym_module] = ACTIONS(1443),
    [anon_sym_any] = ACTIONS(1443),
    [anon_sym_number] = ACTIONS(1443),
    [anon_sym_boolean] = ACTIONS(1443),
    [anon_sym_string] = ACTIONS(1443),
    [anon_sym_symbol] = ACTIONS(1443),
    [anon_sym_abstract] = ACTIONS(1443),
    [anon_sym_interface] = ACTIONS(1443),
    [anon_sym_enum] = ACTIONS(1443),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(2097),
    [sym_identifier] = ACTIONS(2099),
    [anon_sym_export] = ACTIONS(2099),
    [anon_sym_default] = ACTIONS(2099),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_namespace] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_RBRACE] = ACTIONS(2097),
    [anon_sym_typeof] = ACTIONS(2099),
    [anon_sym_import] = ACTIONS(2099),
    [anon_sym_var] = ACTIONS(2099),
    [anon_sym_let] = ACTIONS(2099),
    [anon_sym_const] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2097),
    [anon_sym_else] = ACTIONS(2099),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_switch] = ACTIONS(2099),
    [anon_sym_for] = ACTIONS(2099),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_RPAREN] = ACTIONS(2097),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_while] = ACTIONS(2099),
    [anon_sym_do] = ACTIONS(2099),
    [anon_sym_try] = ACTIONS(2099),
    [anon_sym_with] = ACTIONS(2099),
    [anon_sym_break] = ACTIONS(2099),
    [anon_sym_continue] = ACTIONS(2099),
    [anon_sym_debugger] = ACTIONS(2099),
    [anon_sym_return] = ACTIONS(2099),
    [anon_sym_throw] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(2097),
    [anon_sym_case] = ACTIONS(2099),
    [anon_sym_yield] = ACTIONS(2099),
    [anon_sym_LBRACK] = ACTIONS(2097),
    [anon_sym_LTtemplate_GT] = ACTIONS(2097),
    [anon_sym_LT] = ACTIONS(2099),
    [anon_sym_SLASH] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2099),
    [anon_sym_function] = ACTIONS(2099),
    [anon_sym_new] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2099),
    [anon_sym_DASH] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(2097),
    [anon_sym_void] = ACTIONS(2099),
    [anon_sym_delete] = ACTIONS(2099),
    [anon_sym_PLUS_PLUS] = ACTIONS(2097),
    [anon_sym_DASH_DASH] = ACTIONS(2097),
    [anon_sym_DQUOTE] = ACTIONS(2097),
    [anon_sym_SQUOTE] = ACTIONS(2097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2097),
    [sym_number] = ACTIONS(2097),
    [sym_this] = ACTIONS(2099),
    [sym_super] = ACTIONS(2099),
    [sym_true] = ACTIONS(2099),
    [sym_false] = ACTIONS(2099),
    [sym_null] = ACTIONS(2099),
    [sym_undefined] = ACTIONS(2099),
    [anon_sym_AT] = ACTIONS(2097),
    [anon_sym_static] = ACTIONS(2099),
    [anon_sym_readonly] = ACTIONS(2099),
    [anon_sym_get] = ACTIONS(2099),
    [anon_sym_set] = ACTIONS(2099),
    [anon_sym_declare] = ACTIONS(2099),
    [anon_sym_public] = ACTIONS(2099),
    [anon_sym_private] = ACTIONS(2099),
    [anon_sym_protected] = ACTIONS(2099),
    [anon_sym_override] = ACTIONS(2099),
    [anon_sym_module] = ACTIONS(2099),
    [anon_sym_any] = ACTIONS(2099),
    [anon_sym_number] = ACTIONS(2099),
    [anon_sym_boolean] = ACTIONS(2099),
    [anon_sym_string] = ACTIONS(2099),
    [anon_sym_symbol] = ACTIONS(2099),
    [anon_sym_abstract] = ACTIONS(2099),
    [anon_sym_interface] = ACTIONS(2099),
    [anon_sym_enum] = ACTIONS(2099),
  },
  [617] = {
    [sym__call_signature] = STATE(4149),
    [sym_formal_parameters] = STATE(3123),
    [sym_type_parameters] = STATE(3937),
    [sym_identifier] = ACTIONS(2023),
    [anon_sym_export] = ACTIONS(2025),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_type] = ACTIONS(2025),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_namespace] = ACTIONS(2025),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_async] = ACTIONS(2025),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_static] = ACTIONS(2025),
    [anon_sym_readonly] = ACTIONS(2025),
    [anon_sym_get] = ACTIONS(2025),
    [anon_sym_set] = ACTIONS(2025),
    [anon_sym_declare] = ACTIONS(2025),
    [anon_sym_public] = ACTIONS(2025),
    [anon_sym_private] = ACTIONS(2025),
    [anon_sym_protected] = ACTIONS(2025),
    [anon_sym_override] = ACTIONS(2025),
    [anon_sym_module] = ACTIONS(2025),
    [anon_sym_any] = ACTIONS(2025),
    [anon_sym_number] = ACTIONS(2025),
    [anon_sym_boolean] = ACTIONS(2025),
    [anon_sym_string] = ACTIONS(2025),
    [anon_sym_symbol] = ACTIONS(2025),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(1489),
    [sym_identifier] = ACTIONS(1491),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_default] = ACTIONS(1491),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1491),
    [anon_sym_LBRACE] = ACTIONS(1489),
    [anon_sym_RBRACE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1491),
    [anon_sym_import] = ACTIONS(1491),
    [anon_sym_var] = ACTIONS(1491),
    [anon_sym_let] = ACTIONS(1491),
    [anon_sym_const] = ACTIONS(1491),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_else] = ACTIONS(1491),
    [anon_sym_if] = ACTIONS(1491),
    [anon_sym_switch] = ACTIONS(1491),
    [anon_sym_for] = ACTIONS(1491),
    [anon_sym_LPAREN] = ACTIONS(1489),
    [anon_sym_await] = ACTIONS(1491),
    [anon_sym_while] = ACTIONS(1491),
    [anon_sym_do] = ACTIONS(1491),
    [anon_sym_try] = ACTIONS(1491),
    [anon_sym_with] = ACTIONS(1491),
    [anon_sym_break] = ACTIONS(1491),
    [anon_sym_continue] = ACTIONS(1491),
    [anon_sym_debugger] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1491),
    [anon_sym_throw] = ACTIONS(1491),
    [anon_sym_SEMI] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(1491),
    [anon_sym_yield] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1489),
    [anon_sym_LTtemplate_GT] = ACTIONS(1489),
    [anon_sym_LT] = ACTIONS(1491),
    [anon_sym_SLASH] = ACTIONS(1491),
    [anon_sym_class] = ACTIONS(1491),
    [anon_sym_async] = ACTIONS(1491),
    [anon_sym_function] = ACTIONS(1491),
    [anon_sym_new] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1491),
    [anon_sym_DASH] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_void] = ACTIONS(1491),
    [anon_sym_delete] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1489),
    [anon_sym_DASH_DASH] = ACTIONS(1489),
    [anon_sym_DQUOTE] = ACTIONS(1489),
    [anon_sym_SQUOTE] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1489),
    [sym_number] = ACTIONS(1489),
    [sym_this] = ACTIONS(1491),
    [sym_super] = ACTIONS(1491),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_undefined] = ACTIONS(1491),
    [anon_sym_AT] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_readonly] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_override] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
    [anon_sym_abstract] = ACTIONS(1491),
    [anon_sym_interface] = ACTIONS(1491),
    [anon_sym_enum] = ACTIONS(1491),
    [sym__automatic_semicolon] = ACTIONS(1497),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(1532),
    [sym_identifier] = ACTIONS(1534),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_default] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1534),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_typeof] = ACTIONS(1534),
    [anon_sym_import] = ACTIONS(1534),
    [anon_sym_var] = ACTIONS(1534),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_const] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1534),
    [anon_sym_if] = ACTIONS(1534),
    [anon_sym_switch] = ACTIONS(1534),
    [anon_sym_for] = ACTIONS(1534),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [anon_sym_await] = ACTIONS(1534),
    [anon_sym_while] = ACTIONS(1534),
    [anon_sym_do] = ACTIONS(1534),
    [anon_sym_try] = ACTIONS(1534),
    [anon_sym_with] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1534),
    [anon_sym_continue] = ACTIONS(1534),
    [anon_sym_debugger] = ACTIONS(1534),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_throw] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_case] = ACTIONS(1534),
    [anon_sym_yield] = ACTIONS(1534),
    [anon_sym_LBRACK] = ACTIONS(1532),
    [anon_sym_LTtemplate_GT] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_SLASH] = ACTIONS(1534),
    [anon_sym_class] = ACTIONS(1534),
    [anon_sym_async] = ACTIONS(1534),
    [anon_sym_function] = ACTIONS(1534),
    [anon_sym_new] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1534),
    [anon_sym_DASH] = ACTIONS(1534),
    [anon_sym_TILDE] = ACTIONS(1532),
    [anon_sym_void] = ACTIONS(1534),
    [anon_sym_delete] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [sym_number] = ACTIONS(1532),
    [sym_this] = ACTIONS(1534),
    [sym_super] = ACTIONS(1534),
    [sym_true] = ACTIONS(1534),
    [sym_false] = ACTIONS(1534),
    [sym_null] = ACTIONS(1534),
    [sym_undefined] = ACTIONS(1534),
    [anon_sym_AT] = ACTIONS(1532),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_abstract] = ACTIONS(1534),
    [anon_sym_interface] = ACTIONS(1534),
    [anon_sym_enum] = ACTIONS(1534),
    [sym__automatic_semicolon] = ACTIONS(1540),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(2101),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_default] = ACTIONS(2103),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2101),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_else] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2101),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_case] = ACTIONS(2103),
    [anon_sym_finally] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2101),
    [anon_sym_LTtemplate_GT] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2101),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2101),
    [anon_sym_DASH_DASH] = ACTIONS(2101),
    [anon_sym_DQUOTE] = ACTIONS(2101),
    [anon_sym_SQUOTE] = ACTIONS(2101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2101),
    [sym_number] = ACTIONS(2101),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2101),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_readonly] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_override] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_any] = ACTIONS(2103),
    [anon_sym_number] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2107),
    [anon_sym_export] = ACTIONS(2107),
    [anon_sym_default] = ACTIONS(2107),
    [anon_sym_type] = ACTIONS(2107),
    [anon_sym_namespace] = ACTIONS(2107),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_typeof] = ACTIONS(2107),
    [anon_sym_import] = ACTIONS(2107),
    [anon_sym_var] = ACTIONS(2107),
    [anon_sym_let] = ACTIONS(2107),
    [anon_sym_const] = ACTIONS(2107),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_else] = ACTIONS(2107),
    [anon_sym_if] = ACTIONS(2107),
    [anon_sym_switch] = ACTIONS(2107),
    [anon_sym_for] = ACTIONS(2107),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym_await] = ACTIONS(2107),
    [anon_sym_while] = ACTIONS(2107),
    [anon_sym_do] = ACTIONS(2107),
    [anon_sym_try] = ACTIONS(2107),
    [anon_sym_with] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2107),
    [anon_sym_continue] = ACTIONS(2107),
    [anon_sym_debugger] = ACTIONS(2107),
    [anon_sym_return] = ACTIONS(2107),
    [anon_sym_throw] = ACTIONS(2107),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_case] = ACTIONS(2107),
    [anon_sym_finally] = ACTIONS(2107),
    [anon_sym_yield] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(2105),
    [anon_sym_LTtemplate_GT] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2107),
    [anon_sym_async] = ACTIONS(2107),
    [anon_sym_function] = ACTIONS(2107),
    [anon_sym_new] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2107),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_void] = ACTIONS(2107),
    [anon_sym_delete] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [anon_sym_SQUOTE] = ACTIONS(2105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2105),
    [sym_number] = ACTIONS(2105),
    [sym_this] = ACTIONS(2107),
    [sym_super] = ACTIONS(2107),
    [sym_true] = ACTIONS(2107),
    [sym_false] = ACTIONS(2107),
    [sym_null] = ACTIONS(2107),
    [sym_undefined] = ACTIONS(2107),
    [anon_sym_AT] = ACTIONS(2105),
    [anon_sym_static] = ACTIONS(2107),
    [anon_sym_readonly] = ACTIONS(2107),
    [anon_sym_get] = ACTIONS(2107),
    [anon_sym_set] = ACTIONS(2107),
    [anon_sym_declare] = ACTIONS(2107),
    [anon_sym_public] = ACTIONS(2107),
    [anon_sym_private] = ACTIONS(2107),
    [anon_sym_protected] = ACTIONS(2107),
    [anon_sym_override] = ACTIONS(2107),
    [anon_sym_module] = ACTIONS(2107),
    [anon_sym_any] = ACTIONS(2107),
    [anon_sym_number] = ACTIONS(2107),
    [anon_sym_boolean] = ACTIONS(2107),
    [anon_sym_string] = ACTIONS(2107),
    [anon_sym_symbol] = ACTIONS(2107),
    [anon_sym_abstract] = ACTIONS(2107),
    [anon_sym_interface] = ACTIONS(2107),
    [anon_sym_enum] = ACTIONS(2107),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(1590),
    [sym_identifier] = ACTIONS(1592),
    [anon_sym_export] = ACTIONS(1592),
    [anon_sym_default] = ACTIONS(1592),
    [anon_sym_type] = ACTIONS(1592),
    [anon_sym_namespace] = ACTIONS(1592),
    [anon_sym_LBRACE] = ACTIONS(1590),
    [anon_sym_RBRACE] = ACTIONS(1590),
    [anon_sym_typeof] = ACTIONS(1592),
    [anon_sym_import] = ACTIONS(1592),
    [anon_sym_var] = ACTIONS(1592),
    [anon_sym_let] = ACTIONS(1592),
    [anon_sym_const] = ACTIONS(1592),
    [anon_sym_BANG] = ACTIONS(1590),
    [anon_sym_else] = ACTIONS(1592),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_switch] = ACTIONS(1592),
    [anon_sym_for] = ACTIONS(1592),
    [anon_sym_LPAREN] = ACTIONS(1590),
    [anon_sym_await] = ACTIONS(1592),
    [anon_sym_while] = ACTIONS(1592),
    [anon_sym_do] = ACTIONS(1592),
    [anon_sym_try] = ACTIONS(1592),
    [anon_sym_with] = ACTIONS(1592),
    [anon_sym_break] = ACTIONS(1592),
    [anon_sym_continue] = ACTIONS(1592),
    [anon_sym_debugger] = ACTIONS(1592),
    [anon_sym_return] = ACTIONS(1592),
    [anon_sym_throw] = ACTIONS(1592),
    [anon_sym_SEMI] = ACTIONS(1590),
    [anon_sym_case] = ACTIONS(1592),
    [anon_sym_yield] = ACTIONS(1592),
    [anon_sym_LBRACK] = ACTIONS(1590),
    [anon_sym_LTtemplate_GT] = ACTIONS(1590),
    [anon_sym_LT] = ACTIONS(1592),
    [anon_sym_SLASH] = ACTIONS(1592),
    [anon_sym_class] = ACTIONS(1592),
    [anon_sym_async] = ACTIONS(1592),
    [anon_sym_function] = ACTIONS(1592),
    [anon_sym_new] = ACTIONS(1592),
    [anon_sym_PLUS] = ACTIONS(1592),
    [anon_sym_DASH] = ACTIONS(1592),
    [anon_sym_TILDE] = ACTIONS(1590),
    [anon_sym_void] = ACTIONS(1592),
    [anon_sym_delete] = ACTIONS(1592),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [anon_sym_DQUOTE] = ACTIONS(1590),
    [anon_sym_SQUOTE] = ACTIONS(1590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1590),
    [sym_number] = ACTIONS(1590),
    [sym_this] = ACTIONS(1592),
    [sym_super] = ACTIONS(1592),
    [sym_true] = ACTIONS(1592),
    [sym_false] = ACTIONS(1592),
    [sym_null] = ACTIONS(1592),
    [sym_undefined] = ACTIONS(1592),
    [anon_sym_AT] = ACTIONS(1590),
    [anon_sym_static] = ACTIONS(1592),
    [anon_sym_readonly] = ACTIONS(1592),
    [anon_sym_get] = ACTIONS(1592),
    [anon_sym_set] = ACTIONS(1592),
    [anon_sym_declare] = ACTIONS(1592),
    [anon_sym_public] = ACTIONS(1592),
    [anon_sym_private] = ACTIONS(1592),
    [anon_sym_protected] = ACTIONS(1592),
    [anon_sym_override] = ACTIONS(1592),
    [anon_sym_module] = ACTIONS(1592),
    [anon_sym_any] = ACTIONS(1592),
    [anon_sym_number] = ACTIONS(1592),
    [anon_sym_boolean] = ACTIONS(1592),
    [anon_sym_string] = ACTIONS(1592),
    [anon_sym_symbol] = ACTIONS(1592),
    [anon_sym_abstract] = ACTIONS(1592),
    [anon_sym_interface] = ACTIONS(1592),
    [anon_sym_enum] = ACTIONS(1592),
    [sym__automatic_semicolon] = ACTIONS(1598),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(1610),
    [sym_identifier] = ACTIONS(1612),
    [anon_sym_export] = ACTIONS(1612),
    [anon_sym_default] = ACTIONS(1612),
    [anon_sym_type] = ACTIONS(1612),
    [anon_sym_namespace] = ACTIONS(1612),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_RBRACE] = ACTIONS(1610),
    [anon_sym_typeof] = ACTIONS(1612),
    [anon_sym_import] = ACTIONS(1612),
    [anon_sym_var] = ACTIONS(1612),
    [anon_sym_let] = ACTIONS(1612),
    [anon_sym_const] = ACTIONS(1612),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_else] = ACTIONS(1612),
    [anon_sym_if] = ACTIONS(1612),
    [anon_sym_switch] = ACTIONS(1612),
    [anon_sym_for] = ACTIONS(1612),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_while] = ACTIONS(1612),
    [anon_sym_do] = ACTIONS(1612),
    [anon_sym_try] = ACTIONS(1612),
    [anon_sym_with] = ACTIONS(1612),
    [anon_sym_break] = ACTIONS(1612),
    [anon_sym_continue] = ACTIONS(1612),
    [anon_sym_debugger] = ACTIONS(1612),
    [anon_sym_return] = ACTIONS(1612),
    [anon_sym_throw] = ACTIONS(1612),
    [anon_sym_SEMI] = ACTIONS(1610),
    [anon_sym_case] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1612),
    [anon_sym_LBRACK] = ACTIONS(1610),
    [anon_sym_LTtemplate_GT] = ACTIONS(1610),
    [anon_sym_LT] = ACTIONS(1612),
    [anon_sym_SLASH] = ACTIONS(1612),
    [anon_sym_class] = ACTIONS(1612),
    [anon_sym_async] = ACTIONS(1612),
    [anon_sym_function] = ACTIONS(1612),
    [anon_sym_new] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1612),
    [anon_sym_delete] = ACTIONS(1612),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_DQUOTE] = ACTIONS(1610),
    [anon_sym_SQUOTE] = ACTIONS(1610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1610),
    [sym_number] = ACTIONS(1610),
    [sym_this] = ACTIONS(1612),
    [sym_super] = ACTIONS(1612),
    [sym_true] = ACTIONS(1612),
    [sym_false] = ACTIONS(1612),
    [sym_null] = ACTIONS(1612),
    [sym_undefined] = ACTIONS(1612),
    [anon_sym_AT] = ACTIONS(1610),
    [anon_sym_static] = ACTIONS(1612),
    [anon_sym_readonly] = ACTIONS(1612),
    [anon_sym_get] = ACTIONS(1612),
    [anon_sym_set] = ACTIONS(1612),
    [anon_sym_declare] = ACTIONS(1612),
    [anon_sym_public] = ACTIONS(1612),
    [anon_sym_private] = ACTIONS(1612),
    [anon_sym_protected] = ACTIONS(1612),
    [anon_sym_override] = ACTIONS(1612),
    [anon_sym_module] = ACTIONS(1612),
    [anon_sym_any] = ACTIONS(1612),
    [anon_sym_number] = ACTIONS(1612),
    [anon_sym_boolean] = ACTIONS(1612),
    [anon_sym_string] = ACTIONS(1612),
    [anon_sym_symbol] = ACTIONS(1612),
    [anon_sym_abstract] = ACTIONS(1612),
    [anon_sym_interface] = ACTIONS(1612),
    [anon_sym_enum] = ACTIONS(1612),
    [sym__automatic_semicolon] = ACTIONS(1618),
  },
  [624] = {
    [ts_builtin_sym_end] = ACTIONS(1546),
    [sym_identifier] = ACTIONS(1548),
    [anon_sym_export] = ACTIONS(1548),
    [anon_sym_default] = ACTIONS(1548),
    [anon_sym_type] = ACTIONS(1548),
    [anon_sym_namespace] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_RBRACE] = ACTIONS(1546),
    [anon_sym_typeof] = ACTIONS(1548),
    [anon_sym_import] = ACTIONS(1548),
    [anon_sym_var] = ACTIONS(1548),
    [anon_sym_let] = ACTIONS(1548),
    [anon_sym_const] = ACTIONS(1548),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_else] = ACTIONS(1548),
    [anon_sym_if] = ACTIONS(1548),
    [anon_sym_switch] = ACTIONS(1548),
    [anon_sym_for] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_await] = ACTIONS(1548),
    [anon_sym_while] = ACTIONS(1548),
    [anon_sym_do] = ACTIONS(1548),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_with] = ACTIONS(1548),
    [anon_sym_break] = ACTIONS(1548),
    [anon_sym_continue] = ACTIONS(1548),
    [anon_sym_debugger] = ACTIONS(1548),
    [anon_sym_return] = ACTIONS(1548),
    [anon_sym_throw] = ACTIONS(1548),
    [anon_sym_SEMI] = ACTIONS(1546),
    [anon_sym_case] = ACTIONS(1548),
    [anon_sym_yield] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1546),
    [anon_sym_LTtemplate_GT] = ACTIONS(1546),
    [anon_sym_LT] = ACTIONS(1548),
    [anon_sym_SLASH] = ACTIONS(1548),
    [anon_sym_class] = ACTIONS(1548),
    [anon_sym_async] = ACTIONS(1548),
    [anon_sym_function] = ACTIONS(1548),
    [anon_sym_new] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1548),
    [anon_sym_DASH] = ACTIONS(1548),
    [anon_sym_TILDE] = ACTIONS(1546),
    [anon_sym_void] = ACTIONS(1548),
    [anon_sym_delete] = ACTIONS(1548),
    [anon_sym_PLUS_PLUS] = ACTIONS(1546),
    [anon_sym_DASH_DASH] = ACTIONS(1546),
    [anon_sym_DQUOTE] = ACTIONS(1546),
    [anon_sym_SQUOTE] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1546),
    [sym_number] = ACTIONS(1546),
    [sym_this] = ACTIONS(1548),
    [sym_super] = ACTIONS(1548),
    [sym_true] = ACTIONS(1548),
    [sym_false] = ACTIONS(1548),
    [sym_null] = ACTIONS(1548),
    [sym_undefined] = ACTIONS(1548),
    [anon_sym_AT] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(1548),
    [anon_sym_readonly] = ACTIONS(1548),
    [anon_sym_get] = ACTIONS(1548),
    [anon_sym_set] = ACTIONS(1548),
    [anon_sym_declare] = ACTIONS(1548),
    [anon_sym_public] = ACTIONS(1548),
    [anon_sym_private] = ACTIONS(1548),
    [anon_sym_protected] = ACTIONS(1548),
    [anon_sym_override] = ACTIONS(1548),
    [anon_sym_module] = ACTIONS(1548),
    [anon_sym_any] = ACTIONS(1548),
    [anon_sym_number] = ACTIONS(1548),
    [anon_sym_boolean] = ACTIONS(1548),
    [anon_sym_string] = ACTIONS(1548),
    [anon_sym_symbol] = ACTIONS(1548),
    [anon_sym_abstract] = ACTIONS(1548),
    [anon_sym_interface] = ACTIONS(1548),
    [anon_sym_enum] = ACTIONS(1548),
    [sym__automatic_semicolon] = ACTIONS(1554),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(1499),
    [sym_identifier] = ACTIONS(1501),
    [anon_sym_export] = ACTIONS(1501),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_type] = ACTIONS(1501),
    [anon_sym_namespace] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_RBRACE] = ACTIONS(1499),
    [anon_sym_typeof] = ACTIONS(1501),
    [anon_sym_import] = ACTIONS(1501),
    [anon_sym_var] = ACTIONS(1501),
    [anon_sym_let] = ACTIONS(1501),
    [anon_sym_const] = ACTIONS(1501),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_else] = ACTIONS(1501),
    [anon_sym_if] = ACTIONS(1501),
    [anon_sym_switch] = ACTIONS(1501),
    [anon_sym_for] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1499),
    [anon_sym_await] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1501),
    [anon_sym_do] = ACTIONS(1501),
    [anon_sym_try] = ACTIONS(1501),
    [anon_sym_with] = ACTIONS(1501),
    [anon_sym_break] = ACTIONS(1501),
    [anon_sym_continue] = ACTIONS(1501),
    [anon_sym_debugger] = ACTIONS(1501),
    [anon_sym_return] = ACTIONS(1501),
    [anon_sym_throw] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_case] = ACTIONS(1501),
    [anon_sym_yield] = ACTIONS(1501),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [anon_sym_LTtemplate_GT] = ACTIONS(1499),
    [anon_sym_LT] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(1501),
    [anon_sym_class] = ACTIONS(1501),
    [anon_sym_async] = ACTIONS(1501),
    [anon_sym_function] = ACTIONS(1501),
    [anon_sym_new] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_void] = ACTIONS(1501),
    [anon_sym_delete] = ACTIONS(1501),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1499),
    [sym_number] = ACTIONS(1499),
    [sym_this] = ACTIONS(1501),
    [sym_super] = ACTIONS(1501),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [sym_null] = ACTIONS(1501),
    [sym_undefined] = ACTIONS(1501),
    [anon_sym_AT] = ACTIONS(1499),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_readonly] = ACTIONS(1501),
    [anon_sym_get] = ACTIONS(1501),
    [anon_sym_set] = ACTIONS(1501),
    [anon_sym_declare] = ACTIONS(1501),
    [anon_sym_public] = ACTIONS(1501),
    [anon_sym_private] = ACTIONS(1501),
    [anon_sym_protected] = ACTIONS(1501),
    [anon_sym_override] = ACTIONS(1501),
    [anon_sym_module] = ACTIONS(1501),
    [anon_sym_any] = ACTIONS(1501),
    [anon_sym_number] = ACTIONS(1501),
    [anon_sym_boolean] = ACTIONS(1501),
    [anon_sym_string] = ACTIONS(1501),
    [anon_sym_symbol] = ACTIONS(1501),
    [anon_sym_abstract] = ACTIONS(1501),
    [anon_sym_interface] = ACTIONS(1501),
    [anon_sym_enum] = ACTIONS(1501),
    [sym__automatic_semicolon] = ACTIONS(1507),
  },
  [626] = {
    [sym_else_clause] = STATE(761),
    [ts_builtin_sym_end] = ACTIONS(2109),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2109),
    [anon_sym_RBRACE] = ACTIONS(2109),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_else] = ACTIONS(2113),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2109),
    [anon_sym_LTtemplate_GT] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2109),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2109),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_SQUOTE] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [sym_number] = ACTIONS(2109),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2109),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
  },
  [627] = {
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2117),
    [anon_sym_export] = ACTIONS(2117),
    [anon_sym_default] = ACTIONS(2117),
    [anon_sym_type] = ACTIONS(2117),
    [anon_sym_namespace] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(2115),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_typeof] = ACTIONS(2117),
    [anon_sym_import] = ACTIONS(2117),
    [anon_sym_var] = ACTIONS(2117),
    [anon_sym_let] = ACTIONS(2117),
    [anon_sym_const] = ACTIONS(2117),
    [anon_sym_BANG] = ACTIONS(2115),
    [anon_sym_else] = ACTIONS(2117),
    [anon_sym_if] = ACTIONS(2117),
    [anon_sym_switch] = ACTIONS(2117),
    [anon_sym_for] = ACTIONS(2117),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_RPAREN] = ACTIONS(2115),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_while] = ACTIONS(2117),
    [anon_sym_do] = ACTIONS(2117),
    [anon_sym_try] = ACTIONS(2117),
    [anon_sym_with] = ACTIONS(2117),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_continue] = ACTIONS(2117),
    [anon_sym_debugger] = ACTIONS(2117),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_throw] = ACTIONS(2117),
    [anon_sym_SEMI] = ACTIONS(2115),
    [anon_sym_case] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_LTtemplate_GT] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(2117),
    [anon_sym_SLASH] = ACTIONS(2117),
    [anon_sym_class] = ACTIONS(2117),
    [anon_sym_async] = ACTIONS(2117),
    [anon_sym_function] = ACTIONS(2117),
    [anon_sym_new] = ACTIONS(2117),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2115),
    [anon_sym_void] = ACTIONS(2117),
    [anon_sym_delete] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2115),
    [anon_sym_DASH_DASH] = ACTIONS(2115),
    [anon_sym_DQUOTE] = ACTIONS(2115),
    [anon_sym_SQUOTE] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2115),
    [sym_number] = ACTIONS(2115),
    [sym_this] = ACTIONS(2117),
    [sym_super] = ACTIONS(2117),
    [sym_true] = ACTIONS(2117),
    [sym_false] = ACTIONS(2117),
    [sym_null] = ACTIONS(2117),
    [sym_undefined] = ACTIONS(2117),
    [anon_sym_AT] = ACTIONS(2115),
    [anon_sym_static] = ACTIONS(2117),
    [anon_sym_readonly] = ACTIONS(2117),
    [anon_sym_get] = ACTIONS(2117),
    [anon_sym_set] = ACTIONS(2117),
    [anon_sym_declare] = ACTIONS(2117),
    [anon_sym_public] = ACTIONS(2117),
    [anon_sym_private] = ACTIONS(2117),
    [anon_sym_protected] = ACTIONS(2117),
    [anon_sym_override] = ACTIONS(2117),
    [anon_sym_module] = ACTIONS(2117),
    [anon_sym_any] = ACTIONS(2117),
    [anon_sym_number] = ACTIONS(2117),
    [anon_sym_boolean] = ACTIONS(2117),
    [anon_sym_string] = ACTIONS(2117),
    [anon_sym_symbol] = ACTIONS(2117),
    [anon_sym_abstract] = ACTIONS(2117),
    [anon_sym_interface] = ACTIONS(2117),
    [anon_sym_enum] = ACTIONS(2117),
  },
  [628] = {
    [ts_builtin_sym_end] = ACTIONS(1556),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_export] = ACTIONS(1558),
    [anon_sym_default] = ACTIONS(1558),
    [anon_sym_type] = ACTIONS(1558),
    [anon_sym_namespace] = ACTIONS(1558),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_RBRACE] = ACTIONS(1556),
    [anon_sym_typeof] = ACTIONS(1558),
    [anon_sym_import] = ACTIONS(1558),
    [anon_sym_var] = ACTIONS(1558),
    [anon_sym_let] = ACTIONS(1558),
    [anon_sym_const] = ACTIONS(1558),
    [anon_sym_BANG] = ACTIONS(1556),
    [anon_sym_else] = ACTIONS(1558),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1558),
    [anon_sym_for] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_await] = ACTIONS(1558),
    [anon_sym_while] = ACTIONS(1558),
    [anon_sym_do] = ACTIONS(1558),
    [anon_sym_try] = ACTIONS(1558),
    [anon_sym_with] = ACTIONS(1558),
    [anon_sym_break] = ACTIONS(1558),
    [anon_sym_continue] = ACTIONS(1558),
    [anon_sym_debugger] = ACTIONS(1558),
    [anon_sym_return] = ACTIONS(1558),
    [anon_sym_throw] = ACTIONS(1558),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_case] = ACTIONS(1558),
    [anon_sym_yield] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1556),
    [anon_sym_LTtemplate_GT] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_class] = ACTIONS(1558),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_function] = ACTIONS(1558),
    [anon_sym_new] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_TILDE] = ACTIONS(1556),
    [anon_sym_void] = ACTIONS(1558),
    [anon_sym_delete] = ACTIONS(1558),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_DQUOTE] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1556),
    [sym_number] = ACTIONS(1556),
    [sym_this] = ACTIONS(1558),
    [sym_super] = ACTIONS(1558),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_null] = ACTIONS(1558),
    [sym_undefined] = ACTIONS(1558),
    [anon_sym_AT] = ACTIONS(1556),
    [anon_sym_static] = ACTIONS(1558),
    [anon_sym_readonly] = ACTIONS(1558),
    [anon_sym_get] = ACTIONS(1558),
    [anon_sym_set] = ACTIONS(1558),
    [anon_sym_declare] = ACTIONS(1558),
    [anon_sym_public] = ACTIONS(1558),
    [anon_sym_private] = ACTIONS(1558),
    [anon_sym_protected] = ACTIONS(1558),
    [anon_sym_override] = ACTIONS(1558),
    [anon_sym_module] = ACTIONS(1558),
    [anon_sym_any] = ACTIONS(1558),
    [anon_sym_number] = ACTIONS(1558),
    [anon_sym_boolean] = ACTIONS(1558),
    [anon_sym_string] = ACTIONS(1558),
    [anon_sym_symbol] = ACTIONS(1558),
    [anon_sym_abstract] = ACTIONS(1558),
    [anon_sym_interface] = ACTIONS(1558),
    [anon_sym_enum] = ACTIONS(1558),
    [sym__automatic_semicolon] = ACTIONS(1564),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(1576),
    [sym_identifier] = ACTIONS(1578),
    [anon_sym_export] = ACTIONS(1578),
    [anon_sym_default] = ACTIONS(1578),
    [anon_sym_type] = ACTIONS(1578),
    [anon_sym_namespace] = ACTIONS(1578),
    [anon_sym_LBRACE] = ACTIONS(1576),
    [anon_sym_RBRACE] = ACTIONS(1576),
    [anon_sym_typeof] = ACTIONS(1578),
    [anon_sym_import] = ACTIONS(1578),
    [anon_sym_var] = ACTIONS(1578),
    [anon_sym_let] = ACTIONS(1578),
    [anon_sym_const] = ACTIONS(1578),
    [anon_sym_BANG] = ACTIONS(1576),
    [anon_sym_else] = ACTIONS(1578),
    [anon_sym_if] = ACTIONS(1578),
    [anon_sym_switch] = ACTIONS(1578),
    [anon_sym_for] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1576),
    [anon_sym_await] = ACTIONS(1578),
    [anon_sym_while] = ACTIONS(1578),
    [anon_sym_do] = ACTIONS(1578),
    [anon_sym_try] = ACTIONS(1578),
    [anon_sym_with] = ACTIONS(1578),
    [anon_sym_break] = ACTIONS(1578),
    [anon_sym_continue] = ACTIONS(1578),
    [anon_sym_debugger] = ACTIONS(1578),
    [anon_sym_return] = ACTIONS(1578),
    [anon_sym_throw] = ACTIONS(1578),
    [anon_sym_SEMI] = ACTIONS(1576),
    [anon_sym_case] = ACTIONS(1578),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_LTtemplate_GT] = ACTIONS(1576),
    [anon_sym_LT] = ACTIONS(1578),
    [anon_sym_SLASH] = ACTIONS(1578),
    [anon_sym_class] = ACTIONS(1578),
    [anon_sym_async] = ACTIONS(1578),
    [anon_sym_function] = ACTIONS(1578),
    [anon_sym_new] = ACTIONS(1578),
    [anon_sym_PLUS] = ACTIONS(1578),
    [anon_sym_DASH] = ACTIONS(1578),
    [anon_sym_TILDE] = ACTIONS(1576),
    [anon_sym_void] = ACTIONS(1578),
    [anon_sym_delete] = ACTIONS(1578),
    [anon_sym_PLUS_PLUS] = ACTIONS(1576),
    [anon_sym_DASH_DASH] = ACTIONS(1576),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_SQUOTE] = ACTIONS(1576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1576),
    [sym_number] = ACTIONS(1576),
    [sym_this] = ACTIONS(1578),
    [sym_super] = ACTIONS(1578),
    [sym_true] = ACTIONS(1578),
    [sym_false] = ACTIONS(1578),
    [sym_null] = ACTIONS(1578),
    [sym_undefined] = ACTIONS(1578),
    [anon_sym_AT] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(1578),
    [anon_sym_readonly] = ACTIONS(1578),
    [anon_sym_get] = ACTIONS(1578),
    [anon_sym_set] = ACTIONS(1578),
    [anon_sym_declare] = ACTIONS(1578),
    [anon_sym_public] = ACTIONS(1578),
    [anon_sym_private] = ACTIONS(1578),
    [anon_sym_protected] = ACTIONS(1578),
    [anon_sym_override] = ACTIONS(1578),
    [anon_sym_module] = ACTIONS(1578),
    [anon_sym_any] = ACTIONS(1578),
    [anon_sym_number] = ACTIONS(1578),
    [anon_sym_boolean] = ACTIONS(1578),
    [anon_sym_string] = ACTIONS(1578),
    [anon_sym_symbol] = ACTIONS(1578),
    [anon_sym_abstract] = ACTIONS(1578),
    [anon_sym_interface] = ACTIONS(1578),
    [anon_sym_enum] = ACTIONS(1578),
    [sym__automatic_semicolon] = ACTIONS(1584),
  },
  [630] = {
    [ts_builtin_sym_end] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1477),
    [anon_sym_export] = ACTIONS(1477),
    [anon_sym_default] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1477),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_typeof] = ACTIONS(1477),
    [anon_sym_import] = ACTIONS(1477),
    [anon_sym_var] = ACTIONS(1477),
    [anon_sym_let] = ACTIONS(1477),
    [anon_sym_const] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_switch] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1477),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_with] = ACTIONS(1477),
    [anon_sym_break] = ACTIONS(1477),
    [anon_sym_continue] = ACTIONS(1477),
    [anon_sym_debugger] = ACTIONS(1477),
    [anon_sym_return] = ACTIONS(1477),
    [anon_sym_throw] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1475),
    [anon_sym_LTtemplate_GT] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1477),
    [anon_sym_SLASH] = ACTIONS(1477),
    [anon_sym_class] = ACTIONS(1477),
    [anon_sym_async] = ACTIONS(1477),
    [anon_sym_function] = ACTIONS(1477),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_void] = ACTIONS(1477),
    [anon_sym_delete] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [sym_number] = ACTIONS(1475),
    [sym_this] = ACTIONS(1477),
    [sym_super] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_null] = ACTIONS(1477),
    [sym_undefined] = ACTIONS(1477),
    [anon_sym_AT] = ACTIONS(1475),
    [anon_sym_static] = ACTIONS(1477),
    [anon_sym_readonly] = ACTIONS(1477),
    [anon_sym_get] = ACTIONS(1477),
    [anon_sym_set] = ACTIONS(1477),
    [anon_sym_declare] = ACTIONS(1477),
    [anon_sym_public] = ACTIONS(1477),
    [anon_sym_private] = ACTIONS(1477),
    [anon_sym_protected] = ACTIONS(1477),
    [anon_sym_override] = ACTIONS(1477),
    [anon_sym_module] = ACTIONS(1477),
    [anon_sym_any] = ACTIONS(1477),
    [anon_sym_number] = ACTIONS(1477),
    [anon_sym_boolean] = ACTIONS(1477),
    [anon_sym_string] = ACTIONS(1477),
    [anon_sym_symbol] = ACTIONS(1477),
    [anon_sym_abstract] = ACTIONS(1477),
    [anon_sym_interface] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(1477),
    [sym__automatic_semicolon] = ACTIONS(1483),
  },
  [631] = {
    [sym_statement_block] = STATE(678),
    [ts_builtin_sym_end] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(1395),
    [anon_sym_default] = ACTIONS(1395),
    [anon_sym_type] = ACTIONS(1395),
    [anon_sym_namespace] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(2089),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_typeof] = ACTIONS(1395),
    [anon_sym_import] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1395),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_const] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_else] = ACTIONS(1395),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_switch] = ACTIONS(1395),
    [anon_sym_for] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_do] = ACTIONS(1395),
    [anon_sym_try] = ACTIONS(1395),
    [anon_sym_with] = ACTIONS(1395),
    [anon_sym_break] = ACTIONS(1395),
    [anon_sym_continue] = ACTIONS(1395),
    [anon_sym_debugger] = ACTIONS(1395),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_throw] = ACTIONS(1395),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_LTtemplate_GT] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_class] = ACTIONS(1395),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_function] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1393),
    [anon_sym_void] = ACTIONS(1395),
    [anon_sym_delete] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1393),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1393),
    [sym_number] = ACTIONS(1393),
    [sym_this] = ACTIONS(1395),
    [sym_super] = ACTIONS(1395),
    [sym_true] = ACTIONS(1395),
    [sym_false] = ACTIONS(1395),
    [sym_null] = ACTIONS(1395),
    [sym_undefined] = ACTIONS(1395),
    [anon_sym_AT] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1395),
    [anon_sym_readonly] = ACTIONS(1395),
    [anon_sym_get] = ACTIONS(1395),
    [anon_sym_set] = ACTIONS(1395),
    [anon_sym_declare] = ACTIONS(1395),
    [anon_sym_public] = ACTIONS(1395),
    [anon_sym_private] = ACTIONS(1395),
    [anon_sym_protected] = ACTIONS(1395),
    [anon_sym_override] = ACTIONS(1395),
    [anon_sym_module] = ACTIONS(1395),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1395),
    [anon_sym_interface] = ACTIONS(1395),
    [anon_sym_enum] = ACTIONS(1395),
  },
  [632] = {
    [ts_builtin_sym_end] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_export] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_type] = ACTIONS(1433),
    [anon_sym_namespace] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_RBRACE] = ACTIONS(1431),
    [anon_sym_typeof] = ACTIONS(1433),
    [anon_sym_import] = ACTIONS(1433),
    [anon_sym_var] = ACTIONS(1433),
    [anon_sym_let] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_BANG] = ACTIONS(1431),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(1431),
    [anon_sym_await] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_try] = ACTIONS(1433),
    [anon_sym_with] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_debugger] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_throw] = ACTIONS(1433),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_yield] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1431),
    [anon_sym_LTtemplate_GT] = ACTIONS(1431),
    [anon_sym_LT] = ACTIONS(1433),
    [anon_sym_SLASH] = ACTIONS(1433),
    [anon_sym_class] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1433),
    [anon_sym_function] = ACTIONS(1433),
    [anon_sym_new] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_void] = ACTIONS(1433),
    [anon_sym_delete] = ACTIONS(1433),
    [anon_sym_PLUS_PLUS] = ACTIONS(1431),
    [anon_sym_DASH_DASH] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [anon_sym_SQUOTE] = ACTIONS(1431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1431),
    [sym_number] = ACTIONS(1431),
    [sym_this] = ACTIONS(1433),
    [sym_super] = ACTIONS(1433),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [sym_null] = ACTIONS(1433),
    [sym_undefined] = ACTIONS(1433),
    [anon_sym_AT] = ACTIONS(1431),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_readonly] = ACTIONS(1433),
    [anon_sym_get] = ACTIONS(1433),
    [anon_sym_set] = ACTIONS(1433),
    [anon_sym_declare] = ACTIONS(1433),
    [anon_sym_public] = ACTIONS(1433),
    [anon_sym_private] = ACTIONS(1433),
    [anon_sym_protected] = ACTIONS(1433),
    [anon_sym_override] = ACTIONS(1433),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_any] = ACTIONS(1433),
    [anon_sym_number] = ACTIONS(1433),
    [anon_sym_boolean] = ACTIONS(1433),
    [anon_sym_string] = ACTIONS(1433),
    [anon_sym_symbol] = ACTIONS(1433),
    [anon_sym_abstract] = ACTIONS(1433),
    [anon_sym_interface] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [sym__automatic_semicolon] = ACTIONS(1439),
  },
  [633] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [635] = {
    [ts_builtin_sym_end] = ACTIONS(2127),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_default] = ACTIONS(2129),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2127),
    [anon_sym_RBRACE] = ACTIONS(2127),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_else] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2127),
    [anon_sym_case] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2127),
    [anon_sym_LTtemplate_GT] = ACTIONS(2127),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2127),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2127),
    [anon_sym_DASH_DASH] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(2127),
    [anon_sym_SQUOTE] = ACTIONS(2127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2127),
    [sym_number] = ACTIONS(2127),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2127),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
  },
  [636] = {
    [ts_builtin_sym_end] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1465),
    [anon_sym_export] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_type] = ACTIONS(1465),
    [anon_sym_namespace] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1463),
    [anon_sym_typeof] = ACTIONS(1465),
    [anon_sym_import] = ACTIONS(1465),
    [anon_sym_var] = ACTIONS(1465),
    [anon_sym_let] = ACTIONS(1465),
    [anon_sym_const] = ACTIONS(1465),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_else] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_switch] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1465),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_try] = ACTIONS(1465),
    [anon_sym_with] = ACTIONS(1465),
    [anon_sym_break] = ACTIONS(1465),
    [anon_sym_continue] = ACTIONS(1465),
    [anon_sym_debugger] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(1465),
    [anon_sym_throw] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_case] = ACTIONS(1465),
    [anon_sym_yield] = ACTIONS(1465),
    [anon_sym_LBRACK] = ACTIONS(1463),
    [anon_sym_LTtemplate_GT] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1465),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_class] = ACTIONS(1465),
    [anon_sym_async] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_PLUS] = ACTIONS(1465),
    [anon_sym_DASH] = ACTIONS(1465),
    [anon_sym_TILDE] = ACTIONS(1463),
    [anon_sym_void] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(1465),
    [anon_sym_PLUS_PLUS] = ACTIONS(1463),
    [anon_sym_DASH_DASH] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [sym_number] = ACTIONS(1463),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(1465),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_undefined] = ACTIONS(1465),
    [anon_sym_AT] = ACTIONS(1463),
    [anon_sym_static] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(1465),
    [anon_sym_get] = ACTIONS(1465),
    [anon_sym_set] = ACTIONS(1465),
    [anon_sym_declare] = ACTIONS(1465),
    [anon_sym_public] = ACTIONS(1465),
    [anon_sym_private] = ACTIONS(1465),
    [anon_sym_protected] = ACTIONS(1465),
    [anon_sym_override] = ACTIONS(1465),
    [anon_sym_module] = ACTIONS(1465),
    [anon_sym_any] = ACTIONS(1465),
    [anon_sym_number] = ACTIONS(1465),
    [anon_sym_boolean] = ACTIONS(1465),
    [anon_sym_string] = ACTIONS(1465),
    [anon_sym_symbol] = ACTIONS(1465),
    [anon_sym_abstract] = ACTIONS(1465),
    [anon_sym_interface] = ACTIONS(1465),
    [anon_sym_enum] = ACTIONS(1465),
  },
  [637] = {
    [ts_builtin_sym_end] = ACTIONS(2131),
    [sym_identifier] = ACTIONS(2133),
    [anon_sym_export] = ACTIONS(2133),
    [anon_sym_default] = ACTIONS(2133),
    [anon_sym_type] = ACTIONS(2133),
    [anon_sym_namespace] = ACTIONS(2133),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_typeof] = ACTIONS(2133),
    [anon_sym_import] = ACTIONS(2133),
    [anon_sym_var] = ACTIONS(2133),
    [anon_sym_let] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_else] = ACTIONS(2133),
    [anon_sym_if] = ACTIONS(2133),
    [anon_sym_switch] = ACTIONS(2133),
    [anon_sym_for] = ACTIONS(2133),
    [anon_sym_LPAREN] = ACTIONS(2131),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_while] = ACTIONS(2133),
    [anon_sym_do] = ACTIONS(2133),
    [anon_sym_try] = ACTIONS(2133),
    [anon_sym_with] = ACTIONS(2133),
    [anon_sym_break] = ACTIONS(2133),
    [anon_sym_continue] = ACTIONS(2133),
    [anon_sym_debugger] = ACTIONS(2133),
    [anon_sym_return] = ACTIONS(2133),
    [anon_sym_throw] = ACTIONS(2133),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_case] = ACTIONS(2133),
    [anon_sym_yield] = ACTIONS(2133),
    [anon_sym_LBRACK] = ACTIONS(2131),
    [anon_sym_LTtemplate_GT] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2133),
    [anon_sym_SLASH] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2133),
    [anon_sym_async] = ACTIONS(2133),
    [anon_sym_function] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2133),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_void] = ACTIONS(2133),
    [anon_sym_delete] = ACTIONS(2133),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_number] = ACTIONS(2131),
    [sym_this] = ACTIONS(2133),
    [sym_super] = ACTIONS(2133),
    [sym_true] = ACTIONS(2133),
    [sym_false] = ACTIONS(2133),
    [sym_null] = ACTIONS(2133),
    [sym_undefined] = ACTIONS(2133),
    [anon_sym_AT] = ACTIONS(2131),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_readonly] = ACTIONS(2133),
    [anon_sym_get] = ACTIONS(2133),
    [anon_sym_set] = ACTIONS(2133),
    [anon_sym_declare] = ACTIONS(2133),
    [anon_sym_public] = ACTIONS(2133),
    [anon_sym_private] = ACTIONS(2133),
    [anon_sym_protected] = ACTIONS(2133),
    [anon_sym_override] = ACTIONS(2133),
    [anon_sym_module] = ACTIONS(2133),
    [anon_sym_any] = ACTIONS(2133),
    [anon_sym_number] = ACTIONS(2133),
    [anon_sym_boolean] = ACTIONS(2133),
    [anon_sym_string] = ACTIONS(2133),
    [anon_sym_symbol] = ACTIONS(2133),
    [anon_sym_abstract] = ACTIONS(2133),
    [anon_sym_interface] = ACTIONS(2133),
    [anon_sym_enum] = ACTIONS(2133),
  },
  [638] = {
    [ts_builtin_sym_end] = ACTIONS(2135),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_default] = ACTIONS(2137),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2135),
    [anon_sym_RBRACE] = ACTIONS(2135),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_else] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2135),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym_case] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2135),
    [anon_sym_LTtemplate_GT] = ACTIONS(2135),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2135),
    [sym_number] = ACTIONS(2135),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2135),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_readonly] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_override] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
  },
  [639] = {
    [ts_builtin_sym_end] = ACTIONS(2139),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_export] = ACTIONS(2141),
    [anon_sym_default] = ACTIONS(2141),
    [anon_sym_type] = ACTIONS(2141),
    [anon_sym_namespace] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2139),
    [anon_sym_RBRACE] = ACTIONS(2139),
    [anon_sym_typeof] = ACTIONS(2141),
    [anon_sym_import] = ACTIONS(2141),
    [anon_sym_var] = ACTIONS(2141),
    [anon_sym_let] = ACTIONS(2141),
    [anon_sym_const] = ACTIONS(2141),
    [anon_sym_BANG] = ACTIONS(2139),
    [anon_sym_else] = ACTIONS(2141),
    [anon_sym_if] = ACTIONS(2141),
    [anon_sym_switch] = ACTIONS(2141),
    [anon_sym_for] = ACTIONS(2141),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_while] = ACTIONS(2141),
    [anon_sym_do] = ACTIONS(2141),
    [anon_sym_try] = ACTIONS(2141),
    [anon_sym_with] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2141),
    [anon_sym_continue] = ACTIONS(2141),
    [anon_sym_debugger] = ACTIONS(2141),
    [anon_sym_return] = ACTIONS(2141),
    [anon_sym_throw] = ACTIONS(2141),
    [anon_sym_SEMI] = ACTIONS(2139),
    [anon_sym_case] = ACTIONS(2141),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2139),
    [anon_sym_LTtemplate_GT] = ACTIONS(2139),
    [anon_sym_LT] = ACTIONS(2141),
    [anon_sym_SLASH] = ACTIONS(2141),
    [anon_sym_class] = ACTIONS(2141),
    [anon_sym_async] = ACTIONS(2141),
    [anon_sym_function] = ACTIONS(2141),
    [anon_sym_new] = ACTIONS(2141),
    [anon_sym_PLUS] = ACTIONS(2141),
    [anon_sym_DASH] = ACTIONS(2141),
    [anon_sym_TILDE] = ACTIONS(2139),
    [anon_sym_void] = ACTIONS(2141),
    [anon_sym_delete] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2139),
    [anon_sym_DASH_DASH] = ACTIONS(2139),
    [anon_sym_DQUOTE] = ACTIONS(2139),
    [anon_sym_SQUOTE] = ACTIONS(2139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2139),
    [sym_number] = ACTIONS(2139),
    [sym_this] = ACTIONS(2141),
    [sym_super] = ACTIONS(2141),
    [sym_true] = ACTIONS(2141),
    [sym_false] = ACTIONS(2141),
    [sym_null] = ACTIONS(2141),
    [sym_undefined] = ACTIONS(2141),
    [anon_sym_AT] = ACTIONS(2139),
    [anon_sym_static] = ACTIONS(2141),
    [anon_sym_readonly] = ACTIONS(2141),
    [anon_sym_get] = ACTIONS(2141),
    [anon_sym_set] = ACTIONS(2141),
    [anon_sym_declare] = ACTIONS(2141),
    [anon_sym_public] = ACTIONS(2141),
    [anon_sym_private] = ACTIONS(2141),
    [anon_sym_protected] = ACTIONS(2141),
    [anon_sym_override] = ACTIONS(2141),
    [anon_sym_module] = ACTIONS(2141),
    [anon_sym_any] = ACTIONS(2141),
    [anon_sym_number] = ACTIONS(2141),
    [anon_sym_boolean] = ACTIONS(2141),
    [anon_sym_string] = ACTIONS(2141),
    [anon_sym_symbol] = ACTIONS(2141),
    [anon_sym_abstract] = ACTIONS(2141),
    [anon_sym_interface] = ACTIONS(2141),
    [anon_sym_enum] = ACTIONS(2141),
  },
  [640] = {
    [ts_builtin_sym_end] = ACTIONS(2143),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2143),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2143),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2143),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_LTtemplate_GT] = ACTIONS(2143),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2143),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2143),
    [anon_sym_DASH_DASH] = ACTIONS(2143),
    [anon_sym_DQUOTE] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(2143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2143),
    [sym_number] = ACTIONS(2143),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2143),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
  },
  [641] = {
    [ts_builtin_sym_end] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_default] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_else] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_case] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_LTtemplate_GT] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2147),
    [sym_number] = ACTIONS(2147),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
  },
  [642] = {
    [ts_builtin_sym_end] = ACTIONS(2151),
    [sym_identifier] = ACTIONS(2153),
    [anon_sym_export] = ACTIONS(2153),
    [anon_sym_default] = ACTIONS(2153),
    [anon_sym_type] = ACTIONS(2153),
    [anon_sym_namespace] = ACTIONS(2153),
    [anon_sym_LBRACE] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_typeof] = ACTIONS(2153),
    [anon_sym_import] = ACTIONS(2153),
    [anon_sym_var] = ACTIONS(2153),
    [anon_sym_let] = ACTIONS(2153),
    [anon_sym_const] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_else] = ACTIONS(2153),
    [anon_sym_if] = ACTIONS(2153),
    [anon_sym_switch] = ACTIONS(2153),
    [anon_sym_for] = ACTIONS(2153),
    [anon_sym_LPAREN] = ACTIONS(2151),
    [anon_sym_await] = ACTIONS(2153),
    [anon_sym_while] = ACTIONS(2153),
    [anon_sym_do] = ACTIONS(2153),
    [anon_sym_try] = ACTIONS(2153),
    [anon_sym_with] = ACTIONS(2153),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_continue] = ACTIONS(2153),
    [anon_sym_debugger] = ACTIONS(2153),
    [anon_sym_return] = ACTIONS(2153),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_case] = ACTIONS(2153),
    [anon_sym_yield] = ACTIONS(2153),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_LTtemplate_GT] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_SLASH] = ACTIONS(2153),
    [anon_sym_class] = ACTIONS(2153),
    [anon_sym_async] = ACTIONS(2153),
    [anon_sym_function] = ACTIONS(2153),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_void] = ACTIONS(2153),
    [anon_sym_delete] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_DQUOTE] = ACTIONS(2151),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2151),
    [sym_number] = ACTIONS(2151),
    [sym_this] = ACTIONS(2153),
    [sym_super] = ACTIONS(2153),
    [sym_true] = ACTIONS(2153),
    [sym_false] = ACTIONS(2153),
    [sym_null] = ACTIONS(2153),
    [sym_undefined] = ACTIONS(2153),
    [anon_sym_AT] = ACTIONS(2151),
    [anon_sym_static] = ACTIONS(2153),
    [anon_sym_readonly] = ACTIONS(2153),
    [anon_sym_get] = ACTIONS(2153),
    [anon_sym_set] = ACTIONS(2153),
    [anon_sym_declare] = ACTIONS(2153),
    [anon_sym_public] = ACTIONS(2153),
    [anon_sym_private] = ACTIONS(2153),
    [anon_sym_protected] = ACTIONS(2153),
    [anon_sym_override] = ACTIONS(2153),
    [anon_sym_module] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2153),
    [anon_sym_number] = ACTIONS(2153),
    [anon_sym_boolean] = ACTIONS(2153),
    [anon_sym_string] = ACTIONS(2153),
    [anon_sym_symbol] = ACTIONS(2153),
    [anon_sym_abstract] = ACTIONS(2153),
    [anon_sym_interface] = ACTIONS(2153),
    [anon_sym_enum] = ACTIONS(2153),
  },
  [643] = {
    [ts_builtin_sym_end] = ACTIONS(2151),
    [sym_identifier] = ACTIONS(2153),
    [anon_sym_export] = ACTIONS(2153),
    [anon_sym_default] = ACTIONS(2153),
    [anon_sym_type] = ACTIONS(2153),
    [anon_sym_namespace] = ACTIONS(2153),
    [anon_sym_LBRACE] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_typeof] = ACTIONS(2153),
    [anon_sym_import] = ACTIONS(2153),
    [anon_sym_var] = ACTIONS(2153),
    [anon_sym_let] = ACTIONS(2153),
    [anon_sym_const] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_else] = ACTIONS(2153),
    [anon_sym_if] = ACTIONS(2153),
    [anon_sym_switch] = ACTIONS(2153),
    [anon_sym_for] = ACTIONS(2153),
    [anon_sym_LPAREN] = ACTIONS(2151),
    [anon_sym_await] = ACTIONS(2153),
    [anon_sym_while] = ACTIONS(2153),
    [anon_sym_do] = ACTIONS(2153),
    [anon_sym_try] = ACTIONS(2153),
    [anon_sym_with] = ACTIONS(2153),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_continue] = ACTIONS(2153),
    [anon_sym_debugger] = ACTIONS(2153),
    [anon_sym_return] = ACTIONS(2153),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_case] = ACTIONS(2153),
    [anon_sym_yield] = ACTIONS(2153),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_LTtemplate_GT] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_SLASH] = ACTIONS(2153),
    [anon_sym_class] = ACTIONS(2153),
    [anon_sym_async] = ACTIONS(2153),
    [anon_sym_function] = ACTIONS(2153),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_void] = ACTIONS(2153),
    [anon_sym_delete] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_DQUOTE] = ACTIONS(2151),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2151),
    [sym_number] = ACTIONS(2151),
    [sym_this] = ACTIONS(2153),
    [sym_super] = ACTIONS(2153),
    [sym_true] = ACTIONS(2153),
    [sym_false] = ACTIONS(2153),
    [sym_null] = ACTIONS(2153),
    [sym_undefined] = ACTIONS(2153),
    [anon_sym_AT] = ACTIONS(2151),
    [anon_sym_static] = ACTIONS(2153),
    [anon_sym_readonly] = ACTIONS(2153),
    [anon_sym_get] = ACTIONS(2153),
    [anon_sym_set] = ACTIONS(2153),
    [anon_sym_declare] = ACTIONS(2153),
    [anon_sym_public] = ACTIONS(2153),
    [anon_sym_private] = ACTIONS(2153),
    [anon_sym_protected] = ACTIONS(2153),
    [anon_sym_override] = ACTIONS(2153),
    [anon_sym_module] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2153),
    [anon_sym_number] = ACTIONS(2153),
    [anon_sym_boolean] = ACTIONS(2153),
    [anon_sym_string] = ACTIONS(2153),
    [anon_sym_symbol] = ACTIONS(2153),
    [anon_sym_abstract] = ACTIONS(2153),
    [anon_sym_interface] = ACTIONS(2153),
    [anon_sym_enum] = ACTIONS(2153),
  },
  [644] = {
    [ts_builtin_sym_end] = ACTIONS(2155),
    [sym_identifier] = ACTIONS(2157),
    [anon_sym_export] = ACTIONS(2157),
    [anon_sym_default] = ACTIONS(2157),
    [anon_sym_type] = ACTIONS(2157),
    [anon_sym_namespace] = ACTIONS(2157),
    [anon_sym_LBRACE] = ACTIONS(2155),
    [anon_sym_RBRACE] = ACTIONS(2155),
    [anon_sym_typeof] = ACTIONS(2157),
    [anon_sym_import] = ACTIONS(2157),
    [anon_sym_var] = ACTIONS(2157),
    [anon_sym_let] = ACTIONS(2157),
    [anon_sym_const] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_else] = ACTIONS(2157),
    [anon_sym_if] = ACTIONS(2157),
    [anon_sym_switch] = ACTIONS(2157),
    [anon_sym_for] = ACTIONS(2157),
    [anon_sym_LPAREN] = ACTIONS(2155),
    [anon_sym_await] = ACTIONS(2157),
    [anon_sym_while] = ACTIONS(2157),
    [anon_sym_do] = ACTIONS(2157),
    [anon_sym_try] = ACTIONS(2157),
    [anon_sym_with] = ACTIONS(2157),
    [anon_sym_break] = ACTIONS(2157),
    [anon_sym_continue] = ACTIONS(2157),
    [anon_sym_debugger] = ACTIONS(2157),
    [anon_sym_return] = ACTIONS(2157),
    [anon_sym_throw] = ACTIONS(2157),
    [anon_sym_SEMI] = ACTIONS(2155),
    [anon_sym_case] = ACTIONS(2157),
    [anon_sym_yield] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2155),
    [anon_sym_LTtemplate_GT] = ACTIONS(2155),
    [anon_sym_LT] = ACTIONS(2157),
    [anon_sym_SLASH] = ACTIONS(2157),
    [anon_sym_class] = ACTIONS(2157),
    [anon_sym_async] = ACTIONS(2157),
    [anon_sym_function] = ACTIONS(2157),
    [anon_sym_new] = ACTIONS(2157),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_void] = ACTIONS(2157),
    [anon_sym_delete] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2155),
    [anon_sym_DASH_DASH] = ACTIONS(2155),
    [anon_sym_DQUOTE] = ACTIONS(2155),
    [anon_sym_SQUOTE] = ACTIONS(2155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [sym_number] = ACTIONS(2155),
    [sym_this] = ACTIONS(2157),
    [sym_super] = ACTIONS(2157),
    [sym_true] = ACTIONS(2157),
    [sym_false] = ACTIONS(2157),
    [sym_null] = ACTIONS(2157),
    [sym_undefined] = ACTIONS(2157),
    [anon_sym_AT] = ACTIONS(2155),
    [anon_sym_static] = ACTIONS(2157),
    [anon_sym_readonly] = ACTIONS(2157),
    [anon_sym_get] = ACTIONS(2157),
    [anon_sym_set] = ACTIONS(2157),
    [anon_sym_declare] = ACTIONS(2157),
    [anon_sym_public] = ACTIONS(2157),
    [anon_sym_private] = ACTIONS(2157),
    [anon_sym_protected] = ACTIONS(2157),
    [anon_sym_override] = ACTIONS(2157),
    [anon_sym_module] = ACTIONS(2157),
    [anon_sym_any] = ACTIONS(2157),
    [anon_sym_number] = ACTIONS(2157),
    [anon_sym_boolean] = ACTIONS(2157),
    [anon_sym_string] = ACTIONS(2157),
    [anon_sym_symbol] = ACTIONS(2157),
    [anon_sym_abstract] = ACTIONS(2157),
    [anon_sym_interface] = ACTIONS(2157),
    [anon_sym_enum] = ACTIONS(2157),
  },
  [645] = {
    [ts_builtin_sym_end] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2161),
    [anon_sym_export] = ACTIONS(2161),
    [anon_sym_default] = ACTIONS(2161),
    [anon_sym_type] = ACTIONS(2161),
    [anon_sym_namespace] = ACTIONS(2161),
    [anon_sym_LBRACE] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(2159),
    [anon_sym_typeof] = ACTIONS(2161),
    [anon_sym_import] = ACTIONS(2161),
    [anon_sym_var] = ACTIONS(2161),
    [anon_sym_let] = ACTIONS(2161),
    [anon_sym_const] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2161),
    [anon_sym_if] = ACTIONS(2161),
    [anon_sym_switch] = ACTIONS(2161),
    [anon_sym_for] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(2159),
    [anon_sym_await] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(2161),
    [anon_sym_do] = ACTIONS(2161),
    [anon_sym_try] = ACTIONS(2161),
    [anon_sym_with] = ACTIONS(2161),
    [anon_sym_break] = ACTIONS(2161),
    [anon_sym_continue] = ACTIONS(2161),
    [anon_sym_debugger] = ACTIONS(2161),
    [anon_sym_return] = ACTIONS(2161),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_SEMI] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2161),
    [anon_sym_yield] = ACTIONS(2161),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_LTtemplate_GT] = ACTIONS(2159),
    [anon_sym_LT] = ACTIONS(2161),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_class] = ACTIONS(2161),
    [anon_sym_async] = ACTIONS(2161),
    [anon_sym_function] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2161),
    [anon_sym_PLUS] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2161),
    [anon_sym_delete] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2159),
    [anon_sym_DQUOTE] = ACTIONS(2159),
    [anon_sym_SQUOTE] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2159),
    [sym_number] = ACTIONS(2159),
    [sym_this] = ACTIONS(2161),
    [sym_super] = ACTIONS(2161),
    [sym_true] = ACTIONS(2161),
    [sym_false] = ACTIONS(2161),
    [sym_null] = ACTIONS(2161),
    [sym_undefined] = ACTIONS(2161),
    [anon_sym_AT] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2161),
    [anon_sym_readonly] = ACTIONS(2161),
    [anon_sym_get] = ACTIONS(2161),
    [anon_sym_set] = ACTIONS(2161),
    [anon_sym_declare] = ACTIONS(2161),
    [anon_sym_public] = ACTIONS(2161),
    [anon_sym_private] = ACTIONS(2161),
    [anon_sym_protected] = ACTIONS(2161),
    [anon_sym_override] = ACTIONS(2161),
    [anon_sym_module] = ACTIONS(2161),
    [anon_sym_any] = ACTIONS(2161),
    [anon_sym_number] = ACTIONS(2161),
    [anon_sym_boolean] = ACTIONS(2161),
    [anon_sym_string] = ACTIONS(2161),
    [anon_sym_symbol] = ACTIONS(2161),
    [anon_sym_abstract] = ACTIONS(2161),
    [anon_sym_interface] = ACTIONS(2161),
    [anon_sym_enum] = ACTIONS(2161),
  },
  [646] = {
    [ts_builtin_sym_end] = ACTIONS(2151),
    [sym_identifier] = ACTIONS(2153),
    [anon_sym_export] = ACTIONS(2153),
    [anon_sym_default] = ACTIONS(2153),
    [anon_sym_type] = ACTIONS(2153),
    [anon_sym_namespace] = ACTIONS(2153),
    [anon_sym_LBRACE] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_typeof] = ACTIONS(2153),
    [anon_sym_import] = ACTIONS(2153),
    [anon_sym_var] = ACTIONS(2153),
    [anon_sym_let] = ACTIONS(2153),
    [anon_sym_const] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_else] = ACTIONS(2153),
    [anon_sym_if] = ACTIONS(2153),
    [anon_sym_switch] = ACTIONS(2153),
    [anon_sym_for] = ACTIONS(2153),
    [anon_sym_LPAREN] = ACTIONS(2151),
    [anon_sym_await] = ACTIONS(2153),
    [anon_sym_while] = ACTIONS(2153),
    [anon_sym_do] = ACTIONS(2153),
    [anon_sym_try] = ACTIONS(2153),
    [anon_sym_with] = ACTIONS(2153),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_continue] = ACTIONS(2153),
    [anon_sym_debugger] = ACTIONS(2153),
    [anon_sym_return] = ACTIONS(2153),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_case] = ACTIONS(2153),
    [anon_sym_yield] = ACTIONS(2153),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_LTtemplate_GT] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_SLASH] = ACTIONS(2153),
    [anon_sym_class] = ACTIONS(2153),
    [anon_sym_async] = ACTIONS(2153),
    [anon_sym_function] = ACTIONS(2153),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_void] = ACTIONS(2153),
    [anon_sym_delete] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2151),
    [anon_sym_DQUOTE] = ACTIONS(2151),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2151),
    [sym_number] = ACTIONS(2151),
    [sym_this] = ACTIONS(2153),
    [sym_super] = ACTIONS(2153),
    [sym_true] = ACTIONS(2153),
    [sym_false] = ACTIONS(2153),
    [sym_null] = ACTIONS(2153),
    [sym_undefined] = ACTIONS(2153),
    [anon_sym_AT] = ACTIONS(2151),
    [anon_sym_static] = ACTIONS(2153),
    [anon_sym_readonly] = ACTIONS(2153),
    [anon_sym_get] = ACTIONS(2153),
    [anon_sym_set] = ACTIONS(2153),
    [anon_sym_declare] = ACTIONS(2153),
    [anon_sym_public] = ACTIONS(2153),
    [anon_sym_private] = ACTIONS(2153),
    [anon_sym_protected] = ACTIONS(2153),
    [anon_sym_override] = ACTIONS(2153),
    [anon_sym_module] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2153),
    [anon_sym_number] = ACTIONS(2153),
    [anon_sym_boolean] = ACTIONS(2153),
    [anon_sym_string] = ACTIONS(2153),
    [anon_sym_symbol] = ACTIONS(2153),
    [anon_sym_abstract] = ACTIONS(2153),
    [anon_sym_interface] = ACTIONS(2153),
    [anon_sym_enum] = ACTIONS(2153),
  },
  [647] = {
    [ts_builtin_sym_end] = ACTIONS(2163),
    [sym_identifier] = ACTIONS(2165),
    [anon_sym_export] = ACTIONS(2165),
    [anon_sym_default] = ACTIONS(2165),
    [anon_sym_type] = ACTIONS(2165),
    [anon_sym_namespace] = ACTIONS(2165),
    [anon_sym_LBRACE] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2165),
    [anon_sym_import] = ACTIONS(2165),
    [anon_sym_var] = ACTIONS(2165),
    [anon_sym_let] = ACTIONS(2165),
    [anon_sym_const] = ACTIONS(2165),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2165),
    [anon_sym_if] = ACTIONS(2165),
    [anon_sym_switch] = ACTIONS(2165),
    [anon_sym_for] = ACTIONS(2165),
    [anon_sym_LPAREN] = ACTIONS(2163),
    [anon_sym_await] = ACTIONS(2165),
    [anon_sym_while] = ACTIONS(2165),
    [anon_sym_do] = ACTIONS(2165),
    [anon_sym_try] = ACTIONS(2165),
    [anon_sym_with] = ACTIONS(2165),
    [anon_sym_break] = ACTIONS(2165),
    [anon_sym_continue] = ACTIONS(2165),
    [anon_sym_debugger] = ACTIONS(2165),
    [anon_sym_return] = ACTIONS(2165),
    [anon_sym_throw] = ACTIONS(2165),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_case] = ACTIONS(2165),
    [anon_sym_yield] = ACTIONS(2165),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_LTtemplate_GT] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2165),
    [anon_sym_SLASH] = ACTIONS(2165),
    [anon_sym_class] = ACTIONS(2165),
    [anon_sym_async] = ACTIONS(2165),
    [anon_sym_function] = ACTIONS(2165),
    [anon_sym_new] = ACTIONS(2165),
    [anon_sym_PLUS] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2163),
    [anon_sym_void] = ACTIONS(2165),
    [anon_sym_delete] = ACTIONS(2165),
    [anon_sym_PLUS_PLUS] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2163),
    [anon_sym_SQUOTE] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [sym_number] = ACTIONS(2163),
    [sym_this] = ACTIONS(2165),
    [sym_super] = ACTIONS(2165),
    [sym_true] = ACTIONS(2165),
    [sym_false] = ACTIONS(2165),
    [sym_null] = ACTIONS(2165),
    [sym_undefined] = ACTIONS(2165),
    [anon_sym_AT] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2165),
    [anon_sym_readonly] = ACTIONS(2165),
    [anon_sym_get] = ACTIONS(2165),
    [anon_sym_set] = ACTIONS(2165),
    [anon_sym_declare] = ACTIONS(2165),
    [anon_sym_public] = ACTIONS(2165),
    [anon_sym_private] = ACTIONS(2165),
    [anon_sym_protected] = ACTIONS(2165),
    [anon_sym_override] = ACTIONS(2165),
    [anon_sym_module] = ACTIONS(2165),
    [anon_sym_any] = ACTIONS(2165),
    [anon_sym_number] = ACTIONS(2165),
    [anon_sym_boolean] = ACTIONS(2165),
    [anon_sym_string] = ACTIONS(2165),
    [anon_sym_symbol] = ACTIONS(2165),
    [anon_sym_abstract] = ACTIONS(2165),
    [anon_sym_interface] = ACTIONS(2165),
    [anon_sym_enum] = ACTIONS(2165),
  },
  [648] = {
    [ts_builtin_sym_end] = ACTIONS(2167),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_export] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2169),
    [anon_sym_import] = ACTIONS(2169),
    [anon_sym_var] = ACTIONS(2169),
    [anon_sym_let] = ACTIONS(2169),
    [anon_sym_const] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2169),
    [anon_sym_switch] = ACTIONS(2169),
    [anon_sym_for] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_await] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2169),
    [anon_sym_do] = ACTIONS(2169),
    [anon_sym_try] = ACTIONS(2169),
    [anon_sym_with] = ACTIONS(2169),
    [anon_sym_break] = ACTIONS(2169),
    [anon_sym_continue] = ACTIONS(2169),
    [anon_sym_debugger] = ACTIONS(2169),
    [anon_sym_return] = ACTIONS(2169),
    [anon_sym_throw] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_case] = ACTIONS(2169),
    [anon_sym_yield] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LTtemplate_GT] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_class] = ACTIONS(2169),
    [anon_sym_async] = ACTIONS(2169),
    [anon_sym_function] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_void] = ACTIONS(2169),
    [anon_sym_delete] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [sym_number] = ACTIONS(2167),
    [sym_this] = ACTIONS(2169),
    [sym_super] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_null] = ACTIONS(2169),
    [sym_undefined] = ACTIONS(2169),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2169),
    [anon_sym_readonly] = ACTIONS(2169),
    [anon_sym_get] = ACTIONS(2169),
    [anon_sym_set] = ACTIONS(2169),
    [anon_sym_declare] = ACTIONS(2169),
    [anon_sym_public] = ACTIONS(2169),
    [anon_sym_private] = ACTIONS(2169),
    [anon_sym_protected] = ACTIONS(2169),
    [anon_sym_override] = ACTIONS(2169),
    [anon_sym_module] = ACTIONS(2169),
    [anon_sym_any] = ACTIONS(2169),
    [anon_sym_number] = ACTIONS(2169),
    [anon_sym_boolean] = ACTIONS(2169),
    [anon_sym_string] = ACTIONS(2169),
    [anon_sym_symbol] = ACTIONS(2169),
    [anon_sym_abstract] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2169),
    [anon_sym_enum] = ACTIONS(2169),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1465),
    [anon_sym_export] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_type] = ACTIONS(1465),
    [anon_sym_namespace] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1463),
    [anon_sym_typeof] = ACTIONS(1465),
    [anon_sym_import] = ACTIONS(1465),
    [anon_sym_var] = ACTIONS(1465),
    [anon_sym_let] = ACTIONS(1465),
    [anon_sym_const] = ACTIONS(1465),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_else] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_switch] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1465),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_try] = ACTIONS(1465),
    [anon_sym_with] = ACTIONS(1465),
    [anon_sym_break] = ACTIONS(1465),
    [anon_sym_continue] = ACTIONS(1465),
    [anon_sym_debugger] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(1465),
    [anon_sym_throw] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_case] = ACTIONS(1465),
    [anon_sym_yield] = ACTIONS(1465),
    [anon_sym_LBRACK] = ACTIONS(1463),
    [anon_sym_LTtemplate_GT] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1465),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_class] = ACTIONS(1465),
    [anon_sym_async] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1465),
    [anon_sym_PLUS] = ACTIONS(1465),
    [anon_sym_DASH] = ACTIONS(1465),
    [anon_sym_TILDE] = ACTIONS(1463),
    [anon_sym_void] = ACTIONS(1465),
    [anon_sym_delete] = ACTIONS(1465),
    [anon_sym_PLUS_PLUS] = ACTIONS(1463),
    [anon_sym_DASH_DASH] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [sym_number] = ACTIONS(1463),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(1465),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_undefined] = ACTIONS(1465),
    [anon_sym_AT] = ACTIONS(1463),
    [anon_sym_static] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(1465),
    [anon_sym_get] = ACTIONS(1465),
    [anon_sym_set] = ACTIONS(1465),
    [anon_sym_declare] = ACTIONS(1465),
    [anon_sym_public] = ACTIONS(1465),
    [anon_sym_private] = ACTIONS(1465),
    [anon_sym_protected] = ACTIONS(1465),
    [anon_sym_override] = ACTIONS(1465),
    [anon_sym_module] = ACTIONS(1465),
    [anon_sym_any] = ACTIONS(1465),
    [anon_sym_number] = ACTIONS(1465),
    [anon_sym_boolean] = ACTIONS(1465),
    [anon_sym_string] = ACTIONS(1465),
    [anon_sym_symbol] = ACTIONS(1465),
    [anon_sym_abstract] = ACTIONS(1465),
    [anon_sym_interface] = ACTIONS(1465),
    [anon_sym_enum] = ACTIONS(1465),
  },
  [650] = {
    [ts_builtin_sym_end] = ACTIONS(2171),
    [sym_identifier] = ACTIONS(2173),
    [anon_sym_export] = ACTIONS(2173),
    [anon_sym_default] = ACTIONS(2173),
    [anon_sym_type] = ACTIONS(2173),
    [anon_sym_namespace] = ACTIONS(2173),
    [anon_sym_LBRACE] = ACTIONS(2171),
    [anon_sym_RBRACE] = ACTIONS(2171),
    [anon_sym_typeof] = ACTIONS(2173),
    [anon_sym_import] = ACTIONS(2173),
    [anon_sym_var] = ACTIONS(2173),
    [anon_sym_let] = ACTIONS(2173),
    [anon_sym_const] = ACTIONS(2173),
    [anon_sym_BANG] = ACTIONS(2171),
    [anon_sym_else] = ACTIONS(2173),
    [anon_sym_if] = ACTIONS(2173),
    [anon_sym_switch] = ACTIONS(2173),
    [anon_sym_for] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(2171),
    [anon_sym_await] = ACTIONS(2173),
    [anon_sym_while] = ACTIONS(2173),
    [anon_sym_do] = ACTIONS(2173),
    [anon_sym_try] = ACTIONS(2173),
    [anon_sym_with] = ACTIONS(2173),
    [anon_sym_break] = ACTIONS(2173),
    [anon_sym_continue] = ACTIONS(2173),
    [anon_sym_debugger] = ACTIONS(2173),
    [anon_sym_return] = ACTIONS(2173),
    [anon_sym_throw] = ACTIONS(2173),
    [anon_sym_SEMI] = ACTIONS(2171),
    [anon_sym_case] = ACTIONS(2173),
    [anon_sym_yield] = ACTIONS(2173),
    [anon_sym_LBRACK] = ACTIONS(2171),
    [anon_sym_LTtemplate_GT] = ACTIONS(2171),
    [anon_sym_LT] = ACTIONS(2173),
    [anon_sym_SLASH] = ACTIONS(2173),
    [anon_sym_class] = ACTIONS(2173),
    [anon_sym_async] = ACTIONS(2173),
    [anon_sym_function] = ACTIONS(2173),
    [anon_sym_new] = ACTIONS(2173),
    [anon_sym_PLUS] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2171),
    [anon_sym_void] = ACTIONS(2173),
    [anon_sym_delete] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2171),
    [anon_sym_DQUOTE] = ACTIONS(2171),
    [anon_sym_SQUOTE] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2171),
    [sym_number] = ACTIONS(2171),
    [sym_this] = ACTIONS(2173),
    [sym_super] = ACTIONS(2173),
    [sym_true] = ACTIONS(2173),
    [sym_false] = ACTIONS(2173),
    [sym_null] = ACTIONS(2173),
    [sym_undefined] = ACTIONS(2173),
    [anon_sym_AT] = ACTIONS(2171),
    [anon_sym_static] = ACTIONS(2173),
    [anon_sym_readonly] = ACTIONS(2173),
    [anon_sym_get] = ACTIONS(2173),
    [anon_sym_set] = ACTIONS(2173),
    [anon_sym_declare] = ACTIONS(2173),
    [anon_sym_public] = ACTIONS(2173),
    [anon_sym_private] = ACTIONS(2173),
    [anon_sym_protected] = ACTIONS(2173),
    [anon_sym_override] = ACTIONS(2173),
    [anon_sym_module] = ACTIONS(2173),
    [anon_sym_any] = ACTIONS(2173),
    [anon_sym_number] = ACTIONS(2173),
    [anon_sym_boolean] = ACTIONS(2173),
    [anon_sym_string] = ACTIONS(2173),
    [anon_sym_symbol] = ACTIONS(2173),
    [anon_sym_abstract] = ACTIONS(2173),
    [anon_sym_interface] = ACTIONS(2173),
    [anon_sym_enum] = ACTIONS(2173),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(2175),
    [sym_identifier] = ACTIONS(2177),
    [anon_sym_export] = ACTIONS(2177),
    [anon_sym_default] = ACTIONS(2177),
    [anon_sym_type] = ACTIONS(2177),
    [anon_sym_namespace] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2177),
    [anon_sym_import] = ACTIONS(2177),
    [anon_sym_var] = ACTIONS(2177),
    [anon_sym_let] = ACTIONS(2177),
    [anon_sym_const] = ACTIONS(2177),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_else] = ACTIONS(2177),
    [anon_sym_if] = ACTIONS(2177),
    [anon_sym_switch] = ACTIONS(2177),
    [anon_sym_for] = ACTIONS(2177),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_while] = ACTIONS(2177),
    [anon_sym_do] = ACTIONS(2177),
    [anon_sym_try] = ACTIONS(2177),
    [anon_sym_with] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2177),
    [anon_sym_continue] = ACTIONS(2177),
    [anon_sym_debugger] = ACTIONS(2177),
    [anon_sym_return] = ACTIONS(2177),
    [anon_sym_throw] = ACTIONS(2177),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_case] = ACTIONS(2177),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_LTtemplate_GT] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2177),
    [anon_sym_SLASH] = ACTIONS(2177),
    [anon_sym_class] = ACTIONS(2177),
    [anon_sym_async] = ACTIONS(2177),
    [anon_sym_function] = ACTIONS(2177),
    [anon_sym_new] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2177),
    [anon_sym_DASH] = ACTIONS(2177),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_void] = ACTIONS(2177),
    [anon_sym_delete] = ACTIONS(2177),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_number] = ACTIONS(2175),
    [sym_this] = ACTIONS(2177),
    [sym_super] = ACTIONS(2177),
    [sym_true] = ACTIONS(2177),
    [sym_false] = ACTIONS(2177),
    [sym_null] = ACTIONS(2177),
    [sym_undefined] = ACTIONS(2177),
    [anon_sym_AT] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2177),
    [anon_sym_readonly] = ACTIONS(2177),
    [anon_sym_get] = ACTIONS(2177),
    [anon_sym_set] = ACTIONS(2177),
    [anon_sym_declare] = ACTIONS(2177),
    [anon_sym_public] = ACTIONS(2177),
    [anon_sym_private] = ACTIONS(2177),
    [anon_sym_protected] = ACTIONS(2177),
    [anon_sym_override] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(2177),
    [anon_sym_any] = ACTIONS(2177),
    [anon_sym_number] = ACTIONS(2177),
    [anon_sym_boolean] = ACTIONS(2177),
    [anon_sym_string] = ACTIONS(2177),
    [anon_sym_symbol] = ACTIONS(2177),
    [anon_sym_abstract] = ACTIONS(2177),
    [anon_sym_interface] = ACTIONS(2177),
    [anon_sym_enum] = ACTIONS(2177),
  },
  [652] = {
    [ts_builtin_sym_end] = ACTIONS(2179),
    [sym_identifier] = ACTIONS(2181),
    [anon_sym_export] = ACTIONS(2181),
    [anon_sym_default] = ACTIONS(2181),
    [anon_sym_type] = ACTIONS(2181),
    [anon_sym_namespace] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2179),
    [anon_sym_RBRACE] = ACTIONS(2179),
    [anon_sym_typeof] = ACTIONS(2181),
    [anon_sym_import] = ACTIONS(2181),
    [anon_sym_var] = ACTIONS(2181),
    [anon_sym_let] = ACTIONS(2181),
    [anon_sym_const] = ACTIONS(2181),
    [anon_sym_BANG] = ACTIONS(2179),
    [anon_sym_else] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_switch] = ACTIONS(2181),
    [anon_sym_for] = ACTIONS(2181),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [anon_sym_await] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_try] = ACTIONS(2181),
    [anon_sym_with] = ACTIONS(2181),
    [anon_sym_break] = ACTIONS(2181),
    [anon_sym_continue] = ACTIONS(2181),
    [anon_sym_debugger] = ACTIONS(2181),
    [anon_sym_return] = ACTIONS(2181),
    [anon_sym_throw] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2179),
    [anon_sym_case] = ACTIONS(2181),
    [anon_sym_yield] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [anon_sym_LTtemplate_GT] = ACTIONS(2179),
    [anon_sym_LT] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_class] = ACTIONS(2181),
    [anon_sym_async] = ACTIONS(2181),
    [anon_sym_function] = ACTIONS(2181),
    [anon_sym_new] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_TILDE] = ACTIONS(2179),
    [anon_sym_void] = ACTIONS(2181),
    [anon_sym_delete] = ACTIONS(2181),
    [anon_sym_PLUS_PLUS] = ACTIONS(2179),
    [anon_sym_DASH_DASH] = ACTIONS(2179),
    [anon_sym_DQUOTE] = ACTIONS(2179),
    [anon_sym_SQUOTE] = ACTIONS(2179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2179),
    [sym_number] = ACTIONS(2179),
    [sym_this] = ACTIONS(2181),
    [sym_super] = ACTIONS(2181),
    [sym_true] = ACTIONS(2181),
    [sym_false] = ACTIONS(2181),
    [sym_null] = ACTIONS(2181),
    [sym_undefined] = ACTIONS(2181),
    [anon_sym_AT] = ACTIONS(2179),
    [anon_sym_static] = ACTIONS(2181),
    [anon_sym_readonly] = ACTIONS(2181),
    [anon_sym_get] = ACTIONS(2181),
    [anon_sym_set] = ACTIONS(2181),
    [anon_sym_declare] = ACTIONS(2181),
    [anon_sym_public] = ACTIONS(2181),
    [anon_sym_private] = ACTIONS(2181),
    [anon_sym_protected] = ACTIONS(2181),
    [anon_sym_override] = ACTIONS(2181),
    [anon_sym_module] = ACTIONS(2181),
    [anon_sym_any] = ACTIONS(2181),
    [anon_sym_number] = ACTIONS(2181),
    [anon_sym_boolean] = ACTIONS(2181),
    [anon_sym_string] = ACTIONS(2181),
    [anon_sym_symbol] = ACTIONS(2181),
    [anon_sym_abstract] = ACTIONS(2181),
    [anon_sym_interface] = ACTIONS(2181),
    [anon_sym_enum] = ACTIONS(2181),
  },
  [653] = {
    [ts_builtin_sym_end] = ACTIONS(2183),
    [sym_identifier] = ACTIONS(2185),
    [anon_sym_export] = ACTIONS(2185),
    [anon_sym_default] = ACTIONS(2185),
    [anon_sym_type] = ACTIONS(2185),
    [anon_sym_namespace] = ACTIONS(2185),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2185),
    [anon_sym_import] = ACTIONS(2185),
    [anon_sym_var] = ACTIONS(2185),
    [anon_sym_let] = ACTIONS(2185),
    [anon_sym_const] = ACTIONS(2185),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_else] = ACTIONS(2185),
    [anon_sym_if] = ACTIONS(2185),
    [anon_sym_switch] = ACTIONS(2185),
    [anon_sym_for] = ACTIONS(2185),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2185),
    [anon_sym_while] = ACTIONS(2185),
    [anon_sym_do] = ACTIONS(2185),
    [anon_sym_try] = ACTIONS(2185),
    [anon_sym_with] = ACTIONS(2185),
    [anon_sym_break] = ACTIONS(2185),
    [anon_sym_continue] = ACTIONS(2185),
    [anon_sym_debugger] = ACTIONS(2185),
    [anon_sym_return] = ACTIONS(2185),
    [anon_sym_throw] = ACTIONS(2185),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_case] = ACTIONS(2185),
    [anon_sym_yield] = ACTIONS(2185),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(2185),
    [anon_sym_async] = ACTIONS(2185),
    [anon_sym_function] = ACTIONS(2185),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2185),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2185),
    [anon_sym_delete] = ACTIONS(2185),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [sym_this] = ACTIONS(2185),
    [sym_super] = ACTIONS(2185),
    [sym_true] = ACTIONS(2185),
    [sym_false] = ACTIONS(2185),
    [sym_null] = ACTIONS(2185),
    [sym_undefined] = ACTIONS(2185),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2185),
    [anon_sym_readonly] = ACTIONS(2185),
    [anon_sym_get] = ACTIONS(2185),
    [anon_sym_set] = ACTIONS(2185),
    [anon_sym_declare] = ACTIONS(2185),
    [anon_sym_public] = ACTIONS(2185),
    [anon_sym_private] = ACTIONS(2185),
    [anon_sym_protected] = ACTIONS(2185),
    [anon_sym_override] = ACTIONS(2185),
    [anon_sym_module] = ACTIONS(2185),
    [anon_sym_any] = ACTIONS(2185),
    [anon_sym_number] = ACTIONS(2185),
    [anon_sym_boolean] = ACTIONS(2185),
    [anon_sym_string] = ACTIONS(2185),
    [anon_sym_symbol] = ACTIONS(2185),
    [anon_sym_abstract] = ACTIONS(2185),
    [anon_sym_interface] = ACTIONS(2185),
    [anon_sym_enum] = ACTIONS(2185),
  },
  [654] = {
    [ts_builtin_sym_end] = ACTIONS(2187),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_default] = ACTIONS(2189),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_import] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_else] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_with] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_debugger] = ACTIONS(2189),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_case] = ACTIONS(2189),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_LTtemplate_GT] = ACTIONS(2187),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_void] = ACTIONS(2189),
    [anon_sym_delete] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2187),
    [sym_number] = ACTIONS(2187),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(2189),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2187),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
  },
  [655] = {
    [ts_builtin_sym_end] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2193),
    [anon_sym_export] = ACTIONS(2193),
    [anon_sym_default] = ACTIONS(2193),
    [anon_sym_type] = ACTIONS(2193),
    [anon_sym_namespace] = ACTIONS(2193),
    [anon_sym_LBRACE] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2191),
    [anon_sym_typeof] = ACTIONS(2193),
    [anon_sym_import] = ACTIONS(2193),
    [anon_sym_var] = ACTIONS(2193),
    [anon_sym_let] = ACTIONS(2193),
    [anon_sym_const] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(2191),
    [anon_sym_else] = ACTIONS(2193),
    [anon_sym_if] = ACTIONS(2193),
    [anon_sym_switch] = ACTIONS(2193),
    [anon_sym_for] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(2191),
    [anon_sym_await] = ACTIONS(2193),
    [anon_sym_while] = ACTIONS(2193),
    [anon_sym_do] = ACTIONS(2193),
    [anon_sym_try] = ACTIONS(2193),
    [anon_sym_with] = ACTIONS(2193),
    [anon_sym_break] = ACTIONS(2193),
    [anon_sym_continue] = ACTIONS(2193),
    [anon_sym_debugger] = ACTIONS(2193),
    [anon_sym_return] = ACTIONS(2193),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_SEMI] = ACTIONS(2191),
    [anon_sym_case] = ACTIONS(2193),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_LTtemplate_GT] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_class] = ACTIONS(2193),
    [anon_sym_async] = ACTIONS(2193),
    [anon_sym_function] = ACTIONS(2193),
    [anon_sym_new] = ACTIONS(2193),
    [anon_sym_PLUS] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2191),
    [anon_sym_void] = ACTIONS(2193),
    [anon_sym_delete] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2191),
    [anon_sym_DQUOTE] = ACTIONS(2191),
    [anon_sym_SQUOTE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2191),
    [sym_number] = ACTIONS(2191),
    [sym_this] = ACTIONS(2193),
    [sym_super] = ACTIONS(2193),
    [sym_true] = ACTIONS(2193),
    [sym_false] = ACTIONS(2193),
    [sym_null] = ACTIONS(2193),
    [sym_undefined] = ACTIONS(2193),
    [anon_sym_AT] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2193),
    [anon_sym_readonly] = ACTIONS(2193),
    [anon_sym_get] = ACTIONS(2193),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_declare] = ACTIONS(2193),
    [anon_sym_public] = ACTIONS(2193),
    [anon_sym_private] = ACTIONS(2193),
    [anon_sym_protected] = ACTIONS(2193),
    [anon_sym_override] = ACTIONS(2193),
    [anon_sym_module] = ACTIONS(2193),
    [anon_sym_any] = ACTIONS(2193),
    [anon_sym_number] = ACTIONS(2193),
    [anon_sym_boolean] = ACTIONS(2193),
    [anon_sym_string] = ACTIONS(2193),
    [anon_sym_symbol] = ACTIONS(2193),
    [anon_sym_abstract] = ACTIONS(2193),
    [anon_sym_interface] = ACTIONS(2193),
    [anon_sym_enum] = ACTIONS(2193),
  },
  [656] = {
    [ts_builtin_sym_end] = ACTIONS(2195),
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_export] = ACTIONS(2197),
    [anon_sym_default] = ACTIONS(2197),
    [anon_sym_type] = ACTIONS(2197),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2195),
    [anon_sym_RBRACE] = ACTIONS(2195),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_import] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2195),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_with] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_debugger] = ACTIONS(2197),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2195),
    [anon_sym_case] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_LTtemplate_GT] = ACTIONS(2195),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_function] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2195),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2195),
    [anon_sym_DQUOTE] = ACTIONS(2195),
    [anon_sym_SQUOTE] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2195),
    [sym_number] = ACTIONS(2195),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(2197),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2195),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_declare] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_module] = ACTIONS(2197),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_boolean] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(2199),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_await] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_with] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_LTtemplate_GT] = ACTIONS(2199),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [sym_number] = ACTIONS(2199),
    [sym_this] = ACTIONS(2201),
    [sym_super] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [sym_false] = ACTIONS(2201),
    [sym_null] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_readonly] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_override] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
  },
  [658] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [659] = {
    [ts_builtin_sym_end] = ACTIONS(2203),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_default] = ACTIONS(2205),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2203),
    [anon_sym_RBRACE] = ACTIONS(2203),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_else] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2203),
    [anon_sym_case] = ACTIONS(2205),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LTtemplate_GT] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_DQUOTE] = ACTIONS(2203),
    [anon_sym_SQUOTE] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2203),
    [sym_number] = ACTIONS(2203),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_readonly] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_override] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
  },
  [660] = {
    [ts_builtin_sym_end] = ACTIONS(2207),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2209),
    [anon_sym_default] = ACTIONS(2209),
    [anon_sym_type] = ACTIONS(2209),
    [anon_sym_namespace] = ACTIONS(2209),
    [anon_sym_LBRACE] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2207),
    [anon_sym_typeof] = ACTIONS(2209),
    [anon_sym_import] = ACTIONS(2209),
    [anon_sym_var] = ACTIONS(2209),
    [anon_sym_let] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2209),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_else] = ACTIONS(2209),
    [anon_sym_if] = ACTIONS(2209),
    [anon_sym_switch] = ACTIONS(2209),
    [anon_sym_for] = ACTIONS(2209),
    [anon_sym_LPAREN] = ACTIONS(2207),
    [anon_sym_await] = ACTIONS(2209),
    [anon_sym_while] = ACTIONS(2209),
    [anon_sym_do] = ACTIONS(2209),
    [anon_sym_try] = ACTIONS(2209),
    [anon_sym_with] = ACTIONS(2209),
    [anon_sym_break] = ACTIONS(2209),
    [anon_sym_continue] = ACTIONS(2209),
    [anon_sym_debugger] = ACTIONS(2209),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_throw] = ACTIONS(2209),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_case] = ACTIONS(2209),
    [anon_sym_yield] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(2207),
    [anon_sym_LTtemplate_GT] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2209),
    [anon_sym_SLASH] = ACTIONS(2209),
    [anon_sym_class] = ACTIONS(2209),
    [anon_sym_async] = ACTIONS(2209),
    [anon_sym_function] = ACTIONS(2209),
    [anon_sym_new] = ACTIONS(2209),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2207),
    [anon_sym_void] = ACTIONS(2209),
    [anon_sym_delete] = ACTIONS(2209),
    [anon_sym_PLUS_PLUS] = ACTIONS(2207),
    [anon_sym_DASH_DASH] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [anon_sym_SQUOTE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_number] = ACTIONS(2207),
    [sym_this] = ACTIONS(2209),
    [sym_super] = ACTIONS(2209),
    [sym_true] = ACTIONS(2209),
    [sym_false] = ACTIONS(2209),
    [sym_null] = ACTIONS(2209),
    [sym_undefined] = ACTIONS(2209),
    [anon_sym_AT] = ACTIONS(2207),
    [anon_sym_static] = ACTIONS(2209),
    [anon_sym_readonly] = ACTIONS(2209),
    [anon_sym_get] = ACTIONS(2209),
    [anon_sym_set] = ACTIONS(2209),
    [anon_sym_declare] = ACTIONS(2209),
    [anon_sym_public] = ACTIONS(2209),
    [anon_sym_private] = ACTIONS(2209),
    [anon_sym_protected] = ACTIONS(2209),
    [anon_sym_override] = ACTIONS(2209),
    [anon_sym_module] = ACTIONS(2209),
    [anon_sym_any] = ACTIONS(2209),
    [anon_sym_number] = ACTIONS(2209),
    [anon_sym_boolean] = ACTIONS(2209),
    [anon_sym_string] = ACTIONS(2209),
    [anon_sym_symbol] = ACTIONS(2209),
    [anon_sym_abstract] = ACTIONS(2209),
    [anon_sym_interface] = ACTIONS(2209),
    [anon_sym_enum] = ACTIONS(2209),
  },
  [661] = {
    [ts_builtin_sym_end] = ACTIONS(2211),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_default] = ACTIONS(2213),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_else] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2211),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_case] = ACTIONS(2213),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_LTtemplate_GT] = ACTIONS(2211),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [anon_sym_SQUOTE] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [sym_number] = ACTIONS(2211),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2211),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_readonly] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_override] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
  },
  [662] = {
    [ts_builtin_sym_end] = ACTIONS(2215),
    [sym_identifier] = ACTIONS(2217),
    [anon_sym_export] = ACTIONS(2217),
    [anon_sym_default] = ACTIONS(2217),
    [anon_sym_type] = ACTIONS(2217),
    [anon_sym_namespace] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_typeof] = ACTIONS(2217),
    [anon_sym_import] = ACTIONS(2217),
    [anon_sym_var] = ACTIONS(2217),
    [anon_sym_let] = ACTIONS(2217),
    [anon_sym_const] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2215),
    [anon_sym_else] = ACTIONS(2217),
    [anon_sym_if] = ACTIONS(2217),
    [anon_sym_switch] = ACTIONS(2217),
    [anon_sym_for] = ACTIONS(2217),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_while] = ACTIONS(2217),
    [anon_sym_do] = ACTIONS(2217),
    [anon_sym_try] = ACTIONS(2217),
    [anon_sym_with] = ACTIONS(2217),
    [anon_sym_break] = ACTIONS(2217),
    [anon_sym_continue] = ACTIONS(2217),
    [anon_sym_debugger] = ACTIONS(2217),
    [anon_sym_return] = ACTIONS(2217),
    [anon_sym_throw] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_case] = ACTIONS(2217),
    [anon_sym_yield] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_LTtemplate_GT] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2217),
    [anon_sym_SLASH] = ACTIONS(2217),
    [anon_sym_class] = ACTIONS(2217),
    [anon_sym_async] = ACTIONS(2217),
    [anon_sym_function] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2215),
    [anon_sym_void] = ACTIONS(2217),
    [anon_sym_delete] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2215),
    [anon_sym_DASH_DASH] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(2215),
    [anon_sym_SQUOTE] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2215),
    [sym_number] = ACTIONS(2215),
    [sym_this] = ACTIONS(2217),
    [sym_super] = ACTIONS(2217),
    [sym_true] = ACTIONS(2217),
    [sym_false] = ACTIONS(2217),
    [sym_null] = ACTIONS(2217),
    [sym_undefined] = ACTIONS(2217),
    [anon_sym_AT] = ACTIONS(2215),
    [anon_sym_static] = ACTIONS(2217),
    [anon_sym_readonly] = ACTIONS(2217),
    [anon_sym_get] = ACTIONS(2217),
    [anon_sym_set] = ACTIONS(2217),
    [anon_sym_declare] = ACTIONS(2217),
    [anon_sym_public] = ACTIONS(2217),
    [anon_sym_private] = ACTIONS(2217),
    [anon_sym_protected] = ACTIONS(2217),
    [anon_sym_override] = ACTIONS(2217),
    [anon_sym_module] = ACTIONS(2217),
    [anon_sym_any] = ACTIONS(2217),
    [anon_sym_number] = ACTIONS(2217),
    [anon_sym_boolean] = ACTIONS(2217),
    [anon_sym_string] = ACTIONS(2217),
    [anon_sym_symbol] = ACTIONS(2217),
    [anon_sym_abstract] = ACTIONS(2217),
    [anon_sym_interface] = ACTIONS(2217),
    [anon_sym_enum] = ACTIONS(2217),
  },
  [663] = {
    [ts_builtin_sym_end] = ACTIONS(2219),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2219),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2219),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LTtemplate_GT] = ACTIONS(2219),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2219),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2219),
    [anon_sym_DASH_DASH] = ACTIONS(2219),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [anon_sym_SQUOTE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [sym_number] = ACTIONS(2219),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
  },
  [664] = {
    [ts_builtin_sym_end] = ACTIONS(2219),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2219),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2219),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LTtemplate_GT] = ACTIONS(2219),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2219),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2219),
    [anon_sym_DASH_DASH] = ACTIONS(2219),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [anon_sym_SQUOTE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [sym_number] = ACTIONS(2219),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
  },
  [665] = {
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_default] = ACTIONS(2225),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_else] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2223),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_case] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_LTtemplate_GT] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [anon_sym_SQUOTE] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [sym_number] = ACTIONS(2223),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_readonly] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_override] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
  },
  [666] = {
    [ts_builtin_sym_end] = ACTIONS(2227),
    [sym_identifier] = ACTIONS(2229),
    [anon_sym_export] = ACTIONS(2229),
    [anon_sym_default] = ACTIONS(2229),
    [anon_sym_type] = ACTIONS(2229),
    [anon_sym_namespace] = ACTIONS(2229),
    [anon_sym_LBRACE] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2227),
    [anon_sym_typeof] = ACTIONS(2229),
    [anon_sym_import] = ACTIONS(2229),
    [anon_sym_var] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_else] = ACTIONS(2229),
    [anon_sym_if] = ACTIONS(2229),
    [anon_sym_switch] = ACTIONS(2229),
    [anon_sym_for] = ACTIONS(2229),
    [anon_sym_LPAREN] = ACTIONS(2227),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_while] = ACTIONS(2229),
    [anon_sym_do] = ACTIONS(2229),
    [anon_sym_try] = ACTIONS(2229),
    [anon_sym_with] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2229),
    [anon_sym_continue] = ACTIONS(2229),
    [anon_sym_debugger] = ACTIONS(2229),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_throw] = ACTIONS(2229),
    [anon_sym_SEMI] = ACTIONS(2227),
    [anon_sym_case] = ACTIONS(2229),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2227),
    [anon_sym_LTtemplate_GT] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2229),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_class] = ACTIONS(2229),
    [anon_sym_async] = ACTIONS(2229),
    [anon_sym_function] = ACTIONS(2229),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_void] = ACTIONS(2229),
    [anon_sym_delete] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2227),
    [anon_sym_DQUOTE] = ACTIONS(2227),
    [anon_sym_SQUOTE] = ACTIONS(2227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2227),
    [sym_number] = ACTIONS(2227),
    [sym_this] = ACTIONS(2229),
    [sym_super] = ACTIONS(2229),
    [sym_true] = ACTIONS(2229),
    [sym_false] = ACTIONS(2229),
    [sym_null] = ACTIONS(2229),
    [sym_undefined] = ACTIONS(2229),
    [anon_sym_AT] = ACTIONS(2227),
    [anon_sym_static] = ACTIONS(2229),
    [anon_sym_readonly] = ACTIONS(2229),
    [anon_sym_get] = ACTIONS(2229),
    [anon_sym_set] = ACTIONS(2229),
    [anon_sym_declare] = ACTIONS(2229),
    [anon_sym_public] = ACTIONS(2229),
    [anon_sym_private] = ACTIONS(2229),
    [anon_sym_protected] = ACTIONS(2229),
    [anon_sym_override] = ACTIONS(2229),
    [anon_sym_module] = ACTIONS(2229),
    [anon_sym_any] = ACTIONS(2229),
    [anon_sym_number] = ACTIONS(2229),
    [anon_sym_boolean] = ACTIONS(2229),
    [anon_sym_string] = ACTIONS(2229),
    [anon_sym_symbol] = ACTIONS(2229),
    [anon_sym_abstract] = ACTIONS(2229),
    [anon_sym_interface] = ACTIONS(2229),
    [anon_sym_enum] = ACTIONS(2229),
  },
  [667] = {
    [ts_builtin_sym_end] = ACTIONS(2231),
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_default] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2231),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2231),
    [anon_sym_else] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2231),
    [anon_sym_case] = ACTIONS(2233),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_LTtemplate_GT] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2231),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2231),
    [anon_sym_DASH_DASH] = ACTIONS(2231),
    [anon_sym_DQUOTE] = ACTIONS(2231),
    [anon_sym_SQUOTE] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2231),
    [sym_number] = ACTIONS(2231),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_readonly] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_override] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
  },
  [668] = {
    [ts_builtin_sym_end] = ACTIONS(2235),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_default] = ACTIONS(2237),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2237),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2235),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_case] = ACTIONS(2237),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_LTtemplate_GT] = ACTIONS(2235),
    [anon_sym_LT] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2235),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2235),
    [anon_sym_DASH_DASH] = ACTIONS(2235),
    [anon_sym_DQUOTE] = ACTIONS(2235),
    [anon_sym_SQUOTE] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2235),
    [sym_number] = ACTIONS(2235),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2235),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_readonly] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_override] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
  },
  [669] = {
    [ts_builtin_sym_end] = ACTIONS(2239),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_export] = ACTIONS(2241),
    [anon_sym_default] = ACTIONS(2241),
    [anon_sym_type] = ACTIONS(2241),
    [anon_sym_namespace] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2239),
    [anon_sym_RBRACE] = ACTIONS(2239),
    [anon_sym_typeof] = ACTIONS(2241),
    [anon_sym_import] = ACTIONS(2241),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_else] = ACTIONS(2241),
    [anon_sym_if] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_for] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2239),
    [anon_sym_await] = ACTIONS(2241),
    [anon_sym_while] = ACTIONS(2241),
    [anon_sym_do] = ACTIONS(2241),
    [anon_sym_try] = ACTIONS(2241),
    [anon_sym_with] = ACTIONS(2241),
    [anon_sym_break] = ACTIONS(2241),
    [anon_sym_continue] = ACTIONS(2241),
    [anon_sym_debugger] = ACTIONS(2241),
    [anon_sym_return] = ACTIONS(2241),
    [anon_sym_throw] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2241),
    [anon_sym_yield] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_LTtemplate_GT] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [anon_sym_class] = ACTIONS(2241),
    [anon_sym_async] = ACTIONS(2241),
    [anon_sym_function] = ACTIONS(2241),
    [anon_sym_new] = ACTIONS(2241),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_void] = ACTIONS(2241),
    [anon_sym_delete] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_DQUOTE] = ACTIONS(2239),
    [anon_sym_SQUOTE] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2239),
    [sym_number] = ACTIONS(2239),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(2241),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2241),
    [anon_sym_readonly] = ACTIONS(2241),
    [anon_sym_get] = ACTIONS(2241),
    [anon_sym_set] = ACTIONS(2241),
    [anon_sym_declare] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(2241),
    [anon_sym_private] = ACTIONS(2241),
    [anon_sym_protected] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_module] = ACTIONS(2241),
    [anon_sym_any] = ACTIONS(2241),
    [anon_sym_number] = ACTIONS(2241),
    [anon_sym_boolean] = ACTIONS(2241),
    [anon_sym_string] = ACTIONS(2241),
    [anon_sym_symbol] = ACTIONS(2241),
    [anon_sym_abstract] = ACTIONS(2241),
    [anon_sym_interface] = ACTIONS(2241),
    [anon_sym_enum] = ACTIONS(2241),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(2245),
    [anon_sym_export] = ACTIONS(2245),
    [anon_sym_default] = ACTIONS(2245),
    [anon_sym_type] = ACTIONS(2245),
    [anon_sym_namespace] = ACTIONS(2245),
    [anon_sym_LBRACE] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(2243),
    [anon_sym_typeof] = ACTIONS(2245),
    [anon_sym_import] = ACTIONS(2245),
    [anon_sym_var] = ACTIONS(2245),
    [anon_sym_let] = ACTIONS(2245),
    [anon_sym_const] = ACTIONS(2245),
    [anon_sym_BANG] = ACTIONS(2243),
    [anon_sym_else] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(2245),
    [anon_sym_switch] = ACTIONS(2245),
    [anon_sym_for] = ACTIONS(2245),
    [anon_sym_LPAREN] = ACTIONS(2243),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_while] = ACTIONS(2245),
    [anon_sym_do] = ACTIONS(2245),
    [anon_sym_try] = ACTIONS(2245),
    [anon_sym_with] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(2245),
    [anon_sym_continue] = ACTIONS(2245),
    [anon_sym_debugger] = ACTIONS(2245),
    [anon_sym_return] = ACTIONS(2245),
    [anon_sym_throw] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2245),
    [anon_sym_yield] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_LTtemplate_GT] = ACTIONS(2243),
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2245),
    [anon_sym_class] = ACTIONS(2245),
    [anon_sym_async] = ACTIONS(2245),
    [anon_sym_function] = ACTIONS(2245),
    [anon_sym_new] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2245),
    [anon_sym_TILDE] = ACTIONS(2243),
    [anon_sym_void] = ACTIONS(2245),
    [anon_sym_delete] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2243),
    [anon_sym_DQUOTE] = ACTIONS(2243),
    [anon_sym_SQUOTE] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2243),
    [sym_number] = ACTIONS(2243),
    [sym_this] = ACTIONS(2245),
    [sym_super] = ACTIONS(2245),
    [sym_true] = ACTIONS(2245),
    [sym_false] = ACTIONS(2245),
    [sym_null] = ACTIONS(2245),
    [sym_undefined] = ACTIONS(2245),
    [anon_sym_AT] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2245),
    [anon_sym_readonly] = ACTIONS(2245),
    [anon_sym_get] = ACTIONS(2245),
    [anon_sym_set] = ACTIONS(2245),
    [anon_sym_declare] = ACTIONS(2245),
    [anon_sym_public] = ACTIONS(2245),
    [anon_sym_private] = ACTIONS(2245),
    [anon_sym_protected] = ACTIONS(2245),
    [anon_sym_override] = ACTIONS(2245),
    [anon_sym_module] = ACTIONS(2245),
    [anon_sym_any] = ACTIONS(2245),
    [anon_sym_number] = ACTIONS(2245),
    [anon_sym_boolean] = ACTIONS(2245),
    [anon_sym_string] = ACTIONS(2245),
    [anon_sym_symbol] = ACTIONS(2245),
    [anon_sym_abstract] = ACTIONS(2245),
    [anon_sym_interface] = ACTIONS(2245),
    [anon_sym_enum] = ACTIONS(2245),
  },
  [671] = {
    [ts_builtin_sym_end] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2249),
    [anon_sym_export] = ACTIONS(2249),
    [anon_sym_default] = ACTIONS(2249),
    [anon_sym_type] = ACTIONS(2249),
    [anon_sym_namespace] = ACTIONS(2249),
    [anon_sym_LBRACE] = ACTIONS(2247),
    [anon_sym_RBRACE] = ACTIONS(2247),
    [anon_sym_typeof] = ACTIONS(2249),
    [anon_sym_import] = ACTIONS(2249),
    [anon_sym_var] = ACTIONS(2249),
    [anon_sym_let] = ACTIONS(2249),
    [anon_sym_const] = ACTIONS(2249),
    [anon_sym_BANG] = ACTIONS(2247),
    [anon_sym_else] = ACTIONS(2249),
    [anon_sym_if] = ACTIONS(2249),
    [anon_sym_switch] = ACTIONS(2249),
    [anon_sym_for] = ACTIONS(2249),
    [anon_sym_LPAREN] = ACTIONS(2247),
    [anon_sym_await] = ACTIONS(2249),
    [anon_sym_while] = ACTIONS(2249),
    [anon_sym_do] = ACTIONS(2249),
    [anon_sym_try] = ACTIONS(2249),
    [anon_sym_with] = ACTIONS(2249),
    [anon_sym_break] = ACTIONS(2249),
    [anon_sym_continue] = ACTIONS(2249),
    [anon_sym_debugger] = ACTIONS(2249),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_throw] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym_case] = ACTIONS(2249),
    [anon_sym_yield] = ACTIONS(2249),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_LTtemplate_GT] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2249),
    [anon_sym_class] = ACTIONS(2249),
    [anon_sym_async] = ACTIONS(2249),
    [anon_sym_function] = ACTIONS(2249),
    [anon_sym_new] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2249),
    [anon_sym_TILDE] = ACTIONS(2247),
    [anon_sym_void] = ACTIONS(2249),
    [anon_sym_delete] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2247),
    [anon_sym_DASH_DASH] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [sym_number] = ACTIONS(2247),
    [sym_this] = ACTIONS(2249),
    [sym_super] = ACTIONS(2249),
    [sym_true] = ACTIONS(2249),
    [sym_false] = ACTIONS(2249),
    [sym_null] = ACTIONS(2249),
    [sym_undefined] = ACTIONS(2249),
    [anon_sym_AT] = ACTIONS(2247),
    [anon_sym_static] = ACTIONS(2249),
    [anon_sym_readonly] = ACTIONS(2249),
    [anon_sym_get] = ACTIONS(2249),
    [anon_sym_set] = ACTIONS(2249),
    [anon_sym_declare] = ACTIONS(2249),
    [anon_sym_public] = ACTIONS(2249),
    [anon_sym_private] = ACTIONS(2249),
    [anon_sym_protected] = ACTIONS(2249),
    [anon_sym_override] = ACTIONS(2249),
    [anon_sym_module] = ACTIONS(2249),
    [anon_sym_any] = ACTIONS(2249),
    [anon_sym_number] = ACTIONS(2249),
    [anon_sym_boolean] = ACTIONS(2249),
    [anon_sym_string] = ACTIONS(2249),
    [anon_sym_symbol] = ACTIONS(2249),
    [anon_sym_abstract] = ACTIONS(2249),
    [anon_sym_interface] = ACTIONS(2249),
    [anon_sym_enum] = ACTIONS(2249),
  },
  [672] = {
    [ts_builtin_sym_end] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2249),
    [anon_sym_export] = ACTIONS(2249),
    [anon_sym_default] = ACTIONS(2249),
    [anon_sym_type] = ACTIONS(2249),
    [anon_sym_namespace] = ACTIONS(2249),
    [anon_sym_LBRACE] = ACTIONS(2247),
    [anon_sym_RBRACE] = ACTIONS(2247),
    [anon_sym_typeof] = ACTIONS(2249),
    [anon_sym_import] = ACTIONS(2249),
    [anon_sym_var] = ACTIONS(2249),
    [anon_sym_let] = ACTIONS(2249),
    [anon_sym_const] = ACTIONS(2249),
    [anon_sym_BANG] = ACTIONS(2247),
    [anon_sym_else] = ACTIONS(2249),
    [anon_sym_if] = ACTIONS(2249),
    [anon_sym_switch] = ACTIONS(2249),
    [anon_sym_for] = ACTIONS(2249),
    [anon_sym_LPAREN] = ACTIONS(2247),
    [anon_sym_await] = ACTIONS(2249),
    [anon_sym_while] = ACTIONS(2249),
    [anon_sym_do] = ACTIONS(2249),
    [anon_sym_try] = ACTIONS(2249),
    [anon_sym_with] = ACTIONS(2249),
    [anon_sym_break] = ACTIONS(2249),
    [anon_sym_continue] = ACTIONS(2249),
    [anon_sym_debugger] = ACTIONS(2249),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_throw] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym_case] = ACTIONS(2249),
    [anon_sym_yield] = ACTIONS(2249),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_LTtemplate_GT] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2249),
    [anon_sym_class] = ACTIONS(2249),
    [anon_sym_async] = ACTIONS(2249),
    [anon_sym_function] = ACTIONS(2249),
    [anon_sym_new] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2249),
    [anon_sym_TILDE] = ACTIONS(2247),
    [anon_sym_void] = ACTIONS(2249),
    [anon_sym_delete] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2247),
    [anon_sym_DASH_DASH] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [sym_number] = ACTIONS(2247),
    [sym_this] = ACTIONS(2249),
    [sym_super] = ACTIONS(2249),
    [sym_true] = ACTIONS(2249),
    [sym_false] = ACTIONS(2249),
    [sym_null] = ACTIONS(2249),
    [sym_undefined] = ACTIONS(2249),
    [anon_sym_AT] = ACTIONS(2247),
    [anon_sym_static] = ACTIONS(2249),
    [anon_sym_readonly] = ACTIONS(2249),
    [anon_sym_get] = ACTIONS(2249),
    [anon_sym_set] = ACTIONS(2249),
    [anon_sym_declare] = ACTIONS(2249),
    [anon_sym_public] = ACTIONS(2249),
    [anon_sym_private] = ACTIONS(2249),
    [anon_sym_protected] = ACTIONS(2249),
    [anon_sym_override] = ACTIONS(2249),
    [anon_sym_module] = ACTIONS(2249),
    [anon_sym_any] = ACTIONS(2249),
    [anon_sym_number] = ACTIONS(2249),
    [anon_sym_boolean] = ACTIONS(2249),
    [anon_sym_string] = ACTIONS(2249),
    [anon_sym_symbol] = ACTIONS(2249),
    [anon_sym_abstract] = ACTIONS(2249),
    [anon_sym_interface] = ACTIONS(2249),
    [anon_sym_enum] = ACTIONS(2249),
  },
  [673] = {
    [ts_builtin_sym_end] = ACTIONS(2251),
    [sym_identifier] = ACTIONS(2253),
    [anon_sym_export] = ACTIONS(2253),
    [anon_sym_default] = ACTIONS(2253),
    [anon_sym_type] = ACTIONS(2253),
    [anon_sym_namespace] = ACTIONS(2253),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2253),
    [anon_sym_import] = ACTIONS(2253),
    [anon_sym_var] = ACTIONS(2253),
    [anon_sym_let] = ACTIONS(2253),
    [anon_sym_const] = ACTIONS(2253),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2253),
    [anon_sym_if] = ACTIONS(2253),
    [anon_sym_switch] = ACTIONS(2253),
    [anon_sym_for] = ACTIONS(2253),
    [anon_sym_LPAREN] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2253),
    [anon_sym_while] = ACTIONS(2253),
    [anon_sym_do] = ACTIONS(2253),
    [anon_sym_try] = ACTIONS(2253),
    [anon_sym_with] = ACTIONS(2253),
    [anon_sym_break] = ACTIONS(2253),
    [anon_sym_continue] = ACTIONS(2253),
    [anon_sym_debugger] = ACTIONS(2253),
    [anon_sym_return] = ACTIONS(2253),
    [anon_sym_throw] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2253),
    [anon_sym_yield] = ACTIONS(2253),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_LTtemplate_GT] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2253),
    [anon_sym_class] = ACTIONS(2253),
    [anon_sym_async] = ACTIONS(2253),
    [anon_sym_function] = ACTIONS(2253),
    [anon_sym_new] = ACTIONS(2253),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_DASH] = ACTIONS(2253),
    [anon_sym_TILDE] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2253),
    [anon_sym_delete] = ACTIONS(2253),
    [anon_sym_PLUS_PLUS] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_number] = ACTIONS(2251),
    [sym_this] = ACTIONS(2253),
    [sym_super] = ACTIONS(2253),
    [sym_true] = ACTIONS(2253),
    [sym_false] = ACTIONS(2253),
    [sym_null] = ACTIONS(2253),
    [sym_undefined] = ACTIONS(2253),
    [anon_sym_AT] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2253),
    [anon_sym_readonly] = ACTIONS(2253),
    [anon_sym_get] = ACTIONS(2253),
    [anon_sym_set] = ACTIONS(2253),
    [anon_sym_declare] = ACTIONS(2253),
    [anon_sym_public] = ACTIONS(2253),
    [anon_sym_private] = ACTIONS(2253),
    [anon_sym_protected] = ACTIONS(2253),
    [anon_sym_override] = ACTIONS(2253),
    [anon_sym_module] = ACTIONS(2253),
    [anon_sym_any] = ACTIONS(2253),
    [anon_sym_number] = ACTIONS(2253),
    [anon_sym_boolean] = ACTIONS(2253),
    [anon_sym_string] = ACTIONS(2253),
    [anon_sym_symbol] = ACTIONS(2253),
    [anon_sym_abstract] = ACTIONS(2253),
    [anon_sym_interface] = ACTIONS(2253),
    [anon_sym_enum] = ACTIONS(2253),
  },
  [674] = {
    [ts_builtin_sym_end] = ACTIONS(2255),
    [sym_identifier] = ACTIONS(2257),
    [anon_sym_export] = ACTIONS(2257),
    [anon_sym_default] = ACTIONS(2257),
    [anon_sym_type] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(2255),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_typeof] = ACTIONS(2257),
    [anon_sym_import] = ACTIONS(2257),
    [anon_sym_var] = ACTIONS(2257),
    [anon_sym_let] = ACTIONS(2257),
    [anon_sym_const] = ACTIONS(2257),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_else] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_switch] = ACTIONS(2257),
    [anon_sym_for] = ACTIONS(2257),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_await] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_do] = ACTIONS(2257),
    [anon_sym_try] = ACTIONS(2257),
    [anon_sym_with] = ACTIONS(2257),
    [anon_sym_break] = ACTIONS(2257),
    [anon_sym_continue] = ACTIONS(2257),
    [anon_sym_debugger] = ACTIONS(2257),
    [anon_sym_return] = ACTIONS(2257),
    [anon_sym_throw] = ACTIONS(2257),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_case] = ACTIONS(2257),
    [anon_sym_yield] = ACTIONS(2257),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LTtemplate_GT] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2257),
    [anon_sym_SLASH] = ACTIONS(2257),
    [anon_sym_class] = ACTIONS(2257),
    [anon_sym_async] = ACTIONS(2257),
    [anon_sym_function] = ACTIONS(2257),
    [anon_sym_new] = ACTIONS(2257),
    [anon_sym_PLUS] = ACTIONS(2257),
    [anon_sym_DASH] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2255),
    [anon_sym_void] = ACTIONS(2257),
    [anon_sym_delete] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [anon_sym_DQUOTE] = ACTIONS(2255),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_number] = ACTIONS(2255),
    [sym_this] = ACTIONS(2257),
    [sym_super] = ACTIONS(2257),
    [sym_true] = ACTIONS(2257),
    [sym_false] = ACTIONS(2257),
    [sym_null] = ACTIONS(2257),
    [sym_undefined] = ACTIONS(2257),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2257),
    [anon_sym_readonly] = ACTIONS(2257),
    [anon_sym_get] = ACTIONS(2257),
    [anon_sym_set] = ACTIONS(2257),
    [anon_sym_declare] = ACTIONS(2257),
    [anon_sym_public] = ACTIONS(2257),
    [anon_sym_private] = ACTIONS(2257),
    [anon_sym_protected] = ACTIONS(2257),
    [anon_sym_override] = ACTIONS(2257),
    [anon_sym_module] = ACTIONS(2257),
    [anon_sym_any] = ACTIONS(2257),
    [anon_sym_number] = ACTIONS(2257),
    [anon_sym_boolean] = ACTIONS(2257),
    [anon_sym_string] = ACTIONS(2257),
    [anon_sym_symbol] = ACTIONS(2257),
    [anon_sym_abstract] = ACTIONS(2257),
    [anon_sym_interface] = ACTIONS(2257),
    [anon_sym_enum] = ACTIONS(2257),
  },
  [675] = {
    [ts_builtin_sym_end] = ACTIONS(2259),
    [sym_identifier] = ACTIONS(2261),
    [anon_sym_export] = ACTIONS(2261),
    [anon_sym_default] = ACTIONS(2261),
    [anon_sym_type] = ACTIONS(2261),
    [anon_sym_namespace] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2259),
    [anon_sym_RBRACE] = ACTIONS(2259),
    [anon_sym_typeof] = ACTIONS(2261),
    [anon_sym_import] = ACTIONS(2261),
    [anon_sym_var] = ACTIONS(2261),
    [anon_sym_let] = ACTIONS(2261),
    [anon_sym_const] = ACTIONS(2261),
    [anon_sym_BANG] = ACTIONS(2259),
    [anon_sym_else] = ACTIONS(2261),
    [anon_sym_if] = ACTIONS(2261),
    [anon_sym_switch] = ACTIONS(2261),
    [anon_sym_for] = ACTIONS(2261),
    [anon_sym_LPAREN] = ACTIONS(2259),
    [anon_sym_await] = ACTIONS(2261),
    [anon_sym_while] = ACTIONS(2261),
    [anon_sym_do] = ACTIONS(2261),
    [anon_sym_try] = ACTIONS(2261),
    [anon_sym_with] = ACTIONS(2261),
    [anon_sym_break] = ACTIONS(2261),
    [anon_sym_continue] = ACTIONS(2261),
    [anon_sym_debugger] = ACTIONS(2261),
    [anon_sym_return] = ACTIONS(2261),
    [anon_sym_throw] = ACTIONS(2261),
    [anon_sym_SEMI] = ACTIONS(2259),
    [anon_sym_case] = ACTIONS(2261),
    [anon_sym_yield] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_LTtemplate_GT] = ACTIONS(2259),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_SLASH] = ACTIONS(2261),
    [anon_sym_class] = ACTIONS(2261),
    [anon_sym_async] = ACTIONS(2261),
    [anon_sym_function] = ACTIONS(2261),
    [anon_sym_new] = ACTIONS(2261),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2259),
    [anon_sym_void] = ACTIONS(2261),
    [anon_sym_delete] = ACTIONS(2261),
    [anon_sym_PLUS_PLUS] = ACTIONS(2259),
    [anon_sym_DASH_DASH] = ACTIONS(2259),
    [anon_sym_DQUOTE] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2259),
    [sym_number] = ACTIONS(2259),
    [sym_this] = ACTIONS(2261),
    [sym_super] = ACTIONS(2261),
    [sym_true] = ACTIONS(2261),
    [sym_false] = ACTIONS(2261),
    [sym_null] = ACTIONS(2261),
    [sym_undefined] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2259),
    [anon_sym_static] = ACTIONS(2261),
    [anon_sym_readonly] = ACTIONS(2261),
    [anon_sym_get] = ACTIONS(2261),
    [anon_sym_set] = ACTIONS(2261),
    [anon_sym_declare] = ACTIONS(2261),
    [anon_sym_public] = ACTIONS(2261),
    [anon_sym_private] = ACTIONS(2261),
    [anon_sym_protected] = ACTIONS(2261),
    [anon_sym_override] = ACTIONS(2261),
    [anon_sym_module] = ACTIONS(2261),
    [anon_sym_any] = ACTIONS(2261),
    [anon_sym_number] = ACTIONS(2261),
    [anon_sym_boolean] = ACTIONS(2261),
    [anon_sym_string] = ACTIONS(2261),
    [anon_sym_symbol] = ACTIONS(2261),
    [anon_sym_abstract] = ACTIONS(2261),
    [anon_sym_interface] = ACTIONS(2261),
    [anon_sym_enum] = ACTIONS(2261),
  },
  [676] = {
    [ts_builtin_sym_end] = ACTIONS(2263),
    [sym_identifier] = ACTIONS(2265),
    [anon_sym_export] = ACTIONS(2265),
    [anon_sym_default] = ACTIONS(2265),
    [anon_sym_type] = ACTIONS(2265),
    [anon_sym_namespace] = ACTIONS(2265),
    [anon_sym_LBRACE] = ACTIONS(2263),
    [anon_sym_RBRACE] = ACTIONS(2263),
    [anon_sym_typeof] = ACTIONS(2265),
    [anon_sym_import] = ACTIONS(2265),
    [anon_sym_var] = ACTIONS(2265),
    [anon_sym_let] = ACTIONS(2265),
    [anon_sym_const] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(2263),
    [anon_sym_else] = ACTIONS(2265),
    [anon_sym_if] = ACTIONS(2265),
    [anon_sym_switch] = ACTIONS(2265),
    [anon_sym_for] = ACTIONS(2265),
    [anon_sym_LPAREN] = ACTIONS(2263),
    [anon_sym_await] = ACTIONS(2265),
    [anon_sym_while] = ACTIONS(2265),
    [anon_sym_do] = ACTIONS(2265),
    [anon_sym_try] = ACTIONS(2265),
    [anon_sym_with] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2265),
    [anon_sym_continue] = ACTIONS(2265),
    [anon_sym_debugger] = ACTIONS(2265),
    [anon_sym_return] = ACTIONS(2265),
    [anon_sym_throw] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2263),
    [anon_sym_case] = ACTIONS(2265),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(2263),
    [anon_sym_LTtemplate_GT] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2265),
    [anon_sym_SLASH] = ACTIONS(2265),
    [anon_sym_class] = ACTIONS(2265),
    [anon_sym_async] = ACTIONS(2265),
    [anon_sym_function] = ACTIONS(2265),
    [anon_sym_new] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2263),
    [anon_sym_void] = ACTIONS(2265),
    [anon_sym_delete] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2263),
    [anon_sym_DASH_DASH] = ACTIONS(2263),
    [anon_sym_DQUOTE] = ACTIONS(2263),
    [anon_sym_SQUOTE] = ACTIONS(2263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2263),
    [sym_number] = ACTIONS(2263),
    [sym_this] = ACTIONS(2265),
    [sym_super] = ACTIONS(2265),
    [sym_true] = ACTIONS(2265),
    [sym_false] = ACTIONS(2265),
    [sym_null] = ACTIONS(2265),
    [sym_undefined] = ACTIONS(2265),
    [anon_sym_AT] = ACTIONS(2263),
    [anon_sym_static] = ACTIONS(2265),
    [anon_sym_readonly] = ACTIONS(2265),
    [anon_sym_get] = ACTIONS(2265),
    [anon_sym_set] = ACTIONS(2265),
    [anon_sym_declare] = ACTIONS(2265),
    [anon_sym_public] = ACTIONS(2265),
    [anon_sym_private] = ACTIONS(2265),
    [anon_sym_protected] = ACTIONS(2265),
    [anon_sym_override] = ACTIONS(2265),
    [anon_sym_module] = ACTIONS(2265),
    [anon_sym_any] = ACTIONS(2265),
    [anon_sym_number] = ACTIONS(2265),
    [anon_sym_boolean] = ACTIONS(2265),
    [anon_sym_string] = ACTIONS(2265),
    [anon_sym_symbol] = ACTIONS(2265),
    [anon_sym_abstract] = ACTIONS(2265),
    [anon_sym_interface] = ACTIONS(2265),
    [anon_sym_enum] = ACTIONS(2265),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(2267),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_export] = ACTIONS(2269),
    [anon_sym_default] = ACTIONS(2269),
    [anon_sym_type] = ACTIONS(2269),
    [anon_sym_namespace] = ACTIONS(2269),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_typeof] = ACTIONS(2269),
    [anon_sym_import] = ACTIONS(2269),
    [anon_sym_var] = ACTIONS(2269),
    [anon_sym_let] = ACTIONS(2269),
    [anon_sym_const] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2269),
    [anon_sym_if] = ACTIONS(2269),
    [anon_sym_switch] = ACTIONS(2269),
    [anon_sym_for] = ACTIONS(2269),
    [anon_sym_LPAREN] = ACTIONS(2267),
    [anon_sym_await] = ACTIONS(2269),
    [anon_sym_while] = ACTIONS(2269),
    [anon_sym_do] = ACTIONS(2269),
    [anon_sym_try] = ACTIONS(2269),
    [anon_sym_with] = ACTIONS(2269),
    [anon_sym_break] = ACTIONS(2269),
    [anon_sym_continue] = ACTIONS(2269),
    [anon_sym_debugger] = ACTIONS(2269),
    [anon_sym_return] = ACTIONS(2269),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2269),
    [anon_sym_yield] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_LTtemplate_GT] = ACTIONS(2267),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2269),
    [anon_sym_class] = ACTIONS(2269),
    [anon_sym_async] = ACTIONS(2269),
    [anon_sym_function] = ACTIONS(2269),
    [anon_sym_new] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_void] = ACTIONS(2269),
    [anon_sym_delete] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_DQUOTE] = ACTIONS(2267),
    [anon_sym_SQUOTE] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2267),
    [sym_number] = ACTIONS(2267),
    [sym_this] = ACTIONS(2269),
    [sym_super] = ACTIONS(2269),
    [sym_true] = ACTIONS(2269),
    [sym_false] = ACTIONS(2269),
    [sym_null] = ACTIONS(2269),
    [sym_undefined] = ACTIONS(2269),
    [anon_sym_AT] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2269),
    [anon_sym_readonly] = ACTIONS(2269),
    [anon_sym_get] = ACTIONS(2269),
    [anon_sym_set] = ACTIONS(2269),
    [anon_sym_declare] = ACTIONS(2269),
    [anon_sym_public] = ACTIONS(2269),
    [anon_sym_private] = ACTIONS(2269),
    [anon_sym_protected] = ACTIONS(2269),
    [anon_sym_override] = ACTIONS(2269),
    [anon_sym_module] = ACTIONS(2269),
    [anon_sym_any] = ACTIONS(2269),
    [anon_sym_number] = ACTIONS(2269),
    [anon_sym_boolean] = ACTIONS(2269),
    [anon_sym_string] = ACTIONS(2269),
    [anon_sym_symbol] = ACTIONS(2269),
    [anon_sym_abstract] = ACTIONS(2269),
    [anon_sym_interface] = ACTIONS(2269),
    [anon_sym_enum] = ACTIONS(2269),
  },
  [678] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_typeof] = ACTIONS(1461),
    [anon_sym_import] = ACTIONS(1461),
    [anon_sym_var] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_await] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_try] = ACTIONS(1461),
    [anon_sym_with] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_debugger] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_throw] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_yield] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LTtemplate_GT] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1461),
    [anon_sym_SLASH] = ACTIONS(1461),
    [anon_sym_class] = ACTIONS(1461),
    [anon_sym_async] = ACTIONS(1461),
    [anon_sym_function] = ACTIONS(1461),
    [anon_sym_new] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_void] = ACTIONS(1461),
    [anon_sym_delete] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(1461),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_override] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [anon_sym_abstract] = ACTIONS(1461),
    [anon_sym_interface] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
  },
  [679] = {
    [ts_builtin_sym_end] = ACTIONS(2271),
    [sym_identifier] = ACTIONS(2273),
    [anon_sym_export] = ACTIONS(2273),
    [anon_sym_default] = ACTIONS(2273),
    [anon_sym_type] = ACTIONS(2273),
    [anon_sym_namespace] = ACTIONS(2273),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_RBRACE] = ACTIONS(2271),
    [anon_sym_typeof] = ACTIONS(2273),
    [anon_sym_import] = ACTIONS(2273),
    [anon_sym_var] = ACTIONS(2273),
    [anon_sym_let] = ACTIONS(2273),
    [anon_sym_const] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2271),
    [anon_sym_else] = ACTIONS(2273),
    [anon_sym_if] = ACTIONS(2273),
    [anon_sym_switch] = ACTIONS(2273),
    [anon_sym_for] = ACTIONS(2273),
    [anon_sym_LPAREN] = ACTIONS(2271),
    [anon_sym_await] = ACTIONS(2273),
    [anon_sym_while] = ACTIONS(2273),
    [anon_sym_do] = ACTIONS(2273),
    [anon_sym_try] = ACTIONS(2273),
    [anon_sym_with] = ACTIONS(2273),
    [anon_sym_break] = ACTIONS(2273),
    [anon_sym_continue] = ACTIONS(2273),
    [anon_sym_debugger] = ACTIONS(2273),
    [anon_sym_return] = ACTIONS(2273),
    [anon_sym_throw] = ACTIONS(2273),
    [anon_sym_SEMI] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2273),
    [anon_sym_yield] = ACTIONS(2273),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_LTtemplate_GT] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(2273),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_class] = ACTIONS(2273),
    [anon_sym_async] = ACTIONS(2273),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_new] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_TILDE] = ACTIONS(2271),
    [anon_sym_void] = ACTIONS(2273),
    [anon_sym_delete] = ACTIONS(2273),
    [anon_sym_PLUS_PLUS] = ACTIONS(2271),
    [anon_sym_DASH_DASH] = ACTIONS(2271),
    [anon_sym_DQUOTE] = ACTIONS(2271),
    [anon_sym_SQUOTE] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2271),
    [sym_number] = ACTIONS(2271),
    [sym_this] = ACTIONS(2273),
    [sym_super] = ACTIONS(2273),
    [sym_true] = ACTIONS(2273),
    [sym_false] = ACTIONS(2273),
    [sym_null] = ACTIONS(2273),
    [sym_undefined] = ACTIONS(2273),
    [anon_sym_AT] = ACTIONS(2271),
    [anon_sym_static] = ACTIONS(2273),
    [anon_sym_readonly] = ACTIONS(2273),
    [anon_sym_get] = ACTIONS(2273),
    [anon_sym_set] = ACTIONS(2273),
    [anon_sym_declare] = ACTIONS(2273),
    [anon_sym_public] = ACTIONS(2273),
    [anon_sym_private] = ACTIONS(2273),
    [anon_sym_protected] = ACTIONS(2273),
    [anon_sym_override] = ACTIONS(2273),
    [anon_sym_module] = ACTIONS(2273),
    [anon_sym_any] = ACTIONS(2273),
    [anon_sym_number] = ACTIONS(2273),
    [anon_sym_boolean] = ACTIONS(2273),
    [anon_sym_string] = ACTIONS(2273),
    [anon_sym_symbol] = ACTIONS(2273),
    [anon_sym_abstract] = ACTIONS(2273),
    [anon_sym_interface] = ACTIONS(2273),
    [anon_sym_enum] = ACTIONS(2273),
  },
  [680] = {
    [ts_builtin_sym_end] = ACTIONS(2275),
    [sym_identifier] = ACTIONS(2277),
    [anon_sym_export] = ACTIONS(2277),
    [anon_sym_default] = ACTIONS(2277),
    [anon_sym_type] = ACTIONS(2277),
    [anon_sym_namespace] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2275),
    [anon_sym_RBRACE] = ACTIONS(2275),
    [anon_sym_typeof] = ACTIONS(2277),
    [anon_sym_import] = ACTIONS(2277),
    [anon_sym_var] = ACTIONS(2277),
    [anon_sym_let] = ACTIONS(2277),
    [anon_sym_const] = ACTIONS(2277),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_else] = ACTIONS(2277),
    [anon_sym_if] = ACTIONS(2277),
    [anon_sym_switch] = ACTIONS(2277),
    [anon_sym_for] = ACTIONS(2277),
    [anon_sym_LPAREN] = ACTIONS(2275),
    [anon_sym_await] = ACTIONS(2277),
    [anon_sym_while] = ACTIONS(2277),
    [anon_sym_do] = ACTIONS(2277),
    [anon_sym_try] = ACTIONS(2277),
    [anon_sym_with] = ACTIONS(2277),
    [anon_sym_break] = ACTIONS(2277),
    [anon_sym_continue] = ACTIONS(2277),
    [anon_sym_debugger] = ACTIONS(2277),
    [anon_sym_return] = ACTIONS(2277),
    [anon_sym_throw] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_case] = ACTIONS(2277),
    [anon_sym_yield] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_LTtemplate_GT] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2277),
    [anon_sym_SLASH] = ACTIONS(2277),
    [anon_sym_class] = ACTIONS(2277),
    [anon_sym_async] = ACTIONS(2277),
    [anon_sym_function] = ACTIONS(2277),
    [anon_sym_new] = ACTIONS(2277),
    [anon_sym_PLUS] = ACTIONS(2277),
    [anon_sym_DASH] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2275),
    [anon_sym_void] = ACTIONS(2277),
    [anon_sym_delete] = ACTIONS(2277),
    [anon_sym_PLUS_PLUS] = ACTIONS(2275),
    [anon_sym_DASH_DASH] = ACTIONS(2275),
    [anon_sym_DQUOTE] = ACTIONS(2275),
    [anon_sym_SQUOTE] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2275),
    [sym_number] = ACTIONS(2275),
    [sym_this] = ACTIONS(2277),
    [sym_super] = ACTIONS(2277),
    [sym_true] = ACTIONS(2277),
    [sym_false] = ACTIONS(2277),
    [sym_null] = ACTIONS(2277),
    [sym_undefined] = ACTIONS(2277),
    [anon_sym_AT] = ACTIONS(2275),
    [anon_sym_static] = ACTIONS(2277),
    [anon_sym_readonly] = ACTIONS(2277),
    [anon_sym_get] = ACTIONS(2277),
    [anon_sym_set] = ACTIONS(2277),
    [anon_sym_declare] = ACTIONS(2277),
    [anon_sym_public] = ACTIONS(2277),
    [anon_sym_private] = ACTIONS(2277),
    [anon_sym_protected] = ACTIONS(2277),
    [anon_sym_override] = ACTIONS(2277),
    [anon_sym_module] = ACTIONS(2277),
    [anon_sym_any] = ACTIONS(2277),
    [anon_sym_number] = ACTIONS(2277),
    [anon_sym_boolean] = ACTIONS(2277),
    [anon_sym_string] = ACTIONS(2277),
    [anon_sym_symbol] = ACTIONS(2277),
    [anon_sym_abstract] = ACTIONS(2277),
    [anon_sym_interface] = ACTIONS(2277),
    [anon_sym_enum] = ACTIONS(2277),
  },
  [681] = {
    [ts_builtin_sym_end] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2281),
    [anon_sym_export] = ACTIONS(2281),
    [anon_sym_default] = ACTIONS(2281),
    [anon_sym_type] = ACTIONS(2281),
    [anon_sym_namespace] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(2279),
    [anon_sym_RBRACE] = ACTIONS(2279),
    [anon_sym_typeof] = ACTIONS(2281),
    [anon_sym_import] = ACTIONS(2281),
    [anon_sym_var] = ACTIONS(2281),
    [anon_sym_let] = ACTIONS(2281),
    [anon_sym_const] = ACTIONS(2281),
    [anon_sym_BANG] = ACTIONS(2279),
    [anon_sym_else] = ACTIONS(2281),
    [anon_sym_if] = ACTIONS(2281),
    [anon_sym_switch] = ACTIONS(2281),
    [anon_sym_for] = ACTIONS(2281),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_await] = ACTIONS(2281),
    [anon_sym_while] = ACTIONS(2281),
    [anon_sym_do] = ACTIONS(2281),
    [anon_sym_try] = ACTIONS(2281),
    [anon_sym_with] = ACTIONS(2281),
    [anon_sym_break] = ACTIONS(2281),
    [anon_sym_continue] = ACTIONS(2281),
    [anon_sym_debugger] = ACTIONS(2281),
    [anon_sym_return] = ACTIONS(2281),
    [anon_sym_throw] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_case] = ACTIONS(2281),
    [anon_sym_yield] = ACTIONS(2281),
    [anon_sym_LBRACK] = ACTIONS(2279),
    [anon_sym_LTtemplate_GT] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2281),
    [anon_sym_SLASH] = ACTIONS(2281),
    [anon_sym_class] = ACTIONS(2281),
    [anon_sym_async] = ACTIONS(2281),
    [anon_sym_function] = ACTIONS(2281),
    [anon_sym_new] = ACTIONS(2281),
    [anon_sym_PLUS] = ACTIONS(2281),
    [anon_sym_DASH] = ACTIONS(2281),
    [anon_sym_TILDE] = ACTIONS(2279),
    [anon_sym_void] = ACTIONS(2281),
    [anon_sym_delete] = ACTIONS(2281),
    [anon_sym_PLUS_PLUS] = ACTIONS(2279),
    [anon_sym_DASH_DASH] = ACTIONS(2279),
    [anon_sym_DQUOTE] = ACTIONS(2279),
    [anon_sym_SQUOTE] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2279),
    [sym_number] = ACTIONS(2279),
    [sym_this] = ACTIONS(2281),
    [sym_super] = ACTIONS(2281),
    [sym_true] = ACTIONS(2281),
    [sym_false] = ACTIONS(2281),
    [sym_null] = ACTIONS(2281),
    [sym_undefined] = ACTIONS(2281),
    [anon_sym_AT] = ACTIONS(2279),
    [anon_sym_static] = ACTIONS(2281),
    [anon_sym_readonly] = ACTIONS(2281),
    [anon_sym_get] = ACTIONS(2281),
    [anon_sym_set] = ACTIONS(2281),
    [anon_sym_declare] = ACTIONS(2281),
    [anon_sym_public] = ACTIONS(2281),
    [anon_sym_private] = ACTIONS(2281),
    [anon_sym_protected] = ACTIONS(2281),
    [anon_sym_override] = ACTIONS(2281),
    [anon_sym_module] = ACTIONS(2281),
    [anon_sym_any] = ACTIONS(2281),
    [anon_sym_number] = ACTIONS(2281),
    [anon_sym_boolean] = ACTIONS(2281),
    [anon_sym_string] = ACTIONS(2281),
    [anon_sym_symbol] = ACTIONS(2281),
    [anon_sym_abstract] = ACTIONS(2281),
    [anon_sym_interface] = ACTIONS(2281),
    [anon_sym_enum] = ACTIONS(2281),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2285),
    [anon_sym_export] = ACTIONS(2285),
    [anon_sym_default] = ACTIONS(2285),
    [anon_sym_type] = ACTIONS(2285),
    [anon_sym_namespace] = ACTIONS(2285),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_RBRACE] = ACTIONS(2283),
    [anon_sym_typeof] = ACTIONS(2285),
    [anon_sym_import] = ACTIONS(2285),
    [anon_sym_var] = ACTIONS(2285),
    [anon_sym_let] = ACTIONS(2285),
    [anon_sym_const] = ACTIONS(2285),
    [anon_sym_BANG] = ACTIONS(2283),
    [anon_sym_else] = ACTIONS(2285),
    [anon_sym_if] = ACTIONS(2285),
    [anon_sym_switch] = ACTIONS(2285),
    [anon_sym_for] = ACTIONS(2285),
    [anon_sym_LPAREN] = ACTIONS(2283),
    [anon_sym_await] = ACTIONS(2285),
    [anon_sym_while] = ACTIONS(2285),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_try] = ACTIONS(2285),
    [anon_sym_with] = ACTIONS(2285),
    [anon_sym_break] = ACTIONS(2285),
    [anon_sym_continue] = ACTIONS(2285),
    [anon_sym_debugger] = ACTIONS(2285),
    [anon_sym_return] = ACTIONS(2285),
    [anon_sym_throw] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_case] = ACTIONS(2285),
    [anon_sym_yield] = ACTIONS(2285),
    [anon_sym_LBRACK] = ACTIONS(2283),
    [anon_sym_LTtemplate_GT] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2285),
    [anon_sym_SLASH] = ACTIONS(2285),
    [anon_sym_class] = ACTIONS(2285),
    [anon_sym_async] = ACTIONS(2285),
    [anon_sym_function] = ACTIONS(2285),
    [anon_sym_new] = ACTIONS(2285),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2285),
    [anon_sym_TILDE] = ACTIONS(2283),
    [anon_sym_void] = ACTIONS(2285),
    [anon_sym_delete] = ACTIONS(2285),
    [anon_sym_PLUS_PLUS] = ACTIONS(2283),
    [anon_sym_DASH_DASH] = ACTIONS(2283),
    [anon_sym_DQUOTE] = ACTIONS(2283),
    [anon_sym_SQUOTE] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2283),
    [sym_number] = ACTIONS(2283),
    [sym_this] = ACTIONS(2285),
    [sym_super] = ACTIONS(2285),
    [sym_true] = ACTIONS(2285),
    [sym_false] = ACTIONS(2285),
    [sym_null] = ACTIONS(2285),
    [sym_undefined] = ACTIONS(2285),
    [anon_sym_AT] = ACTIONS(2283),
    [anon_sym_static] = ACTIONS(2285),
    [anon_sym_readonly] = ACTIONS(2285),
    [anon_sym_get] = ACTIONS(2285),
    [anon_sym_set] = ACTIONS(2285),
    [anon_sym_declare] = ACTIONS(2285),
    [anon_sym_public] = ACTIONS(2285),
    [anon_sym_private] = ACTIONS(2285),
    [anon_sym_protected] = ACTIONS(2285),
    [anon_sym_override] = ACTIONS(2285),
    [anon_sym_module] = ACTIONS(2285),
    [anon_sym_any] = ACTIONS(2285),
    [anon_sym_number] = ACTIONS(2285),
    [anon_sym_boolean] = ACTIONS(2285),
    [anon_sym_string] = ACTIONS(2285),
    [anon_sym_symbol] = ACTIONS(2285),
    [anon_sym_abstract] = ACTIONS(2285),
    [anon_sym_interface] = ACTIONS(2285),
    [anon_sym_enum] = ACTIONS(2285),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(2287),
    [sym_identifier] = ACTIONS(2289),
    [anon_sym_export] = ACTIONS(2289),
    [anon_sym_default] = ACTIONS(2289),
    [anon_sym_type] = ACTIONS(2289),
    [anon_sym_namespace] = ACTIONS(2289),
    [anon_sym_LBRACE] = ACTIONS(2287),
    [anon_sym_RBRACE] = ACTIONS(2287),
    [anon_sym_typeof] = ACTIONS(2289),
    [anon_sym_import] = ACTIONS(2289),
    [anon_sym_var] = ACTIONS(2289),
    [anon_sym_let] = ACTIONS(2289),
    [anon_sym_const] = ACTIONS(2289),
    [anon_sym_BANG] = ACTIONS(2287),
    [anon_sym_else] = ACTIONS(2289),
    [anon_sym_if] = ACTIONS(2289),
    [anon_sym_switch] = ACTIONS(2289),
    [anon_sym_for] = ACTIONS(2289),
    [anon_sym_LPAREN] = ACTIONS(2287),
    [anon_sym_await] = ACTIONS(2289),
    [anon_sym_while] = ACTIONS(2289),
    [anon_sym_do] = ACTIONS(2289),
    [anon_sym_try] = ACTIONS(2289),
    [anon_sym_with] = ACTIONS(2289),
    [anon_sym_break] = ACTIONS(2289),
    [anon_sym_continue] = ACTIONS(2289),
    [anon_sym_debugger] = ACTIONS(2289),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_throw] = ACTIONS(2289),
    [anon_sym_SEMI] = ACTIONS(2287),
    [anon_sym_case] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2289),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_LTtemplate_GT] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2289),
    [anon_sym_SLASH] = ACTIONS(2289),
    [anon_sym_class] = ACTIONS(2289),
    [anon_sym_async] = ACTIONS(2289),
    [anon_sym_function] = ACTIONS(2289),
    [anon_sym_new] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_DASH] = ACTIONS(2289),
    [anon_sym_TILDE] = ACTIONS(2287),
    [anon_sym_void] = ACTIONS(2289),
    [anon_sym_delete] = ACTIONS(2289),
    [anon_sym_PLUS_PLUS] = ACTIONS(2287),
    [anon_sym_DASH_DASH] = ACTIONS(2287),
    [anon_sym_DQUOTE] = ACTIONS(2287),
    [anon_sym_SQUOTE] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2287),
    [sym_number] = ACTIONS(2287),
    [sym_this] = ACTIONS(2289),
    [sym_super] = ACTIONS(2289),
    [sym_true] = ACTIONS(2289),
    [sym_false] = ACTIONS(2289),
    [sym_null] = ACTIONS(2289),
    [sym_undefined] = ACTIONS(2289),
    [anon_sym_AT] = ACTIONS(2287),
    [anon_sym_static] = ACTIONS(2289),
    [anon_sym_readonly] = ACTIONS(2289),
    [anon_sym_get] = ACTIONS(2289),
    [anon_sym_set] = ACTIONS(2289),
    [anon_sym_declare] = ACTIONS(2289),
    [anon_sym_public] = ACTIONS(2289),
    [anon_sym_private] = ACTIONS(2289),
    [anon_sym_protected] = ACTIONS(2289),
    [anon_sym_override] = ACTIONS(2289),
    [anon_sym_module] = ACTIONS(2289),
    [anon_sym_any] = ACTIONS(2289),
    [anon_sym_number] = ACTIONS(2289),
    [anon_sym_boolean] = ACTIONS(2289),
    [anon_sym_string] = ACTIONS(2289),
    [anon_sym_symbol] = ACTIONS(2289),
    [anon_sym_abstract] = ACTIONS(2289),
    [anon_sym_interface] = ACTIONS(2289),
    [anon_sym_enum] = ACTIONS(2289),
  },
  [684] = {
    [ts_builtin_sym_end] = ACTIONS(2291),
    [sym_identifier] = ACTIONS(2293),
    [anon_sym_export] = ACTIONS(2293),
    [anon_sym_default] = ACTIONS(2293),
    [anon_sym_type] = ACTIONS(2293),
    [anon_sym_namespace] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2291),
    [anon_sym_RBRACE] = ACTIONS(2291),
    [anon_sym_typeof] = ACTIONS(2293),
    [anon_sym_import] = ACTIONS(2293),
    [anon_sym_var] = ACTIONS(2293),
    [anon_sym_let] = ACTIONS(2293),
    [anon_sym_const] = ACTIONS(2293),
    [anon_sym_BANG] = ACTIONS(2291),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_switch] = ACTIONS(2293),
    [anon_sym_for] = ACTIONS(2293),
    [anon_sym_LPAREN] = ACTIONS(2291),
    [anon_sym_await] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_try] = ACTIONS(2293),
    [anon_sym_with] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_continue] = ACTIONS(2293),
    [anon_sym_debugger] = ACTIONS(2293),
    [anon_sym_return] = ACTIONS(2293),
    [anon_sym_throw] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2291),
    [anon_sym_case] = ACTIONS(2293),
    [anon_sym_yield] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2291),
    [anon_sym_LTtemplate_GT] = ACTIONS(2291),
    [anon_sym_LT] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_class] = ACTIONS(2293),
    [anon_sym_async] = ACTIONS(2293),
    [anon_sym_function] = ACTIONS(2293),
    [anon_sym_new] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(2293),
    [anon_sym_TILDE] = ACTIONS(2291),
    [anon_sym_void] = ACTIONS(2293),
    [anon_sym_delete] = ACTIONS(2293),
    [anon_sym_PLUS_PLUS] = ACTIONS(2291),
    [anon_sym_DASH_DASH] = ACTIONS(2291),
    [anon_sym_DQUOTE] = ACTIONS(2291),
    [anon_sym_SQUOTE] = ACTIONS(2291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2291),
    [sym_number] = ACTIONS(2291),
    [sym_this] = ACTIONS(2293),
    [sym_super] = ACTIONS(2293),
    [sym_true] = ACTIONS(2293),
    [sym_false] = ACTIONS(2293),
    [sym_null] = ACTIONS(2293),
    [sym_undefined] = ACTIONS(2293),
    [anon_sym_AT] = ACTIONS(2291),
    [anon_sym_static] = ACTIONS(2293),
    [anon_sym_readonly] = ACTIONS(2293),
    [anon_sym_get] = ACTIONS(2293),
    [anon_sym_set] = ACTIONS(2293),
    [anon_sym_declare] = ACTIONS(2293),
    [anon_sym_public] = ACTIONS(2293),
    [anon_sym_private] = ACTIONS(2293),
    [anon_sym_protected] = ACTIONS(2293),
    [anon_sym_override] = ACTIONS(2293),
    [anon_sym_module] = ACTIONS(2293),
    [anon_sym_any] = ACTIONS(2293),
    [anon_sym_number] = ACTIONS(2293),
    [anon_sym_boolean] = ACTIONS(2293),
    [anon_sym_string] = ACTIONS(2293),
    [anon_sym_symbol] = ACTIONS(2293),
    [anon_sym_abstract] = ACTIONS(2293),
    [anon_sym_interface] = ACTIONS(2293),
    [anon_sym_enum] = ACTIONS(2293),
  },
  [685] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [686] = {
    [ts_builtin_sym_end] = ACTIONS(1471),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [anon_sym_typeof] = ACTIONS(1473),
    [anon_sym_import] = ACTIONS(1473),
    [anon_sym_var] = ACTIONS(1473),
    [anon_sym_let] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(1471),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(1471),
    [anon_sym_await] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_try] = ACTIONS(1473),
    [anon_sym_with] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_debugger] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_throw] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1471),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_yield] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1471),
    [anon_sym_LTtemplate_GT] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_SLASH] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(1473),
    [anon_sym_new] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_TILDE] = ACTIONS(1471),
    [anon_sym_void] = ACTIONS(1473),
    [anon_sym_delete] = ACTIONS(1473),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(1471),
    [anon_sym_SQUOTE] = ACTIONS(1471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [sym_number] = ACTIONS(1471),
    [sym_this] = ACTIONS(1473),
    [sym_super] = ACTIONS(1473),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [sym_null] = ACTIONS(1473),
    [sym_undefined] = ACTIONS(1473),
    [anon_sym_AT] = ACTIONS(1471),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_override] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [anon_sym_abstract] = ACTIONS(1473),
    [anon_sym_interface] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
  },
  [687] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [688] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [689] = {
    [ts_builtin_sym_end] = ACTIONS(2295),
    [sym_identifier] = ACTIONS(2297),
    [anon_sym_export] = ACTIONS(2297),
    [anon_sym_default] = ACTIONS(2297),
    [anon_sym_type] = ACTIONS(2297),
    [anon_sym_namespace] = ACTIONS(2297),
    [anon_sym_LBRACE] = ACTIONS(2295),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_typeof] = ACTIONS(2297),
    [anon_sym_import] = ACTIONS(2297),
    [anon_sym_var] = ACTIONS(2297),
    [anon_sym_let] = ACTIONS(2297),
    [anon_sym_const] = ACTIONS(2297),
    [anon_sym_BANG] = ACTIONS(2295),
    [anon_sym_else] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_switch] = ACTIONS(2297),
    [anon_sym_for] = ACTIONS(2297),
    [anon_sym_LPAREN] = ACTIONS(2295),
    [anon_sym_await] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_do] = ACTIONS(2297),
    [anon_sym_try] = ACTIONS(2297),
    [anon_sym_with] = ACTIONS(2297),
    [anon_sym_break] = ACTIONS(2297),
    [anon_sym_continue] = ACTIONS(2297),
    [anon_sym_debugger] = ACTIONS(2297),
    [anon_sym_return] = ACTIONS(2297),
    [anon_sym_throw] = ACTIONS(2297),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_case] = ACTIONS(2297),
    [anon_sym_yield] = ACTIONS(2297),
    [anon_sym_LBRACK] = ACTIONS(2295),
    [anon_sym_LTtemplate_GT] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2297),
    [anon_sym_SLASH] = ACTIONS(2297),
    [anon_sym_class] = ACTIONS(2297),
    [anon_sym_async] = ACTIONS(2297),
    [anon_sym_function] = ACTIONS(2297),
    [anon_sym_new] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_DASH] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2295),
    [anon_sym_void] = ACTIONS(2297),
    [anon_sym_delete] = ACTIONS(2297),
    [anon_sym_PLUS_PLUS] = ACTIONS(2295),
    [anon_sym_DASH_DASH] = ACTIONS(2295),
    [anon_sym_DQUOTE] = ACTIONS(2295),
    [anon_sym_SQUOTE] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2295),
    [sym_number] = ACTIONS(2295),
    [sym_this] = ACTIONS(2297),
    [sym_super] = ACTIONS(2297),
    [sym_true] = ACTIONS(2297),
    [sym_false] = ACTIONS(2297),
    [sym_null] = ACTIONS(2297),
    [sym_undefined] = ACTIONS(2297),
    [anon_sym_AT] = ACTIONS(2295),
    [anon_sym_static] = ACTIONS(2297),
    [anon_sym_readonly] = ACTIONS(2297),
    [anon_sym_get] = ACTIONS(2297),
    [anon_sym_set] = ACTIONS(2297),
    [anon_sym_declare] = ACTIONS(2297),
    [anon_sym_public] = ACTIONS(2297),
    [anon_sym_private] = ACTIONS(2297),
    [anon_sym_protected] = ACTIONS(2297),
    [anon_sym_override] = ACTIONS(2297),
    [anon_sym_module] = ACTIONS(2297),
    [anon_sym_any] = ACTIONS(2297),
    [anon_sym_number] = ACTIONS(2297),
    [anon_sym_boolean] = ACTIONS(2297),
    [anon_sym_string] = ACTIONS(2297),
    [anon_sym_symbol] = ACTIONS(2297),
    [anon_sym_abstract] = ACTIONS(2297),
    [anon_sym_interface] = ACTIONS(2297),
    [anon_sym_enum] = ACTIONS(2297),
  },
  [690] = {
    [ts_builtin_sym_end] = ACTIONS(2299),
    [sym_identifier] = ACTIONS(2301),
    [anon_sym_export] = ACTIONS(2301),
    [anon_sym_default] = ACTIONS(2301),
    [anon_sym_type] = ACTIONS(2301),
    [anon_sym_namespace] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2299),
    [anon_sym_RBRACE] = ACTIONS(2299),
    [anon_sym_typeof] = ACTIONS(2301),
    [anon_sym_import] = ACTIONS(2301),
    [anon_sym_var] = ACTIONS(2301),
    [anon_sym_let] = ACTIONS(2301),
    [anon_sym_const] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2299),
    [anon_sym_else] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(2301),
    [anon_sym_for] = ACTIONS(2301),
    [anon_sym_LPAREN] = ACTIONS(2299),
    [anon_sym_await] = ACTIONS(2301),
    [anon_sym_while] = ACTIONS(2301),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_try] = ACTIONS(2301),
    [anon_sym_with] = ACTIONS(2301),
    [anon_sym_break] = ACTIONS(2301),
    [anon_sym_continue] = ACTIONS(2301),
    [anon_sym_debugger] = ACTIONS(2301),
    [anon_sym_return] = ACTIONS(2301),
    [anon_sym_throw] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2299),
    [anon_sym_case] = ACTIONS(2301),
    [anon_sym_yield] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2299),
    [anon_sym_LTtemplate_GT] = ACTIONS(2299),
    [anon_sym_LT] = ACTIONS(2301),
    [anon_sym_SLASH] = ACTIONS(2301),
    [anon_sym_class] = ACTIONS(2301),
    [anon_sym_async] = ACTIONS(2301),
    [anon_sym_function] = ACTIONS(2301),
    [anon_sym_new] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2301),
    [anon_sym_TILDE] = ACTIONS(2299),
    [anon_sym_void] = ACTIONS(2301),
    [anon_sym_delete] = ACTIONS(2301),
    [anon_sym_PLUS_PLUS] = ACTIONS(2299),
    [anon_sym_DASH_DASH] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(2299),
    [anon_sym_SQUOTE] = ACTIONS(2299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2299),
    [sym_number] = ACTIONS(2299),
    [sym_this] = ACTIONS(2301),
    [sym_super] = ACTIONS(2301),
    [sym_true] = ACTIONS(2301),
    [sym_false] = ACTIONS(2301),
    [sym_null] = ACTIONS(2301),
    [sym_undefined] = ACTIONS(2301),
    [anon_sym_AT] = ACTIONS(2299),
    [anon_sym_static] = ACTIONS(2301),
    [anon_sym_readonly] = ACTIONS(2301),
    [anon_sym_get] = ACTIONS(2301),
    [anon_sym_set] = ACTIONS(2301),
    [anon_sym_declare] = ACTIONS(2301),
    [anon_sym_public] = ACTIONS(2301),
    [anon_sym_private] = ACTIONS(2301),
    [anon_sym_protected] = ACTIONS(2301),
    [anon_sym_override] = ACTIONS(2301),
    [anon_sym_module] = ACTIONS(2301),
    [anon_sym_any] = ACTIONS(2301),
    [anon_sym_number] = ACTIONS(2301),
    [anon_sym_boolean] = ACTIONS(2301),
    [anon_sym_string] = ACTIONS(2301),
    [anon_sym_symbol] = ACTIONS(2301),
    [anon_sym_abstract] = ACTIONS(2301),
    [anon_sym_interface] = ACTIONS(2301),
    [anon_sym_enum] = ACTIONS(2301),
  },
  [691] = {
    [ts_builtin_sym_end] = ACTIONS(2303),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_export] = ACTIONS(2305),
    [anon_sym_default] = ACTIONS(2305),
    [anon_sym_type] = ACTIONS(2305),
    [anon_sym_namespace] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2303),
    [anon_sym_RBRACE] = ACTIONS(2303),
    [anon_sym_typeof] = ACTIONS(2305),
    [anon_sym_import] = ACTIONS(2305),
    [anon_sym_var] = ACTIONS(2305),
    [anon_sym_let] = ACTIONS(2305),
    [anon_sym_const] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_else] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_switch] = ACTIONS(2305),
    [anon_sym_for] = ACTIONS(2305),
    [anon_sym_LPAREN] = ACTIONS(2303),
    [anon_sym_await] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2305),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_try] = ACTIONS(2305),
    [anon_sym_with] = ACTIONS(2305),
    [anon_sym_break] = ACTIONS(2305),
    [anon_sym_continue] = ACTIONS(2305),
    [anon_sym_debugger] = ACTIONS(2305),
    [anon_sym_return] = ACTIONS(2305),
    [anon_sym_throw] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [anon_sym_case] = ACTIONS(2305),
    [anon_sym_yield] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2303),
    [anon_sym_LTtemplate_GT] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2305),
    [anon_sym_SLASH] = ACTIONS(2305),
    [anon_sym_class] = ACTIONS(2305),
    [anon_sym_async] = ACTIONS(2305),
    [anon_sym_function] = ACTIONS(2305),
    [anon_sym_new] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2305),
    [anon_sym_TILDE] = ACTIONS(2303),
    [anon_sym_void] = ACTIONS(2305),
    [anon_sym_delete] = ACTIONS(2305),
    [anon_sym_PLUS_PLUS] = ACTIONS(2303),
    [anon_sym_DASH_DASH] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(2303),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2303),
    [sym_number] = ACTIONS(2303),
    [sym_this] = ACTIONS(2305),
    [sym_super] = ACTIONS(2305),
    [sym_true] = ACTIONS(2305),
    [sym_false] = ACTIONS(2305),
    [sym_null] = ACTIONS(2305),
    [sym_undefined] = ACTIONS(2305),
    [anon_sym_AT] = ACTIONS(2303),
    [anon_sym_static] = ACTIONS(2305),
    [anon_sym_readonly] = ACTIONS(2305),
    [anon_sym_get] = ACTIONS(2305),
    [anon_sym_set] = ACTIONS(2305),
    [anon_sym_declare] = ACTIONS(2305),
    [anon_sym_public] = ACTIONS(2305),
    [anon_sym_private] = ACTIONS(2305),
    [anon_sym_protected] = ACTIONS(2305),
    [anon_sym_override] = ACTIONS(2305),
    [anon_sym_module] = ACTIONS(2305),
    [anon_sym_any] = ACTIONS(2305),
    [anon_sym_number] = ACTIONS(2305),
    [anon_sym_boolean] = ACTIONS(2305),
    [anon_sym_string] = ACTIONS(2305),
    [anon_sym_symbol] = ACTIONS(2305),
    [anon_sym_abstract] = ACTIONS(2305),
    [anon_sym_interface] = ACTIONS(2305),
    [anon_sym_enum] = ACTIONS(2305),
  },
  [692] = {
    [ts_builtin_sym_end] = ACTIONS(2307),
    [sym_identifier] = ACTIONS(2309),
    [anon_sym_export] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2309),
    [anon_sym_type] = ACTIONS(2309),
    [anon_sym_namespace] = ACTIONS(2309),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_typeof] = ACTIONS(2309),
    [anon_sym_import] = ACTIONS(2309),
    [anon_sym_var] = ACTIONS(2309),
    [anon_sym_let] = ACTIONS(2309),
    [anon_sym_const] = ACTIONS(2309),
    [anon_sym_BANG] = ACTIONS(2307),
    [anon_sym_else] = ACTIONS(2309),
    [anon_sym_if] = ACTIONS(2309),
    [anon_sym_switch] = ACTIONS(2309),
    [anon_sym_for] = ACTIONS(2309),
    [anon_sym_LPAREN] = ACTIONS(2307),
    [anon_sym_await] = ACTIONS(2309),
    [anon_sym_while] = ACTIONS(2309),
    [anon_sym_do] = ACTIONS(2309),
    [anon_sym_try] = ACTIONS(2309),
    [anon_sym_with] = ACTIONS(2309),
    [anon_sym_break] = ACTIONS(2309),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_debugger] = ACTIONS(2309),
    [anon_sym_return] = ACTIONS(2309),
    [anon_sym_throw] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_case] = ACTIONS(2309),
    [anon_sym_yield] = ACTIONS(2309),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_LTtemplate_GT] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2309),
    [anon_sym_SLASH] = ACTIONS(2309),
    [anon_sym_class] = ACTIONS(2309),
    [anon_sym_async] = ACTIONS(2309),
    [anon_sym_function] = ACTIONS(2309),
    [anon_sym_new] = ACTIONS(2309),
    [anon_sym_PLUS] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2307),
    [anon_sym_void] = ACTIONS(2309),
    [anon_sym_delete] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [sym_number] = ACTIONS(2307),
    [sym_this] = ACTIONS(2309),
    [sym_super] = ACTIONS(2309),
    [sym_true] = ACTIONS(2309),
    [sym_false] = ACTIONS(2309),
    [sym_null] = ACTIONS(2309),
    [sym_undefined] = ACTIONS(2309),
    [anon_sym_AT] = ACTIONS(2307),
    [anon_sym_static] = ACTIONS(2309),
    [anon_sym_readonly] = ACTIONS(2309),
    [anon_sym_get] = ACTIONS(2309),
    [anon_sym_set] = ACTIONS(2309),
    [anon_sym_declare] = ACTIONS(2309),
    [anon_sym_public] = ACTIONS(2309),
    [anon_sym_private] = ACTIONS(2309),
    [anon_sym_protected] = ACTIONS(2309),
    [anon_sym_override] = ACTIONS(2309),
    [anon_sym_module] = ACTIONS(2309),
    [anon_sym_any] = ACTIONS(2309),
    [anon_sym_number] = ACTIONS(2309),
    [anon_sym_boolean] = ACTIONS(2309),
    [anon_sym_string] = ACTIONS(2309),
    [anon_sym_symbol] = ACTIONS(2309),
    [anon_sym_abstract] = ACTIONS(2309),
    [anon_sym_interface] = ACTIONS(2309),
    [anon_sym_enum] = ACTIONS(2309),
  },
  [693] = {
    [ts_builtin_sym_end] = ACTIONS(2311),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2313),
    [anon_sym_default] = ACTIONS(2313),
    [anon_sym_type] = ACTIONS(2313),
    [anon_sym_namespace] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_typeof] = ACTIONS(2313),
    [anon_sym_import] = ACTIONS(2313),
    [anon_sym_var] = ACTIONS(2313),
    [anon_sym_let] = ACTIONS(2313),
    [anon_sym_const] = ACTIONS(2313),
    [anon_sym_BANG] = ACTIONS(2311),
    [anon_sym_else] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_switch] = ACTIONS(2313),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_LPAREN] = ACTIONS(2311),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_while] = ACTIONS(2313),
    [anon_sym_do] = ACTIONS(2313),
    [anon_sym_try] = ACTIONS(2313),
    [anon_sym_with] = ACTIONS(2313),
    [anon_sym_break] = ACTIONS(2313),
    [anon_sym_continue] = ACTIONS(2313),
    [anon_sym_debugger] = ACTIONS(2313),
    [anon_sym_return] = ACTIONS(2313),
    [anon_sym_throw] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [anon_sym_case] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_LTtemplate_GT] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2313),
    [anon_sym_SLASH] = ACTIONS(2313),
    [anon_sym_class] = ACTIONS(2313),
    [anon_sym_async] = ACTIONS(2313),
    [anon_sym_function] = ACTIONS(2313),
    [anon_sym_new] = ACTIONS(2313),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_TILDE] = ACTIONS(2311),
    [anon_sym_void] = ACTIONS(2313),
    [anon_sym_delete] = ACTIONS(2313),
    [anon_sym_PLUS_PLUS] = ACTIONS(2311),
    [anon_sym_DASH_DASH] = ACTIONS(2311),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_SQUOTE] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [sym_number] = ACTIONS(2311),
    [sym_this] = ACTIONS(2313),
    [sym_super] = ACTIONS(2313),
    [sym_true] = ACTIONS(2313),
    [sym_false] = ACTIONS(2313),
    [sym_null] = ACTIONS(2313),
    [sym_undefined] = ACTIONS(2313),
    [anon_sym_AT] = ACTIONS(2311),
    [anon_sym_static] = ACTIONS(2313),
    [anon_sym_readonly] = ACTIONS(2313),
    [anon_sym_get] = ACTIONS(2313),
    [anon_sym_set] = ACTIONS(2313),
    [anon_sym_declare] = ACTIONS(2313),
    [anon_sym_public] = ACTIONS(2313),
    [anon_sym_private] = ACTIONS(2313),
    [anon_sym_protected] = ACTIONS(2313),
    [anon_sym_override] = ACTIONS(2313),
    [anon_sym_module] = ACTIONS(2313),
    [anon_sym_any] = ACTIONS(2313),
    [anon_sym_number] = ACTIONS(2313),
    [anon_sym_boolean] = ACTIONS(2313),
    [anon_sym_string] = ACTIONS(2313),
    [anon_sym_symbol] = ACTIONS(2313),
    [anon_sym_abstract] = ACTIONS(2313),
    [anon_sym_interface] = ACTIONS(2313),
    [anon_sym_enum] = ACTIONS(2313),
  },
  [694] = {
    [ts_builtin_sym_end] = ACTIONS(2315),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_export] = ACTIONS(2317),
    [anon_sym_default] = ACTIONS(2317),
    [anon_sym_type] = ACTIONS(2317),
    [anon_sym_namespace] = ACTIONS(2317),
    [anon_sym_LBRACE] = ACTIONS(2315),
    [anon_sym_RBRACE] = ACTIONS(2315),
    [anon_sym_typeof] = ACTIONS(2317),
    [anon_sym_import] = ACTIONS(2317),
    [anon_sym_var] = ACTIONS(2317),
    [anon_sym_let] = ACTIONS(2317),
    [anon_sym_const] = ACTIONS(2317),
    [anon_sym_BANG] = ACTIONS(2315),
    [anon_sym_else] = ACTIONS(2317),
    [anon_sym_if] = ACTIONS(2317),
    [anon_sym_switch] = ACTIONS(2317),
    [anon_sym_for] = ACTIONS(2317),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_await] = ACTIONS(2317),
    [anon_sym_while] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_try] = ACTIONS(2317),
    [anon_sym_with] = ACTIONS(2317),
    [anon_sym_break] = ACTIONS(2317),
    [anon_sym_continue] = ACTIONS(2317),
    [anon_sym_debugger] = ACTIONS(2317),
    [anon_sym_return] = ACTIONS(2317),
    [anon_sym_throw] = ACTIONS(2317),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_case] = ACTIONS(2317),
    [anon_sym_yield] = ACTIONS(2317),
    [anon_sym_LBRACK] = ACTIONS(2315),
    [anon_sym_LTtemplate_GT] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2317),
    [anon_sym_SLASH] = ACTIONS(2317),
    [anon_sym_class] = ACTIONS(2317),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_new] = ACTIONS(2317),
    [anon_sym_PLUS] = ACTIONS(2317),
    [anon_sym_DASH] = ACTIONS(2317),
    [anon_sym_TILDE] = ACTIONS(2315),
    [anon_sym_void] = ACTIONS(2317),
    [anon_sym_delete] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(2315),
    [anon_sym_DASH_DASH] = ACTIONS(2315),
    [anon_sym_DQUOTE] = ACTIONS(2315),
    [anon_sym_SQUOTE] = ACTIONS(2315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2315),
    [sym_number] = ACTIONS(2315),
    [sym_this] = ACTIONS(2317),
    [sym_super] = ACTIONS(2317),
    [sym_true] = ACTIONS(2317),
    [sym_false] = ACTIONS(2317),
    [sym_null] = ACTIONS(2317),
    [sym_undefined] = ACTIONS(2317),
    [anon_sym_AT] = ACTIONS(2315),
    [anon_sym_static] = ACTIONS(2317),
    [anon_sym_readonly] = ACTIONS(2317),
    [anon_sym_get] = ACTIONS(2317),
    [anon_sym_set] = ACTIONS(2317),
    [anon_sym_declare] = ACTIONS(2317),
    [anon_sym_public] = ACTIONS(2317),
    [anon_sym_private] = ACTIONS(2317),
    [anon_sym_protected] = ACTIONS(2317),
    [anon_sym_override] = ACTIONS(2317),
    [anon_sym_module] = ACTIONS(2317),
    [anon_sym_any] = ACTIONS(2317),
    [anon_sym_number] = ACTIONS(2317),
    [anon_sym_boolean] = ACTIONS(2317),
    [anon_sym_string] = ACTIONS(2317),
    [anon_sym_symbol] = ACTIONS(2317),
    [anon_sym_abstract] = ACTIONS(2317),
    [anon_sym_interface] = ACTIONS(2317),
    [anon_sym_enum] = ACTIONS(2317),
  },
  [695] = {
    [ts_builtin_sym_end] = ACTIONS(2315),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_export] = ACTIONS(2317),
    [anon_sym_default] = ACTIONS(2317),
    [anon_sym_type] = ACTIONS(2317),
    [anon_sym_namespace] = ACTIONS(2317),
    [anon_sym_LBRACE] = ACTIONS(2315),
    [anon_sym_RBRACE] = ACTIONS(2315),
    [anon_sym_typeof] = ACTIONS(2317),
    [anon_sym_import] = ACTIONS(2317),
    [anon_sym_var] = ACTIONS(2317),
    [anon_sym_let] = ACTIONS(2317),
    [anon_sym_const] = ACTIONS(2317),
    [anon_sym_BANG] = ACTIONS(2315),
    [anon_sym_else] = ACTIONS(2317),
    [anon_sym_if] = ACTIONS(2317),
    [anon_sym_switch] = ACTIONS(2317),
    [anon_sym_for] = ACTIONS(2317),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_await] = ACTIONS(2317),
    [anon_sym_while] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_try] = ACTIONS(2317),
    [anon_sym_with] = ACTIONS(2317),
    [anon_sym_break] = ACTIONS(2317),
    [anon_sym_continue] = ACTIONS(2317),
    [anon_sym_debugger] = ACTIONS(2317),
    [anon_sym_return] = ACTIONS(2317),
    [anon_sym_throw] = ACTIONS(2317),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_case] = ACTIONS(2317),
    [anon_sym_yield] = ACTIONS(2317),
    [anon_sym_LBRACK] = ACTIONS(2315),
    [anon_sym_LTtemplate_GT] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2317),
    [anon_sym_SLASH] = ACTIONS(2317),
    [anon_sym_class] = ACTIONS(2317),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_new] = ACTIONS(2317),
    [anon_sym_PLUS] = ACTIONS(2317),
    [anon_sym_DASH] = ACTIONS(2317),
    [anon_sym_TILDE] = ACTIONS(2315),
    [anon_sym_void] = ACTIONS(2317),
    [anon_sym_delete] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(2315),
    [anon_sym_DASH_DASH] = ACTIONS(2315),
    [anon_sym_DQUOTE] = ACTIONS(2315),
    [anon_sym_SQUOTE] = ACTIONS(2315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2315),
    [sym_number] = ACTIONS(2315),
    [sym_this] = ACTIONS(2317),
    [sym_super] = ACTIONS(2317),
    [sym_true] = ACTIONS(2317),
    [sym_false] = ACTIONS(2317),
    [sym_null] = ACTIONS(2317),
    [sym_undefined] = ACTIONS(2317),
    [anon_sym_AT] = ACTIONS(2315),
    [anon_sym_static] = ACTIONS(2317),
    [anon_sym_readonly] = ACTIONS(2317),
    [anon_sym_get] = ACTIONS(2317),
    [anon_sym_set] = ACTIONS(2317),
    [anon_sym_declare] = ACTIONS(2317),
    [anon_sym_public] = ACTIONS(2317),
    [anon_sym_private] = ACTIONS(2317),
    [anon_sym_protected] = ACTIONS(2317),
    [anon_sym_override] = ACTIONS(2317),
    [anon_sym_module] = ACTIONS(2317),
    [anon_sym_any] = ACTIONS(2317),
    [anon_sym_number] = ACTIONS(2317),
    [anon_sym_boolean] = ACTIONS(2317),
    [anon_sym_string] = ACTIONS(2317),
    [anon_sym_symbol] = ACTIONS(2317),
    [anon_sym_abstract] = ACTIONS(2317),
    [anon_sym_interface] = ACTIONS(2317),
    [anon_sym_enum] = ACTIONS(2317),
  },
  [696] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [697] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [698] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2321),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_type] = ACTIONS(2321),
    [anon_sym_namespace] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_typeof] = ACTIONS(2321),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_var] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_const] = ACTIONS(2321),
    [anon_sym_BANG] = ACTIONS(2319),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_switch] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_await] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_break] = ACTIONS(2321),
    [anon_sym_continue] = ACTIONS(2321),
    [anon_sym_debugger] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_throw] = ACTIONS(2321),
    [anon_sym_SEMI] = ACTIONS(2319),
    [anon_sym_case] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_LTtemplate_GT] = ACTIONS(2319),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_void] = ACTIONS(2321),
    [anon_sym_delete] = ACTIONS(2321),
    [anon_sym_PLUS_PLUS] = ACTIONS(2319),
    [anon_sym_DASH_DASH] = ACTIONS(2319),
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [sym_number] = ACTIONS(2319),
    [sym_this] = ACTIONS(2321),
    [sym_super] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_null] = ACTIONS(2321),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_static] = ACTIONS(2321),
    [anon_sym_readonly] = ACTIONS(2321),
    [anon_sym_get] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(2321),
    [anon_sym_declare] = ACTIONS(2321),
    [anon_sym_public] = ACTIONS(2321),
    [anon_sym_private] = ACTIONS(2321),
    [anon_sym_protected] = ACTIONS(2321),
    [anon_sym_override] = ACTIONS(2321),
    [anon_sym_module] = ACTIONS(2321),
    [anon_sym_any] = ACTIONS(2321),
    [anon_sym_number] = ACTIONS(2321),
    [anon_sym_boolean] = ACTIONS(2321),
    [anon_sym_string] = ACTIONS(2321),
    [anon_sym_symbol] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_interface] = ACTIONS(2321),
    [anon_sym_enum] = ACTIONS(2321),
  },
  [699] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2321),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_type] = ACTIONS(2321),
    [anon_sym_namespace] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_typeof] = ACTIONS(2321),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_var] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_const] = ACTIONS(2321),
    [anon_sym_BANG] = ACTIONS(2319),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_switch] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_await] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_break] = ACTIONS(2321),
    [anon_sym_continue] = ACTIONS(2321),
    [anon_sym_debugger] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_throw] = ACTIONS(2321),
    [anon_sym_SEMI] = ACTIONS(2319),
    [anon_sym_case] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_LTtemplate_GT] = ACTIONS(2319),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_void] = ACTIONS(2321),
    [anon_sym_delete] = ACTIONS(2321),
    [anon_sym_PLUS_PLUS] = ACTIONS(2319),
    [anon_sym_DASH_DASH] = ACTIONS(2319),
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [sym_number] = ACTIONS(2319),
    [sym_this] = ACTIONS(2321),
    [sym_super] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_null] = ACTIONS(2321),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_static] = ACTIONS(2321),
    [anon_sym_readonly] = ACTIONS(2321),
    [anon_sym_get] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(2321),
    [anon_sym_declare] = ACTIONS(2321),
    [anon_sym_public] = ACTIONS(2321),
    [anon_sym_private] = ACTIONS(2321),
    [anon_sym_protected] = ACTIONS(2321),
    [anon_sym_override] = ACTIONS(2321),
    [anon_sym_module] = ACTIONS(2321),
    [anon_sym_any] = ACTIONS(2321),
    [anon_sym_number] = ACTIONS(2321),
    [anon_sym_boolean] = ACTIONS(2321),
    [anon_sym_string] = ACTIONS(2321),
    [anon_sym_symbol] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_interface] = ACTIONS(2321),
    [anon_sym_enum] = ACTIONS(2321),
  },
  [700] = {
    [ts_builtin_sym_end] = ACTIONS(2323),
    [sym_identifier] = ACTIONS(2325),
    [anon_sym_export] = ACTIONS(2325),
    [anon_sym_default] = ACTIONS(2325),
    [anon_sym_type] = ACTIONS(2325),
    [anon_sym_namespace] = ACTIONS(2325),
    [anon_sym_LBRACE] = ACTIONS(2323),
    [anon_sym_RBRACE] = ACTIONS(2323),
    [anon_sym_typeof] = ACTIONS(2325),
    [anon_sym_import] = ACTIONS(2325),
    [anon_sym_var] = ACTIONS(2325),
    [anon_sym_let] = ACTIONS(2325),
    [anon_sym_const] = ACTIONS(2325),
    [anon_sym_BANG] = ACTIONS(2323),
    [anon_sym_else] = ACTIONS(2325),
    [anon_sym_if] = ACTIONS(2325),
    [anon_sym_switch] = ACTIONS(2325),
    [anon_sym_for] = ACTIONS(2325),
    [anon_sym_LPAREN] = ACTIONS(2323),
    [anon_sym_await] = ACTIONS(2325),
    [anon_sym_while] = ACTIONS(2325),
    [anon_sym_do] = ACTIONS(2325),
    [anon_sym_try] = ACTIONS(2325),
    [anon_sym_with] = ACTIONS(2325),
    [anon_sym_break] = ACTIONS(2325),
    [anon_sym_continue] = ACTIONS(2325),
    [anon_sym_debugger] = ACTIONS(2325),
    [anon_sym_return] = ACTIONS(2325),
    [anon_sym_throw] = ACTIONS(2325),
    [anon_sym_SEMI] = ACTIONS(2323),
    [anon_sym_case] = ACTIONS(2325),
    [anon_sym_yield] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LTtemplate_GT] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2325),
    [anon_sym_SLASH] = ACTIONS(2325),
    [anon_sym_class] = ACTIONS(2325),
    [anon_sym_async] = ACTIONS(2325),
    [anon_sym_function] = ACTIONS(2325),
    [anon_sym_new] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2325),
    [anon_sym_delete] = ACTIONS(2325),
    [anon_sym_PLUS_PLUS] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [anon_sym_SQUOTE] = ACTIONS(2323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2323),
    [sym_number] = ACTIONS(2323),
    [sym_this] = ACTIONS(2325),
    [sym_super] = ACTIONS(2325),
    [sym_true] = ACTIONS(2325),
    [sym_false] = ACTIONS(2325),
    [sym_null] = ACTIONS(2325),
    [sym_undefined] = ACTIONS(2325),
    [anon_sym_AT] = ACTIONS(2323),
    [anon_sym_static] = ACTIONS(2325),
    [anon_sym_readonly] = ACTIONS(2325),
    [anon_sym_get] = ACTIONS(2325),
    [anon_sym_set] = ACTIONS(2325),
    [anon_sym_declare] = ACTIONS(2325),
    [anon_sym_public] = ACTIONS(2325),
    [anon_sym_private] = ACTIONS(2325),
    [anon_sym_protected] = ACTIONS(2325),
    [anon_sym_override] = ACTIONS(2325),
    [anon_sym_module] = ACTIONS(2325),
    [anon_sym_any] = ACTIONS(2325),
    [anon_sym_number] = ACTIONS(2325),
    [anon_sym_boolean] = ACTIONS(2325),
    [anon_sym_string] = ACTIONS(2325),
    [anon_sym_symbol] = ACTIONS(2325),
    [anon_sym_abstract] = ACTIONS(2325),
    [anon_sym_interface] = ACTIONS(2325),
    [anon_sym_enum] = ACTIONS(2325),
  },
  [701] = {
    [ts_builtin_sym_end] = ACTIONS(2327),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_export] = ACTIONS(2329),
    [anon_sym_default] = ACTIONS(2329),
    [anon_sym_type] = ACTIONS(2329),
    [anon_sym_namespace] = ACTIONS(2329),
    [anon_sym_LBRACE] = ACTIONS(2327),
    [anon_sym_RBRACE] = ACTIONS(2327),
    [anon_sym_typeof] = ACTIONS(2329),
    [anon_sym_import] = ACTIONS(2329),
    [anon_sym_var] = ACTIONS(2329),
    [anon_sym_let] = ACTIONS(2329),
    [anon_sym_const] = ACTIONS(2329),
    [anon_sym_BANG] = ACTIONS(2327),
    [anon_sym_else] = ACTIONS(2329),
    [anon_sym_if] = ACTIONS(2329),
    [anon_sym_switch] = ACTIONS(2329),
    [anon_sym_for] = ACTIONS(2329),
    [anon_sym_LPAREN] = ACTIONS(2327),
    [anon_sym_await] = ACTIONS(2329),
    [anon_sym_while] = ACTIONS(2329),
    [anon_sym_do] = ACTIONS(2329),
    [anon_sym_try] = ACTIONS(2329),
    [anon_sym_with] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2329),
    [anon_sym_continue] = ACTIONS(2329),
    [anon_sym_debugger] = ACTIONS(2329),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_throw] = ACTIONS(2329),
    [anon_sym_SEMI] = ACTIONS(2327),
    [anon_sym_case] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2329),
    [anon_sym_LBRACK] = ACTIONS(2327),
    [anon_sym_LTtemplate_GT] = ACTIONS(2327),
    [anon_sym_LT] = ACTIONS(2329),
    [anon_sym_SLASH] = ACTIONS(2329),
    [anon_sym_class] = ACTIONS(2329),
    [anon_sym_async] = ACTIONS(2329),
    [anon_sym_function] = ACTIONS(2329),
    [anon_sym_new] = ACTIONS(2329),
    [anon_sym_PLUS] = ACTIONS(2329),
    [anon_sym_DASH] = ACTIONS(2329),
    [anon_sym_TILDE] = ACTIONS(2327),
    [anon_sym_void] = ACTIONS(2329),
    [anon_sym_delete] = ACTIONS(2329),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(2327),
    [anon_sym_SQUOTE] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2327),
    [sym_number] = ACTIONS(2327),
    [sym_this] = ACTIONS(2329),
    [sym_super] = ACTIONS(2329),
    [sym_true] = ACTIONS(2329),
    [sym_false] = ACTIONS(2329),
    [sym_null] = ACTIONS(2329),
    [sym_undefined] = ACTIONS(2329),
    [anon_sym_AT] = ACTIONS(2327),
    [anon_sym_static] = ACTIONS(2329),
    [anon_sym_readonly] = ACTIONS(2329),
    [anon_sym_get] = ACTIONS(2329),
    [anon_sym_set] = ACTIONS(2329),
    [anon_sym_declare] = ACTIONS(2329),
    [anon_sym_public] = ACTIONS(2329),
    [anon_sym_private] = ACTIONS(2329),
    [anon_sym_protected] = ACTIONS(2329),
    [anon_sym_override] = ACTIONS(2329),
    [anon_sym_module] = ACTIONS(2329),
    [anon_sym_any] = ACTIONS(2329),
    [anon_sym_number] = ACTIONS(2329),
    [anon_sym_boolean] = ACTIONS(2329),
    [anon_sym_string] = ACTIONS(2329),
    [anon_sym_symbol] = ACTIONS(2329),
    [anon_sym_abstract] = ACTIONS(2329),
    [anon_sym_interface] = ACTIONS(2329),
    [anon_sym_enum] = ACTIONS(2329),
  },
  [702] = {
    [ts_builtin_sym_end] = ACTIONS(2331),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_export] = ACTIONS(2333),
    [anon_sym_default] = ACTIONS(2333),
    [anon_sym_type] = ACTIONS(2333),
    [anon_sym_namespace] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(2331),
    [anon_sym_RBRACE] = ACTIONS(2331),
    [anon_sym_typeof] = ACTIONS(2333),
    [anon_sym_import] = ACTIONS(2333),
    [anon_sym_var] = ACTIONS(2333),
    [anon_sym_let] = ACTIONS(2333),
    [anon_sym_const] = ACTIONS(2333),
    [anon_sym_BANG] = ACTIONS(2331),
    [anon_sym_else] = ACTIONS(2333),
    [anon_sym_if] = ACTIONS(2333),
    [anon_sym_switch] = ACTIONS(2333),
    [anon_sym_for] = ACTIONS(2333),
    [anon_sym_LPAREN] = ACTIONS(2331),
    [anon_sym_await] = ACTIONS(2333),
    [anon_sym_while] = ACTIONS(2333),
    [anon_sym_do] = ACTIONS(2333),
    [anon_sym_try] = ACTIONS(2333),
    [anon_sym_with] = ACTIONS(2333),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_continue] = ACTIONS(2333),
    [anon_sym_debugger] = ACTIONS(2333),
    [anon_sym_return] = ACTIONS(2333),
    [anon_sym_throw] = ACTIONS(2333),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_case] = ACTIONS(2333),
    [anon_sym_yield] = ACTIONS(2333),
    [anon_sym_LBRACK] = ACTIONS(2331),
    [anon_sym_LTtemplate_GT] = ACTIONS(2331),
    [anon_sym_LT] = ACTIONS(2333),
    [anon_sym_SLASH] = ACTIONS(2333),
    [anon_sym_class] = ACTIONS(2333),
    [anon_sym_async] = ACTIONS(2333),
    [anon_sym_function] = ACTIONS(2333),
    [anon_sym_new] = ACTIONS(2333),
    [anon_sym_PLUS] = ACTIONS(2333),
    [anon_sym_DASH] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2331),
    [anon_sym_void] = ACTIONS(2333),
    [anon_sym_delete] = ACTIONS(2333),
    [anon_sym_PLUS_PLUS] = ACTIONS(2331),
    [anon_sym_DASH_DASH] = ACTIONS(2331),
    [anon_sym_DQUOTE] = ACTIONS(2331),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2331),
    [sym_number] = ACTIONS(2331),
    [sym_this] = ACTIONS(2333),
    [sym_super] = ACTIONS(2333),
    [sym_true] = ACTIONS(2333),
    [sym_false] = ACTIONS(2333),
    [sym_null] = ACTIONS(2333),
    [sym_undefined] = ACTIONS(2333),
    [anon_sym_AT] = ACTIONS(2331),
    [anon_sym_static] = ACTIONS(2333),
    [anon_sym_readonly] = ACTIONS(2333),
    [anon_sym_get] = ACTIONS(2333),
    [anon_sym_set] = ACTIONS(2333),
    [anon_sym_declare] = ACTIONS(2333),
    [anon_sym_public] = ACTIONS(2333),
    [anon_sym_private] = ACTIONS(2333),
    [anon_sym_protected] = ACTIONS(2333),
    [anon_sym_override] = ACTIONS(2333),
    [anon_sym_module] = ACTIONS(2333),
    [anon_sym_any] = ACTIONS(2333),
    [anon_sym_number] = ACTIONS(2333),
    [anon_sym_boolean] = ACTIONS(2333),
    [anon_sym_string] = ACTIONS(2333),
    [anon_sym_symbol] = ACTIONS(2333),
    [anon_sym_abstract] = ACTIONS(2333),
    [anon_sym_interface] = ACTIONS(2333),
    [anon_sym_enum] = ACTIONS(2333),
  },
  [703] = {
    [ts_builtin_sym_end] = ACTIONS(2335),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_export] = ACTIONS(2337),
    [anon_sym_default] = ACTIONS(2337),
    [anon_sym_type] = ACTIONS(2337),
    [anon_sym_namespace] = ACTIONS(2337),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_RBRACE] = ACTIONS(2335),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_import] = ACTIONS(2337),
    [anon_sym_var] = ACTIONS(2337),
    [anon_sym_let] = ACTIONS(2337),
    [anon_sym_const] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2335),
    [anon_sym_else] = ACTIONS(2337),
    [anon_sym_if] = ACTIONS(2337),
    [anon_sym_switch] = ACTIONS(2337),
    [anon_sym_for] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(2335),
    [anon_sym_await] = ACTIONS(2337),
    [anon_sym_while] = ACTIONS(2337),
    [anon_sym_do] = ACTIONS(2337),
    [anon_sym_try] = ACTIONS(2337),
    [anon_sym_with] = ACTIONS(2337),
    [anon_sym_break] = ACTIONS(2337),
    [anon_sym_continue] = ACTIONS(2337),
    [anon_sym_debugger] = ACTIONS(2337),
    [anon_sym_return] = ACTIONS(2337),
    [anon_sym_throw] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2335),
    [anon_sym_case] = ACTIONS(2337),
    [anon_sym_yield] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(2335),
    [anon_sym_LTtemplate_GT] = ACTIONS(2335),
    [anon_sym_LT] = ACTIONS(2337),
    [anon_sym_SLASH] = ACTIONS(2337),
    [anon_sym_class] = ACTIONS(2337),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_function] = ACTIONS(2337),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_DASH] = ACTIONS(2337),
    [anon_sym_TILDE] = ACTIONS(2335),
    [anon_sym_void] = ACTIONS(2337),
    [anon_sym_delete] = ACTIONS(2337),
    [anon_sym_PLUS_PLUS] = ACTIONS(2335),
    [anon_sym_DASH_DASH] = ACTIONS(2335),
    [anon_sym_DQUOTE] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2335),
    [sym_number] = ACTIONS(2335),
    [sym_this] = ACTIONS(2337),
    [sym_super] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_null] = ACTIONS(2337),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_AT] = ACTIONS(2335),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_get] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(2337),
    [anon_sym_declare] = ACTIONS(2337),
    [anon_sym_public] = ACTIONS(2337),
    [anon_sym_private] = ACTIONS(2337),
    [anon_sym_protected] = ACTIONS(2337),
    [anon_sym_override] = ACTIONS(2337),
    [anon_sym_module] = ACTIONS(2337),
    [anon_sym_any] = ACTIONS(2337),
    [anon_sym_number] = ACTIONS(2337),
    [anon_sym_boolean] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_symbol] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_interface] = ACTIONS(2337),
    [anon_sym_enum] = ACTIONS(2337),
  },
  [704] = {
    [ts_builtin_sym_end] = ACTIONS(2339),
    [sym_identifier] = ACTIONS(2341),
    [anon_sym_export] = ACTIONS(2341),
    [anon_sym_default] = ACTIONS(2341),
    [anon_sym_type] = ACTIONS(2341),
    [anon_sym_namespace] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_typeof] = ACTIONS(2341),
    [anon_sym_import] = ACTIONS(2341),
    [anon_sym_var] = ACTIONS(2341),
    [anon_sym_let] = ACTIONS(2341),
    [anon_sym_const] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_else] = ACTIONS(2341),
    [anon_sym_if] = ACTIONS(2341),
    [anon_sym_switch] = ACTIONS(2341),
    [anon_sym_for] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2339),
    [anon_sym_await] = ACTIONS(2341),
    [anon_sym_while] = ACTIONS(2341),
    [anon_sym_do] = ACTIONS(2341),
    [anon_sym_try] = ACTIONS(2341),
    [anon_sym_with] = ACTIONS(2341),
    [anon_sym_break] = ACTIONS(2341),
    [anon_sym_continue] = ACTIONS(2341),
    [anon_sym_debugger] = ACTIONS(2341),
    [anon_sym_return] = ACTIONS(2341),
    [anon_sym_throw] = ACTIONS(2341),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_case] = ACTIONS(2341),
    [anon_sym_yield] = ACTIONS(2341),
    [anon_sym_LBRACK] = ACTIONS(2339),
    [anon_sym_LTtemplate_GT] = ACTIONS(2339),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_SLASH] = ACTIONS(2341),
    [anon_sym_class] = ACTIONS(2341),
    [anon_sym_async] = ACTIONS(2341),
    [anon_sym_function] = ACTIONS(2341),
    [anon_sym_new] = ACTIONS(2341),
    [anon_sym_PLUS] = ACTIONS(2341),
    [anon_sym_DASH] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2339),
    [anon_sym_void] = ACTIONS(2341),
    [anon_sym_delete] = ACTIONS(2341),
    [anon_sym_PLUS_PLUS] = ACTIONS(2339),
    [anon_sym_DASH_DASH] = ACTIONS(2339),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_SQUOTE] = ACTIONS(2339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2339),
    [sym_number] = ACTIONS(2339),
    [sym_this] = ACTIONS(2341),
    [sym_super] = ACTIONS(2341),
    [sym_true] = ACTIONS(2341),
    [sym_false] = ACTIONS(2341),
    [sym_null] = ACTIONS(2341),
    [sym_undefined] = ACTIONS(2341),
    [anon_sym_AT] = ACTIONS(2339),
    [anon_sym_static] = ACTIONS(2341),
    [anon_sym_readonly] = ACTIONS(2341),
    [anon_sym_get] = ACTIONS(2341),
    [anon_sym_set] = ACTIONS(2341),
    [anon_sym_declare] = ACTIONS(2341),
    [anon_sym_public] = ACTIONS(2341),
    [anon_sym_private] = ACTIONS(2341),
    [anon_sym_protected] = ACTIONS(2341),
    [anon_sym_override] = ACTIONS(2341),
    [anon_sym_module] = ACTIONS(2341),
    [anon_sym_any] = ACTIONS(2341),
    [anon_sym_number] = ACTIONS(2341),
    [anon_sym_boolean] = ACTIONS(2341),
    [anon_sym_string] = ACTIONS(2341),
    [anon_sym_symbol] = ACTIONS(2341),
    [anon_sym_abstract] = ACTIONS(2341),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_enum] = ACTIONS(2341),
  },
  [705] = {
    [ts_builtin_sym_end] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2345),
    [anon_sym_export] = ACTIONS(2345),
    [anon_sym_default] = ACTIONS(2345),
    [anon_sym_type] = ACTIONS(2345),
    [anon_sym_namespace] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(2343),
    [anon_sym_typeof] = ACTIONS(2345),
    [anon_sym_import] = ACTIONS(2345),
    [anon_sym_var] = ACTIONS(2345),
    [anon_sym_let] = ACTIONS(2345),
    [anon_sym_const] = ACTIONS(2345),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_else] = ACTIONS(2345),
    [anon_sym_if] = ACTIONS(2345),
    [anon_sym_switch] = ACTIONS(2345),
    [anon_sym_for] = ACTIONS(2345),
    [anon_sym_LPAREN] = ACTIONS(2343),
    [anon_sym_await] = ACTIONS(2345),
    [anon_sym_while] = ACTIONS(2345),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_try] = ACTIONS(2345),
    [anon_sym_with] = ACTIONS(2345),
    [anon_sym_break] = ACTIONS(2345),
    [anon_sym_continue] = ACTIONS(2345),
    [anon_sym_debugger] = ACTIONS(2345),
    [anon_sym_return] = ACTIONS(2345),
    [anon_sym_throw] = ACTIONS(2345),
    [anon_sym_SEMI] = ACTIONS(2343),
    [anon_sym_case] = ACTIONS(2345),
    [anon_sym_yield] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2343),
    [anon_sym_LTtemplate_GT] = ACTIONS(2343),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2345),
    [anon_sym_class] = ACTIONS(2345),
    [anon_sym_async] = ACTIONS(2345),
    [anon_sym_function] = ACTIONS(2345),
    [anon_sym_new] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(2345),
    [anon_sym_DASH] = ACTIONS(2345),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_void] = ACTIONS(2345),
    [anon_sym_delete] = ACTIONS(2345),
    [anon_sym_PLUS_PLUS] = ACTIONS(2343),
    [anon_sym_DASH_DASH] = ACTIONS(2343),
    [anon_sym_DQUOTE] = ACTIONS(2343),
    [anon_sym_SQUOTE] = ACTIONS(2343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2343),
    [sym_number] = ACTIONS(2343),
    [sym_this] = ACTIONS(2345),
    [sym_super] = ACTIONS(2345),
    [sym_true] = ACTIONS(2345),
    [sym_false] = ACTIONS(2345),
    [sym_null] = ACTIONS(2345),
    [sym_undefined] = ACTIONS(2345),
    [anon_sym_AT] = ACTIONS(2343),
    [anon_sym_static] = ACTIONS(2345),
    [anon_sym_readonly] = ACTIONS(2345),
    [anon_sym_get] = ACTIONS(2345),
    [anon_sym_set] = ACTIONS(2345),
    [anon_sym_declare] = ACTIONS(2345),
    [anon_sym_public] = ACTIONS(2345),
    [anon_sym_private] = ACTIONS(2345),
    [anon_sym_protected] = ACTIONS(2345),
    [anon_sym_override] = ACTIONS(2345),
    [anon_sym_module] = ACTIONS(2345),
    [anon_sym_any] = ACTIONS(2345),
    [anon_sym_number] = ACTIONS(2345),
    [anon_sym_boolean] = ACTIONS(2345),
    [anon_sym_string] = ACTIONS(2345),
    [anon_sym_symbol] = ACTIONS(2345),
    [anon_sym_abstract] = ACTIONS(2345),
    [anon_sym_interface] = ACTIONS(2345),
    [anon_sym_enum] = ACTIONS(2345),
  },
  [706] = {
    [ts_builtin_sym_end] = ACTIONS(2347),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_export] = ACTIONS(2349),
    [anon_sym_default] = ACTIONS(2349),
    [anon_sym_type] = ACTIONS(2349),
    [anon_sym_namespace] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_typeof] = ACTIONS(2349),
    [anon_sym_import] = ACTIONS(2349),
    [anon_sym_var] = ACTIONS(2349),
    [anon_sym_let] = ACTIONS(2349),
    [anon_sym_const] = ACTIONS(2349),
    [anon_sym_BANG] = ACTIONS(2347),
    [anon_sym_else] = ACTIONS(2349),
    [anon_sym_if] = ACTIONS(2349),
    [anon_sym_switch] = ACTIONS(2349),
    [anon_sym_for] = ACTIONS(2349),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_await] = ACTIONS(2349),
    [anon_sym_while] = ACTIONS(2349),
    [anon_sym_do] = ACTIONS(2349),
    [anon_sym_try] = ACTIONS(2349),
    [anon_sym_with] = ACTIONS(2349),
    [anon_sym_break] = ACTIONS(2349),
    [anon_sym_continue] = ACTIONS(2349),
    [anon_sym_debugger] = ACTIONS(2349),
    [anon_sym_return] = ACTIONS(2349),
    [anon_sym_throw] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_case] = ACTIONS(2349),
    [anon_sym_yield] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_LTtemplate_GT] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2349),
    [anon_sym_SLASH] = ACTIONS(2349),
    [anon_sym_class] = ACTIONS(2349),
    [anon_sym_async] = ACTIONS(2349),
    [anon_sym_function] = ACTIONS(2349),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_void] = ACTIONS(2349),
    [anon_sym_delete] = ACTIONS(2349),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_DQUOTE] = ACTIONS(2347),
    [anon_sym_SQUOTE] = ACTIONS(2347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2347),
    [sym_number] = ACTIONS(2347),
    [sym_this] = ACTIONS(2349),
    [sym_super] = ACTIONS(2349),
    [sym_true] = ACTIONS(2349),
    [sym_false] = ACTIONS(2349),
    [sym_null] = ACTIONS(2349),
    [sym_undefined] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_static] = ACTIONS(2349),
    [anon_sym_readonly] = ACTIONS(2349),
    [anon_sym_get] = ACTIONS(2349),
    [anon_sym_set] = ACTIONS(2349),
    [anon_sym_declare] = ACTIONS(2349),
    [anon_sym_public] = ACTIONS(2349),
    [anon_sym_private] = ACTIONS(2349),
    [anon_sym_protected] = ACTIONS(2349),
    [anon_sym_override] = ACTIONS(2349),
    [anon_sym_module] = ACTIONS(2349),
    [anon_sym_any] = ACTIONS(2349),
    [anon_sym_number] = ACTIONS(2349),
    [anon_sym_boolean] = ACTIONS(2349),
    [anon_sym_string] = ACTIONS(2349),
    [anon_sym_symbol] = ACTIONS(2349),
    [anon_sym_abstract] = ACTIONS(2349),
    [anon_sym_interface] = ACTIONS(2349),
    [anon_sym_enum] = ACTIONS(2349),
  },
  [707] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [708] = {
    [ts_builtin_sym_end] = ACTIONS(2351),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_export] = ACTIONS(2353),
    [anon_sym_default] = ACTIONS(2353),
    [anon_sym_type] = ACTIONS(2353),
    [anon_sym_namespace] = ACTIONS(2353),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_typeof] = ACTIONS(2353),
    [anon_sym_import] = ACTIONS(2353),
    [anon_sym_var] = ACTIONS(2353),
    [anon_sym_let] = ACTIONS(2353),
    [anon_sym_const] = ACTIONS(2353),
    [anon_sym_BANG] = ACTIONS(2351),
    [anon_sym_else] = ACTIONS(2353),
    [anon_sym_if] = ACTIONS(2353),
    [anon_sym_switch] = ACTIONS(2353),
    [anon_sym_for] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(2351),
    [anon_sym_await] = ACTIONS(2353),
    [anon_sym_while] = ACTIONS(2353),
    [anon_sym_do] = ACTIONS(2353),
    [anon_sym_try] = ACTIONS(2353),
    [anon_sym_with] = ACTIONS(2353),
    [anon_sym_break] = ACTIONS(2353),
    [anon_sym_continue] = ACTIONS(2353),
    [anon_sym_debugger] = ACTIONS(2353),
    [anon_sym_return] = ACTIONS(2353),
    [anon_sym_throw] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2351),
    [anon_sym_case] = ACTIONS(2353),
    [anon_sym_yield] = ACTIONS(2353),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_LTtemplate_GT] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_SLASH] = ACTIONS(2353),
    [anon_sym_class] = ACTIONS(2353),
    [anon_sym_async] = ACTIONS(2353),
    [anon_sym_function] = ACTIONS(2353),
    [anon_sym_new] = ACTIONS(2353),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2351),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_delete] = ACTIONS(2353),
    [anon_sym_PLUS_PLUS] = ACTIONS(2351),
    [anon_sym_DASH_DASH] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_SQUOTE] = ACTIONS(2351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [sym_number] = ACTIONS(2351),
    [sym_this] = ACTIONS(2353),
    [sym_super] = ACTIONS(2353),
    [sym_true] = ACTIONS(2353),
    [sym_false] = ACTIONS(2353),
    [sym_null] = ACTIONS(2353),
    [sym_undefined] = ACTIONS(2353),
    [anon_sym_AT] = ACTIONS(2351),
    [anon_sym_static] = ACTIONS(2353),
    [anon_sym_readonly] = ACTIONS(2353),
    [anon_sym_get] = ACTIONS(2353),
    [anon_sym_set] = ACTIONS(2353),
    [anon_sym_declare] = ACTIONS(2353),
    [anon_sym_public] = ACTIONS(2353),
    [anon_sym_private] = ACTIONS(2353),
    [anon_sym_protected] = ACTIONS(2353),
    [anon_sym_override] = ACTIONS(2353),
    [anon_sym_module] = ACTIONS(2353),
    [anon_sym_any] = ACTIONS(2353),
    [anon_sym_number] = ACTIONS(2353),
    [anon_sym_boolean] = ACTIONS(2353),
    [anon_sym_string] = ACTIONS(2353),
    [anon_sym_symbol] = ACTIONS(2353),
    [anon_sym_abstract] = ACTIONS(2353),
    [anon_sym_interface] = ACTIONS(2353),
    [anon_sym_enum] = ACTIONS(2353),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [710] = {
    [ts_builtin_sym_end] = ACTIONS(2355),
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_export] = ACTIONS(2357),
    [anon_sym_default] = ACTIONS(2357),
    [anon_sym_type] = ACTIONS(2357),
    [anon_sym_namespace] = ACTIONS(2357),
    [anon_sym_LBRACE] = ACTIONS(2355),
    [anon_sym_RBRACE] = ACTIONS(2355),
    [anon_sym_typeof] = ACTIONS(2357),
    [anon_sym_import] = ACTIONS(2357),
    [anon_sym_var] = ACTIONS(2357),
    [anon_sym_let] = ACTIONS(2357),
    [anon_sym_const] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2355),
    [anon_sym_else] = ACTIONS(2357),
    [anon_sym_if] = ACTIONS(2357),
    [anon_sym_switch] = ACTIONS(2357),
    [anon_sym_for] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [anon_sym_await] = ACTIONS(2357),
    [anon_sym_while] = ACTIONS(2357),
    [anon_sym_do] = ACTIONS(2357),
    [anon_sym_try] = ACTIONS(2357),
    [anon_sym_with] = ACTIONS(2357),
    [anon_sym_break] = ACTIONS(2357),
    [anon_sym_continue] = ACTIONS(2357),
    [anon_sym_debugger] = ACTIONS(2357),
    [anon_sym_return] = ACTIONS(2357),
    [anon_sym_throw] = ACTIONS(2357),
    [anon_sym_SEMI] = ACTIONS(2355),
    [anon_sym_case] = ACTIONS(2357),
    [anon_sym_yield] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_LTtemplate_GT] = ACTIONS(2355),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_SLASH] = ACTIONS(2357),
    [anon_sym_class] = ACTIONS(2357),
    [anon_sym_async] = ACTIONS(2357),
    [anon_sym_function] = ACTIONS(2357),
    [anon_sym_new] = ACTIONS(2357),
    [anon_sym_PLUS] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2355),
    [anon_sym_void] = ACTIONS(2357),
    [anon_sym_delete] = ACTIONS(2357),
    [anon_sym_PLUS_PLUS] = ACTIONS(2355),
    [anon_sym_DASH_DASH] = ACTIONS(2355),
    [anon_sym_DQUOTE] = ACTIONS(2355),
    [anon_sym_SQUOTE] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2355),
    [sym_number] = ACTIONS(2355),
    [sym_this] = ACTIONS(2357),
    [sym_super] = ACTIONS(2357),
    [sym_true] = ACTIONS(2357),
    [sym_false] = ACTIONS(2357),
    [sym_null] = ACTIONS(2357),
    [sym_undefined] = ACTIONS(2357),
    [anon_sym_AT] = ACTIONS(2355),
    [anon_sym_static] = ACTIONS(2357),
    [anon_sym_readonly] = ACTIONS(2357),
    [anon_sym_get] = ACTIONS(2357),
    [anon_sym_set] = ACTIONS(2357),
    [anon_sym_declare] = ACTIONS(2357),
    [anon_sym_public] = ACTIONS(2357),
    [anon_sym_private] = ACTIONS(2357),
    [anon_sym_protected] = ACTIONS(2357),
    [anon_sym_override] = ACTIONS(2357),
    [anon_sym_module] = ACTIONS(2357),
    [anon_sym_any] = ACTIONS(2357),
    [anon_sym_number] = ACTIONS(2357),
    [anon_sym_boolean] = ACTIONS(2357),
    [anon_sym_string] = ACTIONS(2357),
    [anon_sym_symbol] = ACTIONS(2357),
    [anon_sym_abstract] = ACTIONS(2357),
    [anon_sym_interface] = ACTIONS(2357),
    [anon_sym_enum] = ACTIONS(2357),
  },
  [711] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [712] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [713] = {
    [ts_builtin_sym_end] = ACTIONS(2359),
    [sym_identifier] = ACTIONS(2361),
    [anon_sym_export] = ACTIONS(2361),
    [anon_sym_default] = ACTIONS(2361),
    [anon_sym_type] = ACTIONS(2361),
    [anon_sym_namespace] = ACTIONS(2361),
    [anon_sym_LBRACE] = ACTIONS(2359),
    [anon_sym_RBRACE] = ACTIONS(2359),
    [anon_sym_typeof] = ACTIONS(2361),
    [anon_sym_import] = ACTIONS(2361),
    [anon_sym_var] = ACTIONS(2361),
    [anon_sym_let] = ACTIONS(2361),
    [anon_sym_const] = ACTIONS(2361),
    [anon_sym_BANG] = ACTIONS(2359),
    [anon_sym_else] = ACTIONS(2361),
    [anon_sym_if] = ACTIONS(2361),
    [anon_sym_switch] = ACTIONS(2361),
    [anon_sym_for] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2359),
    [anon_sym_await] = ACTIONS(2361),
    [anon_sym_while] = ACTIONS(2361),
    [anon_sym_do] = ACTIONS(2361),
    [anon_sym_try] = ACTIONS(2361),
    [anon_sym_with] = ACTIONS(2361),
    [anon_sym_break] = ACTIONS(2361),
    [anon_sym_continue] = ACTIONS(2361),
    [anon_sym_debugger] = ACTIONS(2361),
    [anon_sym_return] = ACTIONS(2361),
    [anon_sym_throw] = ACTIONS(2361),
    [anon_sym_SEMI] = ACTIONS(2359),
    [anon_sym_case] = ACTIONS(2361),
    [anon_sym_yield] = ACTIONS(2361),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_LTtemplate_GT] = ACTIONS(2359),
    [anon_sym_LT] = ACTIONS(2361),
    [anon_sym_SLASH] = ACTIONS(2361),
    [anon_sym_class] = ACTIONS(2361),
    [anon_sym_async] = ACTIONS(2361),
    [anon_sym_function] = ACTIONS(2361),
    [anon_sym_new] = ACTIONS(2361),
    [anon_sym_PLUS] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2359),
    [anon_sym_void] = ACTIONS(2361),
    [anon_sym_delete] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2359),
    [anon_sym_DASH_DASH] = ACTIONS(2359),
    [anon_sym_DQUOTE] = ACTIONS(2359),
    [anon_sym_SQUOTE] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2359),
    [sym_number] = ACTIONS(2359),
    [sym_this] = ACTIONS(2361),
    [sym_super] = ACTIONS(2361),
    [sym_true] = ACTIONS(2361),
    [sym_false] = ACTIONS(2361),
    [sym_null] = ACTIONS(2361),
    [sym_undefined] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(2359),
    [anon_sym_static] = ACTIONS(2361),
    [anon_sym_readonly] = ACTIONS(2361),
    [anon_sym_get] = ACTIONS(2361),
    [anon_sym_set] = ACTIONS(2361),
    [anon_sym_declare] = ACTIONS(2361),
    [anon_sym_public] = ACTIONS(2361),
    [anon_sym_private] = ACTIONS(2361),
    [anon_sym_protected] = ACTIONS(2361),
    [anon_sym_override] = ACTIONS(2361),
    [anon_sym_module] = ACTIONS(2361),
    [anon_sym_any] = ACTIONS(2361),
    [anon_sym_number] = ACTIONS(2361),
    [anon_sym_boolean] = ACTIONS(2361),
    [anon_sym_string] = ACTIONS(2361),
    [anon_sym_symbol] = ACTIONS(2361),
    [anon_sym_abstract] = ACTIONS(2361),
    [anon_sym_interface] = ACTIONS(2361),
    [anon_sym_enum] = ACTIONS(2361),
  },
  [714] = {
    [ts_builtin_sym_end] = ACTIONS(2363),
    [sym_identifier] = ACTIONS(2365),
    [anon_sym_export] = ACTIONS(2365),
    [anon_sym_default] = ACTIONS(2365),
    [anon_sym_type] = ACTIONS(2365),
    [anon_sym_namespace] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2363),
    [anon_sym_RBRACE] = ACTIONS(2363),
    [anon_sym_typeof] = ACTIONS(2365),
    [anon_sym_import] = ACTIONS(2365),
    [anon_sym_var] = ACTIONS(2365),
    [anon_sym_let] = ACTIONS(2365),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_BANG] = ACTIONS(2363),
    [anon_sym_else] = ACTIONS(2365),
    [anon_sym_if] = ACTIONS(2365),
    [anon_sym_switch] = ACTIONS(2365),
    [anon_sym_for] = ACTIONS(2365),
    [anon_sym_LPAREN] = ACTIONS(2363),
    [anon_sym_await] = ACTIONS(2365),
    [anon_sym_while] = ACTIONS(2365),
    [anon_sym_do] = ACTIONS(2365),
    [anon_sym_try] = ACTIONS(2365),
    [anon_sym_with] = ACTIONS(2365),
    [anon_sym_break] = ACTIONS(2365),
    [anon_sym_continue] = ACTIONS(2365),
    [anon_sym_debugger] = ACTIONS(2365),
    [anon_sym_return] = ACTIONS(2365),
    [anon_sym_throw] = ACTIONS(2365),
    [anon_sym_SEMI] = ACTIONS(2363),
    [anon_sym_case] = ACTIONS(2365),
    [anon_sym_yield] = ACTIONS(2365),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LTtemplate_GT] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2365),
    [anon_sym_class] = ACTIONS(2365),
    [anon_sym_async] = ACTIONS(2365),
    [anon_sym_function] = ACTIONS(2365),
    [anon_sym_new] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2363),
    [anon_sym_void] = ACTIONS(2365),
    [anon_sym_delete] = ACTIONS(2365),
    [anon_sym_PLUS_PLUS] = ACTIONS(2363),
    [anon_sym_DASH_DASH] = ACTIONS(2363),
    [anon_sym_DQUOTE] = ACTIONS(2363),
    [anon_sym_SQUOTE] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2363),
    [sym_number] = ACTIONS(2363),
    [sym_this] = ACTIONS(2365),
    [sym_super] = ACTIONS(2365),
    [sym_true] = ACTIONS(2365),
    [sym_false] = ACTIONS(2365),
    [sym_null] = ACTIONS(2365),
    [sym_undefined] = ACTIONS(2365),
    [anon_sym_AT] = ACTIONS(2363),
    [anon_sym_static] = ACTIONS(2365),
    [anon_sym_readonly] = ACTIONS(2365),
    [anon_sym_get] = ACTIONS(2365),
    [anon_sym_set] = ACTIONS(2365),
    [anon_sym_declare] = ACTIONS(2365),
    [anon_sym_public] = ACTIONS(2365),
    [anon_sym_private] = ACTIONS(2365),
    [anon_sym_protected] = ACTIONS(2365),
    [anon_sym_override] = ACTIONS(2365),
    [anon_sym_module] = ACTIONS(2365),
    [anon_sym_any] = ACTIONS(2365),
    [anon_sym_number] = ACTIONS(2365),
    [anon_sym_boolean] = ACTIONS(2365),
    [anon_sym_string] = ACTIONS(2365),
    [anon_sym_symbol] = ACTIONS(2365),
    [anon_sym_abstract] = ACTIONS(2365),
    [anon_sym_interface] = ACTIONS(2365),
    [anon_sym_enum] = ACTIONS(2365),
  },
  [715] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2321),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_type] = ACTIONS(2321),
    [anon_sym_namespace] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_typeof] = ACTIONS(2321),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_var] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_const] = ACTIONS(2321),
    [anon_sym_BANG] = ACTIONS(2319),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_switch] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_await] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_break] = ACTIONS(2321),
    [anon_sym_continue] = ACTIONS(2321),
    [anon_sym_debugger] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_throw] = ACTIONS(2321),
    [anon_sym_SEMI] = ACTIONS(2319),
    [anon_sym_case] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_LTtemplate_GT] = ACTIONS(2319),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_void] = ACTIONS(2321),
    [anon_sym_delete] = ACTIONS(2321),
    [anon_sym_PLUS_PLUS] = ACTIONS(2319),
    [anon_sym_DASH_DASH] = ACTIONS(2319),
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [sym_number] = ACTIONS(2319),
    [sym_this] = ACTIONS(2321),
    [sym_super] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_null] = ACTIONS(2321),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_static] = ACTIONS(2321),
    [anon_sym_readonly] = ACTIONS(2321),
    [anon_sym_get] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(2321),
    [anon_sym_declare] = ACTIONS(2321),
    [anon_sym_public] = ACTIONS(2321),
    [anon_sym_private] = ACTIONS(2321),
    [anon_sym_protected] = ACTIONS(2321),
    [anon_sym_override] = ACTIONS(2321),
    [anon_sym_module] = ACTIONS(2321),
    [anon_sym_any] = ACTIONS(2321),
    [anon_sym_number] = ACTIONS(2321),
    [anon_sym_boolean] = ACTIONS(2321),
    [anon_sym_string] = ACTIONS(2321),
    [anon_sym_symbol] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_interface] = ACTIONS(2321),
    [anon_sym_enum] = ACTIONS(2321),
  },
  [716] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2321),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_type] = ACTIONS(2321),
    [anon_sym_namespace] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_typeof] = ACTIONS(2321),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_var] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_const] = ACTIONS(2321),
    [anon_sym_BANG] = ACTIONS(2319),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_switch] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_await] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_break] = ACTIONS(2321),
    [anon_sym_continue] = ACTIONS(2321),
    [anon_sym_debugger] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_throw] = ACTIONS(2321),
    [anon_sym_SEMI] = ACTIONS(2319),
    [anon_sym_case] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_LTtemplate_GT] = ACTIONS(2319),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_void] = ACTIONS(2321),
    [anon_sym_delete] = ACTIONS(2321),
    [anon_sym_PLUS_PLUS] = ACTIONS(2319),
    [anon_sym_DASH_DASH] = ACTIONS(2319),
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [sym_number] = ACTIONS(2319),
    [sym_this] = ACTIONS(2321),
    [sym_super] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_null] = ACTIONS(2321),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_static] = ACTIONS(2321),
    [anon_sym_readonly] = ACTIONS(2321),
    [anon_sym_get] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(2321),
    [anon_sym_declare] = ACTIONS(2321),
    [anon_sym_public] = ACTIONS(2321),
    [anon_sym_private] = ACTIONS(2321),
    [anon_sym_protected] = ACTIONS(2321),
    [anon_sym_override] = ACTIONS(2321),
    [anon_sym_module] = ACTIONS(2321),
    [anon_sym_any] = ACTIONS(2321),
    [anon_sym_number] = ACTIONS(2321),
    [anon_sym_boolean] = ACTIONS(2321),
    [anon_sym_string] = ACTIONS(2321),
    [anon_sym_symbol] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_interface] = ACTIONS(2321),
    [anon_sym_enum] = ACTIONS(2321),
  },
  [717] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2321),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_type] = ACTIONS(2321),
    [anon_sym_namespace] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_typeof] = ACTIONS(2321),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_var] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_const] = ACTIONS(2321),
    [anon_sym_BANG] = ACTIONS(2319),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_switch] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_await] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_break] = ACTIONS(2321),
    [anon_sym_continue] = ACTIONS(2321),
    [anon_sym_debugger] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_throw] = ACTIONS(2321),
    [anon_sym_SEMI] = ACTIONS(2319),
    [anon_sym_case] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_LTtemplate_GT] = ACTIONS(2319),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_void] = ACTIONS(2321),
    [anon_sym_delete] = ACTIONS(2321),
    [anon_sym_PLUS_PLUS] = ACTIONS(2319),
    [anon_sym_DASH_DASH] = ACTIONS(2319),
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [sym_number] = ACTIONS(2319),
    [sym_this] = ACTIONS(2321),
    [sym_super] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_null] = ACTIONS(2321),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_static] = ACTIONS(2321),
    [anon_sym_readonly] = ACTIONS(2321),
    [anon_sym_get] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(2321),
    [anon_sym_declare] = ACTIONS(2321),
    [anon_sym_public] = ACTIONS(2321),
    [anon_sym_private] = ACTIONS(2321),
    [anon_sym_protected] = ACTIONS(2321),
    [anon_sym_override] = ACTIONS(2321),
    [anon_sym_module] = ACTIONS(2321),
    [anon_sym_any] = ACTIONS(2321),
    [anon_sym_number] = ACTIONS(2321),
    [anon_sym_boolean] = ACTIONS(2321),
    [anon_sym_string] = ACTIONS(2321),
    [anon_sym_symbol] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_interface] = ACTIONS(2321),
    [anon_sym_enum] = ACTIONS(2321),
  },
  [718] = {
    [ts_builtin_sym_end] = ACTIONS(2319),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2321),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_type] = ACTIONS(2321),
    [anon_sym_namespace] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_typeof] = ACTIONS(2321),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_var] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_const] = ACTIONS(2321),
    [anon_sym_BANG] = ACTIONS(2319),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_switch] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_await] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_break] = ACTIONS(2321),
    [anon_sym_continue] = ACTIONS(2321),
    [anon_sym_debugger] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_throw] = ACTIONS(2321),
    [anon_sym_SEMI] = ACTIONS(2319),
    [anon_sym_case] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_LTtemplate_GT] = ACTIONS(2319),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2319),
    [anon_sym_void] = ACTIONS(2321),
    [anon_sym_delete] = ACTIONS(2321),
    [anon_sym_PLUS_PLUS] = ACTIONS(2319),
    [anon_sym_DASH_DASH] = ACTIONS(2319),
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [sym_number] = ACTIONS(2319),
    [sym_this] = ACTIONS(2321),
    [sym_super] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_null] = ACTIONS(2321),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_static] = ACTIONS(2321),
    [anon_sym_readonly] = ACTIONS(2321),
    [anon_sym_get] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(2321),
    [anon_sym_declare] = ACTIONS(2321),
    [anon_sym_public] = ACTIONS(2321),
    [anon_sym_private] = ACTIONS(2321),
    [anon_sym_protected] = ACTIONS(2321),
    [anon_sym_override] = ACTIONS(2321),
    [anon_sym_module] = ACTIONS(2321),
    [anon_sym_any] = ACTIONS(2321),
    [anon_sym_number] = ACTIONS(2321),
    [anon_sym_boolean] = ACTIONS(2321),
    [anon_sym_string] = ACTIONS(2321),
    [anon_sym_symbol] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_interface] = ACTIONS(2321),
    [anon_sym_enum] = ACTIONS(2321),
  },
  [719] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [720] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [721] = {
    [ts_builtin_sym_end] = ACTIONS(2367),
    [sym_identifier] = ACTIONS(2369),
    [anon_sym_export] = ACTIONS(2369),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_type] = ACTIONS(2369),
    [anon_sym_namespace] = ACTIONS(2369),
    [anon_sym_LBRACE] = ACTIONS(2367),
    [anon_sym_RBRACE] = ACTIONS(2367),
    [anon_sym_typeof] = ACTIONS(2369),
    [anon_sym_import] = ACTIONS(2369),
    [anon_sym_var] = ACTIONS(2369),
    [anon_sym_let] = ACTIONS(2369),
    [anon_sym_const] = ACTIONS(2369),
    [anon_sym_BANG] = ACTIONS(2367),
    [anon_sym_else] = ACTIONS(2369),
    [anon_sym_if] = ACTIONS(2369),
    [anon_sym_switch] = ACTIONS(2369),
    [anon_sym_for] = ACTIONS(2369),
    [anon_sym_LPAREN] = ACTIONS(2367),
    [anon_sym_await] = ACTIONS(2369),
    [anon_sym_while] = ACTIONS(2369),
    [anon_sym_do] = ACTIONS(2369),
    [anon_sym_try] = ACTIONS(2369),
    [anon_sym_with] = ACTIONS(2369),
    [anon_sym_break] = ACTIONS(2369),
    [anon_sym_continue] = ACTIONS(2369),
    [anon_sym_debugger] = ACTIONS(2369),
    [anon_sym_return] = ACTIONS(2369),
    [anon_sym_throw] = ACTIONS(2369),
    [anon_sym_SEMI] = ACTIONS(2367),
    [anon_sym_case] = ACTIONS(2369),
    [anon_sym_yield] = ACTIONS(2369),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_LTtemplate_GT] = ACTIONS(2367),
    [anon_sym_LT] = ACTIONS(2369),
    [anon_sym_SLASH] = ACTIONS(2369),
    [anon_sym_class] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(2369),
    [anon_sym_function] = ACTIONS(2369),
    [anon_sym_new] = ACTIONS(2369),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_TILDE] = ACTIONS(2367),
    [anon_sym_void] = ACTIONS(2369),
    [anon_sym_delete] = ACTIONS(2369),
    [anon_sym_PLUS_PLUS] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2367),
    [sym_number] = ACTIONS(2367),
    [sym_this] = ACTIONS(2369),
    [sym_super] = ACTIONS(2369),
    [sym_true] = ACTIONS(2369),
    [sym_false] = ACTIONS(2369),
    [sym_null] = ACTIONS(2369),
    [sym_undefined] = ACTIONS(2369),
    [anon_sym_AT] = ACTIONS(2367),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_readonly] = ACTIONS(2369),
    [anon_sym_get] = ACTIONS(2369),
    [anon_sym_set] = ACTIONS(2369),
    [anon_sym_declare] = ACTIONS(2369),
    [anon_sym_public] = ACTIONS(2369),
    [anon_sym_private] = ACTIONS(2369),
    [anon_sym_protected] = ACTIONS(2369),
    [anon_sym_override] = ACTIONS(2369),
    [anon_sym_module] = ACTIONS(2369),
    [anon_sym_any] = ACTIONS(2369),
    [anon_sym_number] = ACTIONS(2369),
    [anon_sym_boolean] = ACTIONS(2369),
    [anon_sym_string] = ACTIONS(2369),
    [anon_sym_symbol] = ACTIONS(2369),
    [anon_sym_abstract] = ACTIONS(2369),
    [anon_sym_interface] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2369),
  },
  [722] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [723] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [724] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [725] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [726] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [727] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [728] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [729] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [730] = {
    [ts_builtin_sym_end] = ACTIONS(2371),
    [sym_identifier] = ACTIONS(2373),
    [anon_sym_export] = ACTIONS(2373),
    [anon_sym_default] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2373),
    [anon_sym_namespace] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_typeof] = ACTIONS(2373),
    [anon_sym_import] = ACTIONS(2373),
    [anon_sym_var] = ACTIONS(2373),
    [anon_sym_let] = ACTIONS(2373),
    [anon_sym_const] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2371),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_if] = ACTIONS(2373),
    [anon_sym_switch] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_await] = ACTIONS(2373),
    [anon_sym_while] = ACTIONS(2373),
    [anon_sym_do] = ACTIONS(2373),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_with] = ACTIONS(2373),
    [anon_sym_break] = ACTIONS(2373),
    [anon_sym_continue] = ACTIONS(2373),
    [anon_sym_debugger] = ACTIONS(2373),
    [anon_sym_return] = ACTIONS(2373),
    [anon_sym_throw] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2371),
    [anon_sym_case] = ACTIONS(2373),
    [anon_sym_yield] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LTtemplate_GT] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_SLASH] = ACTIONS(2373),
    [anon_sym_class] = ACTIONS(2373),
    [anon_sym_async] = ACTIONS(2373),
    [anon_sym_function] = ACTIONS(2373),
    [anon_sym_new] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_void] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [anon_sym_SQUOTE] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [sym_number] = ACTIONS(2371),
    [sym_this] = ACTIONS(2373),
    [sym_super] = ACTIONS(2373),
    [sym_true] = ACTIONS(2373),
    [sym_false] = ACTIONS(2373),
    [sym_null] = ACTIONS(2373),
    [sym_undefined] = ACTIONS(2373),
    [anon_sym_AT] = ACTIONS(2371),
    [anon_sym_static] = ACTIONS(2373),
    [anon_sym_readonly] = ACTIONS(2373),
    [anon_sym_get] = ACTIONS(2373),
    [anon_sym_set] = ACTIONS(2373),
    [anon_sym_declare] = ACTIONS(2373),
    [anon_sym_public] = ACTIONS(2373),
    [anon_sym_private] = ACTIONS(2373),
    [anon_sym_protected] = ACTIONS(2373),
    [anon_sym_override] = ACTIONS(2373),
    [anon_sym_module] = ACTIONS(2373),
    [anon_sym_any] = ACTIONS(2373),
    [anon_sym_number] = ACTIONS(2373),
    [anon_sym_boolean] = ACTIONS(2373),
    [anon_sym_string] = ACTIONS(2373),
    [anon_sym_symbol] = ACTIONS(2373),
    [anon_sym_abstract] = ACTIONS(2373),
    [anon_sym_interface] = ACTIONS(2373),
    [anon_sym_enum] = ACTIONS(2373),
  },
  [731] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [732] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [733] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [734] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [735] = {
    [ts_builtin_sym_end] = ACTIONS(2375),
    [sym_identifier] = ACTIONS(2377),
    [anon_sym_export] = ACTIONS(2377),
    [anon_sym_default] = ACTIONS(2377),
    [anon_sym_type] = ACTIONS(2377),
    [anon_sym_namespace] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2375),
    [anon_sym_RBRACE] = ACTIONS(2375),
    [anon_sym_typeof] = ACTIONS(2377),
    [anon_sym_import] = ACTIONS(2377),
    [anon_sym_var] = ACTIONS(2377),
    [anon_sym_let] = ACTIONS(2377),
    [anon_sym_const] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2375),
    [anon_sym_else] = ACTIONS(2377),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_switch] = ACTIONS(2377),
    [anon_sym_for] = ACTIONS(2377),
    [anon_sym_LPAREN] = ACTIONS(2375),
    [anon_sym_await] = ACTIONS(2377),
    [anon_sym_while] = ACTIONS(2377),
    [anon_sym_do] = ACTIONS(2377),
    [anon_sym_try] = ACTIONS(2377),
    [anon_sym_with] = ACTIONS(2377),
    [anon_sym_break] = ACTIONS(2377),
    [anon_sym_continue] = ACTIONS(2377),
    [anon_sym_debugger] = ACTIONS(2377),
    [anon_sym_return] = ACTIONS(2377),
    [anon_sym_throw] = ACTIONS(2377),
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_case] = ACTIONS(2377),
    [anon_sym_yield] = ACTIONS(2377),
    [anon_sym_LBRACK] = ACTIONS(2375),
    [anon_sym_LTtemplate_GT] = ACTIONS(2375),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_class] = ACTIONS(2377),
    [anon_sym_async] = ACTIONS(2377),
    [anon_sym_function] = ACTIONS(2377),
    [anon_sym_new] = ACTIONS(2377),
    [anon_sym_PLUS] = ACTIONS(2377),
    [anon_sym_DASH] = ACTIONS(2377),
    [anon_sym_TILDE] = ACTIONS(2375),
    [anon_sym_void] = ACTIONS(2377),
    [anon_sym_delete] = ACTIONS(2377),
    [anon_sym_PLUS_PLUS] = ACTIONS(2375),
    [anon_sym_DASH_DASH] = ACTIONS(2375),
    [anon_sym_DQUOTE] = ACTIONS(2375),
    [anon_sym_SQUOTE] = ACTIONS(2375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2375),
    [sym_number] = ACTIONS(2375),
    [sym_this] = ACTIONS(2377),
    [sym_super] = ACTIONS(2377),
    [sym_true] = ACTIONS(2377),
    [sym_false] = ACTIONS(2377),
    [sym_null] = ACTIONS(2377),
    [sym_undefined] = ACTIONS(2377),
    [anon_sym_AT] = ACTIONS(2375),
    [anon_sym_static] = ACTIONS(2377),
    [anon_sym_readonly] = ACTIONS(2377),
    [anon_sym_get] = ACTIONS(2377),
    [anon_sym_set] = ACTIONS(2377),
    [anon_sym_declare] = ACTIONS(2377),
    [anon_sym_public] = ACTIONS(2377),
    [anon_sym_private] = ACTIONS(2377),
    [anon_sym_protected] = ACTIONS(2377),
    [anon_sym_override] = ACTIONS(2377),
    [anon_sym_module] = ACTIONS(2377),
    [anon_sym_any] = ACTIONS(2377),
    [anon_sym_number] = ACTIONS(2377),
    [anon_sym_boolean] = ACTIONS(2377),
    [anon_sym_string] = ACTIONS(2377),
    [anon_sym_symbol] = ACTIONS(2377),
    [anon_sym_abstract] = ACTIONS(2377),
    [anon_sym_interface] = ACTIONS(2377),
    [anon_sym_enum] = ACTIONS(2377),
  },
  [736] = {
    [ts_builtin_sym_end] = ACTIONS(2379),
    [sym_identifier] = ACTIONS(2381),
    [anon_sym_export] = ACTIONS(2381),
    [anon_sym_default] = ACTIONS(2381),
    [anon_sym_type] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2381),
    [anon_sym_LBRACE] = ACTIONS(2379),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_typeof] = ACTIONS(2381),
    [anon_sym_import] = ACTIONS(2381),
    [anon_sym_var] = ACTIONS(2381),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_const] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_else] = ACTIONS(2381),
    [anon_sym_if] = ACTIONS(2381),
    [anon_sym_switch] = ACTIONS(2381),
    [anon_sym_for] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2379),
    [anon_sym_await] = ACTIONS(2381),
    [anon_sym_while] = ACTIONS(2381),
    [anon_sym_do] = ACTIONS(2381),
    [anon_sym_try] = ACTIONS(2381),
    [anon_sym_with] = ACTIONS(2381),
    [anon_sym_break] = ACTIONS(2381),
    [anon_sym_continue] = ACTIONS(2381),
    [anon_sym_debugger] = ACTIONS(2381),
    [anon_sym_return] = ACTIONS(2381),
    [anon_sym_throw] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2379),
    [anon_sym_case] = ACTIONS(2381),
    [anon_sym_yield] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2379),
    [anon_sym_LTtemplate_GT] = ACTIONS(2379),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_SLASH] = ACTIONS(2381),
    [anon_sym_class] = ACTIONS(2381),
    [anon_sym_async] = ACTIONS(2381),
    [anon_sym_function] = ACTIONS(2381),
    [anon_sym_new] = ACTIONS(2381),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2379),
    [anon_sym_void] = ACTIONS(2381),
    [anon_sym_delete] = ACTIONS(2381),
    [anon_sym_PLUS_PLUS] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(2379),
    [anon_sym_DQUOTE] = ACTIONS(2379),
    [anon_sym_SQUOTE] = ACTIONS(2379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2379),
    [sym_number] = ACTIONS(2379),
    [sym_this] = ACTIONS(2381),
    [sym_super] = ACTIONS(2381),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_undefined] = ACTIONS(2381),
    [anon_sym_AT] = ACTIONS(2379),
    [anon_sym_static] = ACTIONS(2381),
    [anon_sym_readonly] = ACTIONS(2381),
    [anon_sym_get] = ACTIONS(2381),
    [anon_sym_set] = ACTIONS(2381),
    [anon_sym_declare] = ACTIONS(2381),
    [anon_sym_public] = ACTIONS(2381),
    [anon_sym_private] = ACTIONS(2381),
    [anon_sym_protected] = ACTIONS(2381),
    [anon_sym_override] = ACTIONS(2381),
    [anon_sym_module] = ACTIONS(2381),
    [anon_sym_any] = ACTIONS(2381),
    [anon_sym_number] = ACTIONS(2381),
    [anon_sym_boolean] = ACTIONS(2381),
    [anon_sym_string] = ACTIONS(2381),
    [anon_sym_symbol] = ACTIONS(2381),
    [anon_sym_abstract] = ACTIONS(2381),
    [anon_sym_interface] = ACTIONS(2381),
    [anon_sym_enum] = ACTIONS(2381),
  },
  [737] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [738] = {
    [ts_builtin_sym_end] = ACTIONS(2383),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_export] = ACTIONS(2385),
    [anon_sym_default] = ACTIONS(2385),
    [anon_sym_type] = ACTIONS(2385),
    [anon_sym_namespace] = ACTIONS(2385),
    [anon_sym_LBRACE] = ACTIONS(2383),
    [anon_sym_RBRACE] = ACTIONS(2383),
    [anon_sym_typeof] = ACTIONS(2385),
    [anon_sym_import] = ACTIONS(2385),
    [anon_sym_var] = ACTIONS(2385),
    [anon_sym_let] = ACTIONS(2385),
    [anon_sym_const] = ACTIONS(2385),
    [anon_sym_BANG] = ACTIONS(2383),
    [anon_sym_else] = ACTIONS(2385),
    [anon_sym_if] = ACTIONS(2385),
    [anon_sym_switch] = ACTIONS(2385),
    [anon_sym_for] = ACTIONS(2385),
    [anon_sym_LPAREN] = ACTIONS(2383),
    [anon_sym_await] = ACTIONS(2385),
    [anon_sym_while] = ACTIONS(2385),
    [anon_sym_do] = ACTIONS(2385),
    [anon_sym_try] = ACTIONS(2385),
    [anon_sym_with] = ACTIONS(2385),
    [anon_sym_break] = ACTIONS(2385),
    [anon_sym_continue] = ACTIONS(2385),
    [anon_sym_debugger] = ACTIONS(2385),
    [anon_sym_return] = ACTIONS(2385),
    [anon_sym_throw] = ACTIONS(2385),
    [anon_sym_SEMI] = ACTIONS(2383),
    [anon_sym_case] = ACTIONS(2385),
    [anon_sym_yield] = ACTIONS(2385),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LTtemplate_GT] = ACTIONS(2383),
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(2385),
    [anon_sym_class] = ACTIONS(2385),
    [anon_sym_async] = ACTIONS(2385),
    [anon_sym_function] = ACTIONS(2385),
    [anon_sym_new] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2385),
    [anon_sym_DASH] = ACTIONS(2385),
    [anon_sym_TILDE] = ACTIONS(2383),
    [anon_sym_void] = ACTIONS(2385),
    [anon_sym_delete] = ACTIONS(2385),
    [anon_sym_PLUS_PLUS] = ACTIONS(2383),
    [anon_sym_DASH_DASH] = ACTIONS(2383),
    [anon_sym_DQUOTE] = ACTIONS(2383),
    [anon_sym_SQUOTE] = ACTIONS(2383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2383),
    [sym_number] = ACTIONS(2383),
    [sym_this] = ACTIONS(2385),
    [sym_super] = ACTIONS(2385),
    [sym_true] = ACTIONS(2385),
    [sym_false] = ACTIONS(2385),
    [sym_null] = ACTIONS(2385),
    [sym_undefined] = ACTIONS(2385),
    [anon_sym_AT] = ACTIONS(2383),
    [anon_sym_static] = ACTIONS(2385),
    [anon_sym_readonly] = ACTIONS(2385),
    [anon_sym_get] = ACTIONS(2385),
    [anon_sym_set] = ACTIONS(2385),
    [anon_sym_declare] = ACTIONS(2385),
    [anon_sym_public] = ACTIONS(2385),
    [anon_sym_private] = ACTIONS(2385),
    [anon_sym_protected] = ACTIONS(2385),
    [anon_sym_override] = ACTIONS(2385),
    [anon_sym_module] = ACTIONS(2385),
    [anon_sym_any] = ACTIONS(2385),
    [anon_sym_number] = ACTIONS(2385),
    [anon_sym_boolean] = ACTIONS(2385),
    [anon_sym_string] = ACTIONS(2385),
    [anon_sym_symbol] = ACTIONS(2385),
    [anon_sym_abstract] = ACTIONS(2385),
    [anon_sym_interface] = ACTIONS(2385),
    [anon_sym_enum] = ACTIONS(2385),
  },
  [739] = {
    [ts_builtin_sym_end] = ACTIONS(2387),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_export] = ACTIONS(2389),
    [anon_sym_default] = ACTIONS(2389),
    [anon_sym_type] = ACTIONS(2389),
    [anon_sym_namespace] = ACTIONS(2389),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_typeof] = ACTIONS(2389),
    [anon_sym_import] = ACTIONS(2389),
    [anon_sym_var] = ACTIONS(2389),
    [anon_sym_let] = ACTIONS(2389),
    [anon_sym_const] = ACTIONS(2389),
    [anon_sym_BANG] = ACTIONS(2387),
    [anon_sym_else] = ACTIONS(2389),
    [anon_sym_if] = ACTIONS(2389),
    [anon_sym_switch] = ACTIONS(2389),
    [anon_sym_for] = ACTIONS(2389),
    [anon_sym_LPAREN] = ACTIONS(2387),
    [anon_sym_await] = ACTIONS(2389),
    [anon_sym_while] = ACTIONS(2389),
    [anon_sym_do] = ACTIONS(2389),
    [anon_sym_try] = ACTIONS(2389),
    [anon_sym_with] = ACTIONS(2389),
    [anon_sym_break] = ACTIONS(2389),
    [anon_sym_continue] = ACTIONS(2389),
    [anon_sym_debugger] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(2389),
    [anon_sym_throw] = ACTIONS(2389),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_case] = ACTIONS(2389),
    [anon_sym_yield] = ACTIONS(2389),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [anon_sym_LTtemplate_GT] = ACTIONS(2387),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_SLASH] = ACTIONS(2389),
    [anon_sym_class] = ACTIONS(2389),
    [anon_sym_async] = ACTIONS(2389),
    [anon_sym_function] = ACTIONS(2389),
    [anon_sym_new] = ACTIONS(2389),
    [anon_sym_PLUS] = ACTIONS(2389),
    [anon_sym_DASH] = ACTIONS(2389),
    [anon_sym_TILDE] = ACTIONS(2387),
    [anon_sym_void] = ACTIONS(2389),
    [anon_sym_delete] = ACTIONS(2389),
    [anon_sym_PLUS_PLUS] = ACTIONS(2387),
    [anon_sym_DASH_DASH] = ACTIONS(2387),
    [anon_sym_DQUOTE] = ACTIONS(2387),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2387),
    [sym_number] = ACTIONS(2387),
    [sym_this] = ACTIONS(2389),
    [sym_super] = ACTIONS(2389),
    [sym_true] = ACTIONS(2389),
    [sym_false] = ACTIONS(2389),
    [sym_null] = ACTIONS(2389),
    [sym_undefined] = ACTIONS(2389),
    [anon_sym_AT] = ACTIONS(2387),
    [anon_sym_static] = ACTIONS(2389),
    [anon_sym_readonly] = ACTIONS(2389),
    [anon_sym_get] = ACTIONS(2389),
    [anon_sym_set] = ACTIONS(2389),
    [anon_sym_declare] = ACTIONS(2389),
    [anon_sym_public] = ACTIONS(2389),
    [anon_sym_private] = ACTIONS(2389),
    [anon_sym_protected] = ACTIONS(2389),
    [anon_sym_override] = ACTIONS(2389),
    [anon_sym_module] = ACTIONS(2389),
    [anon_sym_any] = ACTIONS(2389),
    [anon_sym_number] = ACTIONS(2389),
    [anon_sym_boolean] = ACTIONS(2389),
    [anon_sym_string] = ACTIONS(2389),
    [anon_sym_symbol] = ACTIONS(2389),
    [anon_sym_abstract] = ACTIONS(2389),
    [anon_sym_interface] = ACTIONS(2389),
    [anon_sym_enum] = ACTIONS(2389),
  },
  [740] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [741] = {
    [ts_builtin_sym_end] = ACTIONS(2391),
    [sym_identifier] = ACTIONS(2393),
    [anon_sym_export] = ACTIONS(2393),
    [anon_sym_default] = ACTIONS(2393),
    [anon_sym_type] = ACTIONS(2393),
    [anon_sym_namespace] = ACTIONS(2393),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_RBRACE] = ACTIONS(2391),
    [anon_sym_typeof] = ACTIONS(2393),
    [anon_sym_import] = ACTIONS(2393),
    [anon_sym_var] = ACTIONS(2393),
    [anon_sym_let] = ACTIONS(2393),
    [anon_sym_const] = ACTIONS(2393),
    [anon_sym_BANG] = ACTIONS(2391),
    [anon_sym_else] = ACTIONS(2393),
    [anon_sym_if] = ACTIONS(2393),
    [anon_sym_switch] = ACTIONS(2393),
    [anon_sym_for] = ACTIONS(2393),
    [anon_sym_LPAREN] = ACTIONS(2391),
    [anon_sym_await] = ACTIONS(2393),
    [anon_sym_while] = ACTIONS(2393),
    [anon_sym_do] = ACTIONS(2393),
    [anon_sym_try] = ACTIONS(2393),
    [anon_sym_with] = ACTIONS(2393),
    [anon_sym_break] = ACTIONS(2393),
    [anon_sym_continue] = ACTIONS(2393),
    [anon_sym_debugger] = ACTIONS(2393),
    [anon_sym_return] = ACTIONS(2393),
    [anon_sym_throw] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2391),
    [anon_sym_case] = ACTIONS(2393),
    [anon_sym_yield] = ACTIONS(2393),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_LTtemplate_GT] = ACTIONS(2391),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_SLASH] = ACTIONS(2393),
    [anon_sym_class] = ACTIONS(2393),
    [anon_sym_async] = ACTIONS(2393),
    [anon_sym_function] = ACTIONS(2393),
    [anon_sym_new] = ACTIONS(2393),
    [anon_sym_PLUS] = ACTIONS(2393),
    [anon_sym_DASH] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2391),
    [anon_sym_void] = ACTIONS(2393),
    [anon_sym_delete] = ACTIONS(2393),
    [anon_sym_PLUS_PLUS] = ACTIONS(2391),
    [anon_sym_DASH_DASH] = ACTIONS(2391),
    [anon_sym_DQUOTE] = ACTIONS(2391),
    [anon_sym_SQUOTE] = ACTIONS(2391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2391),
    [sym_number] = ACTIONS(2391),
    [sym_this] = ACTIONS(2393),
    [sym_super] = ACTIONS(2393),
    [sym_true] = ACTIONS(2393),
    [sym_false] = ACTIONS(2393),
    [sym_null] = ACTIONS(2393),
    [sym_undefined] = ACTIONS(2393),
    [anon_sym_AT] = ACTIONS(2391),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_readonly] = ACTIONS(2393),
    [anon_sym_get] = ACTIONS(2393),
    [anon_sym_set] = ACTIONS(2393),
    [anon_sym_declare] = ACTIONS(2393),
    [anon_sym_public] = ACTIONS(2393),
    [anon_sym_private] = ACTIONS(2393),
    [anon_sym_protected] = ACTIONS(2393),
    [anon_sym_override] = ACTIONS(2393),
    [anon_sym_module] = ACTIONS(2393),
    [anon_sym_any] = ACTIONS(2393),
    [anon_sym_number] = ACTIONS(2393),
    [anon_sym_boolean] = ACTIONS(2393),
    [anon_sym_string] = ACTIONS(2393),
    [anon_sym_symbol] = ACTIONS(2393),
    [anon_sym_abstract] = ACTIONS(2393),
    [anon_sym_interface] = ACTIONS(2393),
    [anon_sym_enum] = ACTIONS(2393),
  },
  [742] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [743] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [744] = {
    [ts_builtin_sym_end] = ACTIONS(2395),
    [sym_identifier] = ACTIONS(2397),
    [anon_sym_export] = ACTIONS(2397),
    [anon_sym_default] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2397),
    [anon_sym_namespace] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(2395),
    [anon_sym_RBRACE] = ACTIONS(2395),
    [anon_sym_typeof] = ACTIONS(2397),
    [anon_sym_import] = ACTIONS(2397),
    [anon_sym_var] = ACTIONS(2397),
    [anon_sym_let] = ACTIONS(2397),
    [anon_sym_const] = ACTIONS(2397),
    [anon_sym_BANG] = ACTIONS(2395),
    [anon_sym_else] = ACTIONS(2397),
    [anon_sym_if] = ACTIONS(2397),
    [anon_sym_switch] = ACTIONS(2397),
    [anon_sym_for] = ACTIONS(2397),
    [anon_sym_LPAREN] = ACTIONS(2395),
    [anon_sym_await] = ACTIONS(2397),
    [anon_sym_while] = ACTIONS(2397),
    [anon_sym_do] = ACTIONS(2397),
    [anon_sym_try] = ACTIONS(2397),
    [anon_sym_with] = ACTIONS(2397),
    [anon_sym_break] = ACTIONS(2397),
    [anon_sym_continue] = ACTIONS(2397),
    [anon_sym_debugger] = ACTIONS(2397),
    [anon_sym_return] = ACTIONS(2397),
    [anon_sym_throw] = ACTIONS(2397),
    [anon_sym_SEMI] = ACTIONS(2395),
    [anon_sym_case] = ACTIONS(2397),
    [anon_sym_yield] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_LTtemplate_GT] = ACTIONS(2395),
    [anon_sym_LT] = ACTIONS(2397),
    [anon_sym_SLASH] = ACTIONS(2397),
    [anon_sym_class] = ACTIONS(2397),
    [anon_sym_async] = ACTIONS(2397),
    [anon_sym_function] = ACTIONS(2397),
    [anon_sym_new] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(2397),
    [anon_sym_DASH] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_void] = ACTIONS(2397),
    [anon_sym_delete] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2395),
    [anon_sym_DASH_DASH] = ACTIONS(2395),
    [anon_sym_DQUOTE] = ACTIONS(2395),
    [anon_sym_SQUOTE] = ACTIONS(2395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2395),
    [sym_number] = ACTIONS(2395),
    [sym_this] = ACTIONS(2397),
    [sym_super] = ACTIONS(2397),
    [sym_true] = ACTIONS(2397),
    [sym_false] = ACTIONS(2397),
    [sym_null] = ACTIONS(2397),
    [sym_undefined] = ACTIONS(2397),
    [anon_sym_AT] = ACTIONS(2395),
    [anon_sym_static] = ACTIONS(2397),
    [anon_sym_readonly] = ACTIONS(2397),
    [anon_sym_get] = ACTIONS(2397),
    [anon_sym_set] = ACTIONS(2397),
    [anon_sym_declare] = ACTIONS(2397),
    [anon_sym_public] = ACTIONS(2397),
    [anon_sym_private] = ACTIONS(2397),
    [anon_sym_protected] = ACTIONS(2397),
    [anon_sym_override] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(2397),
    [anon_sym_any] = ACTIONS(2397),
    [anon_sym_number] = ACTIONS(2397),
    [anon_sym_boolean] = ACTIONS(2397),
    [anon_sym_string] = ACTIONS(2397),
    [anon_sym_symbol] = ACTIONS(2397),
    [anon_sym_abstract] = ACTIONS(2397),
    [anon_sym_interface] = ACTIONS(2397),
    [anon_sym_enum] = ACTIONS(2397),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [746] = {
    [ts_builtin_sym_end] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [anon_sym_export] = ACTIONS(1588),
    [anon_sym_default] = ACTIONS(1588),
    [anon_sym_type] = ACTIONS(1588),
    [anon_sym_namespace] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_typeof] = ACTIONS(1588),
    [anon_sym_import] = ACTIONS(1588),
    [anon_sym_var] = ACTIONS(1588),
    [anon_sym_let] = ACTIONS(1588),
    [anon_sym_const] = ACTIONS(1588),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_switch] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1586),
    [anon_sym_await] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_try] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_break] = ACTIONS(1588),
    [anon_sym_continue] = ACTIONS(1588),
    [anon_sym_debugger] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_throw] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym_case] = ACTIONS(1588),
    [anon_sym_yield] = ACTIONS(1588),
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_LTtemplate_GT] = ACTIONS(1586),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_SLASH] = ACTIONS(1588),
    [anon_sym_class] = ACTIONS(1588),
    [anon_sym_async] = ACTIONS(1588),
    [anon_sym_function] = ACTIONS(1588),
    [anon_sym_new] = ACTIONS(1588),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1586),
    [sym_number] = ACTIONS(1586),
    [sym_this] = ACTIONS(1588),
    [sym_super] = ACTIONS(1588),
    [sym_true] = ACTIONS(1588),
    [sym_false] = ACTIONS(1588),
    [sym_null] = ACTIONS(1588),
    [sym_undefined] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(1586),
    [anon_sym_static] = ACTIONS(1588),
    [anon_sym_readonly] = ACTIONS(1588),
    [anon_sym_get] = ACTIONS(1588),
    [anon_sym_set] = ACTIONS(1588),
    [anon_sym_declare] = ACTIONS(1588),
    [anon_sym_public] = ACTIONS(1588),
    [anon_sym_private] = ACTIONS(1588),
    [anon_sym_protected] = ACTIONS(1588),
    [anon_sym_override] = ACTIONS(1588),
    [anon_sym_module] = ACTIONS(1588),
    [anon_sym_any] = ACTIONS(1588),
    [anon_sym_number] = ACTIONS(1588),
    [anon_sym_boolean] = ACTIONS(1588),
    [anon_sym_string] = ACTIONS(1588),
    [anon_sym_symbol] = ACTIONS(1588),
    [anon_sym_abstract] = ACTIONS(1588),
    [anon_sym_interface] = ACTIONS(1588),
    [anon_sym_enum] = ACTIONS(1588),
  },
  [747] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [748] = {
    [ts_builtin_sym_end] = ACTIONS(2207),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2209),
    [anon_sym_default] = ACTIONS(2209),
    [anon_sym_type] = ACTIONS(2209),
    [anon_sym_namespace] = ACTIONS(2209),
    [anon_sym_LBRACE] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2207),
    [anon_sym_typeof] = ACTIONS(2209),
    [anon_sym_import] = ACTIONS(2209),
    [anon_sym_var] = ACTIONS(2209),
    [anon_sym_let] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2209),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_else] = ACTIONS(2209),
    [anon_sym_if] = ACTIONS(2209),
    [anon_sym_switch] = ACTIONS(2209),
    [anon_sym_for] = ACTIONS(2209),
    [anon_sym_LPAREN] = ACTIONS(2207),
    [anon_sym_await] = ACTIONS(2209),
    [anon_sym_while] = ACTIONS(2209),
    [anon_sym_do] = ACTIONS(2209),
    [anon_sym_try] = ACTIONS(2209),
    [anon_sym_with] = ACTIONS(2209),
    [anon_sym_break] = ACTIONS(2209),
    [anon_sym_continue] = ACTIONS(2209),
    [anon_sym_debugger] = ACTIONS(2209),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_throw] = ACTIONS(2209),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_case] = ACTIONS(2209),
    [anon_sym_yield] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(2207),
    [anon_sym_LTtemplate_GT] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2209),
    [anon_sym_SLASH] = ACTIONS(2209),
    [anon_sym_class] = ACTIONS(2209),
    [anon_sym_async] = ACTIONS(2209),
    [anon_sym_function] = ACTIONS(2209),
    [anon_sym_new] = ACTIONS(2209),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2207),
    [anon_sym_void] = ACTIONS(2209),
    [anon_sym_delete] = ACTIONS(2209),
    [anon_sym_PLUS_PLUS] = ACTIONS(2207),
    [anon_sym_DASH_DASH] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [anon_sym_SQUOTE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_number] = ACTIONS(2207),
    [sym_this] = ACTIONS(2209),
    [sym_super] = ACTIONS(2209),
    [sym_true] = ACTIONS(2209),
    [sym_false] = ACTIONS(2209),
    [sym_null] = ACTIONS(2209),
    [sym_undefined] = ACTIONS(2209),
    [anon_sym_AT] = ACTIONS(2207),
    [anon_sym_static] = ACTIONS(2209),
    [anon_sym_readonly] = ACTIONS(2209),
    [anon_sym_get] = ACTIONS(2209),
    [anon_sym_set] = ACTIONS(2209),
    [anon_sym_declare] = ACTIONS(2209),
    [anon_sym_public] = ACTIONS(2209),
    [anon_sym_private] = ACTIONS(2209),
    [anon_sym_protected] = ACTIONS(2209),
    [anon_sym_override] = ACTIONS(2209),
    [anon_sym_module] = ACTIONS(2209),
    [anon_sym_any] = ACTIONS(2209),
    [anon_sym_number] = ACTIONS(2209),
    [anon_sym_boolean] = ACTIONS(2209),
    [anon_sym_string] = ACTIONS(2209),
    [anon_sym_symbol] = ACTIONS(2209),
    [anon_sym_abstract] = ACTIONS(2209),
    [anon_sym_interface] = ACTIONS(2209),
    [anon_sym_enum] = ACTIONS(2209),
  },
  [749] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
  },
  [750] = {
    [ts_builtin_sym_end] = ACTIONS(2399),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_export] = ACTIONS(2401),
    [anon_sym_default] = ACTIONS(2401),
    [anon_sym_type] = ACTIONS(2401),
    [anon_sym_namespace] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2399),
    [anon_sym_RBRACE] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2401),
    [anon_sym_import] = ACTIONS(2401),
    [anon_sym_var] = ACTIONS(2401),
    [anon_sym_let] = ACTIONS(2401),
    [anon_sym_const] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_else] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_switch] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2399),
    [anon_sym_await] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(2401),
    [anon_sym_do] = ACTIONS(2401),
    [anon_sym_try] = ACTIONS(2401),
    [anon_sym_with] = ACTIONS(2401),
    [anon_sym_break] = ACTIONS(2401),
    [anon_sym_continue] = ACTIONS(2401),
    [anon_sym_debugger] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(2401),
    [anon_sym_throw] = ACTIONS(2401),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_case] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [anon_sym_LTtemplate_GT] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_class] = ACTIONS(2401),
    [anon_sym_async] = ACTIONS(2401),
    [anon_sym_function] = ACTIONS(2401),
    [anon_sym_new] = ACTIONS(2401),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_void] = ACTIONS(2401),
    [anon_sym_delete] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2399),
    [anon_sym_DASH_DASH] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [anon_sym_SQUOTE] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [sym_number] = ACTIONS(2399),
    [sym_this] = ACTIONS(2401),
    [sym_super] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_null] = ACTIONS(2401),
    [sym_undefined] = ACTIONS(2401),
    [anon_sym_AT] = ACTIONS(2399),
    [anon_sym_static] = ACTIONS(2401),
    [anon_sym_readonly] = ACTIONS(2401),
    [anon_sym_get] = ACTIONS(2401),
    [anon_sym_set] = ACTIONS(2401),
    [anon_sym_declare] = ACTIONS(2401),
    [anon_sym_public] = ACTIONS(2401),
    [anon_sym_private] = ACTIONS(2401),
    [anon_sym_protected] = ACTIONS(2401),
    [anon_sym_override] = ACTIONS(2401),
    [anon_sym_module] = ACTIONS(2401),
    [anon_sym_any] = ACTIONS(2401),
    [anon_sym_number] = ACTIONS(2401),
    [anon_sym_boolean] = ACTIONS(2401),
    [anon_sym_string] = ACTIONS(2401),
    [anon_sym_symbol] = ACTIONS(2401),
    [anon_sym_abstract] = ACTIONS(2401),
    [anon_sym_interface] = ACTIONS(2401),
    [anon_sym_enum] = ACTIONS(2401),
  },
  [751] = {
    [ts_builtin_sym_end] = ACTIONS(1602),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_export] = ACTIONS(1604),
    [anon_sym_default] = ACTIONS(1604),
    [anon_sym_type] = ACTIONS(1604),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1602),
    [anon_sym_RBRACE] = ACTIONS(1602),
    [anon_sym_typeof] = ACTIONS(1604),
    [anon_sym_import] = ACTIONS(1604),
    [anon_sym_var] = ACTIONS(1604),
    [anon_sym_let] = ACTIONS(1604),
    [anon_sym_const] = ACTIONS(1604),
    [anon_sym_BANG] = ACTIONS(1602),
    [anon_sym_else] = ACTIONS(1604),
    [anon_sym_if] = ACTIONS(1604),
    [anon_sym_switch] = ACTIONS(1604),
    [anon_sym_for] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_await] = ACTIONS(1604),
    [anon_sym_while] = ACTIONS(1604),
    [anon_sym_do] = ACTIONS(1604),
    [anon_sym_try] = ACTIONS(1604),
    [anon_sym_with] = ACTIONS(1604),
    [anon_sym_break] = ACTIONS(1604),
    [anon_sym_continue] = ACTIONS(1604),
    [anon_sym_debugger] = ACTIONS(1604),
    [anon_sym_return] = ACTIONS(1604),
    [anon_sym_throw] = ACTIONS(1604),
    [anon_sym_SEMI] = ACTIONS(1602),
    [anon_sym_case] = ACTIONS(1604),
    [anon_sym_yield] = ACTIONS(1604),
    [anon_sym_LBRACK] = ACTIONS(1602),
    [anon_sym_LTtemplate_GT] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(1604),
    [anon_sym_SLASH] = ACTIONS(1604),
    [anon_sym_class] = ACTIONS(1604),
    [anon_sym_async] = ACTIONS(1604),
    [anon_sym_function] = ACTIONS(1604),
    [anon_sym_new] = ACTIONS(1604),
    [anon_sym_PLUS] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [anon_sym_TILDE] = ACTIONS(1602),
    [anon_sym_void] = ACTIONS(1604),
    [anon_sym_delete] = ACTIONS(1604),
    [anon_sym_PLUS_PLUS] = ACTIONS(1602),
    [anon_sym_DASH_DASH] = ACTIONS(1602),
    [anon_sym_DQUOTE] = ACTIONS(1602),
    [anon_sym_SQUOTE] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1602),
    [sym_number] = ACTIONS(1602),
    [sym_this] = ACTIONS(1604),
    [sym_super] = ACTIONS(1604),
    [sym_true] = ACTIONS(1604),
    [sym_false] = ACTIONS(1604),
    [sym_null] = ACTIONS(1604),
    [sym_undefined] = ACTIONS(1604),
    [anon_sym_AT] = ACTIONS(1602),
    [anon_sym_static] = ACTIONS(1604),
    [anon_sym_readonly] = ACTIONS(1604),
    [anon_sym_get] = ACTIONS(1604),
    [anon_sym_set] = ACTIONS(1604),
    [anon_sym_declare] = ACTIONS(1604),
    [anon_sym_public] = ACTIONS(1604),
    [anon_sym_private] = ACTIONS(1604),
    [anon_sym_protected] = ACTIONS(1604),
    [anon_sym_override] = ACTIONS(1604),
    [anon_sym_module] = ACTIONS(1604),
    [anon_sym_any] = ACTIONS(1604),
    [anon_sym_number] = ACTIONS(1604),
    [anon_sym_boolean] = ACTIONS(1604),
    [anon_sym_string] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1604),
    [anon_sym_abstract] = ACTIONS(1604),
    [anon_sym_interface] = ACTIONS(1604),
    [anon_sym_enum] = ACTIONS(1604),
  },
  [752] = {
    [ts_builtin_sym_end] = ACTIONS(2403),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_export] = ACTIONS(2405),
    [anon_sym_default] = ACTIONS(2405),
    [anon_sym_type] = ACTIONS(2405),
    [anon_sym_namespace] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_RBRACE] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_import] = ACTIONS(2405),
    [anon_sym_var] = ACTIONS(2405),
    [anon_sym_let] = ACTIONS(2405),
    [anon_sym_const] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(2403),
    [anon_sym_else] = ACTIONS(2405),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_switch] = ACTIONS(2405),
    [anon_sym_for] = ACTIONS(2405),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_await] = ACTIONS(2405),
    [anon_sym_while] = ACTIONS(2405),
    [anon_sym_do] = ACTIONS(2405),
    [anon_sym_try] = ACTIONS(2405),
    [anon_sym_with] = ACTIONS(2405),
    [anon_sym_break] = ACTIONS(2405),
    [anon_sym_continue] = ACTIONS(2405),
    [anon_sym_debugger] = ACTIONS(2405),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_throw] = ACTIONS(2405),
    [anon_sym_SEMI] = ACTIONS(2403),
    [anon_sym_case] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2405),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_LTtemplate_GT] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_SLASH] = ACTIONS(2405),
    [anon_sym_class] = ACTIONS(2405),
    [anon_sym_async] = ACTIONS(2405),
    [anon_sym_function] = ACTIONS(2405),
    [anon_sym_new] = ACTIONS(2405),
    [anon_sym_PLUS] = ACTIONS(2405),
    [anon_sym_DASH] = ACTIONS(2405),
    [anon_sym_TILDE] = ACTIONS(2403),
    [anon_sym_void] = ACTIONS(2405),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_PLUS_PLUS] = ACTIONS(2403),
    [anon_sym_DASH_DASH] = ACTIONS(2403),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_number] = ACTIONS(2403),
    [sym_this] = ACTIONS(2405),
    [sym_super] = ACTIONS(2405),
    [sym_true] = ACTIONS(2405),
    [sym_false] = ACTIONS(2405),
    [sym_null] = ACTIONS(2405),
    [sym_undefined] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(2403),
    [anon_sym_static] = ACTIONS(2405),
    [anon_sym_readonly] = ACTIONS(2405),
    [anon_sym_get] = ACTIONS(2405),
    [anon_sym_set] = ACTIONS(2405),
    [anon_sym_declare] = ACTIONS(2405),
    [anon_sym_public] = ACTIONS(2405),
    [anon_sym_private] = ACTIONS(2405),
    [anon_sym_protected] = ACTIONS(2405),
    [anon_sym_override] = ACTIONS(2405),
    [anon_sym_module] = ACTIONS(2405),
    [anon_sym_any] = ACTIONS(2405),
    [anon_sym_number] = ACTIONS(2405),
    [anon_sym_boolean] = ACTIONS(2405),
    [anon_sym_string] = ACTIONS(2405),
    [anon_sym_symbol] = ACTIONS(2405),
    [anon_sym_abstract] = ACTIONS(2405),
    [anon_sym_interface] = ACTIONS(2405),
    [anon_sym_enum] = ACTIONS(2405),
  },
  [753] = {
    [ts_builtin_sym_end] = ACTIONS(2207),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2209),
    [anon_sym_default] = ACTIONS(2209),
    [anon_sym_type] = ACTIONS(2209),
    [anon_sym_namespace] = ACTIONS(2209),
    [anon_sym_LBRACE] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2207),
    [anon_sym_typeof] = ACTIONS(2209),
    [anon_sym_import] = ACTIONS(2209),
    [anon_sym_var] = ACTIONS(2209),
    [anon_sym_let] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2209),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_else] = ACTIONS(2209),
    [anon_sym_if] = ACTIONS(2209),
    [anon_sym_switch] = ACTIONS(2209),
    [anon_sym_for] = ACTIONS(2209),
    [anon_sym_LPAREN] = ACTIONS(2207),
    [anon_sym_await] = ACTIONS(2209),
    [anon_sym_while] = ACTIONS(2209),
    [anon_sym_do] = ACTIONS(2209),
    [anon_sym_try] = ACTIONS(2209),
    [anon_sym_with] = ACTIONS(2209),
    [anon_sym_break] = ACTIONS(2209),
    [anon_sym_continue] = ACTIONS(2209),
    [anon_sym_debugger] = ACTIONS(2209),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_throw] = ACTIONS(2209),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_case] = ACTIONS(2209),
    [anon_sym_yield] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(2207),
    [anon_sym_LTtemplate_GT] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2209),
    [anon_sym_SLASH] = ACTIONS(2209),
    [anon_sym_class] = ACTIONS(2209),
    [anon_sym_async] = ACTIONS(2209),
    [anon_sym_function] = ACTIONS(2209),
    [anon_sym_new] = ACTIONS(2209),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2207),
    [anon_sym_void] = ACTIONS(2209),
    [anon_sym_delete] = ACTIONS(2209),
    [anon_sym_PLUS_PLUS] = ACTIONS(2207),
    [anon_sym_DASH_DASH] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [anon_sym_SQUOTE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_number] = ACTIONS(2207),
    [sym_this] = ACTIONS(2209),
    [sym_super] = ACTIONS(2209),
    [sym_true] = ACTIONS(2209),
    [sym_false] = ACTIONS(2209),
    [sym_null] = ACTIONS(2209),
    [sym_undefined] = ACTIONS(2209),
    [anon_sym_AT] = ACTIONS(2207),
    [anon_sym_static] = ACTIONS(2209),
    [anon_sym_readonly] = ACTIONS(2209),
    [anon_sym_get] = ACTIONS(2209),
    [anon_sym_set] = ACTIONS(2209),
    [anon_sym_declare] = ACTIONS(2209),
    [anon_sym_public] = ACTIONS(2209),
    [anon_sym_private] = ACTIONS(2209),
    [anon_sym_protected] = ACTIONS(2209),
    [anon_sym_override] = ACTIONS(2209),
    [anon_sym_module] = ACTIONS(2209),
    [anon_sym_any] = ACTIONS(2209),
    [anon_sym_number] = ACTIONS(2209),
    [anon_sym_boolean] = ACTIONS(2209),
    [anon_sym_string] = ACTIONS(2209),
    [anon_sym_symbol] = ACTIONS(2209),
    [anon_sym_abstract] = ACTIONS(2209),
    [anon_sym_interface] = ACTIONS(2209),
    [anon_sym_enum] = ACTIONS(2209),
  },
  [754] = {
    [ts_builtin_sym_end] = ACTIONS(2407),
    [sym_identifier] = ACTIONS(2409),
    [anon_sym_export] = ACTIONS(2409),
    [anon_sym_default] = ACTIONS(2409),
    [anon_sym_type] = ACTIONS(2409),
    [anon_sym_namespace] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_RBRACE] = ACTIONS(2407),
    [anon_sym_typeof] = ACTIONS(2409),
    [anon_sym_import] = ACTIONS(2409),
    [anon_sym_var] = ACTIONS(2409),
    [anon_sym_let] = ACTIONS(2409),
    [anon_sym_const] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(2407),
    [anon_sym_else] = ACTIONS(2409),
    [anon_sym_if] = ACTIONS(2409),
    [anon_sym_switch] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2409),
    [anon_sym_while] = ACTIONS(2409),
    [anon_sym_do] = ACTIONS(2409),
    [anon_sym_try] = ACTIONS(2409),
    [anon_sym_with] = ACTIONS(2409),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_continue] = ACTIONS(2409),
    [anon_sym_debugger] = ACTIONS(2409),
    [anon_sym_return] = ACTIONS(2409),
    [anon_sym_throw] = ACTIONS(2409),
    [anon_sym_SEMI] = ACTIONS(2407),
    [anon_sym_case] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LTtemplate_GT] = ACTIONS(2407),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_SLASH] = ACTIONS(2409),
    [anon_sym_class] = ACTIONS(2409),
    [anon_sym_async] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_TILDE] = ACTIONS(2407),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_delete] = ACTIONS(2409),
    [anon_sym_PLUS_PLUS] = ACTIONS(2407),
    [anon_sym_DASH_DASH] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_SQUOTE] = ACTIONS(2407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2407),
    [sym_number] = ACTIONS(2407),
    [sym_this] = ACTIONS(2409),
    [sym_super] = ACTIONS(2409),
    [sym_true] = ACTIONS(2409),
    [sym_false] = ACTIONS(2409),
    [sym_null] = ACTIONS(2409),
    [sym_undefined] = ACTIONS(2409),
    [anon_sym_AT] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(2409),
    [anon_sym_readonly] = ACTIONS(2409),
    [anon_sym_get] = ACTIONS(2409),
    [anon_sym_set] = ACTIONS(2409),
    [anon_sym_declare] = ACTIONS(2409),
    [anon_sym_public] = ACTIONS(2409),
    [anon_sym_private] = ACTIONS(2409),
    [anon_sym_protected] = ACTIONS(2409),
    [anon_sym_override] = ACTIONS(2409),
    [anon_sym_module] = ACTIONS(2409),
    [anon_sym_any] = ACTIONS(2409),
    [anon_sym_number] = ACTIONS(2409),
    [anon_sym_boolean] = ACTIONS(2409),
    [anon_sym_string] = ACTIONS(2409),
    [anon_sym_symbol] = ACTIONS(2409),
    [anon_sym_abstract] = ACTIONS(2409),
    [anon_sym_interface] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2409),
  },
  [755] = {
    [ts_builtin_sym_end] = ACTIONS(2411),
    [sym_identifier] = ACTIONS(2413),
    [anon_sym_export] = ACTIONS(2413),
    [anon_sym_default] = ACTIONS(2413),
    [anon_sym_type] = ACTIONS(2413),
    [anon_sym_namespace] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_RBRACE] = ACTIONS(2411),
    [anon_sym_typeof] = ACTIONS(2413),
    [anon_sym_import] = ACTIONS(2413),
    [anon_sym_var] = ACTIONS(2413),
    [anon_sym_let] = ACTIONS(2413),
    [anon_sym_const] = ACTIONS(2413),
    [anon_sym_BANG] = ACTIONS(2411),
    [anon_sym_else] = ACTIONS(2413),
    [anon_sym_if] = ACTIONS(2413),
    [anon_sym_switch] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_await] = ACTIONS(2413),
    [anon_sym_while] = ACTIONS(2413),
    [anon_sym_do] = ACTIONS(2413),
    [anon_sym_try] = ACTIONS(2413),
    [anon_sym_with] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2413),
    [anon_sym_continue] = ACTIONS(2413),
    [anon_sym_debugger] = ACTIONS(2413),
    [anon_sym_return] = ACTIONS(2413),
    [anon_sym_throw] = ACTIONS(2413),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_case] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LTtemplate_GT] = ACTIONS(2411),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_async] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_void] = ACTIONS(2413),
    [anon_sym_delete] = ACTIONS(2413),
    [anon_sym_PLUS_PLUS] = ACTIONS(2411),
    [anon_sym_DASH_DASH] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_SQUOTE] = ACTIONS(2411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [sym_number] = ACTIONS(2411),
    [sym_this] = ACTIONS(2413),
    [sym_super] = ACTIONS(2413),
    [sym_true] = ACTIONS(2413),
    [sym_false] = ACTIONS(2413),
    [sym_null] = ACTIONS(2413),
    [sym_undefined] = ACTIONS(2413),
    [anon_sym_AT] = ACTIONS(2411),
    [anon_sym_static] = ACTIONS(2413),
    [anon_sym_readonly] = ACTIONS(2413),
    [anon_sym_get] = ACTIONS(2413),
    [anon_sym_set] = ACTIONS(2413),
    [anon_sym_declare] = ACTIONS(2413),
    [anon_sym_public] = ACTIONS(2413),
    [anon_sym_private] = ACTIONS(2413),
    [anon_sym_protected] = ACTIONS(2413),
    [anon_sym_override] = ACTIONS(2413),
    [anon_sym_module] = ACTIONS(2413),
    [anon_sym_any] = ACTIONS(2413),
    [anon_sym_number] = ACTIONS(2413),
    [anon_sym_boolean] = ACTIONS(2413),
    [anon_sym_string] = ACTIONS(2413),
    [anon_sym_symbol] = ACTIONS(2413),
    [anon_sym_abstract] = ACTIONS(2413),
    [anon_sym_interface] = ACTIONS(2413),
    [anon_sym_enum] = ACTIONS(2413),
  },
  [756] = {
    [ts_builtin_sym_end] = ACTIONS(2415),
    [sym_identifier] = ACTIONS(2417),
    [anon_sym_export] = ACTIONS(2417),
    [anon_sym_default] = ACTIONS(2417),
    [anon_sym_type] = ACTIONS(2417),
    [anon_sym_namespace] = ACTIONS(2417),
    [anon_sym_LBRACE] = ACTIONS(2415),
    [anon_sym_RBRACE] = ACTIONS(2415),
    [anon_sym_typeof] = ACTIONS(2417),
    [anon_sym_import] = ACTIONS(2417),
    [anon_sym_var] = ACTIONS(2417),
    [anon_sym_let] = ACTIONS(2417),
    [anon_sym_const] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2415),
    [anon_sym_else] = ACTIONS(2417),
    [anon_sym_if] = ACTIONS(2417),
    [anon_sym_switch] = ACTIONS(2417),
    [anon_sym_for] = ACTIONS(2417),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_await] = ACTIONS(2417),
    [anon_sym_while] = ACTIONS(2417),
    [anon_sym_do] = ACTIONS(2417),
    [anon_sym_try] = ACTIONS(2417),
    [anon_sym_with] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2417),
    [anon_sym_continue] = ACTIONS(2417),
    [anon_sym_debugger] = ACTIONS(2417),
    [anon_sym_return] = ACTIONS(2417),
    [anon_sym_throw] = ACTIONS(2417),
    [anon_sym_SEMI] = ACTIONS(2415),
    [anon_sym_case] = ACTIONS(2417),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [anon_sym_LTtemplate_GT] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(2417),
    [anon_sym_class] = ACTIONS(2417),
    [anon_sym_async] = ACTIONS(2417),
    [anon_sym_function] = ACTIONS(2417),
    [anon_sym_new] = ACTIONS(2417),
    [anon_sym_PLUS] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(2417),
    [anon_sym_TILDE] = ACTIONS(2415),
    [anon_sym_void] = ACTIONS(2417),
    [anon_sym_delete] = ACTIONS(2417),
    [anon_sym_PLUS_PLUS] = ACTIONS(2415),
    [anon_sym_DASH_DASH] = ACTIONS(2415),
    [anon_sym_DQUOTE] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2415),
    [sym_number] = ACTIONS(2415),
    [sym_this] = ACTIONS(2417),
    [sym_super] = ACTIONS(2417),
    [sym_true] = ACTIONS(2417),
    [sym_false] = ACTIONS(2417),
    [sym_null] = ACTIONS(2417),
    [sym_undefined] = ACTIONS(2417),
    [anon_sym_AT] = ACTIONS(2415),
    [anon_sym_static] = ACTIONS(2417),
    [anon_sym_readonly] = ACTIONS(2417),
    [anon_sym_get] = ACTIONS(2417),
    [anon_sym_set] = ACTIONS(2417),
    [anon_sym_declare] = ACTIONS(2417),
    [anon_sym_public] = ACTIONS(2417),
    [anon_sym_private] = ACTIONS(2417),
    [anon_sym_protected] = ACTIONS(2417),
    [anon_sym_override] = ACTIONS(2417),
    [anon_sym_module] = ACTIONS(2417),
    [anon_sym_any] = ACTIONS(2417),
    [anon_sym_number] = ACTIONS(2417),
    [anon_sym_boolean] = ACTIONS(2417),
    [anon_sym_string] = ACTIONS(2417),
    [anon_sym_symbol] = ACTIONS(2417),
    [anon_sym_abstract] = ACTIONS(2417),
    [anon_sym_interface] = ACTIONS(2417),
    [anon_sym_enum] = ACTIONS(2417),
  },
  [757] = {
    [ts_builtin_sym_end] = ACTIONS(2419),
    [sym_identifier] = ACTIONS(2421),
    [anon_sym_export] = ACTIONS(2421),
    [anon_sym_default] = ACTIONS(2421),
    [anon_sym_type] = ACTIONS(2421),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_LBRACE] = ACTIONS(2419),
    [anon_sym_RBRACE] = ACTIONS(2419),
    [anon_sym_typeof] = ACTIONS(2421),
    [anon_sym_import] = ACTIONS(2421),
    [anon_sym_var] = ACTIONS(2421),
    [anon_sym_let] = ACTIONS(2421),
    [anon_sym_const] = ACTIONS(2421),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_else] = ACTIONS(2421),
    [anon_sym_if] = ACTIONS(2421),
    [anon_sym_switch] = ACTIONS(2421),
    [anon_sym_for] = ACTIONS(2421),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [anon_sym_await] = ACTIONS(2421),
    [anon_sym_while] = ACTIONS(2421),
    [anon_sym_do] = ACTIONS(2421),
    [anon_sym_try] = ACTIONS(2421),
    [anon_sym_with] = ACTIONS(2421),
    [anon_sym_break] = ACTIONS(2421),
    [anon_sym_continue] = ACTIONS(2421),
    [anon_sym_debugger] = ACTIONS(2421),
    [anon_sym_return] = ACTIONS(2421),
    [anon_sym_throw] = ACTIONS(2421),
    [anon_sym_SEMI] = ACTIONS(2419),
    [anon_sym_case] = ACTIONS(2421),
    [anon_sym_yield] = ACTIONS(2421),
    [anon_sym_LBRACK] = ACTIONS(2419),
    [anon_sym_LTtemplate_GT] = ACTIONS(2419),
    [anon_sym_LT] = ACTIONS(2421),
    [anon_sym_SLASH] = ACTIONS(2421),
    [anon_sym_class] = ACTIONS(2421),
    [anon_sym_async] = ACTIONS(2421),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_new] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2421),
    [anon_sym_DASH] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2419),
    [anon_sym_void] = ACTIONS(2421),
    [anon_sym_delete] = ACTIONS(2421),
    [anon_sym_PLUS_PLUS] = ACTIONS(2419),
    [anon_sym_DASH_DASH] = ACTIONS(2419),
    [anon_sym_DQUOTE] = ACTIONS(2419),
    [anon_sym_SQUOTE] = ACTIONS(2419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2419),
    [sym_number] = ACTIONS(2419),
    [sym_this] = ACTIONS(2421),
    [sym_super] = ACTIONS(2421),
    [sym_true] = ACTIONS(2421),
    [sym_false] = ACTIONS(2421),
    [sym_null] = ACTIONS(2421),
    [sym_undefined] = ACTIONS(2421),
    [anon_sym_AT] = ACTIONS(2419),
    [anon_sym_static] = ACTIONS(2421),
    [anon_sym_readonly] = ACTIONS(2421),
    [anon_sym_get] = ACTIONS(2421),
    [anon_sym_set] = ACTIONS(2421),
    [anon_sym_declare] = ACTIONS(2421),
    [anon_sym_public] = ACTIONS(2421),
    [anon_sym_private] = ACTIONS(2421),
    [anon_sym_protected] = ACTIONS(2421),
    [anon_sym_override] = ACTIONS(2421),
    [anon_sym_module] = ACTIONS(2421),
    [anon_sym_any] = ACTIONS(2421),
    [anon_sym_number] = ACTIONS(2421),
    [anon_sym_boolean] = ACTIONS(2421),
    [anon_sym_string] = ACTIONS(2421),
    [anon_sym_symbol] = ACTIONS(2421),
    [anon_sym_abstract] = ACTIONS(2421),
    [anon_sym_interface] = ACTIONS(2421),
    [anon_sym_enum] = ACTIONS(2421),
  },
  [758] = {
    [ts_builtin_sym_end] = ACTIONS(2423),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_export] = ACTIONS(2425),
    [anon_sym_default] = ACTIONS(2425),
    [anon_sym_type] = ACTIONS(2425),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(2423),
    [anon_sym_RBRACE] = ACTIONS(2423),
    [anon_sym_typeof] = ACTIONS(2425),
    [anon_sym_import] = ACTIONS(2425),
    [anon_sym_var] = ACTIONS(2425),
    [anon_sym_let] = ACTIONS(2425),
    [anon_sym_const] = ACTIONS(2425),
    [anon_sym_BANG] = ACTIONS(2423),
    [anon_sym_else] = ACTIONS(2425),
    [anon_sym_if] = ACTIONS(2425),
    [anon_sym_switch] = ACTIONS(2425),
    [anon_sym_for] = ACTIONS(2425),
    [anon_sym_LPAREN] = ACTIONS(2423),
    [anon_sym_await] = ACTIONS(2425),
    [anon_sym_while] = ACTIONS(2425),
    [anon_sym_do] = ACTIONS(2425),
    [anon_sym_try] = ACTIONS(2425),
    [anon_sym_with] = ACTIONS(2425),
    [anon_sym_break] = ACTIONS(2425),
    [anon_sym_continue] = ACTIONS(2425),
    [anon_sym_debugger] = ACTIONS(2425),
    [anon_sym_return] = ACTIONS(2425),
    [anon_sym_throw] = ACTIONS(2425),
    [anon_sym_SEMI] = ACTIONS(2423),
    [anon_sym_case] = ACTIONS(2425),
    [anon_sym_yield] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2423),
    [anon_sym_LTtemplate_GT] = ACTIONS(2423),
    [anon_sym_LT] = ACTIONS(2425),
    [anon_sym_SLASH] = ACTIONS(2425),
    [anon_sym_class] = ACTIONS(2425),
    [anon_sym_async] = ACTIONS(2425),
    [anon_sym_function] = ACTIONS(2425),
    [anon_sym_new] = ACTIONS(2425),
    [anon_sym_PLUS] = ACTIONS(2425),
    [anon_sym_DASH] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2423),
    [anon_sym_void] = ACTIONS(2425),
    [anon_sym_delete] = ACTIONS(2425),
    [anon_sym_PLUS_PLUS] = ACTIONS(2423),
    [anon_sym_DASH_DASH] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(2423),
    [anon_sym_SQUOTE] = ACTIONS(2423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2423),
    [sym_number] = ACTIONS(2423),
    [sym_this] = ACTIONS(2425),
    [sym_super] = ACTIONS(2425),
    [sym_true] = ACTIONS(2425),
    [sym_false] = ACTIONS(2425),
    [sym_null] = ACTIONS(2425),
    [sym_undefined] = ACTIONS(2425),
    [anon_sym_AT] = ACTIONS(2423),
    [anon_sym_static] = ACTIONS(2425),
    [anon_sym_readonly] = ACTIONS(2425),
    [anon_sym_get] = ACTIONS(2425),
    [anon_sym_set] = ACTIONS(2425),
    [anon_sym_declare] = ACTIONS(2425),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_override] = ACTIONS(2425),
    [anon_sym_module] = ACTIONS(2425),
    [anon_sym_any] = ACTIONS(2425),
    [anon_sym_number] = ACTIONS(2425),
    [anon_sym_boolean] = ACTIONS(2425),
    [anon_sym_string] = ACTIONS(2425),
    [anon_sym_symbol] = ACTIONS(2425),
    [anon_sym_abstract] = ACTIONS(2425),
    [anon_sym_interface] = ACTIONS(2425),
    [anon_sym_enum] = ACTIONS(2425),
  },
  [759] = {
    [ts_builtin_sym_end] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2429),
    [anon_sym_export] = ACTIONS(2429),
    [anon_sym_default] = ACTIONS(2429),
    [anon_sym_type] = ACTIONS(2429),
    [anon_sym_namespace] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2427),
    [anon_sym_RBRACE] = ACTIONS(2427),
    [anon_sym_typeof] = ACTIONS(2429),
    [anon_sym_import] = ACTIONS(2429),
    [anon_sym_var] = ACTIONS(2429),
    [anon_sym_let] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_switch] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_await] = ACTIONS(2429),
    [anon_sym_while] = ACTIONS(2429),
    [anon_sym_do] = ACTIONS(2429),
    [anon_sym_try] = ACTIONS(2429),
    [anon_sym_with] = ACTIONS(2429),
    [anon_sym_break] = ACTIONS(2429),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_debugger] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_throw] = ACTIONS(2429),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym_case] = ACTIONS(2429),
    [anon_sym_yield] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2427),
    [anon_sym_LTtemplate_GT] = ACTIONS(2427),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_SLASH] = ACTIONS(2429),
    [anon_sym_class] = ACTIONS(2429),
    [anon_sym_async] = ACTIONS(2429),
    [anon_sym_function] = ACTIONS(2429),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_void] = ACTIONS(2429),
    [anon_sym_delete] = ACTIONS(2429),
    [anon_sym_PLUS_PLUS] = ACTIONS(2427),
    [anon_sym_DASH_DASH] = ACTIONS(2427),
    [anon_sym_DQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2427),
    [sym_number] = ACTIONS(2427),
    [sym_this] = ACTIONS(2429),
    [sym_super] = ACTIONS(2429),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [sym_null] = ACTIONS(2429),
    [sym_undefined] = ACTIONS(2429),
    [anon_sym_AT] = ACTIONS(2427),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_readonly] = ACTIONS(2429),
    [anon_sym_get] = ACTIONS(2429),
    [anon_sym_set] = ACTIONS(2429),
    [anon_sym_declare] = ACTIONS(2429),
    [anon_sym_public] = ACTIONS(2429),
    [anon_sym_private] = ACTIONS(2429),
    [anon_sym_protected] = ACTIONS(2429),
    [anon_sym_override] = ACTIONS(2429),
    [anon_sym_module] = ACTIONS(2429),
    [anon_sym_any] = ACTIONS(2429),
    [anon_sym_number] = ACTIONS(2429),
    [anon_sym_boolean] = ACTIONS(2429),
    [anon_sym_string] = ACTIONS(2429),
    [anon_sym_symbol] = ACTIONS(2429),
    [anon_sym_abstract] = ACTIONS(2429),
    [anon_sym_interface] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
  },
  [760] = {
    [ts_builtin_sym_end] = ACTIONS(2431),
    [sym_identifier] = ACTIONS(2433),
    [anon_sym_export] = ACTIONS(2433),
    [anon_sym_default] = ACTIONS(2433),
    [anon_sym_type] = ACTIONS(2433),
    [anon_sym_namespace] = ACTIONS(2433),
    [anon_sym_LBRACE] = ACTIONS(2431),
    [anon_sym_RBRACE] = ACTIONS(2431),
    [anon_sym_typeof] = ACTIONS(2433),
    [anon_sym_import] = ACTIONS(2433),
    [anon_sym_var] = ACTIONS(2433),
    [anon_sym_let] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_BANG] = ACTIONS(2431),
    [anon_sym_else] = ACTIONS(2433),
    [anon_sym_if] = ACTIONS(2433),
    [anon_sym_switch] = ACTIONS(2433),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_await] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2433),
    [anon_sym_do] = ACTIONS(2433),
    [anon_sym_try] = ACTIONS(2433),
    [anon_sym_with] = ACTIONS(2433),
    [anon_sym_break] = ACTIONS(2433),
    [anon_sym_continue] = ACTIONS(2433),
    [anon_sym_debugger] = ACTIONS(2433),
    [anon_sym_return] = ACTIONS(2433),
    [anon_sym_throw] = ACTIONS(2433),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym_case] = ACTIONS(2433),
    [anon_sym_yield] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2431),
    [anon_sym_LTtemplate_GT] = ACTIONS(2431),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_SLASH] = ACTIONS(2433),
    [anon_sym_class] = ACTIONS(2433),
    [anon_sym_async] = ACTIONS(2433),
    [anon_sym_function] = ACTIONS(2433),
    [anon_sym_new] = ACTIONS(2433),
    [anon_sym_PLUS] = ACTIONS(2433),
    [anon_sym_DASH] = ACTIONS(2433),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_void] = ACTIONS(2433),
    [anon_sym_delete] = ACTIONS(2433),
    [anon_sym_PLUS_PLUS] = ACTIONS(2431),
    [anon_sym_DASH_DASH] = ACTIONS(2431),
    [anon_sym_DQUOTE] = ACTIONS(2431),
    [anon_sym_SQUOTE] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2431),
    [sym_number] = ACTIONS(2431),
    [sym_this] = ACTIONS(2433),
    [sym_super] = ACTIONS(2433),
    [sym_true] = ACTIONS(2433),
    [sym_false] = ACTIONS(2433),
    [sym_null] = ACTIONS(2433),
    [sym_undefined] = ACTIONS(2433),
    [anon_sym_AT] = ACTIONS(2431),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_readonly] = ACTIONS(2433),
    [anon_sym_get] = ACTIONS(2433),
    [anon_sym_set] = ACTIONS(2433),
    [anon_sym_declare] = ACTIONS(2433),
    [anon_sym_public] = ACTIONS(2433),
    [anon_sym_private] = ACTIONS(2433),
    [anon_sym_protected] = ACTIONS(2433),
    [anon_sym_override] = ACTIONS(2433),
    [anon_sym_module] = ACTIONS(2433),
    [anon_sym_any] = ACTIONS(2433),
    [anon_sym_number] = ACTIONS(2433),
    [anon_sym_boolean] = ACTIONS(2433),
    [anon_sym_string] = ACTIONS(2433),
    [anon_sym_symbol] = ACTIONS(2433),
    [anon_sym_abstract] = ACTIONS(2433),
    [anon_sym_interface] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
  },
  [761] = {
    [ts_builtin_sym_end] = ACTIONS(2435),
    [sym_identifier] = ACTIONS(2437),
    [anon_sym_export] = ACTIONS(2437),
    [anon_sym_default] = ACTIONS(2437),
    [anon_sym_type] = ACTIONS(2437),
    [anon_sym_namespace] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_RBRACE] = ACTIONS(2435),
    [anon_sym_typeof] = ACTIONS(2437),
    [anon_sym_import] = ACTIONS(2437),
    [anon_sym_var] = ACTIONS(2437),
    [anon_sym_let] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_else] = ACTIONS(2437),
    [anon_sym_if] = ACTIONS(2437),
    [anon_sym_switch] = ACTIONS(2437),
    [anon_sym_for] = ACTIONS(2437),
    [anon_sym_LPAREN] = ACTIONS(2435),
    [anon_sym_await] = ACTIONS(2437),
    [anon_sym_while] = ACTIONS(2437),
    [anon_sym_do] = ACTIONS(2437),
    [anon_sym_try] = ACTIONS(2437),
    [anon_sym_with] = ACTIONS(2437),
    [anon_sym_break] = ACTIONS(2437),
    [anon_sym_continue] = ACTIONS(2437),
    [anon_sym_debugger] = ACTIONS(2437),
    [anon_sym_return] = ACTIONS(2437),
    [anon_sym_throw] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym_case] = ACTIONS(2437),
    [anon_sym_yield] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2435),
    [anon_sym_LTtemplate_GT] = ACTIONS(2435),
    [anon_sym_LT] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2437),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_async] = ACTIONS(2437),
    [anon_sym_function] = ACTIONS(2437),
    [anon_sym_new] = ACTIONS(2437),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_void] = ACTIONS(2437),
    [anon_sym_delete] = ACTIONS(2437),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2435),
    [sym_number] = ACTIONS(2435),
    [sym_this] = ACTIONS(2437),
    [sym_super] = ACTIONS(2437),
    [sym_true] = ACTIONS(2437),
    [sym_false] = ACTIONS(2437),
    [sym_null] = ACTIONS(2437),
    [sym_undefined] = ACTIONS(2437),
    [anon_sym_AT] = ACTIONS(2435),
    [anon_sym_static] = ACTIONS(2437),
    [anon_sym_readonly] = ACTIONS(2437),
    [anon_sym_get] = ACTIONS(2437),
    [anon_sym_set] = ACTIONS(2437),
    [anon_sym_declare] = ACTIONS(2437),
    [anon_sym_public] = ACTIONS(2437),
    [anon_sym_private] = ACTIONS(2437),
    [anon_sym_protected] = ACTIONS(2437),
    [anon_sym_override] = ACTIONS(2437),
    [anon_sym_module] = ACTIONS(2437),
    [anon_sym_any] = ACTIONS(2437),
    [anon_sym_number] = ACTIONS(2437),
    [anon_sym_boolean] = ACTIONS(2437),
    [anon_sym_string] = ACTIONS(2437),
    [anon_sym_symbol] = ACTIONS(2437),
    [anon_sym_abstract] = ACTIONS(2437),
    [anon_sym_interface] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
  },
  [762] = {
    [ts_builtin_sym_end] = ACTIONS(2439),
    [sym_identifier] = ACTIONS(2441),
    [anon_sym_export] = ACTIONS(2441),
    [anon_sym_default] = ACTIONS(2441),
    [anon_sym_type] = ACTIONS(2441),
    [anon_sym_namespace] = ACTIONS(2441),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_typeof] = ACTIONS(2441),
    [anon_sym_import] = ACTIONS(2441),
    [anon_sym_var] = ACTIONS(2441),
    [anon_sym_let] = ACTIONS(2441),
    [anon_sym_const] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2439),
    [anon_sym_else] = ACTIONS(2441),
    [anon_sym_if] = ACTIONS(2441),
    [anon_sym_switch] = ACTIONS(2441),
    [anon_sym_for] = ACTIONS(2441),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [anon_sym_await] = ACTIONS(2441),
    [anon_sym_while] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_try] = ACTIONS(2441),
    [anon_sym_with] = ACTIONS(2441),
    [anon_sym_break] = ACTIONS(2441),
    [anon_sym_continue] = ACTIONS(2441),
    [anon_sym_debugger] = ACTIONS(2441),
    [anon_sym_return] = ACTIONS(2441),
    [anon_sym_throw] = ACTIONS(2441),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym_case] = ACTIONS(2441),
    [anon_sym_yield] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LTtemplate_GT] = ACTIONS(2439),
    [anon_sym_LT] = ACTIONS(2441),
    [anon_sym_SLASH] = ACTIONS(2441),
    [anon_sym_class] = ACTIONS(2441),
    [anon_sym_async] = ACTIONS(2441),
    [anon_sym_function] = ACTIONS(2441),
    [anon_sym_new] = ACTIONS(2441),
    [anon_sym_PLUS] = ACTIONS(2441),
    [anon_sym_DASH] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_void] = ACTIONS(2441),
    [anon_sym_delete] = ACTIONS(2441),
    [anon_sym_PLUS_PLUS] = ACTIONS(2439),
    [anon_sym_DASH_DASH] = ACTIONS(2439),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2439),
    [sym_number] = ACTIONS(2439),
    [sym_this] = ACTIONS(2441),
    [sym_super] = ACTIONS(2441),
    [sym_true] = ACTIONS(2441),
    [sym_false] = ACTIONS(2441),
    [sym_null] = ACTIONS(2441),
    [sym_undefined] = ACTIONS(2441),
    [anon_sym_AT] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2441),
    [anon_sym_readonly] = ACTIONS(2441),
    [anon_sym_get] = ACTIONS(2441),
    [anon_sym_set] = ACTIONS(2441),
    [anon_sym_declare] = ACTIONS(2441),
    [anon_sym_public] = ACTIONS(2441),
    [anon_sym_private] = ACTIONS(2441),
    [anon_sym_protected] = ACTIONS(2441),
    [anon_sym_override] = ACTIONS(2441),
    [anon_sym_module] = ACTIONS(2441),
    [anon_sym_any] = ACTIONS(2441),
    [anon_sym_number] = ACTIONS(2441),
    [anon_sym_boolean] = ACTIONS(2441),
    [anon_sym_string] = ACTIONS(2441),
    [anon_sym_symbol] = ACTIONS(2441),
    [anon_sym_abstract] = ACTIONS(2441),
    [anon_sym_interface] = ACTIONS(2441),
    [anon_sym_enum] = ACTIONS(2441),
  },
  [763] = {
    [ts_builtin_sym_end] = ACTIONS(2443),
    [sym_identifier] = ACTIONS(2445),
    [anon_sym_export] = ACTIONS(2445),
    [anon_sym_default] = ACTIONS(2445),
    [anon_sym_type] = ACTIONS(2445),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_RBRACE] = ACTIONS(2443),
    [anon_sym_typeof] = ACTIONS(2445),
    [anon_sym_import] = ACTIONS(2445),
    [anon_sym_var] = ACTIONS(2445),
    [anon_sym_let] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_else] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_switch] = ACTIONS(2445),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2443),
    [anon_sym_await] = ACTIONS(2445),
    [anon_sym_while] = ACTIONS(2445),
    [anon_sym_do] = ACTIONS(2445),
    [anon_sym_try] = ACTIONS(2445),
    [anon_sym_with] = ACTIONS(2445),
    [anon_sym_break] = ACTIONS(2445),
    [anon_sym_continue] = ACTIONS(2445),
    [anon_sym_debugger] = ACTIONS(2445),
    [anon_sym_return] = ACTIONS(2445),
    [anon_sym_throw] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym_case] = ACTIONS(2445),
    [anon_sym_yield] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_LTtemplate_GT] = ACTIONS(2443),
    [anon_sym_LT] = ACTIONS(2445),
    [anon_sym_SLASH] = ACTIONS(2445),
    [anon_sym_class] = ACTIONS(2445),
    [anon_sym_async] = ACTIONS(2445),
    [anon_sym_function] = ACTIONS(2445),
    [anon_sym_new] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_void] = ACTIONS(2445),
    [anon_sym_delete] = ACTIONS(2445),
    [anon_sym_PLUS_PLUS] = ACTIONS(2443),
    [anon_sym_DASH_DASH] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2443),
    [sym_number] = ACTIONS(2443),
    [sym_this] = ACTIONS(2445),
    [sym_super] = ACTIONS(2445),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [sym_null] = ACTIONS(2445),
    [sym_undefined] = ACTIONS(2445),
    [anon_sym_AT] = ACTIONS(2443),
    [anon_sym_static] = ACTIONS(2445),
    [anon_sym_readonly] = ACTIONS(2445),
    [anon_sym_get] = ACTIONS(2445),
    [anon_sym_set] = ACTIONS(2445),
    [anon_sym_declare] = ACTIONS(2445),
    [anon_sym_public] = ACTIONS(2445),
    [anon_sym_private] = ACTIONS(2445),
    [anon_sym_protected] = ACTIONS(2445),
    [anon_sym_override] = ACTIONS(2445),
    [anon_sym_module] = ACTIONS(2445),
    [anon_sym_any] = ACTIONS(2445),
    [anon_sym_number] = ACTIONS(2445),
    [anon_sym_boolean] = ACTIONS(2445),
    [anon_sym_string] = ACTIONS(2445),
    [anon_sym_symbol] = ACTIONS(2445),
    [anon_sym_abstract] = ACTIONS(2445),
    [anon_sym_interface] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
  },
  [764] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [765] = {
    [ts_builtin_sym_end] = ACTIONS(2447),
    [sym_identifier] = ACTIONS(2449),
    [anon_sym_export] = ACTIONS(2449),
    [anon_sym_default] = ACTIONS(2449),
    [anon_sym_type] = ACTIONS(2449),
    [anon_sym_namespace] = ACTIONS(2449),
    [anon_sym_LBRACE] = ACTIONS(2447),
    [anon_sym_RBRACE] = ACTIONS(2447),
    [anon_sym_typeof] = ACTIONS(2449),
    [anon_sym_import] = ACTIONS(2449),
    [anon_sym_var] = ACTIONS(2449),
    [anon_sym_let] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [anon_sym_BANG] = ACTIONS(2447),
    [anon_sym_else] = ACTIONS(2449),
    [anon_sym_if] = ACTIONS(2449),
    [anon_sym_switch] = ACTIONS(2449),
    [anon_sym_for] = ACTIONS(2449),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_await] = ACTIONS(2449),
    [anon_sym_while] = ACTIONS(2449),
    [anon_sym_do] = ACTIONS(2449),
    [anon_sym_try] = ACTIONS(2449),
    [anon_sym_with] = ACTIONS(2449),
    [anon_sym_break] = ACTIONS(2449),
    [anon_sym_continue] = ACTIONS(2449),
    [anon_sym_debugger] = ACTIONS(2449),
    [anon_sym_return] = ACTIONS(2449),
    [anon_sym_throw] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2447),
    [anon_sym_case] = ACTIONS(2449),
    [anon_sym_yield] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_LTtemplate_GT] = ACTIONS(2447),
    [anon_sym_LT] = ACTIONS(2449),
    [anon_sym_SLASH] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_async] = ACTIONS(2449),
    [anon_sym_function] = ACTIONS(2449),
    [anon_sym_new] = ACTIONS(2449),
    [anon_sym_PLUS] = ACTIONS(2449),
    [anon_sym_DASH] = ACTIONS(2449),
    [anon_sym_TILDE] = ACTIONS(2447),
    [anon_sym_void] = ACTIONS(2449),
    [anon_sym_delete] = ACTIONS(2449),
    [anon_sym_PLUS_PLUS] = ACTIONS(2447),
    [anon_sym_DASH_DASH] = ACTIONS(2447),
    [anon_sym_DQUOTE] = ACTIONS(2447),
    [anon_sym_SQUOTE] = ACTIONS(2447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2447),
    [sym_number] = ACTIONS(2447),
    [sym_this] = ACTIONS(2449),
    [sym_super] = ACTIONS(2449),
    [sym_true] = ACTIONS(2449),
    [sym_false] = ACTIONS(2449),
    [sym_null] = ACTIONS(2449),
    [sym_undefined] = ACTIONS(2449),
    [anon_sym_AT] = ACTIONS(2447),
    [anon_sym_static] = ACTIONS(2449),
    [anon_sym_readonly] = ACTIONS(2449),
    [anon_sym_get] = ACTIONS(2449),
    [anon_sym_set] = ACTIONS(2449),
    [anon_sym_declare] = ACTIONS(2449),
    [anon_sym_public] = ACTIONS(2449),
    [anon_sym_private] = ACTIONS(2449),
    [anon_sym_protected] = ACTIONS(2449),
    [anon_sym_override] = ACTIONS(2449),
    [anon_sym_module] = ACTIONS(2449),
    [anon_sym_any] = ACTIONS(2449),
    [anon_sym_number] = ACTIONS(2449),
    [anon_sym_boolean] = ACTIONS(2449),
    [anon_sym_string] = ACTIONS(2449),
    [anon_sym_symbol] = ACTIONS(2449),
    [anon_sym_abstract] = ACTIONS(2449),
    [anon_sym_interface] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
  },
  [766] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [767] = {
    [ts_builtin_sym_end] = ACTIONS(2451),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_type] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2451),
    [anon_sym_RBRACE] = ACTIONS(2451),
    [anon_sym_typeof] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2453),
    [anon_sym_var] = ACTIONS(2453),
    [anon_sym_let] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2451),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2451),
    [anon_sym_await] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_debugger] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_yield] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [anon_sym_LTtemplate_GT] = ACTIONS(2451),
    [anon_sym_LT] = ACTIONS(2453),
    [anon_sym_SLASH] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_async] = ACTIONS(2453),
    [anon_sym_function] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_void] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_PLUS_PLUS] = ACTIONS(2451),
    [anon_sym_DASH_DASH] = ACTIONS(2451),
    [anon_sym_DQUOTE] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2451),
    [sym_number] = ACTIONS(2451),
    [sym_this] = ACTIONS(2453),
    [sym_super] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_null] = ACTIONS(2453),
    [sym_undefined] = ACTIONS(2453),
    [anon_sym_AT] = ACTIONS(2451),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_readonly] = ACTIONS(2453),
    [anon_sym_get] = ACTIONS(2453),
    [anon_sym_set] = ACTIONS(2453),
    [anon_sym_declare] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_override] = ACTIONS(2453),
    [anon_sym_module] = ACTIONS(2453),
    [anon_sym_any] = ACTIONS(2453),
    [anon_sym_number] = ACTIONS(2453),
    [anon_sym_boolean] = ACTIONS(2453),
    [anon_sym_string] = ACTIONS(2453),
    [anon_sym_symbol] = ACTIONS(2453),
    [anon_sym_abstract] = ACTIONS(2453),
    [anon_sym_interface] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
  },
  [768] = {
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_export] = ACTIONS(2457),
    [anon_sym_default] = ACTIONS(2457),
    [anon_sym_type] = ACTIONS(2457),
    [anon_sym_namespace] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2457),
    [anon_sym_import] = ACTIONS(2457),
    [anon_sym_var] = ACTIONS(2457),
    [anon_sym_let] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_else] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2455),
    [anon_sym_await] = ACTIONS(2457),
    [anon_sym_while] = ACTIONS(2457),
    [anon_sym_do] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_throw] = ACTIONS(2457),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym_case] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_LTtemplate_GT] = ACTIONS(2455),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_async] = ACTIONS(2457),
    [anon_sym_function] = ACTIONS(2457),
    [anon_sym_new] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_void] = ACTIONS(2457),
    [anon_sym_delete] = ACTIONS(2457),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2455),
    [sym_number] = ACTIONS(2455),
    [sym_this] = ACTIONS(2457),
    [sym_super] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_null] = ACTIONS(2457),
    [sym_undefined] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2455),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_readonly] = ACTIONS(2457),
    [anon_sym_get] = ACTIONS(2457),
    [anon_sym_set] = ACTIONS(2457),
    [anon_sym_declare] = ACTIONS(2457),
    [anon_sym_public] = ACTIONS(2457),
    [anon_sym_private] = ACTIONS(2457),
    [anon_sym_protected] = ACTIONS(2457),
    [anon_sym_override] = ACTIONS(2457),
    [anon_sym_module] = ACTIONS(2457),
    [anon_sym_any] = ACTIONS(2457),
    [anon_sym_number] = ACTIONS(2457),
    [anon_sym_boolean] = ACTIONS(2457),
    [anon_sym_string] = ACTIONS(2457),
    [anon_sym_symbol] = ACTIONS(2457),
    [anon_sym_abstract] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
  },
  [769] = {
    [ts_builtin_sym_end] = ACTIONS(2459),
    [sym_identifier] = ACTIONS(2461),
    [anon_sym_export] = ACTIONS(2461),
    [anon_sym_default] = ACTIONS(2461),
    [anon_sym_type] = ACTIONS(2461),
    [anon_sym_namespace] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_RBRACE] = ACTIONS(2459),
    [anon_sym_typeof] = ACTIONS(2461),
    [anon_sym_import] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2461),
    [anon_sym_let] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(2461),
    [anon_sym_BANG] = ACTIONS(2459),
    [anon_sym_else] = ACTIONS(2461),
    [anon_sym_if] = ACTIONS(2461),
    [anon_sym_switch] = ACTIONS(2461),
    [anon_sym_for] = ACTIONS(2461),
    [anon_sym_LPAREN] = ACTIONS(2459),
    [anon_sym_await] = ACTIONS(2461),
    [anon_sym_while] = ACTIONS(2461),
    [anon_sym_do] = ACTIONS(2461),
    [anon_sym_try] = ACTIONS(2461),
    [anon_sym_with] = ACTIONS(2461),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_continue] = ACTIONS(2461),
    [anon_sym_debugger] = ACTIONS(2461),
    [anon_sym_return] = ACTIONS(2461),
    [anon_sym_throw] = ACTIONS(2461),
    [anon_sym_SEMI] = ACTIONS(2459),
    [anon_sym_case] = ACTIONS(2461),
    [anon_sym_yield] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2459),
    [anon_sym_LTtemplate_GT] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2461),
    [anon_sym_SLASH] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2461),
    [anon_sym_async] = ACTIONS(2461),
    [anon_sym_function] = ACTIONS(2461),
    [anon_sym_new] = ACTIONS(2461),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_TILDE] = ACTIONS(2459),
    [anon_sym_void] = ACTIONS(2461),
    [anon_sym_delete] = ACTIONS(2461),
    [anon_sym_PLUS_PLUS] = ACTIONS(2459),
    [anon_sym_DASH_DASH] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(2459),
    [anon_sym_SQUOTE] = ACTIONS(2459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2459),
    [sym_number] = ACTIONS(2459),
    [sym_this] = ACTIONS(2461),
    [sym_super] = ACTIONS(2461),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_undefined] = ACTIONS(2461),
    [anon_sym_AT] = ACTIONS(2459),
    [anon_sym_static] = ACTIONS(2461),
    [anon_sym_readonly] = ACTIONS(2461),
    [anon_sym_get] = ACTIONS(2461),
    [anon_sym_set] = ACTIONS(2461),
    [anon_sym_declare] = ACTIONS(2461),
    [anon_sym_public] = ACTIONS(2461),
    [anon_sym_private] = ACTIONS(2461),
    [anon_sym_protected] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [anon_sym_module] = ACTIONS(2461),
    [anon_sym_any] = ACTIONS(2461),
    [anon_sym_number] = ACTIONS(2461),
    [anon_sym_boolean] = ACTIONS(2461),
    [anon_sym_string] = ACTIONS(2461),
    [anon_sym_symbol] = ACTIONS(2461),
    [anon_sym_abstract] = ACTIONS(2461),
    [anon_sym_interface] = ACTIONS(2461),
    [anon_sym_enum] = ACTIONS(2461),
  },
  [770] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [771] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [772] = {
    [ts_builtin_sym_end] = ACTIONS(2463),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_export] = ACTIONS(2465),
    [anon_sym_default] = ACTIONS(2465),
    [anon_sym_type] = ACTIONS(2465),
    [anon_sym_namespace] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_RBRACE] = ACTIONS(2463),
    [anon_sym_typeof] = ACTIONS(2465),
    [anon_sym_import] = ACTIONS(2465),
    [anon_sym_var] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(2465),
    [anon_sym_const] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2463),
    [anon_sym_else] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_switch] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2463),
    [anon_sym_await] = ACTIONS(2465),
    [anon_sym_while] = ACTIONS(2465),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_try] = ACTIONS(2465),
    [anon_sym_with] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_debugger] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_throw] = ACTIONS(2465),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym_case] = ACTIONS(2465),
    [anon_sym_yield] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [anon_sym_LTtemplate_GT] = ACTIONS(2463),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_class] = ACTIONS(2465),
    [anon_sym_async] = ACTIONS(2465),
    [anon_sym_function] = ACTIONS(2465),
    [anon_sym_new] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_void] = ACTIONS(2465),
    [anon_sym_delete] = ACTIONS(2465),
    [anon_sym_PLUS_PLUS] = ACTIONS(2463),
    [anon_sym_DASH_DASH] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2463),
    [sym_number] = ACTIONS(2463),
    [sym_this] = ACTIONS(2465),
    [sym_super] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_null] = ACTIONS(2465),
    [sym_undefined] = ACTIONS(2465),
    [anon_sym_AT] = ACTIONS(2463),
    [anon_sym_static] = ACTIONS(2465),
    [anon_sym_readonly] = ACTIONS(2465),
    [anon_sym_get] = ACTIONS(2465),
    [anon_sym_set] = ACTIONS(2465),
    [anon_sym_declare] = ACTIONS(2465),
    [anon_sym_public] = ACTIONS(2465),
    [anon_sym_private] = ACTIONS(2465),
    [anon_sym_protected] = ACTIONS(2465),
    [anon_sym_override] = ACTIONS(2465),
    [anon_sym_module] = ACTIONS(2465),
    [anon_sym_any] = ACTIONS(2465),
    [anon_sym_number] = ACTIONS(2465),
    [anon_sym_boolean] = ACTIONS(2465),
    [anon_sym_string] = ACTIONS(2465),
    [anon_sym_symbol] = ACTIONS(2465),
    [anon_sym_abstract] = ACTIONS(2465),
    [anon_sym_interface] = ACTIONS(2465),
    [anon_sym_enum] = ACTIONS(2465),
  },
  [773] = {
    [ts_builtin_sym_end] = ACTIONS(2467),
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2467),
    [anon_sym_RBRACE] = ACTIONS(2467),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2467),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2467),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2467),
    [anon_sym_LTtemplate_GT] = ACTIONS(2467),
    [anon_sym_LT] = ACTIONS(2469),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2467),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2467),
    [anon_sym_DASH_DASH] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [anon_sym_SQUOTE] = ACTIONS(2467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2467),
    [sym_number] = ACTIONS(2467),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2467),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_readonly] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_override] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
  },
  [774] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [775] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [776] = {
    [ts_builtin_sym_end] = ACTIONS(2471),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_export] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_type] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_typeof] = ACTIONS(2473),
    [anon_sym_import] = ACTIONS(2473),
    [anon_sym_var] = ACTIONS(2473),
    [anon_sym_let] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_with] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_debugger] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_async] = ACTIONS(2473),
    [anon_sym_function] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2473),
    [sym_super] = ACTIONS(2473),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [sym_null] = ACTIONS(2473),
    [sym_undefined] = ACTIONS(2473),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_readonly] = ACTIONS(2473),
    [anon_sym_get] = ACTIONS(2473),
    [anon_sym_set] = ACTIONS(2473),
    [anon_sym_declare] = ACTIONS(2473),
    [anon_sym_public] = ACTIONS(2473),
    [anon_sym_private] = ACTIONS(2473),
    [anon_sym_protected] = ACTIONS(2473),
    [anon_sym_override] = ACTIONS(2473),
    [anon_sym_module] = ACTIONS(2473),
    [anon_sym_any] = ACTIONS(2473),
    [anon_sym_number] = ACTIONS(2473),
    [anon_sym_boolean] = ACTIONS(2473),
    [anon_sym_string] = ACTIONS(2473),
    [anon_sym_symbol] = ACTIONS(2473),
    [anon_sym_abstract] = ACTIONS(2473),
    [anon_sym_interface] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
  },
  [777] = {
    [ts_builtin_sym_end] = ACTIONS(2471),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_export] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_type] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_typeof] = ACTIONS(2473),
    [anon_sym_import] = ACTIONS(2473),
    [anon_sym_var] = ACTIONS(2473),
    [anon_sym_let] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [anon_sym_await] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_with] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_debugger] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [anon_sym_LTtemplate_GT] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_async] = ACTIONS(2473),
    [anon_sym_function] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_void] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_number] = ACTIONS(2471),
    [sym_this] = ACTIONS(2473),
    [sym_super] = ACTIONS(2473),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [sym_null] = ACTIONS(2473),
    [sym_undefined] = ACTIONS(2473),
    [anon_sym_AT] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_readonly] = ACTIONS(2473),
    [anon_sym_get] = ACTIONS(2473),
    [anon_sym_set] = ACTIONS(2473),
    [anon_sym_declare] = ACTIONS(2473),
    [anon_sym_public] = ACTIONS(2473),
    [anon_sym_private] = ACTIONS(2473),
    [anon_sym_protected] = ACTIONS(2473),
    [anon_sym_override] = ACTIONS(2473),
    [anon_sym_module] = ACTIONS(2473),
    [anon_sym_any] = ACTIONS(2473),
    [anon_sym_number] = ACTIONS(2473),
    [anon_sym_boolean] = ACTIONS(2473),
    [anon_sym_string] = ACTIONS(2473),
    [anon_sym_symbol] = ACTIONS(2473),
    [anon_sym_abstract] = ACTIONS(2473),
    [anon_sym_interface] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
  },
  [778] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [779] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3816),
    [sym_optional_tuple_parameter] = STATE(3816),
    [sym_optional_type] = STATE(3816),
    [sym_rest_type] = STATE(3816),
    [sym__tuple_type_member] = STATE(3816),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(2477),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2479),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [780] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3601),
    [sym_optional_tuple_parameter] = STATE(3601),
    [sym_optional_type] = STATE(3601),
    [sym_rest_type] = STATE(3601),
    [sym__tuple_type_member] = STATE(3601),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(2487),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2489),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [781] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3646),
    [sym_optional_tuple_parameter] = STATE(3646),
    [sym_optional_type] = STATE(3646),
    [sym_rest_type] = STATE(3646),
    [sym__tuple_type_member] = STATE(3646),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [782] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3667),
    [sym_optional_tuple_parameter] = STATE(3667),
    [sym_optional_type] = STATE(3667),
    [sym_rest_type] = STATE(3667),
    [sym__tuple_type_member] = STATE(3667),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2497),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [783] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3729),
    [sym_optional_tuple_parameter] = STATE(3729),
    [sym_optional_type] = STATE(3729),
    [sym_rest_type] = STATE(3729),
    [sym__tuple_type_member] = STATE(3729),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(2499),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2501),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [784] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2503),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [785] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [786] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2507),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [787] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2509),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [788] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [789] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2513),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [790] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2515),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [791] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2517),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [792] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2519),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [793] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2521),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [794] = {
    [sym_identifier] = ACTIONS(2523),
    [anon_sym_export] = ACTIONS(2523),
    [anon_sym_type] = ACTIONS(2523),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2525),
    [anon_sym_typeof] = ACTIONS(2523),
    [anon_sym_import] = ACTIONS(2523),
    [anon_sym_var] = ACTIONS(2523),
    [anon_sym_let] = ACTIONS(2523),
    [anon_sym_const] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(2525),
    [anon_sym_if] = ACTIONS(2523),
    [anon_sym_switch] = ACTIONS(2523),
    [anon_sym_for] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(2525),
    [anon_sym_await] = ACTIONS(2523),
    [anon_sym_while] = ACTIONS(2523),
    [anon_sym_do] = ACTIONS(2523),
    [anon_sym_try] = ACTIONS(2523),
    [anon_sym_with] = ACTIONS(2523),
    [anon_sym_break] = ACTIONS(2523),
    [anon_sym_continue] = ACTIONS(2523),
    [anon_sym_debugger] = ACTIONS(2523),
    [anon_sym_return] = ACTIONS(2523),
    [anon_sym_throw] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym_yield] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2525),
    [anon_sym_LTtemplate_GT] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2523),
    [anon_sym_SLASH] = ACTIONS(2523),
    [anon_sym_class] = ACTIONS(2523),
    [anon_sym_async] = ACTIONS(2523),
    [anon_sym_function] = ACTIONS(2523),
    [anon_sym_new] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2525),
    [anon_sym_void] = ACTIONS(2523),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_PLUS_PLUS] = ACTIONS(2525),
    [anon_sym_DASH_DASH] = ACTIONS(2525),
    [anon_sym_DQUOTE] = ACTIONS(2525),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2525),
    [sym_number] = ACTIONS(2525),
    [sym_this] = ACTIONS(2523),
    [sym_super] = ACTIONS(2523),
    [sym_true] = ACTIONS(2523),
    [sym_false] = ACTIONS(2523),
    [sym_null] = ACTIONS(2523),
    [sym_undefined] = ACTIONS(2523),
    [anon_sym_AT] = ACTIONS(2525),
    [anon_sym_static] = ACTIONS(2523),
    [anon_sym_readonly] = ACTIONS(2523),
    [anon_sym_get] = ACTIONS(2523),
    [anon_sym_set] = ACTIONS(2523),
    [anon_sym_declare] = ACTIONS(2523),
    [anon_sym_public] = ACTIONS(2523),
    [anon_sym_private] = ACTIONS(2523),
    [anon_sym_protected] = ACTIONS(2523),
    [anon_sym_override] = ACTIONS(2523),
    [anon_sym_module] = ACTIONS(2523),
    [anon_sym_any] = ACTIONS(2523),
    [anon_sym_number] = ACTIONS(2523),
    [anon_sym_boolean] = ACTIONS(2523),
    [anon_sym_string] = ACTIONS(2523),
    [anon_sym_symbol] = ACTIONS(2523),
    [anon_sym_abstract] = ACTIONS(2523),
    [anon_sym_interface] = ACTIONS(2523),
    [anon_sym_enum] = ACTIONS(2523),
  },
  [795] = {
    [sym_identifier] = ACTIONS(2527),
    [anon_sym_export] = ACTIONS(2527),
    [anon_sym_type] = ACTIONS(2527),
    [anon_sym_namespace] = ACTIONS(2527),
    [anon_sym_LBRACE] = ACTIONS(2529),
    [anon_sym_typeof] = ACTIONS(2527),
    [anon_sym_import] = ACTIONS(2527),
    [anon_sym_var] = ACTIONS(2527),
    [anon_sym_let] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_BANG] = ACTIONS(2529),
    [anon_sym_if] = ACTIONS(2527),
    [anon_sym_switch] = ACTIONS(2527),
    [anon_sym_for] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_await] = ACTIONS(2527),
    [anon_sym_while] = ACTIONS(2527),
    [anon_sym_do] = ACTIONS(2527),
    [anon_sym_try] = ACTIONS(2527),
    [anon_sym_with] = ACTIONS(2527),
    [anon_sym_break] = ACTIONS(2527),
    [anon_sym_continue] = ACTIONS(2527),
    [anon_sym_debugger] = ACTIONS(2527),
    [anon_sym_return] = ACTIONS(2527),
    [anon_sym_throw] = ACTIONS(2527),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_yield] = ACTIONS(2527),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_LTtemplate_GT] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_SLASH] = ACTIONS(2527),
    [anon_sym_class] = ACTIONS(2527),
    [anon_sym_async] = ACTIONS(2527),
    [anon_sym_function] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_PLUS] = ACTIONS(2527),
    [anon_sym_DASH] = ACTIONS(2527),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(2527),
    [anon_sym_delete] = ACTIONS(2527),
    [anon_sym_PLUS_PLUS] = ACTIONS(2529),
    [anon_sym_DASH_DASH] = ACTIONS(2529),
    [anon_sym_DQUOTE] = ACTIONS(2529),
    [anon_sym_SQUOTE] = ACTIONS(2529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2529),
    [sym_number] = ACTIONS(2529),
    [sym_this] = ACTIONS(2527),
    [sym_super] = ACTIONS(2527),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [sym_null] = ACTIONS(2527),
    [sym_undefined] = ACTIONS(2527),
    [anon_sym_AT] = ACTIONS(2529),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_readonly] = ACTIONS(2527),
    [anon_sym_get] = ACTIONS(2527),
    [anon_sym_set] = ACTIONS(2527),
    [anon_sym_declare] = ACTIONS(2527),
    [anon_sym_public] = ACTIONS(2527),
    [anon_sym_private] = ACTIONS(2527),
    [anon_sym_protected] = ACTIONS(2527),
    [anon_sym_override] = ACTIONS(2527),
    [anon_sym_module] = ACTIONS(2527),
    [anon_sym_any] = ACTIONS(2527),
    [anon_sym_number] = ACTIONS(2527),
    [anon_sym_boolean] = ACTIONS(2527),
    [anon_sym_string] = ACTIONS(2527),
    [anon_sym_symbol] = ACTIONS(2527),
    [anon_sym_abstract] = ACTIONS(2527),
    [anon_sym_interface] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
  },
  [796] = {
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_export] = ACTIONS(2531),
    [anon_sym_type] = ACTIONS(2531),
    [anon_sym_namespace] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_typeof] = ACTIONS(2531),
    [anon_sym_import] = ACTIONS(2531),
    [anon_sym_var] = ACTIONS(2531),
    [anon_sym_let] = ACTIONS(2531),
    [anon_sym_const] = ACTIONS(2531),
    [anon_sym_BANG] = ACTIONS(2533),
    [anon_sym_if] = ACTIONS(2531),
    [anon_sym_switch] = ACTIONS(2531),
    [anon_sym_for] = ACTIONS(2531),
    [anon_sym_LPAREN] = ACTIONS(2533),
    [anon_sym_await] = ACTIONS(2531),
    [anon_sym_while] = ACTIONS(2531),
    [anon_sym_do] = ACTIONS(2531),
    [anon_sym_try] = ACTIONS(2531),
    [anon_sym_with] = ACTIONS(2531),
    [anon_sym_break] = ACTIONS(2531),
    [anon_sym_continue] = ACTIONS(2531),
    [anon_sym_debugger] = ACTIONS(2531),
    [anon_sym_return] = ACTIONS(2531),
    [anon_sym_throw] = ACTIONS(2531),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_yield] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [anon_sym_LTtemplate_GT] = ACTIONS(2533),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2531),
    [anon_sym_class] = ACTIONS(2531),
    [anon_sym_async] = ACTIONS(2531),
    [anon_sym_function] = ACTIONS(2531),
    [anon_sym_new] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_DASH] = ACTIONS(2531),
    [anon_sym_TILDE] = ACTIONS(2533),
    [anon_sym_void] = ACTIONS(2531),
    [anon_sym_delete] = ACTIONS(2531),
    [anon_sym_PLUS_PLUS] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(2533),
    [anon_sym_DQUOTE] = ACTIONS(2533),
    [anon_sym_SQUOTE] = ACTIONS(2533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2533),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(2531),
    [sym_super] = ACTIONS(2531),
    [sym_true] = ACTIONS(2531),
    [sym_false] = ACTIONS(2531),
    [sym_null] = ACTIONS(2531),
    [sym_undefined] = ACTIONS(2531),
    [anon_sym_AT] = ACTIONS(2533),
    [anon_sym_static] = ACTIONS(2531),
    [anon_sym_readonly] = ACTIONS(2531),
    [anon_sym_get] = ACTIONS(2531),
    [anon_sym_set] = ACTIONS(2531),
    [anon_sym_declare] = ACTIONS(2531),
    [anon_sym_public] = ACTIONS(2531),
    [anon_sym_private] = ACTIONS(2531),
    [anon_sym_protected] = ACTIONS(2531),
    [anon_sym_override] = ACTIONS(2531),
    [anon_sym_module] = ACTIONS(2531),
    [anon_sym_any] = ACTIONS(2531),
    [anon_sym_number] = ACTIONS(2531),
    [anon_sym_boolean] = ACTIONS(2531),
    [anon_sym_string] = ACTIONS(2531),
    [anon_sym_symbol] = ACTIONS(2531),
    [anon_sym_abstract] = ACTIONS(2531),
    [anon_sym_interface] = ACTIONS(2531),
    [anon_sym_enum] = ACTIONS(2531),
  },
  [797] = {
    [sym_identifier] = ACTIONS(2535),
    [anon_sym_export] = ACTIONS(2535),
    [anon_sym_type] = ACTIONS(2535),
    [anon_sym_namespace] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_typeof] = ACTIONS(2535),
    [anon_sym_import] = ACTIONS(2535),
    [anon_sym_var] = ACTIONS(2535),
    [anon_sym_let] = ACTIONS(2535),
    [anon_sym_const] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2535),
    [anon_sym_switch] = ACTIONS(2535),
    [anon_sym_for] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_await] = ACTIONS(2535),
    [anon_sym_while] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(2535),
    [anon_sym_try] = ACTIONS(2535),
    [anon_sym_with] = ACTIONS(2535),
    [anon_sym_break] = ACTIONS(2535),
    [anon_sym_continue] = ACTIONS(2535),
    [anon_sym_debugger] = ACTIONS(2535),
    [anon_sym_return] = ACTIONS(2535),
    [anon_sym_throw] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_yield] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_LTtemplate_GT] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_class] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_new] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2537),
    [anon_sym_void] = ACTIONS(2535),
    [anon_sym_delete] = ACTIONS(2535),
    [anon_sym_PLUS_PLUS] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2537),
    [anon_sym_DQUOTE] = ACTIONS(2537),
    [anon_sym_SQUOTE] = ACTIONS(2537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2537),
    [sym_number] = ACTIONS(2537),
    [sym_this] = ACTIONS(2535),
    [sym_super] = ACTIONS(2535),
    [sym_true] = ACTIONS(2535),
    [sym_false] = ACTIONS(2535),
    [sym_null] = ACTIONS(2535),
    [sym_undefined] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2537),
    [anon_sym_static] = ACTIONS(2535),
    [anon_sym_readonly] = ACTIONS(2535),
    [anon_sym_get] = ACTIONS(2535),
    [anon_sym_set] = ACTIONS(2535),
    [anon_sym_declare] = ACTIONS(2535),
    [anon_sym_public] = ACTIONS(2535),
    [anon_sym_private] = ACTIONS(2535),
    [anon_sym_protected] = ACTIONS(2535),
    [anon_sym_override] = ACTIONS(2535),
    [anon_sym_module] = ACTIONS(2535),
    [anon_sym_any] = ACTIONS(2535),
    [anon_sym_number] = ACTIONS(2535),
    [anon_sym_boolean] = ACTIONS(2535),
    [anon_sym_string] = ACTIONS(2535),
    [anon_sym_symbol] = ACTIONS(2535),
    [anon_sym_abstract] = ACTIONS(2535),
    [anon_sym_interface] = ACTIONS(2535),
    [anon_sym_enum] = ACTIONS(2535),
  },
  [798] = {
    [sym_identifier] = ACTIONS(2535),
    [anon_sym_export] = ACTIONS(2535),
    [anon_sym_type] = ACTIONS(2535),
    [anon_sym_namespace] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_typeof] = ACTIONS(2535),
    [anon_sym_import] = ACTIONS(2535),
    [anon_sym_var] = ACTIONS(2535),
    [anon_sym_let] = ACTIONS(2535),
    [anon_sym_const] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2535),
    [anon_sym_switch] = ACTIONS(2535),
    [anon_sym_for] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_await] = ACTIONS(2535),
    [anon_sym_while] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(2535),
    [anon_sym_try] = ACTIONS(2535),
    [anon_sym_with] = ACTIONS(2535),
    [anon_sym_break] = ACTIONS(2535),
    [anon_sym_continue] = ACTIONS(2535),
    [anon_sym_debugger] = ACTIONS(2535),
    [anon_sym_return] = ACTIONS(2535),
    [anon_sym_throw] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_yield] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_LTtemplate_GT] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_class] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_new] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2537),
    [anon_sym_void] = ACTIONS(2535),
    [anon_sym_delete] = ACTIONS(2535),
    [anon_sym_PLUS_PLUS] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2537),
    [anon_sym_DQUOTE] = ACTIONS(2537),
    [anon_sym_SQUOTE] = ACTIONS(2537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2537),
    [sym_number] = ACTIONS(2537),
    [sym_this] = ACTIONS(2535),
    [sym_super] = ACTIONS(2535),
    [sym_true] = ACTIONS(2535),
    [sym_false] = ACTIONS(2535),
    [sym_null] = ACTIONS(2535),
    [sym_undefined] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2537),
    [anon_sym_static] = ACTIONS(2535),
    [anon_sym_readonly] = ACTIONS(2535),
    [anon_sym_get] = ACTIONS(2535),
    [anon_sym_set] = ACTIONS(2535),
    [anon_sym_declare] = ACTIONS(2535),
    [anon_sym_public] = ACTIONS(2535),
    [anon_sym_private] = ACTIONS(2535),
    [anon_sym_protected] = ACTIONS(2535),
    [anon_sym_override] = ACTIONS(2535),
    [anon_sym_module] = ACTIONS(2535),
    [anon_sym_any] = ACTIONS(2535),
    [anon_sym_number] = ACTIONS(2535),
    [anon_sym_boolean] = ACTIONS(2535),
    [anon_sym_string] = ACTIONS(2535),
    [anon_sym_symbol] = ACTIONS(2535),
    [anon_sym_abstract] = ACTIONS(2535),
    [anon_sym_interface] = ACTIONS(2535),
    [anon_sym_enum] = ACTIONS(2535),
  },
  [799] = {
    [sym_identifier] = ACTIONS(2539),
    [anon_sym_export] = ACTIONS(2539),
    [anon_sym_type] = ACTIONS(2539),
    [anon_sym_namespace] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_typeof] = ACTIONS(2539),
    [anon_sym_import] = ACTIONS(2539),
    [anon_sym_var] = ACTIONS(2539),
    [anon_sym_let] = ACTIONS(2539),
    [anon_sym_const] = ACTIONS(2539),
    [anon_sym_BANG] = ACTIONS(2541),
    [anon_sym_if] = ACTIONS(2539),
    [anon_sym_switch] = ACTIONS(2539),
    [anon_sym_for] = ACTIONS(2539),
    [anon_sym_LPAREN] = ACTIONS(2541),
    [anon_sym_await] = ACTIONS(2539),
    [anon_sym_while] = ACTIONS(2539),
    [anon_sym_do] = ACTIONS(2539),
    [anon_sym_try] = ACTIONS(2539),
    [anon_sym_with] = ACTIONS(2539),
    [anon_sym_break] = ACTIONS(2539),
    [anon_sym_continue] = ACTIONS(2539),
    [anon_sym_debugger] = ACTIONS(2539),
    [anon_sym_return] = ACTIONS(2539),
    [anon_sym_throw] = ACTIONS(2539),
    [anon_sym_SEMI] = ACTIONS(2541),
    [anon_sym_yield] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_LTtemplate_GT] = ACTIONS(2541),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_SLASH] = ACTIONS(2539),
    [anon_sym_class] = ACTIONS(2539),
    [anon_sym_async] = ACTIONS(2539),
    [anon_sym_function] = ACTIONS(2539),
    [anon_sym_new] = ACTIONS(2539),
    [anon_sym_PLUS] = ACTIONS(2539),
    [anon_sym_DASH] = ACTIONS(2539),
    [anon_sym_TILDE] = ACTIONS(2541),
    [anon_sym_void] = ACTIONS(2539),
    [anon_sym_delete] = ACTIONS(2539),
    [anon_sym_PLUS_PLUS] = ACTIONS(2541),
    [anon_sym_DASH_DASH] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2541),
    [anon_sym_SQUOTE] = ACTIONS(2541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [sym_number] = ACTIONS(2541),
    [sym_this] = ACTIONS(2539),
    [sym_super] = ACTIONS(2539),
    [sym_true] = ACTIONS(2539),
    [sym_false] = ACTIONS(2539),
    [sym_null] = ACTIONS(2539),
    [sym_undefined] = ACTIONS(2539),
    [anon_sym_AT] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2539),
    [anon_sym_readonly] = ACTIONS(2539),
    [anon_sym_get] = ACTIONS(2539),
    [anon_sym_set] = ACTIONS(2539),
    [anon_sym_declare] = ACTIONS(2539),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_override] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_any] = ACTIONS(2539),
    [anon_sym_number] = ACTIONS(2539),
    [anon_sym_boolean] = ACTIONS(2539),
    [anon_sym_string] = ACTIONS(2539),
    [anon_sym_symbol] = ACTIONS(2539),
    [anon_sym_abstract] = ACTIONS(2539),
    [anon_sym_interface] = ACTIONS(2539),
    [anon_sym_enum] = ACTIONS(2539),
  },
  [800] = {
    [sym_identifier] = ACTIONS(2535),
    [anon_sym_export] = ACTIONS(2535),
    [anon_sym_type] = ACTIONS(2535),
    [anon_sym_namespace] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_typeof] = ACTIONS(2535),
    [anon_sym_import] = ACTIONS(2535),
    [anon_sym_var] = ACTIONS(2535),
    [anon_sym_let] = ACTIONS(2535),
    [anon_sym_const] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2535),
    [anon_sym_switch] = ACTIONS(2535),
    [anon_sym_for] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_await] = ACTIONS(2535),
    [anon_sym_while] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(2535),
    [anon_sym_try] = ACTIONS(2535),
    [anon_sym_with] = ACTIONS(2535),
    [anon_sym_break] = ACTIONS(2535),
    [anon_sym_continue] = ACTIONS(2535),
    [anon_sym_debugger] = ACTIONS(2535),
    [anon_sym_return] = ACTIONS(2535),
    [anon_sym_throw] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_yield] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_LTtemplate_GT] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_class] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_new] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2537),
    [anon_sym_void] = ACTIONS(2535),
    [anon_sym_delete] = ACTIONS(2535),
    [anon_sym_PLUS_PLUS] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2537),
    [anon_sym_DQUOTE] = ACTIONS(2537),
    [anon_sym_SQUOTE] = ACTIONS(2537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2537),
    [sym_number] = ACTIONS(2537),
    [sym_this] = ACTIONS(2535),
    [sym_super] = ACTIONS(2535),
    [sym_true] = ACTIONS(2535),
    [sym_false] = ACTIONS(2535),
    [sym_null] = ACTIONS(2535),
    [sym_undefined] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2537),
    [anon_sym_static] = ACTIONS(2535),
    [anon_sym_readonly] = ACTIONS(2535),
    [anon_sym_get] = ACTIONS(2535),
    [anon_sym_set] = ACTIONS(2535),
    [anon_sym_declare] = ACTIONS(2535),
    [anon_sym_public] = ACTIONS(2535),
    [anon_sym_private] = ACTIONS(2535),
    [anon_sym_protected] = ACTIONS(2535),
    [anon_sym_override] = ACTIONS(2535),
    [anon_sym_module] = ACTIONS(2535),
    [anon_sym_any] = ACTIONS(2535),
    [anon_sym_number] = ACTIONS(2535),
    [anon_sym_boolean] = ACTIONS(2535),
    [anon_sym_string] = ACTIONS(2535),
    [anon_sym_symbol] = ACTIONS(2535),
    [anon_sym_abstract] = ACTIONS(2535),
    [anon_sym_interface] = ACTIONS(2535),
    [anon_sym_enum] = ACTIONS(2535),
  },
  [801] = {
    [sym_identifier] = ACTIONS(2535),
    [anon_sym_export] = ACTIONS(2535),
    [anon_sym_type] = ACTIONS(2535),
    [anon_sym_namespace] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_typeof] = ACTIONS(2535),
    [anon_sym_import] = ACTIONS(2535),
    [anon_sym_var] = ACTIONS(2535),
    [anon_sym_let] = ACTIONS(2535),
    [anon_sym_const] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2535),
    [anon_sym_switch] = ACTIONS(2535),
    [anon_sym_for] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_await] = ACTIONS(2535),
    [anon_sym_while] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(2535),
    [anon_sym_try] = ACTIONS(2535),
    [anon_sym_with] = ACTIONS(2535),
    [anon_sym_break] = ACTIONS(2535),
    [anon_sym_continue] = ACTIONS(2535),
    [anon_sym_debugger] = ACTIONS(2535),
    [anon_sym_return] = ACTIONS(2535),
    [anon_sym_throw] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_yield] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_LTtemplate_GT] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_class] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_new] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2537),
    [anon_sym_void] = ACTIONS(2535),
    [anon_sym_delete] = ACTIONS(2535),
    [anon_sym_PLUS_PLUS] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2537),
    [anon_sym_DQUOTE] = ACTIONS(2537),
    [anon_sym_SQUOTE] = ACTIONS(2537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2537),
    [sym_number] = ACTIONS(2537),
    [sym_this] = ACTIONS(2535),
    [sym_super] = ACTIONS(2535),
    [sym_true] = ACTIONS(2535),
    [sym_false] = ACTIONS(2535),
    [sym_null] = ACTIONS(2535),
    [sym_undefined] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2537),
    [anon_sym_static] = ACTIONS(2535),
    [anon_sym_readonly] = ACTIONS(2535),
    [anon_sym_get] = ACTIONS(2535),
    [anon_sym_set] = ACTIONS(2535),
    [anon_sym_declare] = ACTIONS(2535),
    [anon_sym_public] = ACTIONS(2535),
    [anon_sym_private] = ACTIONS(2535),
    [anon_sym_protected] = ACTIONS(2535),
    [anon_sym_override] = ACTIONS(2535),
    [anon_sym_module] = ACTIONS(2535),
    [anon_sym_any] = ACTIONS(2535),
    [anon_sym_number] = ACTIONS(2535),
    [anon_sym_boolean] = ACTIONS(2535),
    [anon_sym_string] = ACTIONS(2535),
    [anon_sym_symbol] = ACTIONS(2535),
    [anon_sym_abstract] = ACTIONS(2535),
    [anon_sym_interface] = ACTIONS(2535),
    [anon_sym_enum] = ACTIONS(2535),
  },
  [802] = {
    [sym_identifier] = ACTIONS(2535),
    [anon_sym_export] = ACTIONS(2535),
    [anon_sym_type] = ACTIONS(2535),
    [anon_sym_namespace] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_typeof] = ACTIONS(2535),
    [anon_sym_import] = ACTIONS(2535),
    [anon_sym_var] = ACTIONS(2535),
    [anon_sym_let] = ACTIONS(2535),
    [anon_sym_const] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2535),
    [anon_sym_switch] = ACTIONS(2535),
    [anon_sym_for] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_await] = ACTIONS(2535),
    [anon_sym_while] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(2535),
    [anon_sym_try] = ACTIONS(2535),
    [anon_sym_with] = ACTIONS(2535),
    [anon_sym_break] = ACTIONS(2535),
    [anon_sym_continue] = ACTIONS(2535),
    [anon_sym_debugger] = ACTIONS(2535),
    [anon_sym_return] = ACTIONS(2535),
    [anon_sym_throw] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_yield] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_LTtemplate_GT] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_class] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_new] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2537),
    [anon_sym_void] = ACTIONS(2535),
    [anon_sym_delete] = ACTIONS(2535),
    [anon_sym_PLUS_PLUS] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2537),
    [anon_sym_DQUOTE] = ACTIONS(2537),
    [anon_sym_SQUOTE] = ACTIONS(2537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2537),
    [sym_number] = ACTIONS(2537),
    [sym_this] = ACTIONS(2535),
    [sym_super] = ACTIONS(2535),
    [sym_true] = ACTIONS(2535),
    [sym_false] = ACTIONS(2535),
    [sym_null] = ACTIONS(2535),
    [sym_undefined] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2537),
    [anon_sym_static] = ACTIONS(2535),
    [anon_sym_readonly] = ACTIONS(2535),
    [anon_sym_get] = ACTIONS(2535),
    [anon_sym_set] = ACTIONS(2535),
    [anon_sym_declare] = ACTIONS(2535),
    [anon_sym_public] = ACTIONS(2535),
    [anon_sym_private] = ACTIONS(2535),
    [anon_sym_protected] = ACTIONS(2535),
    [anon_sym_override] = ACTIONS(2535),
    [anon_sym_module] = ACTIONS(2535),
    [anon_sym_any] = ACTIONS(2535),
    [anon_sym_number] = ACTIONS(2535),
    [anon_sym_boolean] = ACTIONS(2535),
    [anon_sym_string] = ACTIONS(2535),
    [anon_sym_symbol] = ACTIONS(2535),
    [anon_sym_abstract] = ACTIONS(2535),
    [anon_sym_interface] = ACTIONS(2535),
    [anon_sym_enum] = ACTIONS(2535),
  },
  [803] = {
    [sym_identifier] = ACTIONS(2535),
    [anon_sym_export] = ACTIONS(2535),
    [anon_sym_type] = ACTIONS(2535),
    [anon_sym_namespace] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_typeof] = ACTIONS(2535),
    [anon_sym_import] = ACTIONS(2535),
    [anon_sym_var] = ACTIONS(2535),
    [anon_sym_let] = ACTIONS(2535),
    [anon_sym_const] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2535),
    [anon_sym_switch] = ACTIONS(2535),
    [anon_sym_for] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_await] = ACTIONS(2535),
    [anon_sym_while] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(2535),
    [anon_sym_try] = ACTIONS(2535),
    [anon_sym_with] = ACTIONS(2535),
    [anon_sym_break] = ACTIONS(2535),
    [anon_sym_continue] = ACTIONS(2535),
    [anon_sym_debugger] = ACTIONS(2535),
    [anon_sym_return] = ACTIONS(2535),
    [anon_sym_throw] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_yield] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_LTtemplate_GT] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_class] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_new] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2537),
    [anon_sym_void] = ACTIONS(2535),
    [anon_sym_delete] = ACTIONS(2535),
    [anon_sym_PLUS_PLUS] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2537),
    [anon_sym_DQUOTE] = ACTIONS(2537),
    [anon_sym_SQUOTE] = ACTIONS(2537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2537),
    [sym_number] = ACTIONS(2537),
    [sym_this] = ACTIONS(2535),
    [sym_super] = ACTIONS(2535),
    [sym_true] = ACTIONS(2535),
    [sym_false] = ACTIONS(2535),
    [sym_null] = ACTIONS(2535),
    [sym_undefined] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2537),
    [anon_sym_static] = ACTIONS(2535),
    [anon_sym_readonly] = ACTIONS(2535),
    [anon_sym_get] = ACTIONS(2535),
    [anon_sym_set] = ACTIONS(2535),
    [anon_sym_declare] = ACTIONS(2535),
    [anon_sym_public] = ACTIONS(2535),
    [anon_sym_private] = ACTIONS(2535),
    [anon_sym_protected] = ACTIONS(2535),
    [anon_sym_override] = ACTIONS(2535),
    [anon_sym_module] = ACTIONS(2535),
    [anon_sym_any] = ACTIONS(2535),
    [anon_sym_number] = ACTIONS(2535),
    [anon_sym_boolean] = ACTIONS(2535),
    [anon_sym_string] = ACTIONS(2535),
    [anon_sym_symbol] = ACTIONS(2535),
    [anon_sym_abstract] = ACTIONS(2535),
    [anon_sym_interface] = ACTIONS(2535),
    [anon_sym_enum] = ACTIONS(2535),
  },
  [804] = {
    [sym_identifier] = ACTIONS(2535),
    [anon_sym_export] = ACTIONS(2535),
    [anon_sym_type] = ACTIONS(2535),
    [anon_sym_namespace] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_typeof] = ACTIONS(2535),
    [anon_sym_import] = ACTIONS(2535),
    [anon_sym_var] = ACTIONS(2535),
    [anon_sym_let] = ACTIONS(2535),
    [anon_sym_const] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2535),
    [anon_sym_switch] = ACTIONS(2535),
    [anon_sym_for] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_await] = ACTIONS(2535),
    [anon_sym_while] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(2535),
    [anon_sym_try] = ACTIONS(2535),
    [anon_sym_with] = ACTIONS(2535),
    [anon_sym_break] = ACTIONS(2535),
    [anon_sym_continue] = ACTIONS(2535),
    [anon_sym_debugger] = ACTIONS(2535),
    [anon_sym_return] = ACTIONS(2535),
    [anon_sym_throw] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_yield] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_LTtemplate_GT] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_class] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_new] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2537),
    [anon_sym_void] = ACTIONS(2535),
    [anon_sym_delete] = ACTIONS(2535),
    [anon_sym_PLUS_PLUS] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2537),
    [anon_sym_DQUOTE] = ACTIONS(2537),
    [anon_sym_SQUOTE] = ACTIONS(2537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2537),
    [sym_number] = ACTIONS(2537),
    [sym_this] = ACTIONS(2535),
    [sym_super] = ACTIONS(2535),
    [sym_true] = ACTIONS(2535),
    [sym_false] = ACTIONS(2535),
    [sym_null] = ACTIONS(2535),
    [sym_undefined] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2537),
    [anon_sym_static] = ACTIONS(2535),
    [anon_sym_readonly] = ACTIONS(2535),
    [anon_sym_get] = ACTIONS(2535),
    [anon_sym_set] = ACTIONS(2535),
    [anon_sym_declare] = ACTIONS(2535),
    [anon_sym_public] = ACTIONS(2535),
    [anon_sym_private] = ACTIONS(2535),
    [anon_sym_protected] = ACTIONS(2535),
    [anon_sym_override] = ACTIONS(2535),
    [anon_sym_module] = ACTIONS(2535),
    [anon_sym_any] = ACTIONS(2535),
    [anon_sym_number] = ACTIONS(2535),
    [anon_sym_boolean] = ACTIONS(2535),
    [anon_sym_string] = ACTIONS(2535),
    [anon_sym_symbol] = ACTIONS(2535),
    [anon_sym_abstract] = ACTIONS(2535),
    [anon_sym_interface] = ACTIONS(2535),
    [anon_sym_enum] = ACTIONS(2535),
  },
  [805] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_rest_pattern] = STATE(4052),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2988),
    [sym_tuple_parameter] = STATE(3932),
    [sym_optional_tuple_parameter] = STATE(3932),
    [sym_optional_type] = STATE(3932),
    [sym_rest_type] = STATE(3932),
    [sym__tuple_type_member] = STATE(3932),
    [sym_constructor_type] = STATE(2988),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2988),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2988),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2988),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [806] = {
    [sym_identifier] = ACTIONS(2535),
    [anon_sym_export] = ACTIONS(2535),
    [anon_sym_type] = ACTIONS(2535),
    [anon_sym_namespace] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_typeof] = ACTIONS(2535),
    [anon_sym_import] = ACTIONS(2535),
    [anon_sym_var] = ACTIONS(2535),
    [anon_sym_let] = ACTIONS(2535),
    [anon_sym_const] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2535),
    [anon_sym_switch] = ACTIONS(2535),
    [anon_sym_for] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_await] = ACTIONS(2535),
    [anon_sym_while] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(2535),
    [anon_sym_try] = ACTIONS(2535),
    [anon_sym_with] = ACTIONS(2535),
    [anon_sym_break] = ACTIONS(2535),
    [anon_sym_continue] = ACTIONS(2535),
    [anon_sym_debugger] = ACTIONS(2535),
    [anon_sym_return] = ACTIONS(2535),
    [anon_sym_throw] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_yield] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_LTtemplate_GT] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_class] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(2535),
    [anon_sym_function] = ACTIONS(2535),
    [anon_sym_new] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2537),
    [anon_sym_void] = ACTIONS(2535),
    [anon_sym_delete] = ACTIONS(2535),
    [anon_sym_PLUS_PLUS] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2537),
    [anon_sym_DQUOTE] = ACTIONS(2537),
    [anon_sym_SQUOTE] = ACTIONS(2537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2537),
    [sym_number] = ACTIONS(2537),
    [sym_this] = ACTIONS(2535),
    [sym_super] = ACTIONS(2535),
    [sym_true] = ACTIONS(2535),
    [sym_false] = ACTIONS(2535),
    [sym_null] = ACTIONS(2535),
    [sym_undefined] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2537),
    [anon_sym_static] = ACTIONS(2535),
    [anon_sym_readonly] = ACTIONS(2535),
    [anon_sym_get] = ACTIONS(2535),
    [anon_sym_set] = ACTIONS(2535),
    [anon_sym_declare] = ACTIONS(2535),
    [anon_sym_public] = ACTIONS(2535),
    [anon_sym_private] = ACTIONS(2535),
    [anon_sym_protected] = ACTIONS(2535),
    [anon_sym_override] = ACTIONS(2535),
    [anon_sym_module] = ACTIONS(2535),
    [anon_sym_any] = ACTIONS(2535),
    [anon_sym_number] = ACTIONS(2535),
    [anon_sym_boolean] = ACTIONS(2535),
    [anon_sym_string] = ACTIONS(2535),
    [anon_sym_symbol] = ACTIONS(2535),
    [anon_sym_abstract] = ACTIONS(2535),
    [anon_sym_interface] = ACTIONS(2535),
    [anon_sym_enum] = ACTIONS(2535),
  },
  [807] = {
    [sym_identifier] = ACTIONS(2543),
    [anon_sym_export] = ACTIONS(2543),
    [anon_sym_type] = ACTIONS(2543),
    [anon_sym_namespace] = ACTIONS(2543),
    [anon_sym_LBRACE] = ACTIONS(2545),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_import] = ACTIONS(2543),
    [anon_sym_var] = ACTIONS(2543),
    [anon_sym_let] = ACTIONS(2543),
    [anon_sym_const] = ACTIONS(2543),
    [anon_sym_BANG] = ACTIONS(2545),
    [anon_sym_if] = ACTIONS(2543),
    [anon_sym_switch] = ACTIONS(2543),
    [anon_sym_for] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_await] = ACTIONS(2543),
    [anon_sym_while] = ACTIONS(2543),
    [anon_sym_do] = ACTIONS(2543),
    [anon_sym_try] = ACTIONS(2543),
    [anon_sym_with] = ACTIONS(2543),
    [anon_sym_break] = ACTIONS(2543),
    [anon_sym_continue] = ACTIONS(2543),
    [anon_sym_debugger] = ACTIONS(2543),
    [anon_sym_return] = ACTIONS(2543),
    [anon_sym_throw] = ACTIONS(2543),
    [anon_sym_SEMI] = ACTIONS(2545),
    [anon_sym_yield] = ACTIONS(2543),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_LTtemplate_GT] = ACTIONS(2545),
    [anon_sym_LT] = ACTIONS(2543),
    [anon_sym_SLASH] = ACTIONS(2543),
    [anon_sym_class] = ACTIONS(2543),
    [anon_sym_async] = ACTIONS(2543),
    [anon_sym_function] = ACTIONS(2543),
    [anon_sym_new] = ACTIONS(2543),
    [anon_sym_PLUS] = ACTIONS(2543),
    [anon_sym_DASH] = ACTIONS(2543),
    [anon_sym_TILDE] = ACTIONS(2545),
    [anon_sym_void] = ACTIONS(2543),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_PLUS_PLUS] = ACTIONS(2545),
    [anon_sym_DASH_DASH] = ACTIONS(2545),
    [anon_sym_DQUOTE] = ACTIONS(2545),
    [anon_sym_SQUOTE] = ACTIONS(2545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2545),
    [sym_number] = ACTIONS(2545),
    [sym_this] = ACTIONS(2543),
    [sym_super] = ACTIONS(2543),
    [sym_true] = ACTIONS(2543),
    [sym_false] = ACTIONS(2543),
    [sym_null] = ACTIONS(2543),
    [sym_undefined] = ACTIONS(2543),
    [anon_sym_AT] = ACTIONS(2545),
    [anon_sym_static] = ACTIONS(2543),
    [anon_sym_readonly] = ACTIONS(2543),
    [anon_sym_get] = ACTIONS(2543),
    [anon_sym_set] = ACTIONS(2543),
    [anon_sym_declare] = ACTIONS(2543),
    [anon_sym_public] = ACTIONS(2543),
    [anon_sym_private] = ACTIONS(2543),
    [anon_sym_protected] = ACTIONS(2543),
    [anon_sym_override] = ACTIONS(2543),
    [anon_sym_module] = ACTIONS(2543),
    [anon_sym_any] = ACTIONS(2543),
    [anon_sym_number] = ACTIONS(2543),
    [anon_sym_boolean] = ACTIONS(2543),
    [anon_sym_string] = ACTIONS(2543),
    [anon_sym_symbol] = ACTIONS(2543),
    [anon_sym_abstract] = ACTIONS(2543),
    [anon_sym_interface] = ACTIONS(2543),
    [anon_sym_enum] = ACTIONS(2543),
  },
  [808] = {
    [sym_identifier] = ACTIONS(2547),
    [anon_sym_export] = ACTIONS(2547),
    [anon_sym_type] = ACTIONS(2547),
    [anon_sym_EQ] = ACTIONS(2547),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [anon_sym_COMMA] = ACTIONS(2549),
    [anon_sym_RBRACE] = ACTIONS(2549),
    [anon_sym_typeof] = ACTIONS(2547),
    [anon_sym_import] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_LPAREN] = ACTIONS(2549),
    [anon_sym_RPAREN] = ACTIONS(2549),
    [anon_sym_await] = ACTIONS(2547),
    [anon_sym_COLON] = ACTIONS(2549),
    [anon_sym_yield] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2549),
    [anon_sym_RBRACK] = ACTIONS(2549),
    [anon_sym_LTtemplate_GT] = ACTIONS(2549),
    [anon_sym_LT] = ACTIONS(2547),
    [anon_sym_GT] = ACTIONS(2549),
    [anon_sym_SLASH] = ACTIONS(2547),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_class] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2547),
    [anon_sym_function] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(2549),
    [anon_sym_QMARK_DOT] = ACTIONS(2549),
    [anon_sym_new] = ACTIONS(2547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2549),
    [anon_sym_PIPE] = ACTIONS(2549),
    [anon_sym_PLUS] = ACTIONS(2547),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_TILDE] = ACTIONS(2549),
    [anon_sym_void] = ACTIONS(2547),
    [anon_sym_delete] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(2549),
    [anon_sym_DASH_DASH] = ACTIONS(2549),
    [anon_sym_DQUOTE] = ACTIONS(2549),
    [anon_sym_SQUOTE] = ACTIONS(2549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2549),
    [sym_number] = ACTIONS(2549),
    [sym_this] = ACTIONS(2547),
    [sym_super] = ACTIONS(2547),
    [sym_true] = ACTIONS(2547),
    [sym_false] = ACTIONS(2547),
    [sym_null] = ACTIONS(2547),
    [sym_undefined] = ACTIONS(2547),
    [anon_sym_AT] = ACTIONS(2549),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_readonly] = ACTIONS(2547),
    [anon_sym_get] = ACTIONS(2547),
    [anon_sym_set] = ACTIONS(2547),
    [anon_sym_QMARK] = ACTIONS(2547),
    [anon_sym_declare] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_override] = ACTIONS(2547),
    [anon_sym_module] = ACTIONS(2547),
    [anon_sym_any] = ACTIONS(2547),
    [anon_sym_number] = ACTIONS(2547),
    [anon_sym_boolean] = ACTIONS(2547),
    [anon_sym_string] = ACTIONS(2547),
    [anon_sym_symbol] = ACTIONS(2547),
    [anon_sym_abstract] = ACTIONS(2547),
    [anon_sym_extends] = ACTIONS(2547),
  },
  [809] = {
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_export] = ACTIONS(2551),
    [anon_sym_type] = ACTIONS(2551),
    [anon_sym_EQ] = ACTIONS(2551),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2553),
    [anon_sym_RBRACE] = ACTIONS(2553),
    [anon_sym_typeof] = ACTIONS(2551),
    [anon_sym_import] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_RPAREN] = ACTIONS(2553),
    [anon_sym_await] = ACTIONS(2551),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK] = ACTIONS(2553),
    [anon_sym_LTtemplate_GT] = ACTIONS(2553),
    [anon_sym_LT] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2553),
    [anon_sym_SLASH] = ACTIONS(2551),
    [anon_sym_DOT] = ACTIONS(2551),
    [anon_sym_class] = ACTIONS(2551),
    [anon_sym_async] = ACTIONS(2551),
    [anon_sym_function] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(2553),
    [anon_sym_QMARK_DOT] = ACTIONS(2553),
    [anon_sym_new] = ACTIONS(2551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2551),
    [anon_sym_DASH] = ACTIONS(2551),
    [anon_sym_TILDE] = ACTIONS(2553),
    [anon_sym_void] = ACTIONS(2551),
    [anon_sym_delete] = ACTIONS(2551),
    [anon_sym_PLUS_PLUS] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_SQUOTE] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2553),
    [sym_number] = ACTIONS(2553),
    [sym_this] = ACTIONS(2551),
    [sym_super] = ACTIONS(2551),
    [sym_true] = ACTIONS(2551),
    [sym_false] = ACTIONS(2551),
    [sym_null] = ACTIONS(2551),
    [sym_undefined] = ACTIONS(2551),
    [anon_sym_AT] = ACTIONS(2553),
    [anon_sym_static] = ACTIONS(2551),
    [anon_sym_readonly] = ACTIONS(2551),
    [anon_sym_get] = ACTIONS(2551),
    [anon_sym_set] = ACTIONS(2551),
    [anon_sym_QMARK] = ACTIONS(2551),
    [anon_sym_declare] = ACTIONS(2551),
    [anon_sym_public] = ACTIONS(2551),
    [anon_sym_private] = ACTIONS(2551),
    [anon_sym_protected] = ACTIONS(2551),
    [anon_sym_override] = ACTIONS(2551),
    [anon_sym_module] = ACTIONS(2551),
    [anon_sym_any] = ACTIONS(2551),
    [anon_sym_number] = ACTIONS(2551),
    [anon_sym_boolean] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_symbol] = ACTIONS(2551),
    [anon_sym_abstract] = ACTIONS(2551),
    [anon_sym_extends] = ACTIONS(2551),
  },
  [810] = {
    [sym_identifier] = ACTIONS(2555),
    [anon_sym_export] = ACTIONS(2555),
    [anon_sym_type] = ACTIONS(2555),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_namespace] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2557),
    [anon_sym_RBRACE] = ACTIONS(2557),
    [anon_sym_typeof] = ACTIONS(2555),
    [anon_sym_import] = ACTIONS(2555),
    [anon_sym_BANG] = ACTIONS(2557),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_RPAREN] = ACTIONS(2557),
    [anon_sym_await] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_RBRACK] = ACTIONS(2557),
    [anon_sym_LTtemplate_GT] = ACTIONS(2557),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_GT] = ACTIONS(2557),
    [anon_sym_SLASH] = ACTIONS(2555),
    [anon_sym_DOT] = ACTIONS(2555),
    [anon_sym_class] = ACTIONS(2555),
    [anon_sym_async] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2555),
    [anon_sym_EQ_GT] = ACTIONS(2557),
    [anon_sym_QMARK_DOT] = ACTIONS(2557),
    [anon_sym_new] = ACTIONS(2555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2557),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_PIPE] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2555),
    [anon_sym_TILDE] = ACTIONS(2557),
    [anon_sym_void] = ACTIONS(2555),
    [anon_sym_delete] = ACTIONS(2555),
    [anon_sym_PLUS_PLUS] = ACTIONS(2557),
    [anon_sym_DASH_DASH] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_SQUOTE] = ACTIONS(2557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2557),
    [sym_number] = ACTIONS(2557),
    [sym_this] = ACTIONS(2555),
    [sym_super] = ACTIONS(2555),
    [sym_true] = ACTIONS(2555),
    [sym_false] = ACTIONS(2555),
    [sym_null] = ACTIONS(2555),
    [sym_undefined] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(2557),
    [anon_sym_static] = ACTIONS(2555),
    [anon_sym_readonly] = ACTIONS(2555),
    [anon_sym_get] = ACTIONS(2555),
    [anon_sym_set] = ACTIONS(2555),
    [anon_sym_QMARK] = ACTIONS(2555),
    [anon_sym_declare] = ACTIONS(2555),
    [anon_sym_public] = ACTIONS(2555),
    [anon_sym_private] = ACTIONS(2555),
    [anon_sym_protected] = ACTIONS(2555),
    [anon_sym_override] = ACTIONS(2555),
    [anon_sym_module] = ACTIONS(2555),
    [anon_sym_any] = ACTIONS(2555),
    [anon_sym_number] = ACTIONS(2555),
    [anon_sym_boolean] = ACTIONS(2555),
    [anon_sym_string] = ACTIONS(2555),
    [anon_sym_symbol] = ACTIONS(2555),
    [anon_sym_abstract] = ACTIONS(2555),
    [anon_sym_extends] = ACTIONS(2555),
  },
  [811] = {
    [sym_nested_identifier] = STATE(152),
    [sym_string] = STATE(153),
    [sym__module] = STATE(184),
    [aux_sym_object_repeat1] = STATE(3702),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [anon_sym_SQUOTE] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [812] = {
    [sym_nested_identifier] = STATE(152),
    [sym_string] = STATE(153),
    [sym__module] = STATE(184),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [anon_sym_SQUOTE] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [813] = {
    [sym_nested_identifier] = STATE(609),
    [sym_string] = STATE(631),
    [sym__module] = STATE(653),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [814] = {
    [sym_nested_identifier] = STATE(152),
    [sym_string] = STATE(153),
    [sym__module] = STATE(184),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(2561),
    [anon_sym_SQUOTE] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [815] = {
    [sym_nested_identifier] = STATE(609),
    [sym_string] = STATE(631),
    [sym__module] = STATE(653),
    [aux_sym_object_repeat1] = STATE(3702),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [816] = {
    [sym_nested_identifier] = STATE(609),
    [sym_string] = STATE(631),
    [sym__module] = STATE(653),
    [aux_sym_object_repeat1] = STATE(3802),
    [aux_sym_object_pattern_repeat1] = STATE(3696),
    [sym_identifier] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(152),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__automatic_semicolon] = ACTIONS(152),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [817] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2690),
    [sym_constructor_type] = STATE(2690),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2690),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_predicate] = STATE(3097),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2573),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2690),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2690),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(2571),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_asserts] = ACTIONS(2573),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [818] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2851),
    [sym_constructor_type] = STATE(2851),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2851),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_predicate] = STATE(3304),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2668),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2851),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2851),
    [sym_identifier] = ACTIONS(2575),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2605),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_asserts] = ACTIONS(2615),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [819] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2733),
    [sym_constructor_type] = STATE(2733),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2733),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_predicate] = STATE(3876),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2418),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2733),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2733),
    [sym_identifier] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(2625),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_asserts] = ACTIONS(2627),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [820] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3461),
    [sym_constructor_type] = STATE(3461),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3461),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3461),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3461),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [821] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3145),
    [sym_constructor_type] = STATE(3145),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3145),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_predicate] = STATE(2427),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2958),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3145),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3145),
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(2643),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [822] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3728),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2665),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_declare] = ACTIONS(2655),
    [anon_sym_public] = ACTIONS(2687),
    [anon_sym_private] = ACTIONS(2687),
    [anon_sym_protected] = ACTIONS(2687),
    [anon_sym_override] = ACTIONS(2689),
    [anon_sym_module] = ACTIONS(2655),
    [anon_sym_any] = ACTIONS(2655),
    [anon_sym_number] = ACTIONS(2655),
    [anon_sym_boolean] = ACTIONS(2655),
    [anon_sym_string] = ACTIONS(2655),
    [anon_sym_symbol] = ACTIONS(2655),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [823] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3707),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3707),
    [sym_pair] = STATE(3707),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3715),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2695),
    [anon_sym_export] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2699),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_get] = ACTIONS(2707),
    [anon_sym_set] = ACTIONS(2707),
    [anon_sym_declare] = ACTIONS(2695),
    [anon_sym_public] = ACTIONS(2709),
    [anon_sym_private] = ACTIONS(2709),
    [anon_sym_protected] = ACTIONS(2709),
    [anon_sym_override] = ACTIONS(2711),
    [anon_sym_module] = ACTIONS(2695),
    [anon_sym_any] = ACTIONS(2695),
    [anon_sym_number] = ACTIONS(2695),
    [anon_sym_boolean] = ACTIONS(2695),
    [anon_sym_string] = ACTIONS(2695),
    [anon_sym_symbol] = ACTIONS(2695),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [824] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3728),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_declare] = ACTIONS(2655),
    [anon_sym_public] = ACTIONS(2687),
    [anon_sym_private] = ACTIONS(2687),
    [anon_sym_protected] = ACTIONS(2687),
    [anon_sym_override] = ACTIONS(2689),
    [anon_sym_module] = ACTIONS(2655),
    [anon_sym_any] = ACTIONS(2655),
    [anon_sym_number] = ACTIONS(2655),
    [anon_sym_boolean] = ACTIONS(2655),
    [anon_sym_string] = ACTIONS(2655),
    [anon_sym_symbol] = ACTIONS(2655),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [825] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2769),
    [sym_constructor_type] = STATE(2769),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2769),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_predicate] = STATE(2770),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2668),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2769),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2769),
    [sym_identifier] = ACTIONS(2575),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2605),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [826] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1307),
    [sym_constructor_type] = STATE(1307),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1307),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_predicate] = STATE(1251),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1235),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1307),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1307),
    [sym_identifier] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2741),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [827] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2757),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [828] = {
    [sym_nested_identifier] = STATE(1333),
    [sym_string] = STATE(1331),
    [sym__module] = STATE(1461),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(210),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(210),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [829] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3728),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2761),
    [anon_sym_export] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2761),
    [anon_sym_namespace] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2771),
    [anon_sym_get] = ACTIONS(2773),
    [anon_sym_set] = ACTIONS(2773),
    [anon_sym_declare] = ACTIONS(2761),
    [anon_sym_public] = ACTIONS(2775),
    [anon_sym_private] = ACTIONS(2775),
    [anon_sym_protected] = ACTIONS(2775),
    [anon_sym_override] = ACTIONS(2777),
    [anon_sym_module] = ACTIONS(2761),
    [anon_sym_any] = ACTIONS(2761),
    [anon_sym_number] = ACTIONS(2761),
    [anon_sym_boolean] = ACTIONS(2761),
    [anon_sym_string] = ACTIONS(2761),
    [anon_sym_symbol] = ACTIONS(2761),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [830] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2779),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [831] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2781),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [832] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [833] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3545),
    [sym_constructor_type] = STATE(3545),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3545),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3545),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3545),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [834] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3728),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2787),
    [anon_sym_namespace] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2793),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2795),
    [anon_sym_readonly] = ACTIONS(2797),
    [anon_sym_get] = ACTIONS(2799),
    [anon_sym_set] = ACTIONS(2799),
    [anon_sym_declare] = ACTIONS(2787),
    [anon_sym_public] = ACTIONS(2801),
    [anon_sym_private] = ACTIONS(2801),
    [anon_sym_protected] = ACTIONS(2801),
    [anon_sym_override] = ACTIONS(2803),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_any] = ACTIONS(2787),
    [anon_sym_number] = ACTIONS(2787),
    [anon_sym_boolean] = ACTIONS(2787),
    [anon_sym_string] = ACTIONS(2787),
    [anon_sym_symbol] = ACTIONS(2787),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [835] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3728),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2787),
    [anon_sym_namespace] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2793),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2795),
    [anon_sym_readonly] = ACTIONS(2797),
    [anon_sym_get] = ACTIONS(2799),
    [anon_sym_set] = ACTIONS(2799),
    [anon_sym_declare] = ACTIONS(2787),
    [anon_sym_public] = ACTIONS(2801),
    [anon_sym_private] = ACTIONS(2801),
    [anon_sym_protected] = ACTIONS(2801),
    [anon_sym_override] = ACTIONS(2803),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_any] = ACTIONS(2787),
    [anon_sym_number] = ACTIONS(2787),
    [anon_sym_boolean] = ACTIONS(2787),
    [anon_sym_string] = ACTIONS(2787),
    [anon_sym_symbol] = ACTIONS(2787),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [836] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3728),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2805),
    [anon_sym_export] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2809),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2811),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_readonly] = ACTIONS(2815),
    [anon_sym_get] = ACTIONS(2817),
    [anon_sym_set] = ACTIONS(2817),
    [anon_sym_declare] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2819),
    [anon_sym_private] = ACTIONS(2819),
    [anon_sym_protected] = ACTIONS(2819),
    [anon_sym_override] = ACTIONS(2821),
    [anon_sym_module] = ACTIONS(2805),
    [anon_sym_any] = ACTIONS(2805),
    [anon_sym_number] = ACTIONS(2805),
    [anon_sym_boolean] = ACTIONS(2805),
    [anon_sym_string] = ACTIONS(2805),
    [anon_sym_symbol] = ACTIONS(2805),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [837] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3728),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2809),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_declare] = ACTIONS(2655),
    [anon_sym_public] = ACTIONS(2687),
    [anon_sym_private] = ACTIONS(2687),
    [anon_sym_protected] = ACTIONS(2687),
    [anon_sym_override] = ACTIONS(2689),
    [anon_sym_module] = ACTIONS(2655),
    [anon_sym_any] = ACTIONS(2655),
    [anon_sym_number] = ACTIONS(2655),
    [anon_sym_boolean] = ACTIONS(2655),
    [anon_sym_string] = ACTIONS(2655),
    [anon_sym_symbol] = ACTIONS(2655),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [838] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2823),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [839] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [840] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3728),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2787),
    [anon_sym_namespace] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2793),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2795),
    [anon_sym_readonly] = ACTIONS(2797),
    [anon_sym_get] = ACTIONS(2799),
    [anon_sym_set] = ACTIONS(2799),
    [anon_sym_declare] = ACTIONS(2787),
    [anon_sym_public] = ACTIONS(2801),
    [anon_sym_private] = ACTIONS(2801),
    [anon_sym_protected] = ACTIONS(2801),
    [anon_sym_override] = ACTIONS(2803),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_any] = ACTIONS(2787),
    [anon_sym_number] = ACTIONS(2787),
    [anon_sym_boolean] = ACTIONS(2787),
    [anon_sym_string] = ACTIONS(2787),
    [anon_sym_symbol] = ACTIONS(2787),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [841] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2829),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [842] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [843] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [844] = {
    [sym_nested_identifier] = STATE(1333),
    [sym_string] = STATE(1331),
    [sym__module] = STATE(1461),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_RBRACE] = ACTIONS(122),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(122),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [845] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2835),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [846] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1671),
    [sym_constructor_type] = STATE(1671),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1671),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_predicate] = STATE(1670),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1560),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1671),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1671),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2863),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [847] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1820),
    [sym_constructor_type] = STATE(1820),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1820),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_predicate] = STATE(1818),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1560),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1820),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1820),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2863),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [848] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2650),
    [sym_constructor_type] = STATE(2650),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2650),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_predicate] = STATE(2653),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2573),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2650),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2650),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(2571),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [849] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2619),
    [sym_constructor_type] = STATE(2619),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2619),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_predicate] = STATE(2625),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2573),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2619),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2619),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(2571),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [850] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3707),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3707),
    [sym_pair] = STATE(3707),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3715),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2695),
    [anon_sym_export] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_get] = ACTIONS(2707),
    [anon_sym_set] = ACTIONS(2707),
    [anon_sym_declare] = ACTIONS(2695),
    [anon_sym_public] = ACTIONS(2709),
    [anon_sym_private] = ACTIONS(2709),
    [anon_sym_protected] = ACTIONS(2709),
    [anon_sym_override] = ACTIONS(2711),
    [anon_sym_module] = ACTIONS(2695),
    [anon_sym_any] = ACTIONS(2695),
    [anon_sym_number] = ACTIONS(2695),
    [anon_sym_boolean] = ACTIONS(2695),
    [anon_sym_string] = ACTIONS(2695),
    [anon_sym_symbol] = ACTIONS(2695),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [851] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [852] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3133),
    [sym_constructor_type] = STATE(3133),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3133),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_predicate] = STATE(2411),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2958),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3133),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3133),
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(2643),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [853] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1347),
    [sym_constructor_type] = STATE(1347),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1347),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_predicate] = STATE(1344),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1235),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1347),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1347),
    [sym_identifier] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2741),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [854] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [855] = {
    [sym_export_statement] = STATE(3113),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3728),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(3113),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(3113),
    [sym_property_signature] = STATE(3113),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(3113),
    [sym_index_signature] = STATE(3113),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_readonly] = ACTIONS(2683),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_declare] = ACTIONS(2655),
    [anon_sym_public] = ACTIONS(2687),
    [anon_sym_private] = ACTIONS(2687),
    [anon_sym_protected] = ACTIONS(2687),
    [anon_sym_override] = ACTIONS(2689),
    [anon_sym_module] = ACTIONS(2655),
    [anon_sym_any] = ACTIONS(2655),
    [anon_sym_number] = ACTIONS(2655),
    [anon_sym_boolean] = ACTIONS(2655),
    [anon_sym_string] = ACTIONS(2655),
    [anon_sym_symbol] = ACTIONS(2655),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2891),
  },
  [856] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2799),
    [sym_constructor_type] = STATE(2799),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2799),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_predicate] = STATE(2800),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2668),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2799),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2799),
    [sym_identifier] = ACTIONS(2575),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2605),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [857] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3539),
    [sym_constructor_type] = STATE(3539),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3539),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3539),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3539),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [858] = {
    [sym_export_statement] = STATE(2987),
    [sym_object_pattern] = STATE(4322),
    [sym_object_assignment_pattern] = STATE(3706),
    [sym_array_pattern] = STATE(4322),
    [sym__call_signature] = STATE(3182),
    [sym__destructuring_pattern] = STATE(4322),
    [sym_spread_element] = STATE(3728),
    [sym_string] = STATE(2539),
    [sym_decorator] = STATE(1171),
    [sym_formal_parameters] = STATE(2701),
    [sym_rest_pattern] = STATE(3706),
    [sym_method_definition] = STATE(3728),
    [sym_pair] = STATE(3728),
    [sym_pair_pattern] = STATE(3706),
    [sym__property_name] = STATE(2539),
    [sym_computed_property_name] = STATE(2539),
    [sym_method_signature] = STATE(2987),
    [sym_accessibility_modifier] = STATE(2278),
    [sym_override_modifier] = STATE(2310),
    [sym_call_signature] = STATE(2987),
    [sym_property_signature] = STATE(2987),
    [sym_type_parameters] = STATE(3934),
    [sym_construct_signature] = STATE(2987),
    [sym_index_signature] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(3562),
    [aux_sym_object_repeat1] = STATE(3614),
    [aux_sym_object_pattern_repeat1] = STATE(3717),
    [sym_identifier] = ACTIONS(2761),
    [anon_sym_export] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_type] = ACTIONS(2761),
    [anon_sym_namespace] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_async] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2771),
    [anon_sym_get] = ACTIONS(2773),
    [anon_sym_set] = ACTIONS(2773),
    [anon_sym_declare] = ACTIONS(2761),
    [anon_sym_public] = ACTIONS(2775),
    [anon_sym_private] = ACTIONS(2775),
    [anon_sym_protected] = ACTIONS(2775),
    [anon_sym_override] = ACTIONS(2777),
    [anon_sym_module] = ACTIONS(2761),
    [anon_sym_any] = ACTIONS(2761),
    [anon_sym_number] = ACTIONS(2761),
    [anon_sym_boolean] = ACTIONS(2761),
    [anon_sym_string] = ACTIONS(2761),
    [anon_sym_symbol] = ACTIONS(2761),
    [anon_sym_abstract] = ACTIONS(2691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2693),
  },
  [859] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3496),
    [sym_constructor_type] = STATE(3496),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3496),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3496),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3496),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [860] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [861] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2460),
    [sym_constructor_type] = STATE(2460),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2460),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_predicate] = STATE(2427),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2418),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2460),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2460),
    [sym_identifier] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(2625),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [862] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2470),
    [sym_constructor_type] = STATE(2470),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2470),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_predicate] = STATE(2411),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2418),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2470),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2470),
    [sym_identifier] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(2625),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [863] = {
    [sym_nested_identifier] = STATE(1333),
    [sym_string] = STATE(1331),
    [sym__module] = STATE(1461),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(150),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(2027),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [864] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3548),
    [sym_constructor_type] = STATE(3548),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3548),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3548),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3548),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [865] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2984),
    [sym_constructor_type] = STATE(2984),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2984),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2984),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2984),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [sym_jsx_identifier] = ACTIONS(2905),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [866] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2907),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [867] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3167),
    [sym_constructor_type] = STATE(3167),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3167),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3167),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3167),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [868] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3146),
    [sym_constructor_type] = STATE(3146),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3146),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3146),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3146),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [869] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3051),
    [sym_constructor_type] = STATE(3051),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3051),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3051),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3051),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [870] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1339),
    [sym_constructor_type] = STATE(1339),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1339),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1339),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1339),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [871] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(3246),
    [sym_constructor_type] = STATE(3246),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(3246),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(3246),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(3246),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [872] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3089),
    [sym_constructor_type] = STATE(3089),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3089),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3089),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3089),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [873] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3147),
    [sym_constructor_type] = STATE(3147),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3147),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3147),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3147),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [874] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3059),
    [sym_constructor_type] = STATE(3059),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3059),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3059),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3059),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [875] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3559),
    [sym_constructor_type] = STATE(3559),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3559),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3559),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3559),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [876] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1729),
    [sym_constructor_type] = STATE(1729),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1729),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1729),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1729),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [877] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2495),
    [sym_constructor_type] = STATE(2495),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2495),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2495),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2495),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [878] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2441),
    [sym_constructor_type] = STATE(2441),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2441),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2441),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2441),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [879] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3021),
    [sym_constructor_type] = STATE(3021),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3021),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3021),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3021),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [880] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2690),
    [sym_constructor_type] = STATE(2690),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2690),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2690),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2690),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [881] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3501),
    [sym_constructor_type] = STATE(3501),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3501),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3501),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3501),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [882] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2440),
    [sym_constructor_type] = STATE(2440),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2440),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2440),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2440),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [883] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3527),
    [sym_constructor_type] = STATE(3527),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3527),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3527),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3527),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [884] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2772),
    [sym_constructor_type] = STATE(2772),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2772),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2772),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2772),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [885] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2984),
    [sym_constructor_type] = STATE(2984),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2984),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2984),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2984),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [886] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(3664),
    [sym_constructor_type] = STATE(3664),
    [sym__primary_type] = STATE(1362),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(3664),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(3664),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(3664),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [887] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2510),
    [sym_constructor_type] = STATE(2510),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2510),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2510),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2510),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [888] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2814),
    [sym_constructor_type] = STATE(2814),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2814),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2814),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2814),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [889] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1732),
    [sym_constructor_type] = STATE(1732),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1732),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1732),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1732),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [890] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2815),
    [sym_constructor_type] = STATE(2815),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2815),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2815),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2815),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [891] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(3664),
    [sym_constructor_type] = STATE(3664),
    [sym__primary_type] = STATE(1349),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(3664),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(3664),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(3664),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [892] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1346),
    [sym_constructor_type] = STATE(1346),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1346),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1346),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1346),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [893] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2733),
    [sym_constructor_type] = STATE(2733),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2733),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2733),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2733),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [894] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2828),
    [sym_constructor_type] = STATE(2828),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2828),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2828),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2828),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [895] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(3237),
    [sym_constructor_type] = STATE(3237),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(3237),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(3237),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(3237),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [896] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2771),
    [sym_constructor_type] = STATE(2771),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2771),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2771),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2771),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [897] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1267),
    [sym_constructor_type] = STATE(1267),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1267),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1267),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1267),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [898] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1656),
    [sym_constructor_type] = STATE(1656),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1656),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1656),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1656),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [899] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3524),
    [sym_constructor_type] = STATE(3524),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3524),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3524),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3524),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [900] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1312),
    [sym_constructor_type] = STATE(1312),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1312),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1312),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1312),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [901] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(3247),
    [sym_constructor_type] = STATE(3247),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(3247),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(3247),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(3247),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [902] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2441),
    [sym_constructor_type] = STATE(2441),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2441),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2441),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2441),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [903] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3529),
    [sym_constructor_type] = STATE(3529),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3529),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3529),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3529),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [904] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2612),
    [sym_constructor_type] = STATE(2612),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2612),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2612),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2612),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [905] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2655),
    [sym_constructor_type] = STATE(2655),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2655),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2655),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2655),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [906] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1659),
    [sym_constructor_type] = STATE(1659),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1659),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1659),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1659),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [907] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1667),
    [sym_constructor_type] = STATE(1667),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1667),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1667),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1667),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [908] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2440),
    [sym_constructor_type] = STATE(2440),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2440),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2440),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2440),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [909] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1290),
    [sym_constructor_type] = STATE(1290),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1290),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1290),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1290),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [910] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1291),
    [sym_constructor_type] = STATE(1291),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1291),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1291),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1291),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [911] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1665),
    [sym_constructor_type] = STATE(1665),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1665),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1665),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1665),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [912] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2465),
    [sym_constructor_type] = STATE(2465),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2465),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2465),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2465),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [913] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1343),
    [sym_constructor_type] = STATE(1343),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1343),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1343),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1343),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [914] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3042),
    [sym_constructor_type] = STATE(3042),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3042),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3042),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3042),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [915] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2409),
    [sym_constructor_type] = STATE(2409),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2409),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2409),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2409),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [916] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1649),
    [sym_constructor_type] = STATE(1649),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1649),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1649),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1649),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [917] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3472),
    [sym_constructor_type] = STATE(3472),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3472),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3472),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3472),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [918] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3648),
    [sym_constructor_type] = STATE(3648),
    [sym__primary_type] = STATE(2433),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3648),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3648),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3648),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [919] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1308),
    [sym_constructor_type] = STATE(1308),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1308),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1308),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1308),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [920] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1661),
    [sym_constructor_type] = STATE(1661),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1661),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1661),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1661),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [921] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3149),
    [sym_constructor_type] = STATE(3149),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3149),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3149),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3149),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [922] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3473),
    [sym_constructor_type] = STATE(3473),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3473),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3473),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3473),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [923] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1263),
    [sym_constructor_type] = STATE(1263),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1263),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1263),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1263),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [924] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2830),
    [sym_constructor_type] = STATE(2830),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2830),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2830),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2830),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [925] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2652),
    [sym_constructor_type] = STATE(2652),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2652),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2652),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2652),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [926] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1310),
    [sym_constructor_type] = STATE(1310),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1310),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1310),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1310),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [927] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3573),
    [sym_constructor_type] = STATE(3573),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3573),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3573),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3573),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [928] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3143),
    [sym_constructor_type] = STATE(3143),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3143),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3143),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3143),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [929] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2850),
    [sym_constructor_type] = STATE(2850),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2850),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2850),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2850),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [930] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3648),
    [sym_constructor_type] = STATE(3648),
    [sym__primary_type] = STATE(2431),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3648),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3648),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3648),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [931] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2847),
    [sym_constructor_type] = STATE(2847),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2847),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2847),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2847),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [932] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2654),
    [sym_constructor_type] = STATE(2654),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2654),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2654),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2654),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [933] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(3832),
    [sym_constructor_type] = STATE(3832),
    [sym__primary_type] = STATE(2634),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(3832),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(3832),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(3832),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [934] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2464),
    [sym_constructor_type] = STATE(2464),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2464),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2464),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2464),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [935] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3552),
    [sym_constructor_type] = STATE(3552),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3552),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3552),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3552),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [936] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3574),
    [sym_constructor_type] = STATE(3574),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3574),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3574),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3574),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [937] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3551),
    [sym_constructor_type] = STATE(3551),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3551),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3551),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3551),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [938] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3456),
    [sym_constructor_type] = STATE(3456),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3456),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3456),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3456),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [939] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1812),
    [sym_constructor_type] = STATE(1812),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1812),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1812),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1812),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [940] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2633),
    [sym_constructor_type] = STATE(2633),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2633),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2633),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2633),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [941] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2795),
    [sym_constructor_type] = STATE(2795),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2795),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2795),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2795),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [942] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(3832),
    [sym_constructor_type] = STATE(3832),
    [sym__primary_type] = STATE(2638),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(3832),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(3832),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(3832),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [943] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2632),
    [sym_constructor_type] = STATE(2632),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2632),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2632),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2632),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [944] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2412),
    [sym_constructor_type] = STATE(2412),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2412),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2412),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2412),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [945] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3513),
    [sym_constructor_type] = STATE(3513),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3513),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3513),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3513),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [946] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2409),
    [sym_constructor_type] = STATE(2409),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2409),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2409),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2409),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [947] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1719),
    [sym_constructor_type] = STATE(1719),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1719),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1719),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1719),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [948] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1718),
    [sym_constructor_type] = STATE(1718),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1718),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1718),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1718),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [949] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3127),
    [sym_constructor_type] = STATE(3127),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3127),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3127),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3127),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [950] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2423),
    [sym_constructor_type] = STATE(2423),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2423),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2423),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2423),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [951] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3553),
    [sym_constructor_type] = STATE(3553),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3553),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3553),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3553),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [952] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(3605),
    [sym_constructor_type] = STATE(3605),
    [sym__primary_type] = STATE(2748),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(3605),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(3605),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(3605),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [953] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(3445),
    [sym_constructor_type] = STATE(3445),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(3445),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(3445),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(3445),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [954] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2639),
    [sym_constructor_type] = STATE(2639),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2639),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2639),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2639),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [955] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(3605),
    [sym_constructor_type] = STATE(3605),
    [sym__primary_type] = STATE(2746),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(3605),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(3605),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(3605),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [956] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2659),
    [sym_constructor_type] = STATE(2659),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2659),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2659),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2659),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [957] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1702),
    [sym_constructor_type] = STATE(1702),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1702),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1702),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1702),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [958] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2416),
    [sym_constructor_type] = STATE(2416),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2416),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2416),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2416),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [959] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(3822),
    [sym_constructor_type] = STATE(3822),
    [sym__primary_type] = STATE(1700),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(3822),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(3822),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(3822),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [960] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2745),
    [sym_constructor_type] = STATE(2745),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2745),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2745),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2745),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [961] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3013),
    [sym_constructor_type] = STATE(3013),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3013),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3013),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3013),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [962] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2661),
    [sym_constructor_type] = STATE(2661),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2661),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2661),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2661),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [963] = {
    [sym_nested_identifier] = STATE(1333),
    [sym_string] = STATE(1331),
    [sym__module] = STATE(1461),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_RPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [964] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4185),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3012),
    [sym_constructor_type] = STATE(3012),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3012),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(4077),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3012),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3012),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [965] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2643),
    [sym_constructor_type] = STATE(2643),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2643),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2643),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2643),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [966] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3811),
    [sym_constructor_type] = STATE(3811),
    [sym__primary_type] = STATE(2433),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3811),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3811),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3811),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [967] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2644),
    [sym_constructor_type] = STATE(2644),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2644),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2644),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2644),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [968] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3648),
    [sym_constructor_type] = STATE(3648),
    [sym__primary_type] = STATE(3356),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3500),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3648),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3648),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [969] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(3822),
    [sym_constructor_type] = STATE(3822),
    [sym__primary_type] = STATE(1697),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(3822),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(3822),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(3822),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [970] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3811),
    [sym_constructor_type] = STATE(3811),
    [sym__primary_type] = STATE(2431),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3811),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3811),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3811),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2653),
  },
  [971] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2412),
    [sym_constructor_type] = STATE(2412),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2412),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2412),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2412),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [972] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2741),
    [sym_constructor_type] = STATE(2741),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2741),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2741),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2741),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [973] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1376),
    [sym_constructor_type] = STATE(1376),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1376),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1376),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1376),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [974] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(3406),
    [sym_constructor_type] = STATE(3406),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(3406),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(3406),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(3406),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [975] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1258),
    [sym_constructor_type] = STATE(1258),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1258),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1258),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1258),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [976] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1808),
    [sym_constructor_type] = STATE(1808),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1808),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1808),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1808),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [977] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2740),
    [sym_constructor_type] = STATE(2740),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2740),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2740),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2740),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [978] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1352),
    [sym_constructor_type] = STATE(1352),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1352),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1352),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1352),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [979] = {
    [sym_nested_identifier] = STATE(4123),
    [sym_string] = STATE(1265),
    [sym_formal_parameters] = STATE(4323),
    [sym_nested_type_identifier] = STATE(1239),
    [sym__type] = STATE(1311),
    [sym_constructor_type] = STATE(1311),
    [sym__primary_type] = STATE(1261),
    [sym_template_literal_type] = STATE(1260),
    [sym_infer_type] = STATE(1311),
    [sym_conditional_type] = STATE(1260),
    [sym_generic_type] = STATE(1260),
    [sym_type_query] = STATE(1260),
    [sym_index_type_query] = STATE(1260),
    [sym_lookup_type] = STATE(1260),
    [sym_literal_type] = STATE(1260),
    [sym__number] = STATE(1259),
    [sym_existential_type] = STATE(1260),
    [sym_flow_maybe_type] = STATE(1260),
    [sym_parenthesized_type] = STATE(1260),
    [sym_predefined_type] = STATE(1260),
    [sym_object_type] = STATE(1260),
    [sym_type_parameters] = STATE(4081),
    [sym_array_type] = STATE(1260),
    [sym_tuple_type] = STATE(1260),
    [sym_readonly_type] = STATE(1311),
    [sym_union_type] = STATE(1260),
    [sym_intersection_type] = STATE(1260),
    [sym_function_type] = STATE(1311),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_void] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_number] = ACTIONS(2739),
    [sym_this] = ACTIONS(2911),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_null] = ACTIONS(2743),
    [sym_undefined] = ACTIONS(2743),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_QMARK] = ACTIONS(2747),
    [anon_sym_any] = ACTIONS(2735),
    [anon_sym_number] = ACTIONS(2735),
    [anon_sym_boolean] = ACTIONS(2735),
    [anon_sym_string] = ACTIONS(2735),
    [anon_sym_symbol] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_infer] = ACTIONS(2751),
    [anon_sym_keyof] = ACTIONS(2753),
    [anon_sym_unknown] = ACTIONS(2735),
    [anon_sym_never] = ACTIONS(2735),
    [anon_sym_object] = ACTIONS(2735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2755),
  },
  [980] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [981] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2423),
    [sym_constructor_type] = STATE(2423),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2423),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2423),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2423),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [982] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2458),
    [sym_constructor_type] = STATE(2458),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2458),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2458),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2458),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [983] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3446),
    [sym_constructor_type] = STATE(3446),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3446),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3446),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3446),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [984] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3115),
    [sym_constructor_type] = STATE(3115),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3115),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3115),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3115),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [985] = {
    [sym_nested_identifier] = STATE(1333),
    [sym_string] = STATE(1331),
    [sym__module] = STATE(1461),
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_EQ] = ACTIONS(1228),
    [anon_sym_as] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(152),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_BANG] = ACTIONS(116),
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_RPAREN] = ACTIONS(152),
    [anon_sym_in] = ACTIONS(116),
    [anon_sym_COLON] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_RBRACK] = ACTIONS(152),
    [anon_sym_LT] = ACTIONS(116),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_SLASH] = ACTIONS(116),
    [anon_sym_DOT] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(213),
    [anon_sym_QMARK_DOT] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(156),
    [anon_sym_DASH_EQ] = ACTIONS(156),
    [anon_sym_STAR_EQ] = ACTIONS(156),
    [anon_sym_SLASH_EQ] = ACTIONS(156),
    [anon_sym_PERCENT_EQ] = ACTIONS(156),
    [anon_sym_CARET_EQ] = ACTIONS(156),
    [anon_sym_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(156),
    [anon_sym_LT_LT_EQ] = ACTIONS(156),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(156),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(116),
    [anon_sym_PIPE_PIPE] = ACTIONS(116),
    [anon_sym_GT_GT] = ACTIONS(116),
    [anon_sym_GT_GT_GT] = ACTIONS(116),
    [anon_sym_LT_LT] = ACTIONS(116),
    [anon_sym_AMP] = ACTIONS(116),
    [anon_sym_CARET] = ACTIONS(116),
    [anon_sym_PIPE] = ACTIONS(116),
    [anon_sym_PLUS] = ACTIONS(116),
    [anon_sym_DASH] = ACTIONS(116),
    [anon_sym_PERCENT] = ACTIONS(116),
    [anon_sym_STAR_STAR] = ACTIONS(116),
    [anon_sym_LT_EQ] = ACTIONS(152),
    [anon_sym_EQ_EQ] = ACTIONS(116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(152),
    [anon_sym_BANG_EQ] = ACTIONS(116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(152),
    [anon_sym_GT_EQ] = ACTIONS(152),
    [anon_sym_QMARK_QMARK] = ACTIONS(116),
    [anon_sym_instanceof] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(152),
    [anon_sym_DASH_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_satisfies] = ACTIONS(116),
    [sym__ternary_qmark] = ACTIONS(152),
  },
  [986] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3072),
    [sym_constructor_type] = STATE(3072),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3072),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3072),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3072),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [987] = {
    [sym_nested_identifier] = STATE(4186),
    [sym_string] = STATE(1796),
    [sym_formal_parameters] = STATE(4471),
    [sym_nested_type_identifier] = STATE(1576),
    [sym__type] = STATE(1815),
    [sym_constructor_type] = STATE(1815),
    [sym__primary_type] = STATE(1790),
    [sym_template_literal_type] = STATE(1789),
    [sym_infer_type] = STATE(1815),
    [sym_conditional_type] = STATE(1789),
    [sym_generic_type] = STATE(1789),
    [sym_type_query] = STATE(1789),
    [sym_index_type_query] = STATE(1789),
    [sym_lookup_type] = STATE(1789),
    [sym_literal_type] = STATE(1789),
    [sym__number] = STATE(1784),
    [sym_existential_type] = STATE(1789),
    [sym_flow_maybe_type] = STATE(1789),
    [sym_parenthesized_type] = STATE(1789),
    [sym_predefined_type] = STATE(1789),
    [sym_object_type] = STATE(1789),
    [sym_type_parameters] = STATE(3866),
    [sym_array_type] = STATE(1789),
    [sym_tuple_type] = STATE(1789),
    [sym_readonly_type] = STATE(1815),
    [sym_union_type] = STATE(1789),
    [sym_intersection_type] = STATE(1789),
    [sym_function_type] = STATE(1815),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2861),
    [sym_this] = ACTIONS(2915),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_infer] = ACTIONS(2873),
    [anon_sym_keyof] = ACTIONS(2875),
    [anon_sym_unknown] = ACTIONS(2857),
    [anon_sym_never] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2877),
  },
  [988] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(3191),
    [sym_constructor_type] = STATE(3191),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(3191),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(3191),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(3191),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
  [989] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3577),
    [sym_constructor_type] = STATE(3577),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3577),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3577),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3577),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [990] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3493),
    [sym_constructor_type] = STATE(3493),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3493),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3493),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3493),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [991] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3489),
    [sym_constructor_type] = STATE(3489),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3489),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3489),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3489),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [992] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2838),
    [sym_constructor_type] = STATE(2838),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2838),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2838),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2838),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [993] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3566),
    [sym_constructor_type] = STATE(3566),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3566),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3566),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3566),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [994] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2712),
    [sym_formal_parameters] = STATE(4275),
    [sym_nested_type_identifier] = STATE(2615),
    [sym__type] = STATE(2750),
    [sym_constructor_type] = STATE(2750),
    [sym__primary_type] = STATE(2718),
    [sym_template_literal_type] = STATE(2719),
    [sym_infer_type] = STATE(2750),
    [sym_conditional_type] = STATE(2719),
    [sym_generic_type] = STATE(2719),
    [sym_type_query] = STATE(2719),
    [sym_index_type_query] = STATE(2719),
    [sym_lookup_type] = STATE(2719),
    [sym_literal_type] = STATE(2719),
    [sym__number] = STATE(2720),
    [sym_existential_type] = STATE(2719),
    [sym_flow_maybe_type] = STATE(2719),
    [sym_parenthesized_type] = STATE(2719),
    [sym_predefined_type] = STATE(2719),
    [sym_object_type] = STATE(2719),
    [sym_type_parameters] = STATE(3863),
    [sym_array_type] = STATE(2719),
    [sym_tuple_type] = STATE(2719),
    [sym_readonly_type] = STATE(2750),
    [sym_union_type] = STATE(2719),
    [sym_intersection_type] = STATE(2719),
    [sym_function_type] = STATE(2750),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_void] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2597),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2601),
    [sym_number] = ACTIONS(2603),
    [sym_this] = ACTIONS(2919),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2609),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2595),
    [anon_sym_number] = ACTIONS(2595),
    [anon_sym_boolean] = ACTIONS(2595),
    [anon_sym_string] = ACTIONS(2595),
    [anon_sym_symbol] = ACTIONS(2595),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_infer] = ACTIONS(2617),
    [anon_sym_keyof] = ACTIONS(2619),
    [anon_sym_unknown] = ACTIONS(2595),
    [anon_sym_never] = ACTIONS(2595),
    [anon_sym_object] = ACTIONS(2595),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2621),
  },
  [995] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2487),
    [sym_constructor_type] = STATE(2487),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2487),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2487),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2487),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [996] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(3087),
    [sym_constructor_type] = STATE(3087),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(3087),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(3087),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(3087),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [997] = {
    [sym_nested_identifier] = STATE(4216),
    [sym_string] = STATE(2436),
    [sym_formal_parameters] = STATE(4214),
    [sym_nested_type_identifier] = STATE(2399),
    [sym__type] = STATE(2416),
    [sym_constructor_type] = STATE(2416),
    [sym__primary_type] = STATE(2443),
    [sym_template_literal_type] = STATE(2445),
    [sym_infer_type] = STATE(2416),
    [sym_conditional_type] = STATE(2445),
    [sym_generic_type] = STATE(2445),
    [sym_type_query] = STATE(2445),
    [sym_index_type_query] = STATE(2445),
    [sym_lookup_type] = STATE(2445),
    [sym_literal_type] = STATE(2445),
    [sym__number] = STATE(2421),
    [sym_existential_type] = STATE(2445),
    [sym_flow_maybe_type] = STATE(2445),
    [sym_parenthesized_type] = STATE(2445),
    [sym_predefined_type] = STATE(2445),
    [sym_object_type] = STATE(2445),
    [sym_type_parameters] = STATE(3981),
    [sym_array_type] = STATE(2445),
    [sym_tuple_type] = STATE(2445),
    [sym_readonly_type] = STATE(2416),
    [sym_union_type] = STATE(2445),
    [sym_intersection_type] = STATE(2445),
    [sym_function_type] = STATE(2416),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_this] = ACTIONS(1252),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_null] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1256),
    [anon_sym_QMARK] = ACTIONS(616),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(197),
    [anon_sym_infer] = ACTIONS(199),
    [anon_sym_keyof] = ACTIONS(201),
    [anon_sym_unknown] = ACTIONS(203),
    [anon_sym_never] = ACTIONS(203),
    [anon_sym_object] = ACTIONS(203),
    [anon_sym_LBRACE_PIPE] = ACTIONS(205),
  },
  [998] = {
    [sym_nested_identifier] = STATE(4140),
    [sym_string] = STATE(2666),
    [sym_formal_parameters] = STATE(4357),
    [sym_nested_type_identifier] = STATE(2536),
    [sym__type] = STATE(2628),
    [sym_constructor_type] = STATE(2628),
    [sym__primary_type] = STATE(2662),
    [sym_template_literal_type] = STATE(2613),
    [sym_infer_type] = STATE(2628),
    [sym_conditional_type] = STATE(2613),
    [sym_generic_type] = STATE(2613),
    [sym_type_query] = STATE(2613),
    [sym_index_type_query] = STATE(2613),
    [sym_lookup_type] = STATE(2613),
    [sym_literal_type] = STATE(2613),
    [sym__number] = STATE(2660),
    [sym_existential_type] = STATE(2613),
    [sym_flow_maybe_type] = STATE(2613),
    [sym_parenthesized_type] = STATE(2613),
    [sym_predefined_type] = STATE(2613),
    [sym_object_type] = STATE(2613),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(2613),
    [sym_tuple_type] = STATE(2613),
    [sym_readonly_type] = STATE(2628),
    [sym_union_type] = STATE(2613),
    [sym_intersection_type] = STATE(2613),
    [sym_function_type] = STATE(2628),
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_void] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [sym_null] = ACTIONS(1313),
    [sym_undefined] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(752),
    [anon_sym_any] = ACTIONS(762),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(756),
    [anon_sym_infer] = ACTIONS(758),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(762),
    [anon_sym_never] = ACTIONS(762),
    [anon_sym_object] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [89] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_EQ,
    ACTIONS(1273), 1,
      anon_sym_COLON,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(1270), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(152), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [182] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1258), 1,
      anon_sym_EQ,
    ACTIONS(1260), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_nested_identifier,
    STATE(1244), 1,
      sym_string,
    STATE(1383), 1,
      sym__module,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [271] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1919), 1,
      anon_sym_COLON,
    ACTIONS(2559), 1,
      sym_identifier,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2563), 1,
      anon_sym_SQUOTE,
    STATE(152), 1,
      sym_nested_identifier,
    STATE(153), 1,
      sym_string,
    STATE(184), 1,
      sym__module,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [362] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1917), 1,
      anon_sym_COLON,
    ACTIONS(2565), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(631), 1,
      sym_string,
    STATE(653), 1,
      sym__module,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [453] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1909), 1,
      anon_sym_COLON,
    ACTIONS(2921), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_nested_identifier,
    STATE(1244), 1,
      sym_string,
    STATE(1383), 1,
      sym__module,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [544] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1917), 1,
      anon_sym_COLON,
    ACTIONS(2921), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_nested_identifier,
    STATE(1244), 1,
      sym_string,
    STATE(1383), 1,
      sym__module,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [635] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(2037), 1,
      anon_sym_in,
    ACTIONS(2040), 1,
      anon_sym_of,
    ACTIONS(2921), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_nested_identifier,
    STATE(1244), 1,
      sym_string,
    STATE(1383), 1,
      sym__module,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [728] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_nested_identifier,
    STATE(1244), 1,
      sym_string,
    STATE(1383), 1,
      sym__module,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [817] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1909), 1,
      anon_sym_COLON,
    ACTIONS(2923), 1,
      sym_identifier,
    STATE(631), 1,
      sym_string,
    STATE(653), 1,
      sym__module,
    STATE(3508), 1,
      sym_nested_identifier,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [908] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1260), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [997] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1919), 1,
      anon_sym_COLON,
    ACTIONS(2565), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(631), 1,
      sym_string,
    STATE(653), 1,
      sym__module,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1088] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1844), 1,
      anon_sym_LPAREN,
    ACTIONS(1847), 1,
      anon_sym_COLON,
    ACTIONS(1850), 1,
      anon_sym_LT,
    ACTIONS(1859), 1,
      anon_sym_QMARK,
    ACTIONS(1889), 1,
      anon_sym_RBRACE,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(2925), 1,
      sym_identifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1180] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1281), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 14,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [1268] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(1844), 1,
      anon_sym_LPAREN,
    ACTIONS(1847), 1,
      anon_sym_COLON,
    ACTIONS(1850), 1,
      anon_sym_LT,
    ACTIONS(1859), 1,
      anon_sym_QMARK,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(2925), 1,
      sym_identifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1360] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1448] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1266), 1,
      anon_sym_EQ,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1536] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1844), 1,
      anon_sym_LPAREN,
    ACTIONS(1847), 1,
      anon_sym_COLON,
    ACTIONS(1850), 1,
      anon_sym_LT,
    ACTIONS(1859), 1,
      anon_sym_QMARK,
    ACTIONS(1891), 1,
      anon_sym_RBRACE,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(2925), 1,
      sym_identifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1628] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(122), 1,
      anon_sym_COMMA,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      anon_sym_RBRACK,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(2064), 1,
      anon_sym_EQ,
    ACTIONS(2067), 1,
      anon_sym_COLON,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1722] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1279), 1,
      anon_sym_EQ,
    ACTIONS(1281), 1,
      anon_sym_EQ_GT,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 14,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [1810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2929), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [1879] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(1847), 1,
      anon_sym_COLON,
    ACTIONS(1859), 1,
      anon_sym_QMARK,
    ACTIONS(2933), 1,
      anon_sym_EQ,
    ACTIONS(2937), 1,
      anon_sym_LPAREN,
    ACTIONS(2940), 1,
      anon_sym_LT,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1968] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2055] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(2559), 1,
      sym_identifier,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE,
    ACTIONS(2563), 1,
      anon_sym_SQUOTE,
    STATE(152), 1,
      sym_nested_identifier,
    STATE(153), 1,
      sym_string,
    STATE(184), 1,
      sym__module,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2142] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_COLON,
    ACTIONS(1859), 1,
      anon_sym_QMARK,
    ACTIONS(1889), 1,
      anon_sym_RBRACE,
    ACTIONS(2933), 1,
      anon_sym_EQ,
    ACTIONS(2937), 1,
      anon_sym_LPAREN,
    ACTIONS(2940), 1,
      anon_sym_LT,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2231] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1844), 1,
      anon_sym_LPAREN,
    ACTIONS(1847), 1,
      anon_sym_COLON,
    ACTIONS(1850), 1,
      anon_sym_LT,
    ACTIONS(1859), 1,
      anon_sym_QMARK,
    ACTIONS(1891), 1,
      anon_sym_RBRACE,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2320] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(233), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2659), 1,
      anon_sym_STAR,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2671), 1,
      anon_sym_LBRACK,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(2949), 1,
      anon_sym_export,
    ACTIONS(2954), 1,
      anon_sym_async,
    ACTIONS(2956), 1,
      anon_sym_static,
    ACTIONS(2958), 1,
      anon_sym_readonly,
    ACTIONS(2964), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2278), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(2679), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2951), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2960), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2962), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2539), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4016), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4017), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3008), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2947), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2453] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2966), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_nested_identifier,
    STATE(2897), 1,
      sym_string,
    STATE(3324), 1,
      sym__module,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2540] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(233), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2659), 1,
      anon_sym_STAR,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2671), 1,
      anon_sym_LBRACK,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(2949), 1,
      anon_sym_export,
    ACTIONS(2954), 1,
      anon_sym_async,
    ACTIONS(2956), 1,
      anon_sym_static,
    ACTIONS(2958), 1,
      anon_sym_readonly,
    ACTIONS(2964), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2278), 1,
      sym_accessibility_modifier,
    STATE(2310), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(2679), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2951), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2960), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2962), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2539), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4016), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4017), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3110), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2947), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2968), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2970), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2742] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_nested_identifier,
    STATE(1244), 1,
      sym_string,
    STATE(1383), 1,
      sym__module,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2972), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2974), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2978), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2967] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1266), 1,
      anon_sym_EQ,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(2067), 1,
      anon_sym_COLON,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3056] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(2923), 1,
      sym_identifier,
    STATE(631), 1,
      sym_string,
    STATE(653), 1,
      sym__module,
    STATE(3508), 1,
      sym_nested_identifier,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3143] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1266), 1,
      anon_sym_EQ,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(2077), 1,
      anon_sym_COLON,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3232] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_COLON,
    ACTIONS(1859), 1,
      anon_sym_QMARK,
    ACTIONS(1891), 1,
      anon_sym_RBRACE,
    ACTIONS(2933), 1,
      anon_sym_EQ,
    ACTIONS(2937), 1,
      anon_sym_LPAREN,
    ACTIONS(2940), 1,
      anon_sym_LT,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2980), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2982), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [3390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2986), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [3459] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(2565), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(631), 1,
      sym_string,
    STATE(653), 1,
      sym__module,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2990), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [3615] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(1844), 1,
      anon_sym_LPAREN,
    ACTIONS(1847), 1,
      anon_sym_COLON,
    ACTIONS(1850), 1,
      anon_sym_LT,
    ACTIONS(1859), 1,
      anon_sym_QMARK,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3704] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1844), 1,
      anon_sym_LPAREN,
    ACTIONS(1847), 1,
      anon_sym_COLON,
    ACTIONS(1850), 1,
      anon_sym_LT,
    ACTIONS(1859), 1,
      anon_sym_QMARK,
    ACTIONS(1889), 1,
      anon_sym_RBRACE,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3793] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(122), 1,
      anon_sym_COMMA,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      anon_sym_RBRACK,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(2064), 1,
      anon_sym_EQ,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2525), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [3952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [4024] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3010), 1,
      anon_sym_extends,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(2996), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3002), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2935), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [4110] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2037), 1,
      anon_sym_in,
    ACTIONS(2040), 1,
      anon_sym_of,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [4200] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3012), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3016), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4286] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1321), 1,
      anon_sym_EQ,
    ACTIONS(1323), 1,
      anon_sym_EQ_GT,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [4372] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1273), 1,
      anon_sym_COLON,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [4460] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(1323), 1,
      anon_sym_EQ_GT,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [4546] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3010), 1,
      anon_sym_extends,
    ACTIONS(3022), 1,
      anon_sym_EQ,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    ACTIONS(3031), 1,
      anon_sym_QMARK,
    STATE(2429), 1,
      sym_type_arguments,
    STATE(3899), 1,
      sym_type_annotation,
    ACTIONS(3002), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2935), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4640] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3036), 1,
      anon_sym_DOT,
    ACTIONS(3038), 1,
      anon_sym_QMARK_DOT,
    STATE(2543), 1,
      sym_arguments,
    ACTIONS(3016), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3012), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2935), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2545), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [4794] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3022), 1,
      anon_sym_EQ,
    ACTIONS(3040), 1,
      anon_sym_LT,
    ACTIONS(3043), 1,
      anon_sym_DOT,
    STATE(2640), 1,
      sym_type_arguments,
    ACTIONS(3002), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3010), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2935), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4882] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_EQ,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(122), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4959] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2027), 1,
      anon_sym_QMARK,
    ACTIONS(1273), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5036] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3010), 1,
      anon_sym_extends,
    ACTIONS(3022), 1,
      anon_sym_EQ,
    ACTIONS(3025), 1,
      anon_sym_RPAREN,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3002), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3046), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2935), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5127] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3010), 1,
      anon_sym_extends,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(2996), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3002), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5212] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3012), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3016), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5297] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_string,
    STATE(1333), 1,
      sym_nested_identifier,
    STATE(1461), 1,
      sym__module,
    ACTIONS(152), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [5382] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3053), 1,
      anon_sym_EQ,
    ACTIONS(3055), 1,
      anon_sym_EQ_GT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3012), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3016), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5467] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3059), 1,
      anon_sym_EQ_GT,
    ACTIONS(3061), 1,
      anon_sym_QMARK,
    ACTIONS(3057), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5544] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3010), 1,
      anon_sym_extends,
    ACTIONS(3063), 1,
      anon_sym_EQ,
    ACTIONS(3065), 1,
      anon_sym_EQ_GT,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(2996), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3002), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5629] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_EQ,
    ACTIONS(1381), 1,
      anon_sym_extends,
    ACTIONS(3067), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3070), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(152), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [5708] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3016), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3012), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2935), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5793] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_EQ,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(210), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5870] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3053), 1,
      anon_sym_EQ,
    ACTIONS(3055), 1,
      anon_sym_EQ_GT,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3010), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3002), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5955] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3022), 1,
      anon_sym_EQ,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3046), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6032] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3059), 1,
      anon_sym_EQ_GT,
    ACTIONS(3073), 1,
      anon_sym_EQ,
    ACTIONS(3076), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6109] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3010), 1,
      anon_sym_extends,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3059), 1,
      anon_sym_EQ_GT,
    ACTIONS(3073), 1,
      anon_sym_EQ,
    ACTIONS(3078), 1,
      anon_sym_RPAREN,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3002), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3076), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2935), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6200] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3063), 1,
      anon_sym_EQ,
    ACTIONS(3065), 1,
      anon_sym_EQ_GT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3012), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3016), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6285] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_EQ,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3070), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1381), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(152), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6364] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1381), 1,
      anon_sym_extends,
    ACTIONS(3067), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3070), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6442] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6514] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_EQ,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6586] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1919), 1,
      anon_sym_COLON,
    ACTIONS(2925), 1,
      sym_identifier,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [6662] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_EQ,
    ACTIONS(3083), 1,
      anon_sym_EQ_GT,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3010), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3002), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6746] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 1,
      anon_sym_EQ,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3046), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6820] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_COLON,
    ACTIONS(3059), 1,
      anon_sym_EQ_GT,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3002), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3010), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2935), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6906] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_EQ,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1381), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3070), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(152), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6988] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3085), 1,
      anon_sym_EQ,
    ACTIONS(3087), 1,
      anon_sym_EQ_GT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3012), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3016), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7072] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3081), 1,
      anon_sym_EQ,
    ACTIONS(3083), 1,
      anon_sym_EQ_GT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3012), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3016), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7156] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3061), 1,
      anon_sym_QMARK,
    ACTIONS(3057), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7230] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3073), 1,
      anon_sym_EQ,
    ACTIONS(3076), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7304] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3016), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(3012), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2935), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7388] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_EQ,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(122), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1381), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3070), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(152), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7470] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_EQ,
    ACTIONS(1260), 1,
      anon_sym_EQ_GT,
    ACTIONS(1381), 1,
      anon_sym_extends,
    ACTIONS(3067), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3070), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7620] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3010), 1,
      anon_sym_extends,
    ACTIONS(3057), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3002), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3089), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2935), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7708] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7780] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1917), 1,
      anon_sym_COLON,
    ACTIONS(2925), 1,
      sym_identifier,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [7856] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3010), 1,
      anon_sym_extends,
    ACTIONS(3085), 1,
      anon_sym_EQ,
    ACTIONS(3087), 1,
      anon_sym_EQ_GT,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(2996), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3002), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7940] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1909), 1,
      anon_sym_COLON,
    ACTIONS(2925), 1,
      sym_identifier,
    ACTIONS(152), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [8016] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 1,
      anon_sym_EQ,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(1381), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3070), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2525), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [8159] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 1,
      anon_sym_COLON,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8232] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    ACTIONS(3093), 1,
      anon_sym_in,
    ACTIONS(3096), 1,
      anon_sym_of,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8307] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8378] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1919), 1,
      anon_sym_COLON,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8451] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_EQ,
    ACTIONS(3065), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8522] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8591] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8660] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3010), 1,
      anon_sym_extends,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(2996), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3002), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8743] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3098), 1,
      anon_sym_EQ,
    ACTIONS(3100), 1,
      anon_sym_EQ_GT,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3010), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3002), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8826] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(1381), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3070), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8903] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(2037), 1,
      anon_sym_in,
    ACTIONS(3102), 1,
      anon_sym_of,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8978] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(1273), 1,
      anon_sym_COLON,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3070), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1381), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(152), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9057] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_EQ,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(1383), 1,
      anon_sym_QMARK,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3070), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1381), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(152), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9136] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2968), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2970), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9272] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1909), 1,
      anon_sym_COLON,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9345] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_EQ,
    ACTIONS(1273), 1,
      anon_sym_COLON,
    ACTIONS(1381), 1,
      anon_sym_extends,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3070), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3104), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(152), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2929), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2990), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9556] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_EQ,
    ACTIONS(1281), 1,
      anon_sym_EQ_GT,
    ACTIONS(1381), 1,
      anon_sym_extends,
    ACTIONS(3067), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3070), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(116), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9633] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2980), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2982), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2986), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9905] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1917), 1,
      anon_sym_COLON,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2545), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [10043] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3065), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10114] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_COLON,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2972), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2974), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [10252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2978), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [10388] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_EQ,
    ACTIONS(1273), 1,
      anon_sym_COLON,
    ACTIONS(1270), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10463] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1919), 1,
      anon_sym_COLON,
    ACTIONS(2943), 1,
      anon_sym_EQ_GT,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10536] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3098), 1,
      anon_sym_EQ,
    ACTIONS(3100), 1,
      anon_sym_EQ_GT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3012), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3016), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10619] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3059), 1,
      anon_sym_EQ_GT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3016), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3012), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2935), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_EQ,
    ACTIONS(1260), 1,
      anon_sym_EQ_GT,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10773] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 1,
      anon_sym_EQ,
    ACTIONS(3087), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10843] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3087), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10913] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_RBRACK,
    ACTIONS(3055), 1,
      anon_sym_EQ_GT,
    ACTIONS(3076), 1,
      anon_sym_COMMA,
    ACTIONS(3108), 1,
      anon_sym_EQ,
    ACTIONS(3111), 1,
      anon_sym_in,
    ACTIONS(3113), 1,
      anon_sym_COLON,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10991] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_EQ,
    ACTIONS(1381), 1,
      anon_sym_extends,
    ACTIONS(3067), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3070), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11067] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_EQ,
    ACTIONS(1281), 1,
      anon_sym_EQ_GT,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11137] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3059), 1,
      anon_sym_EQ_GT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3016), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3012), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2935), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11219] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(122), 1,
      anon_sym_COMMA,
    ACTIONS(210), 1,
      anon_sym_RBRACK,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(2064), 1,
      anon_sym_EQ,
    ACTIONS(2067), 1,
      anon_sym_COLON,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11363] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_EQ,
    ACTIONS(3055), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11433] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3059), 1,
      anon_sym_EQ_GT,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3010), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3002), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11515] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11585] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3119), 1,
      anon_sym_DOT,
    STATE(1179), 1,
      sym_arguments,
    ACTIONS(3117), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3115), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [11655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1281), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11725] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3008), 1,
      anon_sym_EQ_GT,
    ACTIONS(3121), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11797] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 1,
      anon_sym_EQ,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11867] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3055), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11937] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1321), 1,
      anon_sym_EQ,
    ACTIONS(1323), 1,
      anon_sym_EQ_GT,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(1381), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3070), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12013] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(3124), 1,
      sym_identifier,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [12085] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3057), 1,
      anon_sym_COLON,
    ACTIONS(3121), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12157] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_AT,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
    ACTIONS(3128), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3126), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [12227] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12295] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3059), 1,
      anon_sym_EQ_GT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3012), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3016), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2935), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12377] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    ACTIONS(3093), 1,
      anon_sym_in,
    ACTIONS(3096), 1,
      anon_sym_of,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12449] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(2925), 1,
      sym_identifier,
    ACTIONS(152), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [12521] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_EQ,
    ACTIONS(3055), 1,
      anon_sym_EQ_GT,
    ACTIONS(3111), 1,
      anon_sym_in,
    ACTIONS(3113), 1,
      anon_sym_COLON,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12594] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_EQ,
    ACTIONS(3055), 1,
      anon_sym_EQ_GT,
    ACTIONS(3111), 1,
      anon_sym_in,
    ACTIONS(3133), 1,
      anon_sym_COLON,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12667] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 1,
      anon_sym_EQ,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(2077), 1,
      anon_sym_COLON,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12807] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(122), 1,
      anon_sym_COMMA,
    ACTIONS(210), 1,
      anon_sym_RBRACK,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(2064), 1,
      anon_sym_EQ,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12880] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_RBRACK,
    ACTIONS(3055), 1,
      anon_sym_EQ_GT,
    ACTIONS(3076), 1,
      anon_sym_COMMA,
    ACTIONS(3108), 1,
      anon_sym_EQ,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 1,
      anon_sym_EQ,
    ACTIONS(3083), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13022] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 1,
      anon_sym_EQ,
    ACTIONS(1268), 1,
      anon_sym_EQ_GT,
    ACTIONS(2067), 1,
      anon_sym_COLON,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13093] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3083), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13162] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13229] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(1381), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3070), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(152), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3137), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3135), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [13434] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_AT,
    ACTIONS(3139), 1,
      anon_sym_class,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
    ACTIONS(3128), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3126), 38,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13505] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1277), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3144), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3142), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [13636] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3059), 1,
      anon_sym_EQ_GT,
    ACTIONS(3093), 1,
      anon_sym_in,
    ACTIONS(3096), 1,
      anon_sym_of,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13708] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(1273), 1,
      anon_sym_COLON,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13778] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(1323), 1,
      anon_sym_EQ_GT,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13846] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2037), 1,
      anon_sym_in,
    ACTIONS(3102), 1,
      anon_sym_of,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13918] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 1,
      anon_sym_EQ,
    ACTIONS(3100), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14052] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1321), 1,
      anon_sym_EQ,
    ACTIONS(1323), 1,
      anon_sym_EQ_GT,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(152), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3146), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [14182] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_RBRACK,
    ACTIONS(3076), 1,
      anon_sym_COMMA,
    ACTIONS(3108), 1,
      anon_sym_EQ,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3100), 1,
      anon_sym_EQ_GT,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3115), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [14382] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3093), 1,
      anon_sym_in,
    ACTIONS(3096), 1,
      anon_sym_of,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14451] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3057), 1,
      anon_sym_COLON,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 1,
      anon_sym_EQ,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2935), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14583] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3059), 1,
      anon_sym_EQ_GT,
    ACTIONS(2935), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2945), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2931), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14650] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(150), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(152), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(156), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(116), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14717] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(2889), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2891), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3113), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14833] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3172), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3174), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3071), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14949] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3176), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3178), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3088), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15065] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(2669), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2693), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2987), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15181] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3180), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3182), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3058), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15297] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3184), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3186), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3131), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15413] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3188), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15525] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1832), 1,
      anon_sym_LBRACE,
    ACTIONS(1963), 1,
      anon_sym_namespace,
    ACTIONS(1965), 1,
      anon_sym_import,
    ACTIONS(1967), 1,
      anon_sym_var,
    ACTIONS(1969), 1,
      anon_sym_let,
    ACTIONS(1971), 1,
      anon_sym_const,
    ACTIONS(1973), 1,
      anon_sym_class,
    ACTIONS(1975), 1,
      anon_sym_async,
    ACTIONS(1977), 1,
      anon_sym_function,
    ACTIONS(1979), 1,
      anon_sym_declare,
    ACTIONS(1983), 1,
      anon_sym_abstract,
    ACTIONS(1987), 1,
      anon_sym_interface,
    ACTIONS(1989), 1,
      anon_sym_enum,
    ACTIONS(3190), 1,
      anon_sym_STAR,
    ACTIONS(3192), 1,
      anon_sym_default,
    ACTIONS(3194), 1,
      anon_sym_type,
    ACTIONS(3196), 1,
      anon_sym_EQ,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_RBRACE,
    ACTIONS(3208), 1,
      anon_sym_module,
    STATE(1171), 1,
      sym_decorator,
    STATE(3322), 1,
      aux_sym_export_statement_repeat1,
    STATE(3327), 1,
      sym_internal_module,
    STATE(3328), 1,
      sym_declaration,
    STATE(3519), 1,
      sym_export_clause,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    STATE(3940), 1,
      sym_namespace_export,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3329), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [15643] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3210), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15755] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1832), 1,
      anon_sym_LBRACE,
    ACTIONS(1963), 1,
      anon_sym_namespace,
    ACTIONS(1965), 1,
      anon_sym_import,
    ACTIONS(1967), 1,
      anon_sym_var,
    ACTIONS(1969), 1,
      anon_sym_let,
    ACTIONS(1971), 1,
      anon_sym_const,
    ACTIONS(1973), 1,
      anon_sym_class,
    ACTIONS(1975), 1,
      anon_sym_async,
    ACTIONS(1977), 1,
      anon_sym_function,
    ACTIONS(1979), 1,
      anon_sym_declare,
    ACTIONS(1983), 1,
      anon_sym_abstract,
    ACTIONS(1987), 1,
      anon_sym_interface,
    ACTIONS(1989), 1,
      anon_sym_enum,
    ACTIONS(3190), 1,
      anon_sym_STAR,
    ACTIONS(3192), 1,
      anon_sym_default,
    ACTIONS(3194), 1,
      anon_sym_type,
    ACTIONS(3196), 1,
      anon_sym_EQ,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3208), 1,
      anon_sym_module,
    ACTIONS(3212), 1,
      anon_sym_RBRACE,
    STATE(1171), 1,
      sym_decorator,
    STATE(3322), 1,
      aux_sym_export_statement_repeat1,
    STATE(3327), 1,
      sym_internal_module,
    STATE(3328), 1,
      sym_declaration,
    STATE(3519), 1,
      sym_export_clause,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    STATE(3940), 1,
      sym_namespace_export,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3329), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [15873] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3215), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15985] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3217), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16097] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3219), 1,
      sym_identifier,
    ACTIONS(3221), 1,
      anon_sym_STAR,
    ACTIONS(3227), 1,
      anon_sym_LBRACE,
    STATE(3963), 1,
      sym_import_require_clause,
    STATE(3972), 1,
      sym_string,
    STATE(3978), 1,
      sym_import_clause,
    ACTIONS(3223), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(4411), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(3225), 15,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3229), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16175] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3231), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16287] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3233), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16399] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3235), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16511] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3237), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16623] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3239), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16735] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1832), 1,
      anon_sym_LBRACE,
    ACTIONS(1963), 1,
      anon_sym_namespace,
    ACTIONS(1965), 1,
      anon_sym_import,
    ACTIONS(1967), 1,
      anon_sym_var,
    ACTIONS(1969), 1,
      anon_sym_let,
    ACTIONS(1971), 1,
      anon_sym_const,
    ACTIONS(1973), 1,
      anon_sym_class,
    ACTIONS(1975), 1,
      anon_sym_async,
    ACTIONS(1977), 1,
      anon_sym_function,
    ACTIONS(1979), 1,
      anon_sym_declare,
    ACTIONS(1983), 1,
      anon_sym_abstract,
    ACTIONS(1987), 1,
      anon_sym_interface,
    ACTIONS(1989), 1,
      anon_sym_enum,
    ACTIONS(3190), 1,
      anon_sym_STAR,
    ACTIONS(3192), 1,
      anon_sym_default,
    ACTIONS(3194), 1,
      anon_sym_type,
    ACTIONS(3196), 1,
      anon_sym_EQ,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3208), 1,
      anon_sym_module,
    ACTIONS(3241), 1,
      anon_sym_RBRACE,
    STATE(1171), 1,
      sym_decorator,
    STATE(3322), 1,
      aux_sym_export_statement_repeat1,
    STATE(3327), 1,
      sym_internal_module,
    STATE(3328), 1,
      sym_declaration,
    STATE(3519), 1,
      sym_export_clause,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    STATE(3940), 1,
      sym_namespace_export,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3329), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [16853] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3244), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16965] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1832), 1,
      anon_sym_LBRACE,
    ACTIONS(1963), 1,
      anon_sym_namespace,
    ACTIONS(1965), 1,
      anon_sym_import,
    ACTIONS(1967), 1,
      anon_sym_var,
    ACTIONS(1969), 1,
      anon_sym_let,
    ACTIONS(1971), 1,
      anon_sym_const,
    ACTIONS(1973), 1,
      anon_sym_class,
    ACTIONS(1975), 1,
      anon_sym_async,
    ACTIONS(1977), 1,
      anon_sym_function,
    ACTIONS(1979), 1,
      anon_sym_declare,
    ACTIONS(1983), 1,
      anon_sym_abstract,
    ACTIONS(1987), 1,
      anon_sym_interface,
    ACTIONS(1989), 1,
      anon_sym_enum,
    ACTIONS(3190), 1,
      anon_sym_STAR,
    ACTIONS(3192), 1,
      anon_sym_default,
    ACTIONS(3194), 1,
      anon_sym_type,
    ACTIONS(3196), 1,
      anon_sym_EQ,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3208), 1,
      anon_sym_module,
    ACTIONS(3246), 1,
      anon_sym_RBRACE,
    STATE(1171), 1,
      sym_decorator,
    STATE(3322), 1,
      aux_sym_export_statement_repeat1,
    STATE(3327), 1,
      sym_internal_module,
    STATE(3328), 1,
      sym_declaration,
    STATE(3519), 1,
      sym_export_clause,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    STATE(3940), 1,
      sym_namespace_export,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3329), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [17083] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3249), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17195] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3251), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17307] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3253), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17419] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1832), 1,
      anon_sym_LBRACE,
    ACTIONS(1963), 1,
      anon_sym_namespace,
    ACTIONS(1965), 1,
      anon_sym_import,
    ACTIONS(1967), 1,
      anon_sym_var,
    ACTIONS(1969), 1,
      anon_sym_let,
    ACTIONS(1971), 1,
      anon_sym_const,
    ACTIONS(1973), 1,
      anon_sym_class,
    ACTIONS(1975), 1,
      anon_sym_async,
    ACTIONS(1977), 1,
      anon_sym_function,
    ACTIONS(1979), 1,
      anon_sym_declare,
    ACTIONS(1983), 1,
      anon_sym_abstract,
    ACTIONS(1987), 1,
      anon_sym_interface,
    ACTIONS(1989), 1,
      anon_sym_enum,
    ACTIONS(3190), 1,
      anon_sym_STAR,
    ACTIONS(3192), 1,
      anon_sym_default,
    ACTIONS(3194), 1,
      anon_sym_type,
    ACTIONS(3196), 1,
      anon_sym_EQ,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3208), 1,
      anon_sym_module,
    ACTIONS(3255), 1,
      anon_sym_RBRACE,
    STATE(1171), 1,
      sym_decorator,
    STATE(3322), 1,
      aux_sym_export_statement_repeat1,
    STATE(3327), 1,
      sym_internal_module,
    STATE(3328), 1,
      sym_declaration,
    STATE(3519), 1,
      sym_export_clause,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    STATE(3940), 1,
      sym_namespace_export,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3329), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [17537] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3258), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17649] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3260), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17761] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3262), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17873] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3264), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17985] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3266), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18097] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3008), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18205] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1832), 1,
      anon_sym_LBRACE,
    ACTIONS(1963), 1,
      anon_sym_namespace,
    ACTIONS(1965), 1,
      anon_sym_import,
    ACTIONS(1967), 1,
      anon_sym_var,
    ACTIONS(1969), 1,
      anon_sym_let,
    ACTIONS(1971), 1,
      anon_sym_const,
    ACTIONS(1973), 1,
      anon_sym_class,
    ACTIONS(1975), 1,
      anon_sym_async,
    ACTIONS(1977), 1,
      anon_sym_function,
    ACTIONS(1979), 1,
      anon_sym_declare,
    ACTIONS(1983), 1,
      anon_sym_abstract,
    ACTIONS(1987), 1,
      anon_sym_interface,
    ACTIONS(1989), 1,
      anon_sym_enum,
    ACTIONS(3190), 1,
      anon_sym_STAR,
    ACTIONS(3192), 1,
      anon_sym_default,
    ACTIONS(3194), 1,
      anon_sym_type,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3208), 1,
      anon_sym_module,
    ACTIONS(3268), 1,
      anon_sym_EQ,
    STATE(1171), 1,
      sym_decorator,
    STATE(3322), 1,
      aux_sym_export_statement_repeat1,
    STATE(3327), 1,
      sym_internal_module,
    STATE(3328), 1,
      sym_declaration,
    STATE(3519), 1,
      sym_export_clause,
    STATE(3940), 1,
      sym_namespace_export,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3329), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [18313] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3139), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18421] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3070), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18529] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3084), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1606), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [18693] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3110), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18801] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3056), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1542), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [18965] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1832), 1,
      anon_sym_LBRACE,
    ACTIONS(1963), 1,
      anon_sym_namespace,
    ACTIONS(1965), 1,
      anon_sym_import,
    ACTIONS(1967), 1,
      anon_sym_var,
    ACTIONS(1969), 1,
      anon_sym_let,
    ACTIONS(1971), 1,
      anon_sym_const,
    ACTIONS(1973), 1,
      anon_sym_class,
    ACTIONS(1975), 1,
      anon_sym_async,
    ACTIONS(1977), 1,
      anon_sym_function,
    ACTIONS(1979), 1,
      anon_sym_declare,
    ACTIONS(1983), 1,
      anon_sym_abstract,
    ACTIONS(1987), 1,
      anon_sym_interface,
    ACTIONS(1989), 1,
      anon_sym_enum,
    ACTIONS(3190), 1,
      anon_sym_STAR,
    ACTIONS(3192), 1,
      anon_sym_default,
    ACTIONS(3194), 1,
      anon_sym_type,
    ACTIONS(3196), 1,
      anon_sym_EQ,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3208), 1,
      anon_sym_module,
    STATE(1171), 1,
      sym_decorator,
    STATE(3322), 1,
      aux_sym_export_statement_repeat1,
    STATE(3327), 1,
      sym_internal_module,
    STATE(3328), 1,
      sym_declaration,
    STATE(3519), 1,
      sym_export_clause,
    STATE(3940), 1,
      sym_namespace_export,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3329), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [19075] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(2675), 1,
      anon_sym_new,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(2691), 1,
      anon_sym_abstract,
    ACTIONS(3152), 1,
      anon_sym_export,
    ACTIONS(3154), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3158), 1,
      anon_sym_async,
    ACTIONS(3162), 1,
      anon_sym_static,
    ACTIONS(3164), 1,
      anon_sym_readonly,
    ACTIONS(3170), 1,
      anon_sym_override,
    STATE(1171), 1,
      sym_decorator,
    STATE(2296), 1,
      sym_accessibility_modifier,
    STATE(2309), 1,
      sym_override_modifier,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3562), 1,
      aux_sym_export_statement_repeat1,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(3160), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3166), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3428), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [19183] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3282), 1,
      anon_sym_LT,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_QMARK_DOT,
    STATE(1340), 1,
      sym_type_arguments,
    STATE(1453), 1,
      sym_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3274), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3276), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [19254] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_LT,
    ACTIONS(3290), 1,
      anon_sym_DOT,
    ACTIONS(3292), 1,
      anon_sym_is,
    STATE(1345), 1,
      sym_type_arguments,
    ACTIONS(3288), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3010), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19317] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_STAR,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(233), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3296), 1,
      anon_sym_RBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(3300), 1,
      anon_sym_async,
    ACTIONS(3302), 1,
      anon_sym_static,
    ACTIONS(3304), 1,
      anon_sym_readonly,
    ACTIONS(3310), 1,
      anon_sym_override,
    STATE(2294), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(3715), 1,
      aux_sym_object_repeat1,
    STATE(3717), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(237), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3306), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3308), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3706), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3707), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3294), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [19415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_LT,
    ACTIONS(3290), 1,
      anon_sym_DOT,
    STATE(1345), 1,
      sym_type_arguments,
    ACTIONS(3288), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3010), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19475] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_STAR,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(233), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(3314), 1,
      anon_sym_RBRACE,
    ACTIONS(3316), 1,
      anon_sym_async,
    ACTIONS(3318), 1,
      anon_sym_static,
    ACTIONS(3320), 1,
      anon_sym_readonly,
    ACTIONS(3326), 1,
      anon_sym_override,
    STATE(2294), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(3614), 1,
      aux_sym_object_repeat1,
    STATE(3717), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(237), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3322), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3324), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3706), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3728), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3312), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [19573] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(3330), 1,
      anon_sym_DOT,
    STATE(1454), 1,
      sym_statement_block,
    ACTIONS(1395), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1393), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [19633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_is,
    ACTIONS(3332), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3334), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_is,
    ACTIONS(3338), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3340), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19745] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_STAR,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(233), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(3344), 1,
      anon_sym_RBRACE,
    ACTIONS(3346), 1,
      anon_sym_async,
    ACTIONS(3348), 1,
      anon_sym_static,
    ACTIONS(3350), 1,
      anon_sym_readonly,
    ACTIONS(3356), 1,
      anon_sym_override,
    STATE(2294), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(3614), 1,
      aux_sym_object_repeat1,
    STATE(3717), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(237), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3706), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3728), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3342), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [19843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1542), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_LT,
    STATE(1379), 1,
      sym_type_arguments,
    ACTIONS(3332), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3334), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19955] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_STAR,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(233), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(3360), 1,
      anon_sym_RBRACE,
    ACTIONS(3362), 1,
      anon_sym_async,
    ACTIONS(3364), 1,
      anon_sym_static,
    ACTIONS(3366), 1,
      anon_sym_readonly,
    ACTIONS(3372), 1,
      anon_sym_override,
    STATE(2294), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(3614), 1,
      aux_sym_object_repeat1,
    STATE(3717), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(237), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3368), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3370), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3706), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3728), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3358), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [20053] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(3374), 1,
      sym__automatic_semicolon,
    ACTIONS(1421), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1419), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [20111] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_STAR,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(233), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(3378), 1,
      anon_sym_RBRACE,
    ACTIONS(3380), 1,
      anon_sym_async,
    ACTIONS(3382), 1,
      anon_sym_static,
    ACTIONS(3384), 1,
      anon_sym_readonly,
    ACTIONS(3390), 1,
      anon_sym_override,
    STATE(2294), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(3614), 1,
      aux_sym_object_repeat1,
    STATE(3717), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(237), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3386), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3388), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3706), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3728), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3376), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [20209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1606), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20263] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1454), 1,
      sym_statement_block,
    ACTIONS(1395), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1393), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [20321] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_STAR,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(233), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(3394), 1,
      anon_sym_RBRACE,
    ACTIONS(3396), 1,
      anon_sym_async,
    ACTIONS(3398), 1,
      anon_sym_static,
    ACTIONS(3400), 1,
      anon_sym_readonly,
    ACTIONS(3406), 1,
      anon_sym_override,
    STATE(2294), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(3715), 1,
      aux_sym_object_repeat1,
    STATE(3717), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(237), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3402), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3404), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3706), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3707), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3392), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [20419] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_STAR,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(233), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(3410), 1,
      anon_sym_RBRACE,
    ACTIONS(3412), 1,
      anon_sym_async,
    ACTIONS(3414), 1,
      anon_sym_static,
    ACTIONS(3416), 1,
      anon_sym_readonly,
    ACTIONS(3422), 1,
      anon_sym_override,
    STATE(2294), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    STATE(3614), 1,
      aux_sym_object_repeat1,
    STATE(3717), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(237), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3418), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3420), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3706), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3728), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3408), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [20517] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3428), 1,
      anon_sym_DOT,
    STATE(1361), 1,
      sym_arguments,
    ACTIONS(3424), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3426), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1381), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [20631] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3434), 1,
      anon_sym_DOT,
    STATE(1356), 1,
      sym_arguments,
    ACTIONS(3430), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3432), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3436), 1,
      anon_sym_DOT,
    STATE(1364), 1,
      sym_arguments,
    ACTIONS(3016), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3012), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3440), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20804] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3446), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [20915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 1,
      sym__automatic_semicolon,
    ACTIONS(1447), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1445), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [20970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3492), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3494), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [21027] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(3508), 1,
      anon_sym_extends,
    ACTIONS(3502), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3505), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3496), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [21088] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [21145] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(1995), 1,
      anon_sym_extends,
    ACTIONS(3510), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3513), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1423), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [21206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_AMP,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3518), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3526), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3334), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_LBRACK,
    ACTIONS(3528), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3530), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21424] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3534), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [21535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3538), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3340), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3540), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3542), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3546), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_AMP,
    ACTIONS(3548), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3550), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21802] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3552), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [21913] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3558), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3554), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3556), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [21984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3546), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3546), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_DOT,
    ACTIONS(3565), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3567), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3573), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3573), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2549), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3573), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3374), 1,
      sym__automatic_semicolon,
    ACTIONS(1421), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1419), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [22518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22571] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3579), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [22682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3583), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22788] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3589), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3585), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 19,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [22867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1991), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22920] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3592), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [23031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1995), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23084] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3594), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [23195] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3596), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [23306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3598), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3600), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3604), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3606), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3608), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23624] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3614), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [23735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3618), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3618), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3618), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3622), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3624), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3508), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3622), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3622), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3628), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2001), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1999), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24212] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3630), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [24323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_AMP,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3632), 1,
      anon_sym_extends,
    ACTIONS(3438), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3440), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [24382] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_AMP,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3632), 1,
      anon_sym_extends,
    ACTIONS(3634), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3636), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [24441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3640), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24494] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_AMP,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3632), 1,
      anon_sym_extends,
    ACTIONS(3642), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3644), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [24553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3648), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3652), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3654), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3656), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [24712] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3658), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [24823] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3660), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [24934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1443), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1441), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [24987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3664), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3668), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [25148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3664), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25201] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3674), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3670), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3672), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [25274] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3681), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [25349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3668), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3686), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3690), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3686), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3690), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3492), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3694), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    STATE(1496), 1,
      sym_statement_block,
    ACTIONS(1395), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1393), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [25830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3694), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25883] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    ACTIONS(3702), 1,
      anon_sym_DOT,
    STATE(1496), 1,
      sym_statement_block,
    ACTIONS(1395), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1393), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [25942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [25995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3706), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3710), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2007), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3712), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3714), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_AMP,
    ACTIONS(3716), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3718), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    STATE(1513), 1,
      sym_arguments,
    ACTIONS(3720), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3722), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [26319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3724), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3726), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3728), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3734), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3736), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3738), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3740), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3742), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_AMP,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3632), 1,
      anon_sym_extends,
    ACTIONS(3744), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [26643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_AMP,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3632), 1,
      anon_sym_extends,
    ACTIONS(3736), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3738), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [26702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3750), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26755] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3530), 1,
      anon_sym_extends,
    ACTIONS(3532), 1,
      anon_sym_LBRACK,
    ACTIONS(3528), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3754), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [26814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3760), 1,
      anon_sym_DOT,
    ACTIONS(3756), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3758), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3765), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [26922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_AMP,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3632), 1,
      anon_sym_extends,
    ACTIONS(3767), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3769), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [26981] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [27084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3773), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3777), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3781), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27243] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3677), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [27332] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3681), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 18,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [27413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3783), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27466] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3681), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [27545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3789), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_LBRACK,
    ACTIONS(3791), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3793), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27653] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [27748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3797), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2003), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [27854] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3677), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3679), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [27947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3801), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [28000] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3681), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [28081] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_QMARK_DOT,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(1467), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1469), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [28142] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [28243] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [28342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2551), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2553), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [28395] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [28480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2557), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [28533] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3805), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [28646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_AMP,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3632), 1,
      anon_sym_extends,
    ACTIONS(3807), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3809), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [28705] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [28802] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3811), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [28913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3813), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3815), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [28966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3817), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3592), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [29018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3819), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3821), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [29070] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [29168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1602), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [29220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3859), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3861), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [29272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3863), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3811), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [29324] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3865), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [29398] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [29482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3882), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [29534] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3552), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [29644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3914), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3916), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [29696] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3918), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [29776] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [29874] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [29974] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3865), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [30054] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3921), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3670), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3672), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [30126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3924), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3926), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [30178] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [30270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3928), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3930), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [30322] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [30416] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [30508] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3534), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [30618] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(3932), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    STATE(4393), 1,
      sym_type_annotation,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [30734] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [30830] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3934), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [30940] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3865), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [31018] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3542), 1,
      anon_sym_extends,
    ACTIONS(3936), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31076] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [31160] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3865), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [31240] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3918), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [31314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3340), 1,
      anon_sym_extends,
    ACTIONS(3942), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3945), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31372] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3677), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [31460] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3811), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [31570] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3630), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [31680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31732] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [31834] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3630), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [31944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1572), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [31996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1594), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1596), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [32048] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [32142] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [32238] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3918), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [32316] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3918), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [32396] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3677), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [32484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3956), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3958), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [32536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3962), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [32588] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [32690] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3592), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [32800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3962), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [32852] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3614), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [32962] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3594), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [33072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3962), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3964), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3966), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3962), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33228] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3446), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [33338] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3660), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [33448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3968), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3970), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1443), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1441), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33552] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3596), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [33662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3972), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3974), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33714] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3446), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [33824] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3660), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [33934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3976), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33986] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3552), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [34096] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3534), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [34206] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [34306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1467), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1469), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3982), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1493), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1495), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1538), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34514] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(3984), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    STATE(4476), 1,
      sym_type_annotation,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1522), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1616), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3986), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3988), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1459), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [34838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3990), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3992), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3996), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1485), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4000), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1437), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1602), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4002), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4004), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1552), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1562), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35410] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    ACTIONS(4006), 1,
      anon_sym_COMMA,
    ACTIONS(4009), 1,
      anon_sym_RBRACE,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4011), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4015), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3446), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3225), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3229), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4025), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35784] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    ACTIONS(4006), 1,
      anon_sym_COMMA,
    ACTIONS(4009), 1,
      anon_sym_RBRACE,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3552), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4029), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1471), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [36002] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    ACTIONS(4009), 1,
      anon_sym_RBRACE,
    ACTIONS(4031), 1,
      anon_sym_COMMA,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3630), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36116] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3658), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [36226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4034), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4036), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4038), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4040), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36330] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    ACTIONS(4042), 1,
      anon_sym_COMMA,
    ACTIONS(4045), 1,
      anon_sym_RBRACE,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3630), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36444] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_STAR,
    ACTIONS(233), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_async,
    ACTIONS(4051), 1,
      anon_sym_static,
    ACTIONS(4053), 1,
      anon_sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_override,
    STATE(2294), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    ACTIONS(237), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2951), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4055), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4057), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4016), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4017), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4047), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36534] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3811), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [36644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4061), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4063), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36696] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4065), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    STATE(4283), 1,
      sym_type_annotation,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4069), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36864] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4071), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    STATE(4327), 1,
      sym_type_annotation,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(3496), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4073), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4075), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37086] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4077), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3670), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3672), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [37158] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_extends,
    ACTIONS(4084), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4087), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4080), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4082), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4090), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4092), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37268] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4094), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3585), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [37346] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4101), 1,
      anon_sym_COMMA,
    ACTIONS(4105), 1,
      anon_sym_LT,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    STATE(2858), 1,
      sym_type_arguments,
    STATE(3565), 1,
      aux_sym_extends_clause_repeat1,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4099), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37460] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4137), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3585), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [37538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4140), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3534), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 1,
      sym__automatic_semicolon,
    ACTIONS(1421), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1419), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [37644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1459), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37696] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3827), 1,
      anon_sym_GT,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    ACTIONS(4146), 1,
      anon_sym_in,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4144), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [37808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4082), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4151), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1485), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [37964] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3658), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [38074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4159), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4153), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4157), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [38130] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3579), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [38240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1586), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1447), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1445), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [38344] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4162), 1,
      anon_sym_LT,
    ACTIONS(4164), 1,
      anon_sym_QMARK_DOT,
    STATE(1690), 1,
      sym_type_arguments,
    STATE(1925), 1,
      sym_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3274), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3276), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [38412] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4162), 1,
      anon_sym_LT,
    ACTIONS(4166), 1,
      anon_sym_DOT,
    ACTIONS(4168), 1,
      anon_sym_is,
    STATE(1705), 1,
      sym_type_arguments,
    ACTIONS(3288), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3010), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [38472] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4170), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3554), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3556), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [38542] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3614), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [38652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4173), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4175), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1582), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4177), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3496), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [38812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4182), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38864] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3592), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [38974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4186), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4190), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4192), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4194), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4196), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4198), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1471), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4200), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4202), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4204), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [39342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 1,
      anon_sym_EQ,
    ACTIONS(4153), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4157), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4207), 1,
      sym__automatic_semicolon,
    ACTIONS(1447), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1445), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [39450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1586), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [39502] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4209), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3554), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3556), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [39572] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3579), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [39682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4212), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4214), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1447), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1445), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3596), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(1423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4218), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4220), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3594), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39996] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4009), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4224), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40108] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3596), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [40218] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3831), 1,
      anon_sym_LT,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3835), 1,
      anon_sym_GT_GT,
    ACTIONS(3839), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_CARET,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
    ACTIONS(3847), 1,
      anon_sym_PERCENT,
    ACTIONS(3849), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3948), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3952), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3954), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3823), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3827), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3837), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3845), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3853), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3855), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3851), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3594), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [40328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4226), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4228), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [40380] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [40473] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(4254), 1,
      anon_sym_DOT,
    STATE(1678), 1,
      sym_arguments,
    ACTIONS(3430), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3432), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [40530] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(4256), 1,
      anon_sym_DOT,
    STATE(1680), 1,
      sym_arguments,
    ACTIONS(3016), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3012), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [40587] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(4258), 1,
      anon_sym_DOT,
    STATE(1679), 1,
      sym_arguments,
    ACTIONS(3424), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3426), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [40644] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4260), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [40753] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4262), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 16,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [40832] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3579), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40941] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3061), 1,
      anon_sym_QMARK,
    ACTIONS(3057), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [40998] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3677), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [41085] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [41182] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [41281] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4144), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [41390] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(4279), 1,
      anon_sym_RBRACK,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3722), 1,
      aux_sym_array_repeat1,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41503] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4283), 1,
      anon_sym_RBRACE,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4289), 1,
      anon_sym_AT,
    ACTIONS(4291), 1,
      anon_sym_static,
    ACTIONS(4293), 1,
      anon_sym_readonly,
    ACTIONS(4297), 1,
      anon_sym_declare,
    ACTIONS(4299), 1,
      anon_sym_abstract,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4287), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4295), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1586), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41598] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4301), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3554), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3556), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [41667] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3596), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41776] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4304), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [41885] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4306), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3585), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 17,
      sym__ternary_qmark,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41962] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4262), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [42041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3073), 1,
      anon_sym_EQ,
    ACTIONS(3076), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [42098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4168), 1,
      anon_sym_is,
    ACTIONS(3338), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3340), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [42151] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    ACTIONS(4309), 1,
      anon_sym_COMMA,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4311), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42262] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 1,
      anon_sym_EQ,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3542), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [42321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4313), 1,
      anon_sym_is,
    ACTIONS(3332), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3334), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [42374] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4289), 1,
      anon_sym_AT,
    ACTIONS(4291), 1,
      anon_sym_static,
    ACTIONS(4293), 1,
      anon_sym_readonly,
    ACTIONS(4297), 1,
      anon_sym_declare,
    ACTIONS(4299), 1,
      anon_sym_abstract,
    ACTIONS(4315), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4287), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4295), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1582), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [42469] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4144), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [42578] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(4317), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3662), 1,
      aux_sym_array_repeat1,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42691] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4262), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [42768] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4319), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3670), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3672), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [42839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1381), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [42890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4162), 1,
      anon_sym_LT,
    ACTIONS(4166), 1,
      anon_sym_DOT,
    STATE(1705), 1,
      sym_type_arguments,
    ACTIONS(3288), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3010), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [42947] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4289), 1,
      anon_sym_AT,
    ACTIONS(4291), 1,
      anon_sym_static,
    ACTIONS(4293), 1,
      anon_sym_readonly,
    ACTIONS(4297), 1,
      anon_sym_declare,
    ACTIONS(4299), 1,
      anon_sym_abstract,
    ACTIONS(4322), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4287), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4295), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1586), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43042] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(4324), 1,
      anon_sym_RBRACK,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3606), 1,
      aux_sym_array_repeat1,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43155] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [43250] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4289), 1,
      anon_sym_AT,
    ACTIONS(4291), 1,
      anon_sym_static,
    ACTIONS(4293), 1,
      anon_sym_readonly,
    ACTIONS(4297), 1,
      anon_sym_declare,
    ACTIONS(4299), 1,
      anon_sym_abstract,
    ACTIONS(4326), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4287), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4295), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1568), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43345] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(3510), 1,
      anon_sym_LBRACK,
    ACTIONS(3513), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4328), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1995), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1423), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [43406] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4289), 1,
      anon_sym_AT,
    ACTIONS(4291), 1,
      anon_sym_static,
    ACTIONS(4293), 1,
      anon_sym_readonly,
    ACTIONS(4297), 1,
      anon_sym_declare,
    ACTIONS(4299), 1,
      anon_sym_abstract,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4287), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4295), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1608), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43501] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(4334), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3618), 1,
      aux_sym_array_repeat1,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43614] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [43697] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4162), 1,
      anon_sym_LT,
    STATE(1696), 1,
      sym_type_arguments,
    ACTIONS(3332), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3334), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [43752] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4262), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [43825] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [43918] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3811), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44027] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3630), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44136] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    ACTIONS(4309), 1,
      anon_sym_COMMA,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4336), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44247] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4289), 1,
      anon_sym_AT,
    ACTIONS(4291), 1,
      anon_sym_static,
    ACTIONS(4293), 1,
      anon_sym_readonly,
    ACTIONS(4297), 1,
      anon_sym_declare,
    ACTIONS(4299), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4287), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4295), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1586), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [44342] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4340), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3554), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3556), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [44411] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 1,
      anon_sym_EQ,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3046), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [44468] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3614), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44577] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4346), 1,
      anon_sym_STAR,
    ACTIONS(4349), 1,
      anon_sym_RBRACE,
    ACTIONS(4351), 1,
      anon_sym_LBRACK,
    ACTIONS(4354), 1,
      anon_sym_async,
    ACTIONS(4357), 1,
      anon_sym_DASH,
    ACTIONS(4360), 1,
      anon_sym_DQUOTE,
    ACTIONS(4363), 1,
      anon_sym_SQUOTE,
    ACTIONS(4369), 1,
      anon_sym_AT,
    ACTIONS(4372), 1,
      anon_sym_static,
    ACTIONS(4375), 1,
      anon_sym_readonly,
    ACTIONS(4381), 1,
      anon_sym_declare,
    ACTIONS(4387), 1,
      anon_sym_override,
    ACTIONS(4390), 1,
      anon_sym_abstract,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4366), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4378), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4384), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1586), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4343), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [44672] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3552), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44781] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3534), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44890] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3552), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44999] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3614), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45108] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(4393), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3608), 1,
      aux_sym_array_repeat1,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45221] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4105), 1,
      anon_sym_LT,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    STATE(2873), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4395), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [45330] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3630), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45439] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3811), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45548] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(4397), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3703), 1,
      aux_sym_array_repeat1,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4399), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [45716] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4401), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [45789] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [45872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4404), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4153), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4157), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [45927] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [46024] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [46123] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4401), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [46202] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [46293] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3534), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46402] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [46503] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [46598] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4401), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [46675] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4289), 1,
      anon_sym_AT,
    ACTIONS(4291), 1,
      anon_sym_static,
    ACTIONS(4293), 1,
      anon_sym_readonly,
    ACTIONS(4297), 1,
      anon_sym_declare,
    ACTIONS(4299), 1,
      anon_sym_abstract,
    ACTIONS(4406), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4287), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4295), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1586), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46770] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3552), 1,
      anon_sym_COMMA,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4011), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46881] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3446), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46990] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4401), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 16,
      sym__ternary_qmark,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47069] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3677), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [47156] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(4408), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    STATE(3827), 1,
      aux_sym_array_repeat1,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47269] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3660), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47378] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4410), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3508), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3496), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [47439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4414), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3496), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [47494] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4289), 1,
      anon_sym_AT,
    ACTIONS(4291), 1,
      anon_sym_static,
    ACTIONS(4293), 1,
      anon_sym_readonly,
    ACTIONS(4297), 1,
      anon_sym_declare,
    ACTIONS(4299), 1,
      anon_sym_abstract,
    ACTIONS(4416), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4287), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4295), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1550), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47589] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4289), 1,
      anon_sym_AT,
    ACTIONS(4291), 1,
      anon_sym_static,
    ACTIONS(4293), 1,
      anon_sym_readonly,
    ACTIONS(4297), 1,
      anon_sym_declare,
    ACTIONS(4299), 1,
      anon_sym_abstract,
    ACTIONS(4418), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4287), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4295), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1586), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47684] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3446), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47793] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(1995), 1,
      anon_sym_extends,
    ACTIONS(3510), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3513), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1423), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [47852] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(4420), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3676), 1,
      aux_sym_array_repeat1,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47965] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3660), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48074] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3542), 1,
      anon_sym_extends,
    ACTIONS(3936), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [48133] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(3508), 1,
      anon_sym_extends,
    ACTIONS(3502), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3505), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3496), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [48192] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(2677), 1,
      anon_sym_DASH,
    ACTIONS(3156), 1,
      anon_sym_LBRACK,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4289), 1,
      anon_sym_AT,
    ACTIONS(4291), 1,
      anon_sym_static,
    ACTIONS(4293), 1,
      anon_sym_readonly,
    ACTIONS(4297), 1,
      anon_sym_declare,
    ACTIONS(4299), 1,
      anon_sym_abstract,
    ACTIONS(4422), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      sym_method_definition,
    STATE(2266), 1,
      sym_accessibility_modifier,
    STATE(2315), 1,
      sym_override_modifier,
    STATE(3531), 1,
      sym_method_signature,
    ACTIONS(4287), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4295), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1618), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3647), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3150), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [48287] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3579), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48396] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3658), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48505] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4424), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3585), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 17,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [48582] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4427), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3670), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3672), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [48653] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3596), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48762] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3594), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48871] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3592), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48980] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3508), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3505), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3496), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [49039] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(3510), 1,
      anon_sym_LBRACK,
    ACTIONS(1995), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3513), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1423), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [49098] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3592), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49207] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3658), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49316] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(4430), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3671), 1,
      aux_sym_array_repeat1,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49429] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(4432), 1,
      anon_sym_RBRACK,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3606), 1,
      aux_sym_array_repeat1,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49542] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    ACTIONS(4309), 1,
      anon_sym_COMMA,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4434), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49653] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3868), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3872), 1,
      anon_sym_LT,
    ACTIONS(3874), 1,
      anon_sym_GT_GT,
    ACTIONS(3880), 1,
      anon_sym_PERCENT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3896), 1,
      anon_sym_AMP,
    ACTIONS(3898), 1,
      anon_sym_CARET,
    ACTIONS(3900), 1,
      anon_sym_PIPE,
    ACTIONS(3908), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(3912), 1,
      sym__ternary_qmark,
    ACTIONS(4309), 1,
      anon_sym_COMMA,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3805), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3876), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3878), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3890), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3904), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3902), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49764] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [49855] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4109), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4111), 1,
      anon_sym_GT_GT,
    ACTIONS(4115), 1,
      anon_sym_AMP,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_PERCENT,
    ACTIONS(4125), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 1,
      sym__ternary_qmark,
    ACTIONS(4277), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4097), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4103), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4113), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4121), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4131), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3594), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4127), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49964] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [50065] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4436), 1,
      anon_sym_RBRACK,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3686), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [50225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(4142), 1,
      sym__automatic_semicolon,
    ACTIONS(1421), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1419), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50279] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3660), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50387] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3614), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50495] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_PIPE,
    ACTIONS(4478), 1,
      anon_sym_extends,
    ACTIONS(3807), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3809), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3801), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [50601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2557), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [50651] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4480), 1,
      anon_sym_RBRACK,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50761] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3508), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_RPAREN,
    ACTIONS(3498), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4177), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3496), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50823] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3658), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50931] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3542), 1,
      anon_sym_extends,
    ACTIONS(3936), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [50987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3518), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3340), 1,
      anon_sym_extends,
    ACTIONS(3942), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3945), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [51097] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    ACTIONS(3542), 1,
      anon_sym_extends,
    ACTIONS(3936), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [51155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3538), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3546), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51255] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_PIPE,
    ACTIONS(4478), 1,
      anon_sym_extends,
    ACTIONS(3767), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3769), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [51311] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3446), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51419] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4482), 1,
      anon_sym_RBRACE,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3712), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3714), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_AMP,
    ACTIONS(3716), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3718), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3546), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3734), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3546), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3573), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3736), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3738), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51881] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_PIPE,
    ACTIONS(4478), 1,
      anon_sym_extends,
    ACTIONS(3736), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3738), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [51937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [51989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3760), 1,
      anon_sym_DOT,
    ACTIONS(3756), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3758), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52041] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4484), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3670), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3672), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [52111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3765), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3773), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3777), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3781), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3789), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3797), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2003), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52461] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4487), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52571] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    ACTIONS(4489), 1,
      anon_sym_SEMI,
    ACTIONS(4491), 1,
      sym__automatic_semicolon,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52681] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4493), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52791] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4495), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52901] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4497), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53011] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_extends,
    ACTIONS(3510), 1,
      anon_sym_LBRACK,
    ACTIONS(4328), 1,
      anon_sym_RPAREN,
    ACTIONS(1425), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3513), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4204), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1423), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [53073] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4499), 1,
      anon_sym_RBRACE,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53183] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4501), 1,
      anon_sym_RBRACE,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53293] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    STATE(1993), 1,
      sym_arguments,
    ACTIONS(3720), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3722), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [53347] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4503), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3750), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53505] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3255), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4515), 1,
      anon_sym_readonly,
    STATE(2313), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53587] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(1995), 1,
      anon_sym_extends,
    ACTIONS(1997), 1,
      anon_sym_QMARK,
    ACTIONS(3510), 1,
      anon_sym_LBRACK,
    ACTIONS(4399), 1,
      anon_sym_COLON,
    ACTIONS(3513), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4328), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1423), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [53651] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3508), 1,
      anon_sym_extends,
    ACTIONS(3624), 1,
      anon_sym_QMARK,
    ACTIONS(4414), 1,
      anon_sym_COLON,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4410), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3496), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [53715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3813), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3815), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4519), 1,
      anon_sym_LBRACK,
    ACTIONS(3791), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3793), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3573), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3783), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53917] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3530), 1,
      anon_sym_extends,
    ACTIONS(4519), 1,
      anon_sym_LBRACK,
    ACTIONS(3528), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3754), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [53973] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LBRACK,
    ACTIONS(3340), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3945), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [54029] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_PIPE,
    ACTIONS(4478), 1,
      anon_sym_extends,
    ACTIONS(3744), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [54085] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 6,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [54185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3573), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3740), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3742), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3728), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54435] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4521), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3585), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [54511] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3677), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [54597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3583), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3492), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1991), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [54797] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4524), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [54875] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3579), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54983] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4524), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [55059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_AMP,
    ACTIONS(3548), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3550), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3652), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55161] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4527), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3624), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3508), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55321] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 1,
      anon_sym_EQ,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3046), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3542), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [55383] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3340), 1,
      anon_sym_extends,
    ACTIONS(3942), 1,
      anon_sym_LBRACK,
    ACTIONS(4534), 1,
      anon_sym_RPAREN,
    ACTIONS(3945), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4529), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4531), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [55445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_DOT,
    ACTIONS(3565), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3567), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1995), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55547] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4540), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3554), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3556), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55615] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4543), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2007), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3598), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3600), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3710), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3706), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3604), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3606), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3608), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3618), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3618), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3618), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3622), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3622), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3622), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3628), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56523] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_extends,
    ACTIONS(3510), 1,
      anon_sym_LBRACK,
    ACTIONS(4545), 1,
      anon_sym_RPAREN,
    ACTIONS(1425), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3513), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4399), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1423), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [56585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2001), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1999), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3694), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3694), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3690), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56885] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3340), 1,
      anon_sym_extends,
    ACTIONS(3942), 1,
      anon_sym_LBRACK,
    ACTIONS(4550), 1,
      anon_sym_RPAREN,
    ACTIONS(3945), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4529), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4548), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [56947] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3073), 1,
      anon_sym_EQ,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3076), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3542), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [57009] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3246), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4515), 1,
      anon_sym_readonly,
    STATE(2313), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57091] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3552), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57199] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3212), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4515), 1,
      anon_sym_readonly,
    STATE(2313), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2549), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [57331] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3241), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4515), 1,
      anon_sym_readonly,
    STATE(2313), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57413] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3630), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57521] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3811), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57629] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_LBRACK,
    ACTIONS(3730), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4087), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4080), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4082), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [57685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [57739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3492), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3494), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [57793] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_extends,
    ACTIONS(4084), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4087), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4080), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4082), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [57849] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3508), 1,
      anon_sym_extends,
    ACTIONS(4553), 1,
      anon_sym_RPAREN,
    ACTIONS(3498), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4414), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3496), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [57911] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3936), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3542), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [57967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3492), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [58021] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4556), 1,
      anon_sym_RBRACK,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58131] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    ACTIONS(4558), 1,
      anon_sym_SEMI,
    ACTIONS(4560), 1,
      sym__automatic_semicolon,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58241] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4224), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58349] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4515), 1,
      anon_sym_readonly,
    STATE(2313), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3686), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [58481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4087), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4084), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3730), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4080), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4082), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [58537] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4562), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58645] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4009), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58753] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [58847] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58955] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3596), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59063] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4564), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3724), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3726), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [59223] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4566), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59333] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [59425] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3594), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59533] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3592), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3526), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [59691] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [59781] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4524), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [59859] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [59957] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [60053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3334), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [60103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4519), 1,
      anon_sym_LBRACK,
    ACTIONS(3528), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3530), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [60155] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4568), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3945), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3942), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3340), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [60321] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3886), 1,
      anon_sym_as,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(3910), 1,
      anon_sym_satisfies,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4446), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_CARET,
    ACTIONS(4456), 1,
      anon_sym_PIPE,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4470), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4472), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3534), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4440), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4468), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4464), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60429] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_EQ,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3542), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [60487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3340), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [60537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3540), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3542), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [60587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [60637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 1,
      sym_regex_flags,
    ACTIONS(4570), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(4572), 25,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3690), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [60739] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4576), 1,
      anon_sym_COLON,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(1423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [60901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 1,
      anon_sym_EQ,
    ACTIONS(4153), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4157), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [60953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(3496), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61005] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_EQ,
    ACTIONS(3542), 1,
      anon_sym_extends,
    ACTIONS(3936), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3668), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61113] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4578), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3664), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_PIPE,
    ACTIONS(4478), 1,
      anon_sym_extends,
    ACTIONS(3642), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3644), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3668), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3664), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3654), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3656), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3648), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61581] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4524), 1,
      anon_sym_LT,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [61653] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_PIPE,
    ACTIONS(4478), 1,
      anon_sym_extends,
    ACTIONS(3634), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3636), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4164), 1,
      anon_sym_QMARK_DOT,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(1467), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1469), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61767] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3542), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3440), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3640), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [61923] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_AMP,
    ACTIONS(4476), 1,
      anon_sym_PIPE,
    ACTIONS(4478), 1,
      anon_sym_extends,
    ACTIONS(3438), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3440), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61979] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3340), 1,
      anon_sym_extends,
    ACTIONS(3942), 1,
      anon_sym_LBRACK,
    ACTIONS(4584), 1,
      anon_sym_RPAREN,
    ACTIONS(3945), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4580), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4582), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [62041] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4587), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62151] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4448), 1,
      anon_sym_GT_GT,
    ACTIONS(4460), 1,
      anon_sym_PERCENT,
    ACTIONS(4462), 1,
      anon_sym_STAR_STAR,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3857), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4438), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4450), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4458), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [62233] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3452), 1,
      anon_sym_LT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3456), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3460), 1,
      anon_sym_GT_GT,
    ACTIONS(3464), 1,
      anon_sym_AMP,
    ACTIONS(3466), 1,
      anon_sym_CARET,
    ACTIONS(3468), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 1,
      anon_sym_PERCENT,
    ACTIONS(3474), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3482), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3488), 1,
      sym__ternary_qmark,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
    ACTIONS(4589), 1,
      anon_sym_RBRACK,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3442), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3450), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3462), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3470), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3478), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3476), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2551), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2553), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62393] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(1429), 1,
      sym__automatic_semicolon,
    ACTIONS(1419), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [62449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1616), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [62498] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3540), 1,
      anon_sym_QMARK,
    ACTIONS(3542), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3936), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [62555] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    ACTIONS(4591), 1,
      anon_sym_COLON,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62662] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3658), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62769] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LPAREN,
    ACTIONS(4632), 1,
      anon_sym_COLON,
    ACTIONS(4634), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_QMARK,
    ACTIONS(2931), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [62826] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3255), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4643), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62899] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(4414), 1,
      anon_sym_of,
    ACTIONS(4645), 1,
      anon_sym_in,
    ACTIONS(3496), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [62954] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    ACTIONS(4648), 1,
      anon_sym_COLON,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_extends,
    ACTIONS(4087), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4084), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(4080), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4082), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 1,
      sym__automatic_semicolon,
    ACTIONS(1610), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1614), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1616), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63169] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [63264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3859), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3861), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4548), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63366] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3592), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1467), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1469), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3914), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3916), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1507), 1,
      sym__automatic_semicolon,
    ACTIONS(1499), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1503), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4652), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63679] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3255), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4654), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63754] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    ACTIONS(4656), 1,
      anon_sym_COLON,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63861] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4658), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_LBRACE,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4666), 1,
      anon_sym_readonly,
    STATE(2290), 1,
      sym_statement_block,
    STATE(2305), 1,
      sym_override_modifier,
    ACTIONS(4664), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4668), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2462), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1532), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1536), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1538), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 1,
      sym__automatic_semicolon,
    ACTIONS(1546), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1550), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1552), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4670), 1,
      sym_regex_flags,
    ACTIONS(4570), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(4572), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4140), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3534), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64140] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 1,
      sym__automatic_semicolon,
    ACTIONS(1590), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1594), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1596), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64193] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3057), 1,
      anon_sym_COLON,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3542), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4672), 1,
      sym__automatic_semicolon,
    ACTIONS(1489), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1493), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1495), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64305] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4674), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4676), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4674), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4676), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3882), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1467), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1469), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4680), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64564] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [64645] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3594), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1560), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1562), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64803] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4674), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4676), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64905] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3596), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65012] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3660), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65119] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3446), 1,
      anon_sym_of,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65226] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 1,
      anon_sym_EQ,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3542), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4173), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4175), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65332] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [65431] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4144), 1,
      anon_sym_of,
    ACTIONS(4595), 1,
      anon_sym_GT,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    ACTIONS(4682), 1,
      anon_sym_in,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65540] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [65611] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3811), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1467), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1469), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1503), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65818] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3630), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65925] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3614), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66032] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    ACTIONS(4688), 1,
      anon_sym_RBRACK,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1572), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66188] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3677), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [66273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1431), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1435), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1437), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66324] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    ACTIONS(4690), 1,
      anon_sym_COLON,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3990), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3992), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3996), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4670), 1,
      sym_regex_flags,
    ACTIONS(4570), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(4572), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1479), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66631] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 1,
      anon_sym_EQ,
    ACTIONS(3540), 1,
      anon_sym_QMARK,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3542), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66690] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3057), 1,
      anon_sym_COLON,
    ACTIONS(3542), 1,
      anon_sym_extends,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4692), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1594), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1596), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3968), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3970), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66849] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [66924] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [67017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1552), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67115] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [67206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4186), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      sym__automatic_semicolon,
    ACTIONS(1566), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1570), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1572), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      sym__automatic_semicolon,
    ACTIONS(1610), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1614), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1616), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67361] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [67450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4226), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4228), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3962), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3962), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3962), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4015), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1562), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67744] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(4414), 1,
      anon_sym_COLON,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3508), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3496), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3964), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3966), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67852] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    ACTIONS(4698), 1,
      anon_sym_COLON,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3962), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68008] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [68085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3956), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3958), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68134] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 1,
      anon_sym_EQ,
    ACTIONS(4404), 1,
      anon_sym_of,
    ACTIONS(4700), 1,
      anon_sym_in,
    ACTIONS(4153), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4157), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1538), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3225), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3229), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68287] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4703), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3670), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3672), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [68356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4019), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3446), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68454] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 1,
      anon_sym_EQ,
    ACTIONS(3542), 1,
      anon_sym_extends,
    ACTIONS(3936), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [68511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1483), 1,
      sym__automatic_semicolon,
    ACTIONS(1475), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1479), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4061), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4063), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(3510), 1,
      anon_sym_LBRACK,
    ACTIONS(4399), 1,
      anon_sym_COLON,
    ACTIONS(3513), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1995), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1423), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 1,
      sym__automatic_semicolon,
    ACTIONS(1431), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1435), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1437), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3982), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1493), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1495), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3986), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3988), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(4399), 1,
      anon_sym_of,
    ACTIONS(4706), 1,
      anon_sym_in,
    ACTIONS(1423), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68927] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4680), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3819), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3821), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4002), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4004), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4709), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4711), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4680), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3976), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3978), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1582), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4025), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69382] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    ACTIONS(4713), 1,
      anon_sym_COLON,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 1,
      sym__automatic_semicolon,
    ACTIONS(1576), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1580), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1582), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4029), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69591] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3552), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4200), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4202), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4192), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4194), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1497), 1,
      sym__automatic_semicolon,
    ACTIONS(1489), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1493), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1495), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1580), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1582), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4034), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4036), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_EQ,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4717), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70053] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 1,
      sym__automatic_semicolon,
    ACTIONS(1546), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1550), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1552), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70106] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4721), 1,
      sym__automatic_semicolon,
    ACTIONS(1590), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1594), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1596), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1566), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1570), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1572), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70210] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [70307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4038), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4040), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70356] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3934), 1,
      anon_sym_RBRACE,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70463] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 1,
      sym__automatic_semicolon,
    ACTIONS(1532), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1536), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1538), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70516] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    ACTIONS(4723), 1,
      anon_sym_COLON,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4531), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4000), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1522), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70823] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 1,
      sym__automatic_semicolon,
    ACTIONS(1556), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1560), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1562), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70876] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 14,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4727), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1520), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1522), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4151), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71106] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_QMARK,
    ACTIONS(3730), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4087), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4084), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(4080), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4082), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4196), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4198), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71212] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4729), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3554), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3556), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [71279] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 1,
      sym__automatic_semicolon,
    ACTIONS(1516), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1520), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1522), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71332] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4654), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3492), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4069), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71509] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3508), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3505), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3496), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3863), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3811), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71615] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4643), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71688] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(3510), 1,
      anon_sym_LBRACK,
    ACTIONS(1995), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3513), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1423), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4073), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4075), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4190), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71843] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3212), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4643), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71916] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    ACTIONS(4732), 1,
      anon_sym_COLON,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3924), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3926), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72072] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4734), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3585), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 15,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [72147] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3534), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72254] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_EQ,
    ACTIONS(3093), 1,
      anon_sym_in,
    ACTIONS(3096), 1,
      anon_sym_of,
    ACTIONS(2931), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72309] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3212), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4654), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3928), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3930), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72433] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3579), 1,
      anon_sym_of,
    ACTIONS(4597), 1,
      anon_sym_LT,
    ACTIONS(4599), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4601), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4603), 1,
      anon_sym_GT_GT,
    ACTIONS(4607), 1,
      anon_sym_AMP,
    ACTIONS(4609), 1,
      anon_sym_CARET,
    ACTIONS(4611), 1,
      anon_sym_PIPE,
    ACTIONS(4615), 1,
      anon_sym_PERCENT,
    ACTIONS(4617), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4627), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4595), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4605), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4613), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4621), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4623), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4619), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4080), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4082), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72589] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3542), 1,
      anon_sym_extends,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3936), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72644] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3241), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4654), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3972), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3974), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72768] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3241), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4643), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4090), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4092), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72890] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3246), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4643), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4182), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73012] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4234), 1,
      anon_sym_LT,
    ACTIONS(4236), 1,
      anon_sym_GT_GT,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4244), 1,
      anon_sym_PERCENT,
    ACTIONS(4246), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4267), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4269), 1,
      anon_sym_CARET,
    ACTIONS(4271), 1,
      anon_sym_PIPE,
    ACTIONS(4273), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4275), 1,
      sym__ternary_qmark,
    ACTIONS(4737), 1,
      anon_sym_RBRACK,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4250), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4252), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4248), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3817), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3592), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3594), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4218), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4220), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3596), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4212), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4214), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73364] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4580), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4582), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1437), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73466] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3246), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4654), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 1,
      anon_sym_LPAREN,
    ACTIONS(4742), 1,
      anon_sym_COLON,
    ACTIONS(4744), 1,
      anon_sym_LT,
    ACTIONS(4747), 1,
      anon_sym_QMARK,
    ACTIONS(4200), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4202), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73598] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73702] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(3829), 1,
      anon_sym_LBRACK,
    ACTIONS(3833), 1,
      anon_sym_DOT,
    ACTIONS(3888), 1,
      anon_sym_BANG,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3455), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1989), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73806] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73874] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3241), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73942] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74046] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74150] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3212), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LBRACK,
    ACTIONS(3340), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3945), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74272] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74376] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74480] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74584] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4785), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [74654] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74758] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3542), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74812] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [74892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_LBRACK,
    ACTIONS(3730), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4087), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4080), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4082), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74946] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75050] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(3492), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75102] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [75200] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3677), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [75284] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4785), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 13,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [75360] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4785), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [75434] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [75526] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4790), 1,
      anon_sym_static,
    ACTIONS(4792), 1,
      anon_sym_readonly,
    ACTIONS(4794), 1,
      anon_sym_abstract,
    STATE(2288), 1,
      sym_accessibility_modifier,
    STATE(2318), 1,
      sym_override_modifier,
    ACTIONS(4788), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3168), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2807), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3150), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75598] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_EQ,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 1,
      anon_sym_EQ,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [75802] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75906] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 1,
      anon_sym_QMARK,
    ACTIONS(3340), 1,
      anon_sym_extends,
    ACTIONS(3945), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3942), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75962] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76066] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 1,
      anon_sym_EQ,
    ACTIONS(4404), 1,
      anon_sym_COLON,
    ACTIONS(4159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4153), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4157), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76120] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3677), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [76210] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 1,
      anon_sym_EQ,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3542), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76266] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [76354] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4785), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3677), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [76430] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [76526] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4796), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3670), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3672), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [76594] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3677), 1,
      anon_sym_BANG,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3679), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [76688] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4799), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3585), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 14,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [76762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3121), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76814] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76918] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4802), 1,
      anon_sym_LT,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3554), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3556), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [76984] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_EQ,
    ACTIONS(3542), 1,
      anon_sym_extends,
    ACTIONS(3936), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77040] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3246), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77108] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4515), 1,
      anon_sym_readonly,
    STATE(2313), 1,
      sym_override_modifier,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77182] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(3508), 1,
      anon_sym_extends,
    ACTIONS(3502), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3496), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77238] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(1995), 1,
      anon_sym_extends,
    ACTIONS(3510), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3513), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1423), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77294] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_LBRACK,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3444), 1,
      anon_sym_as,
    ACTIONS(3448), 1,
      anon_sym_BANG,
    ACTIONS(3454), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_satisfies,
    ACTIONS(4753), 1,
      anon_sym_LT,
    ACTIONS(4755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4759), 1,
      anon_sym_GT_GT,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_CARET,
    ACTIONS(4767), 1,
      anon_sym_PIPE,
    ACTIONS(4771), 1,
      anon_sym_PERCENT,
    ACTIONS(4773), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4781), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4783), 1,
      sym__ternary_qmark,
    STATE(3509), 1,
      sym_type_arguments,
    STATE(3765), 1,
      sym_optional_chain,
    ACTIONS(3484), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4749), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4751), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4761), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4769), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4777), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1439), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4775), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77398] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3255), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 1,
      sym_regex_flags,
    ACTIONS(4570), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4572), 22,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77516] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(4809), 1,
      anon_sym_RBRACE,
    STATE(3632), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4811), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3776), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4805), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77585] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(4204), 1,
      anon_sym_RBRACK,
    ACTIONS(4399), 1,
      anon_sym_COMMA,
    ACTIONS(1423), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_LBRACK,
    ACTIONS(4087), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3730), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4080), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4082), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4813), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4816), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3884), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4819), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4822), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4825), 1,
      sym_identifier,
    ACTIONS(3225), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3229), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77838] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LBRACK,
    ACTIONS(3945), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3340), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77891] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4829), 1,
      anon_sym_RBRACE,
    STATE(2308), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    STATE(2543), 1,
      sym_arguments,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4198), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4831), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4834), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4063), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4837), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4840), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4843), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4846), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78168] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3542), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3939), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78223] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4849), 1,
      anon_sym_RBRACE,
    STATE(2308), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4069), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4851), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4854), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4857), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4860), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78400] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(4865), 1,
      anon_sym_RBRACE,
    STATE(3717), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4811), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3706), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4863), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 1,
      anon_sym_EQ,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78518] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4654), 1,
      anon_sym_LBRACK,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1505), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4867), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4870), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78634] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
    ACTIONS(3939), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3542), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78687] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_RBRACK,
    ACTIONS(3076), 1,
      anon_sym_COMMA,
    ACTIONS(3108), 1,
      anon_sym_EQ,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78740] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4654), 1,
      anon_sym_LBRACK,
    ACTIONS(4658), 1,
      anon_sym_STAR,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4873), 1,
      anon_sym_abstract,
    ACTIONS(4664), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4668), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2462), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78805] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(2308), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78884] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_RBRACE,
    STATE(2308), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78963] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1891), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(2308), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 1,
      sym_identifier,
    ACTIONS(3225), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3229), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 1,
      anon_sym_EQ,
    ACTIONS(4159), 1,
      anon_sym_RBRACK,
    ACTIONS(4404), 1,
      anon_sym_COMMA,
    ACTIONS(4153), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4157), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79144] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4879), 1,
      anon_sym_STAR,
    ACTIONS(4881), 1,
      anon_sym_async,
    ACTIONS(4885), 1,
      anon_sym_readonly,
    STATE(2304), 1,
      sym_override_modifier,
    ACTIONS(4883), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4887), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2517), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79213] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4889), 1,
      anon_sym_RBRACE,
    STATE(2308), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79292] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4891), 1,
      anon_sym_STAR,
    ACTIONS(4893), 1,
      anon_sym_async,
    ACTIONS(4897), 1,
      anon_sym_readonly,
    STATE(2307), 1,
      sym_override_modifier,
    ACTIONS(4895), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4899), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2457), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3340), 1,
      anon_sym_extends,
    ACTIONS(3942), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3945), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2931), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79414] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_async,
    ACTIONS(4907), 1,
      anon_sym_readonly,
    STATE(2301), 1,
      sym_override_modifier,
    ACTIONS(4905), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4909), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2525), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79483] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4891), 1,
      anon_sym_STAR,
    ACTIONS(4893), 1,
      anon_sym_async,
    ACTIONS(4911), 1,
      anon_sym_abstract,
    ACTIONS(4895), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4899), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2457), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79548] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4643), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79613] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(4177), 1,
      anon_sym_RBRACK,
    ACTIONS(4414), 1,
      anon_sym_COMMA,
    ACTIONS(3496), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79666] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1889), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(2308), 1,
      sym_override_modifier,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79745] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_STAR,
    ACTIONS(4915), 1,
      anon_sym_async,
    ACTIONS(4919), 1,
      anon_sym_readonly,
    STATE(2306), 1,
      sym_override_modifier,
    ACTIONS(4917), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4921), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79814] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4654), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_STAR,
    ACTIONS(4915), 1,
      anon_sym_async,
    ACTIONS(4917), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4921), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79876] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4923), 1,
      anon_sym_STAR,
    ACTIONS(4925), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4927), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3130), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79936] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79996] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3241), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80054] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4929), 1,
      anon_sym_STAR,
    ACTIONS(4931), 1,
      anon_sym_async,
    ACTIONS(4933), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4935), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2533), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80116] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3241), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80174] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4929), 1,
      anon_sym_STAR,
    ACTIONS(4937), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4939), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3098), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80234] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      anon_sym_STAR,
    ACTIONS(4943), 1,
      anon_sym_async,
    ACTIONS(4945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4947), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2540), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80296] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3212), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1712), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [80402] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4658), 1,
      anon_sym_STAR,
    ACTIONS(4949), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4951), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2986), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80462] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4953), 1,
      anon_sym_STAR,
    ACTIONS(4955), 1,
      anon_sym_async,
    ACTIONS(4957), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2453), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_EQ,
    ACTIONS(4414), 1,
      anon_sym_of,
    ACTIONS(4645), 1,
      anon_sym_in,
    ACTIONS(3496), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [80576] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 1,
      anon_sym_EQ,
    ACTIONS(4404), 1,
      anon_sym_of,
    ACTIONS(4700), 1,
      anon_sym_in,
    ACTIONS(4153), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4157), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [80628] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80698] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4889), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80768] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4879), 1,
      anon_sym_STAR,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4963), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2976), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80828] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4889), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80900] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3212), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80958] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81030] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4891), 1,
      anon_sym_STAR,
    ACTIONS(4965), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4967), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3001), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81090] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4849), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81160] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4891), 1,
      anon_sym_STAR,
    ACTIONS(4893), 1,
      anon_sym_async,
    ACTIONS(4895), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4899), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2457), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81222] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81292] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81364] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4969), 1,
      anon_sym_STAR,
    ACTIONS(4971), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4973), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3114), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81424] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3246), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81482] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      anon_sym_STAR,
    ACTIONS(4975), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4977), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3148), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 1,
      sym_regex_flags,
    ACTIONS(4570), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(4572), 20,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81590] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4829), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81660] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_async,
    ACTIONS(4905), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4909), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2525), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 1,
      anon_sym_EQ,
    ACTIONS(2931), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81770] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4979), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4981), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81830] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_STAR,
    ACTIONS(4983), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4985), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3007), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81890] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4849), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81962] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4987), 1,
      anon_sym_STAR,
    ACTIONS(4989), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4991), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3080), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82022] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_EQ,
    ACTIONS(4399), 1,
      anon_sym_of,
    ACTIONS(4706), 1,
      anon_sym_in,
    ACTIONS(1423), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1427), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [82074] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4993), 1,
      anon_sym_STAR,
    ACTIONS(4995), 1,
      anon_sym_async,
    ACTIONS(4997), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4999), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2534), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82136] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82194] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4993), 1,
      anon_sym_STAR,
    ACTIONS(5001), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5003), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82254] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4879), 1,
      anon_sym_STAR,
    ACTIONS(4881), 1,
      anon_sym_async,
    ACTIONS(4883), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4887), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2517), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82316] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4953), 1,
      anon_sym_STAR,
    ACTIONS(5005), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5007), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82376] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3246), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82434] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5009), 1,
      anon_sym_STAR,
    ACTIONS(5011), 1,
      anon_sym_async,
    ACTIONS(5013), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5015), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2518), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82496] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1891), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_EQ,
    ACTIONS(3093), 1,
      anon_sym_in,
    ACTIONS(3096), 1,
      anon_sym_of,
    ACTIONS(2931), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2935), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [82620] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1891), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82690] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1889), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82762] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1889), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82832] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5009), 1,
      anon_sym_STAR,
    ACTIONS(5017), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5019), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3132), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82892] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5021), 1,
      anon_sym_STAR,
    ACTIONS(5023), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82952] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(4829), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83024] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(3298), 1,
      anon_sym_LBRACK,
    ACTIONS(4811), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5029), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4016), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4322), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5027), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83088] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3255), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83146] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3255), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83204] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5021), 1,
      anon_sym_STAR,
    ACTIONS(5031), 1,
      anon_sym_async,
    ACTIONS(5033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5035), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83266] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83324] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5001), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83379] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4983), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3007), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83434] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(2308), 1,
      sym_override_modifier,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5037), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83505] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4829), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83570] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4971), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3114), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83625] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3148), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83680] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5017), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3132), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83735] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5023), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83790] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4925), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3130), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83892] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5040), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3150), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83947] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_STAR,
    ACTIONS(1626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5046), 1,
      anon_sym_async,
    ACTIONS(5050), 1,
      anon_sym_static,
    ACTIONS(5052), 1,
      anon_sym_readonly,
    ACTIONS(5058), 1,
      anon_sym_override,
    STATE(2294), 1,
      sym_accessibility_modifier,
    STATE(2303), 1,
      sym_override_modifier,
    ACTIONS(5044), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5048), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5054), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5056), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4017), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(5042), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84024] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4979), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84079] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4849), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84144] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4949), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2986), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84199] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5005), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84254] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84309] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1891), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84374] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4989), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3080), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84429] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1889), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84494] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4965), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3001), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84549] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5062), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3004), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84604] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2976), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84659] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5064), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2738), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3150), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84714] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4937), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3098), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84769] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4875), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84834] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84899] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4889), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84964] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5066), 1,
      anon_sym_readonly,
    STATE(2329), 1,
      sym_override_modifier,
    ACTIONS(5064), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2738), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3150), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85024] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    STATE(2308), 1,
      sym_override_modifier,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5068), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85092] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4911), 1,
      anon_sym_abstract,
    ACTIONS(5064), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2738), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3150), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85148] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5037), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85210] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5070), 1,
      anon_sym_abstract,
    ACTIONS(5040), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3150), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85266] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5037), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85330] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5072), 1,
      anon_sym_readonly,
    STATE(2344), 1,
      sym_override_modifier,
    ACTIONS(5040), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3150), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85390] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85440] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85490] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5068), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85549] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4849), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85604] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85659] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4875), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85714] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4875), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85769] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4829), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85824] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5068), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85885] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5074), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2768), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3150), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85938] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4829), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85993] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1889), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86048] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86103] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1889), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86158] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4849), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86213] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5037), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86270] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5076), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2711), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3150), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86323] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1891), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86378] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1891), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86433] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4889), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86488] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4889), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86543] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5068), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86597] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1836), 1,
      anon_sym_import,
    ACTIONS(1838), 1,
      anon_sym_var,
    ACTIONS(1840), 1,
      anon_sym_let,
    ACTIONS(1842), 1,
      anon_sym_const,
    ACTIONS(1853), 1,
      anon_sym_class,
    ACTIONS(1855), 1,
      anon_sym_async,
    ACTIONS(1857), 1,
      anon_sym_function,
    ACTIONS(1865), 1,
      anon_sym_abstract,
    ACTIONS(1867), 1,
      anon_sym_interface,
    ACTIONS(1869), 1,
      anon_sym_enum,
    ACTIONS(1895), 1,
      anon_sym_type,
    ACTIONS(1907), 1,
      anon_sym_namespace,
    ACTIONS(1911), 1,
      anon_sym_declare,
    ACTIONS(1913), 1,
      anon_sym_module,
    ACTIONS(5078), 1,
      anon_sym_default,
    STATE(636), 1,
      sym_internal_module,
    STATE(690), 1,
      sym_declaration,
    STATE(1171), 1,
      sym_decorator,
    STATE(3198), 1,
      aux_sym_export_statement_repeat1,
    STATE(649), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [86676] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1830), 1,
      anon_sym_namespace,
    ACTIONS(1836), 1,
      anon_sym_import,
    ACTIONS(1838), 1,
      anon_sym_var,
    ACTIONS(1840), 1,
      anon_sym_let,
    ACTIONS(1842), 1,
      anon_sym_const,
    ACTIONS(1853), 1,
      anon_sym_class,
    ACTIONS(1855), 1,
      anon_sym_async,
    ACTIONS(1857), 1,
      anon_sym_function,
    ACTIONS(1861), 1,
      anon_sym_declare,
    ACTIONS(1863), 1,
      anon_sym_module,
    ACTIONS(1865), 1,
      anon_sym_abstract,
    ACTIONS(1867), 1,
      anon_sym_interface,
    ACTIONS(1869), 1,
      anon_sym_enum,
    ACTIONS(1895), 1,
      anon_sym_type,
    ACTIONS(5080), 1,
      anon_sym_default,
    STATE(636), 1,
      sym_internal_module,
    STATE(690), 1,
      sym_declaration,
    STATE(1171), 1,
      sym_decorator,
    STATE(3198), 1,
      aux_sym_export_statement_repeat1,
    STATE(649), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [86755] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1830), 1,
      anon_sym_namespace,
    ACTIONS(1836), 1,
      anon_sym_import,
    ACTIONS(1838), 1,
      anon_sym_var,
    ACTIONS(1840), 1,
      anon_sym_let,
    ACTIONS(1842), 1,
      anon_sym_const,
    ACTIONS(1853), 1,
      anon_sym_class,
    ACTIONS(1855), 1,
      anon_sym_async,
    ACTIONS(1857), 1,
      anon_sym_function,
    ACTIONS(1861), 1,
      anon_sym_declare,
    ACTIONS(1863), 1,
      anon_sym_module,
    ACTIONS(1865), 1,
      anon_sym_abstract,
    ACTIONS(1867), 1,
      anon_sym_interface,
    ACTIONS(1869), 1,
      anon_sym_enum,
    ACTIONS(1895), 1,
      anon_sym_type,
    ACTIONS(5082), 1,
      anon_sym_default,
    STATE(636), 1,
      sym_internal_module,
    STATE(690), 1,
      sym_declaration,
    STATE(1171), 1,
      sym_decorator,
    STATE(3198), 1,
      aux_sym_export_statement_repeat1,
    STATE(649), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [86834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5084), 1,
      anon_sym_LPAREN,
    ACTIONS(5086), 1,
      anon_sym_DOT,
    STATE(2281), 1,
      sym_arguments,
    ACTIONS(3117), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3115), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [86881] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1836), 1,
      anon_sym_import,
    ACTIONS(1838), 1,
      anon_sym_var,
    ACTIONS(1840), 1,
      anon_sym_let,
    ACTIONS(1842), 1,
      anon_sym_const,
    ACTIONS(1853), 1,
      anon_sym_class,
    ACTIONS(1855), 1,
      anon_sym_async,
    ACTIONS(1857), 1,
      anon_sym_function,
    ACTIONS(1865), 1,
      anon_sym_abstract,
    ACTIONS(1867), 1,
      anon_sym_interface,
    ACTIONS(1869), 1,
      anon_sym_enum,
    ACTIONS(1895), 1,
      anon_sym_type,
    ACTIONS(1901), 1,
      anon_sym_global,
    ACTIONS(1907), 1,
      anon_sym_namespace,
    ACTIONS(1911), 1,
      anon_sym_declare,
    ACTIONS(1949), 1,
      anon_sym_module,
    STATE(636), 1,
      sym_internal_module,
    STATE(650), 1,
      sym_declaration,
    STATE(1171), 1,
      sym_decorator,
    STATE(3198), 1,
      aux_sym_export_statement_repeat1,
    STATE(649), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [86960] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1961), 1,
      anon_sym_type,
    ACTIONS(1963), 1,
      anon_sym_namespace,
    ACTIONS(1965), 1,
      anon_sym_import,
    ACTIONS(1967), 1,
      anon_sym_var,
    ACTIONS(1969), 1,
      anon_sym_let,
    ACTIONS(1971), 1,
      anon_sym_const,
    ACTIONS(1973), 1,
      anon_sym_class,
    ACTIONS(1975), 1,
      anon_sym_async,
    ACTIONS(1977), 1,
      anon_sym_function,
    ACTIONS(1979), 1,
      anon_sym_declare,
    ACTIONS(1981), 1,
      anon_sym_module,
    ACTIONS(1983), 1,
      anon_sym_abstract,
    ACTIONS(1985), 1,
      anon_sym_global,
    ACTIONS(1987), 1,
      anon_sym_interface,
    ACTIONS(1989), 1,
      anon_sym_enum,
    STATE(1171), 1,
      sym_decorator,
    STATE(3322), 1,
      aux_sym_export_statement_repeat1,
    STATE(3325), 1,
      sym_declaration,
    STATE(3327), 1,
      sym_internal_module,
    STATE(3329), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [87039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(5037), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87086] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(5037), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87133] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1961), 1,
      anon_sym_type,
    ACTIONS(1963), 1,
      anon_sym_namespace,
    ACTIONS(1965), 1,
      anon_sym_import,
    ACTIONS(1967), 1,
      anon_sym_var,
    ACTIONS(1969), 1,
      anon_sym_let,
    ACTIONS(1971), 1,
      anon_sym_const,
    ACTIONS(1973), 1,
      anon_sym_class,
    ACTIONS(1975), 1,
      anon_sym_async,
    ACTIONS(1977), 1,
      anon_sym_function,
    ACTIONS(1979), 1,
      anon_sym_declare,
    ACTIONS(1983), 1,
      anon_sym_abstract,
    ACTIONS(1987), 1,
      anon_sym_interface,
    ACTIONS(1989), 1,
      anon_sym_enum,
    ACTIONS(3208), 1,
      anon_sym_module,
    ACTIONS(5088), 1,
      anon_sym_default,
    STATE(1171), 1,
      sym_decorator,
    STATE(3302), 1,
      sym_declaration,
    STATE(3322), 1,
      aux_sym_export_statement_repeat1,
    STATE(3327), 1,
      sym_internal_module,
    STATE(3329), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [87212] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5090), 1,
      anon_sym_STAR,
    ACTIONS(5092), 1,
      anon_sym_async,
    ACTIONS(5096), 1,
      anon_sym_readonly,
    STATE(2311), 1,
      sym_override_modifier,
    ACTIONS(5094), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5098), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87275] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(1830), 1,
      anon_sym_namespace,
    ACTIONS(1836), 1,
      anon_sym_import,
    ACTIONS(1838), 1,
      anon_sym_var,
    ACTIONS(1840), 1,
      anon_sym_let,
    ACTIONS(1842), 1,
      anon_sym_const,
    ACTIONS(1853), 1,
      anon_sym_class,
    ACTIONS(1855), 1,
      anon_sym_async,
    ACTIONS(1857), 1,
      anon_sym_function,
    ACTIONS(1861), 1,
      anon_sym_declare,
    ACTIONS(1865), 1,
      anon_sym_abstract,
    ACTIONS(1867), 1,
      anon_sym_interface,
    ACTIONS(1869), 1,
      anon_sym_enum,
    ACTIONS(1895), 1,
      anon_sym_type,
    ACTIONS(1899), 1,
      anon_sym_module,
    ACTIONS(1901), 1,
      anon_sym_global,
    STATE(636), 1,
      sym_internal_module,
    STATE(650), 1,
      sym_declaration,
    STATE(1171), 1,
      sym_decorator,
    STATE(3198), 1,
      aux_sym_export_statement_repeat1,
    STATE(649), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [87354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5102), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5100), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5106), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5104), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87434] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5108), 1,
      anon_sym_STAR,
    ACTIONS(5110), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5112), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2994), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5116), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5114), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5118), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87568] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5108), 1,
      anon_sym_STAR,
    ACTIONS(5122), 1,
      anon_sym_async,
    ACTIONS(5110), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5112), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2994), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87624] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5090), 1,
      anon_sym_STAR,
    ACTIONS(5094), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5098), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87678] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5124), 1,
      anon_sym_EQ_GT,
    ACTIONS(5094), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5126), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87770] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5130), 1,
      anon_sym_STAR,
    ACTIONS(5132), 1,
      anon_sym_async,
    ACTIONS(5134), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5136), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3017), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87826] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5130), 1,
      anon_sym_STAR,
    ACTIONS(5134), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5136), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3017), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5138), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3137), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3135), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_DOT,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5142), 1,
      sym__automatic_semicolon,
    ACTIONS(1445), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1447), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1485), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1487), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 1,
      sym__automatic_semicolon,
    ACTIONS(1419), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1421), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88084] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5146), 1,
      anon_sym_STAR,
    ACTIONS(5148), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5150), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3041), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5068), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5152), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88222] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5090), 1,
      anon_sym_STAR,
    ACTIONS(5092), 1,
      anon_sym_async,
    ACTIONS(5094), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5098), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5158), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5156), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5102), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5100), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5160), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1447), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5164), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5106), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5104), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5168), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5068), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1714), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5172), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5152), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5138), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5160), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5164), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5178), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5176), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5116), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5114), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5182), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5118), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [88964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5188), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5186), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89004] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5005), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5190), 1,
      sym__automatic_semicolon,
    ACTIONS(1445), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1447), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89094] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5110), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2994), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89143] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4989), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3080), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89192] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5001), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89241] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4979), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89290] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4925), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3130), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 1,
      sym__automatic_semicolon,
    ACTIONS(1419), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1421), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89380] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5017), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3132), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89429] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5194), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3119), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89478] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3148), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89527] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4658), 1,
      anon_sym_STAR,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(5196), 1,
      anon_sym_static,
    ACTIONS(5198), 1,
      anon_sym_readonly,
    ACTIONS(5200), 1,
      anon_sym_abstract,
    STATE(2305), 1,
      sym_override_modifier,
    ACTIONS(4664), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4668), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2462), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89590] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4937), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3098), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89639] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4965), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3001), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89688] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5148), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3041), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89737] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2976), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89786] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5202), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3109), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89835] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4971), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3114), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5134), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3017), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89933] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5204), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3128), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89982] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5206), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3075), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90031] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5023), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90080] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5094), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90129] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4515), 1,
      anon_sym_readonly,
    ACTIONS(5208), 1,
      anon_sym_static,
    STATE(2313), 1,
      sym_override_modifier,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1447), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90227] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5210), 1,
      anon_sym_RBRACE,
    STATE(3670), 1,
      sym_enum_assignment,
    ACTIONS(5212), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3221), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3146), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3115), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90353] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5214), 1,
      anon_sym_RBRACE,
    STATE(3599), 1,
      sym_enum_assignment,
    ACTIONS(5216), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3165), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90403] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5218), 1,
      anon_sym_RBRACE,
    STATE(3944), 1,
      sym_enum_assignment,
    ACTIONS(5220), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2553), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2551), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90491] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 1,
      anon_sym_RBRACE,
    STATE(3944), 1,
      sym_enum_assignment,
    ACTIONS(5220), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90541] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5224), 1,
      anon_sym_RBRACE,
    STATE(3944), 1,
      sym_enum_assignment,
    ACTIONS(5220), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90591] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5226), 1,
      anon_sym_static,
    ACTIONS(5228), 1,
      anon_sym_readonly,
    ACTIONS(5230), 1,
      anon_sym_abstract,
    STATE(2329), 1,
      sym_override_modifier,
    ACTIONS(5064), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2738), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2549), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2547), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5232), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90723] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5236), 1,
      anon_sym_RBRACE,
    STATE(3944), 1,
      sym_enum_assignment,
    ACTIONS(5220), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90773] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5238), 1,
      anon_sym_RBRACE,
    STATE(3944), 1,
      sym_enum_assignment,
    ACTIONS(5220), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5240), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [90861] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(1959), 1,
      anon_sym_override,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(5242), 1,
      anon_sym_static,
    STATE(2308), 1,
      sym_override_modifier,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90921] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5244), 1,
      anon_sym_RBRACE,
    STATE(3944), 1,
      sym_enum_assignment,
    ACTIONS(5220), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90971] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3170), 1,
      anon_sym_override,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_STAR,
    ACTIONS(4915), 1,
      anon_sym_async,
    ACTIONS(4919), 1,
      anon_sym_readonly,
    ACTIONS(5246), 1,
      anon_sym_static,
    STATE(2306), 1,
      sym_override_modifier,
    ACTIONS(4917), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4921), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91031] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5248), 1,
      anon_sym_RBRACE,
    STATE(3944), 1,
      sym_enum_assignment,
    ACTIONS(5220), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1485), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1487), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [91119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2557), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2555), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [91157] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5250), 1,
      anon_sym_RBRACE,
    STATE(3944), 1,
      sym_enum_assignment,
    ACTIONS(5220), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91207] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4993), 1,
      anon_sym_STAR,
    ACTIONS(4995), 1,
      anon_sym_async,
    ACTIONS(5252), 1,
      anon_sym_readonly,
    ACTIONS(4997), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4999), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2534), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1690), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1688), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91299] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(1953), 1,
      anon_sym_async,
    ACTIONS(1955), 1,
      anon_sym_readonly,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4827), 1,
      anon_sym_STAR,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1957), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91352] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 1,
      anon_sym_STAR,
    ACTIONS(4943), 1,
      anon_sym_async,
    ACTIONS(5254), 1,
      anon_sym_readonly,
    ACTIONS(4945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4947), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2540), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91405] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4891), 1,
      anon_sym_STAR,
    ACTIONS(4893), 1,
      anon_sym_async,
    ACTIONS(4897), 1,
      anon_sym_readonly,
    ACTIONS(4895), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4899), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2457), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91458] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4903), 1,
      anon_sym_async,
    ACTIONS(4907), 1,
      anon_sym_readonly,
    ACTIONS(4905), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4909), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2525), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91511] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5021), 1,
      anon_sym_STAR,
    ACTIONS(5031), 1,
      anon_sym_async,
    ACTIONS(5256), 1,
      anon_sym_readonly,
    ACTIONS(5033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5035), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91564] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5090), 1,
      anon_sym_STAR,
    ACTIONS(5092), 1,
      anon_sym_async,
    ACTIONS(5096), 1,
      anon_sym_readonly,
    ACTIONS(5094), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5098), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91617] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 1,
      anon_sym_STAR,
    ACTIONS(4915), 1,
      anon_sym_async,
    ACTIONS(4919), 1,
      anon_sym_readonly,
    ACTIONS(4917), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4921), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91670] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4511), 1,
      anon_sym_async,
    ACTIONS(4515), 1,
      anon_sym_readonly,
    ACTIONS(4513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91723] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5108), 1,
      anon_sym_STAR,
    ACTIONS(5122), 1,
      anon_sym_async,
    ACTIONS(5258), 1,
      anon_sym_readonly,
    ACTIONS(5110), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5112), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2994), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91776] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5260), 1,
      anon_sym_STAR,
    ACTIONS(5264), 1,
      anon_sym_readonly,
    ACTIONS(5262), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5266), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2463), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91827] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4879), 1,
      anon_sym_STAR,
    ACTIONS(4881), 1,
      anon_sym_async,
    ACTIONS(4885), 1,
      anon_sym_readonly,
    ACTIONS(4883), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4887), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2517), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91880] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5066), 1,
      anon_sym_readonly,
    ACTIONS(5268), 1,
      anon_sym_STAR,
    ACTIONS(5270), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5272), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2466), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91931] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(4658), 1,
      anon_sym_STAR,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4666), 1,
      anon_sym_readonly,
    ACTIONS(4664), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4668), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2462), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91984] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    STATE(3944), 1,
      sym_enum_assignment,
    ACTIONS(5220), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92031] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5023), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92075] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5066), 1,
      anon_sym_readonly,
    ACTIONS(5064), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2738), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92121] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5060), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92165] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4641), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92209] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4937), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3098), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92253] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(1945), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3092), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92297] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5148), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3041), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92341] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5110), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2994), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92385] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3148), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92429] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5017), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3132), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4925), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3130), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92517] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5204), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3128), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92561] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5072), 1,
      anon_sym_readonly,
    ACTIONS(5040), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92607] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4989), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3080), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92651] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4983), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3007), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92695] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5040), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92739] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4979), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92783] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4971), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3114), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92827] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5076), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2711), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92871] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4961), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2976), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92915] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5005), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5134), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3017), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93003] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5206), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3075), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93047] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4965), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3001), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93091] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5094), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93135] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5001), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93179] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5194), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3119), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93223] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5274), 1,
      anon_sym_readonly,
    ACTIONS(5076), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2711), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93269] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(4509), 1,
      anon_sym_LBRACK,
    ACTIONS(5064), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2738), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3150), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93313] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(4949), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2986), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93357] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5062), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3004), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93401] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(4639), 1,
      anon_sym_LBRACK,
    ACTIONS(5202), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3109), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1951), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5276), 1,
      sym_identifier,
    STATE(4184), 1,
      sym_mapped_type_clause,
    ACTIONS(5278), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93476] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(5280), 1,
      anon_sym_LT,
    ACTIONS(5282), 1,
      anon_sym_DOT,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3010), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [93508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93534] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(5280), 1,
      anon_sym_LT,
    ACTIONS(5282), 1,
      anon_sym_DOT,
    ACTIONS(5284), 1,
      anon_sym_is,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3010), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [93568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3583), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93594] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5288), 1,
      anon_sym_EQ,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5292), 1,
      anon_sym_COMMA,
    ACTIONS(5294), 1,
      anon_sym_COLON,
    ACTIONS(5296), 1,
      anon_sym_LT,
    ACTIONS(5298), 1,
      anon_sym_GT,
    ACTIONS(5301), 1,
      anon_sym_SLASH,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5307), 1,
      anon_sym_extends,
    STATE(2816), 1,
      sym_type_arguments,
    STATE(2834), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3533), 1,
      sym_constraint,
    STATE(4070), 1,
      sym_default_type,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [93650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3708), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3710), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3618), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3706), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3618), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3698), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3622), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3622), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3694), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3622), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3577), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3628), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3698), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3724), 1,
      anon_sym_EQ,
    ACTIONS(3726), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_implements,
  [94014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3573), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      anon_sym_EQ,
    ACTIONS(3801), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_implements,
  [94066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3612), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3694), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_EQ,
    ACTIONS(3750), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_implements,
  [94144] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(5309), 1,
      anon_sym_DOT,
    ACTIONS(5311), 1,
      anon_sym_QMARK_DOT,
    STATE(2394), 1,
      sym_arguments,
    ACTIONS(3430), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3432), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3612), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94204] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      anon_sym_DOT,
    ACTIONS(5315), 1,
      anon_sym_QMARK_DOT,
    STATE(2395), 1,
      sym_arguments,
    ACTIONS(3424), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3426), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3573), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3546), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94290] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3016), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3012), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3612), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3573), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3546), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3546), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3664), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3668), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94480] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5288), 1,
      anon_sym_EQ,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5292), 1,
      anon_sym_COMMA,
    ACTIONS(5294), 1,
      anon_sym_COLON,
    ACTIONS(5296), 1,
      anon_sym_LT,
    ACTIONS(5298), 1,
      anon_sym_GT,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5307), 1,
      anon_sym_extends,
    ACTIONS(5317), 1,
      anon_sym_SLASH,
    STATE(2753), 1,
      sym_type_arguments,
    STATE(2755), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3533), 1,
      sym_constraint,
    STATE(4070), 1,
      sym_default_type,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [94536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3664), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3668), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3690), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3686), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3686), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3690), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3618), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3781), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3789), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3797), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94793] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 1,
      anon_sym_DOT,
    ACTIONS(5321), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3565), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3567), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1441), 1,
      anon_sym_DOT,
    ACTIONS(3756), 1,
      anon_sym_EQ,
    ACTIONS(3758), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [94849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 1,
      anon_sym_EQ,
    ACTIONS(5280), 1,
      anon_sym_LT,
    STATE(2437), 1,
      sym_type_arguments,
    ACTIONS(3334), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [94878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1542), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [94902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 1,
      anon_sym_PIPE,
    ACTIONS(1606), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [94926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 1,
      anon_sym_EQ,
    ACTIONS(1381), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_is,
  [94950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5325), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94992] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3430), 1,
      anon_sym_PIPE,
    ACTIONS(5327), 1,
      anon_sym_DOT,
    ACTIONS(5329), 1,
      anon_sym_QMARK_DOT,
    STATE(2544), 1,
      sym_arguments,
    ACTIONS(3432), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_EQ,
    ACTIONS(3773), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_EQ,
    ACTIONS(3608), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3654), 1,
      anon_sym_EQ,
    ACTIONS(3656), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 1,
      anon_sym_EQ,
    ACTIONS(3648), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_EQ,
    ACTIONS(3640), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 1,
      anon_sym_EQ,
    ACTIONS(3440), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_EQ,
    ACTIONS(3538), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_EQ,
    ACTIONS(3563), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_EQ,
    ACTIONS(3765), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3624), 1,
      anon_sym_EQ,
    ACTIONS(3508), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 1,
      anon_sym_EQ,
    ACTIONS(3652), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5331), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 1,
      anon_sym_EQ,
    ACTIONS(5333), 1,
      anon_sym_is,
    ACTIONS(3334), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5335), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95343] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_PIPE,
    ACTIONS(5337), 1,
      anon_sym_LT,
    ACTIONS(5339), 1,
      anon_sym_DOT,
    ACTIONS(5341), 1,
      anon_sym_is,
    STATE(2640), 1,
      sym_type_arguments,
    ACTIONS(3010), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 1,
      anon_sym_EQ,
    ACTIONS(3526), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5343), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym_EQ,
    ACTIONS(3734), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95441] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3424), 1,
      anon_sym_PIPE,
    ACTIONS(5345), 1,
      anon_sym_DOT,
    ACTIONS(5347), 1,
      anon_sym_QMARK_DOT,
    STATE(2530), 1,
      sym_arguments,
    ACTIONS(3426), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 1,
      anon_sym_EQ,
    ACTIONS(3492), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_EQ,
    ACTIONS(3730), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3736), 1,
      anon_sym_EQ,
    ACTIONS(3738), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3712), 1,
      anon_sym_EQ,
    ACTIONS(3714), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3740), 1,
      anon_sym_EQ,
    ACTIONS(3742), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      anon_sym_EQ,
    ACTIONS(3777), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_EQ,
    ACTIONS(5349), 1,
      anon_sym_LBRACK,
    ACTIONS(3530), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3754), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [95637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3783), 1,
      anon_sym_EQ,
    ACTIONS(3785), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_EQ,
    ACTIONS(5349), 1,
      anon_sym_LBRACK,
    ACTIONS(3793), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 1,
      anon_sym_EQ,
    ACTIONS(5284), 1,
      anon_sym_is,
    ACTIONS(3340), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3540), 1,
      anon_sym_EQ,
    ACTIONS(3542), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3813), 1,
      anon_sym_EQ,
    ACTIONS(3815), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 1,
      anon_sym_EQ,
    ACTIONS(3340), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5353), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_EQ,
    ACTIONS(3604), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_EQ,
    ACTIONS(3600), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95867] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym_PIPE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3036), 1,
      anon_sym_DOT,
    ACTIONS(3038), 1,
      anon_sym_QMARK_DOT,
    STATE(2543), 1,
      sym_arguments,
    ACTIONS(3012), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 1,
      anon_sym_EQ,
    ACTIONS(5349), 1,
      anon_sym_LBRACK,
    ACTIONS(3530), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5355), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 1,
      anon_sym_EQ,
    ACTIONS(3334), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [95967] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5359), 1,
      sym_number,
    STATE(4410), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [95995] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym_number,
    STATE(4263), 1,
      sym_string,
    STATE(4267), 1,
      sym_predefined_type,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96025] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5363), 1,
      sym_number,
    STATE(4287), 1,
      sym_predefined_type,
    STATE(4288), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96055] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5365), 1,
      sym_number,
    STATE(4235), 1,
      sym_predefined_type,
    STATE(4236), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96085] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5367), 1,
      sym_number,
    STATE(4206), 1,
      sym_predefined_type,
    STATE(4230), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96115] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5369), 1,
      sym_number,
    STATE(4284), 1,
      sym_predefined_type,
    STATE(4285), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5371), 1,
      sym_number,
    STATE(4290), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96173] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5377), 1,
      anon_sym_BANG,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5383), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3091), 1,
      sym__call_signature,
    STATE(3363), 1,
      sym_type_annotation,
    STATE(3691), 1,
      sym__initializer,
    STATE(3917), 1,
      sym_type_parameters,
    ACTIONS(5375), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96215] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5385), 1,
      sym_number,
    STATE(4241), 1,
      sym_predefined_type,
    STATE(4242), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96245] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_extends,
    ACTIONS(5280), 1,
      anon_sym_LT,
    ACTIONS(5282), 1,
      anon_sym_DOT,
    ACTIONS(5391), 1,
      anon_sym_GT,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(5387), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5389), 2,
      anon_sym_LBRACE,
      sym_jsx_identifier,
    ACTIONS(3010), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [96279] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5394), 1,
      sym_number,
    STATE(4244), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96307] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5398), 1,
      anon_sym_BANG,
    ACTIONS(5400), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3039), 1,
      sym__call_signature,
    STATE(3410), 1,
      sym_type_annotation,
    STATE(3808), 1,
      sym__initializer,
    STATE(3917), 1,
      sym_type_parameters,
    ACTIONS(5396), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_EQ,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(3718), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [96373] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5406), 1,
      anon_sym_BANG,
    ACTIONS(5408), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3053), 1,
      sym__call_signature,
    STATE(3371), 1,
      sym_type_annotation,
    STATE(3695), 1,
      sym__initializer,
    STATE(3917), 1,
      sym_type_parameters,
    ACTIONS(5404), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3736), 1,
      anon_sym_EQ,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(3738), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [96443] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_PIPE,
    ACTIONS(5337), 1,
      anon_sym_LT,
    ACTIONS(5339), 1,
      anon_sym_DOT,
    STATE(2640), 1,
      sym_type_arguments,
    ACTIONS(3010), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96471] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5416), 1,
      anon_sym_BANG,
    ACTIONS(5418), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3002), 1,
      sym__call_signature,
    STATE(3323), 1,
      sym_type_annotation,
    STATE(3752), 1,
      sym__initializer,
    STATE(3917), 1,
      sym_type_parameters,
    ACTIONS(5414), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96513] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5416), 1,
      anon_sym_BANG,
    ACTIONS(5420), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3323), 1,
      sym_type_annotation,
    STATE(3760), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym__initializer,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5414), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96555] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 1,
      anon_sym_EQ,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(3746), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [96583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3516), 1,
      anon_sym_EQ,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(3518), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
  [96609] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5398), 1,
      anon_sym_BANG,
    ACTIONS(5422), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3410), 1,
      sym_type_annotation,
    STATE(3784), 1,
      sym__initializer,
    STATE(3785), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5396), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96651] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5426), 1,
      anon_sym_BANG,
    ACTIONS(5428), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(2993), 1,
      sym__call_signature,
    STATE(3176), 1,
      sym_type_annotation,
    STATE(3640), 1,
      sym__initializer,
    STATE(3917), 1,
      sym_type_parameters,
    ACTIONS(5424), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96693] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5430), 1,
      sym_number,
    STATE(4280), 1,
      sym_predefined_type,
    STATE(4281), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5432), 1,
      sym_number,
    STATE(4226), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 1,
      anon_sym_EQ,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(3440), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [96779] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5434), 1,
      sym_number,
    STATE(4246), 1,
      sym_string,
    STATE(4249), 1,
      sym_predefined_type,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [96809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3708), 1,
      anon_sym_PIPE,
    ACTIONS(3710), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 1,
      anon_sym_PIPE,
    ACTIONS(3706), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_PIPE,
    ACTIONS(3698), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3694), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_PIPE,
    ACTIONS(3698), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3694), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3686), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3686), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 1,
      anon_sym_PIPE,
    ACTIONS(3668), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_PIPE,
    ACTIONS(3664), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 1,
      anon_sym_PIPE,
    ACTIONS(3668), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_PIPE,
    ACTIONS(3664), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97117] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5436), 1,
      sym_number,
    STATE(4269), 1,
      sym_string,
    STATE(4271), 1,
      sym_predefined_type,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 1,
      anon_sym_EQ,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(3550), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [97171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5438), 1,
      sym_number,
    STATE(4349), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97199] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      sym_number,
    STATE(4346), 1,
      sym_predefined_type,
    STATE(4347), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97229] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5442), 1,
      sym_number,
    STATE(4339), 1,
      sym_predefined_type,
    STATE(4341), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 1,
      anon_sym_PIPE,
    ACTIONS(3546), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 1,
      anon_sym_PIPE,
    ACTIONS(3546), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 1,
      anon_sym_PIPE,
    ACTIONS(3546), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3573), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 1,
      anon_sym_EQ,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(3636), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [97375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3573), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 1,
      anon_sym_PIPE,
    ACTIONS(3628), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 1,
      anon_sym_PIPE,
    ACTIONS(3622), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 1,
      anon_sym_PIPE,
    ACTIONS(3622), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 1,
      anon_sym_PIPE,
    ACTIONS(3622), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 1,
      anon_sym_PIPE,
    ACTIONS(3618), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 1,
      anon_sym_PIPE,
    ACTIONS(3618), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 1,
      anon_sym_PIPE,
    ACTIONS(3618), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_PIPE,
    ACTIONS(3612), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_PIPE,
    ACTIONS(3612), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_PIPE,
    ACTIONS(3612), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97617] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5444), 1,
      sym_number,
    STATE(4406), 1,
      sym_predefined_type,
    STATE(4408), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97647] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5446), 1,
      sym_number,
    STATE(4402), 1,
      sym_predefined_type,
    STATE(4403), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97677] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5448), 1,
      sym_number,
    STATE(4335), 1,
      sym_predefined_type,
    STATE(4337), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97707] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 1,
      anon_sym_EQ,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(3644), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [97735] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5450), 1,
      sym_number,
    STATE(4396), 1,
      sym_predefined_type,
    STATE(4398), 1,
      sym_string,
    ACTIONS(5357), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [97765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_PIPE,
    ACTIONS(3583), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_PIPE,
    ACTIONS(3577), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_PIPE,
    ACTIONS(3577), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_PIPE,
    ACTIONS(3577), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3573), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97875] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5454), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2922), 1,
      sym__call_signature,
    STATE(3311), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5452), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97910] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5458), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2886), 1,
      sym__call_signature,
    STATE(3372), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5456), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_PIPE,
    ACTIONS(5460), 1,
      anon_sym_DOT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3567), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97970] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5464), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_DOT,
    ACTIONS(5468), 1,
      anon_sym_QMARK_DOT,
    STATE(2626), 1,
      sym_arguments,
    ACTIONS(3012), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [97997] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5464), 1,
      anon_sym_LPAREN,
    ACTIONS(5470), 1,
      anon_sym_DOT,
    ACTIONS(5472), 1,
      anon_sym_QMARK_DOT,
    STATE(2627), 1,
      sym_arguments,
    ACTIONS(3426), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3277), 1,
      sym_type_predicate,
    STATE(4435), 1,
      sym_predefined_type,
    ACTIONS(5474), 2,
      sym_identifier,
      sym_this,
    ACTIONS(203), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [98049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2551), 1,
      anon_sym_PIPE,
    ACTIONS(2553), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98070] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5296), 1,
      anon_sym_LT,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(5478), 1,
      anon_sym_GT,
    ACTIONS(5480), 1,
      anon_sym_SLASH,
    STATE(2786), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2808), 1,
      sym_type_arguments,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [98111] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5482), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3311), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5452), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_PIPE,
    ACTIONS(2557), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98167] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3094), 1,
      sym_type_predicate,
    STATE(4372), 1,
      sym_predefined_type,
    ACTIONS(5484), 2,
      sym_identifier,
      sym_this,
    ACTIONS(203), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [98192] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5488), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2940), 1,
      sym__call_signature,
    STATE(3426), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5486), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1441), 1,
      anon_sym_DOT,
    ACTIONS(3756), 1,
      anon_sym_PIPE,
    ACTIONS(3758), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 1,
      anon_sym_PIPE,
    ACTIONS(3789), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98271] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5492), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3352), 1,
      sym__call_signature,
    STATE(3353), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5490), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4001), 1,
      sym_type_predicate,
    STATE(4144), 1,
      sym_predefined_type,
    ACTIONS(5494), 2,
      sym_identifier,
      sym_this,
    ACTIONS(203), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [98331] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5496), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3372), 1,
      sym_type_annotation,
    STATE(3373), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5456), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98366] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5500), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3395), 1,
      sym__call_signature,
    STATE(3399), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5498), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 1,
      anon_sym_LT,
    ACTIONS(5504), 1,
      anon_sym_DOT,
    ACTIONS(5506), 1,
      anon_sym_is,
    STATE(2829), 1,
      sym_type_arguments,
    ACTIONS(3010), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 1,
      anon_sym_PIPE,
    ACTIONS(5337), 1,
      anon_sym_LT,
    STATE(2631), 1,
      sym_type_arguments,
    ACTIONS(3334), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98453] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5508), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3424), 1,
      sym__call_signature,
    STATE(3426), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5486), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98488] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5296), 1,
      anon_sym_LT,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(5478), 1,
      anon_sym_GT,
    ACTIONS(5510), 1,
      anon_sym_SLASH,
    STATE(2835), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2836), 1,
      sym_type_arguments,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [98529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5512), 1,
      anon_sym_COLON,
    ACTIONS(5514), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2915), 1,
      sym__call_signature,
    STATE(3353), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5490), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98564] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5516), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2939), 1,
      sym__call_signature,
    STATE(3399), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5498), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_PIPE,
    ACTIONS(2549), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98620] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5464), 1,
      anon_sym_LPAREN,
    ACTIONS(5518), 1,
      anon_sym_DOT,
    ACTIONS(5520), 1,
      anon_sym_QMARK_DOT,
    STATE(2629), 1,
      sym_arguments,
    ACTIONS(3432), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 1,
      anon_sym_PIPE,
    ACTIONS(3797), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_PIPE,
    ACTIONS(3781), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98689] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3023), 1,
      sym__call_signature,
    STATE(3413), 1,
      sym_type_annotation,
    STATE(3803), 1,
      sym__initializer,
    STATE(3917), 1,
      sym_type_parameters,
    ACTIONS(5522), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98743] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 1,
      anon_sym_LT,
    ACTIONS(5504), 1,
      anon_sym_DOT,
    STATE(2829), 1,
      sym_type_arguments,
    ACTIONS(3010), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98767] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3082), 1,
      sym__call_signature,
    STATE(3226), 1,
      sym_type_annotation,
    STATE(3654), 1,
      sym__initializer,
    STATE(3917), 1,
      sym_type_parameters,
    ACTIONS(5524), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98803] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3389), 1,
      sym__call_signature,
    STATE(3394), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5526), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98835] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3374), 1,
      sym_type_annotation,
    STATE(3375), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5528), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98867] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2866), 1,
      sym__call_signature,
    STATE(3394), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5526), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98899] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3111), 1,
      sym__call_signature,
    STATE(3443), 1,
      sym_type_annotation,
    STATE(3825), 1,
      sym__initializer,
    STATE(3917), 1,
      sym_type_parameters,
    ACTIONS(5530), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3698), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3694), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3698), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3694), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3690), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3686), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3690), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99097] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5296), 1,
      anon_sym_LT,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5478), 1,
      anon_sym_GT,
    ACTIONS(5480), 1,
      anon_sym_SLASH,
    STATE(2785), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2808), 1,
      sym_type_arguments,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [99135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3686), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99153] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2950), 1,
      sym__call_signature,
    STATE(3431), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5532), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3668), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3664), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3668), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3664), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3628), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99275] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3430), 1,
      sym__call_signature,
    STATE(3431), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5532), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 1,
      anon_sym_PIPE,
    ACTIONS(1381), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [99327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 1,
      anon_sym_PIPE,
    ACTIONS(5341), 1,
      anon_sym_is,
    ACTIONS(3340), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 1,
      anon_sym_PIPE,
    ACTIONS(5534), 1,
      anon_sym_is,
    ACTIONS(3334), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [99371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3622), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99389] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3050), 1,
      sym__call_signature,
    STATE(3391), 1,
      sym_type_annotation,
    STATE(3701), 1,
      sym__initializer,
    STATE(3917), 1,
      sym_type_parameters,
    ACTIONS(5536), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99425] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5296), 1,
      anon_sym_LT,
    ACTIONS(5301), 1,
      anon_sym_SLASH,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5478), 1,
      anon_sym_GT,
    STATE(2816), 1,
      sym_type_arguments,
    STATE(2821), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [99463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3622), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99481] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3413), 1,
      sym_type_annotation,
    STATE(3791), 1,
      sym__initializer,
    STATE(3793), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5522), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3622), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3618), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99553] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2920), 1,
      sym__call_signature,
    STATE(3288), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5538), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3618), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99603] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3246), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [99631] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3212), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [99659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3618), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99695] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3005), 1,
      sym__call_signature,
    STATE(3333), 1,
      sym_type_annotation,
    STATE(3766), 1,
      sym__initializer,
    STATE(3917), 1,
      sym_type_parameters,
    ACTIONS(5540), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99767] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [99795] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5296), 1,
      anon_sym_LT,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5317), 1,
      anon_sym_SLASH,
    ACTIONS(5478), 1,
      anon_sym_GT,
    STATE(2737), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2753), 1,
      sym_type_arguments,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [99833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3583), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99851] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    ACTIONS(5280), 1,
      anon_sym_LT,
    ACTIONS(5282), 1,
      anon_sym_DOT,
    ACTIONS(5542), 1,
      anon_sym_QMARK,
    STATE(2429), 1,
      sym_type_arguments,
    STATE(3899), 1,
      sym_type_annotation,
    ACTIONS(3010), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99917] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3255), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [99945] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3288), 1,
      sym_type_annotation,
    STATE(3306), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5538), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [99995] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2863), 1,
      sym__call_signature,
    STATE(3374), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5528), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100027] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3391), 1,
      sym_type_annotation,
    STATE(3677), 1,
      sym__initializer,
    STATE(3680), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5536), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100081] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3241), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [100109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [100127] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5296), 1,
      anon_sym_LT,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5478), 1,
      anon_sym_GT,
    ACTIONS(5510), 1,
      anon_sym_SLASH,
    STATE(2832), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2836), 1,
      sym_type_arguments,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [100165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3546), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3546), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3546), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100255] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2924), 1,
      sym__call_signature,
    STATE(3337), 1,
      sym_type_annotation,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5545), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100287] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3337), 1,
      sym_type_annotation,
    STATE(3338), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
    ACTIONS(5545), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym_PIPE,
    ACTIONS(3734), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 1,
      anon_sym_PIPE,
    ACTIONS(3334), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [100374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 1,
      anon_sym_LT,
    STATE(2825), 1,
      sym_type_arguments,
    ACTIONS(3334), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_PIPE,
    ACTIONS(2003), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_PIPE,
    ACTIONS(3640), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2557), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(3440), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [100473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3654), 1,
      anon_sym_PIPE,
    ACTIONS(3656), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_PIPE,
    ACTIONS(3750), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5553), 1,
      anon_sym_DOT,
    ACTIONS(5555), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3567), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2549), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1441), 1,
      anon_sym_DOT,
    ACTIONS(3758), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 1,
      anon_sym_PIPE,
    ACTIONS(3440), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 1,
      anon_sym_PIPE,
    ACTIONS(3648), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      anon_sym_PIPE,
    ACTIONS(3801), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3813), 1,
      anon_sym_PIPE,
    ACTIONS(3815), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(3644), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [100718] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(3636), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [100741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_PIPE,
    ACTIONS(5557), 1,
      anon_sym_LBRACK,
    ACTIONS(3793), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      anon_sym_PIPE,
    ACTIONS(3777), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_PIPE,
    ACTIONS(3773), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3783), 1,
      anon_sym_PIPE,
    ACTIONS(3785), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(5557), 1,
      anon_sym_LBRACK,
    ACTIONS(3530), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(3754), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(3746), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [100865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3740), 1,
      anon_sym_PIPE,
    ACTIONS(3742), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_PIPE,
    ACTIONS(3730), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3492), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(3550), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 1,
      anon_sym_PIPE,
    ACTIONS(3652), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3624), 1,
      anon_sym_PIPE,
    ACTIONS(3508), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2553), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_PIPE,
    ACTIONS(3765), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 1,
      anon_sym_PIPE,
    ACTIONS(1995), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2001), 1,
      anon_sym_PIPE,
    ACTIONS(1999), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(3738), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [101078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3608), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_PIPE,
    ACTIONS(3604), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3736), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_PIPE,
    ACTIONS(3600), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(3718), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 1,
      anon_sym_PIPE,
    ACTIONS(1991), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_PIPE,
    ACTIONS(3563), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3724), 1,
      anon_sym_PIPE,
    ACTIONS(3726), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_PIPE,
    ACTIONS(3538), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 1,
      anon_sym_PIPE,
    ACTIONS(3526), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(3518), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(5557), 1,
      anon_sym_LBRACK,
    ACTIONS(3530), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3712), 1,
      anon_sym_PIPE,
    ACTIONS(3714), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4742), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [101348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3540), 1,
      anon_sym_PIPE,
    ACTIONS(3542), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 1,
      anon_sym_PIPE,
    ACTIONS(2007), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_is,
    ACTIONS(3334), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101423] = 7,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5563), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      sym_jsx_text,
    ACTIONS(5567), 1,
      sym_comment,
    STATE(1468), 1,
      sym_jsx_closing_element,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2752), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [101449] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5569), 1,
      anon_sym_LT,
    ACTIONS(5571), 1,
      anon_sym_DQUOTE,
    ACTIONS(5573), 1,
      anon_sym_SQUOTE,
    STATE(2696), 1,
      sym_jsx_opening_element,
    STATE(3272), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [101475] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5569), 1,
      anon_sym_LT,
    ACTIONS(5571), 1,
      anon_sym_DQUOTE,
    ACTIONS(5573), 1,
      anon_sym_SQUOTE,
    STATE(2696), 1,
      sym_jsx_opening_element,
    STATE(3271), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [101501] = 7,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5565), 1,
      sym_jsx_text,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5575), 1,
      anon_sym_LT,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(3177), 1,
      sym_jsx_closing_element,
    STATE(2752), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [101527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5309), 1,
      anon_sym_DOT,
    ACTIONS(5311), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5577), 1,
      anon_sym_LPAREN,
    STATE(2394), 1,
      sym_arguments,
    ACTIONS(3432), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101551] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      sym_identifier,
    ACTIONS(5583), 1,
      anon_sym_COMMA,
    ACTIONS(5585), 1,
      anon_sym_RBRACE,
    STATE(3627), 1,
      sym_import_specifier,
    ACTIONS(5581), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(4300), 2,
      sym__module_export_name,
      sym_string,
  [101581] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5317), 1,
      anon_sym_SLASH,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(5478), 1,
      anon_sym_GT,
    STATE(2822), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [101613] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5577), 1,
      anon_sym_LPAREN,
    STATE(2396), 1,
      sym_arguments,
    ACTIONS(3012), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101637] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5589), 1,
      anon_sym_BANG,
    STATE(3193), 1,
      sym_type_annotation,
    STATE(3613), 1,
      sym__initializer,
    ACTIONS(5591), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5587), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101665] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3227), 1,
      anon_sym_LBRACE,
    ACTIONS(5593), 1,
      sym_identifier,
    ACTIONS(5595), 1,
      anon_sym_STAR,
    STATE(4032), 1,
      sym_import_clause,
    STATE(4075), 1,
      sym_string,
    STATE(4076), 1,
      sym_import_require_clause,
    STATE(4411), 2,
      sym_namespace_import,
      sym_named_imports,
  [101697] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5589), 1,
      anon_sym_BANG,
    ACTIONS(5597), 1,
      anon_sym_EQ,
    STATE(3193), 1,
      sym_type_annotation,
    STATE(3256), 1,
      sym__initializer,
    ACTIONS(5591), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5587), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101725] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(5478), 1,
      anon_sym_GT,
    ACTIONS(5480), 1,
      anon_sym_SLASH,
    STATE(2788), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [101757] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5599), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    STATE(1869), 1,
      sym_class_body,
    STATE(2930), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3841), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [101791] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    ACTIONS(5607), 1,
      sym_identifier,
    STATE(1869), 1,
      sym_class_body,
    STATE(2930), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3841), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [101825] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    ACTIONS(5609), 1,
      sym_identifier,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(1510), 1,
      sym_class_body,
    STATE(2971), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4069), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [101859] = 7,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5563), 1,
      anon_sym_LT,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5613), 1,
      sym_jsx_text,
    STATE(1516), 1,
      sym_jsx_closing_element,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2669), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [101885] = 7,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5565), 1,
      sym_jsx_text,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5615), 1,
      anon_sym_LT,
    STATE(1916), 1,
      sym_jsx_closing_element,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2752), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [101911] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    ACTIONS(5617), 1,
      sym_identifier,
    STATE(1920), 1,
      sym_class_body,
    STATE(2952), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3889), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [101945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      anon_sym_COLON,
    STATE(3096), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5619), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101965] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5313), 1,
      anon_sym_DOT,
    ACTIONS(5315), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5577), 1,
      anon_sym_LPAREN,
    STATE(2395), 1,
      sym_arguments,
    ACTIONS(3426), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101989] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5301), 1,
      anon_sym_SLASH,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(5478), 1,
      anon_sym_GT,
    STATE(2811), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [102021] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(5623), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102043] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(5625), 1,
      sym_identifier,
    ACTIONS(5629), 1,
      anon_sym_COMMA,
    ACTIONS(5631), 1,
      anon_sym_RBRACE,
    STATE(3747), 1,
      sym_export_specifier,
    ACTIONS(5627), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(3745), 2,
      sym__module_export_name,
      sym_string,
  [102073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_is,
    ACTIONS(3340), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5280), 1,
      anon_sym_LT,
    ACTIONS(5282), 1,
      anon_sym_DOT,
    ACTIONS(5633), 1,
      anon_sym_is,
    STATE(2429), 1,
      sym_type_arguments,
    ACTIONS(3010), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3206), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [102135] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    ACTIONS(5635), 1,
      sym_identifier,
    STATE(1920), 1,
      sym_class_body,
    STATE(2952), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3889), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102169] = 7,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5575), 1,
      anon_sym_LT,
    ACTIONS(5637), 1,
      sym_jsx_text,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(3217), 1,
      sym_jsx_closing_element,
    STATE(2672), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [102195] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      sym_identifier,
    STATE(1920), 1,
      sym_class_body,
    STATE(2952), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3889), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102229] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5641), 1,
      sym_identifier,
    STATE(1482), 1,
      sym_class_body,
    STATE(2919), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3919), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102263] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    ACTIONS(5643), 1,
      sym_identifier,
    STATE(1920), 1,
      sym_class_body,
    STATE(2952), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3889), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102297] = 7,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5565), 1,
      sym_jsx_text,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5645), 1,
      anon_sym_LT,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(3755), 1,
      sym_jsx_closing_element,
    STATE(2752), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [102323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      anon_sym_COLON,
    STATE(3101), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5647), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102343] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(5478), 1,
      anon_sym_GT,
    ACTIONS(5510), 1,
      anon_sym_SLASH,
    STATE(2791), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [102375] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5649), 1,
      sym_identifier,
    STATE(2064), 1,
      sym_class_body,
    STATE(2887), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4095), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102409] = 7,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5645), 1,
      anon_sym_LT,
    ACTIONS(5651), 1,
      sym_jsx_text,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(3635), 1,
      sym_jsx_closing_element,
    STATE(2700), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [102435] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    ACTIONS(5653), 1,
      sym_identifier,
    STATE(1869), 1,
      sym_class_body,
    STATE(2930), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3841), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102469] = 7,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5615), 1,
      anon_sym_LT,
    ACTIONS(5655), 1,
      sym_jsx_text,
    STATE(1976), 1,
      sym_jsx_closing_element,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2685), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [102495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1381), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [102511] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_extends,
    ACTIONS(5605), 1,
      anon_sym_implements,
    ACTIONS(5657), 1,
      sym_identifier,
    STATE(1869), 1,
      sym_class_body,
    STATE(2930), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3841), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102545] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1511), 1,
      sym_class_body,
    STATE(2905), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3870), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102576] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      sym_identifier,
    ACTIONS(5663), 1,
      anon_sym_RBRACE,
    STATE(3971), 1,
      sym_import_specifier,
    ACTIONS(5581), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(4300), 2,
      sym__module_export_name,
      sym_string,
  [102603] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3363), 1,
      sym_type_annotation,
    STATE(3681), 1,
      sym__initializer,
    ACTIONS(5377), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5375), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3542), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3340), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102658] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1937), 1,
      sym_class_body,
    STATE(2931), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3986), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [102704] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3193), 1,
      sym_type_annotation,
    STATE(3603), 1,
      sym__initializer,
    ACTIONS(5591), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5587), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102729] = 6,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5565), 1,
      sym_jsx_text,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5667), 1,
      anon_sym_LT,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2752), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [102752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 1,
      anon_sym_LBRACK,
    ACTIONS(3530), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3334), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102799] = 6,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5671), 1,
      anon_sym_LT,
    ACTIONS(5673), 1,
      sym_jsx_text,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2717), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [102822] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4829), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [102847] = 6,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5565), 1,
      sym_jsx_text,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5675), 1,
      anon_sym_LT,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2752), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [102870] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(2954), 1,
      sym_type_parameters,
    STATE(3197), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4019), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5679), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [102916] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_class_body,
    STATE(2904), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3987), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [102947] = 6,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5681), 1,
      anon_sym_LT,
    ACTIONS(5683), 1,
      sym_jsx_text,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2723), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [102970] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(5625), 1,
      sym_identifier,
    ACTIONS(5685), 1,
      anon_sym_RBRACE,
    STATE(3995), 1,
      sym_export_specifier,
    ACTIONS(5627), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(3745), 2,
      sym__module_export_name,
      sym_string,
  [102997] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5687), 1,
      anon_sym_GT,
    ACTIONS(5689), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [103026] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5691), 1,
      anon_sym_LBRACE,
    STATE(171), 1,
      sym_class_body,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3999), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [103057] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1834), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [103082] = 6,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5693), 1,
      anon_sym_LT,
    ACTIONS(5695), 1,
      sym_jsx_text,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2810), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103105] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(5697), 1,
      anon_sym_EQ,
    ACTIONS(5623), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [103128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103143] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5301), 1,
      anon_sym_SLASH,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5478), 1,
      anon_sym_GT,
    STATE(2823), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [103172] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5699), 1,
      anon_sym_GT,
    ACTIONS(5701), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [103201] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5703), 1,
      anon_sym_GT,
    ACTIONS(5705), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [103230] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3410), 1,
      sym_type_annotation,
    STATE(3796), 1,
      sym__initializer,
    ACTIONS(5398), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5396), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_AMP,
    ACTIONS(3550), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [103302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3492), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103332] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5691), 1,
      anon_sym_LBRACE,
    STATE(180), 1,
      sym_class_body,
    STATE(2969), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4037), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [103363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_PIPE,
    ACTIONS(5711), 1,
      anon_sym_extends,
    ACTIONS(3746), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [103384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 1,
      anon_sym_LBRACK,
    ACTIONS(3530), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3754), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3785), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 1,
      anon_sym_LBRACK,
    ACTIONS(3793), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103435] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1967), 1,
      sym_class_body,
    STATE(2955), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4061), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [103466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_PIPE,
    ACTIONS(5711), 1,
      anon_sym_extends,
    ACTIONS(3644), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [103487] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(629), 1,
      sym_class_body,
    STATE(2953), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3958), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [103518] = 6,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5713), 1,
      anon_sym_LBRACE,
    ACTIONS(5716), 1,
      anon_sym_LT,
    ACTIONS(5719), 1,
      sym_jsx_text,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2752), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103541] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5722), 1,
      anon_sym_GT,
    ACTIONS(5724), 1,
      anon_sym_SLASH,
    STATE(2729), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [103570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103585] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5726), 1,
      anon_sym_GT,
    ACTIONS(5728), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [103614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 1,
      anon_sym_COLON,
    STATE(3319), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5647), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103633] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1958), 1,
      sym_class_body,
    STATE(2908), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3975), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [103664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [103679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3750), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1889), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [103734] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4875), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [103759] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(1891), 1,
      anon_sym_RBRACE,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3702), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [103784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3773), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103814] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(5625), 1,
      sym_identifier,
    ACTIONS(5734), 1,
      anon_sym_RBRACE,
    STATE(3995), 1,
      sym_export_specifier,
    ACTIONS(5627), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(3745), 2,
      sym__module_export_name,
      sym_string,
  [103841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3765), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103856] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3423), 1,
      sym_type_annotation,
    STATE(3775), 1,
      sym__initializer,
    ACTIONS(5738), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5736), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103881] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_PIPE,
    ACTIONS(5711), 1,
      anon_sym_extends,
    ACTIONS(3738), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [103902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3738), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_AMP,
    ACTIONS(3718), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [103949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3714), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103964] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1934), 1,
      sym_class_body,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4026), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [103995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3801), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104025] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5740), 1,
      anon_sym_LBRACE,
    STATE(741), 1,
      sym_class_body,
    STATE(2941), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4025), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [104056] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5740), 1,
      anon_sym_LBRACE,
    STATE(675), 1,
      sym_class_body,
    STATE(2968), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3850), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [104087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2007), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104102] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5687), 1,
      anon_sym_GT,
    ACTIONS(5742), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104131] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5699), 1,
      anon_sym_GT,
    ACTIONS(5744), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104160] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      sym_identifier,
    ACTIONS(5746), 1,
      anon_sym_RBRACE,
    STATE(3971), 1,
      sym_import_specifier,
    ACTIONS(5581), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(4300), 2,
      sym__module_export_name,
      sym_string,
  [104187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 1,
      anon_sym_COLON,
    STATE(3303), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5619), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104206] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4889), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [104231] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5703), 1,
      anon_sym_GT,
    ACTIONS(5748), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104260] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5726), 1,
      anon_sym_GT,
    ACTIONS(5750), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104304] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5752), 1,
      anon_sym_GT,
    ACTIONS(5754), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104333] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5478), 1,
      anon_sym_GT,
    ACTIONS(5480), 1,
      anon_sym_SLASH,
    STATE(2781), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104362] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5597), 1,
      anon_sym_EQ,
    STATE(3193), 1,
      sym_type_annotation,
    STATE(3259), 1,
      sym__initializer,
    ACTIONS(5591), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5587), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104387] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5752), 1,
      anon_sym_GT,
    ACTIONS(5756), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104416] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3896), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [104447] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(2069), 1,
      sym_class_body,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3951), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [104478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3656), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104508] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5478), 1,
      anon_sym_GT,
    ACTIONS(5510), 1,
      anon_sym_SLASH,
    STATE(2827), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [104552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3640), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_PIPE,
    ACTIONS(5711), 1,
      anon_sym_extends,
    ACTIONS(3440), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [104588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3440), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3726), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5760), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [104648] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5762), 1,
      sym_identifier,
    ACTIONS(5765), 1,
      anon_sym_LBRACE,
    ACTIONS(5768), 1,
      anon_sym_GT,
    ACTIONS(5770), 1,
      anon_sym_SLASH,
    ACTIONS(5772), 1,
      sym_jsx_identifier,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104677] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5687), 1,
      anon_sym_GT,
    ACTIONS(5775), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104706] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1943), 1,
      sym_class_body,
    STATE(2878), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3888), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [104737] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3323), 1,
      sym_type_annotation,
    STATE(3759), 1,
      sym__initializer,
    ACTIONS(5416), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5414), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104762] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5722), 1,
      anon_sym_GT,
    ACTIONS(5777), 1,
      anon_sym_SLASH,
    STATE(2780), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104791] = 6,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5565), 1,
      sym_jsx_text,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LT,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2752), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [104814] = 6,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5565), 1,
      sym_jsx_text,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LT,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2752), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [104837] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5752), 1,
      anon_sym_GT,
    ACTIONS(5783), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104866] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4849), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3802), 1,
      aux_sym_object_repeat1,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [104891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3608), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104936] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5722), 1,
      anon_sym_GT,
    ACTIONS(5785), 1,
      anon_sym_SLASH,
    STATE(2805), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104980] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(2883), 1,
      sym_type_parameters,
    STATE(3283), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4094), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [105011] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5317), 1,
      anon_sym_SLASH,
    ACTIONS(5478), 1,
      anon_sym_GT,
    STATE(2736), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105040] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5687), 1,
      anon_sym_GT,
    ACTIONS(5787), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105069] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5703), 1,
      anon_sym_GT,
    ACTIONS(5789), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105098] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5752), 1,
      anon_sym_GT,
    ACTIONS(5791), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105127] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5699), 1,
      anon_sym_GT,
    ACTIONS(5793), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105156] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1962), 1,
      sym_class_body,
    STATE(2865), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3970), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [105187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3815), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105202] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3371), 1,
      sym_type_annotation,
    STATE(3686), 1,
      sym__initializer,
    ACTIONS(5406), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5404), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105227] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5699), 1,
      anon_sym_GT,
    ACTIONS(5795), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3538), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3742), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_PIPE,
    ACTIONS(3518), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [105305] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(2961), 1,
      sym_type_parameters,
    STATE(3249), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4055), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [105336] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5703), 1,
      anon_sym_GT,
    ACTIONS(5797), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105365] = 6,
    ACTIONS(5561), 1,
      anon_sym_LBRACE,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(5799), 1,
      anon_sym_LT,
    ACTIONS(5801), 1,
      sym_jsx_text,
    STATE(2704), 1,
      sym_jsx_opening_element,
    STATE(2809), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [105388] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5726), 1,
      anon_sym_GT,
    ACTIONS(5803), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105417] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5726), 1,
      anon_sym_GT,
    ACTIONS(5805), 1,
      anon_sym_SLASH,
    STATE(2804), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105446] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      sym_identifier,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    ACTIONS(5303), 1,
      sym_jsx_identifier,
    ACTIONS(5722), 1,
      anon_sym_GT,
    ACTIONS(5807), 1,
      anon_sym_SLASH,
    STATE(2820), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3064), 1,
      sym_jsx_namespace_name,
    STATE(3253), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105475] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1451), 1,
      sym_class_body,
    STATE(2965), 1,
      sym_type_parameters,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4042), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [105506] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_PIPE,
    ACTIONS(5711), 1,
      anon_sym_extends,
    ACTIONS(3636), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [105527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2557), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      sym_identifier,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LBRACK,
    ACTIONS(5815), 1,
      anon_sym_enum,
    STATE(3534), 1,
      sym_variable_declarator,
    STATE(2945), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [105565] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5817), 1,
      sym_escape_sequence,
    ACTIONS(5819), 1,
      anon_sym_BQUOTE,
    ACTIONS(5821), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5823), 1,
      sym__template_chars,
    STATE(2997), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3194), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5817), 1,
      sym_escape_sequence,
    ACTIONS(5821), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5823), 1,
      sym__template_chars,
    ACTIONS(5825), 1,
      anon_sym_BQUOTE,
    STATE(2997), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3194), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105613] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(5625), 1,
      sym_identifier,
    STATE(3995), 1,
      sym_export_specifier,
    ACTIONS(5627), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(3745), 2,
      sym__module_export_name,
      sym_string,
  [105637] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      sym_identifier,
    STATE(3971), 1,
      sym_import_specifier,
    ACTIONS(5581), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(4300), 2,
      sym__module_export_name,
      sym_string,
  [105661] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5817), 1,
      sym_escape_sequence,
    ACTIONS(5821), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5823), 1,
      sym__template_chars,
    ACTIONS(5827), 1,
      anon_sym_BQUOTE,
    STATE(2997), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3393), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105685] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(5589), 1,
      anon_sym_BANG,
    STATE(3193), 1,
      sym_type_annotation,
    STATE(3613), 1,
      sym__initializer,
    ACTIONS(5587), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(5829), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1443), 3,
      anon_sym_while,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1441), 5,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_DOT,
  [105745] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5821), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5823), 1,
      sym__template_chars,
    ACTIONS(5831), 1,
      sym_escape_sequence,
    ACTIONS(5833), 1,
      anon_sym_BQUOTE,
    STATE(3107), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3194), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(5835), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105789] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_PIPE,
    ACTIONS(5711), 1,
      anon_sym_extends,
    ACTIONS(5623), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105809] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5817), 1,
      sym_escape_sequence,
    ACTIONS(5821), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5823), 1,
      sym__template_chars,
    ACTIONS(5837), 1,
      anon_sym_BQUOTE,
    STATE(2997), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3194), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105833] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5817), 1,
      sym_escape_sequence,
    ACTIONS(5821), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5823), 1,
      sym__template_chars,
    ACTIONS(5839), 1,
      anon_sym_BQUOTE,
    STATE(2997), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3194), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2553), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105871] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5821), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5823), 1,
      sym__template_chars,
    ACTIONS(5831), 1,
      sym_escape_sequence,
    ACTIONS(5841), 1,
      anon_sym_BQUOTE,
    STATE(3107), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3194), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2549), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    ACTIONS(5845), 1,
      anon_sym_DOT,
    STATE(3387), 1,
      sym_statement_block,
    ACTIONS(1393), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105929] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(4101), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5847), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(1455), 2,
      sym_template_string,
      sym_arguments,
  [105953] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      sym_identifier,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LBRACK,
    ACTIONS(5849), 1,
      anon_sym_enum,
    STATE(3520), 1,
      sym_variable_declarator,
    STATE(2945), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [105977] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5817), 1,
      sym_escape_sequence,
    ACTIONS(5821), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5823), 1,
      sym__template_chars,
    ACTIONS(5851), 1,
      anon_sym_BQUOTE,
    STATE(2997), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3194), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [106001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4003), 1,
      sym_statement_block,
    ACTIONS(5853), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(5037), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [106035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3881), 1,
      sym_statement_block,
    ACTIONS(5855), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [106065] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1862), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3918), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [106090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3857), 1,
      sym_statement_block,
    ACTIONS(5859), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3954), 1,
      sym_statement_block,
    ACTIONS(5861), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3946), 1,
      sym_statement_block,
    ACTIONS(5859), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5341), 1,
      anon_sym_is,
    ACTIONS(5863), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106156] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5865), 1,
      sym_identifier,
    ACTIONS(5867), 1,
      anon_sym_DOT,
    STATE(631), 1,
      sym_string,
    STATE(653), 1,
      sym__module,
    STATE(3508), 1,
      sym_nested_identifier,
  [106181] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5869), 1,
      anon_sym_LBRACE,
    ACTIONS(5871), 1,
      anon_sym_COMMA,
    ACTIONS(5873), 1,
      anon_sym_LT,
    ACTIONS(5875), 1,
      anon_sym_DOT,
    ACTIONS(5877), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3487), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3597), 1,
      sym_type_arguments,
  [106206] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5879), 1,
      sym_identifier,
    ACTIONS(5881), 1,
      anon_sym_STAR,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4051), 1,
      sym__call_signature,
  [106231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    STATE(1455), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [106250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3336), 1,
      sym_type_annotation,
    ACTIONS(5887), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3287), 1,
      sym_type_annotation,
    ACTIONS(5889), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [106297] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3254), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4057), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [106322] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1886), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3858), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [106347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3333), 1,
      sym_type_annotation,
    STATE(3762), 1,
      sym__initializer,
    ACTIONS(5540), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106368] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(5895), 1,
      anon_sym_EQ,
    ACTIONS(5893), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5897), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [106387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_EQ,
    ACTIONS(3057), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [106402] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      sym_identifier,
    ACTIONS(5903), 1,
      anon_sym_STAR,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4024), 1,
      sym__call_signature,
  [106427] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3216), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4029), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [106452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3750), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_BQUOTE,
  [106467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3724), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3726), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_BQUOTE,
  [106482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3927), 1,
      sym_statement_block,
    ACTIONS(5905), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106499] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(2063), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3950), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [106524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LBRACK,
    ACTIONS(5907), 1,
      sym_identifier,
    STATE(3534), 1,
      sym_variable_declarator,
    STATE(2716), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [106545] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5691), 1,
      anon_sym_LBRACE,
    STATE(177), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3851), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [106570] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LBRACK,
    ACTIONS(5909), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_variable_declarator,
    STATE(2790), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [106591] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LBRACK,
    ACTIONS(5911), 1,
      sym_identifier,
    STATE(3587), 1,
      sym_variable_declarator,
    STATE(2945), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [106612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4414), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4399), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    ACTIONS(5296), 1,
      anon_sym_LT,
    STATE(1884), 1,
      sym_arguments,
    STATE(4110), 1,
      sym_type_arguments,
    ACTIONS(5913), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [106659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106672] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5915), 1,
      sym_identifier,
    ACTIONS(5917), 1,
      anon_sym_STAR,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3935), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [106697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    STATE(3387), 1,
      sym_statement_block,
    ACTIONS(1393), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106714] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5919), 1,
      sym_identifier,
    ACTIONS(5921), 1,
      anon_sym_STAR,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3875), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [106739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LBRACK,
    ACTIONS(5911), 1,
      sym_identifier,
    STATE(3520), 1,
      sym_variable_declarator,
    STATE(2945), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [106760] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LBRACK,
    ACTIONS(5911), 1,
      sym_identifier,
    STATE(3466), 1,
      sym_variable_declarator,
    STATE(2945), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [106781] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3443), 1,
      sym_type_annotation,
    STATE(3754), 1,
      sym__initializer,
    ACTIONS(5530), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5923), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [106828] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(628), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3879), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [106853] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1457), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4050), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [106878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4742), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [106891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 1,
      anon_sym_EQ,
    ACTIONS(3076), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [106906] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1905), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3837), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [106931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4000), 1,
      sym_statement_block,
    ACTIONS(5928), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106948] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5930), 1,
      sym_identifier,
    ACTIONS(5932), 1,
      anon_sym_STAR,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3935), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [106973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5679), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [106999] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(2065), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3852), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5760), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4010), 1,
      sym_statement_block,
    ACTIONS(5934), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1441), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [107067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107080] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3351), 1,
      sym_type_annotation,
    STATE(3774), 1,
      sym__initializer,
    ACTIONS(5936), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107101] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1518), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4058), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3983), 1,
      sym_statement_block,
    ACTIONS(5938), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3413), 1,
      sym_type_annotation,
    STATE(3806), 1,
      sym__initializer,
    ACTIONS(5522), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4106), 1,
      sym_statement_block,
    ACTIONS(5940), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3842), 1,
      sym_statement_block,
    ACTIONS(5940), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3956), 1,
      sym_statement_block,
    ACTIONS(5853), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4108), 1,
      sym_statement_block,
    ACTIONS(5905), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107232] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(205), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1230), 1,
      anon_sym_LBRACE,
    ACTIONS(5942), 1,
      anon_sym_LT,
    ACTIONS(5944), 1,
      anon_sym_extends,
    STATE(744), 1,
      sym_object_type,
    STATE(3432), 1,
      sym_type_parameters,
    STATE(3767), 1,
      sym_extends_type_clause,
  [107257] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5867), 1,
      anon_sym_DOT,
    ACTIONS(5946), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(631), 1,
      sym_string,
    STATE(653), 1,
      sym__module,
  [107282] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5948), 1,
      sym_identifier,
    ACTIONS(5950), 1,
      anon_sym_STAR,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3935), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [107307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3844), 1,
      sym_statement_block,
    ACTIONS(5938), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107324] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1944), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3965), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107349] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1919), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3945), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107374] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1864), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3979), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3877), 1,
      sym_statement_block,
    ACTIONS(5952), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3887), 1,
      sym_statement_block,
    ACTIONS(5954), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4102), 1,
      sym_statement_block,
    ACTIONS(5855), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    ACTIONS(5296), 1,
      anon_sym_LT,
    STATE(1456), 1,
      sym_arguments,
    STATE(4012), 1,
      sym_type_arguments,
    ACTIONS(5913), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [107471] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3391), 1,
      sym_type_annotation,
    STATE(3711), 1,
      sym__initializer,
    ACTIONS(5536), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3984), 1,
      sym_statement_block,
    ACTIONS(5956), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3874), 1,
      sym_statement_block,
    ACTIONS(5861), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4062), 1,
      sym_statement_block,
    ACTIONS(5956), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107543] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5740), 1,
      anon_sym_LBRACE,
    STATE(652), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3868), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107568] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    ACTIONS(5958), 1,
      anon_sym_EQ,
    ACTIONS(5962), 1,
      anon_sym_QMARK,
    STATE(3576), 1,
      sym_type_annotation,
    STATE(3997), 1,
      sym__initializer,
    ACTIONS(5960), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [107604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5964), 1,
      anon_sym_EQ,
    ACTIONS(3076), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [107619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3193), 1,
      sym_type_annotation,
    STATE(3603), 1,
      sym__initializer,
    ACTIONS(5587), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107640] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LBRACK,
    ACTIONS(5911), 1,
      sym_identifier,
    STATE(3457), 1,
      sym_variable_declarator,
    STATE(2945), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [107661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(5969), 1,
      anon_sym_STAR,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3875), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [107686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3422), 1,
      sym_type_annotation,
    ACTIONS(5971), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_EQ,
    STATE(3533), 1,
      sym_constraint,
    STATE(4070), 1,
      sym_default_type,
    ACTIONS(5292), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(5973), 2,
      anon_sym_COLON,
      anon_sym_extends,
  [107724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3980), 1,
      sym_statement_block,
    ACTIONS(5975), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107741] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5977), 1,
      sym_identifier,
    ACTIONS(5979), 1,
      anon_sym_STAR,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3875), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [107766] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1965), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3998), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107791] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(630), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3991), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107816] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3156), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3964), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107841] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1959), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4021), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107866] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5981), 1,
      anon_sym_COLON,
    ACTIONS(5983), 1,
      anon_sym_QMARK,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4020), 1,
      sym__call_signature,
  [107891] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5985), 1,
      sym_identifier,
    ACTIONS(5987), 1,
      anon_sym_STAR,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3935), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [107916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 1,
      anon_sym_is,
    ACTIONS(3334), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5991), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [107944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3400), 1,
      sym_type_annotation,
    ACTIONS(5993), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107961] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3185), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4015), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [107986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3801), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_BQUOTE,
  [108001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3226), 1,
      sym_type_annotation,
    STATE(3631), 1,
      sym__initializer,
    ACTIONS(5524), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5983), 1,
      anon_sym_QMARK,
    ACTIONS(5995), 1,
      anon_sym_COLON,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4020), 1,
      sym__call_signature,
  [108047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1465), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4011), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [108072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5633), 1,
      anon_sym_is,
    ACTIONS(3340), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108087] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(5997), 1,
      sym_identifier,
    ACTIONS(5999), 1,
      anon_sym_STAR,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3875), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [108112] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5740), 1,
      anon_sym_LBRACE,
    STATE(758), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(3990), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [108137] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(5691), 1,
      anon_sym_LBRACE,
    STATE(165), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4063), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [108162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3925), 1,
      sym_statement_block,
    ACTIONS(6001), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108179] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    ACTIONS(5659), 1,
      anon_sym_extends,
    ACTIONS(5661), 1,
      anon_sym_implements,
    STATE(1477), 1,
      sym_class_body,
    STATE(3579), 1,
      sym_extends_clause,
    STATE(4047), 1,
      sym_class_heritage,
    STATE(4376), 1,
      sym_implements_clause,
  [108204] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(5813), 1,
      anon_sym_LBRACK,
    ACTIONS(5911), 1,
      sym_identifier,
    STATE(3534), 1,
      sym_variable_declarator,
    STATE(2945), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [108225] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(6003), 1,
      sym_identifier,
    ACTIONS(6005), 1,
      anon_sym_DOT,
    STATE(2857), 1,
      sym_nested_identifier,
    STATE(2897), 1,
      sym_string,
    STATE(3324), 1,
      sym__module,
  [108250] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1287), 1,
      anon_sym_LBRACE,
    ACTIONS(5942), 1,
      anon_sym_LT,
    ACTIONS(5944), 1,
      anon_sym_extends,
    STATE(3308), 1,
      sym_object_type,
    STATE(3384), 1,
      sym_type_parameters,
    STATE(3611), 1,
      sym_extends_type_clause,
  [108275] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      sym_identifier,
    ACTIONS(6009), 1,
      anon_sym_import,
    STATE(2405), 1,
      sym__type_query_subscript_expression,
    STATE(2424), 1,
      sym__type_query_member_expression,
    STATE(2519), 1,
      sym__type_query_call_expression,
    STATE(3856), 1,
      sym_import,
  [108297] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6011), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2923), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [108319] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6017), 1,
      anon_sym_SLASH,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [108341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6021), 1,
      anon_sym_default,
    ACTIONS(6023), 1,
      anon_sym_RBRACE,
    ACTIONS(6025), 1,
      anon_sym_case,
    STATE(2998), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [108359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(6027), 1,
      sym_identifier,
    ACTIONS(6029), 1,
      anon_sym_LBRACK,
    STATE(3532), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [108377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(6029), 1,
      anon_sym_LBRACK,
    ACTIONS(6031), 1,
      sym_identifier,
    STATE(3955), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [108395] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_LBRACE,
    ACTIONS(6029), 1,
      anon_sym_LBRACK,
    ACTIONS(6033), 1,
      sym_identifier,
    STATE(3734), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [108413] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6035), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [108435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5389), 4,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [108449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6037), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [108467] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6039), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [108489] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(2999), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [108511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3010), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6045), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6043), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6049), 1,
      anon_sym_QMARK,
    ACTIONS(6047), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [108547] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6051), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [108569] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6053), 1,
      sym_identifier,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4030), 1,
      sym__call_signature,
  [108591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6055), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [108613] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5871), 1,
      anon_sym_COMMA,
    ACTIONS(5873), 1,
      anon_sym_LT,
    ACTIONS(6057), 1,
      anon_sym_LBRACE,
    ACTIONS(6059), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3484), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3712), 1,
      sym_type_arguments,
  [108635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2225), 1,
      sym_statement_block,
    ACTIONS(5934), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108651] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6063), 1,
      anon_sym_QMARK,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3840), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [108673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5068), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3206), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [108687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6065), 1,
      anon_sym_QMARK,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(3982), 1,
      sym__call_signature,
  [108709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6069), 1,
      anon_sym_BQUOTE,
    ACTIONS(6071), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6067), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3031), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [108727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6073), 1,
      anon_sym_default,
    ACTIONS(6076), 1,
      anon_sym_RBRACE,
    ACTIONS(6078), 1,
      anon_sym_case,
    STATE(2998), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [108745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2217), 1,
      sym_statement_block,
    ACTIONS(5956), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(6081), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6083), 1,
      anon_sym_QMARK_COLON,
    STATE(3402), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [108779] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3020), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [108801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2238), 1,
      sym_statement_block,
    ACTIONS(5956), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108829] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6087), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3794), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [108851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2237), 1,
      sym_statement_block,
    ACTIONS(5975), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108867] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(6003), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_nested_identifier,
    STATE(2897), 1,
      sym_string,
    STATE(3324), 1,
      sym__module,
  [108889] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6089), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3420), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [108911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3028), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3249), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6091), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108927] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(6003), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_nested_identifier,
    STATE(2897), 1,
      sym_string,
    STATE(3381), 1,
      sym__module,
  [108949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3249), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6091), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108965] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6093), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
  [108983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    ACTIONS(3746), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [109001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(3550), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [109015] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6101), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [109037] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6103), 1,
      sym_identifier,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4099), 1,
      sym__call_signature,
  [109059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6071), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6105), 1,
      anon_sym_BQUOTE,
    ACTIONS(5817), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2997), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [109077] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6107), 1,
      anon_sym_QMARK,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(3959), 1,
      sym__call_signature,
  [109099] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6009), 1,
      anon_sym_import,
    ACTIONS(6109), 1,
      sym_identifier,
    STATE(2374), 1,
      sym__type_query_subscript_expression,
    STATE(2376), 1,
      sym__type_query_member_expression,
    STATE(2397), 1,
      sym__type_query_call_expression,
    STATE(4056), 1,
      sym_import,
  [109121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2241), 1,
      sym_statement_block,
    ACTIONS(5938), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2239), 1,
      sym_statement_block,
    ACTIONS(5940), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109153] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6111), 1,
      anon_sym_COMMA,
    ACTIONS(6113), 1,
      anon_sym_GT,
    STATE(3689), 1,
      aux_sym_implements_clause_repeat1,
  [109175] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(6115), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3048), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [109197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2249), 1,
      sym_statement_block,
    ACTIONS(5938), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109213] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6117), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [109235] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6119), 1,
      sym_identifier,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4071), 1,
      sym__call_signature,
  [109257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(6081), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6083), 1,
      anon_sym_QMARK_COLON,
    STATE(3369), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [109275] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6121), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3682), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [109297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3231), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6123), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109313] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6125), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3341), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [109335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6130), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6127), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6135), 1,
      anon_sym_BQUOTE,
    ACTIONS(6137), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6132), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3031), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [109369] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 1,
      anon_sym_LT,
    ACTIONS(5875), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_LBRACE,
    STATE(3597), 1,
      sym_type_arguments,
    ACTIONS(6142), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [109389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109413] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6144), 1,
      anon_sym_export,
    ACTIONS(6146), 1,
      anon_sym_class,
    ACTIONS(6148), 1,
      anon_sym_abstract,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [109435] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6150), 1,
      sym_identifier,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4030), 1,
      sym__call_signature,
  [109457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      sym_identifier,
    ACTIONS(6154), 1,
      anon_sym_GT,
    ACTIONS(6156), 1,
      sym_jsx_identifier,
    STATE(2591), 1,
      sym_nested_identifier,
    STATE(2819), 1,
      sym_jsx_namespace_name,
    STATE(3578), 1,
      sym_type_parameter,
  [109479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2007), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2248), 1,
      sym_statement_block,
    ACTIONS(5940), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109519] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6158), 1,
      anon_sym_QMARK,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4109), 1,
      sym__call_signature,
  [109541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6160), 1,
      anon_sym_LBRACE,
    ACTIONS(6162), 1,
      anon_sym_COMMA,
    STATE(3649), 1,
      aux_sym_implements_clause_repeat1,
  [109563] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5865), 1,
      sym_identifier,
    STATE(631), 1,
      sym_string,
    STATE(751), 1,
      sym__module,
    STATE(3508), 1,
      sym_nested_identifier,
  [109585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(6081), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6083), 1,
      anon_sym_QMARK_COLON,
    STATE(3181), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [109603] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 1,
      sym_identifier,
    ACTIONS(6166), 1,
      anon_sym_GT,
    ACTIONS(6168), 1,
      sym_jsx_identifier,
    STATE(2576), 1,
      sym_nested_identifier,
    STATE(2735), 1,
      sym_jsx_namespace_name,
    STATE(3578), 1,
      sym_type_parameter,
  [109625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2246), 1,
      sym_statement_block,
    ACTIONS(5859), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(6081), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6083), 1,
      anon_sym_QMARK_COLON,
    STATE(3153), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [109659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2247), 1,
      sym_statement_block,
    ACTIONS(5861), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(6170), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3077), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [109697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2235), 1,
      sym_statement_block,
    ACTIONS(5859), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109713] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6172), 1,
      anon_sym_COMMA,
    ACTIONS(6174), 1,
      anon_sym_GT,
    STATE(3705), 1,
      aux_sym_implements_clause_repeat1,
  [109735] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6009), 1,
      anon_sym_import,
    ACTIONS(6176), 1,
      sym_identifier,
    STATE(1538), 1,
      sym__type_query_subscript_expression,
    STATE(1540), 1,
      sym__type_query_member_expression,
    STATE(1724), 1,
      sym__type_query_call_expression,
    STATE(3947), 1,
      sym_import,
  [109757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2228), 1,
      sym_statement_block,
    ACTIONS(5861), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3264), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6178), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3251), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6180), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3054), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3251), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6180), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109821] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5865), 1,
      sym_identifier,
    STATE(631), 1,
      sym_string,
    STATE(653), 1,
      sym__module,
    STATE(3508), 1,
      sym_nested_identifier,
  [109843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3055), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6184), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6182), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109859] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6186), 1,
      anon_sym_COMMA,
    ACTIONS(6188), 1,
      anon_sym_GT,
    STATE(3678), 1,
      aux_sym_implements_clause_repeat1,
  [109881] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6190), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3383), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [109903] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6192), 1,
      sym_identifier,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3930), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [109925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6071), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6194), 1,
      anon_sym_BQUOTE,
    ACTIONS(5831), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3107), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [109943] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6196), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [109965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6200), 1,
      anon_sym_EQ,
    ACTIONS(6198), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6202), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [109981] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6204), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [110003] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6009), 1,
      anon_sym_import,
    ACTIONS(6206), 1,
      sym_identifier,
    STATE(2397), 1,
      sym__type_query_call_expression,
    STATE(2673), 1,
      sym__type_query_subscript_expression,
    STATE(2688), 1,
      sym__type_query_member_expression,
    STATE(3867), 1,
      sym_import,
  [110025] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6208), 1,
      sym_identifier,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4030), 1,
      sym__call_signature,
  [110047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3253), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6210), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3258), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6212), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3068), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3258), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6212), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3069), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6216), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6214), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110111] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6218), 1,
      anon_sym_COMMA,
    ACTIONS(6220), 1,
      anon_sym_GT,
    STATE(3610), 1,
      aux_sym_implements_clause_repeat1,
  [110133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(6081), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6083), 1,
      anon_sym_QMARK_COLON,
    STATE(3152), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [110151] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6009), 1,
      anon_sym_import,
    ACTIONS(6222), 1,
      sym_identifier,
    STATE(2521), 1,
      sym__type_query_member_expression,
    STATE(2542), 1,
      sym__type_query_subscript_expression,
    STATE(2622), 1,
      sym__type_query_call_expression,
    STATE(4100), 1,
      sym_import,
  [110173] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6224), 1,
      anon_sym_QMARK,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(3996), 1,
      sym__call_signature,
  [110195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2221), 1,
      sym_statement_block,
    ACTIONS(5855), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2220), 1,
      sym_statement_block,
    ACTIONS(5905), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    ACTIONS(5958), 1,
      anon_sym_EQ,
    STATE(3570), 1,
      sym_type_annotation,
    STATE(4098), 1,
      sym__initializer,
    ACTIONS(6226), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [110247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6021), 1,
      anon_sym_default,
    ACTIONS(6025), 1,
      anon_sym_case,
    ACTIONS(6228), 1,
      anon_sym_RBRACE,
    STATE(2978), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [110265] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(6230), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3103), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [110287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3260), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6232), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2253), 1,
      sym_statement_block,
    ACTIONS(5855), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3262), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6234), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3081), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3262), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6234), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110351] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6236), 1,
      sym_identifier,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3930), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [110373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(6081), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6083), 1,
      anon_sym_QMARK_COLON,
    STATE(3433), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [110391] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6238), 1,
      anon_sym_COMMA,
    ACTIONS(6240), 1,
      anon_sym_GT,
    STATE(3620), 1,
      aux_sym_implements_clause_repeat1,
  [110413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3083), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6244), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6242), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110429] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6246), 1,
      anon_sym_COMMA,
    ACTIONS(6248), 1,
      anon_sym_GT,
    STATE(3660), 1,
      aux_sym_implements_clause_repeat1,
  [110451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(6081), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6083), 1,
      anon_sym_QMARK_COLON,
    STATE(3436), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [110469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2251), 1,
      sym_statement_block,
    ACTIONS(5905), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110485] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6250), 1,
      anon_sym_QMARK,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(3966), 1,
      sym__call_signature,
  [110507] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6009), 1,
      anon_sym_import,
    ACTIONS(6252), 1,
      sym_identifier,
    STATE(1247), 1,
      sym__type_query_member_expression,
    STATE(1249), 1,
      sym__type_query_subscript_expression,
    STATE(1273), 1,
      sym__type_query_call_expression,
    STATE(4018), 1,
      sym_import,
  [110529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [110553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6254), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110577] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6258), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3378), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [110599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(6081), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6083), 1,
      anon_sym_QMARK_COLON,
    STATE(3361), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [110617] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    ACTIONS(6081), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6083), 1,
      anon_sym_QMARK_COLON,
    STATE(3360), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [110635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6260), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2242), 1,
      sym_statement_block,
    ACTIONS(5853), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2243), 1,
      sym_statement_block,
    ACTIONS(5928), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym_COLON,
    ACTIONS(5619), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3883), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [110695] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6264), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [110717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3215), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6266), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6071), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6268), 1,
      anon_sym_BQUOTE,
    ACTIONS(6067), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3031), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [110751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3188), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6270), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110767] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    ACTIONS(6272), 1,
      anon_sym_QMARK,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3117), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [110789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3106), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3188), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6270), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2218), 1,
      sym_statement_block,
    ACTIONS(5853), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110821] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6274), 1,
      sym_identifier,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3930), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [110843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3108), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6278), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6276), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110859] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6280), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3340), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [110881] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6282), 1,
      anon_sym_COMMA,
    ACTIONS(6284), 1,
      anon_sym_GT,
    STATE(3823), 1,
      aux_sym_implements_clause_repeat1,
  [110903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2245), 1,
      sym_statement_block,
    ACTIONS(5952), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2252), 1,
      sym_statement_block,
    ACTIONS(5954), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110935] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6146), 1,
      anon_sym_class,
    ACTIONS(6148), 1,
      anon_sym_abstract,
    ACTIONS(6286), 1,
      anon_sym_export,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [110957] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6288), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3331), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [110979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_LBRACE,
    STATE(2254), 1,
      sym_statement_block,
    ACTIONS(6001), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5991), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [111007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5923), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [111019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym_COLON,
    ACTIONS(5647), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3928), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [111035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [111047] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6148), 1,
      anon_sym_abstract,
    ACTIONS(6290), 1,
      anon_sym_export,
    ACTIONS(6292), 1,
      anon_sym_class,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [111069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_is,
    ACTIONS(5863), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(3518), 4,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
  [111099] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6294), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2934), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [111121] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6296), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2938), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [111143] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2909), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [111165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3142), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6302), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6300), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111181] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6304), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2925), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [111203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    ACTIONS(3440), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [111221] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6306), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [111243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [111255] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6308), 1,
      sym_identifier,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3930), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [111277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    ACTIONS(6310), 1,
      anon_sym_SLASH,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [111299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5946), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(631), 1,
      sym_string,
    STATE(751), 1,
      sym__module,
  [111321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3140), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3217), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6312), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3210), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6314), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111353] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(5946), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(631), 1,
      sym_string,
    STATE(653), 1,
      sym__module,
  [111375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3030), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3217), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6312), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    ACTIONS(3644), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [111409] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    ACTIONS(6316), 1,
      sym_identifier,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4030), 1,
      sym__call_signature,
  [111431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    ACTIONS(3738), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [111449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(3718), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [111463] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    ACTIONS(3636), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [111481] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2867), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [111503] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    ACTIONS(6320), 1,
      anon_sym_as,
    ACTIONS(6322), 1,
      anon_sym_RBRACK,
  [111522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2327), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6326), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1532), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4652), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2423), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6328), 1,
      anon_sym_BQUOTE,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6332), 1,
      sym__template_chars,
    STATE(3192), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [111616] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(6334), 1,
      anon_sym_SEMI,
    ACTIONS(6336), 1,
      sym__automatic_semicolon,
    ACTIONS(6338), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1852), 1,
      sym_statement_block,
  [111635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2419), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2271), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4676), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4676), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4676), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111701] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 1,
      anon_sym_EQ,
    ACTIONS(6340), 1,
      anon_sym_COMMA,
    ACTIONS(6342), 1,
      anon_sym_RBRACE,
    STATE(3656), 1,
      aux_sym_enum_body_repeat1,
    STATE(3862), 1,
      sym__initializer,
  [111720] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [111739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6344), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [111756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym_COLON,
    ACTIONS(6346), 1,
      anon_sym_EQ_GT,
    STATE(3928), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [111782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3956), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3958), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [111806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym_COLON,
    ACTIONS(6349), 1,
      anon_sym_EQ_GT,
    STATE(3883), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [111821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6352), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [111843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3982), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [111856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3768), 1,
      sym__initializer,
    ACTIONS(6354), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4019), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [111884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2127), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6356), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3962), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [111985] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    ACTIONS(6360), 1,
      anon_sym_SEMI,
    ACTIONS(6362), 1,
      sym__automatic_semicolon,
    ACTIONS(6364), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3224), 1,
      sym_statement_block,
  [112004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      sym__automatic_semicolon,
    ACTIONS(1610), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3913), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [112036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(6368), 1,
      anon_sym_PIPE,
    ACTIONS(6366), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6370), 1,
      anon_sym_BQUOTE,
    ACTIONS(6372), 1,
      sym__template_chars,
    STATE(3358), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3583), 1,
      sym__initializer,
    ACTIONS(6374), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6372), 1,
      sym__template_chars,
    ACTIONS(6376), 1,
      anon_sym_BQUOTE,
    STATE(3358), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112113] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(3976), 1,
      sym__call_signature,
  [112132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1566), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112154] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6148), 1,
      anon_sym_abstract,
    ACTIONS(6378), 1,
      anon_sym_class,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [112173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3964), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3966), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [112186] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2929), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [112205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3839), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [112235] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_COLON,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(6380), 1,
      anon_sym_RBRACE,
    STATE(3798), 1,
      aux_sym_object_pattern_repeat1,
  [112254] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3398), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [112273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(3977), 1,
      sym__call_signature,
  [112292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112303] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3898), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [112322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3846), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [112352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3886), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [112371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112382] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1397), 1,
      anon_sym_LBRACE,
    ACTIONS(6334), 1,
      anon_sym_SEMI,
    ACTIONS(6336), 1,
      sym__automatic_semicolon,
    ACTIONS(6338), 1,
      sym__function_signature_automatic_semicolon,
    STATE(182), 1,
      sym_statement_block,
  [112401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(6382), 1,
      sym_identifier,
    STATE(4128), 2,
      sym__module_export_name,
      sym_string,
  [112418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2187), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112429] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6384), 1,
      anon_sym_class,
    ACTIONS(6386), 1,
      anon_sym_abstract,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [112448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2179), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4188), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4190), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [112472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym_COLON,
    ACTIONS(6388), 1,
      anon_sym_EQ_GT,
    STATE(3883), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [112498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2163), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112509] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 1,
      anon_sym_EQ,
    ACTIONS(6391), 1,
      anon_sym_COMMA,
    ACTIONS(6393), 1,
      anon_sym_RBRACE,
    STATE(3818), 1,
      aux_sym_enum_body_repeat1,
    STATE(3862), 1,
      sym__initializer,
  [112528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym_COLON,
    ACTIONS(6395), 1,
      anon_sym_EQ_GT,
    STATE(3928), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [112543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4721), 1,
      sym__automatic_semicolon,
    ACTIONS(1590), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 1,
      sym__automatic_semicolon,
    ACTIONS(1546), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3741), 1,
      sym__initializer,
    ACTIONS(6398), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym_COLON,
    ACTIONS(6400), 1,
      anon_sym_EQ_GT,
    STATE(3883), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [112610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3368), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [112629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112640] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2868), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [112659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112670] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      sym_identifier,
    ACTIONS(6015), 1,
      anon_sym_GT,
    ACTIONS(6019), 1,
      sym_jsx_identifier,
    STATE(2604), 1,
      sym_nested_identifier,
    STATE(2796), 1,
      sym_jsx_namespace_name,
  [112689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(6403), 1,
      sym_identifier,
    STATE(3849), 2,
      sym__module_export_name,
      sym_string,
  [112706] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3847), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [112725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6372), 1,
      sym__template_chars,
    ACTIONS(6405), 1,
      anon_sym_BQUOTE,
    STATE(3358), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    ACTIONS(6334), 1,
      anon_sym_SEMI,
    ACTIONS(6336), 1,
      sym__automatic_semicolon,
    ACTIONS(6338), 1,
      sym__function_signature_automatic_semicolon,
    STATE(622), 1,
      sym_statement_block,
  [112761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(6368), 1,
      anon_sym_PIPE,
    ACTIONS(6407), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112778] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3843), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [112797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3962), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [112810] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3838), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [112829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3962), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [112842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    STATE(3899), 1,
      sym_type_annotation,
    ACTIONS(3076), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [112857] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(6409), 1,
      anon_sym_SEMI,
    ACTIONS(6411), 1,
      sym__automatic_semicolon,
    ACTIONS(6413), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1836), 1,
      sym_statement_block,
  [112876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112887] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(3985), 1,
      sym__call_signature,
  [112906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(6368), 1,
      anon_sym_PIPE,
    ACTIONS(6415), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112923] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(6368), 1,
      anon_sym_PIPE,
    ACTIONS(6417), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112962] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    ACTIONS(6409), 1,
      anon_sym_SEMI,
    ACTIONS(6411), 1,
      sym__automatic_semicolon,
    ACTIONS(6413), 1,
      sym__function_signature_automatic_semicolon,
    STATE(623), 1,
      sym_statement_block,
  [112981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4672), 1,
      sym__automatic_semicolon,
    ACTIONS(1489), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2935), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [113013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6419), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6421), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(3988), 1,
      sym__call_signature,
  [113056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6425), 1,
      anon_sym_in,
    ACTIONS(6427), 1,
      anon_sym_of,
    ACTIONS(6423), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6429), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [113082] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3236), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [113101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 1,
      anon_sym_in,
    ACTIONS(6433), 1,
      anon_sym_of,
    ACTIONS(6423), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6435), 1,
      anon_sym_BQUOTE,
    ACTIONS(6437), 1,
      sym__template_chars,
    STATE(3194), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4717), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4548), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4680), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4680), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1431), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4046), 1,
      sym__call_signature,
  [113207] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2861), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [113226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(6439), 1,
      sym_identifier,
    STATE(3993), 2,
      sym__module_export_name,
      sym_string,
  [113243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2307), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113254] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2933), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [113273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6441), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6443), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6445), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6447), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113299] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(2970), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [113318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2315), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2315), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6449), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [113373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6451), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6453), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2383), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2391), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113452] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3019), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [113471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6455), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2439), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2451), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [113537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 1,
      anon_sym_LT,
    ACTIONS(6459), 1,
      anon_sym_LBRACE,
    STATE(3712), 1,
      sym_type_arguments,
    ACTIONS(6461), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [113609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2323), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6254), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6465), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5938), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2395), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2431), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5952), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6467), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym_COLON,
    ACTIONS(6469), 1,
      anon_sym_EQ_GT,
    STATE(3928), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [113769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2363), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2343), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4414), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [113802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4399), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [113813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2347), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2467), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6260), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5940), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6372), 1,
      sym__template_chars,
    ACTIONS(6472), 1,
      anon_sym_BQUOTE,
    STATE(3358), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113874] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6386), 1,
      anon_sym_abstract,
    ACTIONS(6474), 1,
      anon_sym_class,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [113893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3801), 1,
      sym__initializer,
    ACTIONS(6476), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2171), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3962), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6001), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113998] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3330), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [114017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3787), 1,
      sym__initializer,
    ACTIONS(6478), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2311), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114043] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3116), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [114062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6480), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6482), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5928), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5940), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3380), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [114147] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3310), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [114166] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4005), 1,
      sym__call_signature,
  [114185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5938), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6484), 1,
      anon_sym_EQ,
    ACTIONS(3057), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [114231] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3120), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [114250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3859), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3861), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [114263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3757), 1,
      sym__initializer,
    ACTIONS(6486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4025), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [114313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6490), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [114330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LBRACK,
    ACTIONS(6492), 1,
      anon_sym_RBRACE,
    ACTIONS(3530), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114345] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6494), 1,
      anon_sym_BQUOTE,
    ACTIONS(6496), 1,
      sym__template_chars,
    STATE(3235), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6498), 1,
      anon_sym_BQUOTE,
    ACTIONS(6500), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6503), 1,
      sym__template_chars,
    STATE(3358), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114379] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4013), 1,
      sym__call_signature,
  [114398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6506), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6508), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114420] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6510), 1,
      sym_identifier,
    ACTIONS(6512), 1,
      anon_sym_GT,
    ACTIONS(6514), 1,
      sym_jsx_identifier,
    STATE(2562), 1,
      sym_nested_identifier,
    STATE(2789), 1,
      sym_jsx_namespace_name,
  [114439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3773), 1,
      sym__initializer,
    ACTIONS(6516), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114454] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3693), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [114473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6518), 1,
      anon_sym_BQUOTE,
    ACTIONS(6520), 1,
      sym__template_chars,
    STATE(3393), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114490] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4031), 1,
      sym__call_signature,
  [114509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4029), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [114522] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(6522), 1,
      anon_sym_SEMI,
    ACTIONS(6524), 1,
      sym__automatic_semicolon,
    ACTIONS(6526), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1898), 1,
      sym_statement_block,
  [114541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114552] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6530), 1,
      anon_sym_BQUOTE,
    ACTIONS(6532), 1,
      sym__template_chars,
    STATE(3321), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      sym__initializer,
    ACTIONS(6534), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5905), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5855), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4680), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5905), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114661] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3345), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [114680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3396), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [114721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5861), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114732] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1287), 1,
      anon_sym_LBRACE,
    ACTIONS(5944), 1,
      anon_sym_extends,
    STATE(3281), 1,
      sym_object_type,
    STATE(3598), 1,
      sym_extends_type_clause,
  [114751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4044), 1,
      sym__call_signature,
  [114770] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4049), 1,
      sym__call_signature,
  [114789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym_COLON,
    ACTIONS(6540), 1,
      anon_sym_EQ_GT,
    STATE(3883), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [114815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114826] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3187), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [114845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3607), 1,
      sym__initializer,
    ACTIONS(6543), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114860] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(3953), 1,
      sym__call_signature,
  [114879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6372), 1,
      sym__template_chars,
    ACTIONS(6545), 1,
      anon_sym_BQUOTE,
    STATE(3358), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [114896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5861), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5855), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4711), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114940] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(6360), 1,
      anon_sym_SEMI,
    ACTIONS(6362), 1,
      sym__automatic_semicolon,
    ACTIONS(6364), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1948), 1,
      sym_statement_block,
  [114959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6551), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114981] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3885), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [115000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6553), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115011] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3046), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [115030] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4097), 1,
      sym__call_signature,
  [115049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3158), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [115068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(6368), 1,
      anon_sym_PIPE,
    ACTIONS(6555), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115085] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3440), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [115104] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3076), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [115123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1441), 1,
      anon_sym_DOT,
    ACTIONS(3756), 1,
      anon_sym_LBRACE,
    ACTIONS(3758), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [115138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3700), 1,
      sym__initializer,
    ACTIONS(6557), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115164] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    ACTIONS(6522), 1,
      anon_sym_SEMI,
    ACTIONS(6524), 1,
      sym__automatic_semicolon,
    ACTIONS(6526), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3188), 1,
      sym_statement_block,
  [115183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3699), 1,
      sym__initializer,
    ACTIONS(6559), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115198] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3890), 1,
      sym__call_signature,
    STATE(3937), 1,
      sym_type_parameters,
  [115217] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3685), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [115236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3412), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [115255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 1,
      anon_sym_COLON,
    ACTIONS(6561), 1,
      anon_sym_EQ_GT,
    STATE(3928), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [115270] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6146), 1,
      anon_sym_class,
    ACTIONS(6148), 1,
      anon_sym_abstract,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [115289] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2701), 1,
      sym_formal_parameters,
    STATE(3347), 1,
      sym__call_signature,
    STATE(3934), 1,
      sym_type_parameters,
  [115308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5956), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1542), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [115332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6564), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3772), 1,
      sym__initializer,
    ACTIONS(6566), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5956), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115369] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4002), 1,
      sym__call_signature,
  [115388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115399] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4103), 1,
      sym__call_signature,
  [115418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1606), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [115442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5975), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115464] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(205), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1230), 1,
      anon_sym_LBRACE,
    ACTIONS(5944), 1,
      anon_sym_extends,
    STATE(736), 1,
      sym_object_type,
    STATE(3659), 1,
      sym_extends_type_clause,
  [115483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115494] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3243), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [115513] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_COLON,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(6574), 1,
      anon_sym_RBRACE,
    STATE(3696), 1,
      aux_sym_object_pattern_repeat1,
  [115532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6576), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115543] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3250), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [115562] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2756), 1,
      sym_formal_parameters,
    STATE(3212), 1,
      sym__call_signature,
    STATE(3917), 1,
      sym_type_parameters,
  [115581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_DQUOTE,
    ACTIONS(1943), 1,
      anon_sym_SQUOTE,
    ACTIONS(6578), 1,
      sym_identifier,
    STATE(3788), 2,
      sym__module_export_name,
      sym_string,
  [115598] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1397), 1,
      anon_sym_LBRACE,
    ACTIONS(6409), 1,
      anon_sym_SEMI,
    ACTIONS(6411), 1,
      sym__automatic_semicolon,
    ACTIONS(6413), 1,
      sym__function_signature_automatic_semicolon,
    STATE(186), 1,
      sym_statement_block,
  [115617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_formal_parameters,
    STATE(3937), 1,
      sym_type_parameters,
    STATE(4028), 1,
      sym__call_signature,
  [115636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6148), 1,
      anon_sym_abstract,
    ACTIONS(6292), 1,
      anon_sym_class,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [115655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3777), 1,
      sym__initializer,
    ACTIONS(6580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(6582), 1,
      sym_identifier,
    STATE(4164), 2,
      sym__module_export_name,
      sym_string,
  [115687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(6368), 1,
      anon_sym_PIPE,
    ACTIONS(6584), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6586), 1,
      anon_sym_QMARK,
  [115720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 1,
      anon_sym_COMMA,
    STATE(3525), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6590), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3904), 1,
      sym_type_parameters,
    STATE(4264), 1,
      sym_formal_parameters,
  [115750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_from,
    STATE(3893), 1,
      sym__from_clause,
    ACTIONS(4011), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6594), 1,
      anon_sym_class,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [115780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6596), 1,
      anon_sym_LBRACE,
    ACTIONS(6598), 1,
      anon_sym_COMMA,
    ACTIONS(6601), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3451), 1,
      aux_sym_extends_type_clause_repeat1,
  [115796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 1,
      anon_sym_EQ,
    STATE(3862), 1,
      sym__initializer,
    ACTIONS(6603), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [115810] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6605), 1,
      anon_sym_DQUOTE,
    STATE(3453), 1,
      aux_sym_string_repeat1,
    ACTIONS(6607), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [115824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 1,
      anon_sym_COMMA,
    STATE(3525), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6610), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    STATE(1883), 2,
      sym_template_string,
      sym_arguments,
  [115852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6612), 1,
      anon_sym_COLON,
  [115868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 1,
      anon_sym_COMMA,
    STATE(3554), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6614), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115882] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6616), 1,
      anon_sym_SQUOTE,
    STATE(3458), 1,
      aux_sym_string_repeat2,
    ACTIONS(6618), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [115896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      sym_identifier,
    STATE(2992), 1,
      sym_nested_type_identifier,
    STATE(3543), 1,
      sym_generic_type,
    STATE(4181), 1,
      sym_nested_identifier,
  [115912] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_SQUOTE,
    STATE(3538), 1,
      aux_sym_string_repeat2,
    ACTIONS(6625), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [115926] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6627), 1,
      anon_sym_RBRACK,
  [115942] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym_SQUOTE,
    STATE(3458), 1,
      aux_sym_string_repeat2,
    ACTIONS(6631), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [115956] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym_DQUOTE,
    STATE(3453), 1,
      aux_sym_string_repeat1,
    ACTIONS(6633), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [115970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3871), 1,
      sym_type_parameters,
    STATE(4445), 1,
      sym_formal_parameters,
  [115986] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6635), 1,
      anon_sym_SQUOTE,
    STATE(3458), 1,
      aux_sym_string_repeat2,
    ACTIONS(6631), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 1,
      anon_sym_COMMA,
    STATE(3447), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6637), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116014] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6635), 1,
      anon_sym_DQUOTE,
    STATE(3453), 1,
      aux_sym_string_repeat1,
    ACTIONS(6633), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116028] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6639), 1,
      anon_sym_SQUOTE,
    STATE(3465), 1,
      aux_sym_string_repeat2,
    ACTIONS(6641), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116042] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6639), 1,
      anon_sym_DQUOTE,
    STATE(3467), 1,
      aux_sym_string_repeat1,
    ACTIONS(6643), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116056] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6645), 1,
      anon_sym_DQUOTE,
    STATE(3480), 1,
      aux_sym_string_repeat1,
    ACTIONS(6647), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116070] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6645), 1,
      anon_sym_SQUOTE,
    STATE(3481), 1,
      aux_sym_string_repeat2,
    ACTIONS(6649), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116084] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6651), 1,
      anon_sym_RBRACK,
  [116100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6653), 1,
      anon_sym_RBRACK,
  [116116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3873), 1,
      sym_type_parameters,
    STATE(4273), 1,
      sym_formal_parameters,
  [116132] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6623), 1,
      anon_sym_DQUOTE,
    STATE(3479), 1,
      aux_sym_string_repeat1,
    ACTIONS(6655), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_from,
    STATE(3921), 1,
      sym__from_clause,
    ACTIONS(4224), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6657), 1,
      sym_identifier,
    ACTIONS(6659), 1,
      sym_jsx_identifier,
    STATE(4068), 1,
      sym_nested_identifier,
    STATE(4436), 1,
      sym_jsx_namespace_name,
  [116176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6661), 1,
      anon_sym_RPAREN,
  [116192] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6663), 1,
      anon_sym_DQUOTE,
    STATE(3453), 1,
      aux_sym_string_repeat1,
    ACTIONS(6633), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116206] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6665), 1,
      anon_sym_DQUOTE,
    STATE(3453), 1,
      aux_sym_string_repeat1,
    ACTIONS(6633), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116220] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6665), 1,
      anon_sym_SQUOTE,
    STATE(3458), 1,
      aux_sym_string_repeat2,
    ACTIONS(6631), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5871), 1,
      anon_sym_COMMA,
    ACTIONS(6667), 1,
      anon_sym_LBRACE,
    ACTIONS(6669), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3451), 1,
      aux_sym_extends_type_clause_repeat1,
  [116250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_COMMA,
    ACTIONS(6671), 1,
      anon_sym_EQ,
    ACTIONS(6673), 1,
      anon_sym_RBRACK,
    STATE(3612), 1,
      aux_sym_array_pattern_repeat1,
  [116266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5871), 1,
      anon_sym_COMMA,
    ACTIONS(6667), 1,
      anon_sym_LBRACE,
    ACTIONS(6669), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3451), 1,
      aux_sym_extends_type_clause_repeat1,
  [116282] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6675), 1,
      anon_sym_SQUOTE,
    STATE(3458), 1,
      aux_sym_string_repeat2,
    ACTIONS(6631), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116296] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6675), 1,
      anon_sym_DQUOTE,
    STATE(3453), 1,
      aux_sym_string_repeat1,
    ACTIONS(6633), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116310] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5871), 1,
      anon_sym_COMMA,
    ACTIONS(6677), 1,
      anon_sym_LBRACE,
    ACTIONS(6679), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3451), 1,
      aux_sym_extends_type_clause_repeat1,
  [116326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 1,
      sym_identifier,
    STATE(3298), 1,
      sym_nested_type_identifier,
    STATE(3748), 1,
      sym_generic_type,
    STATE(4181), 1,
      sym_nested_identifier,
  [116342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6683), 1,
      anon_sym_RBRACK,
  [116358] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6685), 1,
      anon_sym_SQUOTE,
    STATE(3485), 1,
      aux_sym_string_repeat2,
    ACTIONS(6687), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116372] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6685), 1,
      anon_sym_DQUOTE,
    STATE(3486), 1,
      aux_sym_string_repeat1,
    ACTIONS(6689), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116386] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 1,
      sym_identifier,
    ACTIONS(6693), 1,
      sym_jsx_identifier,
    STATE(4006), 1,
      sym_nested_identifier,
    STATE(4143), 1,
      sym_jsx_namespace_name,
  [116402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6695), 1,
      anon_sym_RBRACK,
  [116418] = 5,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6697), 1,
      sym__glimmer_template_content,
    ACTIONS(6699), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1396), 1,
      sym_glimmer_closing_tag,
    STATE(3514), 1,
      aux_sym_glimmer_template_repeat1,
  [116434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3895), 1,
      sym_type_parameters,
    STATE(4431), 1,
      sym_formal_parameters,
  [116450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6701), 1,
      anon_sym_RBRACK,
  [116466] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6703), 1,
      anon_sym_DQUOTE,
    STATE(3463), 1,
      aux_sym_string_repeat1,
    ACTIONS(6705), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6707), 1,
      anon_sym_COMMA,
    STATE(3498), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(6093), 2,
      anon_sym_LBRACE,
      anon_sym_GT,
  [116494] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_DQUOTE,
    STATE(3453), 1,
      aux_sym_string_repeat1,
    ACTIONS(6633), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 1,
      anon_sym_RBRACE,
    ACTIONS(3530), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6712), 1,
      anon_sym_COLON,
  [116536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5124), 1,
      anon_sym_EQ_GT,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [116548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 1,
      anon_sym_EQ_GT,
    ACTIONS(3206), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [116560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2875), 1,
      sym_formal_parameters,
    STATE(3915), 1,
      sym_type_parameters,
  [116576] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6703), 1,
      anon_sym_SQUOTE,
    STATE(3462), 1,
      aux_sym_string_repeat2,
    ACTIONS(6716), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116590] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_SQUOTE,
    STATE(3458), 1,
      aux_sym_string_repeat2,
    ACTIONS(6631), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116604] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_DQUOTE,
    STATE(3453), 1,
      aux_sym_string_repeat1,
    ACTIONS(6633), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1393), 1,
      anon_sym_while,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    STATE(678), 1,
      sym_statement_block,
  [116634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_BQUOTE,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    STATE(1455), 2,
      sym_template_string,
      sym_arguments,
  [116648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6720), 1,
      anon_sym_RPAREN,
  [116664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COMMA,
    STATE(3511), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6722), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [116678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4101), 1,
      anon_sym_COMMA,
    STATE(3511), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6727), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [116692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6729), 1,
      anon_sym_QMARK,
  [116708] = 5,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6699), 1,
      anon_sym_LT_SLASHtemplate_GT,
    ACTIONS(6731), 1,
      sym__glimmer_template_content,
    STATE(1467), 1,
      sym_glimmer_closing_tag,
    STATE(3833), 1,
      aux_sym_glimmer_template_repeat1,
  [116724] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6733), 1,
      anon_sym_SQUOTE,
    STATE(3506), 1,
      aux_sym_string_repeat2,
    ACTIONS(6735), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116738] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6737), 1,
      anon_sym_SQUOTE,
    STATE(3458), 1,
      aux_sym_string_repeat2,
    ACTIONS(6631), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116752] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6737), 1,
      anon_sym_DQUOTE,
    STATE(3453), 1,
      aux_sym_string_repeat1,
    ACTIONS(6633), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116766] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6733), 1,
      anon_sym_DQUOTE,
    STATE(3507), 1,
      aux_sym_string_repeat1,
    ACTIONS(6739), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_from,
    STATE(3865), 1,
      sym__from_clause,
    ACTIONS(6741), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 1,
      anon_sym_COMMA,
    STATE(3454), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6743), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3805), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [116818] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6745), 1,
      anon_sym_SQUOTE,
    STATE(3516), 1,
      aux_sym_string_repeat2,
    ACTIONS(6747), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [116832] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6745), 1,
      anon_sym_DQUOTE,
    STATE(3517), 1,
      aux_sym_string_repeat1,
    ACTIONS(6749), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [116846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6751), 1,
      anon_sym_QMARK,
  [116862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      anon_sym_COMMA,
    STATE(3525), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6756), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116876] = 5,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6731), 1,
      sym__glimmer_template_content,
    ACTIONS(6758), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1904), 1,
      sym_glimmer_closing_tag,
    STATE(3833), 1,
      aux_sym_glimmer_template_repeat1,
  [116892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6760), 1,
      anon_sym_COLON,
  [116908] = 5,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6758), 1,
      anon_sym_LT_SLASHtemplate_GT,
    ACTIONS(6762), 1,
      sym__glimmer_template_content,
    STATE(1979), 1,
      sym_glimmer_closing_tag,
    STATE(3526), 1,
      aux_sym_glimmer_template_repeat1,
  [116924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6764), 1,
      anon_sym_COLON,
  [116940] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4137), 1,
      sym_formal_parameters,
  [116956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6766), 1,
      anon_sym_EQ,
    STATE(3848), 1,
      sym__initializer,
    ACTIONS(5591), 2,
      anon_sym_in,
      anon_sym_of,
  [116980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_EQ,
    STATE(4080), 1,
      sym_default_type,
    ACTIONS(6768), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [116994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 1,
      anon_sym_COMMA,
    STATE(3557), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6770), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [117008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6772), 1,
      anon_sym_RPAREN,
  [117024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_COLON,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    ACTIONS(6774), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [117038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4079), 1,
      sym_type_parameters,
    STATE(4175), 1,
      sym_formal_parameters,
  [117054] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6663), 1,
      anon_sym_SQUOTE,
    STATE(3458), 1,
      aux_sym_string_repeat2,
    ACTIONS(6631), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [117068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6776), 1,
      anon_sym_RBRACK,
  [117084] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6778), 1,
      anon_sym_class,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [117100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6780), 1,
      anon_sym_COMMA,
    STATE(3541), 1,
      aux_sym_array_repeat1,
    ACTIONS(4304), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [117114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6783), 1,
      sym_escape_sequence,
    ACTIONS(6785), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [117126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5871), 1,
      anon_sym_COMMA,
    ACTIONS(6057), 1,
      anon_sym_LBRACE,
    ACTIONS(6059), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3482), 1,
      aux_sym_extends_type_clause_repeat1,
  [117142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6788), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [117152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6790), 1,
      anon_sym_RBRACK,
  [117168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4090), 1,
      sym_type_parameters,
    STATE(4162), 1,
      sym_formal_parameters,
  [117184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3227), 1,
      anon_sym_LBRACE,
    ACTIONS(5595), 1,
      anon_sym_STAR,
    STATE(4117), 2,
      sym_namespace_import,
      sym_named_imports,
  [117198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6792), 1,
      anon_sym_RBRACK,
  [117214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4048), 1,
      sym_type_parameters,
    STATE(4381), 1,
      sym_formal_parameters,
  [117230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3882), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_formal_parameters,
  [117246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6794), 1,
      anon_sym_QMARK,
  [117262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6796), 1,
      anon_sym_QMARK,
  [117278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6798), 1,
      anon_sym_QMARK,
  [117294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 1,
      anon_sym_COMMA,
    STATE(3525), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6800), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [117308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6802), 1,
      sym_identifier,
    ACTIONS(6804), 1,
      sym_jsx_identifier,
    STATE(3861), 1,
      sym_nested_identifier,
    STATE(4377), 1,
      sym_jsx_namespace_name,
  [117324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6806), 1,
      anon_sym_RPAREN,
  [117340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 1,
      anon_sym_COMMA,
    STATE(3525), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6808), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [117354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4053), 1,
      sym_type_parameters,
    STATE(4367), 1,
      sym_formal_parameters,
  [117370] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6810), 1,
      anon_sym_COLON,
  [117386] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_SQUOTE,
    STATE(3458), 1,
      aux_sym_string_repeat2,
    ACTIONS(6631), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [117400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6812), 1,
      anon_sym_RPAREN,
  [117416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_AT,
    ACTIONS(6814), 1,
      anon_sym_export,
    STATE(1151), 1,
      aux_sym_export_statement_repeat1,
    STATE(1171), 1,
      sym_decorator,
  [117432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2948), 1,
      sym_formal_parameters,
    STATE(3916), 1,
      sym_type_parameters,
  [117448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_from,
    STATE(4007), 1,
      sym__from_clause,
    ACTIONS(6816), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [117462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4101), 1,
      anon_sym_COMMA,
    STATE(3511), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6818), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [117476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6820), 1,
      anon_sym_COLON,
  [117492] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4067), 1,
      sym_type_parameters,
    STATE(4306), 1,
      sym_formal_parameters,
  [117508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6822), 1,
      sym_identifier,
    ACTIONS(6824), 1,
      sym_jsx_identifier,
    STATE(4027), 1,
      sym_nested_identifier,
    STATE(4311), 1,
      sym_jsx_namespace_name,
  [117524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4074), 1,
      sym_type_parameters,
    STATE(4314), 1,
      sym_formal_parameters,
  [117540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 1,
      anon_sym_EQ,
    STATE(3952), 1,
      sym__initializer,
    ACTIONS(6826), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [117554] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6828), 1,
      anon_sym_DQUOTE,
    STATE(3499), 1,
      aux_sym_string_repeat1,
    ACTIONS(6830), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [117568] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6828), 1,
      anon_sym_SQUOTE,
    STATE(3560), 1,
      aux_sym_string_repeat2,
    ACTIONS(6832), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [117582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6834), 1,
      anon_sym_RBRACK,
  [117598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6836), 1,
      anon_sym_RBRACK,
  [117614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_COMMA,
    ACTIONS(6671), 1,
      anon_sym_EQ,
    ACTIONS(6838), 1,
      anon_sym_RBRACK,
    STATE(3721), 1,
      aux_sym_array_pattern_repeat1,
  [117630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 1,
      anon_sym_EQ,
    STATE(4096), 1,
      sym__initializer,
    ACTIONS(6840), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [117644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
    ACTIONS(6842), 1,
      anon_sym_RBRACK,
  [117660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6844), 1,
      anon_sym_COMMA,
    ACTIONS(6846), 1,
      anon_sym_GT,
    STATE(3645), 1,
      aux_sym_type_parameters_repeat1,
  [117673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 1,
      anon_sym_implements,
    ACTIONS(6848), 1,
      anon_sym_LBRACE,
    STATE(4210), 1,
      sym_implements_clause,
  [117686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5923), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [117695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 1,
      anon_sym_RPAREN,
    ACTIONS(6850), 1,
      anon_sym_COMMA,
    STATE(3596), 1,
      aux_sym_formal_parameters_repeat1,
  [117708] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(3859), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [117717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6852), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4334), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [117739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4334), 1,
      anon_sym_RPAREN,
    STATE(3618), 1,
      aux_sym_array_repeat1,
  [117752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4279), 1,
      anon_sym_RBRACK,
    STATE(3722), 1,
      aux_sym_array_repeat1,
  [117765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6756), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4279), 1,
      anon_sym_RBRACK,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [117787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    ACTIONS(6854), 1,
      anon_sym_LPAREN,
    STATE(614), 1,
      sym_statement_block,
  [117800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_COMMA,
    ACTIONS(6838), 1,
      anon_sym_RBRACK,
    STATE(3630), 1,
      aux_sym_array_pattern_repeat1,
  [117813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4393), 1,
      anon_sym_RPAREN,
    STATE(3608), 1,
      aux_sym_array_repeat1,
  [117826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4393), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [117839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [117848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6856), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2517), 1,
      anon_sym_RBRACK,
    ACTIONS(6858), 1,
      anon_sym_COMMA,
    STATE(3756), 1,
      aux_sym_tuple_type_repeat1,
  [117870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6860), 1,
      anon_sym_COMMA,
    ACTIONS(6863), 1,
      anon_sym_RPAREN,
    STATE(3596), 1,
      aux_sym_formal_parameters_repeat1,
  [117883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3740), 1,
      anon_sym_LBRACE,
    ACTIONS(3742), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [117894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1287), 1,
      anon_sym_LBRACE,
    STATE(3214), 1,
      sym_object_type,
  [117907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6865), 1,
      anon_sym_COMMA,
    ACTIONS(6867), 1,
      anon_sym_RBRACE,
    STATE(3657), 1,
      aux_sym_enum_body_repeat1,
  [117920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6869), 1,
      anon_sym_COMMA,
    ACTIONS(6871), 1,
      anon_sym_GT,
    STATE(3716), 1,
      aux_sym_type_parameters_repeat1,
  [117933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6873), 1,
      anon_sym_COMMA,
    ACTIONS(6875), 1,
      anon_sym_RBRACK,
    STATE(3623), 1,
      aux_sym_tuple_type_repeat1,
  [117946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4304), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [117955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6671), 1,
      anon_sym_EQ,
    ACTIONS(6877), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_PIPE,
    ACTIONS(5711), 1,
      anon_sym_extends,
  [117988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(6879), 1,
      anon_sym_RBRACK,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [118001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6881), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(6883), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [118023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_RBRACE,
    ACTIONS(6885), 1,
      anon_sym_COMMA,
    STATE(3725), 1,
      aux_sym_named_imports_repeat1,
  [118036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2825), 1,
      anon_sym_GT,
    ACTIONS(6887), 1,
      anon_sym_COMMA,
    STATE(3498), 1,
      aux_sym_implements_clause_repeat1,
  [118049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1287), 1,
      anon_sym_LBRACE,
    STATE(3282), 1,
      sym_object_type,
  [118062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_COMMA,
    ACTIONS(6889), 1,
      anon_sym_RBRACK,
    STATE(3630), 1,
      aux_sym_array_pattern_repeat1,
  [118075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym_COMMA,
    ACTIONS(6893), 1,
      anon_sym_RBRACE,
    STATE(3666), 1,
      aux_sym_object_repeat1,
  [118097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6895), 1,
      sym_identifier,
    ACTIONS(6897), 1,
      anon_sym_LBRACK,
    ACTIONS(6899), 1,
      sym_private_property_identifier,
  [118110] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6901), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      sym_identifier,
    ACTIONS(6905), 1,
      anon_sym_LBRACK,
    ACTIONS(6907), 1,
      sym_private_property_identifier,
  [118132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(6909), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [118145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      sym_identifier,
    ACTIONS(6913), 1,
      anon_sym_LBRACK,
    ACTIONS(6915), 1,
      sym_private_property_identifier,
  [118158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2829), 1,
      anon_sym_GT,
    ACTIONS(6917), 1,
      anon_sym_COMMA,
    STATE(3498), 1,
      aux_sym_implements_clause_repeat1,
  [118171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6919), 1,
      sym_identifier,
    ACTIONS(6921), 1,
      anon_sym_LBRACK,
    ACTIONS(6923), 1,
      sym_private_property_identifier,
  [118184] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6925), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 1,
      anon_sym_RBRACK,
    ACTIONS(6927), 1,
      anon_sym_COMMA,
    STATE(3756), 1,
      aux_sym_tuple_type_repeat1,
  [118206] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6901), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118215] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6901), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6929), 1,
      sym_identifier,
    ACTIONS(6931), 1,
      anon_sym_require,
    STATE(3824), 1,
      sym_nested_identifier,
  [118237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6933), 1,
      anon_sym_COMMA,
    ACTIONS(6935), 1,
      anon_sym_RBRACE,
    STATE(3609), 1,
      aux_sym_named_imports_repeat1,
  [118250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_as,
    ACTIONS(6939), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [118261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      sym_identifier,
    STATE(1143), 1,
      sym_decorator_member_expression,
    STATE(1182), 1,
      sym_decorator_call_expression,
  [118274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6877), 1,
      anon_sym_RBRACK,
    ACTIONS(6943), 1,
      anon_sym_COMMA,
    STATE(3630), 1,
      aux_sym_array_pattern_repeat1,
  [118287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(6948), 1,
      anon_sym_RBRACE,
    STATE(3665), 1,
      aux_sym_object_pattern_repeat1,
  [118309] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6901), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(6950), 1,
      anon_sym_GT,
  [118331] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(4188), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6952), 1,
      sym_identifier,
    ACTIONS(6954), 1,
      anon_sym_GT,
    STATE(4072), 1,
      sym_type_parameter,
  [118353] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6956), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118362] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(4027), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6958), 1,
      anon_sym_COMMA,
    ACTIONS(6961), 1,
      anon_sym_GT,
    STATE(3639), 1,
      aux_sym_type_parameters_repeat1,
  [118384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_as,
    ACTIONS(6965), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [118404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(6969), 1,
      anon_sym_RPAREN,
    STATE(3736), 1,
      aux_sym_formal_parameters_repeat1,
  [118417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_EQ,
    ACTIONS(6973), 1,
      anon_sym_COMMA,
    ACTIONS(6975), 1,
      anon_sym_from,
  [118430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_await,
    STATE(48), 1,
      sym__for_header,
  [118443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 1,
      anon_sym_COMMA,
    ACTIONS(6983), 1,
      anon_sym_GT,
    STATE(3639), 1,
      aux_sym_type_parameters_repeat1,
  [118456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6985), 1,
      anon_sym_COMMA,
    ACTIONS(6987), 1,
      anon_sym_RBRACK,
    STATE(3804), 1,
      aux_sym_tuple_type_repeat1,
  [118469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(5410), 1,
      anon_sym_PIPE,
    ACTIONS(5412), 1,
      anon_sym_extends,
  [118491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6162), 1,
      anon_sym_COMMA,
    ACTIONS(6989), 1,
      anon_sym_LBRACE,
    STATE(3498), 1,
      aux_sym_implements_clause_repeat1,
  [118504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 1,
      anon_sym_RBRACK,
    ACTIONS(6991), 1,
      anon_sym_COMMA,
    STATE(3756), 1,
      aux_sym_tuple_type_repeat1,
  [118517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6952), 1,
      sym_identifier,
    ACTIONS(6983), 1,
      anon_sym_GT,
    STATE(4072), 1,
      sym_type_parameter,
  [118530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(6993), 1,
      anon_sym_EQ,
    STATE(4329), 1,
      sym_type_parameters,
  [118543] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(4023), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LT,
    ACTIONS(6995), 1,
      anon_sym_EQ,
    STATE(4247), 1,
      sym_type_parameters,
  [118574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6997), 1,
      anon_sym_COMMA,
    ACTIONS(6999), 1,
      anon_sym_RBRACE,
    STATE(3737), 1,
      aux_sym_enum_body_repeat1,
  [118587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7001), 1,
      anon_sym_COMMA,
    ACTIONS(7003), 1,
      anon_sym_RBRACE,
    STATE(3737), 1,
      aux_sym_enum_body_repeat1,
  [118600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(7005), 1,
      anon_sym_GT,
  [118613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(205), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1230), 1,
      anon_sym_LBRACE,
    STATE(654), 1,
      sym_object_type,
  [118626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_GT,
    ACTIONS(7007), 1,
      anon_sym_COMMA,
    STATE(3498), 1,
      aux_sym_implements_clause_repeat1,
  [118639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7009), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(7011), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [118661] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(3960), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      anon_sym_extends,
    ACTIONS(7013), 1,
      anon_sym_AMP,
    ACTIONS(7015), 1,
      anon_sym_PIPE,
  [118683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7017), 1,
      anon_sym_COMMA,
    ACTIONS(7020), 1,
      anon_sym_RBRACE,
    STATE(3665), 1,
      aux_sym_object_pattern_repeat1,
  [118696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7022), 1,
      anon_sym_COMMA,
    ACTIONS(7025), 1,
      anon_sym_RBRACE,
    STATE(3666), 1,
      aux_sym_object_repeat1,
  [118709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 1,
      anon_sym_COMMA,
    ACTIONS(7029), 1,
      anon_sym_RBRACK,
    STATE(3595), 1,
      aux_sym_tuple_type_repeat1,
  [118722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4420), 1,
      anon_sym_RPAREN,
    STATE(3676), 1,
      aux_sym_array_repeat1,
  [118735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4420), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [118748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 1,
      anon_sym_COMMA,
    ACTIONS(7033), 1,
      anon_sym_RBRACE,
    STATE(3820), 1,
      aux_sym_enum_body_repeat1,
  [118761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(7035), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [118774] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(3960), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym_COMMA,
    ACTIONS(7037), 1,
      anon_sym_RBRACE,
    STATE(3666), 1,
      aux_sym_object_repeat1,
  [118796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(7039), 1,
      anon_sym_RBRACE,
    STATE(3665), 1,
      aux_sym_object_pattern_repeat1,
  [118809] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(3960), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(7041), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [118831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2783), 1,
      anon_sym_GT,
    ACTIONS(7045), 1,
      anon_sym_COMMA,
    STATE(3498), 1,
      aux_sym_implements_clause_repeat1,
  [118853] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(3964), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7047), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7051), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4317), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [118902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4317), 1,
      anon_sym_RPAREN,
    STATE(3662), 1,
      aux_sym_array_repeat1,
  [118915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7047), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7053), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118933] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(3960), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7055), 1,
      sym_identifier,
    ACTIONS(7057), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [118953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 1,
      anon_sym_GT,
    ACTIONS(7059), 1,
      anon_sym_COMMA,
    STATE(3498), 1,
      aux_sym_implements_clause_repeat1,
  [118966] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(3980), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118984] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(3956), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7061), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119002] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6451), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [119011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7053), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(7063), 1,
      anon_sym_RBRACE,
    STATE(3665), 1,
      aux_sym_object_pattern_repeat1,
  [119033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4397), 1,
      anon_sym_RPAREN,
    STATE(3703), 1,
      aux_sym_array_repeat1,
  [119046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4397), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [119059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym_COMMA,
    ACTIONS(7069), 1,
      anon_sym_RBRACE,
    STATE(3666), 1,
      aux_sym_object_repeat1,
  [119099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(7071), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [119112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(7073), 1,
      anon_sym_GT,
  [119125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2833), 1,
      anon_sym_GT,
    ACTIONS(7075), 1,
      anon_sym_COMMA,
    STATE(3498), 1,
      aux_sym_implements_clause_repeat1,
  [119138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(7077), 1,
      anon_sym_RBRACE,
    STATE(3674), 1,
      aux_sym_object_pattern_repeat1,
  [119151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym_COMMA,
    ACTIONS(7079), 1,
      anon_sym_RBRACE,
    STATE(3673), 1,
      aux_sym_object_repeat1,
  [119164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 1,
      anon_sym_is,
    ACTIONS(5863), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [119175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6671), 1,
      anon_sym_EQ,
    ACTIONS(7081), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5845), 1,
      anon_sym_DOT,
    ACTIONS(7083), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3813), 1,
      anon_sym_LBRACE,
    ACTIONS(3815), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [119217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7085), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [119226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 1,
      anon_sym_COMMA,
    ACTIONS(7090), 1,
      anon_sym_RBRACE,
    STATE(3714), 1,
      aux_sym_export_clause_repeat1,
  [119239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym_COMMA,
    ACTIONS(7079), 1,
      anon_sym_RBRACE,
    STATE(3666), 1,
      aux_sym_object_repeat1,
  [119252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 1,
      anon_sym_COMMA,
    ACTIONS(7094), 1,
      anon_sym_GT,
    STATE(3639), 1,
      aux_sym_type_parameters_repeat1,
  [119265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(7077), 1,
      anon_sym_RBRACE,
    STATE(3665), 1,
      aux_sym_object_pattern_repeat1,
  [119278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6952), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_GT,
    STATE(4072), 1,
      sym_type_parameter,
  [119291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 1,
      anon_sym_EQ,
    ACTIONS(3076), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [119302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_COMMA,
    ACTIONS(6838), 1,
      anon_sym_RBRACK,
    STATE(3721), 1,
      aux_sym_array_pattern_repeat1,
  [119315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_COMMA,
    ACTIONS(7099), 1,
      anon_sym_RBRACK,
    STATE(3630), 1,
      aux_sym_array_pattern_repeat1,
  [119328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(7101), 1,
      anon_sym_RBRACK,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [119341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7103), 1,
      anon_sym_LBRACE,
    ACTIONS(6449), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [119352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_LBRACE,
    ACTIONS(7105), 1,
      sym_identifier,
    STATE(3449), 1,
      sym_export_clause,
  [119365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_COMMA,
    ACTIONS(7110), 1,
      anon_sym_RBRACE,
    STATE(3725), 1,
      aux_sym_named_imports_repeat1,
  [119378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 1,
      anon_sym_LPAREN,
    ACTIONS(7114), 1,
      anon_sym_await,
    STATE(52), 1,
      sym__for_header,
  [119391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    STATE(4179), 1,
      sym_string,
  [119404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym_COMMA,
    ACTIONS(6893), 1,
      anon_sym_RBRACE,
    STATE(3786), 1,
      aux_sym_object_repeat1,
  [119417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_COMMA,
    ACTIONS(7118), 1,
      anon_sym_RBRACK,
    STATE(3650), 1,
      aux_sym_tuple_type_repeat1,
  [119430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5991), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [119439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7120), 1,
      anon_sym_COMMA,
    ACTIONS(7122), 1,
      anon_sym_RPAREN,
    STATE(3581), 1,
      aux_sym_formal_parameters_repeat1,
  [119452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [119461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      anon_sym_while,
    ACTIONS(7124), 1,
      anon_sym_else,
    STATE(761), 1,
      sym_else_clause,
  [119474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    ACTIONS(7126), 1,
      anon_sym_RPAREN,
    STATE(4182), 1,
      sym_type_annotation,
  [119487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6952), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_GT,
    STATE(4072), 1,
      sym_type_parameter,
  [119500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_RPAREN,
    ACTIONS(7130), 1,
      anon_sym_COMMA,
    STATE(3596), 1,
      aux_sym_formal_parameters_repeat1,
  [119513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7132), 1,
      anon_sym_COMMA,
    ACTIONS(7135), 1,
      anon_sym_RBRACE,
    STATE(3737), 1,
      aux_sym_enum_body_repeat1,
  [119526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_from,
    ACTIONS(7137), 1,
      anon_sym_as,
    STATE(3938), 1,
      sym__from_clause,
  [119539] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(7139), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [119548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 1,
      anon_sym_RBRACE,
    ACTIONS(7141), 1,
      anon_sym_COMMA,
    STATE(3714), 1,
      aux_sym_export_clause_repeat1,
  [119561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7143), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_from,
    ACTIONS(7137), 1,
      anon_sym_as,
    STATE(3872), 1,
      sym__from_clause,
  [119583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_LBRACE,
    ACTIONS(7145), 1,
      sym_identifier,
    STATE(3476), 1,
      sym_export_clause,
  [119596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6973), 1,
      anon_sym_COMMA,
    ACTIONS(6975), 1,
      anon_sym_from,
    ACTIONS(7147), 1,
      anon_sym_EQ,
  [119609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_as,
    ACTIONS(7151), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7153), 1,
      anon_sym_LBRACE,
    ACTIONS(6352), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [119631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7155), 1,
      anon_sym_COMMA,
    ACTIONS(7157), 1,
      anon_sym_RBRACE,
    STATE(3740), 1,
      aux_sym_export_clause_repeat1,
  [119644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_LBRACE,
    ACTIONS(6461), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [119655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7159), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [119664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_EQ,
    ACTIONS(3096), 2,
      anon_sym_in,
      anon_sym_of,
  [119675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    STATE(3892), 1,
      sym_string,
  [119688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7161), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7163), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [119706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119715] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(4017), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [119724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7167), 1,
      anon_sym_COMMA,
    ACTIONS(7170), 1,
      anon_sym_RBRACK,
    STATE(3756), 1,
      aux_sym_tuple_type_repeat1,
  [119737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7172), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [119755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7161), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7176), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7161), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 1,
      sym_identifier,
    ACTIONS(7182), 1,
      anon_sym_LBRACK,
    ACTIONS(7184), 1,
      sym_private_property_identifier,
  [119804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5913), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [119813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 1,
      sym_identifier,
    ACTIONS(7188), 1,
      anon_sym_LBRACK,
    ACTIONS(7190), 1,
      sym_private_property_identifier,
  [119826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(205), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1230), 1,
      anon_sym_LBRACE,
    STATE(738), 1,
      sym_object_type,
  [119848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7192), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 1,
      anon_sym_COMMA,
    ACTIONS(7196), 1,
      anon_sym_RPAREN,
    STATE(3799), 1,
      aux_sym_formal_parameters_repeat1,
  [119870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4430), 1,
      anon_sym_RPAREN,
    STATE(3671), 1,
      aux_sym_array_repeat1,
  [119883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4430), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [119896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7198), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7200), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(6948), 1,
      anon_sym_RBRACE,
    STATE(3797), 1,
      aux_sym_object_pattern_repeat1,
  [119945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7206), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 1,
      sym_identifier,
    ACTIONS(7210), 1,
      anon_sym_LBRACK,
    ACTIONS(7212), 1,
      sym_private_property_identifier,
  [119967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 1,
      anon_sym_RBRACK,
    ACTIONS(7214), 1,
      anon_sym_COMMA,
    STATE(3756), 1,
      aux_sym_tuple_type_repeat1,
  [119980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7216), 1,
      sym_identifier,
    ACTIONS(7218), 1,
      anon_sym_LBRACK,
    ACTIONS(7220), 1,
      sym_private_property_identifier,
  [119993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_LBRACE,
    ACTIONS(3750), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [120004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 1,
      sym_identifier,
    ACTIONS(7224), 1,
      anon_sym_LBRACK,
    ACTIONS(7226), 1,
      sym_private_property_identifier,
  [120017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 1,
      sym_identifier,
    ACTIONS(7230), 1,
      anon_sym_LBRACK,
    ACTIONS(7232), 1,
      sym_private_property_identifier,
  [120030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7234), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym_COMMA,
    ACTIONS(7238), 1,
      anon_sym_RBRACE,
    STATE(3666), 1,
      aux_sym_object_repeat1,
  [120061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 1,
      anon_sym_as,
    ACTIONS(7244), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7246), 1,
      sym_identifier,
    ACTIONS(7248), 1,
      anon_sym_LBRACK,
    ACTIONS(7250), 1,
      sym_private_property_identifier,
  [120094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      sym_identifier,
    ACTIONS(7254), 1,
      anon_sym_LBRACK,
    ACTIONS(7256), 1,
      sym_private_property_identifier,
  [120107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7258), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7260), 1,
      sym_identifier,
    ACTIONS(7262), 1,
      anon_sym_LBRACK,
    ACTIONS(7264), 1,
      sym_private_property_identifier,
  [120129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7266), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 1,
      sym_identifier,
    ACTIONS(7270), 1,
      anon_sym_LBRACK,
    ACTIONS(7272), 1,
      sym_private_property_identifier,
  [120160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7234), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(7274), 1,
      anon_sym_RBRACE,
    STATE(3665), 1,
      aux_sym_object_pattern_repeat1,
  [120182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_COMMA,
    ACTIONS(7276), 1,
      anon_sym_RBRACE,
    STATE(3665), 1,
      aux_sym_object_pattern_repeat1,
  [120195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1353), 1,
      anon_sym_RPAREN,
    ACTIONS(7278), 1,
      anon_sym_COMMA,
    STATE(3596), 1,
      aux_sym_formal_parameters_repeat1,
  [120208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      anon_sym_while,
    ACTIONS(7280), 1,
      anon_sym_else,
    STATE(761), 1,
      sym_else_clause,
  [120221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7282), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym_COMMA,
    ACTIONS(7284), 1,
      anon_sym_RBRACE,
    STATE(3666), 1,
      aux_sym_object_repeat1,
  [120243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7258), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_RBRACK,
    ACTIONS(7286), 1,
      anon_sym_COMMA,
    STATE(3756), 1,
      aux_sym_tuple_type_repeat1,
  [120265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 1,
      sym_identifier,
    ACTIONS(7290), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7258), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_COMMA,
    ACTIONS(6673), 1,
      anon_sym_RBRACK,
    STATE(3612), 1,
      aux_sym_array_pattern_repeat1,
  [120298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7234), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4408), 1,
      anon_sym_RPAREN,
    STATE(3827), 1,
      aux_sym_array_repeat1,
  [120320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      anon_sym_LBRACE,
    ACTIONS(3801), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [120331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
  [120344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4408), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [120357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7292), 1,
      anon_sym_LPAREN,
    ACTIONS(7294), 1,
      anon_sym_await,
    STATE(42), 1,
      sym__for_header,
  [120370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4432), 1,
      anon_sym_RBRACK,
    STATE(3606), 1,
      aux_sym_array_repeat1,
  [120383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(4432), 1,
      anon_sym_RBRACK,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [120396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7296), 1,
      anon_sym_COMMA,
    ACTIONS(7298), 1,
      anon_sym_RBRACK,
    STATE(3779), 1,
      aux_sym_tuple_type_repeat1,
  [120409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_COMMA,
    ACTIONS(6673), 1,
      anon_sym_RBRACK,
    STATE(3630), 1,
      aux_sym_array_pattern_repeat1,
  [120422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 1,
      anon_sym_COMMA,
    ACTIONS(7302), 1,
      anon_sym_RBRACE,
    STATE(3737), 1,
      aux_sym_enum_body_repeat1,
  [120435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7304), 1,
      sym_identifier,
    STATE(2209), 1,
      sym_decorator_member_expression,
    STATE(2282), 1,
      sym_decorator_call_expression,
  [120448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7306), 1,
      anon_sym_COMMA,
    ACTIONS(7308), 1,
      anon_sym_RBRACE,
    STATE(3737), 1,
      aux_sym_enum_body_repeat1,
  [120461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(7310), 1,
      anon_sym_GT,
  [120474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4478), 1,
      anon_sym_extends,
    ACTIONS(7312), 1,
      anon_sym_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE,
  [120487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_GT,
    ACTIONS(7316), 1,
      anon_sym_COMMA,
    STATE(3498), 1,
      aux_sym_implements_clause_repeat1,
  [120500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5845), 1,
      anon_sym_DOT,
    ACTIONS(7318), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3724), 1,
      anon_sym_LBRACE,
    ACTIONS(3726), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [120531] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(7320), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_array_repeat1,
  [120544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_LBRACE,
    ACTIONS(6429), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [120555] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(6463), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [120564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [120573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_EQ,
    ACTIONS(3096), 2,
      anon_sym_in,
      anon_sym_of,
  [120584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_AMP,
    ACTIONS(5551), 1,
      anon_sym_extends,
    ACTIONS(6368), 1,
      anon_sym_PIPE,
  [120597] = 4,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(7328), 1,
      sym__glimmer_template_content,
    ACTIONS(7331), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(3833), 1,
      aux_sym_glimmer_template_repeat1,
  [120610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6952), 1,
      sym_identifier,
    STATE(3578), 1,
      sym_type_parameter,
  [120620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(51), 1,
      sym_parenthesized_expression,
  [120630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7335), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1913), 1,
      sym_class_body,
  [120648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1924), 1,
      sym_statement_block,
  [120658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1947), 1,
      sym_statement_block,
  [120668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3954), 1,
      sym_statement_block,
  [120678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1951), 1,
      sym_class_body,
  [120688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3946), 1,
      sym_statement_block,
  [120706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3227), 1,
      sym_formal_parameters,
  [120724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1397), 1,
      anon_sym_LBRACE,
    STATE(168), 1,
      sym_statement_block,
  [120734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    STATE(618), 1,
      sym_statement_block,
  [120744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6425), 1,
      anon_sym_in,
    ACTIONS(6427), 1,
      anon_sym_of,
  [120754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 1,
      anon_sym_LBRACE,
    STATE(757), 1,
      sym_class_body,
  [120772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5691), 1,
      anon_sym_LBRACE,
    STATE(174), 1,
      sym_class_body,
  [120782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(2057), 1,
      sym_class_body,
  [120792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7339), 1,
      sym_identifier,
    STATE(3710), 1,
      sym_nested_identifier,
  [120802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      sym_identifier,
    ACTIONS(7343), 1,
      anon_sym_STAR,
  [120812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(621), 1,
      sym_statement_block,
  [120822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    STATE(2543), 1,
      sym_arguments,
  [120832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1949), 1,
      sym_class_body,
  [120850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(7310), 1,
      anon_sym_GT,
  [120860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7345), 1,
      anon_sym_SEMI,
    ACTIONS(7347), 1,
      sym__automatic_semicolon,
  [120870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(7310), 1,
      anon_sym_GT,
  [120880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4270), 1,
      sym_formal_parameters,
  [120898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_in,
    ACTIONS(7353), 1,
      anon_sym_COLON,
  [120908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7355), 1,
      anon_sym_SEMI,
    ACTIONS(7357), 1,
      sym__automatic_semicolon,
  [120918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4441), 1,
      sym_formal_parameters,
  [120928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 1,
      anon_sym_LPAREN,
    STATE(2396), 1,
      sym_arguments,
  [120938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 1,
      anon_sym_LBRACE,
    STATE(639), 1,
      sym_class_body,
  [120948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
  [120958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(1460), 1,
      sym_class_body,
  [120968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4432), 1,
      sym_formal_parameters,
  [120978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7359), 1,
      anon_sym_SEMI,
    ACTIONS(7361), 1,
      sym__automatic_semicolon,
  [120988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4229), 1,
      sym_formal_parameters,
  [120998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1929), 1,
      sym_statement_block,
  [121016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [121024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_parenthesized_expression,
  [121042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(619), 1,
      sym_class_body,
  [121052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4336), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4168), 1,
      sym_formal_parameters,
  [121078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6254), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [121086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3219), 1,
      sym_formal_parameters,
  [121096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3925), 1,
      sym_statement_block,
  [121106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    STATE(3225), 1,
      sym_statement_block,
  [121116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1881), 1,
      sym_class_body,
  [121134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1970), 1,
      sym_class_body,
  [121144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    STATE(1452), 1,
      sym_statement_block,
  [121154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4311), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7363), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7365), 1,
      anon_sym_SEMI,
    ACTIONS(7367), 1,
      sym__automatic_semicolon,
  [121180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4412), 1,
      sym_formal_parameters,
  [121198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3265), 1,
      sym_class_body,
  [121208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7371), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [121216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    STATE(3251), 1,
      sym_statement_block,
  [121226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7373), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [121234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    STATE(3931), 1,
      sym_type_annotation,
  [121244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 1,
      sym_identifier,
    ACTIONS(7272), 1,
      sym_private_property_identifier,
  [121262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      sym_private_property_identifier,
  [121272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4248), 1,
      sym_formal_parameters,
  [121282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7381), 1,
      sym_identifier,
    ACTIONS(7383), 1,
      sym_private_property_identifier,
  [121292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7385), 1,
      sym_identifier,
    ACTIONS(7387), 1,
      sym_private_property_identifier,
  [121302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7389), 1,
      sym_identifier,
    ACTIONS(7391), 1,
      sym_private_property_identifier,
  [121312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7393), 1,
      sym_identifier,
    ACTIONS(7395), 1,
      sym_private_property_identifier,
  [121322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7397), 1,
      sym_identifier,
    ACTIONS(7399), 1,
      sym_private_property_identifier,
  [121332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 1,
      sym_identifier,
    ACTIONS(7212), 1,
      sym_private_property_identifier,
  [121342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7401), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7403), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1854), 1,
      sym_statement_block,
  [121368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(55), 1,
      sym_parenthesized_expression,
  [121378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2960), 1,
      sym_formal_parameters,
  [121388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2874), 1,
      sym_formal_parameters,
  [121398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5379), 1,
      anon_sym_LPAREN,
    STATE(2783), 1,
      sym_formal_parameters,
  [121408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1848), 1,
      sym_class_body,
  [121418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(1484), 1,
      sym_class_body,
  [121428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7405), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym__for_header,
  [121438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7407), 1,
      anon_sym_SEMI,
    ACTIONS(7409), 1,
      sym__automatic_semicolon,
  [121448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3805), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(760), 1,
      sym_statement_block,
  [121466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7411), 1,
      anon_sym_LBRACE,
    STATE(637), 1,
      sym_enum_body,
  [121476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5188), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7413), 1,
      sym_identifier,
    ACTIONS(7415), 1,
      sym_private_property_identifier,
  [121494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5116), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6260), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [121510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      sym_identifier,
    ACTIONS(7419), 1,
      sym_private_property_identifier,
  [121520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1957), 1,
      sym_statement_block,
  [121530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7421), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [121538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [121546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7405), 1,
      anon_sym_LPAREN,
    STATE(54), 1,
      sym__for_header,
  [121556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
    STATE(2687), 1,
      sym_formal_parameters,
  [121566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1997), 1,
      sym_statement_block,
  [121576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_LBRACE,
    STATE(3307), 1,
      sym_enum_body,
  [121586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3104), 1,
      sym_formal_parameters,
  [121596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7425), 1,
      anon_sym_SEMI,
    ACTIONS(7427), 1,
      sym__automatic_semicolon,
  [121606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6952), 1,
      sym_identifier,
    STATE(4072), 1,
      sym_type_parameter,
  [121616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_from,
    STATE(3860), 1,
      sym__from_clause,
  [121626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7429), 1,
      sym_identifier,
    ACTIONS(7431), 1,
      anon_sym_STAR,
  [121636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_LBRACE,
    STATE(3289), 1,
      sym_enum_body,
  [121646] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(7433), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [121654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7435), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1897), 1,
      sym_class_body,
  [121672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    STATE(1680), 1,
      sym_arguments,
  [121690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7439), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(2058), 1,
      sym_class_body,
  [121716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(2073), 1,
      sym_class_body,
  [121726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7441), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [121734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4102), 1,
      sym_statement_block,
  [121744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5591), 2,
      anon_sym_in,
      anon_sym_of,
  [121760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5106), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7443), 1,
      sym_identifier,
    STATE(3824), 1,
      sym_nested_identifier,
  [121778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(632), 1,
      sym_class_body,
  [121788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4108), 1,
      sym_statement_block,
  [121798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7405), 1,
      anon_sym_LPAREN,
    STATE(40), 1,
      sym__for_header,
  [121808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7445), 1,
      anon_sym_LBRACE,
    STATE(721), 1,
      sym_switch_body,
  [121818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(47), 1,
      sym_parenthesized_expression,
  [121828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7447), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3376), 1,
      sym_class_body,
  [121846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1999), 1,
      sym_class_body,
  [121856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3984), 1,
      sym_statement_block,
  [121866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    STATE(3309), 1,
      sym_statement_block,
  [121876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym_parenthesized_expression,
  [121886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(57), 1,
      sym_parenthesized_expression,
  [121896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1875), 1,
      sym_class_body,
  [121906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7449), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3172), 1,
      sym_formal_parameters,
  [121932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7451), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1894), 1,
      sym_class_body,
  [121950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1893), 1,
      sym_statement_block,
  [121960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1889), 1,
      sym_statement_block,
  [121970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_from,
    STATE(4082), 1,
      sym__from_clause,
  [121980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1879), 1,
      sym_class_body,
  [121990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5158), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4139), 1,
      sym_formal_parameters,
  [122008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3842), 1,
      sym_statement_block,
  [122018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5102), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3844), 1,
      sym_statement_block,
  [122044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1922), 1,
      sym_class_body,
  [122054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(625), 1,
      sym_class_body,
  [122064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LBRACE,
    STATE(624), 1,
      sym_statement_block,
  [122074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(620), 1,
      sym_statement_block,
  [122084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 1,
      anon_sym_LBRACE,
    STATE(710), 1,
      sym_class_body,
  [122094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym_class_body,
  [122104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7081), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4434), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3887), 1,
      sym_statement_block,
  [122146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7455), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [122154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1857), 1,
      sym_class_body,
  [122164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5691), 1,
      anon_sym_LBRACE,
    STATE(169), 1,
      sym_class_body,
  [122174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [122190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3877), 1,
      sym_statement_block,
  [122200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5106), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_SEMI,
    ACTIONS(7459), 1,
      sym__automatic_semicolon,
  [122218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(3980), 1,
      sym_statement_block,
  [122228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(7073), 1,
      anon_sym_GT,
  [122238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7461), 1,
      anon_sym_SEMI,
    ACTIONS(7463), 1,
      sym__automatic_semicolon,
  [122248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(7073), 1,
      anon_sym_GT,
  [122258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(1449), 1,
      sym_class_body,
  [122284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    STATE(1487), 1,
      sym_arguments,
  [122294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    STATE(1448), 1,
      sym_statement_block,
  [122304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(3388), 1,
      sym_formal_parameters,
  [122314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3154), 1,
      sym_class_body,
  [122324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7020), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 1,
      anon_sym_LPAREN,
    STATE(1364), 1,
      sym_arguments,
  [122350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3159), 1,
      sym_class_body,
  [122360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4010), 1,
      sym_statement_block,
  [122370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1953), 1,
      sym_class_body,
  [122380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      sym_parenthesized_expression,
  [122390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(7005), 1,
      anon_sym_GT,
  [122400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    STATE(1462), 1,
      sym_statement_block,
  [122410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 1,
      anon_sym_LBRACE,
    STATE(651), 1,
      sym_class_body,
  [122420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(2001), 1,
      sym_class_body,
  [122430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(7005), 1,
      anon_sym_GT,
  [122440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1397), 1,
      anon_sym_LBRACE,
    STATE(176), 1,
      sym_statement_block,
  [122450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3173), 1,
      sym_class_body,
  [122460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1842), 1,
      sym_statement_block,
  [122470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1942), 1,
      sym_statement_block,
  [122480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_from,
    STATE(4054), 1,
      sym__from_clause,
  [122490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(584), 1,
      sym_statement_block,
  [122500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4378), 1,
      sym_formal_parameters,
  [122510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7465), 1,
      sym_identifier,
    ACTIONS(7467), 1,
      sym_private_property_identifier,
  [122520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      sym_identifier,
    ACTIONS(7471), 1,
      sym_private_property_identifier,
  [122530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5691), 1,
      anon_sym_LBRACE,
    STATE(156), 1,
      sym_class_body,
  [122540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7473), 1,
      sym_identifier,
    ACTIONS(7475), 1,
      sym_private_property_identifier,
  [122550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 1,
      sym_identifier,
    ACTIONS(7479), 1,
      sym_private_property_identifier,
  [122560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      sym_identifier,
    ACTIONS(7483), 1,
      sym_private_property_identifier,
  [122570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      sym_identifier,
    ACTIONS(7487), 1,
      sym_private_property_identifier,
  [122580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(1464), 1,
      sym_class_body,
  [122590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4166), 1,
      sym_formal_parameters,
  [122600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    STATE(1463), 1,
      sym_statement_block,
  [122610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(50), 1,
      sym_parenthesized_expression,
  [122620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1827), 1,
      sym_statement_block,
  [122630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(1527), 1,
      sym_class_body,
  [122640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4368), 1,
      sym_formal_parameters,
  [122650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    STATE(1418), 1,
      sym_statement_block,
  [122660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(1417), 1,
      sym_class_body,
  [122670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    STATE(1531), 1,
      sym_statement_block,
  [122680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_COLON,
    STATE(3899), 1,
      sym_type_annotation,
  [122690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4354), 1,
      sym_formal_parameters,
  [122700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7489), 1,
      anon_sym_SEMI,
    ACTIONS(7491), 1,
      sym__automatic_semicolon,
  [122710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3190), 1,
      sym_class_body,
  [122720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_LPAREN,
    STATE(2396), 1,
      sym_arguments,
  [122730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3196), 1,
      sym_class_body,
  [122740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(1388), 1,
      sym_class_body,
  [122750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7493), 1,
      sym_identifier,
    ACTIONS(7495), 1,
      sym_private_property_identifier,
  [122760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7497), 1,
      sym_identifier,
    ACTIONS(7499), 1,
      sym_private_property_identifier,
  [122770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1843), 1,
      sym_class_body,
  [122780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5102), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [122788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5691), 1,
      anon_sym_LBRACE,
    STATE(178), 1,
      sym_class_body,
  [122798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_from,
    STATE(4004), 1,
      sym__from_clause,
  [122808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7501), 1,
      sym_identifier,
    ACTIONS(7503), 1,
      anon_sym_STAR,
  [122818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6863), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [122826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4291), 1,
      sym_formal_parameters,
  [122836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    ACTIONS(6950), 1,
      anon_sym_GT,
  [122846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(1478), 1,
      sym_class_body,
  [122856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7505), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [122864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    STATE(1459), 1,
      sym_statement_block,
  [122874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6961), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [122882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2905), 1,
      sym_jsx_identifier,
    ACTIONS(7507), 1,
      sym_identifier,
  [122892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4307), 1,
      sym_formal_parameters,
  [122902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7509), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7511), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4169), 1,
      sym_formal_parameters,
  [122928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5476), 1,
      anon_sym_COLON,
    ACTIONS(6950), 1,
      anon_sym_GT,
  [122938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4163), 1,
      sym_formal_parameters,
  [122948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7513), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [122956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4312), 1,
      sym_formal_parameters,
  [122966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7515), 1,
      anon_sym_SEMI,
    ACTIONS(7517), 1,
      sym__automatic_semicolon,
  [122976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6952), 1,
      sym_identifier,
    STATE(3600), 1,
      sym_type_parameter,
  [122986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_COLON,
    STATE(3594), 1,
      sym_type_annotation,
  [122996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7519), 1,
      sym_identifier,
    ACTIONS(7521), 1,
      sym_private_property_identifier,
  [123006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      sym_identifier,
    ACTIONS(7525), 1,
      sym_private_property_identifier,
  [123016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      sym_identifier,
    ACTIONS(7529), 1,
      sym_private_property_identifier,
  [123026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(3961), 1,
      sym_parenthesized_expression,
  [123036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6895), 1,
      sym_identifier,
    ACTIONS(6899), 1,
      sym_private_property_identifier,
  [123046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_LPAREN,
    STATE(4161), 1,
      sym_formal_parameters,
  [123056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7531), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6877), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [123072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7411), 1,
      anon_sym_LBRACE,
    STATE(762), 1,
      sym_enum_body,
  [123082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    STATE(3218), 1,
      sym_class_body,
  [123092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5611), 1,
      anon_sym_LBRACE,
    STATE(2068), 1,
      sym_class_body,
  [123102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7533), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [123110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(1849), 1,
      sym_statement_block,
  [123120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7535), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [123128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    STATE(1390), 1,
      sym_statement_block,
  [123138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5464), 1,
      anon_sym_LPAREN,
    STATE(2626), 1,
      sym_arguments,
  [123148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [123164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4003), 1,
      sym_statement_block,
  [123174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(645), 1,
      sym_statement_block,
  [123184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7537), 1,
      sym_identifier,
    ACTIONS(7539), 1,
      anon_sym_STAR,
  [123194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [123202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7541), 1,
      anon_sym_LPAREN,
    STATE(4091), 1,
      sym_parenthesized_expression,
  [123212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5116), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [123220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 1,
      anon_sym_LBRACE,
    STATE(4000), 1,
      sym_statement_block,
  [123230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_LPAREN,
    STATE(1975), 1,
      sym_arguments,
  [123240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7543), 1,
      sym_identifier,
  [123247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_EQ_GT,
  [123254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7547), 1,
      anon_sym_EQ_GT,
  [123261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_EQ_GT,
  [123268] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(7551), 1,
      sym_regex_pattern,
  [123275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7553), 1,
      anon_sym_EQ_GT,
  [123282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7555), 1,
      anon_sym_from,
  [123289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      anon_sym_LPAREN,
  [123296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7559), 1,
      anon_sym_COLON,
  [123303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_RBRACK,
  [123310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7561), 1,
      sym_identifier,
  [123317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7563), 1,
      anon_sym_GT,
  [123324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_DOT,
  [123331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7565), 1,
      anon_sym_GT,
  [123338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7567), 1,
      anon_sym_GT,
  [123345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7569), 1,
      anon_sym_GT,
  [123352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7571), 1,
      anon_sym_from,
  [123359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7573), 1,
      anon_sym_as,
  [123366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7575), 1,
      anon_sym_GT,
  [123373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7577), 1,
      anon_sym_GT,
  [123380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7579), 1,
      anon_sym_RBRACK,
  [123387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7581), 1,
      anon_sym_LBRACK,
  [123394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7583), 1,
      anon_sym_new,
  [123401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7585), 1,
      anon_sym_require,
  [123408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7587), 1,
      anon_sym_from,
  [123415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6987), 1,
      anon_sym_RBRACK,
  [123422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7589), 1,
      anon_sym_EQ_GT,
  [123429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7591), 1,
      sym_identifier,
  [123436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7593), 1,
      anon_sym_EQ_GT,
  [123443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_DOT,
  [123450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7595), 1,
      anon_sym_COLON,
  [123457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7597), 1,
      anon_sym_EQ_GT,
  [123464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7073), 1,
      anon_sym_GT,
  [123471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5333), 1,
      anon_sym_is,
  [123478] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(7599), 1,
      sym_regex_pattern,
  [123485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7601), 1,
      sym_identifier,
  [123492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7603), 1,
      anon_sym_from,
  [123499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4576), 1,
      anon_sym_COLON,
  [123506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7605), 1,
      anon_sym_EQ_GT,
  [123513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7607), 1,
      anon_sym_EQ_GT,
  [123520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7609), 1,
      anon_sym_EQ_GT,
  [123527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_RPAREN,
  [123534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6484), 1,
      anon_sym_EQ,
  [123541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7611), 1,
      sym_identifier,
  [123548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7613), 1,
      anon_sym_EQ_GT,
  [123555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_RPAREN,
  [123562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_RPAREN,
  [123569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7615), 1,
      anon_sym_GT,
  [123576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7617), 1,
      anon_sym_GT,
  [123583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7619), 1,
      anon_sym_RBRACK,
  [123590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7621), 1,
      anon_sym_EQ_GT,
  [123597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7623), 1,
      anon_sym_EQ_GT,
  [123604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7625), 1,
      anon_sym_EQ_GT,
  [123611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7627), 1,
      anon_sym_from,
  [123618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7629), 1,
      sym_identifier,
  [123625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7631), 1,
      anon_sym_EQ_GT,
  [123632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4587), 1,
      anon_sym_RPAREN,
  [123639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7633), 1,
      anon_sym_EQ_GT,
  [123646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7635), 1,
      anon_sym_EQ_GT,
  [123653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7637), 1,
      anon_sym_EQ_GT,
  [123660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_RBRACE,
  [123667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7639), 1,
      anon_sym_EQ_GT,
  [123674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7641), 1,
      anon_sym_EQ_GT,
  [123681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7643), 1,
      anon_sym_EQ_GT,
  [123688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7645), 1,
      anon_sym_EQ_GT,
  [123695] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(7647), 1,
      sym_regex_pattern,
  [123702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      sym_identifier,
  [123709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 1,
      anon_sym_from,
  [123716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7653), 1,
      anon_sym_RPAREN,
  [123723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4578), 1,
      anon_sym_RPAREN,
  [123730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5875), 1,
      anon_sym_DOT,
  [123737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7655), 1,
      anon_sym_RPAREN,
  [123744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7657), 1,
      anon_sym_COLON,
  [123751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7659), 1,
      anon_sym_RBRACK,
  [123758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7661), 1,
      anon_sym_EQ_GT,
  [123765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4166), 1,
      anon_sym_DOT,
  [123772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      sym_identifier,
  [123779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 1,
      anon_sym_RBRACK,
  [123786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7665), 1,
      sym_identifier,
  [123793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_RBRACK,
  [123800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym_RBRACK,
  [123807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7671), 1,
      sym_identifier,
  [123814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7673), 1,
      anon_sym_RBRACK,
  [123821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_RBRACK,
  [123828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7677), 1,
      sym_identifier,
  [123835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5504), 1,
      anon_sym_DOT,
  [123842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7679), 1,
      sym_identifier,
  [123849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7681), 1,
      anon_sym_RBRACK,
  [123856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4501), 1,
      anon_sym_RBRACE,
  [123863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7683), 1,
      anon_sym_RBRACK,
  [123870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7685), 1,
      anon_sym_RBRACK,
  [123877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      anon_sym_RBRACK,
  [123884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7689), 1,
      anon_sym_RBRACK,
  [123891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7691), 1,
      anon_sym_RBRACK,
  [123898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7693), 1,
      sym_identifier,
  [123905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7695), 1,
      anon_sym_RBRACK,
  [123912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      sym_identifier,
  [123919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7699), 1,
      sym_identifier,
  [123926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7701), 1,
      sym_identifier,
  [123933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7703), 1,
      anon_sym_LBRACE,
  [123940] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(7705), 1,
      sym_regex_pattern,
  [123947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7707), 1,
      anon_sym_RPAREN,
  [123954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7709), 1,
      anon_sym_class,
  [123961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7711), 1,
      anon_sym_EQ_GT,
  [123968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_EQ_GT,
  [123975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5282), 1,
      anon_sym_DOT,
  [123982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7715), 1,
      anon_sym_EQ,
  [123989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7717), 1,
      anon_sym_namespace,
  [123996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7719), 1,
      anon_sym_RPAREN,
  [124003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7721), 1,
      anon_sym_RPAREN,
  [124010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7723), 1,
      sym_identifier,
  [124017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7725), 1,
      anon_sym_RPAREN,
  [124024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7727), 1,
      sym_identifier,
  [124031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      sym_identifier,
  [124038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7731), 1,
      anon_sym_new,
  [124045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_RBRACK,
  [124052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7735), 1,
      sym_number,
  [124059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7737), 1,
      anon_sym_RBRACK,
  [124066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7739), 1,
      anon_sym_EQ_GT,
  [124073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7741), 1,
      anon_sym_RBRACK,
  [124080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7743), 1,
      anon_sym_EQ_GT,
  [124087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_RBRACK,
  [124094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_EQ_GT,
  [124101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_EQ_GT,
  [124108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      anon_sym_RBRACK,
  [124115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7753), 1,
      anon_sym_RBRACK,
  [124122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7145), 1,
      sym_identifier,
  [124129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7755), 1,
      anon_sym_readonly,
  [124136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_RBRACK,
  [124143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7759), 1,
      anon_sym_class,
  [124150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7761), 1,
      anon_sym_RBRACK,
  [124157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 1,
      anon_sym_RBRACK,
  [124164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7765), 1,
      anon_sym_RBRACK,
  [124171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7767), 1,
      anon_sym_RBRACK,
  [124178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7769), 1,
      anon_sym_EQ,
  [124185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7771), 1,
      anon_sym_RBRACK,
  [124192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7773), 1,
      anon_sym_EQ,
  [124199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7775), 1,
      anon_sym_EQ_GT,
  [124206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_RBRACK,
  [124213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7779), 1,
      anon_sym_RBRACK,
  [124220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7781), 1,
      anon_sym_GT,
  [124227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7783), 1,
      anon_sym_RBRACK,
  [124234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7785), 1,
      anon_sym_RBRACK,
  [124241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7787), 1,
      anon_sym_RBRACK,
  [124248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7789), 1,
      anon_sym_RBRACK,
  [124255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7791), 1,
      anon_sym_RBRACK,
  [124262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7793), 1,
      anon_sym_new,
  [124269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7795), 1,
      anon_sym_RBRACK,
  [124276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7797), 1,
      anon_sym_RBRACK,
  [124283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7799), 1,
      anon_sym_RBRACK,
  [124290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7801), 1,
      anon_sym_RBRACK,
  [124297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7803), 1,
      anon_sym_RBRACK,
  [124304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7805), 1,
      anon_sym_RBRACK,
  [124311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7807), 1,
      anon_sym_EQ_GT,
  [124318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7809), 1,
      anon_sym_COLON,
  [124325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7811), 1,
      anon_sym_GT,
  [124332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7813), 1,
      anon_sym_RBRACK,
  [124339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7815), 1,
      anon_sym_RBRACK,
  [124346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7817), 1,
      anon_sym_RBRACK,
  [124353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7819), 1,
      anon_sym_EQ_GT,
  [124360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7821), 1,
      anon_sym_RBRACK,
  [124367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7823), 1,
      sym_identifier,
  [124374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7825), 1,
      anon_sym_EQ_GT,
  [124381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6875), 1,
      anon_sym_RBRACK,
  [124388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7827), 1,
      anon_sym_EQ_GT,
  [124395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7829), 1,
      sym_identifier,
  [124402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7831), 1,
      sym_number,
  [124409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7833), 1,
      sym_identifier,
  [124416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7835), 1,
      anon_sym_SLASH2,
  [124423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7837), 1,
      anon_sym_RBRACK,
  [124430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7839), 1,
      anon_sym_RBRACK,
  [124437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7841), 1,
      anon_sym_RBRACK,
  [124444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7843), 1,
      anon_sym_RPAREN,
  [124451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7845), 1,
      anon_sym_RBRACK,
  [124458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_RBRACK,
  [124465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7849), 1,
      anon_sym_RBRACK,
  [124472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7851), 1,
      anon_sym_RBRACK,
  [124479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7853), 1,
      anon_sym_RBRACK,
  [124486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7855), 1,
      anon_sym_RBRACK,
  [124493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7857), 1,
      anon_sym_RBRACK,
  [124500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7859), 1,
      anon_sym_EQ_GT,
  [124507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7861), 1,
      anon_sym_RBRACK,
  [124514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7863), 1,
      anon_sym_RBRACK,
  [124521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7865), 1,
      anon_sym_COLON,
  [124528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_RBRACK,
  [124535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_RBRACK,
  [124542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_RBRACK,
  [124549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 1,
      anon_sym_RBRACK,
  [124556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7875), 1,
      anon_sym_RBRACK,
  [124563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7877), 1,
      anon_sym_as,
  [124570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7879), 1,
      anon_sym_RBRACK,
  [124577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7881), 1,
      anon_sym_from,
  [124584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6935), 1,
      anon_sym_RBRACE,
  [124591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7883), 1,
      anon_sym_RBRACK,
  [124598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_RBRACK,
  [124605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7887), 1,
      anon_sym_EQ_GT,
  [124612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym_EQ_GT,
  [124619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_GT,
  [124626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 1,
      sym_identifier,
  [124633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7895), 1,
      anon_sym_GT,
  [124640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7005), 1,
      anon_sym_GT,
  [124647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7897), 1,
      anon_sym_EQ_GT,
  [124654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7899), 1,
      sym_identifier,
  [124661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7901), 1,
      anon_sym_EQ_GT,
  [124668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7029), 1,
      anon_sym_RBRACK,
  [124675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7903), 1,
      anon_sym_GT,
  [124682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7905), 1,
      anon_sym_GT,
  [124689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7907), 1,
      anon_sym_GT,
  [124696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7909), 1,
      anon_sym_GT,
  [124703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 1,
      anon_sym_GT,
  [124710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7913), 1,
      anon_sym_RBRACK,
  [124717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7915), 1,
      anon_sym_EQ,
  [124724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7917), 1,
      anon_sym_EQ_GT,
  [124731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7919), 1,
      sym_identifier,
  [124738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7921), 1,
      sym_number,
  [124745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7923), 1,
      anon_sym_GT,
  [124752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7925), 1,
      anon_sym_RPAREN,
  [124759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7927), 1,
      sym_identifier,
  [124766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7929), 1,
      anon_sym_EQ,
  [124773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7931), 1,
      sym_identifier,
  [124780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7933), 1,
      sym_identifier,
  [124787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7935), 1,
      anon_sym_SLASH2,
  [124794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 1,
      anon_sym_RPAREN,
  [124801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7937), 1,
      sym_identifier,
  [124808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7939), 1,
      anon_sym_RBRACK,
  [124815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7941), 1,
      anon_sym_EQ,
  [124822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7943), 1,
      anon_sym_RBRACK,
  [124829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7945), 1,
      anon_sym_RBRACK,
  [124836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7947), 1,
      anon_sym_RBRACK,
  [124843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7157), 1,
      anon_sym_RBRACE,
  [124850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7949), 1,
      anon_sym_RBRACK,
  [124857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7951), 1,
      anon_sym_EQ_GT,
  [124864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7953), 1,
      sym_identifier,
  [124871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7955), 1,
      anon_sym_EQ,
  [124878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7957), 1,
      anon_sym_RBRACK,
  [124885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7959), 1,
      anon_sym_RBRACK,
  [124892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      anon_sym_RBRACK,
  [124899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7963), 1,
      anon_sym_RBRACK,
  [124906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7965), 1,
      anon_sym_RBRACK,
  [124913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7967), 1,
      anon_sym_EQ_GT,
  [124920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7969), 1,
      anon_sym_EQ_GT,
  [124927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7971), 1,
      anon_sym_EQ_GT,
  [124934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7973), 1,
      anon_sym_class,
  [124941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7975), 1,
      anon_sym_EQ_GT,
  [124948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7977), 1,
      anon_sym_RBRACK,
  [124955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7979), 1,
      anon_sym_RBRACK,
  [124962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7981), 1,
      anon_sym_EQ_GT,
  [124969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7983), 1,
      anon_sym_RBRACK,
  [124976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7985), 1,
      anon_sym_RBRACK,
  [124983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7987), 1,
      anon_sym_RBRACK,
  [124990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7989), 1,
      anon_sym_RBRACK,
  [124997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7991), 1,
      anon_sym_RBRACK,
  [125004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7993), 1,
      sym_identifier,
  [125011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7995), 1,
      anon_sym_RBRACK,
  [125018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7105), 1,
      sym_identifier,
  [125025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      anon_sym_RBRACK,
  [125032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7999), 1,
      anon_sym_EQ_GT,
  [125039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8001), 1,
      anon_sym_EQ_GT,
  [125046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8003), 1,
      anon_sym_target,
  [125053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8005), 1,
      anon_sym_GT,
  [125060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8007), 1,
      anon_sym_GT,
  [125067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_is,
  [125074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8009), 1,
      anon_sym_EQ_GT,
  [125081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 1,
      anon_sym_EQ_GT,
  [125088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5124), 1,
      anon_sym_EQ_GT,
  [125095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6848), 1,
      anon_sym_LBRACE,
  [125102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7310), 1,
      anon_sym_GT,
  [125109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_EQ_GT,
  [125116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8013), 1,
      sym_identifier,
  [125123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8015), 1,
      anon_sym_SLASH2,
  [125130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8017), 1,
      anon_sym_EQ_GT,
  [125137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7298), 1,
      anon_sym_RBRACK,
  [125144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8019), 1,
      anon_sym_GT,
  [125151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8021), 1,
      anon_sym_GT,
  [125158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8023), 1,
      anon_sym_GT,
  [125165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8025), 1,
      anon_sym_GT,
  [125172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8027), 1,
      anon_sym_GT,
  [125179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8029), 1,
      anon_sym_GT,
  [125186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8031), 1,
      anon_sym_RBRACK,
  [125193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      sym_identifier,
  [125200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8035), 1,
      sym_number,
  [125207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8037), 1,
      anon_sym_GT,
  [125214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8039), 1,
      anon_sym_RPAREN,
  [125221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8041), 1,
      anon_sym_SLASH2,
  [125228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3932), 1,
      anon_sym_RPAREN,
  [125235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8043), 1,
      anon_sym_RBRACK,
  [125242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8045), 1,
      anon_sym_while,
  [125249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8047), 1,
      anon_sym_RBRACK,
  [125256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4527), 1,
      anon_sym_RPAREN,
  [125263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4065), 1,
      anon_sym_RPAREN,
  [125270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8049), 1,
      anon_sym_RBRACK,
  [125277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8051), 1,
      anon_sym_RBRACK,
  [125284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8053), 1,
      anon_sym_RBRACK,
  [125291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8055), 1,
      anon_sym_RBRACK,
  [125298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 1,
      sym_identifier,
  [125305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8059), 1,
      anon_sym_RBRACK,
  [125312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8061), 1,
      anon_sym_EQ,
  [125319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8063), 1,
      anon_sym_RBRACK,
  [125326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8065), 1,
      anon_sym_RBRACK,
  [125333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8067), 1,
      anon_sym_RBRACK,
  [125340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 1,
      anon_sym_from,
  [125347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8069), 1,
      anon_sym_EQ_GT,
  [125354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8071), 1,
      anon_sym_RBRACK,
  [125361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8073), 1,
      anon_sym_EQ_GT,
  [125368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8075), 1,
      anon_sym_as,
  [125375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8077), 1,
      anon_sym_EQ,
  [125382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8079), 1,
      anon_sym_RBRACK,
  [125389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8081), 1,
      anon_sym_GT,
  [125396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8083), 1,
      anon_sym_RBRACK,
  [125403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8085), 1,
      anon_sym_EQ_GT,
  [125410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8087), 1,
      anon_sym_RBRACK,
  [125417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8089), 1,
      anon_sym_EQ_GT,
  [125424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8091), 1,
      anon_sym_EQ_GT,
  [125431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 1,
      anon_sym_RBRACK,
  [125438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_RBRACK,
  [125445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8097), 1,
      anon_sym_RBRACK,
  [125452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8099), 1,
      anon_sym_EQ,
  [125459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8101), 1,
      anon_sym_RBRACK,
  [125466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8103), 1,
      anon_sym_new,
  [125473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8105), 1,
      anon_sym_RBRACK,
  [125480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8107), 1,
      anon_sym_EQ_GT,
  [125487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8109), 1,
      anon_sym_EQ_GT,
  [125494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8111), 1,
      anon_sym_GT,
  [125501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8113), 1,
      anon_sym_GT,
  [125508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_is,
  [125515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6950), 1,
      anon_sym_GT,
  [125522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4436), 1,
      anon_sym_RBRACK,
  [125529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8115), 1,
      anon_sym_function,
  [125536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8117), 1,
      sym_identifier,
  [125543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      sym_identifier,
  [125550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_EQ_GT,
  [125557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8123), 1,
      anon_sym_namespace,
  [125564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8125), 1,
      anon_sym_EQ,
  [125571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      sym_identifier,
  [125578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8129), 1,
      anon_sym_EQ_GT,
  [125585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 1,
      anon_sym_RBRACK,
  [125592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_new,
  [125599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8133), 1,
      anon_sym_GT,
  [125606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_GT,
  [125613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8137), 1,
      anon_sym_GT,
  [125620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8139), 1,
      anon_sym_GT,
  [125627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym_new,
  [125634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_GT,
  [125641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8145), 1,
      anon_sym_SLASH2,
  [125648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_EQ,
  [125655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_EQ_GT,
  [125662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_RBRACE,
  [125669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8149), 1,
      sym_identifier,
  [125676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8151), 1,
      anon_sym_function,
  [125683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8153), 1,
      ts_builtin_sym_end,
  [125690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8155), 1,
      sym_identifier,
  [125697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8157), 1,
      sym_identifier,
  [125704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8159), 1,
      sym_identifier,
  [125711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8161), 1,
      anon_sym_new,
  [125718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8163), 1,
      sym_identifier,
  [125725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8165), 1,
      sym_identifier,
  [125732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8167), 1,
      anon_sym_class,
  [125739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3229), 1,
      anon_sym_LPAREN,
  [125746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4589), 1,
      anon_sym_RBRACK,
  [125753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8169), 1,
      sym_identifier,
  [125760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8171), 1,
      anon_sym_EQ_GT,
  [125767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8173), 1,
      sym_identifier,
  [125774] = 2,
    ACTIONS(5567), 1,
      sym_comment,
    ACTIONS(8175), 1,
      sym_regex_pattern,
  [125781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8177), 1,
      sym_number,
  [125788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8179), 1,
      anon_sym_GT,
  [125795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8181), 1,
      anon_sym_RPAREN,
  [125802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      sym_identifier,
  [125809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8185), 1,
      anon_sym_EQ_GT,
  [125816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_EQ,
  [125823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_RPAREN,
  [125830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8187), 1,
      anon_sym_target,
  [125837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8189), 1,
      anon_sym_EQ_GT,
  [125844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8191), 1,
      anon_sym_EQ_GT,
  [125851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8193), 1,
      anon_sym_EQ_GT,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(999)] = 0,
  [SMALL_STATE(1000)] = 89,
  [SMALL_STATE(1001)] = 182,
  [SMALL_STATE(1002)] = 271,
  [SMALL_STATE(1003)] = 362,
  [SMALL_STATE(1004)] = 453,
  [SMALL_STATE(1005)] = 544,
  [SMALL_STATE(1006)] = 635,
  [SMALL_STATE(1007)] = 728,
  [SMALL_STATE(1008)] = 817,
  [SMALL_STATE(1009)] = 908,
  [SMALL_STATE(1010)] = 997,
  [SMALL_STATE(1011)] = 1088,
  [SMALL_STATE(1012)] = 1180,
  [SMALL_STATE(1013)] = 1268,
  [SMALL_STATE(1014)] = 1360,
  [SMALL_STATE(1015)] = 1448,
  [SMALL_STATE(1016)] = 1536,
  [SMALL_STATE(1017)] = 1628,
  [SMALL_STATE(1018)] = 1722,
  [SMALL_STATE(1019)] = 1810,
  [SMALL_STATE(1020)] = 1879,
  [SMALL_STATE(1021)] = 1968,
  [SMALL_STATE(1022)] = 2055,
  [SMALL_STATE(1023)] = 2142,
  [SMALL_STATE(1024)] = 2231,
  [SMALL_STATE(1025)] = 2320,
  [SMALL_STATE(1026)] = 2453,
  [SMALL_STATE(1027)] = 2540,
  [SMALL_STATE(1028)] = 2673,
  [SMALL_STATE(1029)] = 2742,
  [SMALL_STATE(1030)] = 2829,
  [SMALL_STATE(1031)] = 2898,
  [SMALL_STATE(1032)] = 2967,
  [SMALL_STATE(1033)] = 3056,
  [SMALL_STATE(1034)] = 3143,
  [SMALL_STATE(1035)] = 3232,
  [SMALL_STATE(1036)] = 3321,
  [SMALL_STATE(1037)] = 3390,
  [SMALL_STATE(1038)] = 3459,
  [SMALL_STATE(1039)] = 3546,
  [SMALL_STATE(1040)] = 3615,
  [SMALL_STATE(1041)] = 3704,
  [SMALL_STATE(1042)] = 3793,
  [SMALL_STATE(1043)] = 3884,
  [SMALL_STATE(1044)] = 3952,
  [SMALL_STATE(1045)] = 4024,
  [SMALL_STATE(1046)] = 4110,
  [SMALL_STATE(1047)] = 4200,
  [SMALL_STATE(1048)] = 4286,
  [SMALL_STATE(1049)] = 4372,
  [SMALL_STATE(1050)] = 4460,
  [SMALL_STATE(1051)] = 4546,
  [SMALL_STATE(1052)] = 4640,
  [SMALL_STATE(1053)] = 4726,
  [SMALL_STATE(1054)] = 4794,
  [SMALL_STATE(1055)] = 4882,
  [SMALL_STATE(1056)] = 4959,
  [SMALL_STATE(1057)] = 5036,
  [SMALL_STATE(1058)] = 5127,
  [SMALL_STATE(1059)] = 5212,
  [SMALL_STATE(1060)] = 5297,
  [SMALL_STATE(1061)] = 5382,
  [SMALL_STATE(1062)] = 5467,
  [SMALL_STATE(1063)] = 5544,
  [SMALL_STATE(1064)] = 5629,
  [SMALL_STATE(1065)] = 5708,
  [SMALL_STATE(1066)] = 5793,
  [SMALL_STATE(1067)] = 5870,
  [SMALL_STATE(1068)] = 5955,
  [SMALL_STATE(1069)] = 6032,
  [SMALL_STATE(1070)] = 6109,
  [SMALL_STATE(1071)] = 6200,
  [SMALL_STATE(1072)] = 6285,
  [SMALL_STATE(1073)] = 6364,
  [SMALL_STATE(1074)] = 6442,
  [SMALL_STATE(1075)] = 6514,
  [SMALL_STATE(1076)] = 6586,
  [SMALL_STATE(1077)] = 6662,
  [SMALL_STATE(1078)] = 6746,
  [SMALL_STATE(1079)] = 6820,
  [SMALL_STATE(1080)] = 6906,
  [SMALL_STATE(1081)] = 6988,
  [SMALL_STATE(1082)] = 7072,
  [SMALL_STATE(1083)] = 7156,
  [SMALL_STATE(1084)] = 7230,
  [SMALL_STATE(1085)] = 7304,
  [SMALL_STATE(1086)] = 7388,
  [SMALL_STATE(1087)] = 7470,
  [SMALL_STATE(1088)] = 7548,
  [SMALL_STATE(1089)] = 7620,
  [SMALL_STATE(1090)] = 7708,
  [SMALL_STATE(1091)] = 7780,
  [SMALL_STATE(1092)] = 7856,
  [SMALL_STATE(1093)] = 7940,
  [SMALL_STATE(1094)] = 8016,
  [SMALL_STATE(1095)] = 8094,
  [SMALL_STATE(1096)] = 8159,
  [SMALL_STATE(1097)] = 8232,
  [SMALL_STATE(1098)] = 8307,
  [SMALL_STATE(1099)] = 8378,
  [SMALL_STATE(1100)] = 8451,
  [SMALL_STATE(1101)] = 8522,
  [SMALL_STATE(1102)] = 8591,
  [SMALL_STATE(1103)] = 8660,
  [SMALL_STATE(1104)] = 8743,
  [SMALL_STATE(1105)] = 8826,
  [SMALL_STATE(1106)] = 8903,
  [SMALL_STATE(1107)] = 8978,
  [SMALL_STATE(1108)] = 9057,
  [SMALL_STATE(1109)] = 9136,
  [SMALL_STATE(1110)] = 9207,
  [SMALL_STATE(1111)] = 9272,
  [SMALL_STATE(1112)] = 9345,
  [SMALL_STATE(1113)] = 9426,
  [SMALL_STATE(1114)] = 9491,
  [SMALL_STATE(1115)] = 9556,
  [SMALL_STATE(1116)] = 9633,
  [SMALL_STATE(1117)] = 9704,
  [SMALL_STATE(1118)] = 9769,
  [SMALL_STATE(1119)] = 9834,
  [SMALL_STATE(1120)] = 9905,
  [SMALL_STATE(1121)] = 9978,
  [SMALL_STATE(1122)] = 10043,
  [SMALL_STATE(1123)] = 10114,
  [SMALL_STATE(1124)] = 10187,
  [SMALL_STATE(1125)] = 10252,
  [SMALL_STATE(1126)] = 10323,
  [SMALL_STATE(1127)] = 10388,
  [SMALL_STATE(1128)] = 10463,
  [SMALL_STATE(1129)] = 10536,
  [SMALL_STATE(1130)] = 10619,
  [SMALL_STATE(1131)] = 10702,
  [SMALL_STATE(1132)] = 10773,
  [SMALL_STATE(1133)] = 10843,
  [SMALL_STATE(1134)] = 10913,
  [SMALL_STATE(1135)] = 10991,
  [SMALL_STATE(1136)] = 11067,
  [SMALL_STATE(1137)] = 11137,
  [SMALL_STATE(1138)] = 11219,
  [SMALL_STATE(1139)] = 11295,
  [SMALL_STATE(1140)] = 11363,
  [SMALL_STATE(1141)] = 11433,
  [SMALL_STATE(1142)] = 11515,
  [SMALL_STATE(1143)] = 11585,
  [SMALL_STATE(1144)] = 11655,
  [SMALL_STATE(1145)] = 11725,
  [SMALL_STATE(1146)] = 11797,
  [SMALL_STATE(1147)] = 11867,
  [SMALL_STATE(1148)] = 11937,
  [SMALL_STATE(1149)] = 12013,
  [SMALL_STATE(1150)] = 12085,
  [SMALL_STATE(1151)] = 12157,
  [SMALL_STATE(1152)] = 12227,
  [SMALL_STATE(1153)] = 12295,
  [SMALL_STATE(1154)] = 12377,
  [SMALL_STATE(1155)] = 12449,
  [SMALL_STATE(1156)] = 12521,
  [SMALL_STATE(1157)] = 12594,
  [SMALL_STATE(1158)] = 12667,
  [SMALL_STATE(1159)] = 12738,
  [SMALL_STATE(1160)] = 12807,
  [SMALL_STATE(1161)] = 12880,
  [SMALL_STATE(1162)] = 12953,
  [SMALL_STATE(1163)] = 13022,
  [SMALL_STATE(1164)] = 13093,
  [SMALL_STATE(1165)] = 13162,
  [SMALL_STATE(1166)] = 13229,
  [SMALL_STATE(1167)] = 13304,
  [SMALL_STATE(1168)] = 13371,
  [SMALL_STATE(1169)] = 13434,
  [SMALL_STATE(1170)] = 13505,
  [SMALL_STATE(1171)] = 13574,
  [SMALL_STATE(1172)] = 13636,
  [SMALL_STATE(1173)] = 13708,
  [SMALL_STATE(1174)] = 13778,
  [SMALL_STATE(1175)] = 13846,
  [SMALL_STATE(1176)] = 13918,
  [SMALL_STATE(1177)] = 13984,
  [SMALL_STATE(1178)] = 14052,
  [SMALL_STATE(1179)] = 14120,
  [SMALL_STATE(1180)] = 14182,
  [SMALL_STATE(1181)] = 14252,
  [SMALL_STATE(1182)] = 14320,
  [SMALL_STATE(1183)] = 14382,
  [SMALL_STATE(1184)] = 14451,
  [SMALL_STATE(1185)] = 14518,
  [SMALL_STATE(1186)] = 14583,
  [SMALL_STATE(1187)] = 14650,
  [SMALL_STATE(1188)] = 14717,
  [SMALL_STATE(1189)] = 14833,
  [SMALL_STATE(1190)] = 14949,
  [SMALL_STATE(1191)] = 15065,
  [SMALL_STATE(1192)] = 15181,
  [SMALL_STATE(1193)] = 15297,
  [SMALL_STATE(1194)] = 15413,
  [SMALL_STATE(1195)] = 15525,
  [SMALL_STATE(1196)] = 15643,
  [SMALL_STATE(1197)] = 15755,
  [SMALL_STATE(1198)] = 15873,
  [SMALL_STATE(1199)] = 15985,
  [SMALL_STATE(1200)] = 16097,
  [SMALL_STATE(1201)] = 16175,
  [SMALL_STATE(1202)] = 16287,
  [SMALL_STATE(1203)] = 16399,
  [SMALL_STATE(1204)] = 16511,
  [SMALL_STATE(1205)] = 16623,
  [SMALL_STATE(1206)] = 16735,
  [SMALL_STATE(1207)] = 16853,
  [SMALL_STATE(1208)] = 16965,
  [SMALL_STATE(1209)] = 17083,
  [SMALL_STATE(1210)] = 17195,
  [SMALL_STATE(1211)] = 17307,
  [SMALL_STATE(1212)] = 17419,
  [SMALL_STATE(1213)] = 17537,
  [SMALL_STATE(1214)] = 17649,
  [SMALL_STATE(1215)] = 17761,
  [SMALL_STATE(1216)] = 17873,
  [SMALL_STATE(1217)] = 17985,
  [SMALL_STATE(1218)] = 18097,
  [SMALL_STATE(1219)] = 18205,
  [SMALL_STATE(1220)] = 18313,
  [SMALL_STATE(1221)] = 18421,
  [SMALL_STATE(1222)] = 18529,
  [SMALL_STATE(1223)] = 18637,
  [SMALL_STATE(1224)] = 18693,
  [SMALL_STATE(1225)] = 18801,
  [SMALL_STATE(1226)] = 18909,
  [SMALL_STATE(1227)] = 18965,
  [SMALL_STATE(1228)] = 19075,
  [SMALL_STATE(1229)] = 19183,
  [SMALL_STATE(1230)] = 19254,
  [SMALL_STATE(1231)] = 19317,
  [SMALL_STATE(1232)] = 19415,
  [SMALL_STATE(1233)] = 19475,
  [SMALL_STATE(1234)] = 19573,
  [SMALL_STATE(1235)] = 19633,
  [SMALL_STATE(1236)] = 19689,
  [SMALL_STATE(1237)] = 19745,
  [SMALL_STATE(1238)] = 19843,
  [SMALL_STATE(1239)] = 19897,
  [SMALL_STATE(1240)] = 19955,
  [SMALL_STATE(1241)] = 20053,
  [SMALL_STATE(1242)] = 20111,
  [SMALL_STATE(1243)] = 20209,
  [SMALL_STATE(1244)] = 20263,
  [SMALL_STATE(1245)] = 20321,
  [SMALL_STATE(1246)] = 20419,
  [SMALL_STATE(1247)] = 20517,
  [SMALL_STATE(1248)] = 20577,
  [SMALL_STATE(1249)] = 20631,
  [SMALL_STATE(1250)] = 20691,
  [SMALL_STATE(1251)] = 20751,
  [SMALL_STATE(1252)] = 20804,
  [SMALL_STATE(1253)] = 20915,
  [SMALL_STATE(1254)] = 20970,
  [SMALL_STATE(1255)] = 21027,
  [SMALL_STATE(1256)] = 21088,
  [SMALL_STATE(1257)] = 21145,
  [SMALL_STATE(1258)] = 21206,
  [SMALL_STATE(1259)] = 21263,
  [SMALL_STATE(1260)] = 21316,
  [SMALL_STATE(1261)] = 21369,
  [SMALL_STATE(1262)] = 21424,
  [SMALL_STATE(1263)] = 21535,
  [SMALL_STATE(1264)] = 21588,
  [SMALL_STATE(1265)] = 21641,
  [SMALL_STATE(1266)] = 21694,
  [SMALL_STATE(1267)] = 21747,
  [SMALL_STATE(1268)] = 21802,
  [SMALL_STATE(1269)] = 21913,
  [SMALL_STATE(1270)] = 21984,
  [SMALL_STATE(1271)] = 22037,
  [SMALL_STATE(1272)] = 22090,
  [SMALL_STATE(1273)] = 22143,
  [SMALL_STATE(1274)] = 22198,
  [SMALL_STATE(1275)] = 22251,
  [SMALL_STATE(1276)] = 22304,
  [SMALL_STATE(1277)] = 22357,
  [SMALL_STATE(1278)] = 22410,
  [SMALL_STATE(1279)] = 22463,
  [SMALL_STATE(1280)] = 22518,
  [SMALL_STATE(1281)] = 22571,
  [SMALL_STATE(1282)] = 22682,
  [SMALL_STATE(1283)] = 22735,
  [SMALL_STATE(1284)] = 22788,
  [SMALL_STATE(1285)] = 22867,
  [SMALL_STATE(1286)] = 22920,
  [SMALL_STATE(1287)] = 23031,
  [SMALL_STATE(1288)] = 23084,
  [SMALL_STATE(1289)] = 23195,
  [SMALL_STATE(1290)] = 23306,
  [SMALL_STATE(1291)] = 23359,
  [SMALL_STATE(1292)] = 23412,
  [SMALL_STATE(1293)] = 23465,
  [SMALL_STATE(1294)] = 23518,
  [SMALL_STATE(1295)] = 23571,
  [SMALL_STATE(1296)] = 23624,
  [SMALL_STATE(1297)] = 23735,
  [SMALL_STATE(1298)] = 23788,
  [SMALL_STATE(1299)] = 23841,
  [SMALL_STATE(1300)] = 23894,
  [SMALL_STATE(1301)] = 23947,
  [SMALL_STATE(1302)] = 24000,
  [SMALL_STATE(1303)] = 24053,
  [SMALL_STATE(1304)] = 24106,
  [SMALL_STATE(1305)] = 24159,
  [SMALL_STATE(1306)] = 24212,
  [SMALL_STATE(1307)] = 24323,
  [SMALL_STATE(1308)] = 24382,
  [SMALL_STATE(1309)] = 24441,
  [SMALL_STATE(1310)] = 24494,
  [SMALL_STATE(1311)] = 24553,
  [SMALL_STATE(1312)] = 24606,
  [SMALL_STATE(1313)] = 24659,
  [SMALL_STATE(1314)] = 24712,
  [SMALL_STATE(1315)] = 24823,
  [SMALL_STATE(1316)] = 24934,
  [SMALL_STATE(1317)] = 24987,
  [SMALL_STATE(1318)] = 25040,
  [SMALL_STATE(1319)] = 25093,
  [SMALL_STATE(1320)] = 25148,
  [SMALL_STATE(1321)] = 25201,
  [SMALL_STATE(1322)] = 25274,
  [SMALL_STATE(1323)] = 25349,
  [SMALL_STATE(1324)] = 25402,
  [SMALL_STATE(1325)] = 25455,
  [SMALL_STATE(1326)] = 25508,
  [SMALL_STATE(1327)] = 25561,
  [SMALL_STATE(1328)] = 25614,
  [SMALL_STATE(1329)] = 25667,
  [SMALL_STATE(1330)] = 25720,
  [SMALL_STATE(1331)] = 25773,
  [SMALL_STATE(1332)] = 25830,
  [SMALL_STATE(1333)] = 25883,
  [SMALL_STATE(1334)] = 25942,
  [SMALL_STATE(1335)] = 25995,
  [SMALL_STATE(1336)] = 26048,
  [SMALL_STATE(1337)] = 26101,
  [SMALL_STATE(1338)] = 26154,
  [SMALL_STATE(1339)] = 26207,
  [SMALL_STATE(1340)] = 26262,
  [SMALL_STATE(1341)] = 26319,
  [SMALL_STATE(1342)] = 26372,
  [SMALL_STATE(1343)] = 26425,
  [SMALL_STATE(1344)] = 26478,
  [SMALL_STATE(1345)] = 26531,
  [SMALL_STATE(1346)] = 26584,
  [SMALL_STATE(1347)] = 26643,
  [SMALL_STATE(1348)] = 26702,
  [SMALL_STATE(1349)] = 26755,
  [SMALL_STATE(1350)] = 26814,
  [SMALL_STATE(1351)] = 26869,
  [SMALL_STATE(1352)] = 26922,
  [SMALL_STATE(1353)] = 26981,
  [SMALL_STATE(1354)] = 27084,
  [SMALL_STATE(1355)] = 27137,
  [SMALL_STATE(1356)] = 27190,
  [SMALL_STATE(1357)] = 27243,
  [SMALL_STATE(1358)] = 27332,
  [SMALL_STATE(1359)] = 27413,
  [SMALL_STATE(1360)] = 27466,
  [SMALL_STATE(1361)] = 27545,
  [SMALL_STATE(1362)] = 27598,
  [SMALL_STATE(1363)] = 27653,
  [SMALL_STATE(1364)] = 27748,
  [SMALL_STATE(1365)] = 27801,
  [SMALL_STATE(1366)] = 27854,
  [SMALL_STATE(1367)] = 27947,
  [SMALL_STATE(1368)] = 28000,
  [SMALL_STATE(1369)] = 28081,
  [SMALL_STATE(1370)] = 28142,
  [SMALL_STATE(1371)] = 28243,
  [SMALL_STATE(1372)] = 28342,
  [SMALL_STATE(1373)] = 28395,
  [SMALL_STATE(1374)] = 28480,
  [SMALL_STATE(1375)] = 28533,
  [SMALL_STATE(1376)] = 28646,
  [SMALL_STATE(1377)] = 28705,
  [SMALL_STATE(1378)] = 28802,
  [SMALL_STATE(1379)] = 28913,
  [SMALL_STATE(1380)] = 28966,
  [SMALL_STATE(1381)] = 29018,
  [SMALL_STATE(1382)] = 29070,
  [SMALL_STATE(1383)] = 29168,
  [SMALL_STATE(1384)] = 29220,
  [SMALL_STATE(1385)] = 29272,
  [SMALL_STATE(1386)] = 29324,
  [SMALL_STATE(1387)] = 29398,
  [SMALL_STATE(1388)] = 29482,
  [SMALL_STATE(1389)] = 29534,
  [SMALL_STATE(1390)] = 29644,
  [SMALL_STATE(1391)] = 29696,
  [SMALL_STATE(1392)] = 29776,
  [SMALL_STATE(1393)] = 29874,
  [SMALL_STATE(1394)] = 29974,
  [SMALL_STATE(1395)] = 30054,
  [SMALL_STATE(1396)] = 30126,
  [SMALL_STATE(1397)] = 30178,
  [SMALL_STATE(1398)] = 30270,
  [SMALL_STATE(1399)] = 30322,
  [SMALL_STATE(1400)] = 30416,
  [SMALL_STATE(1401)] = 30508,
  [SMALL_STATE(1402)] = 30618,
  [SMALL_STATE(1403)] = 30734,
  [SMALL_STATE(1404)] = 30830,
  [SMALL_STATE(1405)] = 30940,
  [SMALL_STATE(1406)] = 31018,
  [SMALL_STATE(1407)] = 31076,
  [SMALL_STATE(1408)] = 31160,
  [SMALL_STATE(1409)] = 31240,
  [SMALL_STATE(1410)] = 31314,
  [SMALL_STATE(1411)] = 31372,
  [SMALL_STATE(1412)] = 31460,
  [SMALL_STATE(1413)] = 31570,
  [SMALL_STATE(1414)] = 31680,
  [SMALL_STATE(1415)] = 31732,
  [SMALL_STATE(1416)] = 31834,
  [SMALL_STATE(1417)] = 31944,
  [SMALL_STATE(1418)] = 31996,
  [SMALL_STATE(1419)] = 32048,
  [SMALL_STATE(1420)] = 32142,
  [SMALL_STATE(1421)] = 32238,
  [SMALL_STATE(1422)] = 32316,
  [SMALL_STATE(1423)] = 32396,
  [SMALL_STATE(1424)] = 32484,
  [SMALL_STATE(1425)] = 32536,
  [SMALL_STATE(1426)] = 32588,
  [SMALL_STATE(1427)] = 32690,
  [SMALL_STATE(1428)] = 32800,
  [SMALL_STATE(1429)] = 32852,
  [SMALL_STATE(1430)] = 32962,
  [SMALL_STATE(1431)] = 33072,
  [SMALL_STATE(1432)] = 33124,
  [SMALL_STATE(1433)] = 33176,
  [SMALL_STATE(1434)] = 33228,
  [SMALL_STATE(1435)] = 33338,
  [SMALL_STATE(1436)] = 33448,
  [SMALL_STATE(1437)] = 33500,
  [SMALL_STATE(1438)] = 33552,
  [SMALL_STATE(1439)] = 33662,
  [SMALL_STATE(1440)] = 33714,
  [SMALL_STATE(1441)] = 33824,
  [SMALL_STATE(1442)] = 33934,
  [SMALL_STATE(1443)] = 33986,
  [SMALL_STATE(1444)] = 34096,
  [SMALL_STATE(1445)] = 34206,
  [SMALL_STATE(1446)] = 34306,
  [SMALL_STATE(1447)] = 34358,
  [SMALL_STATE(1448)] = 34410,
  [SMALL_STATE(1449)] = 34462,
  [SMALL_STATE(1450)] = 34514,
  [SMALL_STATE(1451)] = 34630,
  [SMALL_STATE(1452)] = 34682,
  [SMALL_STATE(1453)] = 34734,
  [SMALL_STATE(1454)] = 34786,
  [SMALL_STATE(1455)] = 34838,
  [SMALL_STATE(1456)] = 34890,
  [SMALL_STATE(1457)] = 34942,
  [SMALL_STATE(1458)] = 34994,
  [SMALL_STATE(1459)] = 35046,
  [SMALL_STATE(1460)] = 35098,
  [SMALL_STATE(1461)] = 35150,
  [SMALL_STATE(1462)] = 35202,
  [SMALL_STATE(1463)] = 35254,
  [SMALL_STATE(1464)] = 35306,
  [SMALL_STATE(1465)] = 35358,
  [SMALL_STATE(1466)] = 35410,
  [SMALL_STATE(1467)] = 35524,
  [SMALL_STATE(1468)] = 35576,
  [SMALL_STATE(1469)] = 35628,
  [SMALL_STATE(1470)] = 35680,
  [SMALL_STATE(1471)] = 35732,
  [SMALL_STATE(1472)] = 35784,
  [SMALL_STATE(1473)] = 35898,
  [SMALL_STATE(1474)] = 35950,
  [SMALL_STATE(1475)] = 36002,
  [SMALL_STATE(1476)] = 36116,
  [SMALL_STATE(1477)] = 36226,
  [SMALL_STATE(1478)] = 36278,
  [SMALL_STATE(1479)] = 36330,
  [SMALL_STATE(1480)] = 36444,
  [SMALL_STATE(1481)] = 36534,
  [SMALL_STATE(1482)] = 36644,
  [SMALL_STATE(1483)] = 36696,
  [SMALL_STATE(1484)] = 36812,
  [SMALL_STATE(1485)] = 36864,
  [SMALL_STATE(1486)] = 36980,
  [SMALL_STATE(1487)] = 37034,
  [SMALL_STATE(1488)] = 37086,
  [SMALL_STATE(1489)] = 37158,
  [SMALL_STATE(1490)] = 37216,
  [SMALL_STATE(1491)] = 37268,
  [SMALL_STATE(1492)] = 37346,
  [SMALL_STATE(1493)] = 37460,
  [SMALL_STATE(1494)] = 37538,
  [SMALL_STATE(1495)] = 37590,
  [SMALL_STATE(1496)] = 37644,
  [SMALL_STATE(1497)] = 37696,
  [SMALL_STATE(1498)] = 37808,
  [SMALL_STATE(1499)] = 37860,
  [SMALL_STATE(1500)] = 37912,
  [SMALL_STATE(1501)] = 37964,
  [SMALL_STATE(1502)] = 38074,
  [SMALL_STATE(1503)] = 38130,
  [SMALL_STATE(1504)] = 38240,
  [SMALL_STATE(1505)] = 38292,
  [SMALL_STATE(1506)] = 38344,
  [SMALL_STATE(1507)] = 38412,
  [SMALL_STATE(1508)] = 38472,
  [SMALL_STATE(1509)] = 38542,
  [SMALL_STATE(1510)] = 38652,
  [SMALL_STATE(1511)] = 38704,
  [SMALL_STATE(1512)] = 38756,
  [SMALL_STATE(1513)] = 38812,
  [SMALL_STATE(1514)] = 38864,
  [SMALL_STATE(1515)] = 38974,
  [SMALL_STATE(1516)] = 39026,
  [SMALL_STATE(1517)] = 39078,
  [SMALL_STATE(1518)] = 39130,
  [SMALL_STATE(1519)] = 39182,
  [SMALL_STATE(1520)] = 39234,
  [SMALL_STATE(1521)] = 39286,
  [SMALL_STATE(1522)] = 39342,
  [SMALL_STATE(1523)] = 39396,
  [SMALL_STATE(1524)] = 39450,
  [SMALL_STATE(1525)] = 39502,
  [SMALL_STATE(1526)] = 39572,
  [SMALL_STATE(1527)] = 39682,
  [SMALL_STATE(1528)] = 39734,
  [SMALL_STATE(1529)] = 39786,
  [SMALL_STATE(1530)] = 39838,
  [SMALL_STATE(1531)] = 39892,
  [SMALL_STATE(1532)] = 39944,
  [SMALL_STATE(1533)] = 39996,
  [SMALL_STATE(1534)] = 40108,
  [SMALL_STATE(1535)] = 40218,
  [SMALL_STATE(1536)] = 40328,
  [SMALL_STATE(1537)] = 40380,
  [SMALL_STATE(1538)] = 40473,
  [SMALL_STATE(1539)] = 40530,
  [SMALL_STATE(1540)] = 40587,
  [SMALL_STATE(1541)] = 40644,
  [SMALL_STATE(1542)] = 40753,
  [SMALL_STATE(1543)] = 40832,
  [SMALL_STATE(1544)] = 40941,
  [SMALL_STATE(1545)] = 40998,
  [SMALL_STATE(1546)] = 41085,
  [SMALL_STATE(1547)] = 41182,
  [SMALL_STATE(1548)] = 41281,
  [SMALL_STATE(1549)] = 41390,
  [SMALL_STATE(1550)] = 41503,
  [SMALL_STATE(1551)] = 41598,
  [SMALL_STATE(1552)] = 41667,
  [SMALL_STATE(1553)] = 41776,
  [SMALL_STATE(1554)] = 41885,
  [SMALL_STATE(1555)] = 41962,
  [SMALL_STATE(1556)] = 42041,
  [SMALL_STATE(1557)] = 42098,
  [SMALL_STATE(1558)] = 42151,
  [SMALL_STATE(1559)] = 42262,
  [SMALL_STATE(1560)] = 42321,
  [SMALL_STATE(1561)] = 42374,
  [SMALL_STATE(1562)] = 42469,
  [SMALL_STATE(1563)] = 42578,
  [SMALL_STATE(1564)] = 42691,
  [SMALL_STATE(1565)] = 42768,
  [SMALL_STATE(1566)] = 42839,
  [SMALL_STATE(1567)] = 42890,
  [SMALL_STATE(1568)] = 42947,
  [SMALL_STATE(1569)] = 43042,
  [SMALL_STATE(1570)] = 43155,
  [SMALL_STATE(1571)] = 43250,
  [SMALL_STATE(1572)] = 43345,
  [SMALL_STATE(1573)] = 43406,
  [SMALL_STATE(1574)] = 43501,
  [SMALL_STATE(1575)] = 43614,
  [SMALL_STATE(1576)] = 43697,
  [SMALL_STATE(1577)] = 43752,
  [SMALL_STATE(1578)] = 43825,
  [SMALL_STATE(1579)] = 43918,
  [SMALL_STATE(1580)] = 44027,
  [SMALL_STATE(1581)] = 44136,
  [SMALL_STATE(1582)] = 44247,
  [SMALL_STATE(1583)] = 44342,
  [SMALL_STATE(1584)] = 44411,
  [SMALL_STATE(1585)] = 44468,
  [SMALL_STATE(1586)] = 44577,
  [SMALL_STATE(1587)] = 44672,
  [SMALL_STATE(1588)] = 44781,
  [SMALL_STATE(1589)] = 44890,
  [SMALL_STATE(1590)] = 44999,
  [SMALL_STATE(1591)] = 45108,
  [SMALL_STATE(1592)] = 45221,
  [SMALL_STATE(1593)] = 45330,
  [SMALL_STATE(1594)] = 45439,
  [SMALL_STATE(1595)] = 45548,
  [SMALL_STATE(1596)] = 45661,
  [SMALL_STATE(1597)] = 45716,
  [SMALL_STATE(1598)] = 45789,
  [SMALL_STATE(1599)] = 45872,
  [SMALL_STATE(1600)] = 45927,
  [SMALL_STATE(1601)] = 46024,
  [SMALL_STATE(1602)] = 46123,
  [SMALL_STATE(1603)] = 46202,
  [SMALL_STATE(1604)] = 46293,
  [SMALL_STATE(1605)] = 46402,
  [SMALL_STATE(1606)] = 46503,
  [SMALL_STATE(1607)] = 46598,
  [SMALL_STATE(1608)] = 46675,
  [SMALL_STATE(1609)] = 46770,
  [SMALL_STATE(1610)] = 46881,
  [SMALL_STATE(1611)] = 46990,
  [SMALL_STATE(1612)] = 47069,
  [SMALL_STATE(1613)] = 47156,
  [SMALL_STATE(1614)] = 47269,
  [SMALL_STATE(1615)] = 47378,
  [SMALL_STATE(1616)] = 47439,
  [SMALL_STATE(1617)] = 47494,
  [SMALL_STATE(1618)] = 47589,
  [SMALL_STATE(1619)] = 47684,
  [SMALL_STATE(1620)] = 47793,
  [SMALL_STATE(1621)] = 47852,
  [SMALL_STATE(1622)] = 47965,
  [SMALL_STATE(1623)] = 48074,
  [SMALL_STATE(1624)] = 48133,
  [SMALL_STATE(1625)] = 48192,
  [SMALL_STATE(1626)] = 48287,
  [SMALL_STATE(1627)] = 48396,
  [SMALL_STATE(1628)] = 48505,
  [SMALL_STATE(1629)] = 48582,
  [SMALL_STATE(1630)] = 48653,
  [SMALL_STATE(1631)] = 48762,
  [SMALL_STATE(1632)] = 48871,
  [SMALL_STATE(1633)] = 48980,
  [SMALL_STATE(1634)] = 49039,
  [SMALL_STATE(1635)] = 49098,
  [SMALL_STATE(1636)] = 49207,
  [SMALL_STATE(1637)] = 49316,
  [SMALL_STATE(1638)] = 49429,
  [SMALL_STATE(1639)] = 49542,
  [SMALL_STATE(1640)] = 49653,
  [SMALL_STATE(1641)] = 49764,
  [SMALL_STATE(1642)] = 49855,
  [SMALL_STATE(1643)] = 49964,
  [SMALL_STATE(1644)] = 50065,
  [SMALL_STATE(1645)] = 50175,
  [SMALL_STATE(1646)] = 50225,
  [SMALL_STATE(1647)] = 50279,
  [SMALL_STATE(1648)] = 50387,
  [SMALL_STATE(1649)] = 50495,
  [SMALL_STATE(1650)] = 50551,
  [SMALL_STATE(1651)] = 50601,
  [SMALL_STATE(1652)] = 50651,
  [SMALL_STATE(1653)] = 50761,
  [SMALL_STATE(1654)] = 50823,
  [SMALL_STATE(1655)] = 50931,
  [SMALL_STATE(1656)] = 50987,
  [SMALL_STATE(1657)] = 51041,
  [SMALL_STATE(1658)] = 51097,
  [SMALL_STATE(1659)] = 51155,
  [SMALL_STATE(1660)] = 51205,
  [SMALL_STATE(1661)] = 51255,
  [SMALL_STATE(1662)] = 51311,
  [SMALL_STATE(1663)] = 51419,
  [SMALL_STATE(1664)] = 51529,
  [SMALL_STATE(1665)] = 51579,
  [SMALL_STATE(1666)] = 51631,
  [SMALL_STATE(1667)] = 51681,
  [SMALL_STATE(1668)] = 51731,
  [SMALL_STATE(1669)] = 51781,
  [SMALL_STATE(1670)] = 51831,
  [SMALL_STATE(1671)] = 51881,
  [SMALL_STATE(1672)] = 51937,
  [SMALL_STATE(1673)] = 51989,
  [SMALL_STATE(1674)] = 52041,
  [SMALL_STATE(1675)] = 52111,
  [SMALL_STATE(1676)] = 52161,
  [SMALL_STATE(1677)] = 52211,
  [SMALL_STATE(1678)] = 52261,
  [SMALL_STATE(1679)] = 52311,
  [SMALL_STATE(1680)] = 52361,
  [SMALL_STATE(1681)] = 52411,
  [SMALL_STATE(1682)] = 52461,
  [SMALL_STATE(1683)] = 52571,
  [SMALL_STATE(1684)] = 52681,
  [SMALL_STATE(1685)] = 52791,
  [SMALL_STATE(1686)] = 52901,
  [SMALL_STATE(1687)] = 53011,
  [SMALL_STATE(1688)] = 53073,
  [SMALL_STATE(1689)] = 53183,
  [SMALL_STATE(1690)] = 53293,
  [SMALL_STATE(1691)] = 53347,
  [SMALL_STATE(1692)] = 53455,
  [SMALL_STATE(1693)] = 53505,
  [SMALL_STATE(1694)] = 53587,
  [SMALL_STATE(1695)] = 53651,
  [SMALL_STATE(1696)] = 53715,
  [SMALL_STATE(1697)] = 53765,
  [SMALL_STATE(1698)] = 53817,
  [SMALL_STATE(1699)] = 53867,
  [SMALL_STATE(1700)] = 53917,
  [SMALL_STATE(1701)] = 53973,
  [SMALL_STATE(1702)] = 54029,
  [SMALL_STATE(1703)] = 54085,
  [SMALL_STATE(1704)] = 54185,
  [SMALL_STATE(1705)] = 54235,
  [SMALL_STATE(1706)] = 54285,
  [SMALL_STATE(1707)] = 54335,
  [SMALL_STATE(1708)] = 54385,
  [SMALL_STATE(1709)] = 54435,
  [SMALL_STATE(1710)] = 54511,
  [SMALL_STATE(1711)] = 54597,
  [SMALL_STATE(1712)] = 54647,
  [SMALL_STATE(1713)] = 54697,
  [SMALL_STATE(1714)] = 54747,
  [SMALL_STATE(1715)] = 54797,
  [SMALL_STATE(1716)] = 54875,
  [SMALL_STATE(1717)] = 54983,
  [SMALL_STATE(1718)] = 55059,
  [SMALL_STATE(1719)] = 55111,
  [SMALL_STATE(1720)] = 55161,
  [SMALL_STATE(1721)] = 55271,
  [SMALL_STATE(1722)] = 55321,
  [SMALL_STATE(1723)] = 55383,
  [SMALL_STATE(1724)] = 55445,
  [SMALL_STATE(1725)] = 55497,
  [SMALL_STATE(1726)] = 55547,
  [SMALL_STATE(1727)] = 55615,
  [SMALL_STATE(1728)] = 55723,
  [SMALL_STATE(1729)] = 55773,
  [SMALL_STATE(1730)] = 55823,
  [SMALL_STATE(1731)] = 55873,
  [SMALL_STATE(1732)] = 55923,
  [SMALL_STATE(1733)] = 55973,
  [SMALL_STATE(1734)] = 56023,
  [SMALL_STATE(1735)] = 56073,
  [SMALL_STATE(1736)] = 56123,
  [SMALL_STATE(1737)] = 56173,
  [SMALL_STATE(1738)] = 56223,
  [SMALL_STATE(1739)] = 56273,
  [SMALL_STATE(1740)] = 56323,
  [SMALL_STATE(1741)] = 56373,
  [SMALL_STATE(1742)] = 56423,
  [SMALL_STATE(1743)] = 56473,
  [SMALL_STATE(1744)] = 56523,
  [SMALL_STATE(1745)] = 56585,
  [SMALL_STATE(1746)] = 56635,
  [SMALL_STATE(1747)] = 56685,
  [SMALL_STATE(1748)] = 56735,
  [SMALL_STATE(1749)] = 56785,
  [SMALL_STATE(1750)] = 56835,
  [SMALL_STATE(1751)] = 56885,
  [SMALL_STATE(1752)] = 56947,
  [SMALL_STATE(1753)] = 57009,
  [SMALL_STATE(1754)] = 57091,
  [SMALL_STATE(1755)] = 57199,
  [SMALL_STATE(1756)] = 57281,
  [SMALL_STATE(1757)] = 57331,
  [SMALL_STATE(1758)] = 57413,
  [SMALL_STATE(1759)] = 57521,
  [SMALL_STATE(1760)] = 57629,
  [SMALL_STATE(1761)] = 57685,
  [SMALL_STATE(1762)] = 57739,
  [SMALL_STATE(1763)] = 57793,
  [SMALL_STATE(1764)] = 57849,
  [SMALL_STATE(1765)] = 57911,
  [SMALL_STATE(1766)] = 57967,
  [SMALL_STATE(1767)] = 58021,
  [SMALL_STATE(1768)] = 58131,
  [SMALL_STATE(1769)] = 58241,
  [SMALL_STATE(1770)] = 58349,
  [SMALL_STATE(1771)] = 58431,
  [SMALL_STATE(1772)] = 58481,
  [SMALL_STATE(1773)] = 58537,
  [SMALL_STATE(1774)] = 58645,
  [SMALL_STATE(1775)] = 58753,
  [SMALL_STATE(1776)] = 58847,
  [SMALL_STATE(1777)] = 58955,
  [SMALL_STATE(1778)] = 59063,
  [SMALL_STATE(1779)] = 59173,
  [SMALL_STATE(1780)] = 59223,
  [SMALL_STATE(1781)] = 59333,
  [SMALL_STATE(1782)] = 59425,
  [SMALL_STATE(1783)] = 59533,
  [SMALL_STATE(1784)] = 59641,
  [SMALL_STATE(1785)] = 59691,
  [SMALL_STATE(1786)] = 59781,
  [SMALL_STATE(1787)] = 59859,
  [SMALL_STATE(1788)] = 59957,
  [SMALL_STATE(1789)] = 60053,
  [SMALL_STATE(1790)] = 60103,
  [SMALL_STATE(1791)] = 60155,
  [SMALL_STATE(1792)] = 60265,
  [SMALL_STATE(1793)] = 60321,
  [SMALL_STATE(1794)] = 60429,
  [SMALL_STATE(1795)] = 60487,
  [SMALL_STATE(1796)] = 60537,
  [SMALL_STATE(1797)] = 60587,
  [SMALL_STATE(1798)] = 60637,
  [SMALL_STATE(1799)] = 60689,
  [SMALL_STATE(1800)] = 60739,
  [SMALL_STATE(1801)] = 60849,
  [SMALL_STATE(1802)] = 60901,
  [SMALL_STATE(1803)] = 60953,
  [SMALL_STATE(1804)] = 61005,
  [SMALL_STATE(1805)] = 61063,
  [SMALL_STATE(1806)] = 61113,
  [SMALL_STATE(1807)] = 61223,
  [SMALL_STATE(1808)] = 61273,
  [SMALL_STATE(1809)] = 61329,
  [SMALL_STATE(1810)] = 61379,
  [SMALL_STATE(1811)] = 61429,
  [SMALL_STATE(1812)] = 61479,
  [SMALL_STATE(1813)] = 61529,
  [SMALL_STATE(1814)] = 61581,
  [SMALL_STATE(1815)] = 61653,
  [SMALL_STATE(1816)] = 61709,
  [SMALL_STATE(1817)] = 61767,
  [SMALL_STATE(1818)] = 61823,
  [SMALL_STATE(1819)] = 61873,
  [SMALL_STATE(1820)] = 61923,
  [SMALL_STATE(1821)] = 61979,
  [SMALL_STATE(1822)] = 62041,
  [SMALL_STATE(1823)] = 62151,
  [SMALL_STATE(1824)] = 62233,
  [SMALL_STATE(1825)] = 62343,
  [SMALL_STATE(1826)] = 62393,
  [SMALL_STATE(1827)] = 62449,
  [SMALL_STATE(1828)] = 62498,
  [SMALL_STATE(1829)] = 62555,
  [SMALL_STATE(1830)] = 62662,
  [SMALL_STATE(1831)] = 62769,
  [SMALL_STATE(1832)] = 62826,
  [SMALL_STATE(1833)] = 62899,
  [SMALL_STATE(1834)] = 62954,
  [SMALL_STATE(1835)] = 63061,
  [SMALL_STATE(1836)] = 63116,
  [SMALL_STATE(1837)] = 63169,
  [SMALL_STATE(1838)] = 63264,
  [SMALL_STATE(1839)] = 63313,
  [SMALL_STATE(1840)] = 63366,
  [SMALL_STATE(1841)] = 63473,
  [SMALL_STATE(1842)] = 63524,
  [SMALL_STATE(1843)] = 63573,
  [SMALL_STATE(1844)] = 63626,
  [SMALL_STATE(1845)] = 63679,
  [SMALL_STATE(1846)] = 63754,
  [SMALL_STATE(1847)] = 63861,
  [SMALL_STATE(1848)] = 63936,
  [SMALL_STATE(1849)] = 63987,
  [SMALL_STATE(1850)] = 64040,
  [SMALL_STATE(1851)] = 64091,
  [SMALL_STATE(1852)] = 64140,
  [SMALL_STATE(1853)] = 64193,
  [SMALL_STATE(1854)] = 64252,
  [SMALL_STATE(1855)] = 64305,
  [SMALL_STATE(1856)] = 64358,
  [SMALL_STATE(1857)] = 64411,
  [SMALL_STATE(1858)] = 64460,
  [SMALL_STATE(1859)] = 64511,
  [SMALL_STATE(1860)] = 64564,
  [SMALL_STATE(1861)] = 64645,
  [SMALL_STATE(1862)] = 64752,
  [SMALL_STATE(1863)] = 64803,
  [SMALL_STATE(1864)] = 64856,
  [SMALL_STATE(1865)] = 64905,
  [SMALL_STATE(1866)] = 65012,
  [SMALL_STATE(1867)] = 65119,
  [SMALL_STATE(1868)] = 65226,
  [SMALL_STATE(1869)] = 65283,
  [SMALL_STATE(1870)] = 65332,
  [SMALL_STATE(1871)] = 65431,
  [SMALL_STATE(1872)] = 65540,
  [SMALL_STATE(1873)] = 65611,
  [SMALL_STATE(1874)] = 65718,
  [SMALL_STATE(1875)] = 65767,
  [SMALL_STATE(1876)] = 65818,
  [SMALL_STATE(1877)] = 65925,
  [SMALL_STATE(1878)] = 66032,
  [SMALL_STATE(1879)] = 66139,
  [SMALL_STATE(1880)] = 66188,
  [SMALL_STATE(1881)] = 66273,
  [SMALL_STATE(1882)] = 66324,
  [SMALL_STATE(1883)] = 66431,
  [SMALL_STATE(1884)] = 66480,
  [SMALL_STATE(1885)] = 66529,
  [SMALL_STATE(1886)] = 66580,
  [SMALL_STATE(1887)] = 66631,
  [SMALL_STATE(1888)] = 66690,
  [SMALL_STATE(1889)] = 66751,
  [SMALL_STATE(1890)] = 66800,
  [SMALL_STATE(1891)] = 66849,
  [SMALL_STATE(1892)] = 66924,
  [SMALL_STATE(1893)] = 67017,
  [SMALL_STATE(1894)] = 67066,
  [SMALL_STATE(1895)] = 67115,
  [SMALL_STATE(1896)] = 67206,
  [SMALL_STATE(1897)] = 67255,
  [SMALL_STATE(1898)] = 67308,
  [SMALL_STATE(1899)] = 67361,
  [SMALL_STATE(1900)] = 67450,
  [SMALL_STATE(1901)] = 67499,
  [SMALL_STATE(1902)] = 67548,
  [SMALL_STATE(1903)] = 67597,
  [SMALL_STATE(1904)] = 67646,
  [SMALL_STATE(1905)] = 67695,
  [SMALL_STATE(1906)] = 67744,
  [SMALL_STATE(1907)] = 67803,
  [SMALL_STATE(1908)] = 67852,
  [SMALL_STATE(1909)] = 67959,
  [SMALL_STATE(1910)] = 68008,
  [SMALL_STATE(1911)] = 68085,
  [SMALL_STATE(1912)] = 68134,
  [SMALL_STATE(1913)] = 68189,
  [SMALL_STATE(1914)] = 68238,
  [SMALL_STATE(1915)] = 68287,
  [SMALL_STATE(1916)] = 68356,
  [SMALL_STATE(1917)] = 68405,
  [SMALL_STATE(1918)] = 68454,
  [SMALL_STATE(1919)] = 68511,
  [SMALL_STATE(1920)] = 68564,
  [SMALL_STATE(1921)] = 68613,
  [SMALL_STATE(1922)] = 68672,
  [SMALL_STATE(1923)] = 68725,
  [SMALL_STATE(1924)] = 68774,
  [SMALL_STATE(1925)] = 68823,
  [SMALL_STATE(1926)] = 68872,
  [SMALL_STATE(1927)] = 68927,
  [SMALL_STATE(1928)] = 68980,
  [SMALL_STATE(1929)] = 69029,
  [SMALL_STATE(1930)] = 69078,
  [SMALL_STATE(1931)] = 69129,
  [SMALL_STATE(1932)] = 69182,
  [SMALL_STATE(1933)] = 69235,
  [SMALL_STATE(1934)] = 69284,
  [SMALL_STATE(1935)] = 69333,
  [SMALL_STATE(1936)] = 69382,
  [SMALL_STATE(1937)] = 69489,
  [SMALL_STATE(1938)] = 69542,
  [SMALL_STATE(1939)] = 69591,
  [SMALL_STATE(1940)] = 69698,
  [SMALL_STATE(1941)] = 69747,
  [SMALL_STATE(1942)] = 69796,
  [SMALL_STATE(1943)] = 69849,
  [SMALL_STATE(1944)] = 69900,
  [SMALL_STATE(1945)] = 69949,
  [SMALL_STATE(1946)] = 70000,
  [SMALL_STATE(1947)] = 70053,
  [SMALL_STATE(1948)] = 70106,
  [SMALL_STATE(1949)] = 70159,
  [SMALL_STATE(1950)] = 70210,
  [SMALL_STATE(1951)] = 70307,
  [SMALL_STATE(1952)] = 70356,
  [SMALL_STATE(1953)] = 70463,
  [SMALL_STATE(1954)] = 70516,
  [SMALL_STATE(1955)] = 70623,
  [SMALL_STATE(1956)] = 70672,
  [SMALL_STATE(1957)] = 70725,
  [SMALL_STATE(1958)] = 70774,
  [SMALL_STATE(1959)] = 70823,
  [SMALL_STATE(1960)] = 70876,
  [SMALL_STATE(1961)] = 70953,
  [SMALL_STATE(1962)] = 71006,
  [SMALL_STATE(1963)] = 71057,
  [SMALL_STATE(1964)] = 71106,
  [SMALL_STATE(1965)] = 71163,
  [SMALL_STATE(1966)] = 71212,
  [SMALL_STATE(1967)] = 71279,
  [SMALL_STATE(1968)] = 71332,
  [SMALL_STATE(1969)] = 71407,
  [SMALL_STATE(1970)] = 71460,
  [SMALL_STATE(1971)] = 71509,
  [SMALL_STATE(1972)] = 71566,
  [SMALL_STATE(1973)] = 71615,
  [SMALL_STATE(1974)] = 71688,
  [SMALL_STATE(1975)] = 71745,
  [SMALL_STATE(1976)] = 71794,
  [SMALL_STATE(1977)] = 71843,
  [SMALL_STATE(1978)] = 71916,
  [SMALL_STATE(1979)] = 72023,
  [SMALL_STATE(1980)] = 72072,
  [SMALL_STATE(1981)] = 72147,
  [SMALL_STATE(1982)] = 72254,
  [SMALL_STATE(1983)] = 72309,
  [SMALL_STATE(1984)] = 72384,
  [SMALL_STATE(1985)] = 72433,
  [SMALL_STATE(1986)] = 72540,
  [SMALL_STATE(1987)] = 72589,
  [SMALL_STATE(1988)] = 72644,
  [SMALL_STATE(1989)] = 72719,
  [SMALL_STATE(1990)] = 72768,
  [SMALL_STATE(1991)] = 72841,
  [SMALL_STATE(1992)] = 72890,
  [SMALL_STATE(1993)] = 72963,
  [SMALL_STATE(1994)] = 73012,
  [SMALL_STATE(1995)] = 73119,
  [SMALL_STATE(1996)] = 73168,
  [SMALL_STATE(1997)] = 73217,
  [SMALL_STATE(1998)] = 73266,
  [SMALL_STATE(1999)] = 73315,
  [SMALL_STATE(2000)] = 73364,
  [SMALL_STATE(2001)] = 73417,
  [SMALL_STATE(2002)] = 73466,
  [SMALL_STATE(2003)] = 73541,
  [SMALL_STATE(2004)] = 73598,
  [SMALL_STATE(2005)] = 73702,
  [SMALL_STATE(2006)] = 73806,
  [SMALL_STATE(2007)] = 73874,
  [SMALL_STATE(2008)] = 73942,
  [SMALL_STATE(2009)] = 74046,
  [SMALL_STATE(2010)] = 74150,
  [SMALL_STATE(2011)] = 74218,
  [SMALL_STATE(2012)] = 74272,
  [SMALL_STATE(2013)] = 74376,
  [SMALL_STATE(2014)] = 74480,
  [SMALL_STATE(2015)] = 74584,
  [SMALL_STATE(2016)] = 74654,
  [SMALL_STATE(2017)] = 74758,
  [SMALL_STATE(2018)] = 74812,
  [SMALL_STATE(2019)] = 74892,
  [SMALL_STATE(2020)] = 74946,
  [SMALL_STATE(2021)] = 75050,
  [SMALL_STATE(2022)] = 75102,
  [SMALL_STATE(2023)] = 75200,
  [SMALL_STATE(2024)] = 75284,
  [SMALL_STATE(2025)] = 75360,
  [SMALL_STATE(2026)] = 75434,
  [SMALL_STATE(2027)] = 75526,
  [SMALL_STATE(2028)] = 75598,
  [SMALL_STATE(2029)] = 75702,
  [SMALL_STATE(2030)] = 75752,
  [SMALL_STATE(2031)] = 75802,
  [SMALL_STATE(2032)] = 75906,
  [SMALL_STATE(2033)] = 75962,
  [SMALL_STATE(2034)] = 76066,
  [SMALL_STATE(2035)] = 76120,
  [SMALL_STATE(2036)] = 76210,
  [SMALL_STATE(2037)] = 76266,
  [SMALL_STATE(2038)] = 76354,
  [SMALL_STATE(2039)] = 76430,
  [SMALL_STATE(2040)] = 76526,
  [SMALL_STATE(2041)] = 76594,
  [SMALL_STATE(2042)] = 76688,
  [SMALL_STATE(2043)] = 76762,
  [SMALL_STATE(2044)] = 76814,
  [SMALL_STATE(2045)] = 76918,
  [SMALL_STATE(2046)] = 76984,
  [SMALL_STATE(2047)] = 77040,
  [SMALL_STATE(2048)] = 77108,
  [SMALL_STATE(2049)] = 77182,
  [SMALL_STATE(2050)] = 77238,
  [SMALL_STATE(2051)] = 77294,
  [SMALL_STATE(2052)] = 77398,
  [SMALL_STATE(2053)] = 77466,
  [SMALL_STATE(2054)] = 77516,
  [SMALL_STATE(2055)] = 77585,
  [SMALL_STATE(2056)] = 77638,
  [SMALL_STATE(2057)] = 77691,
  [SMALL_STATE(2058)] = 77740,
  [SMALL_STATE(2059)] = 77789,
  [SMALL_STATE(2060)] = 77838,
  [SMALL_STATE(2061)] = 77891,
  [SMALL_STATE(2062)] = 77970,
  [SMALL_STATE(2063)] = 78021,
  [SMALL_STATE(2064)] = 78070,
  [SMALL_STATE(2065)] = 78119,
  [SMALL_STATE(2066)] = 78168,
  [SMALL_STATE(2067)] = 78223,
  [SMALL_STATE(2068)] = 78302,
  [SMALL_STATE(2069)] = 78351,
  [SMALL_STATE(2070)] = 78400,
  [SMALL_STATE(2071)] = 78469,
  [SMALL_STATE(2072)] = 78518,
  [SMALL_STATE(2073)] = 78585,
  [SMALL_STATE(2074)] = 78634,
  [SMALL_STATE(2075)] = 78687,
  [SMALL_STATE(2076)] = 78740,
  [SMALL_STATE(2077)] = 78805,
  [SMALL_STATE(2078)] = 78884,
  [SMALL_STATE(2079)] = 78963,
  [SMALL_STATE(2080)] = 79042,
  [SMALL_STATE(2081)] = 79091,
  [SMALL_STATE(2082)] = 79144,
  [SMALL_STATE(2083)] = 79213,
  [SMALL_STATE(2084)] = 79292,
  [SMALL_STATE(2085)] = 79361,
  [SMALL_STATE(2086)] = 79414,
  [SMALL_STATE(2087)] = 79483,
  [SMALL_STATE(2088)] = 79548,
  [SMALL_STATE(2089)] = 79613,
  [SMALL_STATE(2090)] = 79666,
  [SMALL_STATE(2091)] = 79745,
  [SMALL_STATE(2092)] = 79814,
  [SMALL_STATE(2093)] = 79876,
  [SMALL_STATE(2094)] = 79936,
  [SMALL_STATE(2095)] = 79996,
  [SMALL_STATE(2096)] = 80054,
  [SMALL_STATE(2097)] = 80116,
  [SMALL_STATE(2098)] = 80174,
  [SMALL_STATE(2099)] = 80234,
  [SMALL_STATE(2100)] = 80296,
  [SMALL_STATE(2101)] = 80354,
  [SMALL_STATE(2102)] = 80402,
  [SMALL_STATE(2103)] = 80462,
  [SMALL_STATE(2104)] = 80524,
  [SMALL_STATE(2105)] = 80576,
  [SMALL_STATE(2106)] = 80628,
  [SMALL_STATE(2107)] = 80698,
  [SMALL_STATE(2108)] = 80768,
  [SMALL_STATE(2109)] = 80828,
  [SMALL_STATE(2110)] = 80900,
  [SMALL_STATE(2111)] = 80958,
  [SMALL_STATE(2112)] = 81030,
  [SMALL_STATE(2113)] = 81090,
  [SMALL_STATE(2114)] = 81160,
  [SMALL_STATE(2115)] = 81222,
  [SMALL_STATE(2116)] = 81292,
  [SMALL_STATE(2117)] = 81364,
  [SMALL_STATE(2118)] = 81424,
  [SMALL_STATE(2119)] = 81482,
  [SMALL_STATE(2120)] = 81542,
  [SMALL_STATE(2121)] = 81590,
  [SMALL_STATE(2122)] = 81660,
  [SMALL_STATE(2123)] = 81722,
  [SMALL_STATE(2124)] = 81770,
  [SMALL_STATE(2125)] = 81830,
  [SMALL_STATE(2126)] = 81890,
  [SMALL_STATE(2127)] = 81962,
  [SMALL_STATE(2128)] = 82022,
  [SMALL_STATE(2129)] = 82074,
  [SMALL_STATE(2130)] = 82136,
  [SMALL_STATE(2131)] = 82194,
  [SMALL_STATE(2132)] = 82254,
  [SMALL_STATE(2133)] = 82316,
  [SMALL_STATE(2134)] = 82376,
  [SMALL_STATE(2135)] = 82434,
  [SMALL_STATE(2136)] = 82496,
  [SMALL_STATE(2137)] = 82568,
  [SMALL_STATE(2138)] = 82620,
  [SMALL_STATE(2139)] = 82690,
  [SMALL_STATE(2140)] = 82762,
  [SMALL_STATE(2141)] = 82832,
  [SMALL_STATE(2142)] = 82892,
  [SMALL_STATE(2143)] = 82952,
  [SMALL_STATE(2144)] = 83024,
  [SMALL_STATE(2145)] = 83088,
  [SMALL_STATE(2146)] = 83146,
  [SMALL_STATE(2147)] = 83204,
  [SMALL_STATE(2148)] = 83266,
  [SMALL_STATE(2149)] = 83324,
  [SMALL_STATE(2150)] = 83379,
  [SMALL_STATE(2151)] = 83434,
  [SMALL_STATE(2152)] = 83505,
  [SMALL_STATE(2153)] = 83570,
  [SMALL_STATE(2154)] = 83625,
  [SMALL_STATE(2155)] = 83680,
  [SMALL_STATE(2156)] = 83735,
  [SMALL_STATE(2157)] = 83790,
  [SMALL_STATE(2158)] = 83845,
  [SMALL_STATE(2159)] = 83892,
  [SMALL_STATE(2160)] = 83947,
  [SMALL_STATE(2161)] = 84024,
  [SMALL_STATE(2162)] = 84079,
  [SMALL_STATE(2163)] = 84144,
  [SMALL_STATE(2164)] = 84199,
  [SMALL_STATE(2165)] = 84254,
  [SMALL_STATE(2166)] = 84309,
  [SMALL_STATE(2167)] = 84374,
  [SMALL_STATE(2168)] = 84429,
  [SMALL_STATE(2169)] = 84494,
  [SMALL_STATE(2170)] = 84549,
  [SMALL_STATE(2171)] = 84604,
  [SMALL_STATE(2172)] = 84659,
  [SMALL_STATE(2173)] = 84714,
  [SMALL_STATE(2174)] = 84769,
  [SMALL_STATE(2175)] = 84834,
  [SMALL_STATE(2176)] = 84899,
  [SMALL_STATE(2177)] = 84964,
  [SMALL_STATE(2178)] = 85024,
  [SMALL_STATE(2179)] = 85092,
  [SMALL_STATE(2180)] = 85148,
  [SMALL_STATE(2181)] = 85210,
  [SMALL_STATE(2182)] = 85266,
  [SMALL_STATE(2183)] = 85330,
  [SMALL_STATE(2184)] = 85390,
  [SMALL_STATE(2185)] = 85440,
  [SMALL_STATE(2186)] = 85490,
  [SMALL_STATE(2187)] = 85549,
  [SMALL_STATE(2188)] = 85604,
  [SMALL_STATE(2189)] = 85659,
  [SMALL_STATE(2190)] = 85714,
  [SMALL_STATE(2191)] = 85769,
  [SMALL_STATE(2192)] = 85824,
  [SMALL_STATE(2193)] = 85885,
  [SMALL_STATE(2194)] = 85938,
  [SMALL_STATE(2195)] = 85993,
  [SMALL_STATE(2196)] = 86048,
  [SMALL_STATE(2197)] = 86103,
  [SMALL_STATE(2198)] = 86158,
  [SMALL_STATE(2199)] = 86213,
  [SMALL_STATE(2200)] = 86270,
  [SMALL_STATE(2201)] = 86323,
  [SMALL_STATE(2202)] = 86378,
  [SMALL_STATE(2203)] = 86433,
  [SMALL_STATE(2204)] = 86488,
  [SMALL_STATE(2205)] = 86543,
  [SMALL_STATE(2206)] = 86597,
  [SMALL_STATE(2207)] = 86676,
  [SMALL_STATE(2208)] = 86755,
  [SMALL_STATE(2209)] = 86834,
  [SMALL_STATE(2210)] = 86881,
  [SMALL_STATE(2211)] = 86960,
  [SMALL_STATE(2212)] = 87039,
  [SMALL_STATE(2213)] = 87086,
  [SMALL_STATE(2214)] = 87133,
  [SMALL_STATE(2215)] = 87212,
  [SMALL_STATE(2216)] = 87275,
  [SMALL_STATE(2217)] = 87354,
  [SMALL_STATE(2218)] = 87394,
  [SMALL_STATE(2219)] = 87434,
  [SMALL_STATE(2220)] = 87488,
  [SMALL_STATE(2221)] = 87528,
  [SMALL_STATE(2222)] = 87568,
  [SMALL_STATE(2223)] = 87624,
  [SMALL_STATE(2224)] = 87678,
  [SMALL_STATE(2225)] = 87730,
  [SMALL_STATE(2226)] = 87770,
  [SMALL_STATE(2227)] = 87826,
  [SMALL_STATE(2228)] = 87880,
  [SMALL_STATE(2229)] = 87920,
  [SMALL_STATE(2230)] = 87960,
  [SMALL_STATE(2231)] = 88002,
  [SMALL_STATE(2232)] = 88042,
  [SMALL_STATE(2233)] = 88084,
  [SMALL_STATE(2234)] = 88138,
  [SMALL_STATE(2235)] = 88182,
  [SMALL_STATE(2236)] = 88222,
  [SMALL_STATE(2237)] = 88278,
  [SMALL_STATE(2238)] = 88318,
  [SMALL_STATE(2239)] = 88358,
  [SMALL_STATE(2240)] = 88398,
  [SMALL_STATE(2241)] = 88438,
  [SMALL_STATE(2242)] = 88478,
  [SMALL_STATE(2243)] = 88518,
  [SMALL_STATE(2244)] = 88558,
  [SMALL_STATE(2245)] = 88602,
  [SMALL_STATE(2246)] = 88642,
  [SMALL_STATE(2247)] = 88682,
  [SMALL_STATE(2248)] = 88722,
  [SMALL_STATE(2249)] = 88762,
  [SMALL_STATE(2250)] = 88802,
  [SMALL_STATE(2251)] = 88844,
  [SMALL_STATE(2252)] = 88884,
  [SMALL_STATE(2253)] = 88924,
  [SMALL_STATE(2254)] = 88964,
  [SMALL_STATE(2255)] = 89004,
  [SMALL_STATE(2256)] = 89053,
  [SMALL_STATE(2257)] = 89094,
  [SMALL_STATE(2258)] = 89143,
  [SMALL_STATE(2259)] = 89192,
  [SMALL_STATE(2260)] = 89241,
  [SMALL_STATE(2261)] = 89290,
  [SMALL_STATE(2262)] = 89339,
  [SMALL_STATE(2263)] = 89380,
  [SMALL_STATE(2264)] = 89429,
  [SMALL_STATE(2265)] = 89478,
  [SMALL_STATE(2266)] = 89527,
  [SMALL_STATE(2267)] = 89590,
  [SMALL_STATE(2268)] = 89639,
  [SMALL_STATE(2269)] = 89688,
  [SMALL_STATE(2270)] = 89737,
  [SMALL_STATE(2271)] = 89786,
  [SMALL_STATE(2272)] = 89835,
  [SMALL_STATE(2273)] = 89884,
  [SMALL_STATE(2274)] = 89933,
  [SMALL_STATE(2275)] = 89982,
  [SMALL_STATE(2276)] = 90031,
  [SMALL_STATE(2277)] = 90080,
  [SMALL_STATE(2278)] = 90129,
  [SMALL_STATE(2279)] = 90189,
  [SMALL_STATE(2280)] = 90227,
  [SMALL_STATE(2281)] = 90277,
  [SMALL_STATE(2282)] = 90315,
  [SMALL_STATE(2283)] = 90353,
  [SMALL_STATE(2284)] = 90403,
  [SMALL_STATE(2285)] = 90453,
  [SMALL_STATE(2286)] = 90491,
  [SMALL_STATE(2287)] = 90541,
  [SMALL_STATE(2288)] = 90591,
  [SMALL_STATE(2289)] = 90647,
  [SMALL_STATE(2290)] = 90685,
  [SMALL_STATE(2291)] = 90723,
  [SMALL_STATE(2292)] = 90773,
  [SMALL_STATE(2293)] = 90823,
  [SMALL_STATE(2294)] = 90861,
  [SMALL_STATE(2295)] = 90921,
  [SMALL_STATE(2296)] = 90971,
  [SMALL_STATE(2297)] = 91031,
  [SMALL_STATE(2298)] = 91081,
  [SMALL_STATE(2299)] = 91119,
  [SMALL_STATE(2300)] = 91157,
  [SMALL_STATE(2301)] = 91207,
  [SMALL_STATE(2302)] = 91260,
  [SMALL_STATE(2303)] = 91299,
  [SMALL_STATE(2304)] = 91352,
  [SMALL_STATE(2305)] = 91405,
  [SMALL_STATE(2306)] = 91458,
  [SMALL_STATE(2307)] = 91511,
  [SMALL_STATE(2308)] = 91564,
  [SMALL_STATE(2309)] = 91617,
  [SMALL_STATE(2310)] = 91670,
  [SMALL_STATE(2311)] = 91723,
  [SMALL_STATE(2312)] = 91776,
  [SMALL_STATE(2313)] = 91827,
  [SMALL_STATE(2314)] = 91880,
  [SMALL_STATE(2315)] = 91931,
  [SMALL_STATE(2316)] = 91984,
  [SMALL_STATE(2317)] = 92031,
  [SMALL_STATE(2318)] = 92075,
  [SMALL_STATE(2319)] = 92121,
  [SMALL_STATE(2320)] = 92165,
  [SMALL_STATE(2321)] = 92209,
  [SMALL_STATE(2322)] = 92253,
  [SMALL_STATE(2323)] = 92297,
  [SMALL_STATE(2324)] = 92341,
  [SMALL_STATE(2325)] = 92385,
  [SMALL_STATE(2326)] = 92429,
  [SMALL_STATE(2327)] = 92473,
  [SMALL_STATE(2328)] = 92517,
  [SMALL_STATE(2329)] = 92561,
  [SMALL_STATE(2330)] = 92607,
  [SMALL_STATE(2331)] = 92651,
  [SMALL_STATE(2332)] = 92695,
  [SMALL_STATE(2333)] = 92739,
  [SMALL_STATE(2334)] = 92783,
  [SMALL_STATE(2335)] = 92827,
  [SMALL_STATE(2336)] = 92871,
  [SMALL_STATE(2337)] = 92915,
  [SMALL_STATE(2338)] = 92959,
  [SMALL_STATE(2339)] = 93003,
  [SMALL_STATE(2340)] = 93047,
  [SMALL_STATE(2341)] = 93091,
  [SMALL_STATE(2342)] = 93135,
  [SMALL_STATE(2343)] = 93179,
  [SMALL_STATE(2344)] = 93223,
  [SMALL_STATE(2345)] = 93269,
  [SMALL_STATE(2346)] = 93313,
  [SMALL_STATE(2347)] = 93357,
  [SMALL_STATE(2348)] = 93401,
  [SMALL_STATE(2349)] = 93445,
  [SMALL_STATE(2350)] = 93476,
  [SMALL_STATE(2351)] = 93508,
  [SMALL_STATE(2352)] = 93534,
  [SMALL_STATE(2353)] = 93568,
  [SMALL_STATE(2354)] = 93594,
  [SMALL_STATE(2355)] = 93650,
  [SMALL_STATE(2356)] = 93676,
  [SMALL_STATE(2357)] = 93702,
  [SMALL_STATE(2358)] = 93728,
  [SMALL_STATE(2359)] = 93754,
  [SMALL_STATE(2360)] = 93780,
  [SMALL_STATE(2361)] = 93806,
  [SMALL_STATE(2362)] = 93832,
  [SMALL_STATE(2363)] = 93858,
  [SMALL_STATE(2364)] = 93884,
  [SMALL_STATE(2365)] = 93910,
  [SMALL_STATE(2366)] = 93936,
  [SMALL_STATE(2367)] = 93962,
  [SMALL_STATE(2368)] = 93988,
  [SMALL_STATE(2369)] = 94014,
  [SMALL_STATE(2370)] = 94040,
  [SMALL_STATE(2371)] = 94066,
  [SMALL_STATE(2372)] = 94092,
  [SMALL_STATE(2373)] = 94118,
  [SMALL_STATE(2374)] = 94144,
  [SMALL_STATE(2375)] = 94178,
  [SMALL_STATE(2376)] = 94204,
  [SMALL_STATE(2377)] = 94238,
  [SMALL_STATE(2378)] = 94264,
  [SMALL_STATE(2379)] = 94290,
  [SMALL_STATE(2380)] = 94324,
  [SMALL_STATE(2381)] = 94350,
  [SMALL_STATE(2382)] = 94376,
  [SMALL_STATE(2383)] = 94402,
  [SMALL_STATE(2384)] = 94428,
  [SMALL_STATE(2385)] = 94454,
  [SMALL_STATE(2386)] = 94480,
  [SMALL_STATE(2387)] = 94536,
  [SMALL_STATE(2388)] = 94562,
  [SMALL_STATE(2389)] = 94588,
  [SMALL_STATE(2390)] = 94614,
  [SMALL_STATE(2391)] = 94640,
  [SMALL_STATE(2392)] = 94666,
  [SMALL_STATE(2393)] = 94692,
  [SMALL_STATE(2394)] = 94718,
  [SMALL_STATE(2395)] = 94743,
  [SMALL_STATE(2396)] = 94768,
  [SMALL_STATE(2397)] = 94793,
  [SMALL_STATE(2398)] = 94822,
  [SMALL_STATE(2399)] = 94849,
  [SMALL_STATE(2400)] = 94878,
  [SMALL_STATE(2401)] = 94902,
  [SMALL_STATE(2402)] = 94926,
  [SMALL_STATE(2403)] = 94950,
  [SMALL_STATE(2404)] = 94971,
  [SMALL_STATE(2405)] = 94992,
  [SMALL_STATE(2406)] = 95023,
  [SMALL_STATE(2407)] = 95046,
  [SMALL_STATE(2408)] = 95069,
  [SMALL_STATE(2409)] = 95092,
  [SMALL_STATE(2410)] = 95115,
  [SMALL_STATE(2411)] = 95138,
  [SMALL_STATE(2412)] = 95161,
  [SMALL_STATE(2413)] = 95184,
  [SMALL_STATE(2414)] = 95207,
  [SMALL_STATE(2415)] = 95230,
  [SMALL_STATE(2416)] = 95253,
  [SMALL_STATE(2417)] = 95276,
  [SMALL_STATE(2418)] = 95297,
  [SMALL_STATE(2419)] = 95322,
  [SMALL_STATE(2420)] = 95343,
  [SMALL_STATE(2421)] = 95374,
  [SMALL_STATE(2422)] = 95397,
  [SMALL_STATE(2423)] = 95418,
  [SMALL_STATE(2424)] = 95441,
  [SMALL_STATE(2425)] = 95472,
  [SMALL_STATE(2426)] = 95495,
  [SMALL_STATE(2427)] = 95518,
  [SMALL_STATE(2428)] = 95541,
  [SMALL_STATE(2429)] = 95564,
  [SMALL_STATE(2430)] = 95587,
  [SMALL_STATE(2431)] = 95610,
  [SMALL_STATE(2432)] = 95637,
  [SMALL_STATE(2433)] = 95660,
  [SMALL_STATE(2434)] = 95685,
  [SMALL_STATE(2435)] = 95710,
  [SMALL_STATE(2436)] = 95731,
  [SMALL_STATE(2437)] = 95754,
  [SMALL_STATE(2438)] = 95777,
  [SMALL_STATE(2439)] = 95800,
  [SMALL_STATE(2440)] = 95821,
  [SMALL_STATE(2441)] = 95844,
  [SMALL_STATE(2442)] = 95867,
  [SMALL_STATE(2443)] = 95898,
  [SMALL_STATE(2444)] = 95923,
  [SMALL_STATE(2445)] = 95944,
  [SMALL_STATE(2446)] = 95967,
  [SMALL_STATE(2447)] = 95995,
  [SMALL_STATE(2448)] = 96025,
  [SMALL_STATE(2449)] = 96055,
  [SMALL_STATE(2450)] = 96085,
  [SMALL_STATE(2451)] = 96115,
  [SMALL_STATE(2452)] = 96145,
  [SMALL_STATE(2453)] = 96173,
  [SMALL_STATE(2454)] = 96215,
  [SMALL_STATE(2455)] = 96245,
  [SMALL_STATE(2456)] = 96279,
  [SMALL_STATE(2457)] = 96307,
  [SMALL_STATE(2458)] = 96349,
  [SMALL_STATE(2459)] = 96373,
  [SMALL_STATE(2460)] = 96415,
  [SMALL_STATE(2461)] = 96443,
  [SMALL_STATE(2462)] = 96471,
  [SMALL_STATE(2463)] = 96513,
  [SMALL_STATE(2464)] = 96555,
  [SMALL_STATE(2465)] = 96583,
  [SMALL_STATE(2466)] = 96609,
  [SMALL_STATE(2467)] = 96651,
  [SMALL_STATE(2468)] = 96693,
  [SMALL_STATE(2469)] = 96723,
  [SMALL_STATE(2470)] = 96751,
  [SMALL_STATE(2471)] = 96779,
  [SMALL_STATE(2472)] = 96809,
  [SMALL_STATE(2473)] = 96831,
  [SMALL_STATE(2474)] = 96853,
  [SMALL_STATE(2475)] = 96875,
  [SMALL_STATE(2476)] = 96897,
  [SMALL_STATE(2477)] = 96919,
  [SMALL_STATE(2478)] = 96941,
  [SMALL_STATE(2479)] = 96963,
  [SMALL_STATE(2480)] = 96985,
  [SMALL_STATE(2481)] = 97007,
  [SMALL_STATE(2482)] = 97029,
  [SMALL_STATE(2483)] = 97051,
  [SMALL_STATE(2484)] = 97073,
  [SMALL_STATE(2485)] = 97095,
  [SMALL_STATE(2486)] = 97117,
  [SMALL_STATE(2487)] = 97147,
  [SMALL_STATE(2488)] = 97171,
  [SMALL_STATE(2489)] = 97199,
  [SMALL_STATE(2490)] = 97229,
  [SMALL_STATE(2491)] = 97259,
  [SMALL_STATE(2492)] = 97281,
  [SMALL_STATE(2493)] = 97303,
  [SMALL_STATE(2494)] = 97325,
  [SMALL_STATE(2495)] = 97347,
  [SMALL_STATE(2496)] = 97375,
  [SMALL_STATE(2497)] = 97397,
  [SMALL_STATE(2498)] = 97419,
  [SMALL_STATE(2499)] = 97441,
  [SMALL_STATE(2500)] = 97463,
  [SMALL_STATE(2501)] = 97485,
  [SMALL_STATE(2502)] = 97507,
  [SMALL_STATE(2503)] = 97529,
  [SMALL_STATE(2504)] = 97551,
  [SMALL_STATE(2505)] = 97573,
  [SMALL_STATE(2506)] = 97595,
  [SMALL_STATE(2507)] = 97617,
  [SMALL_STATE(2508)] = 97647,
  [SMALL_STATE(2509)] = 97677,
  [SMALL_STATE(2510)] = 97707,
  [SMALL_STATE(2511)] = 97735,
  [SMALL_STATE(2512)] = 97765,
  [SMALL_STATE(2513)] = 97787,
  [SMALL_STATE(2514)] = 97809,
  [SMALL_STATE(2515)] = 97831,
  [SMALL_STATE(2516)] = 97853,
  [SMALL_STATE(2517)] = 97875,
  [SMALL_STATE(2518)] = 97910,
  [SMALL_STATE(2519)] = 97945,
  [SMALL_STATE(2520)] = 97970,
  [SMALL_STATE(2521)] = 97997,
  [SMALL_STATE(2522)] = 98024,
  [SMALL_STATE(2523)] = 98049,
  [SMALL_STATE(2524)] = 98070,
  [SMALL_STATE(2525)] = 98111,
  [SMALL_STATE(2526)] = 98146,
  [SMALL_STATE(2527)] = 98167,
  [SMALL_STATE(2528)] = 98192,
  [SMALL_STATE(2529)] = 98227,
  [SMALL_STATE(2530)] = 98250,
  [SMALL_STATE(2531)] = 98271,
  [SMALL_STATE(2532)] = 98306,
  [SMALL_STATE(2533)] = 98331,
  [SMALL_STATE(2534)] = 98366,
  [SMALL_STATE(2535)] = 98401,
  [SMALL_STATE(2536)] = 98428,
  [SMALL_STATE(2537)] = 98453,
  [SMALL_STATE(2538)] = 98488,
  [SMALL_STATE(2539)] = 98529,
  [SMALL_STATE(2540)] = 98564,
  [SMALL_STATE(2541)] = 98599,
  [SMALL_STATE(2542)] = 98620,
  [SMALL_STATE(2543)] = 98647,
  [SMALL_STATE(2544)] = 98668,
  [SMALL_STATE(2545)] = 98689,
  [SMALL_STATE(2546)] = 98725,
  [SMALL_STATE(2547)] = 98743,
  [SMALL_STATE(2548)] = 98767,
  [SMALL_STATE(2549)] = 98803,
  [SMALL_STATE(2550)] = 98835,
  [SMALL_STATE(2551)] = 98867,
  [SMALL_STATE(2552)] = 98899,
  [SMALL_STATE(2553)] = 98935,
  [SMALL_STATE(2554)] = 98953,
  [SMALL_STATE(2555)] = 98971,
  [SMALL_STATE(2556)] = 98989,
  [SMALL_STATE(2557)] = 99007,
  [SMALL_STATE(2558)] = 99025,
  [SMALL_STATE(2559)] = 99043,
  [SMALL_STATE(2560)] = 99061,
  [SMALL_STATE(2561)] = 99079,
  [SMALL_STATE(2562)] = 99097,
  [SMALL_STATE(2563)] = 99135,
  [SMALL_STATE(2564)] = 99153,
  [SMALL_STATE(2565)] = 99185,
  [SMALL_STATE(2566)] = 99203,
  [SMALL_STATE(2567)] = 99221,
  [SMALL_STATE(2568)] = 99239,
  [SMALL_STATE(2569)] = 99257,
  [SMALL_STATE(2570)] = 99275,
  [SMALL_STATE(2571)] = 99307,
  [SMALL_STATE(2572)] = 99327,
  [SMALL_STATE(2573)] = 99349,
  [SMALL_STATE(2574)] = 99371,
  [SMALL_STATE(2575)] = 99389,
  [SMALL_STATE(2576)] = 99425,
  [SMALL_STATE(2577)] = 99463,
  [SMALL_STATE(2578)] = 99481,
  [SMALL_STATE(2579)] = 99517,
  [SMALL_STATE(2580)] = 99535,
  [SMALL_STATE(2581)] = 99553,
  [SMALL_STATE(2582)] = 99585,
  [SMALL_STATE(2583)] = 99603,
  [SMALL_STATE(2584)] = 99631,
  [SMALL_STATE(2585)] = 99659,
  [SMALL_STATE(2586)] = 99677,
  [SMALL_STATE(2587)] = 99695,
  [SMALL_STATE(2588)] = 99731,
  [SMALL_STATE(2589)] = 99749,
  [SMALL_STATE(2590)] = 99767,
  [SMALL_STATE(2591)] = 99795,
  [SMALL_STATE(2592)] = 99833,
  [SMALL_STATE(2593)] = 99851,
  [SMALL_STATE(2594)] = 99881,
  [SMALL_STATE(2595)] = 99899,
  [SMALL_STATE(2596)] = 99917,
  [SMALL_STATE(2597)] = 99945,
  [SMALL_STATE(2598)] = 99977,
  [SMALL_STATE(2599)] = 99995,
  [SMALL_STATE(2600)] = 100027,
  [SMALL_STATE(2601)] = 100063,
  [SMALL_STATE(2602)] = 100081,
  [SMALL_STATE(2603)] = 100109,
  [SMALL_STATE(2604)] = 100127,
  [SMALL_STATE(2605)] = 100165,
  [SMALL_STATE(2606)] = 100183,
  [SMALL_STATE(2607)] = 100201,
  [SMALL_STATE(2608)] = 100219,
  [SMALL_STATE(2609)] = 100237,
  [SMALL_STATE(2610)] = 100255,
  [SMALL_STATE(2611)] = 100287,
  [SMALL_STATE(2612)] = 100319,
  [SMALL_STATE(2613)] = 100338,
  [SMALL_STATE(2614)] = 100357,
  [SMALL_STATE(2615)] = 100374,
  [SMALL_STATE(2616)] = 100395,
  [SMALL_STATE(2617)] = 100414,
  [SMALL_STATE(2618)] = 100433,
  [SMALL_STATE(2619)] = 100450,
  [SMALL_STATE(2620)] = 100473,
  [SMALL_STATE(2621)] = 100492,
  [SMALL_STATE(2622)] = 100511,
  [SMALL_STATE(2623)] = 100532,
  [SMALL_STATE(2624)] = 100549,
  [SMALL_STATE(2625)] = 100568,
  [SMALL_STATE(2626)] = 100587,
  [SMALL_STATE(2627)] = 100604,
  [SMALL_STATE(2628)] = 100621,
  [SMALL_STATE(2629)] = 100640,
  [SMALL_STATE(2630)] = 100657,
  [SMALL_STATE(2631)] = 100676,
  [SMALL_STATE(2632)] = 100695,
  [SMALL_STATE(2633)] = 100718,
  [SMALL_STATE(2634)] = 100741,
  [SMALL_STATE(2635)] = 100762,
  [SMALL_STATE(2636)] = 100781,
  [SMALL_STATE(2637)] = 100800,
  [SMALL_STATE(2638)] = 100819,
  [SMALL_STATE(2639)] = 100842,
  [SMALL_STATE(2640)] = 100865,
  [SMALL_STATE(2641)] = 100884,
  [SMALL_STATE(2642)] = 100903,
  [SMALL_STATE(2643)] = 100922,
  [SMALL_STATE(2644)] = 100943,
  [SMALL_STATE(2645)] = 100962,
  [SMALL_STATE(2646)] = 100981,
  [SMALL_STATE(2647)] = 100998,
  [SMALL_STATE(2648)] = 101017,
  [SMALL_STATE(2649)] = 101036,
  [SMALL_STATE(2650)] = 101055,
  [SMALL_STATE(2651)] = 101078,
  [SMALL_STATE(2652)] = 101097,
  [SMALL_STATE(2653)] = 101116,
  [SMALL_STATE(2654)] = 101135,
  [SMALL_STATE(2655)] = 101154,
  [SMALL_STATE(2656)] = 101175,
  [SMALL_STATE(2657)] = 101194,
  [SMALL_STATE(2658)] = 101213,
  [SMALL_STATE(2659)] = 101232,
  [SMALL_STATE(2660)] = 101251,
  [SMALL_STATE(2661)] = 101270,
  [SMALL_STATE(2662)] = 101291,
  [SMALL_STATE(2663)] = 101312,
  [SMALL_STATE(2664)] = 101331,
  [SMALL_STATE(2665)] = 101348,
  [SMALL_STATE(2666)] = 101367,
  [SMALL_STATE(2667)] = 101386,
  [SMALL_STATE(2668)] = 101405,
  [SMALL_STATE(2669)] = 101423,
  [SMALL_STATE(2670)] = 101449,
  [SMALL_STATE(2671)] = 101475,
  [SMALL_STATE(2672)] = 101501,
  [SMALL_STATE(2673)] = 101527,
  [SMALL_STATE(2674)] = 101551,
  [SMALL_STATE(2675)] = 101581,
  [SMALL_STATE(2676)] = 101613,
  [SMALL_STATE(2677)] = 101637,
  [SMALL_STATE(2678)] = 101665,
  [SMALL_STATE(2679)] = 101697,
  [SMALL_STATE(2680)] = 101725,
  [SMALL_STATE(2681)] = 101757,
  [SMALL_STATE(2682)] = 101791,
  [SMALL_STATE(2683)] = 101825,
  [SMALL_STATE(2684)] = 101859,
  [SMALL_STATE(2685)] = 101885,
  [SMALL_STATE(2686)] = 101911,
  [SMALL_STATE(2687)] = 101945,
  [SMALL_STATE(2688)] = 101965,
  [SMALL_STATE(2689)] = 101989,
  [SMALL_STATE(2690)] = 102021,
  [SMALL_STATE(2691)] = 102043,
  [SMALL_STATE(2692)] = 102073,
  [SMALL_STATE(2693)] = 102091,
  [SMALL_STATE(2694)] = 102115,
  [SMALL_STATE(2695)] = 102135,
  [SMALL_STATE(2696)] = 102169,
  [SMALL_STATE(2697)] = 102195,
  [SMALL_STATE(2698)] = 102229,
  [SMALL_STATE(2699)] = 102263,
  [SMALL_STATE(2700)] = 102297,
  [SMALL_STATE(2701)] = 102323,
  [SMALL_STATE(2702)] = 102343,
  [SMALL_STATE(2703)] = 102375,
  [SMALL_STATE(2704)] = 102409,
  [SMALL_STATE(2705)] = 102435,
  [SMALL_STATE(2706)] = 102469,
  [SMALL_STATE(2707)] = 102495,
  [SMALL_STATE(2708)] = 102511,
  [SMALL_STATE(2709)] = 102545,
  [SMALL_STATE(2710)] = 102576,
  [SMALL_STATE(2711)] = 102603,
  [SMALL_STATE(2712)] = 102628,
  [SMALL_STATE(2713)] = 102643,
  [SMALL_STATE(2714)] = 102658,
  [SMALL_STATE(2715)] = 102689,
  [SMALL_STATE(2716)] = 102704,
  [SMALL_STATE(2717)] = 102729,
  [SMALL_STATE(2718)] = 102752,
  [SMALL_STATE(2719)] = 102769,
  [SMALL_STATE(2720)] = 102784,
  [SMALL_STATE(2721)] = 102799,
  [SMALL_STATE(2722)] = 102822,
  [SMALL_STATE(2723)] = 102847,
  [SMALL_STATE(2724)] = 102870,
  [SMALL_STATE(2725)] = 102901,
  [SMALL_STATE(2726)] = 102916,
  [SMALL_STATE(2727)] = 102947,
  [SMALL_STATE(2728)] = 102970,
  [SMALL_STATE(2729)] = 102997,
  [SMALL_STATE(2730)] = 103026,
  [SMALL_STATE(2731)] = 103057,
  [SMALL_STATE(2732)] = 103082,
  [SMALL_STATE(2733)] = 103105,
  [SMALL_STATE(2734)] = 103128,
  [SMALL_STATE(2735)] = 103143,
  [SMALL_STATE(2736)] = 103172,
  [SMALL_STATE(2737)] = 103201,
  [SMALL_STATE(2738)] = 103230,
  [SMALL_STATE(2739)] = 103255,
  [SMALL_STATE(2740)] = 103270,
  [SMALL_STATE(2741)] = 103285,
  [SMALL_STATE(2742)] = 103302,
  [SMALL_STATE(2743)] = 103317,
  [SMALL_STATE(2744)] = 103332,
  [SMALL_STATE(2745)] = 103363,
  [SMALL_STATE(2746)] = 103384,
  [SMALL_STATE(2747)] = 103403,
  [SMALL_STATE(2748)] = 103418,
  [SMALL_STATE(2749)] = 103435,
  [SMALL_STATE(2750)] = 103466,
  [SMALL_STATE(2751)] = 103487,
  [SMALL_STATE(2752)] = 103518,
  [SMALL_STATE(2753)] = 103541,
  [SMALL_STATE(2754)] = 103570,
  [SMALL_STATE(2755)] = 103585,
  [SMALL_STATE(2756)] = 103614,
  [SMALL_STATE(2757)] = 103633,
  [SMALL_STATE(2758)] = 103664,
  [SMALL_STATE(2759)] = 103679,
  [SMALL_STATE(2760)] = 103694,
  [SMALL_STATE(2761)] = 103709,
  [SMALL_STATE(2762)] = 103734,
  [SMALL_STATE(2763)] = 103759,
  [SMALL_STATE(2764)] = 103784,
  [SMALL_STATE(2765)] = 103799,
  [SMALL_STATE(2766)] = 103814,
  [SMALL_STATE(2767)] = 103841,
  [SMALL_STATE(2768)] = 103856,
  [SMALL_STATE(2769)] = 103881,
  [SMALL_STATE(2770)] = 103902,
  [SMALL_STATE(2771)] = 103917,
  [SMALL_STATE(2772)] = 103932,
  [SMALL_STATE(2773)] = 103949,
  [SMALL_STATE(2774)] = 103964,
  [SMALL_STATE(2775)] = 103995,
  [SMALL_STATE(2776)] = 104010,
  [SMALL_STATE(2777)] = 104025,
  [SMALL_STATE(2778)] = 104056,
  [SMALL_STATE(2779)] = 104087,
  [SMALL_STATE(2780)] = 104102,
  [SMALL_STATE(2781)] = 104131,
  [SMALL_STATE(2782)] = 104160,
  [SMALL_STATE(2783)] = 104187,
  [SMALL_STATE(2784)] = 104206,
  [SMALL_STATE(2785)] = 104231,
  [SMALL_STATE(2786)] = 104260,
  [SMALL_STATE(2787)] = 104289,
  [SMALL_STATE(2788)] = 104304,
  [SMALL_STATE(2789)] = 104333,
  [SMALL_STATE(2790)] = 104362,
  [SMALL_STATE(2791)] = 104387,
  [SMALL_STATE(2792)] = 104416,
  [SMALL_STATE(2793)] = 104447,
  [SMALL_STATE(2794)] = 104478,
  [SMALL_STATE(2795)] = 104493,
  [SMALL_STATE(2796)] = 104508,
  [SMALL_STATE(2797)] = 104537,
  [SMALL_STATE(2798)] = 104552,
  [SMALL_STATE(2799)] = 104567,
  [SMALL_STATE(2800)] = 104588,
  [SMALL_STATE(2801)] = 104603,
  [SMALL_STATE(2802)] = 104618,
  [SMALL_STATE(2803)] = 104633,
  [SMALL_STATE(2804)] = 104648,
  [SMALL_STATE(2805)] = 104677,
  [SMALL_STATE(2806)] = 104706,
  [SMALL_STATE(2807)] = 104737,
  [SMALL_STATE(2808)] = 104762,
  [SMALL_STATE(2809)] = 104791,
  [SMALL_STATE(2810)] = 104814,
  [SMALL_STATE(2811)] = 104837,
  [SMALL_STATE(2812)] = 104866,
  [SMALL_STATE(2813)] = 104891,
  [SMALL_STATE(2814)] = 104906,
  [SMALL_STATE(2815)] = 104921,
  [SMALL_STATE(2816)] = 104936,
  [SMALL_STATE(2817)] = 104965,
  [SMALL_STATE(2818)] = 104980,
  [SMALL_STATE(2819)] = 105011,
  [SMALL_STATE(2820)] = 105040,
  [SMALL_STATE(2821)] = 105069,
  [SMALL_STATE(2822)] = 105098,
  [SMALL_STATE(2823)] = 105127,
  [SMALL_STATE(2824)] = 105156,
  [SMALL_STATE(2825)] = 105187,
  [SMALL_STATE(2826)] = 105202,
  [SMALL_STATE(2827)] = 105227,
  [SMALL_STATE(2828)] = 105256,
  [SMALL_STATE(2829)] = 105271,
  [SMALL_STATE(2830)] = 105286,
  [SMALL_STATE(2831)] = 105305,
  [SMALL_STATE(2832)] = 105336,
  [SMALL_STATE(2833)] = 105365,
  [SMALL_STATE(2834)] = 105388,
  [SMALL_STATE(2835)] = 105417,
  [SMALL_STATE(2836)] = 105446,
  [SMALL_STATE(2837)] = 105475,
  [SMALL_STATE(2838)] = 105506,
  [SMALL_STATE(2839)] = 105527,
  [SMALL_STATE(2840)] = 105541,
  [SMALL_STATE(2841)] = 105565,
  [SMALL_STATE(2842)] = 105589,
  [SMALL_STATE(2843)] = 105613,
  [SMALL_STATE(2844)] = 105637,
  [SMALL_STATE(2845)] = 105661,
  [SMALL_STATE(2846)] = 105685,
  [SMALL_STATE(2847)] = 105709,
  [SMALL_STATE(2848)] = 105729,
  [SMALL_STATE(2849)] = 105745,
  [SMALL_STATE(2850)] = 105769,
  [SMALL_STATE(2851)] = 105789,
  [SMALL_STATE(2852)] = 105809,
  [SMALL_STATE(2853)] = 105833,
  [SMALL_STATE(2854)] = 105857,
  [SMALL_STATE(2855)] = 105871,
  [SMALL_STATE(2856)] = 105895,
  [SMALL_STATE(2857)] = 105909,
  [SMALL_STATE(2858)] = 105929,
  [SMALL_STATE(2859)] = 105953,
  [SMALL_STATE(2860)] = 105977,
  [SMALL_STATE(2861)] = 106001,
  [SMALL_STATE(2862)] = 106018,
  [SMALL_STATE(2863)] = 106035,
  [SMALL_STATE(2864)] = 106052,
  [SMALL_STATE(2865)] = 106065,
  [SMALL_STATE(2866)] = 106090,
  [SMALL_STATE(2867)] = 106107,
  [SMALL_STATE(2868)] = 106124,
  [SMALL_STATE(2869)] = 106141,
  [SMALL_STATE(2870)] = 106156,
  [SMALL_STATE(2871)] = 106181,
  [SMALL_STATE(2872)] = 106206,
  [SMALL_STATE(2873)] = 106231,
  [SMALL_STATE(2874)] = 106250,
  [SMALL_STATE(2875)] = 106267,
  [SMALL_STATE(2876)] = 106284,
  [SMALL_STATE(2877)] = 106297,
  [SMALL_STATE(2878)] = 106322,
  [SMALL_STATE(2879)] = 106347,
  [SMALL_STATE(2880)] = 106368,
  [SMALL_STATE(2881)] = 106387,
  [SMALL_STATE(2882)] = 106402,
  [SMALL_STATE(2883)] = 106427,
  [SMALL_STATE(2884)] = 106452,
  [SMALL_STATE(2885)] = 106467,
  [SMALL_STATE(2886)] = 106482,
  [SMALL_STATE(2887)] = 106499,
  [SMALL_STATE(2888)] = 106524,
  [SMALL_STATE(2889)] = 106545,
  [SMALL_STATE(2890)] = 106570,
  [SMALL_STATE(2891)] = 106591,
  [SMALL_STATE(2892)] = 106612,
  [SMALL_STATE(2893)] = 106625,
  [SMALL_STATE(2894)] = 106638,
  [SMALL_STATE(2895)] = 106659,
  [SMALL_STATE(2896)] = 106672,
  [SMALL_STATE(2897)] = 106697,
  [SMALL_STATE(2898)] = 106714,
  [SMALL_STATE(2899)] = 106739,
  [SMALL_STATE(2900)] = 106760,
  [SMALL_STATE(2901)] = 106781,
  [SMALL_STATE(2902)] = 106802,
  [SMALL_STATE(2903)] = 106815,
  [SMALL_STATE(2904)] = 106828,
  [SMALL_STATE(2905)] = 106853,
  [SMALL_STATE(2906)] = 106878,
  [SMALL_STATE(2907)] = 106891,
  [SMALL_STATE(2908)] = 106906,
  [SMALL_STATE(2909)] = 106931,
  [SMALL_STATE(2910)] = 106948,
  [SMALL_STATE(2911)] = 106973,
  [SMALL_STATE(2912)] = 106986,
  [SMALL_STATE(2913)] = 106999,
  [SMALL_STATE(2914)] = 107024,
  [SMALL_STATE(2915)] = 107037,
  [SMALL_STATE(2916)] = 107054,
  [SMALL_STATE(2917)] = 107067,
  [SMALL_STATE(2918)] = 107080,
  [SMALL_STATE(2919)] = 107101,
  [SMALL_STATE(2920)] = 107126,
  [SMALL_STATE(2921)] = 107143,
  [SMALL_STATE(2922)] = 107164,
  [SMALL_STATE(2923)] = 107181,
  [SMALL_STATE(2924)] = 107198,
  [SMALL_STATE(2925)] = 107215,
  [SMALL_STATE(2926)] = 107232,
  [SMALL_STATE(2927)] = 107257,
  [SMALL_STATE(2928)] = 107282,
  [SMALL_STATE(2929)] = 107307,
  [SMALL_STATE(2930)] = 107324,
  [SMALL_STATE(2931)] = 107349,
  [SMALL_STATE(2932)] = 107374,
  [SMALL_STATE(2933)] = 107399,
  [SMALL_STATE(2934)] = 107416,
  [SMALL_STATE(2935)] = 107433,
  [SMALL_STATE(2936)] = 107450,
  [SMALL_STATE(2937)] = 107471,
  [SMALL_STATE(2938)] = 107492,
  [SMALL_STATE(2939)] = 107509,
  [SMALL_STATE(2940)] = 107526,
  [SMALL_STATE(2941)] = 107543,
  [SMALL_STATE(2942)] = 107568,
  [SMALL_STATE(2943)] = 107591,
  [SMALL_STATE(2944)] = 107604,
  [SMALL_STATE(2945)] = 107619,
  [SMALL_STATE(2946)] = 107640,
  [SMALL_STATE(2947)] = 107661,
  [SMALL_STATE(2948)] = 107686,
  [SMALL_STATE(2949)] = 107703,
  [SMALL_STATE(2950)] = 107724,
  [SMALL_STATE(2951)] = 107741,
  [SMALL_STATE(2952)] = 107766,
  [SMALL_STATE(2953)] = 107791,
  [SMALL_STATE(2954)] = 107816,
  [SMALL_STATE(2955)] = 107841,
  [SMALL_STATE(2956)] = 107866,
  [SMALL_STATE(2957)] = 107891,
  [SMALL_STATE(2958)] = 107916,
  [SMALL_STATE(2959)] = 107931,
  [SMALL_STATE(2960)] = 107944,
  [SMALL_STATE(2961)] = 107961,
  [SMALL_STATE(2962)] = 107986,
  [SMALL_STATE(2963)] = 108001,
  [SMALL_STATE(2964)] = 108022,
  [SMALL_STATE(2965)] = 108047,
  [SMALL_STATE(2966)] = 108072,
  [SMALL_STATE(2967)] = 108087,
  [SMALL_STATE(2968)] = 108112,
  [SMALL_STATE(2969)] = 108137,
  [SMALL_STATE(2970)] = 108162,
  [SMALL_STATE(2971)] = 108179,
  [SMALL_STATE(2972)] = 108204,
  [SMALL_STATE(2973)] = 108225,
  [SMALL_STATE(2974)] = 108250,
  [SMALL_STATE(2975)] = 108275,
  [SMALL_STATE(2976)] = 108297,
  [SMALL_STATE(2977)] = 108319,
  [SMALL_STATE(2978)] = 108341,
  [SMALL_STATE(2979)] = 108359,
  [SMALL_STATE(2980)] = 108377,
  [SMALL_STATE(2981)] = 108395,
  [SMALL_STATE(2982)] = 108413,
  [SMALL_STATE(2983)] = 108435,
  [SMALL_STATE(2984)] = 108449,
  [SMALL_STATE(2985)] = 108467,
  [SMALL_STATE(2986)] = 108489,
  [SMALL_STATE(2987)] = 108511,
  [SMALL_STATE(2988)] = 108527,
  [SMALL_STATE(2989)] = 108547,
  [SMALL_STATE(2990)] = 108569,
  [SMALL_STATE(2991)] = 108591,
  [SMALL_STATE(2992)] = 108613,
  [SMALL_STATE(2993)] = 108635,
  [SMALL_STATE(2994)] = 108651,
  [SMALL_STATE(2995)] = 108673,
  [SMALL_STATE(2996)] = 108687,
  [SMALL_STATE(2997)] = 108709,
  [SMALL_STATE(2998)] = 108727,
  [SMALL_STATE(2999)] = 108745,
  [SMALL_STATE(3000)] = 108761,
  [SMALL_STATE(3001)] = 108779,
  [SMALL_STATE(3002)] = 108801,
  [SMALL_STATE(3003)] = 108817,
  [SMALL_STATE(3004)] = 108829,
  [SMALL_STATE(3005)] = 108851,
  [SMALL_STATE(3006)] = 108867,
  [SMALL_STATE(3007)] = 108889,
  [SMALL_STATE(3008)] = 108911,
  [SMALL_STATE(3009)] = 108927,
  [SMALL_STATE(3010)] = 108949,
  [SMALL_STATE(3011)] = 108965,
  [SMALL_STATE(3012)] = 108983,
  [SMALL_STATE(3013)] = 109001,
  [SMALL_STATE(3014)] = 109015,
  [SMALL_STATE(3015)] = 109037,
  [SMALL_STATE(3016)] = 109059,
  [SMALL_STATE(3017)] = 109077,
  [SMALL_STATE(3018)] = 109099,
  [SMALL_STATE(3019)] = 109121,
  [SMALL_STATE(3020)] = 109137,
  [SMALL_STATE(3021)] = 109153,
  [SMALL_STATE(3022)] = 109175,
  [SMALL_STATE(3023)] = 109197,
  [SMALL_STATE(3024)] = 109213,
  [SMALL_STATE(3025)] = 109235,
  [SMALL_STATE(3026)] = 109257,
  [SMALL_STATE(3027)] = 109275,
  [SMALL_STATE(3028)] = 109297,
  [SMALL_STATE(3029)] = 109313,
  [SMALL_STATE(3030)] = 109335,
  [SMALL_STATE(3031)] = 109351,
  [SMALL_STATE(3032)] = 109369,
  [SMALL_STATE(3033)] = 109389,
  [SMALL_STATE(3034)] = 109401,
  [SMALL_STATE(3035)] = 109413,
  [SMALL_STATE(3036)] = 109435,
  [SMALL_STATE(3037)] = 109457,
  [SMALL_STATE(3038)] = 109479,
  [SMALL_STATE(3039)] = 109491,
  [SMALL_STATE(3040)] = 109507,
  [SMALL_STATE(3041)] = 109519,
  [SMALL_STATE(3042)] = 109541,
  [SMALL_STATE(3043)] = 109563,
  [SMALL_STATE(3044)] = 109585,
  [SMALL_STATE(3045)] = 109603,
  [SMALL_STATE(3046)] = 109625,
  [SMALL_STATE(3047)] = 109641,
  [SMALL_STATE(3048)] = 109659,
  [SMALL_STATE(3049)] = 109675,
  [SMALL_STATE(3050)] = 109697,
  [SMALL_STATE(3051)] = 109713,
  [SMALL_STATE(3052)] = 109735,
  [SMALL_STATE(3053)] = 109757,
  [SMALL_STATE(3054)] = 109773,
  [SMALL_STATE(3055)] = 109789,
  [SMALL_STATE(3056)] = 109805,
  [SMALL_STATE(3057)] = 109821,
  [SMALL_STATE(3058)] = 109843,
  [SMALL_STATE(3059)] = 109859,
  [SMALL_STATE(3060)] = 109881,
  [SMALL_STATE(3061)] = 109903,
  [SMALL_STATE(3062)] = 109925,
  [SMALL_STATE(3063)] = 109943,
  [SMALL_STATE(3064)] = 109965,
  [SMALL_STATE(3065)] = 109981,
  [SMALL_STATE(3066)] = 110003,
  [SMALL_STATE(3067)] = 110025,
  [SMALL_STATE(3068)] = 110047,
  [SMALL_STATE(3069)] = 110063,
  [SMALL_STATE(3070)] = 110079,
  [SMALL_STATE(3071)] = 110095,
  [SMALL_STATE(3072)] = 110111,
  [SMALL_STATE(3073)] = 110133,
  [SMALL_STATE(3074)] = 110151,
  [SMALL_STATE(3075)] = 110173,
  [SMALL_STATE(3076)] = 110195,
  [SMALL_STATE(3077)] = 110211,
  [SMALL_STATE(3078)] = 110227,
  [SMALL_STATE(3079)] = 110247,
  [SMALL_STATE(3080)] = 110265,
  [SMALL_STATE(3081)] = 110287,
  [SMALL_STATE(3082)] = 110303,
  [SMALL_STATE(3083)] = 110319,
  [SMALL_STATE(3084)] = 110335,
  [SMALL_STATE(3085)] = 110351,
  [SMALL_STATE(3086)] = 110373,
  [SMALL_STATE(3087)] = 110391,
  [SMALL_STATE(3088)] = 110413,
  [SMALL_STATE(3089)] = 110429,
  [SMALL_STATE(3090)] = 110451,
  [SMALL_STATE(3091)] = 110469,
  [SMALL_STATE(3092)] = 110485,
  [SMALL_STATE(3093)] = 110507,
  [SMALL_STATE(3094)] = 110529,
  [SMALL_STATE(3095)] = 110541,
  [SMALL_STATE(3096)] = 110553,
  [SMALL_STATE(3097)] = 110565,
  [SMALL_STATE(3098)] = 110577,
  [SMALL_STATE(3099)] = 110599,
  [SMALL_STATE(3100)] = 110617,
  [SMALL_STATE(3101)] = 110635,
  [SMALL_STATE(3102)] = 110647,
  [SMALL_STATE(3103)] = 110663,
  [SMALL_STATE(3104)] = 110679,
  [SMALL_STATE(3105)] = 110695,
  [SMALL_STATE(3106)] = 110717,
  [SMALL_STATE(3107)] = 110733,
  [SMALL_STATE(3108)] = 110751,
  [SMALL_STATE(3109)] = 110767,
  [SMALL_STATE(3110)] = 110789,
  [SMALL_STATE(3111)] = 110805,
  [SMALL_STATE(3112)] = 110821,
  [SMALL_STATE(3113)] = 110843,
  [SMALL_STATE(3114)] = 110859,
  [SMALL_STATE(3115)] = 110881,
  [SMALL_STATE(3116)] = 110903,
  [SMALL_STATE(3117)] = 110919,
  [SMALL_STATE(3118)] = 110935,
  [SMALL_STATE(3119)] = 110957,
  [SMALL_STATE(3120)] = 110979,
  [SMALL_STATE(3121)] = 110995,
  [SMALL_STATE(3122)] = 111007,
  [SMALL_STATE(3123)] = 111019,
  [SMALL_STATE(3124)] = 111035,
  [SMALL_STATE(3125)] = 111047,
  [SMALL_STATE(3126)] = 111069,
  [SMALL_STATE(3127)] = 111083,
  [SMALL_STATE(3128)] = 111099,
  [SMALL_STATE(3129)] = 111121,
  [SMALL_STATE(3130)] = 111143,
  [SMALL_STATE(3131)] = 111165,
  [SMALL_STATE(3132)] = 111181,
  [SMALL_STATE(3133)] = 111203,
  [SMALL_STATE(3134)] = 111221,
  [SMALL_STATE(3135)] = 111243,
  [SMALL_STATE(3136)] = 111255,
  [SMALL_STATE(3137)] = 111277,
  [SMALL_STATE(3138)] = 111299,
  [SMALL_STATE(3139)] = 111321,
  [SMALL_STATE(3140)] = 111337,
  [SMALL_STATE(3141)] = 111353,
  [SMALL_STATE(3142)] = 111375,
  [SMALL_STATE(3143)] = 111391,
  [SMALL_STATE(3144)] = 111409,
  [SMALL_STATE(3145)] = 111431,
  [SMALL_STATE(3146)] = 111449,
  [SMALL_STATE(3147)] = 111463,
  [SMALL_STATE(3148)] = 111481,
  [SMALL_STATE(3149)] = 111503,
  [SMALL_STATE(3150)] = 111522,
  [SMALL_STATE(3151)] = 111533,
  [SMALL_STATE(3152)] = 111544,
  [SMALL_STATE(3153)] = 111555,
  [SMALL_STATE(3154)] = 111566,
  [SMALL_STATE(3155)] = 111577,
  [SMALL_STATE(3156)] = 111588,
  [SMALL_STATE(3157)] = 111599,
  [SMALL_STATE(3158)] = 111616,
  [SMALL_STATE(3159)] = 111635,
  [SMALL_STATE(3160)] = 111646,
  [SMALL_STATE(3161)] = 111657,
  [SMALL_STATE(3162)] = 111668,
  [SMALL_STATE(3163)] = 111679,
  [SMALL_STATE(3164)] = 111690,
  [SMALL_STATE(3165)] = 111701,
  [SMALL_STATE(3166)] = 111720,
  [SMALL_STATE(3167)] = 111739,
  [SMALL_STATE(3168)] = 111756,
  [SMALL_STATE(3169)] = 111767,
  [SMALL_STATE(3170)] = 111782,
  [SMALL_STATE(3171)] = 111793,
  [SMALL_STATE(3172)] = 111806,
  [SMALL_STATE(3173)] = 111821,
  [SMALL_STATE(3174)] = 111832,
  [SMALL_STATE(3175)] = 111843,
  [SMALL_STATE(3176)] = 111856,
  [SMALL_STATE(3177)] = 111871,
  [SMALL_STATE(3178)] = 111884,
  [SMALL_STATE(3179)] = 111895,
  [SMALL_STATE(3180)] = 111906,
  [SMALL_STATE(3181)] = 111917,
  [SMALL_STATE(3182)] = 111928,
  [SMALL_STATE(3183)] = 111939,
  [SMALL_STATE(3184)] = 111950,
  [SMALL_STATE(3185)] = 111961,
  [SMALL_STATE(3186)] = 111972,
  [SMALL_STATE(3187)] = 111985,
  [SMALL_STATE(3188)] = 112004,
  [SMALL_STATE(3189)] = 112017,
  [SMALL_STATE(3190)] = 112036,
  [SMALL_STATE(3191)] = 112047,
  [SMALL_STATE(3192)] = 112064,
  [SMALL_STATE(3193)] = 112081,
  [SMALL_STATE(3194)] = 112096,
  [SMALL_STATE(3195)] = 112113,
  [SMALL_STATE(3196)] = 112132,
  [SMALL_STATE(3197)] = 112143,
  [SMALL_STATE(3198)] = 112154,
  [SMALL_STATE(3199)] = 112173,
  [SMALL_STATE(3200)] = 112186,
  [SMALL_STATE(3201)] = 112205,
  [SMALL_STATE(3202)] = 112216,
  [SMALL_STATE(3203)] = 112235,
  [SMALL_STATE(3204)] = 112254,
  [SMALL_STATE(3205)] = 112273,
  [SMALL_STATE(3206)] = 112292,
  [SMALL_STATE(3207)] = 112303,
  [SMALL_STATE(3208)] = 112322,
  [SMALL_STATE(3209)] = 112333,
  [SMALL_STATE(3210)] = 112352,
  [SMALL_STATE(3211)] = 112371,
  [SMALL_STATE(3212)] = 112382,
  [SMALL_STATE(3213)] = 112401,
  [SMALL_STATE(3214)] = 112418,
  [SMALL_STATE(3215)] = 112429,
  [SMALL_STATE(3216)] = 112448,
  [SMALL_STATE(3217)] = 112459,
  [SMALL_STATE(3218)] = 112472,
  [SMALL_STATE(3219)] = 112483,
  [SMALL_STATE(3220)] = 112498,
  [SMALL_STATE(3221)] = 112509,
  [SMALL_STATE(3222)] = 112528,
  [SMALL_STATE(3223)] = 112543,
  [SMALL_STATE(3224)] = 112554,
  [SMALL_STATE(3225)] = 112567,
  [SMALL_STATE(3226)] = 112580,
  [SMALL_STATE(3227)] = 112595,
  [SMALL_STATE(3228)] = 112610,
  [SMALL_STATE(3229)] = 112629,
  [SMALL_STATE(3230)] = 112640,
  [SMALL_STATE(3231)] = 112659,
  [SMALL_STATE(3232)] = 112670,
  [SMALL_STATE(3233)] = 112689,
  [SMALL_STATE(3234)] = 112706,
  [SMALL_STATE(3235)] = 112725,
  [SMALL_STATE(3236)] = 112742,
  [SMALL_STATE(3237)] = 112761,
  [SMALL_STATE(3238)] = 112778,
  [SMALL_STATE(3239)] = 112797,
  [SMALL_STATE(3240)] = 112810,
  [SMALL_STATE(3241)] = 112829,
  [SMALL_STATE(3242)] = 112842,
  [SMALL_STATE(3243)] = 112857,
  [SMALL_STATE(3244)] = 112876,
  [SMALL_STATE(3245)] = 112887,
  [SMALL_STATE(3246)] = 112906,
  [SMALL_STATE(3247)] = 112923,
  [SMALL_STATE(3248)] = 112940,
  [SMALL_STATE(3249)] = 112951,
  [SMALL_STATE(3250)] = 112962,
  [SMALL_STATE(3251)] = 112981,
  [SMALL_STATE(3252)] = 112994,
  [SMALL_STATE(3253)] = 113013,
  [SMALL_STATE(3254)] = 113026,
  [SMALL_STATE(3255)] = 113037,
  [SMALL_STATE(3256)] = 113056,
  [SMALL_STATE(3257)] = 113071,
  [SMALL_STATE(3258)] = 113082,
  [SMALL_STATE(3259)] = 113101,
  [SMALL_STATE(3260)] = 113116,
  [SMALL_STATE(3261)] = 113133,
  [SMALL_STATE(3262)] = 113144,
  [SMALL_STATE(3263)] = 113155,
  [SMALL_STATE(3264)] = 113166,
  [SMALL_STATE(3265)] = 113177,
  [SMALL_STATE(3266)] = 113188,
  [SMALL_STATE(3267)] = 113207,
  [SMALL_STATE(3268)] = 113226,
  [SMALL_STATE(3269)] = 113243,
  [SMALL_STATE(3270)] = 113254,
  [SMALL_STATE(3271)] = 113273,
  [SMALL_STATE(3272)] = 113286,
  [SMALL_STATE(3273)] = 113299,
  [SMALL_STATE(3274)] = 113318,
  [SMALL_STATE(3275)] = 113329,
  [SMALL_STATE(3276)] = 113340,
  [SMALL_STATE(3277)] = 113351,
  [SMALL_STATE(3278)] = 113362,
  [SMALL_STATE(3279)] = 113373,
  [SMALL_STATE(3280)] = 113386,
  [SMALL_STATE(3281)] = 113397,
  [SMALL_STATE(3282)] = 113408,
  [SMALL_STATE(3283)] = 113419,
  [SMALL_STATE(3284)] = 113430,
  [SMALL_STATE(3285)] = 113441,
  [SMALL_STATE(3286)] = 113452,
  [SMALL_STATE(3287)] = 113471,
  [SMALL_STATE(3288)] = 113482,
  [SMALL_STATE(3289)] = 113493,
  [SMALL_STATE(3290)] = 113504,
  [SMALL_STATE(3291)] = 113515,
  [SMALL_STATE(3292)] = 113526,
  [SMALL_STATE(3293)] = 113537,
  [SMALL_STATE(3294)] = 113548,
  [SMALL_STATE(3295)] = 113559,
  [SMALL_STATE(3296)] = 113570,
  [SMALL_STATE(3297)] = 113581,
  [SMALL_STATE(3298)] = 113592,
  [SMALL_STATE(3299)] = 113609,
  [SMALL_STATE(3300)] = 113620,
  [SMALL_STATE(3301)] = 113631,
  [SMALL_STATE(3302)] = 113642,
  [SMALL_STATE(3303)] = 113653,
  [SMALL_STATE(3304)] = 113664,
  [SMALL_STATE(3305)] = 113675,
  [SMALL_STATE(3306)] = 113688,
  [SMALL_STATE(3307)] = 113699,
  [SMALL_STATE(3308)] = 113710,
  [SMALL_STATE(3309)] = 113721,
  [SMALL_STATE(3310)] = 113732,
  [SMALL_STATE(3311)] = 113743,
  [SMALL_STATE(3312)] = 113754,
  [SMALL_STATE(3313)] = 113769,
  [SMALL_STATE(3314)] = 113780,
  [SMALL_STATE(3315)] = 113791,
  [SMALL_STATE(3316)] = 113802,
  [SMALL_STATE(3317)] = 113813,
  [SMALL_STATE(3318)] = 113824,
  [SMALL_STATE(3319)] = 113835,
  [SMALL_STATE(3320)] = 113846,
  [SMALL_STATE(3321)] = 113857,
  [SMALL_STATE(3322)] = 113874,
  [SMALL_STATE(3323)] = 113893,
  [SMALL_STATE(3324)] = 113908,
  [SMALL_STATE(3325)] = 113919,
  [SMALL_STATE(3326)] = 113930,
  [SMALL_STATE(3327)] = 113943,
  [SMALL_STATE(3328)] = 113954,
  [SMALL_STATE(3329)] = 113965,
  [SMALL_STATE(3330)] = 113976,
  [SMALL_STATE(3331)] = 113987,
  [SMALL_STATE(3332)] = 113998,
  [SMALL_STATE(3333)] = 114017,
  [SMALL_STATE(3334)] = 114032,
  [SMALL_STATE(3335)] = 114043,
  [SMALL_STATE(3336)] = 114062,
  [SMALL_STATE(3337)] = 114073,
  [SMALL_STATE(3338)] = 114084,
  [SMALL_STATE(3339)] = 114095,
  [SMALL_STATE(3340)] = 114106,
  [SMALL_STATE(3341)] = 114117,
  [SMALL_STATE(3342)] = 114128,
  [SMALL_STATE(3343)] = 114147,
  [SMALL_STATE(3344)] = 114166,
  [SMALL_STATE(3345)] = 114185,
  [SMALL_STATE(3346)] = 114196,
  [SMALL_STATE(3347)] = 114207,
  [SMALL_STATE(3348)] = 114218,
  [SMALL_STATE(3349)] = 114231,
  [SMALL_STATE(3350)] = 114250,
  [SMALL_STATE(3351)] = 114263,
  [SMALL_STATE(3352)] = 114278,
  [SMALL_STATE(3353)] = 114289,
  [SMALL_STATE(3354)] = 114300,
  [SMALL_STATE(3355)] = 114313,
  [SMALL_STATE(3356)] = 114330,
  [SMALL_STATE(3357)] = 114345,
  [SMALL_STATE(3358)] = 114362,
  [SMALL_STATE(3359)] = 114379,
  [SMALL_STATE(3360)] = 114398,
  [SMALL_STATE(3361)] = 114409,
  [SMALL_STATE(3362)] = 114420,
  [SMALL_STATE(3363)] = 114439,
  [SMALL_STATE(3364)] = 114454,
  [SMALL_STATE(3365)] = 114473,
  [SMALL_STATE(3366)] = 114490,
  [SMALL_STATE(3367)] = 114509,
  [SMALL_STATE(3368)] = 114522,
  [SMALL_STATE(3369)] = 114541,
  [SMALL_STATE(3370)] = 114552,
  [SMALL_STATE(3371)] = 114569,
  [SMALL_STATE(3372)] = 114584,
  [SMALL_STATE(3373)] = 114595,
  [SMALL_STATE(3374)] = 114606,
  [SMALL_STATE(3375)] = 114617,
  [SMALL_STATE(3376)] = 114628,
  [SMALL_STATE(3377)] = 114639,
  [SMALL_STATE(3378)] = 114650,
  [SMALL_STATE(3379)] = 114661,
  [SMALL_STATE(3380)] = 114680,
  [SMALL_STATE(3381)] = 114691,
  [SMALL_STATE(3382)] = 114702,
  [SMALL_STATE(3383)] = 114721,
  [SMALL_STATE(3384)] = 114732,
  [SMALL_STATE(3385)] = 114751,
  [SMALL_STATE(3386)] = 114770,
  [SMALL_STATE(3387)] = 114789,
  [SMALL_STATE(3388)] = 114800,
  [SMALL_STATE(3389)] = 114815,
  [SMALL_STATE(3390)] = 114826,
  [SMALL_STATE(3391)] = 114845,
  [SMALL_STATE(3392)] = 114860,
  [SMALL_STATE(3393)] = 114879,
  [SMALL_STATE(3394)] = 114896,
  [SMALL_STATE(3395)] = 114907,
  [SMALL_STATE(3396)] = 114918,
  [SMALL_STATE(3397)] = 114929,
  [SMALL_STATE(3398)] = 114940,
  [SMALL_STATE(3399)] = 114959,
  [SMALL_STATE(3400)] = 114970,
  [SMALL_STATE(3401)] = 114981,
  [SMALL_STATE(3402)] = 115000,
  [SMALL_STATE(3403)] = 115011,
  [SMALL_STATE(3404)] = 115030,
  [SMALL_STATE(3405)] = 115049,
  [SMALL_STATE(3406)] = 115068,
  [SMALL_STATE(3407)] = 115085,
  [SMALL_STATE(3408)] = 115104,
  [SMALL_STATE(3409)] = 115123,
  [SMALL_STATE(3410)] = 115138,
  [SMALL_STATE(3411)] = 115153,
  [SMALL_STATE(3412)] = 115164,
  [SMALL_STATE(3413)] = 115183,
  [SMALL_STATE(3414)] = 115198,
  [SMALL_STATE(3415)] = 115217,
  [SMALL_STATE(3416)] = 115236,
  [SMALL_STATE(3417)] = 115255,
  [SMALL_STATE(3418)] = 115270,
  [SMALL_STATE(3419)] = 115289,
  [SMALL_STATE(3420)] = 115308,
  [SMALL_STATE(3421)] = 115319,
  [SMALL_STATE(3422)] = 115332,
  [SMALL_STATE(3423)] = 115343,
  [SMALL_STATE(3424)] = 115358,
  [SMALL_STATE(3425)] = 115369,
  [SMALL_STATE(3426)] = 115388,
  [SMALL_STATE(3427)] = 115399,
  [SMALL_STATE(3428)] = 115418,
  [SMALL_STATE(3429)] = 115429,
  [SMALL_STATE(3430)] = 115442,
  [SMALL_STATE(3431)] = 115453,
  [SMALL_STATE(3432)] = 115464,
  [SMALL_STATE(3433)] = 115483,
  [SMALL_STATE(3434)] = 115494,
  [SMALL_STATE(3435)] = 115513,
  [SMALL_STATE(3436)] = 115532,
  [SMALL_STATE(3437)] = 115543,
  [SMALL_STATE(3438)] = 115562,
  [SMALL_STATE(3439)] = 115581,
  [SMALL_STATE(3440)] = 115598,
  [SMALL_STATE(3441)] = 115617,
  [SMALL_STATE(3442)] = 115636,
  [SMALL_STATE(3443)] = 115655,
  [SMALL_STATE(3444)] = 115670,
  [SMALL_STATE(3445)] = 115687,
  [SMALL_STATE(3446)] = 115704,
  [SMALL_STATE(3447)] = 115720,
  [SMALL_STATE(3448)] = 115734,
  [SMALL_STATE(3449)] = 115750,
  [SMALL_STATE(3450)] = 115764,
  [SMALL_STATE(3451)] = 115780,
  [SMALL_STATE(3452)] = 115796,
  [SMALL_STATE(3453)] = 115810,
  [SMALL_STATE(3454)] = 115824,
  [SMALL_STATE(3455)] = 115838,
  [SMALL_STATE(3456)] = 115852,
  [SMALL_STATE(3457)] = 115868,
  [SMALL_STATE(3458)] = 115882,
  [SMALL_STATE(3459)] = 115896,
  [SMALL_STATE(3460)] = 115912,
  [SMALL_STATE(3461)] = 115926,
  [SMALL_STATE(3462)] = 115942,
  [SMALL_STATE(3463)] = 115956,
  [SMALL_STATE(3464)] = 115970,
  [SMALL_STATE(3465)] = 115986,
  [SMALL_STATE(3466)] = 116000,
  [SMALL_STATE(3467)] = 116014,
  [SMALL_STATE(3468)] = 116028,
  [SMALL_STATE(3469)] = 116042,
  [SMALL_STATE(3470)] = 116056,
  [SMALL_STATE(3471)] = 116070,
  [SMALL_STATE(3472)] = 116084,
  [SMALL_STATE(3473)] = 116100,
  [SMALL_STATE(3474)] = 116116,
  [SMALL_STATE(3475)] = 116132,
  [SMALL_STATE(3476)] = 116146,
  [SMALL_STATE(3477)] = 116160,
  [SMALL_STATE(3478)] = 116176,
  [SMALL_STATE(3479)] = 116192,
  [SMALL_STATE(3480)] = 116206,
  [SMALL_STATE(3481)] = 116220,
  [SMALL_STATE(3482)] = 116234,
  [SMALL_STATE(3483)] = 116250,
  [SMALL_STATE(3484)] = 116266,
  [SMALL_STATE(3485)] = 116282,
  [SMALL_STATE(3486)] = 116296,
  [SMALL_STATE(3487)] = 116310,
  [SMALL_STATE(3488)] = 116326,
  [SMALL_STATE(3489)] = 116342,
  [SMALL_STATE(3490)] = 116358,
  [SMALL_STATE(3491)] = 116372,
  [SMALL_STATE(3492)] = 116386,
  [SMALL_STATE(3493)] = 116402,
  [SMALL_STATE(3494)] = 116418,
  [SMALL_STATE(3495)] = 116434,
  [SMALL_STATE(3496)] = 116450,
  [SMALL_STATE(3497)] = 116466,
  [SMALL_STATE(3498)] = 116480,
  [SMALL_STATE(3499)] = 116494,
  [SMALL_STATE(3500)] = 116508,
  [SMALL_STATE(3501)] = 116520,
  [SMALL_STATE(3502)] = 116536,
  [SMALL_STATE(3503)] = 116548,
  [SMALL_STATE(3504)] = 116560,
  [SMALL_STATE(3505)] = 116576,
  [SMALL_STATE(3506)] = 116590,
  [SMALL_STATE(3507)] = 116604,
  [SMALL_STATE(3508)] = 116618,
  [SMALL_STATE(3509)] = 116634,
  [SMALL_STATE(3510)] = 116648,
  [SMALL_STATE(3511)] = 116664,
  [SMALL_STATE(3512)] = 116678,
  [SMALL_STATE(3513)] = 116692,
  [SMALL_STATE(3514)] = 116708,
  [SMALL_STATE(3515)] = 116724,
  [SMALL_STATE(3516)] = 116738,
  [SMALL_STATE(3517)] = 116752,
  [SMALL_STATE(3518)] = 116766,
  [SMALL_STATE(3519)] = 116780,
  [SMALL_STATE(3520)] = 116794,
  [SMALL_STATE(3521)] = 116808,
  [SMALL_STATE(3522)] = 116818,
  [SMALL_STATE(3523)] = 116832,
  [SMALL_STATE(3524)] = 116846,
  [SMALL_STATE(3525)] = 116862,
  [SMALL_STATE(3526)] = 116876,
  [SMALL_STATE(3527)] = 116892,
  [SMALL_STATE(3528)] = 116908,
  [SMALL_STATE(3529)] = 116924,
  [SMALL_STATE(3530)] = 116940,
  [SMALL_STATE(3531)] = 116956,
  [SMALL_STATE(3532)] = 116966,
  [SMALL_STATE(3533)] = 116980,
  [SMALL_STATE(3534)] = 116994,
  [SMALL_STATE(3535)] = 117008,
  [SMALL_STATE(3536)] = 117024,
  [SMALL_STATE(3537)] = 117038,
  [SMALL_STATE(3538)] = 117054,
  [SMALL_STATE(3539)] = 117068,
  [SMALL_STATE(3540)] = 117084,
  [SMALL_STATE(3541)] = 117100,
  [SMALL_STATE(3542)] = 117114,
  [SMALL_STATE(3543)] = 117126,
  [SMALL_STATE(3544)] = 117142,
  [SMALL_STATE(3545)] = 117152,
  [SMALL_STATE(3546)] = 117168,
  [SMALL_STATE(3547)] = 117184,
  [SMALL_STATE(3548)] = 117198,
  [SMALL_STATE(3549)] = 117214,
  [SMALL_STATE(3550)] = 117230,
  [SMALL_STATE(3551)] = 117246,
  [SMALL_STATE(3552)] = 117262,
  [SMALL_STATE(3553)] = 117278,
  [SMALL_STATE(3554)] = 117294,
  [SMALL_STATE(3555)] = 117308,
  [SMALL_STATE(3556)] = 117324,
  [SMALL_STATE(3557)] = 117340,
  [SMALL_STATE(3558)] = 117354,
  [SMALL_STATE(3559)] = 117370,
  [SMALL_STATE(3560)] = 117386,
  [SMALL_STATE(3561)] = 117400,
  [SMALL_STATE(3562)] = 117416,
  [SMALL_STATE(3563)] = 117432,
  [SMALL_STATE(3564)] = 117448,
  [SMALL_STATE(3565)] = 117462,
  [SMALL_STATE(3566)] = 117476,
  [SMALL_STATE(3567)] = 117492,
  [SMALL_STATE(3568)] = 117508,
  [SMALL_STATE(3569)] = 117524,
  [SMALL_STATE(3570)] = 117540,
  [SMALL_STATE(3571)] = 117554,
  [SMALL_STATE(3572)] = 117568,
  [SMALL_STATE(3573)] = 117582,
  [SMALL_STATE(3574)] = 117598,
  [SMALL_STATE(3575)] = 117614,
  [SMALL_STATE(3576)] = 117630,
  [SMALL_STATE(3577)] = 117644,
  [SMALL_STATE(3578)] = 117660,
  [SMALL_STATE(3579)] = 117673,
  [SMALL_STATE(3580)] = 117686,
  [SMALL_STATE(3581)] = 117695,
  [SMALL_STATE(3582)] = 117708,
  [SMALL_STATE(3583)] = 117717,
  [SMALL_STATE(3584)] = 117726,
  [SMALL_STATE(3585)] = 117739,
  [SMALL_STATE(3586)] = 117752,
  [SMALL_STATE(3587)] = 117765,
  [SMALL_STATE(3588)] = 117774,
  [SMALL_STATE(3589)] = 117787,
  [SMALL_STATE(3590)] = 117800,
  [SMALL_STATE(3591)] = 117813,
  [SMALL_STATE(3592)] = 117826,
  [SMALL_STATE(3593)] = 117839,
  [SMALL_STATE(3594)] = 117848,
  [SMALL_STATE(3595)] = 117857,
  [SMALL_STATE(3596)] = 117870,
  [SMALL_STATE(3597)] = 117883,
  [SMALL_STATE(3598)] = 117894,
  [SMALL_STATE(3599)] = 117907,
  [SMALL_STATE(3600)] = 117920,
  [SMALL_STATE(3601)] = 117933,
  [SMALL_STATE(3602)] = 117946,
  [SMALL_STATE(3603)] = 117955,
  [SMALL_STATE(3604)] = 117964,
  [SMALL_STATE(3605)] = 117975,
  [SMALL_STATE(3606)] = 117988,
  [SMALL_STATE(3607)] = 118001,
  [SMALL_STATE(3608)] = 118010,
  [SMALL_STATE(3609)] = 118023,
  [SMALL_STATE(3610)] = 118036,
  [SMALL_STATE(3611)] = 118049,
  [SMALL_STATE(3612)] = 118062,
  [SMALL_STATE(3613)] = 118075,
  [SMALL_STATE(3614)] = 118084,
  [SMALL_STATE(3615)] = 118097,
  [SMALL_STATE(3616)] = 118110,
  [SMALL_STATE(3617)] = 118119,
  [SMALL_STATE(3618)] = 118132,
  [SMALL_STATE(3619)] = 118145,
  [SMALL_STATE(3620)] = 118158,
  [SMALL_STATE(3621)] = 118171,
  [SMALL_STATE(3622)] = 118184,
  [SMALL_STATE(3623)] = 118193,
  [SMALL_STATE(3624)] = 118206,
  [SMALL_STATE(3625)] = 118215,
  [SMALL_STATE(3626)] = 118224,
  [SMALL_STATE(3627)] = 118237,
  [SMALL_STATE(3628)] = 118250,
  [SMALL_STATE(3629)] = 118261,
  [SMALL_STATE(3630)] = 118274,
  [SMALL_STATE(3631)] = 118287,
  [SMALL_STATE(3632)] = 118296,
  [SMALL_STATE(3633)] = 118309,
  [SMALL_STATE(3634)] = 118318,
  [SMALL_STATE(3635)] = 118331,
  [SMALL_STATE(3636)] = 118340,
  [SMALL_STATE(3637)] = 118353,
  [SMALL_STATE(3638)] = 118362,
  [SMALL_STATE(3639)] = 118371,
  [SMALL_STATE(3640)] = 118384,
  [SMALL_STATE(3641)] = 118393,
  [SMALL_STATE(3642)] = 118404,
  [SMALL_STATE(3643)] = 118417,
  [SMALL_STATE(3644)] = 118430,
  [SMALL_STATE(3645)] = 118443,
  [SMALL_STATE(3646)] = 118456,
  [SMALL_STATE(3647)] = 118469,
  [SMALL_STATE(3648)] = 118478,
  [SMALL_STATE(3649)] = 118491,
  [SMALL_STATE(3650)] = 118504,
  [SMALL_STATE(3651)] = 118517,
  [SMALL_STATE(3652)] = 118530,
  [SMALL_STATE(3653)] = 118543,
  [SMALL_STATE(3654)] = 118552,
  [SMALL_STATE(3655)] = 118561,
  [SMALL_STATE(3656)] = 118574,
  [SMALL_STATE(3657)] = 118587,
  [SMALL_STATE(3658)] = 118600,
  [SMALL_STATE(3659)] = 118613,
  [SMALL_STATE(3660)] = 118626,
  [SMALL_STATE(3661)] = 118639,
  [SMALL_STATE(3662)] = 118648,
  [SMALL_STATE(3663)] = 118661,
  [SMALL_STATE(3664)] = 118670,
  [SMALL_STATE(3665)] = 118683,
  [SMALL_STATE(3666)] = 118696,
  [SMALL_STATE(3667)] = 118709,
  [SMALL_STATE(3668)] = 118722,
  [SMALL_STATE(3669)] = 118735,
  [SMALL_STATE(3670)] = 118748,
  [SMALL_STATE(3671)] = 118761,
  [SMALL_STATE(3672)] = 118774,
  [SMALL_STATE(3673)] = 118783,
  [SMALL_STATE(3674)] = 118796,
  [SMALL_STATE(3675)] = 118809,
  [SMALL_STATE(3676)] = 118818,
  [SMALL_STATE(3677)] = 118831,
  [SMALL_STATE(3678)] = 118840,
  [SMALL_STATE(3679)] = 118853,
  [SMALL_STATE(3680)] = 118862,
  [SMALL_STATE(3681)] = 118871,
  [SMALL_STATE(3682)] = 118880,
  [SMALL_STATE(3683)] = 118889,
  [SMALL_STATE(3684)] = 118902,
  [SMALL_STATE(3685)] = 118915,
  [SMALL_STATE(3686)] = 118924,
  [SMALL_STATE(3687)] = 118933,
  [SMALL_STATE(3688)] = 118942,
  [SMALL_STATE(3689)] = 118953,
  [SMALL_STATE(3690)] = 118966,
  [SMALL_STATE(3691)] = 118975,
  [SMALL_STATE(3692)] = 118984,
  [SMALL_STATE(3693)] = 118993,
  [SMALL_STATE(3694)] = 119002,
  [SMALL_STATE(3695)] = 119011,
  [SMALL_STATE(3696)] = 119020,
  [SMALL_STATE(3697)] = 119033,
  [SMALL_STATE(3698)] = 119046,
  [SMALL_STATE(3699)] = 119059,
  [SMALL_STATE(3700)] = 119068,
  [SMALL_STATE(3701)] = 119077,
  [SMALL_STATE(3702)] = 119086,
  [SMALL_STATE(3703)] = 119099,
  [SMALL_STATE(3704)] = 119112,
  [SMALL_STATE(3705)] = 119125,
  [SMALL_STATE(3706)] = 119138,
  [SMALL_STATE(3707)] = 119151,
  [SMALL_STATE(3708)] = 119164,
  [SMALL_STATE(3709)] = 119175,
  [SMALL_STATE(3710)] = 119186,
  [SMALL_STATE(3711)] = 119197,
  [SMALL_STATE(3712)] = 119206,
  [SMALL_STATE(3713)] = 119217,
  [SMALL_STATE(3714)] = 119226,
  [SMALL_STATE(3715)] = 119239,
  [SMALL_STATE(3716)] = 119252,
  [SMALL_STATE(3717)] = 119265,
  [SMALL_STATE(3718)] = 119278,
  [SMALL_STATE(3719)] = 119291,
  [SMALL_STATE(3720)] = 119302,
  [SMALL_STATE(3721)] = 119315,
  [SMALL_STATE(3722)] = 119328,
  [SMALL_STATE(3723)] = 119341,
  [SMALL_STATE(3724)] = 119352,
  [SMALL_STATE(3725)] = 119365,
  [SMALL_STATE(3726)] = 119378,
  [SMALL_STATE(3727)] = 119391,
  [SMALL_STATE(3728)] = 119404,
  [SMALL_STATE(3729)] = 119417,
  [SMALL_STATE(3730)] = 119430,
  [SMALL_STATE(3731)] = 119439,
  [SMALL_STATE(3732)] = 119452,
  [SMALL_STATE(3733)] = 119461,
  [SMALL_STATE(3734)] = 119474,
  [SMALL_STATE(3735)] = 119487,
  [SMALL_STATE(3736)] = 119500,
  [SMALL_STATE(3737)] = 119513,
  [SMALL_STATE(3738)] = 119526,
  [SMALL_STATE(3739)] = 119539,
  [SMALL_STATE(3740)] = 119548,
  [SMALL_STATE(3741)] = 119561,
  [SMALL_STATE(3742)] = 119570,
  [SMALL_STATE(3743)] = 119583,
  [SMALL_STATE(3744)] = 119596,
  [SMALL_STATE(3745)] = 119609,
  [SMALL_STATE(3746)] = 119620,
  [SMALL_STATE(3747)] = 119631,
  [SMALL_STATE(3748)] = 119644,
  [SMALL_STATE(3749)] = 119655,
  [SMALL_STATE(3750)] = 119664,
  [SMALL_STATE(3751)] = 119675,
  [SMALL_STATE(3752)] = 119688,
  [SMALL_STATE(3753)] = 119697,
  [SMALL_STATE(3754)] = 119706,
  [SMALL_STATE(3755)] = 119715,
  [SMALL_STATE(3756)] = 119724,
  [SMALL_STATE(3757)] = 119737,
  [SMALL_STATE(3758)] = 119746,
  [SMALL_STATE(3759)] = 119755,
  [SMALL_STATE(3760)] = 119764,
  [SMALL_STATE(3761)] = 119773,
  [SMALL_STATE(3762)] = 119782,
  [SMALL_STATE(3763)] = 119791,
  [SMALL_STATE(3764)] = 119804,
  [SMALL_STATE(3765)] = 119813,
  [SMALL_STATE(3766)] = 119826,
  [SMALL_STATE(3767)] = 119835,
  [SMALL_STATE(3768)] = 119848,
  [SMALL_STATE(3769)] = 119857,
  [SMALL_STATE(3770)] = 119870,
  [SMALL_STATE(3771)] = 119883,
  [SMALL_STATE(3772)] = 119896,
  [SMALL_STATE(3773)] = 119905,
  [SMALL_STATE(3774)] = 119914,
  [SMALL_STATE(3775)] = 119923,
  [SMALL_STATE(3776)] = 119932,
  [SMALL_STATE(3777)] = 119945,
  [SMALL_STATE(3778)] = 119954,
  [SMALL_STATE(3779)] = 119967,
  [SMALL_STATE(3780)] = 119980,
  [SMALL_STATE(3781)] = 119993,
  [SMALL_STATE(3782)] = 120004,
  [SMALL_STATE(3783)] = 120017,
  [SMALL_STATE(3784)] = 120030,
  [SMALL_STATE(3785)] = 120039,
  [SMALL_STATE(3786)] = 120048,
  [SMALL_STATE(3787)] = 120061,
  [SMALL_STATE(3788)] = 120070,
  [SMALL_STATE(3789)] = 120081,
  [SMALL_STATE(3790)] = 120094,
  [SMALL_STATE(3791)] = 120107,
  [SMALL_STATE(3792)] = 120116,
  [SMALL_STATE(3793)] = 120129,
  [SMALL_STATE(3794)] = 120138,
  [SMALL_STATE(3795)] = 120147,
  [SMALL_STATE(3796)] = 120160,
  [SMALL_STATE(3797)] = 120169,
  [SMALL_STATE(3798)] = 120182,
  [SMALL_STATE(3799)] = 120195,
  [SMALL_STATE(3800)] = 120208,
  [SMALL_STATE(3801)] = 120221,
  [SMALL_STATE(3802)] = 120230,
  [SMALL_STATE(3803)] = 120243,
  [SMALL_STATE(3804)] = 120252,
  [SMALL_STATE(3805)] = 120265,
  [SMALL_STATE(3806)] = 120276,
  [SMALL_STATE(3807)] = 120285,
  [SMALL_STATE(3808)] = 120298,
  [SMALL_STATE(3809)] = 120307,
  [SMALL_STATE(3810)] = 120320,
  [SMALL_STATE(3811)] = 120331,
  [SMALL_STATE(3812)] = 120344,
  [SMALL_STATE(3813)] = 120357,
  [SMALL_STATE(3814)] = 120370,
  [SMALL_STATE(3815)] = 120383,
  [SMALL_STATE(3816)] = 120396,
  [SMALL_STATE(3817)] = 120409,
  [SMALL_STATE(3818)] = 120422,
  [SMALL_STATE(3819)] = 120435,
  [SMALL_STATE(3820)] = 120448,
  [SMALL_STATE(3821)] = 120461,
  [SMALL_STATE(3822)] = 120474,
  [SMALL_STATE(3823)] = 120487,
  [SMALL_STATE(3824)] = 120500,
  [SMALL_STATE(3825)] = 120511,
  [SMALL_STATE(3826)] = 120520,
  [SMALL_STATE(3827)] = 120531,
  [SMALL_STATE(3828)] = 120544,
  [SMALL_STATE(3829)] = 120555,
  [SMALL_STATE(3830)] = 120564,
  [SMALL_STATE(3831)] = 120573,
  [SMALL_STATE(3832)] = 120584,
  [SMALL_STATE(3833)] = 120597,
  [SMALL_STATE(3834)] = 120610,
  [SMALL_STATE(3835)] = 120620,
  [SMALL_STATE(3836)] = 120630,
  [SMALL_STATE(3837)] = 120638,
  [SMALL_STATE(3838)] = 120648,
  [SMALL_STATE(3839)] = 120658,
  [SMALL_STATE(3840)] = 120668,
  [SMALL_STATE(3841)] = 120678,
  [SMALL_STATE(3842)] = 120688,
  [SMALL_STATE(3843)] = 120696,
  [SMALL_STATE(3844)] = 120706,
  [SMALL_STATE(3845)] = 120714,
  [SMALL_STATE(3846)] = 120724,
  [SMALL_STATE(3847)] = 120734,
  [SMALL_STATE(3848)] = 120744,
  [SMALL_STATE(3849)] = 120754,
  [SMALL_STATE(3850)] = 120762,
  [SMALL_STATE(3851)] = 120772,
  [SMALL_STATE(3852)] = 120782,
  [SMALL_STATE(3853)] = 120792,
  [SMALL_STATE(3854)] = 120802,
  [SMALL_STATE(3855)] = 120812,
  [SMALL_STATE(3856)] = 120822,
  [SMALL_STATE(3857)] = 120832,
  [SMALL_STATE(3858)] = 120840,
  [SMALL_STATE(3859)] = 120850,
  [SMALL_STATE(3860)] = 120860,
  [SMALL_STATE(3861)] = 120870,
  [SMALL_STATE(3862)] = 120880,
  [SMALL_STATE(3863)] = 120888,
  [SMALL_STATE(3864)] = 120898,
  [SMALL_STATE(3865)] = 120908,
  [SMALL_STATE(3866)] = 120918,
  [SMALL_STATE(3867)] = 120928,
  [SMALL_STATE(3868)] = 120938,
  [SMALL_STATE(3869)] = 120948,
  [SMALL_STATE(3870)] = 120958,
  [SMALL_STATE(3871)] = 120968,
  [SMALL_STATE(3872)] = 120978,
  [SMALL_STATE(3873)] = 120988,
  [SMALL_STATE(3874)] = 120998,
  [SMALL_STATE(3875)] = 121006,
  [SMALL_STATE(3876)] = 121016,
  [SMALL_STATE(3877)] = 121024,
  [SMALL_STATE(3878)] = 121032,
  [SMALL_STATE(3879)] = 121042,
  [SMALL_STATE(3880)] = 121052,
  [SMALL_STATE(3881)] = 121060,
  [SMALL_STATE(3882)] = 121068,
  [SMALL_STATE(3883)] = 121078,
  [SMALL_STATE(3884)] = 121086,
  [SMALL_STATE(3885)] = 121096,
  [SMALL_STATE(3886)] = 121106,
  [SMALL_STATE(3887)] = 121116,
  [SMALL_STATE(3888)] = 121124,
  [SMALL_STATE(3889)] = 121134,
  [SMALL_STATE(3890)] = 121144,
  [SMALL_STATE(3891)] = 121154,
  [SMALL_STATE(3892)] = 121162,
  [SMALL_STATE(3893)] = 121170,
  [SMALL_STATE(3894)] = 121180,
  [SMALL_STATE(3895)] = 121188,
  [SMALL_STATE(3896)] = 121198,
  [SMALL_STATE(3897)] = 121208,
  [SMALL_STATE(3898)] = 121216,
  [SMALL_STATE(3899)] = 121226,
  [SMALL_STATE(3900)] = 121234,
  [SMALL_STATE(3901)] = 121244,
  [SMALL_STATE(3902)] = 121252,
  [SMALL_STATE(3903)] = 121262,
  [SMALL_STATE(3904)] = 121272,
  [SMALL_STATE(3905)] = 121282,
  [SMALL_STATE(3906)] = 121292,
  [SMALL_STATE(3907)] = 121302,
  [SMALL_STATE(3908)] = 121312,
  [SMALL_STATE(3909)] = 121322,
  [SMALL_STATE(3910)] = 121332,
  [SMALL_STATE(3911)] = 121342,
  [SMALL_STATE(3912)] = 121350,
  [SMALL_STATE(3913)] = 121358,
  [SMALL_STATE(3914)] = 121368,
  [SMALL_STATE(3915)] = 121378,
  [SMALL_STATE(3916)] = 121388,
  [SMALL_STATE(3917)] = 121398,
  [SMALL_STATE(3918)] = 121408,
  [SMALL_STATE(3919)] = 121418,
  [SMALL_STATE(3920)] = 121428,
  [SMALL_STATE(3921)] = 121438,
  [SMALL_STATE(3922)] = 121448,
  [SMALL_STATE(3923)] = 121456,
  [SMALL_STATE(3924)] = 121466,
  [SMALL_STATE(3925)] = 121476,
  [SMALL_STATE(3926)] = 121484,
  [SMALL_STATE(3927)] = 121494,
  [SMALL_STATE(3928)] = 121502,
  [SMALL_STATE(3929)] = 121510,
  [SMALL_STATE(3930)] = 121520,
  [SMALL_STATE(3931)] = 121530,
  [SMALL_STATE(3932)] = 121538,
  [SMALL_STATE(3933)] = 121546,
  [SMALL_STATE(3934)] = 121556,
  [SMALL_STATE(3935)] = 121566,
  [SMALL_STATE(3936)] = 121576,
  [SMALL_STATE(3937)] = 121586,
  [SMALL_STATE(3938)] = 121596,
  [SMALL_STATE(3939)] = 121606,
  [SMALL_STATE(3940)] = 121616,
  [SMALL_STATE(3941)] = 121626,
  [SMALL_STATE(3942)] = 121636,
  [SMALL_STATE(3943)] = 121646,
  [SMALL_STATE(3944)] = 121654,
  [SMALL_STATE(3945)] = 121662,
  [SMALL_STATE(3946)] = 121672,
  [SMALL_STATE(3947)] = 121680,
  [SMALL_STATE(3948)] = 121690,
  [SMALL_STATE(3949)] = 121698,
  [SMALL_STATE(3950)] = 121706,
  [SMALL_STATE(3951)] = 121716,
  [SMALL_STATE(3952)] = 121726,
  [SMALL_STATE(3953)] = 121734,
  [SMALL_STATE(3954)] = 121744,
  [SMALL_STATE(3955)] = 121752,
  [SMALL_STATE(3956)] = 121760,
  [SMALL_STATE(3957)] = 121768,
  [SMALL_STATE(3958)] = 121778,
  [SMALL_STATE(3959)] = 121788,
  [SMALL_STATE(3960)] = 121798,
  [SMALL_STATE(3961)] = 121808,
  [SMALL_STATE(3962)] = 121818,
  [SMALL_STATE(3963)] = 121828,
  [SMALL_STATE(3964)] = 121836,
  [SMALL_STATE(3965)] = 121846,
  [SMALL_STATE(3966)] = 121856,
  [SMALL_STATE(3967)] = 121866,
  [SMALL_STATE(3968)] = 121876,
  [SMALL_STATE(3969)] = 121886,
  [SMALL_STATE(3970)] = 121896,
  [SMALL_STATE(3971)] = 121906,
  [SMALL_STATE(3972)] = 121914,
  [SMALL_STATE(3973)] = 121922,
  [SMALL_STATE(3974)] = 121932,
  [SMALL_STATE(3975)] = 121940,
  [SMALL_STATE(3976)] = 121950,
  [SMALL_STATE(3977)] = 121960,
  [SMALL_STATE(3978)] = 121970,
  [SMALL_STATE(3979)] = 121980,
  [SMALL_STATE(3980)] = 121990,
  [SMALL_STATE(3981)] = 121998,
  [SMALL_STATE(3982)] = 122008,
  [SMALL_STATE(3983)] = 122018,
  [SMALL_STATE(3984)] = 122026,
  [SMALL_STATE(3985)] = 122034,
  [SMALL_STATE(3986)] = 122044,
  [SMALL_STATE(3987)] = 122054,
  [SMALL_STATE(3988)] = 122064,
  [SMALL_STATE(3989)] = 122074,
  [SMALL_STATE(3990)] = 122084,
  [SMALL_STATE(3991)] = 122094,
  [SMALL_STATE(3992)] = 122104,
  [SMALL_STATE(3993)] = 122112,
  [SMALL_STATE(3994)] = 122120,
  [SMALL_STATE(3995)] = 122128,
  [SMALL_STATE(3996)] = 122136,
  [SMALL_STATE(3997)] = 122146,
  [SMALL_STATE(3998)] = 122154,
  [SMALL_STATE(3999)] = 122164,
  [SMALL_STATE(4000)] = 122174,
  [SMALL_STATE(4001)] = 122182,
  [SMALL_STATE(4002)] = 122190,
  [SMALL_STATE(4003)] = 122200,
  [SMALL_STATE(4004)] = 122208,
  [SMALL_STATE(4005)] = 122218,
  [SMALL_STATE(4006)] = 122228,
  [SMALL_STATE(4007)] = 122238,
  [SMALL_STATE(4008)] = 122248,
  [SMALL_STATE(4009)] = 122258,
  [SMALL_STATE(4010)] = 122266,
  [SMALL_STATE(4011)] = 122274,
  [SMALL_STATE(4012)] = 122284,
  [SMALL_STATE(4013)] = 122294,
  [SMALL_STATE(4014)] = 122304,
  [SMALL_STATE(4015)] = 122314,
  [SMALL_STATE(4016)] = 122324,
  [SMALL_STATE(4017)] = 122332,
  [SMALL_STATE(4018)] = 122340,
  [SMALL_STATE(4019)] = 122350,
  [SMALL_STATE(4020)] = 122360,
  [SMALL_STATE(4021)] = 122370,
  [SMALL_STATE(4022)] = 122380,
  [SMALL_STATE(4023)] = 122390,
  [SMALL_STATE(4024)] = 122400,
  [SMALL_STATE(4025)] = 122410,
  [SMALL_STATE(4026)] = 122420,
  [SMALL_STATE(4027)] = 122430,
  [SMALL_STATE(4028)] = 122440,
  [SMALL_STATE(4029)] = 122450,
  [SMALL_STATE(4030)] = 122460,
  [SMALL_STATE(4031)] = 122470,
  [SMALL_STATE(4032)] = 122480,
  [SMALL_STATE(4033)] = 122490,
  [SMALL_STATE(4034)] = 122500,
  [SMALL_STATE(4035)] = 122510,
  [SMALL_STATE(4036)] = 122520,
  [SMALL_STATE(4037)] = 122530,
  [SMALL_STATE(4038)] = 122540,
  [SMALL_STATE(4039)] = 122550,
  [SMALL_STATE(4040)] = 122560,
  [SMALL_STATE(4041)] = 122570,
  [SMALL_STATE(4042)] = 122580,
  [SMALL_STATE(4043)] = 122590,
  [SMALL_STATE(4044)] = 122600,
  [SMALL_STATE(4045)] = 122610,
  [SMALL_STATE(4046)] = 122620,
  [SMALL_STATE(4047)] = 122630,
  [SMALL_STATE(4048)] = 122640,
  [SMALL_STATE(4049)] = 122650,
  [SMALL_STATE(4050)] = 122660,
  [SMALL_STATE(4051)] = 122670,
  [SMALL_STATE(4052)] = 122680,
  [SMALL_STATE(4053)] = 122690,
  [SMALL_STATE(4054)] = 122700,
  [SMALL_STATE(4055)] = 122710,
  [SMALL_STATE(4056)] = 122720,
  [SMALL_STATE(4057)] = 122730,
  [SMALL_STATE(4058)] = 122740,
  [SMALL_STATE(4059)] = 122750,
  [SMALL_STATE(4060)] = 122760,
  [SMALL_STATE(4061)] = 122770,
  [SMALL_STATE(4062)] = 122780,
  [SMALL_STATE(4063)] = 122788,
  [SMALL_STATE(4064)] = 122798,
  [SMALL_STATE(4065)] = 122808,
  [SMALL_STATE(4066)] = 122818,
  [SMALL_STATE(4067)] = 122826,
  [SMALL_STATE(4068)] = 122836,
  [SMALL_STATE(4069)] = 122846,
  [SMALL_STATE(4070)] = 122856,
  [SMALL_STATE(4071)] = 122864,
  [SMALL_STATE(4072)] = 122874,
  [SMALL_STATE(4073)] = 122882,
  [SMALL_STATE(4074)] = 122892,
  [SMALL_STATE(4075)] = 122902,
  [SMALL_STATE(4076)] = 122910,
  [SMALL_STATE(4077)] = 122918,
  [SMALL_STATE(4078)] = 122928,
  [SMALL_STATE(4079)] = 122938,
  [SMALL_STATE(4080)] = 122948,
  [SMALL_STATE(4081)] = 122956,
  [SMALL_STATE(4082)] = 122966,
  [SMALL_STATE(4083)] = 122976,
  [SMALL_STATE(4084)] = 122986,
  [SMALL_STATE(4085)] = 122996,
  [SMALL_STATE(4086)] = 123006,
  [SMALL_STATE(4087)] = 123016,
  [SMALL_STATE(4088)] = 123026,
  [SMALL_STATE(4089)] = 123036,
  [SMALL_STATE(4090)] = 123046,
  [SMALL_STATE(4091)] = 123056,
  [SMALL_STATE(4092)] = 123064,
  [SMALL_STATE(4093)] = 123072,
  [SMALL_STATE(4094)] = 123082,
  [SMALL_STATE(4095)] = 123092,
  [SMALL_STATE(4096)] = 123102,
  [SMALL_STATE(4097)] = 123110,
  [SMALL_STATE(4098)] = 123120,
  [SMALL_STATE(4099)] = 123128,
  [SMALL_STATE(4100)] = 123138,
  [SMALL_STATE(4101)] = 123148,
  [SMALL_STATE(4102)] = 123156,
  [SMALL_STATE(4103)] = 123164,
  [SMALL_STATE(4104)] = 123174,
  [SMALL_STATE(4105)] = 123184,
  [SMALL_STATE(4106)] = 123194,
  [SMALL_STATE(4107)] = 123202,
  [SMALL_STATE(4108)] = 123212,
  [SMALL_STATE(4109)] = 123220,
  [SMALL_STATE(4110)] = 123230,
  [SMALL_STATE(4111)] = 123240,
  [SMALL_STATE(4112)] = 123247,
  [SMALL_STATE(4113)] = 123254,
  [SMALL_STATE(4114)] = 123261,
  [SMALL_STATE(4115)] = 123268,
  [SMALL_STATE(4116)] = 123275,
  [SMALL_STATE(4117)] = 123282,
  [SMALL_STATE(4118)] = 123289,
  [SMALL_STATE(4119)] = 123296,
  [SMALL_STATE(4120)] = 123303,
  [SMALL_STATE(4121)] = 123310,
  [SMALL_STATE(4122)] = 123317,
  [SMALL_STATE(4123)] = 123324,
  [SMALL_STATE(4124)] = 123331,
  [SMALL_STATE(4125)] = 123338,
  [SMALL_STATE(4126)] = 123345,
  [SMALL_STATE(4127)] = 123352,
  [SMALL_STATE(4128)] = 123359,
  [SMALL_STATE(4129)] = 123366,
  [SMALL_STATE(4130)] = 123373,
  [SMALL_STATE(4131)] = 123380,
  [SMALL_STATE(4132)] = 123387,
  [SMALL_STATE(4133)] = 123394,
  [SMALL_STATE(4134)] = 123401,
  [SMALL_STATE(4135)] = 123408,
  [SMALL_STATE(4136)] = 123415,
  [SMALL_STATE(4137)] = 123422,
  [SMALL_STATE(4138)] = 123429,
  [SMALL_STATE(4139)] = 123436,
  [SMALL_STATE(4140)] = 123443,
  [SMALL_STATE(4141)] = 123450,
  [SMALL_STATE(4142)] = 123457,
  [SMALL_STATE(4143)] = 123464,
  [SMALL_STATE(4144)] = 123471,
  [SMALL_STATE(4145)] = 123478,
  [SMALL_STATE(4146)] = 123485,
  [SMALL_STATE(4147)] = 123492,
  [SMALL_STATE(4148)] = 123499,
  [SMALL_STATE(4149)] = 123506,
  [SMALL_STATE(4150)] = 123513,
  [SMALL_STATE(4151)] = 123520,
  [SMALL_STATE(4152)] = 123527,
  [SMALL_STATE(4153)] = 123534,
  [SMALL_STATE(4154)] = 123541,
  [SMALL_STATE(4155)] = 123548,
  [SMALL_STATE(4156)] = 123555,
  [SMALL_STATE(4157)] = 123562,
  [SMALL_STATE(4158)] = 123569,
  [SMALL_STATE(4159)] = 123576,
  [SMALL_STATE(4160)] = 123583,
  [SMALL_STATE(4161)] = 123590,
  [SMALL_STATE(4162)] = 123597,
  [SMALL_STATE(4163)] = 123604,
  [SMALL_STATE(4164)] = 123611,
  [SMALL_STATE(4165)] = 123618,
  [SMALL_STATE(4166)] = 123625,
  [SMALL_STATE(4167)] = 123632,
  [SMALL_STATE(4168)] = 123639,
  [SMALL_STATE(4169)] = 123646,
  [SMALL_STATE(4170)] = 123653,
  [SMALL_STATE(4171)] = 123660,
  [SMALL_STATE(4172)] = 123667,
  [SMALL_STATE(4173)] = 123674,
  [SMALL_STATE(4174)] = 123681,
  [SMALL_STATE(4175)] = 123688,
  [SMALL_STATE(4176)] = 123695,
  [SMALL_STATE(4177)] = 123702,
  [SMALL_STATE(4178)] = 123709,
  [SMALL_STATE(4179)] = 123716,
  [SMALL_STATE(4180)] = 123723,
  [SMALL_STATE(4181)] = 123730,
  [SMALL_STATE(4182)] = 123737,
  [SMALL_STATE(4183)] = 123744,
  [SMALL_STATE(4184)] = 123751,
  [SMALL_STATE(4185)] = 123758,
  [SMALL_STATE(4186)] = 123765,
  [SMALL_STATE(4187)] = 123772,
  [SMALL_STATE(4188)] = 123779,
  [SMALL_STATE(4189)] = 123786,
  [SMALL_STATE(4190)] = 123793,
  [SMALL_STATE(4191)] = 123800,
  [SMALL_STATE(4192)] = 123807,
  [SMALL_STATE(4193)] = 123814,
  [SMALL_STATE(4194)] = 123821,
  [SMALL_STATE(4195)] = 123828,
  [SMALL_STATE(4196)] = 123835,
  [SMALL_STATE(4197)] = 123842,
  [SMALL_STATE(4198)] = 123849,
  [SMALL_STATE(4199)] = 123856,
  [SMALL_STATE(4200)] = 123863,
  [SMALL_STATE(4201)] = 123870,
  [SMALL_STATE(4202)] = 123877,
  [SMALL_STATE(4203)] = 123884,
  [SMALL_STATE(4204)] = 123891,
  [SMALL_STATE(4205)] = 123898,
  [SMALL_STATE(4206)] = 123905,
  [SMALL_STATE(4207)] = 123912,
  [SMALL_STATE(4208)] = 123919,
  [SMALL_STATE(4209)] = 123926,
  [SMALL_STATE(4210)] = 123933,
  [SMALL_STATE(4211)] = 123940,
  [SMALL_STATE(4212)] = 123947,
  [SMALL_STATE(4213)] = 123954,
  [SMALL_STATE(4214)] = 123961,
  [SMALL_STATE(4215)] = 123968,
  [SMALL_STATE(4216)] = 123975,
  [SMALL_STATE(4217)] = 123982,
  [SMALL_STATE(4218)] = 123989,
  [SMALL_STATE(4219)] = 123996,
  [SMALL_STATE(4220)] = 124003,
  [SMALL_STATE(4221)] = 124010,
  [SMALL_STATE(4222)] = 124017,
  [SMALL_STATE(4223)] = 124024,
  [SMALL_STATE(4224)] = 124031,
  [SMALL_STATE(4225)] = 124038,
  [SMALL_STATE(4226)] = 124045,
  [SMALL_STATE(4227)] = 124052,
  [SMALL_STATE(4228)] = 124059,
  [SMALL_STATE(4229)] = 124066,
  [SMALL_STATE(4230)] = 124073,
  [SMALL_STATE(4231)] = 124080,
  [SMALL_STATE(4232)] = 124087,
  [SMALL_STATE(4233)] = 124094,
  [SMALL_STATE(4234)] = 124101,
  [SMALL_STATE(4235)] = 124108,
  [SMALL_STATE(4236)] = 124115,
  [SMALL_STATE(4237)] = 124122,
  [SMALL_STATE(4238)] = 124129,
  [SMALL_STATE(4239)] = 124136,
  [SMALL_STATE(4240)] = 124143,
  [SMALL_STATE(4241)] = 124150,
  [SMALL_STATE(4242)] = 124157,
  [SMALL_STATE(4243)] = 124164,
  [SMALL_STATE(4244)] = 124171,
  [SMALL_STATE(4245)] = 124178,
  [SMALL_STATE(4246)] = 124185,
  [SMALL_STATE(4247)] = 124192,
  [SMALL_STATE(4248)] = 124199,
  [SMALL_STATE(4249)] = 124206,
  [SMALL_STATE(4250)] = 124213,
  [SMALL_STATE(4251)] = 124220,
  [SMALL_STATE(4252)] = 124227,
  [SMALL_STATE(4253)] = 124234,
  [SMALL_STATE(4254)] = 124241,
  [SMALL_STATE(4255)] = 124248,
  [SMALL_STATE(4256)] = 124255,
  [SMALL_STATE(4257)] = 124262,
  [SMALL_STATE(4258)] = 124269,
  [SMALL_STATE(4259)] = 124276,
  [SMALL_STATE(4260)] = 124283,
  [SMALL_STATE(4261)] = 124290,
  [SMALL_STATE(4262)] = 124297,
  [SMALL_STATE(4263)] = 124304,
  [SMALL_STATE(4264)] = 124311,
  [SMALL_STATE(4265)] = 124318,
  [SMALL_STATE(4266)] = 124325,
  [SMALL_STATE(4267)] = 124332,
  [SMALL_STATE(4268)] = 124339,
  [SMALL_STATE(4269)] = 124346,
  [SMALL_STATE(4270)] = 124353,
  [SMALL_STATE(4271)] = 124360,
  [SMALL_STATE(4272)] = 124367,
  [SMALL_STATE(4273)] = 124374,
  [SMALL_STATE(4274)] = 124381,
  [SMALL_STATE(4275)] = 124388,
  [SMALL_STATE(4276)] = 124395,
  [SMALL_STATE(4277)] = 124402,
  [SMALL_STATE(4278)] = 124409,
  [SMALL_STATE(4279)] = 124416,
  [SMALL_STATE(4280)] = 124423,
  [SMALL_STATE(4281)] = 124430,
  [SMALL_STATE(4282)] = 124437,
  [SMALL_STATE(4283)] = 124444,
  [SMALL_STATE(4284)] = 124451,
  [SMALL_STATE(4285)] = 124458,
  [SMALL_STATE(4286)] = 124465,
  [SMALL_STATE(4287)] = 124472,
  [SMALL_STATE(4288)] = 124479,
  [SMALL_STATE(4289)] = 124486,
  [SMALL_STATE(4290)] = 124493,
  [SMALL_STATE(4291)] = 124500,
  [SMALL_STATE(4292)] = 124507,
  [SMALL_STATE(4293)] = 124514,
  [SMALL_STATE(4294)] = 124521,
  [SMALL_STATE(4295)] = 124528,
  [SMALL_STATE(4296)] = 124535,
  [SMALL_STATE(4297)] = 124542,
  [SMALL_STATE(4298)] = 124549,
  [SMALL_STATE(4299)] = 124556,
  [SMALL_STATE(4300)] = 124563,
  [SMALL_STATE(4301)] = 124570,
  [SMALL_STATE(4302)] = 124577,
  [SMALL_STATE(4303)] = 124584,
  [SMALL_STATE(4304)] = 124591,
  [SMALL_STATE(4305)] = 124598,
  [SMALL_STATE(4306)] = 124605,
  [SMALL_STATE(4307)] = 124612,
  [SMALL_STATE(4308)] = 124619,
  [SMALL_STATE(4309)] = 124626,
  [SMALL_STATE(4310)] = 124633,
  [SMALL_STATE(4311)] = 124640,
  [SMALL_STATE(4312)] = 124647,
  [SMALL_STATE(4313)] = 124654,
  [SMALL_STATE(4314)] = 124661,
  [SMALL_STATE(4315)] = 124668,
  [SMALL_STATE(4316)] = 124675,
  [SMALL_STATE(4317)] = 124682,
  [SMALL_STATE(4318)] = 124689,
  [SMALL_STATE(4319)] = 124696,
  [SMALL_STATE(4320)] = 124703,
  [SMALL_STATE(4321)] = 124710,
  [SMALL_STATE(4322)] = 124717,
  [SMALL_STATE(4323)] = 124724,
  [SMALL_STATE(4324)] = 124731,
  [SMALL_STATE(4325)] = 124738,
  [SMALL_STATE(4326)] = 124745,
  [SMALL_STATE(4327)] = 124752,
  [SMALL_STATE(4328)] = 124759,
  [SMALL_STATE(4329)] = 124766,
  [SMALL_STATE(4330)] = 124773,
  [SMALL_STATE(4331)] = 124780,
  [SMALL_STATE(4332)] = 124787,
  [SMALL_STATE(4333)] = 124794,
  [SMALL_STATE(4334)] = 124801,
  [SMALL_STATE(4335)] = 124808,
  [SMALL_STATE(4336)] = 124815,
  [SMALL_STATE(4337)] = 124822,
  [SMALL_STATE(4338)] = 124829,
  [SMALL_STATE(4339)] = 124836,
  [SMALL_STATE(4340)] = 124843,
  [SMALL_STATE(4341)] = 124850,
  [SMALL_STATE(4342)] = 124857,
  [SMALL_STATE(4343)] = 124864,
  [SMALL_STATE(4344)] = 124871,
  [SMALL_STATE(4345)] = 124878,
  [SMALL_STATE(4346)] = 124885,
  [SMALL_STATE(4347)] = 124892,
  [SMALL_STATE(4348)] = 124899,
  [SMALL_STATE(4349)] = 124906,
  [SMALL_STATE(4350)] = 124913,
  [SMALL_STATE(4351)] = 124920,
  [SMALL_STATE(4352)] = 124927,
  [SMALL_STATE(4353)] = 124934,
  [SMALL_STATE(4354)] = 124941,
  [SMALL_STATE(4355)] = 124948,
  [SMALL_STATE(4356)] = 124955,
  [SMALL_STATE(4357)] = 124962,
  [SMALL_STATE(4358)] = 124969,
  [SMALL_STATE(4359)] = 124976,
  [SMALL_STATE(4360)] = 124983,
  [SMALL_STATE(4361)] = 124990,
  [SMALL_STATE(4362)] = 124997,
  [SMALL_STATE(4363)] = 125004,
  [SMALL_STATE(4364)] = 125011,
  [SMALL_STATE(4365)] = 125018,
  [SMALL_STATE(4366)] = 125025,
  [SMALL_STATE(4367)] = 125032,
  [SMALL_STATE(4368)] = 125039,
  [SMALL_STATE(4369)] = 125046,
  [SMALL_STATE(4370)] = 125053,
  [SMALL_STATE(4371)] = 125060,
  [SMALL_STATE(4372)] = 125067,
  [SMALL_STATE(4373)] = 125074,
  [SMALL_STATE(4374)] = 125081,
  [SMALL_STATE(4375)] = 125088,
  [SMALL_STATE(4376)] = 125095,
  [SMALL_STATE(4377)] = 125102,
  [SMALL_STATE(4378)] = 125109,
  [SMALL_STATE(4379)] = 125116,
  [SMALL_STATE(4380)] = 125123,
  [SMALL_STATE(4381)] = 125130,
  [SMALL_STATE(4382)] = 125137,
  [SMALL_STATE(4383)] = 125144,
  [SMALL_STATE(4384)] = 125151,
  [SMALL_STATE(4385)] = 125158,
  [SMALL_STATE(4386)] = 125165,
  [SMALL_STATE(4387)] = 125172,
  [SMALL_STATE(4388)] = 125179,
  [SMALL_STATE(4389)] = 125186,
  [SMALL_STATE(4390)] = 125193,
  [SMALL_STATE(4391)] = 125200,
  [SMALL_STATE(4392)] = 125207,
  [SMALL_STATE(4393)] = 125214,
  [SMALL_STATE(4394)] = 125221,
  [SMALL_STATE(4395)] = 125228,
  [SMALL_STATE(4396)] = 125235,
  [SMALL_STATE(4397)] = 125242,
  [SMALL_STATE(4398)] = 125249,
  [SMALL_STATE(4399)] = 125256,
  [SMALL_STATE(4400)] = 125263,
  [SMALL_STATE(4401)] = 125270,
  [SMALL_STATE(4402)] = 125277,
  [SMALL_STATE(4403)] = 125284,
  [SMALL_STATE(4404)] = 125291,
  [SMALL_STATE(4405)] = 125298,
  [SMALL_STATE(4406)] = 125305,
  [SMALL_STATE(4407)] = 125312,
  [SMALL_STATE(4408)] = 125319,
  [SMALL_STATE(4409)] = 125326,
  [SMALL_STATE(4410)] = 125333,
  [SMALL_STATE(4411)] = 125340,
  [SMALL_STATE(4412)] = 125347,
  [SMALL_STATE(4413)] = 125354,
  [SMALL_STATE(4414)] = 125361,
  [SMALL_STATE(4415)] = 125368,
  [SMALL_STATE(4416)] = 125375,
  [SMALL_STATE(4417)] = 125382,
  [SMALL_STATE(4418)] = 125389,
  [SMALL_STATE(4419)] = 125396,
  [SMALL_STATE(4420)] = 125403,
  [SMALL_STATE(4421)] = 125410,
  [SMALL_STATE(4422)] = 125417,
  [SMALL_STATE(4423)] = 125424,
  [SMALL_STATE(4424)] = 125431,
  [SMALL_STATE(4425)] = 125438,
  [SMALL_STATE(4426)] = 125445,
  [SMALL_STATE(4427)] = 125452,
  [SMALL_STATE(4428)] = 125459,
  [SMALL_STATE(4429)] = 125466,
  [SMALL_STATE(4430)] = 125473,
  [SMALL_STATE(4431)] = 125480,
  [SMALL_STATE(4432)] = 125487,
  [SMALL_STATE(4433)] = 125494,
  [SMALL_STATE(4434)] = 125501,
  [SMALL_STATE(4435)] = 125508,
  [SMALL_STATE(4436)] = 125515,
  [SMALL_STATE(4437)] = 125522,
  [SMALL_STATE(4438)] = 125529,
  [SMALL_STATE(4439)] = 125536,
  [SMALL_STATE(4440)] = 125543,
  [SMALL_STATE(4441)] = 125550,
  [SMALL_STATE(4442)] = 125557,
  [SMALL_STATE(4443)] = 125564,
  [SMALL_STATE(4444)] = 125571,
  [SMALL_STATE(4445)] = 125578,
  [SMALL_STATE(4446)] = 125585,
  [SMALL_STATE(4447)] = 125592,
  [SMALL_STATE(4448)] = 125599,
  [SMALL_STATE(4449)] = 125606,
  [SMALL_STATE(4450)] = 125613,
  [SMALL_STATE(4451)] = 125620,
  [SMALL_STATE(4452)] = 125627,
  [SMALL_STATE(4453)] = 125634,
  [SMALL_STATE(4454)] = 125641,
  [SMALL_STATE(4455)] = 125648,
  [SMALL_STATE(4456)] = 125655,
  [SMALL_STATE(4457)] = 125662,
  [SMALL_STATE(4458)] = 125669,
  [SMALL_STATE(4459)] = 125676,
  [SMALL_STATE(4460)] = 125683,
  [SMALL_STATE(4461)] = 125690,
  [SMALL_STATE(4462)] = 125697,
  [SMALL_STATE(4463)] = 125704,
  [SMALL_STATE(4464)] = 125711,
  [SMALL_STATE(4465)] = 125718,
  [SMALL_STATE(4466)] = 125725,
  [SMALL_STATE(4467)] = 125732,
  [SMALL_STATE(4468)] = 125739,
  [SMALL_STATE(4469)] = 125746,
  [SMALL_STATE(4470)] = 125753,
  [SMALL_STATE(4471)] = 125760,
  [SMALL_STATE(4472)] = 125767,
  [SMALL_STATE(4473)] = 125774,
  [SMALL_STATE(4474)] = 125781,
  [SMALL_STATE(4475)] = 125788,
  [SMALL_STATE(4476)] = 125795,
  [SMALL_STATE(4477)] = 125802,
  [SMALL_STATE(4478)] = 125809,
  [SMALL_STATE(4479)] = 125816,
  [SMALL_STATE(4480)] = 125823,
  [SMALL_STATE(4481)] = 125830,
  [SMALL_STATE(4482)] = 125837,
  [SMALL_STATE(4483)] = 125844,
  [SMALL_STATE(4484)] = 125851,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2972),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2840),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3962),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4088),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3644),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4045),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4033),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4022),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3688),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3805),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3901),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4473),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2967),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4467),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4462),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4461),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(353),
  [116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(398),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3037),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(4211),
  [144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2683),
  [146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(352),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4225),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4221),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(442),
  [210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1128),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(536),
  [321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1076),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1002),
  [329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(330),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1200),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2946),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2972),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2840),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(330),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3962),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4088),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3644),
  [359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(127),
  [362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(344),
  [365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4045),
  [368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(53),
  [371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4033),
  [374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4022),
  [377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3688),
  [380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3805),
  [383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3901),
  [386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(225),
  [389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(245),
  [392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(627),
  [395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(100),
  [398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(138),
  [401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3943),
  [404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3045),
  [407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4473),
  [410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2708),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(573),
  [416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2967),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(261),
  [422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(455),
  [425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3497),
  [428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3505),
  [431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3062),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1955),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1955),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1930),
  [443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3629),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1099),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(541),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1010),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4467),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4462),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4461),
  [464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 202),
  [466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 202),
  [468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 49),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 49),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, .production_id = 53),
  [478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3, .production_id = 53),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3835),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3726),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3969),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3968),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3914),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3813),
  [554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3869),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3878),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4211),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(128),
  [627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(149),
  [630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3037),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3016),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4429),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4390),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4145),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4176),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2681),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2951),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [1000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [1002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [1004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [1006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [1012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4115),
  [1016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [1020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [1032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [1038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [1048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [1060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [1086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [1102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [1104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [1110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [1142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [1144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [1150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [1152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [1154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [1156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [1158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [1160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [1162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [1164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [1174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [1176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [1184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [1186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [1206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2947),
  [1210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4209),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2350),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3834),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4227),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_rest_pattern, 2, .production_id = 27),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, .production_id = 27),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2975),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4391),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [1381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [1393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [1395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [1419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [1421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [1423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [1425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 98),
  [1433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 98),
  [1435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 98),
  [1437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 98),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [1443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [1445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [1459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 24),
  [1461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 24),
  [1463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [1465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [1467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 99),
  [1477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 99),
  [1479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 99),
  [1481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 99),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [1485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 191),
  [1491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 191),
  [1493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 191),
  [1495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 191),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 159),
  [1501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 159),
  [1503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 159),
  [1505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 159),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [1509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1512] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2636),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 123),
  [1518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 123),
  [1520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 123),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 123),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [1528] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2406),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 197),
  [1534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 197),
  [1536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 197),
  [1538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 197),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 150),
  [1548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 150),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 150),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 150),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 160),
  [1558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 160),
  [1560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 160),
  [1562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 160),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 140),
  [1568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 140),
  [1570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 140),
  [1572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 140),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 48),
  [1578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 48),
  [1580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 48),
  [1582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 48),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 150),
  [1592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 150),
  [1594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 150),
  [1596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 150),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 115),
  [1612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 115),
  [1614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 115),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 115),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2703),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [1662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [1666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [1668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2980),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [1682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [1688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_modifier, 1),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [1712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [1734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4481),
  [1738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4369),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3738),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4442),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [1844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(46),
  [1850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3503),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3502),
  [1925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2341),
  [1928] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(135),
  [1932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(336),
  [1935] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3834),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2928),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2224),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3095),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [1991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [1993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [1999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [2009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4483),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4484),
  [2015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(135),
  [2018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3834),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2872),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4150),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4151),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, .production_id = 27),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4374),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4375),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2896),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [2037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(268),
  [2040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [2042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4422),
  [2044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4420),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4112),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4116),
  [2052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [2054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [2056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3589),
  [2058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4104),
  [2060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4351),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4350),
  [2064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(489),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4233),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4231),
  [2073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2957),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4173),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4172),
  [2085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 40),
  [2087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 40),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4111),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [2095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [2097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 229),
  [2103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 229),
  [2105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 205),
  [2107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 205),
  [2109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 32),
  [2111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 32),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [2115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 34),
  [2121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 34),
  [2123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 84),
  [2125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 84),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 150),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 150),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 60),
  [2133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 60),
  [2135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 150),
  [2137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 150),
  [2139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 192),
  [2141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 192),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 133),
  [2145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 133),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 149),
  [2153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 149),
  [2155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 91),
  [2157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 91),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [2161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 115),
  [2165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 115),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 98),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 98),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [2173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [2175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 151),
  [2177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 151),
  [2179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 152),
  [2181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 152),
  [2183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [2185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [2187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 140),
  [2189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 140),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, .production_id = 44),
  [2193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, .production_id = 44),
  [2195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 114),
  [2209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 114),
  [2211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [2213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 44),
  [2217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 44),
  [2219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 126),
  [2221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 126),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [2229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 194),
  [2233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 194),
  [2235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 43),
  [2237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 43),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 48),
  [2241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 48),
  [2243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 158),
  [2249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 158),
  [2251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 43),
  [2253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 43),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 123),
  [2257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 123),
  [2259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 162),
  [2261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 162),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 42),
  [2265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 42),
  [2267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 196),
  [2273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 196),
  [2275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 128),
  [2277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 128),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 41),
  [2281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 41),
  [2283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, .production_id = 28),
  [2285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, .production_id = 28),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 164),
  [2289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 164),
  [2291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 39),
  [2293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 39),
  [2295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [2297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [2299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 72),
  [2301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 72),
  [2303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 191),
  [2305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 191),
  [2307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [2309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [2311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, .production_id = 224),
  [2313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, .production_id = 224),
  [2315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [2317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [2319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 74),
  [2321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 74),
  [2323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 75),
  [2325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 75),
  [2327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4),
  [2329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 194),
  [2333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 194),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 196),
  [2337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 196),
  [2339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 122),
  [2341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 122),
  [2343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [2349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [2351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 197),
  [2353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 197),
  [2355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 225),
  [2357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 225),
  [2359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 168),
  [2361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 168),
  [2363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, .production_id = 31),
  [2365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, .production_id = 31),
  [2367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 33),
  [2369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 33),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 22),
  [2373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 22),
  [2375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [2377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [2379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 99),
  [2381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 99),
  [2383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 98),
  [2385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 98),
  [2387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [2389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [2391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 117),
  [2393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 117),
  [2395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 48),
  [2397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 48),
  [2399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 159),
  [2401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 159),
  [2403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 99),
  [2405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 99),
  [2407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 160),
  [2413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 160),
  [2415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 204),
  [2417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 204),
  [2419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 198),
  [2421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 198),
  [2423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 199),
  [2425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 199),
  [2427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [2429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [2431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [2433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [2435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 83),
  [2437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 83),
  [2439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [2441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [2443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, .production_id = 31),
  [2445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, .production_id = 31),
  [2447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 140),
  [2449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 140),
  [2451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [2453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [2455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 79),
  [2457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 79),
  [2459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [2461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [2463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 20),
  [2469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 20),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 74),
  [2473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 74),
  [2475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [2523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 166),
  [2529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 166),
  [2531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 203),
  [2533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 203),
  [2535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, .production_id = 228),
  [2537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 7, .production_id = 228),
  [2539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 167),
  [2541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 167),
  [2543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 85),
  [2545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 85),
  [2547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [2549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [2551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [2553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [2555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [2557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2572),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2527),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2535),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4452),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4276),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [2627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2532),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2693),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2966),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4464),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [2657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [2681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [2685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [2687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [2689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [2691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4133),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [2701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [2703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [2705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [2707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [2709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [2711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [2715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [2719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3569),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [2735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [2743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4447),
  [2751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [2759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [2763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [2767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [2771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [2773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [2775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [2787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [2795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [2797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [2801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [2803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [2805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [2811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [2819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [2837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [2843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3052),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [2867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4257),
  [2873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4472),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [2909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [2915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [2923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [2925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3652),
  [2927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 65),
  [2929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 65),
  [2931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [2933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [2937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [2945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [2947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2694),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [2951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1), REDUCE(aux_sym_object_pattern_repeat1, 1),
  [2954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [2956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [2960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [2962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [2964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [2966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [2968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [2970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [2972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 63),
  [2974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 63),
  [2976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 62),
  [2978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 62),
  [2980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 120),
  [2982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 120),
  [2984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 156),
  [2986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 156),
  [2988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 64),
  [2990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 64),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [2996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 50),
  [2999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(872),
  [3002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 50),
  [3005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4138),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 50),
  [3012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [3016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [3022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(465),
  [3025] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 50),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [3031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 50), SHIFT(3900),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [3040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(986),
  [3043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4379),
  [3046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(359),
  [3076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 50),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3089] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 50), REDUCE(sym_rest_pattern, 2),
  [3093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(269),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3104] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1), REDUCE(sym_rest_pattern, 2, .production_id = 27),
  [3108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(495),
  [3111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [3115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [3117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4197),
  [3121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_rest_pattern, 2),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3655),
  [3126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 19),
  [3128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 19),
  [3130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 19), SHIFT_REPEAT(3629),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [3135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 62),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 62),
  [3139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 19), SHIFT(2698),
  [3142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [3144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [3146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 15),
  [3148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 15),
  [3150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [3152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [3158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [3162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [3164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [3166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4218),
  [3200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1480),
  [3203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1599),
  [3206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [3212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1502),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3744),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4415),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2678),
  [3225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [3229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [3241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1802),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [3246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2034),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [3255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1522),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3270] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 25), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 26),
  [3274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 13),
  [3276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 13),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [3288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 50),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2763),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [3300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [3302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [3304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [3306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [3308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [3310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [3312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [3316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [3322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [3324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [3332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [3334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [3338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 51),
  [3340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 51),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [3346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [3348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [3350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [3352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [3354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [3358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2722),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [3362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [3366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [3368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [3370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [3376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2731),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [3382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [3386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [3388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [3390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [3392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2762),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [3396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [3398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [3400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [3404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [3408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2761),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [3412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [3414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [3416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [3418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [3420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [3422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [3424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 103),
  [3426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 103),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [3430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 104),
  [3432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 104),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [3438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 190),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 190),
  [3442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [3446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 70),
  [3448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [3450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [3452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [3460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [3464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [3468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [3470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [3478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 8),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 8),
  [3496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [3498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [3500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [3502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [3505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [3508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [3510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [3513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [3516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 261),
  [3518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 261),
  [3520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [3522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [3524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, .production_id = 52),
  [3526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, .production_id = 52),
  [3528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [3534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 23),
  [3536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 6, .production_id = 248),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 6, .production_id = 248),
  [3540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [3544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 247),
  [3546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 247),
  [3548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [3550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [3552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 21),
  [3554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(95),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 105),
  [3567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 105),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [3571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 246),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 246),
  [3575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 245),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 245),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [3581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 244),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 244),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [3589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(95),
  [3592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 113),
  [3594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 112),
  [3596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 110),
  [3598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 223),
  [3600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 223),
  [3602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 222),
  [3604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 222),
  [3606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [3608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [3610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 221),
  [3612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 221),
  [3614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [3616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 220),
  [3618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 220),
  [3620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 219),
  [3622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 219),
  [3624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [3626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 120),
  [3628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 120),
  [3630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 58),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [3634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 157),
  [3636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 157),
  [3638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [3640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [3642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 80),
  [3644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 80),
  [3646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, .production_id = 189),
  [3648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, .production_id = 189),
  [3650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [3652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [3654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [3656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [3658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 155),
  [3660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 61),
  [3662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 188),
  [3664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 188),
  [3666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 187),
  [3668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 187),
  [3670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(95),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 61),
  [3681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(95),
  [3684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 186),
  [3686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 186),
  [3688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 185),
  [3690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 185),
  [3692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 184),
  [3694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 184),
  [3696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 183),
  [3698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 183),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [3704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 63),
  [3706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 63),
  [3708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 62),
  [3710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 62),
  [3712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [3714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [3716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [3718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [3720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [3722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [3724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [3726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [3728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2),
  [3730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2),
  [3732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [3734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [3736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 147),
  [3738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 147),
  [3740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 106),
  [3742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 106),
  [3744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2),
  [3746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2),
  [3748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [3750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [3752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [3754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [3756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 146),
  [3758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 146),
  [3760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 146),
  [3763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3),
  [3765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3),
  [3767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_satisfies_expression, 3),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_satisfies_expression, 3),
  [3771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [3775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [3777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [3779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 145),
  [3781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 145),
  [3783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 107),
  [3785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 107),
  [3787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 144),
  [3789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 144),
  [3791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [3793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [3795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 15),
  [3797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 15),
  [3799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [3801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 58),
  [3807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [3813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 108),
  [3815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 108),
  [3817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 113),
  [3819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [3821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [3823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [3827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [3831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [3839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [3843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [3845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [3853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [3859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 135),
  [3861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 135),
  [3863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [3865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(91),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [3872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 161),
  [3884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 161),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [3888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 148),
  [3916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 148),
  [3918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(94),
  [3921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(91),
  [3924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 2, .production_id = 16),
  [3926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 2, .production_id = 16),
  [3928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_closing_tag, 1),
  [3930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_closing_tag, 1),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [3934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [3936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [3939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [3942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 51),
  [3945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 51),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 4, .dynamic_precedence = -1, .production_id = 44),
  [3958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 4, .dynamic_precedence = -1, .production_id = 44),
  [3960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 92),
  [3962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 92),
  [3964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 94),
  [3966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 94),
  [3968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [3970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [3972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 15),
  [3974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 15),
  [3976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 14),
  [3978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 14),
  [3980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 5),
  [3982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 5),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [3986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 66),
  [3992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 66),
  [3994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 67),
  [3996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 67),
  [3998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 111),
  [4000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 111),
  [4002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 55),
  [4004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 55),
  [4006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 76), REDUCE(sym_assignment_expression, 3, .production_id = 21),
  [4009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 76),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [4013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 3, .production_id = 68),
  [4015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 3, .production_id = 68),
  [4017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 3, .production_id = 69),
  [4019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 3, .production_id = 69),
  [4021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 70),
  [4023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 6),
  [4025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 6),
  [4027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 6, .dynamic_precedence = -1, .production_id = 134),
  [4029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 6, .dynamic_precedence = -1, .production_id = 134),
  [4031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 76), REDUCE(sym_assignment_expression, 3, .production_id = 58),
  [4034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 54),
  [4036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 54),
  [4038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 53),
  [4040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 53),
  [4042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 58), REDUCE(sym_assignment_expression, 3, .production_id = 58),
  [4045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 58),
  [4047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [4051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [4053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [4055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [4061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 73),
  [4063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 73),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [4067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 124),
  [4069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 124),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [4073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 121),
  [4075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 121),
  [4077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(94),
  [4080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [4082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [4084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [4087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [4090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 25),
  [4092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 25),
  [4094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(94),
  [4097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [4099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 49),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [4111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [4119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [4121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [4137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(91),
  [4140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 23),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [4144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 49),
  [4146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 49), SHIFT(430),
  [4149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [4151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [4153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 25),
  [4155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, .production_id = 26),
  [4157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 25),
  [4159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 25), REDUCE(sym_object_pattern, 3, .production_id = 26),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [4170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(91),
  [4173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 11),
  [4175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 11),
  [4177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [4180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 116),
  [4182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 116),
  [4184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [4186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [4188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 2, .production_id = 16),
  [4190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 2, .production_id = 16),
  [4192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 96),
  [4194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 96),
  [4196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 125),
  [4198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 125),
  [4200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [4202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [4204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [4209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(94),
  [4212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 109),
  [4214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 109),
  [4216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 110),
  [4218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 111),
  [4220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 111),
  [4222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 112),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [4226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [4228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [4230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [4232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [4240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [4242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [4250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [4260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 58),
  [4262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(88),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [4271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [4291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [4293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [4295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [4297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [4299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [4301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(90),
  [4304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [4306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(90),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [4319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(90),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [4328] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [4340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(88),
  [4343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2614),
  [4346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2346),
  [4349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(271),
  [4354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2102),
  [4357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4238),
  [4360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3518),
  [4363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3515),
  [4366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2467),
  [4369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3819),
  [4372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1847),
  [4375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2076),
  [4378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2163),
  [4381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2027),
  [4384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2101),
  [4387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2158),
  [4390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2312),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [4395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 49),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [4399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2),
  [4401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(90),
  [4404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, .production_id = 26),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [4410] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [4424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(88),
  [4427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(88),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [4456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [4458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [4474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [4476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [4484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(97),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [4503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 77),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [4515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [4517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [4521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(97),
  [4524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(97),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [4529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4534] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 9), REDUCE(sym__primary_type, 1, .production_id = 51),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [4540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(97),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [4545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 9), REDUCE(sym__primary_type, 1, .production_id = 51),
  [4553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [4570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 35),
  [4572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 35),
  [4574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 35),
  [4582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 35),
  [4584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 51), REDUCE(sym__parameter_name, 2, .production_id = 35),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [4593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [4595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [4597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [4603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [4607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [4613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [4632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [4634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [4637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [4643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [4645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [4650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 86),
  [4652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 86),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [4666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [4670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [4674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 90),
  [4676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 90),
  [4678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 132),
  [4680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 132),
  [4682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 49), SHIFT(441),
  [4685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(89),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [4692] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1), REDUCE(sym_rest_pattern, 2),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [4700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 25), REDUCE(sym_object_pattern, 3, .production_id = 26),
  [4703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(89),
  [4706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [4709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, .production_id = 169),
  [4711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, .production_id = 169),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 130),
  [4717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 130),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [4725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 38),
  [4727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 38),
  [4729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(89),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(89),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [4739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [4744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3),
  [4749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [4751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [4753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [4785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(96),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [4790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [4796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(96),
  [4799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(96),
  [4802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(96),
  [4805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [4813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 140), REDUCE(sym_class, 6, .production_id = 197),
  [4816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 140), REDUCE(sym_class, 6, .production_id = 197),
  [4819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 109), REDUCE(sym_class, 5, .production_id = 161),
  [4822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 109), REDUCE(sym_class, 5, .production_id = 161),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4245),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [4831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 54), REDUCE(sym_class, 4, .production_id = 125),
  [4834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 54), REDUCE(sym_class, 4, .production_id = 125),
  [4837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 11), REDUCE(sym_class, 3, .production_id = 73),
  [4840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 11), REDUCE(sym_class, 3, .production_id = 73),
  [4843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 99), REDUCE(sym_class, 5, .production_id = 160),
  [4846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 99), REDUCE(sym_class, 5, .production_id = 160),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [4851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 53), REDUCE(sym_class, 4, .production_id = 124),
  [4854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 53), REDUCE(sym_class, 4, .production_id = 124),
  [4857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 48), REDUCE(sym_class, 4, .production_id = 123),
  [4860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 48), REDUCE(sym_class, 4, .production_id = 123),
  [4863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3435),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [4867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 98), REDUCE(sym_class, 5, .production_id = 159),
  [4870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 98), REDUCE(sym_class, 5, .production_id = 159),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4336),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [4881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [4885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [4893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [4897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [4899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [4903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [4909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [4919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [4927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [4935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [4939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [4951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [4955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [4959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [4963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [4967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [4973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [4977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [4981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [4985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [4991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [4995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [4999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [5003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [5007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [5011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [5015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [5019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [5025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [5027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [5029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1),
  [5031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [5035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [5037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 25), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 26),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [5042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2995),
  [5044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [5046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [5050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [5052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [5054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [5056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [5066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [5068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 25),
  [5070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [5072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [5086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4470),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [5092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [5096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [5098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [5100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 115),
  [5102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 115),
  [5104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 249),
  [5106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 249),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [5112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [5114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 227),
  [5116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 227),
  [5118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 226),
  [5120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 226),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [5126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 78),
  [5128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 78),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [5132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [5136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2269),
  [5138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 191),
  [5140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 191),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [5152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 200),
  [5154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 200),
  [5156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 129),
  [5158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 129),
  [5160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 150),
  [5162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 150),
  [5164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 165),
  [5166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 165),
  [5168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 250),
  [5170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 250),
  [5172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 262),
  [5174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 262),
  [5176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [5182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 263),
  [5184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 263),
  [5186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, .production_id = 272),
  [5188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, .production_id = 272),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [5198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [5200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [5208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [5226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [5228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [5230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [5232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_static_block, 2, .production_id = 11),
  [5234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_static_block, 2, .production_id = 11),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [5240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [5266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [5274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3864),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4183),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [5286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [5292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 12),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 12), SHIFT(3637),
  [5301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4251),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [5307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [5317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4475),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [5375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 215),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [5387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_namespace_name, 3),
  [5389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_namespace_name, 3),
  [5391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 50), REDUCE(sym_jsx_namespace_name, 3),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [5396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 135),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [5404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 178),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [5414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 44),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [5424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [5452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 135),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [5456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 215),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [5474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [5480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4326),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [5484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2869),
  [5486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 44),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [5490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3708),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [5498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 178),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [5510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4392),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [5522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 44),
  [5524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 178),
  [5526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 135),
  [5528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 178),
  [5530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 215),
  [5532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [5536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 135),
  [5538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 44),
  [5540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 50), SHIFT(3900),
  [5545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 215),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [5549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [5561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [5563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3063),
  [5565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [5567] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [5575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [5579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3628),
  [5581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3213),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [5585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [5587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [5597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [5599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [5603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [5605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [5607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [5609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [5613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [5615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [5617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [5619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 18),
  [5621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [5623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [5625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3745),
  [5627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [5631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [5635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2749),
  [5637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2672),
  [5639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2824),
  [5641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [5643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2757),
  [5645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3137),
  [5647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [5651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [5653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2714),
  [5655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2685),
  [5657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [5659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [5661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [5663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [5665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4),
  [5667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2985),
  [5669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [5671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2977),
  [5673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [5675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [5677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [5679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, .production_id = 26),
  [5681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [5683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [5689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4433),
  [5691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [5693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3065),
  [5695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [5697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [5701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4448),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [5705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4449),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [5713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(206),
  [5716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(3232),
  [5719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(2752),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [5724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4451),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [5728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4450),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [5732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [5736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 242),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [5742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4308),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4316),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [5748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4317),
  [5750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4318),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [5754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4320),
  [5756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4387),
  [5758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3),
  [5760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4),
  [5762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 93), SHIFT_REPEAT(2880),
  [5765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 93), SHIFT_REPEAT(203),
  [5768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 93),
  [5770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 93),
  [5772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 93), SHIFT_REPEAT(2880),
  [5775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4159),
  [5777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4319),
  [5779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [5781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2982),
  [5783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4124),
  [5785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4125),
  [5787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4370),
  [5789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4129),
  [5791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4453),
  [5793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4130),
  [5795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4383),
  [5797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [5799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3024),
  [5801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4126),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4385),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4386),
  [5809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [5815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4405),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [5829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [5835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [5847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 100),
  [5849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4205),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [5853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 251),
  [5855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 234),
  [5857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [5859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 206),
  [5861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 207),
  [5863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [5867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [5869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 118),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [5873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [5877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 118),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [5885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 3, .production_id = 100),
  [5887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 181),
  [5889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 182),
  [5891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [5893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [5897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [5901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [5905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 235),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [5913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_chain, 1),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [5921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [5923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [5925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(359),
  [5928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 252),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [5934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 97),
  [5936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 242),
  [5938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 170),
  [5940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 149),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [5952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 266),
  [5954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 271),
  [5956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 114),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [5960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, .production_id = 10),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [5964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(465),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [5971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, .production_id = 143),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [5975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 139),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [5991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [5993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 218),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [6001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, .production_id = 274),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4465),
  [6007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [6009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4468),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [6013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2538),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [6017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4266),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [6035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4158),
  [6037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [6039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4310),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [6047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [6051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4371),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [6055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4388),
  [6057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 119),
  [6059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 119),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [6073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(4119),
  [6076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [6078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(267),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [6093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [6101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4434),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [6109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [6117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [6127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1228),
  [6130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [6132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(3031),
  [6135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [6137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(257),
  [6140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 118),
  [6142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 118),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [6152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [6160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [6164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3477),
  [6198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [6202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1),
  [6204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4122),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2676),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [6222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [6226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, .production_id = 10),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [6252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [6254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 71),
  [6256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [6260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 17),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [6264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3492),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [6306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [6310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [6322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 171),
  [6324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 232),
  [6326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 233),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [6344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [6346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(998),
  [6349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 18), SHIFT(849),
  [6352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [6354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [6356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 230),
  [6358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 102),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [6374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [6388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 18), SHIFT(925),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [6395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(915),
  [6398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 238),
  [6400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 18), SHIFT(862),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [6419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 1, .production_id = 45),
  [6421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 1, .production_id = 45),
  [6423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 29),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [6429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [6441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [6443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [6445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3),
  [6447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3),
  [6449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [6451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 3),
  [6453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 3),
  [6455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 217),
  [6457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 176),
  [6459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 119),
  [6461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 119),
  [6463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 2),
  [6465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 2),
  [6467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 174),
  [6469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(848),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [6476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 137),
  [6478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 80),
  [6480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 216),
  [6482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, .production_id = 257),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [6486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 269),
  [6488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 30),
  [6490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [6498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2),
  [6500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(968),
  [6503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(3358),
  [6506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 265),
  [6508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 264),
  [6510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2524),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [6516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 241),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [6528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, .production_id = 214),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [6534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 213),
  [6536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 241),
  [6538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 238),
  [6540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 18), SHIFT(882),
  [6543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 209),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [6547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 209),
  [6549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 213),
  [6551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 5, .production_id = 243),
  [6553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, .production_id = 172),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [6557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 174),
  [6559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 176),
  [6561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(861),
  [6564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 180),
  [6566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 260),
  [6568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 137),
  [6570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 80),
  [6572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 254),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [6576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 255),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [6580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 257),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [6596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 193),
  [6598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 193), SHIFT_REPEAT(3488),
  [6601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 193),
  [6603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 44),
  [6605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [6607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(3453),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [6616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [6618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(3458),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [6623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [6629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [6635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [6639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [6645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [6657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3634),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [6663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [6665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [6667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 154),
  [6669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 154),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [6675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [6677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 153),
  [6679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 153),
  [6681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [6685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [6691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3704),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [6697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [6699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [6703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [6707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(980),
  [6710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [6718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [6722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 142),
  [6724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 142), SHIFT_REPEAT(486),
  [6727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 4, .production_id = 141),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [6731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3833),
  [6733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [6737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [6745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [6753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2891),
  [6756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [6762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [6768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 47),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [6774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 26),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [6780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(200),
  [6783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1),
  [6785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1), REDUCE(aux_sym_template_literal_type_repeat1, 1),
  [6788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [6802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3821),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [6818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 101),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [6822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [6826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 88),
  [6828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [6840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 37),
  [6842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, .production_id = 231),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [6848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [6852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 81),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [6856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 80),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [6860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(147),
  [6863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [6873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [6877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [6881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 236),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [6887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [6901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 92),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [6925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 94),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [6929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3824),
  [6931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4118),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [6937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_export_name, 1),
  [6939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 1, .production_id = 5),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [6943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2), SHIFT_REPEAT(187),
  [6946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 237),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [6956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1, .production_id = 44),
  [6958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(3939),
  [6961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [6963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 29),
  [6965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 2, .production_id = 44),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [6975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [6989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [7009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 239),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [7017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2), SHIFT_REPEAT(2144),
  [7020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2),
  [7022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(2160),
  [7025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [7043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 208),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [7047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 206),
  [7049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 240),
  [7051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 207),
  [7053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 212),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [7061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 234),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [7065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 211),
  [7067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 210),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [7081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, .production_id = 77),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [7085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4),
  [7087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2843),
  [7090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [7096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(495),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [7103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [7107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2844),
  [7110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [7132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 195), SHIFT_REPEAT(2316),
  [7135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 195),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [7139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 5, .dynamic_precedence = -1, .production_id = 134),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [7143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 253),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [7151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 1, .production_id = 5),
  [7153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [7159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [7161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 136),
  [7163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3),
  [7165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 256),
  [7167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(805),
  [7170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [7172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, .production_id = 273),
  [7174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [7176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 114),
  [7178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 138),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [7192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 81),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [7198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 270),
  [7200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 258),
  [7202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 268),
  [7204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 259),
  [7206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 267),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [7234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 173),
  [7236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 149),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [7240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 179),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [7244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 2, .production_id = 44),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [7258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 175),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [7262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [7266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 170),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [7282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 177),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [7322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [7324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [7328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2), SHIFT_REPEAT(3833),
  [7331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [7335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 4, .production_id = 163),
  [7337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 4, .production_id = 163),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [7347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [7349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 29),
  [7351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [7359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [7363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 28),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [7371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [7373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, .production_id = 30),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [7387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [7397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [7399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [7403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [7405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [7407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [7409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [7411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [7415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [7419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [7421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, .production_id = 80),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [7433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_opening_tag, 1),
  [7435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [7437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 3, .production_id = 127),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [7441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 131),
  [7443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [7449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [7451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6, .production_id = 201),
  [7453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 3, .production_id = 127),
  [7455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 36),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [7459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [7461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [7465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [7479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [7481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [7483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [7487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [7489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [7491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [7495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [7505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 46),
  [7507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2983),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [7513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 95),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [7533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 89),
  [7535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 87),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [7551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4332),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [7555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [7559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [7561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [7563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [7567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [7569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [7571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [7587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [7591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [7593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [7595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [7599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4394),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [7603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [7607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [7625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [7627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_export, 3),
  [7629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [7631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [7633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [7647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4279),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [7651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [7703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [7705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4454),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [7709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [7725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [7737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [7739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [7763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [7767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [7773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [7835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [7845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [7871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [7881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [7885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [7897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [7913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [7929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [7933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [7935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [7937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [7939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [7941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [7943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [7947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [7957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [7961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [8005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [8015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [8041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [8145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [8153] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [8175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4380),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_tsx_external_scanner_create(void);
void tree_sitter_tsx_external_scanner_destroy(void *);
bool tree_sitter_tsx_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tsx_external_scanner_serialize(void *, char *);
void tree_sitter_tsx_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_tsx(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_tsx_external_scanner_create,
      tree_sitter_tsx_external_scanner_destroy,
      tree_sitter_tsx_external_scanner_scan,
      tree_sitter_tsx_external_scanner_serialize,
      tree_sitter_tsx_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
